(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestInvariants_R () T@$TypeName)
(declare-fun $TestInvariants_S () T@$TypeName)
(declare-fun $TestInvariants_T () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestInvariants_R_x () Int)
(declare-fun $TestInvariants_R_type_value () T@$TypeValue)
(declare-fun $TestInvariants_S_y () Int)
(declare-fun $TestInvariants_S_type_value () T@$TypeValue)
(declare-fun $TestInvariants_T_x () Int)
(declare-fun $TestInvariants_T_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestInvariants_R $TestInvariants_S $TestInvariants_T)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestInvariants_R_x 0))
(assert (= $TestInvariants_R_type_value ($StructType $TestInvariants_R $EmptyTypeValueArray)))
(assert (= $TestInvariants_S_y 0))
(assert (= $TestInvariants_S_type_value ($StructType $TestInvariants_S $EmptyTypeValueArray)))
(assert (= $TestInvariants_T_x 0))
(assert (= $TestInvariants_T_type_value ($StructType $TestInvariants_T $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_pack_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 33449) (let ((anon0$2_correct  (=> (= (ControlFlow 0 15428) (- 0 33622)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1)) $TestInvariants_R_x) ($Integer 1))))))))
(let ((inline$$TestInvariants_invalid_R_pack_$def_verify$0$anon3_Else_correct  (=> (and (not true) (= (ControlFlow 0 15410) 15428)) anon0$2_correct)))
(let ((inline$$TestInvariants_invalid_R_pack_$def_verify$0$anon3_Then_correct  (=> (= (ControlFlow 0 15420) 15428) anon0$2_correct)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 15374) (- 0 33596)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 15374) 15420) inline$$TestInvariants_invalid_R_pack_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 15374) 15410) inline$$TestInvariants_invalid_R_pack_$def_verify$0$anon3_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 15388) 15374)) inline$$TestInvariants_R_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 15394) 15374) inline$$TestInvariants_R_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 15382) 15394) inline$$TestInvariants_R_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 15382) 15388) inline$$TestInvariants_R_pack$0$anon5_Else_correct)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 15362) 15374)) inline$$TestInvariants_R_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_pack_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_pack_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_pack_$def_verify$0$$t0@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_pack_$def_verify$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 15354) 15382) inline$$TestInvariants_R_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 15354) 15362) inline$$TestInvariants_R_pack$0$anon4_Else_correct)))))
(let ((inline$$TestInvariants_invalid_R_pack_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_invalid_R_pack_$def_verify$0$$t0@1 ($Integer 1)) (= (ControlFlow 0 15400) 15354)) inline$$TestInvariants_R_pack$0$anon0_correct))))
(let ((anon0_correct  (=> (= (ControlFlow 0 33449) 15400) inline$$TestInvariants_invalid_R_pack_$def_verify$0$anon0_correct)))
anon0_correct))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestInvariants_R_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 33654) (let ((anon0$2_correct@@0  (=> (= (ControlFlow 0 16426) (- 0 34127)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)) $TestInvariants_R_x) ($Integer 4))))))))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 16390) 16426)) anon0$2_correct@@0)))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 16400) 16426) anon0$2_correct@@0)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2| inline$$TestInvariants_R_pack$0$$struct@1@@0)) (and (=> (= (ControlFlow 0 16348) 16400) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 16348) 16390) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 inline$$TestInvariants_R_pack$0$$struct@1@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|)) (and (=> (= (ControlFlow 0 16374) 16400) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 16374) 16390) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon9_Else_correct))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 16251) (- 0 34047)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 16251) 16374) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 16251) 16348) inline$$WritebackToValue$0$anon3_Else_correct))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$Entry_correct  (=> (and (= inline$$TestInvariants_R_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)) (= (ControlFlow 0 16239) 16251)) inline$$TestInvariants_R_$pack_ref$0$anon0_correct)))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 16212) 16239)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct)))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon8_Then_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)) (= (ControlFlow 0 16410) 16239)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$TestInvariants_R_pack$1$$struct@1)) (and (=> (= (ControlFlow 0 16198) 16410) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 16198) 16212) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestInvariants_R_pack$1$anon3_correct  (and (=> (= (ControlFlow 0 16119) (- 0 33985)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$1$$struct@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$1$$struct@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 16119) 16198) inline$$WriteRef$0$anon0_correct)))))
(let ((inline$$TestInvariants_R_pack$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 16133) 16119)) inline$$TestInvariants_R_pack$1$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$1$anon5_Then_correct  (=> (= (ControlFlow 0 16139) 16119) inline$$TestInvariants_R_pack$1$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$1$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 16127) 16139) inline$$TestInvariants_R_pack$1$anon5_Then_correct) (=> (= (ControlFlow 0 16127) 16133) inline$$TestInvariants_R_pack$1$anon5_Else_correct)))))
(let ((inline$$TestInvariants_R_pack$1$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 16107) 16119)) inline$$TestInvariants_R_pack$1$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$1$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_update_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_update_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_update_$def_verify$0$$t3@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_update_$def_verify$0$$t3@1) 1)))) (and (=> (= (ControlFlow 0 16099) 16127) inline$$TestInvariants_R_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 16099) 16107) inline$$TestInvariants_R_pack$1$anon4_Else_correct)))))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon2$2_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_$def_verify$0$$t3@1 ($Integer 4)) (= (ControlFlow 0 16145) 16099)) inline$$TestInvariants_R_pack$1$anon0_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$0$$before@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 15953) 16145)) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon2$2_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$Entry_correct  (=> (and (= inline$$TestInvariants_R_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 15947) 15953)) inline$$TestInvariants_R_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 1) $EmptyPath inline$$TestInvariants_R_pack$0$$struct@1@@0)) (= (ControlFlow 0 15920) 15947)) inline$$TestInvariants_R_$unpack_ref$0$Entry_correct)))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 15870) 15920)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 16418) 15920) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@0  (and (=> (= (ControlFlow 0 15836) (- 0 33860)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 15836) 16418) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 15836) 15870) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon7_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 15850) 15836)) inline$$TestInvariants_R_pack$0$anon3_correct@@0)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 15856) 15836) inline$$TestInvariants_R_pack$0$anon3_correct@@0)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@0  (=> (> 1310 0) (and (=> (= (ControlFlow 0 15844) 15856) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 15844) 15850) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@0)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@0  (=> (and (>= 0 1310) (= (ControlFlow 0 15824) 15836)) inline$$TestInvariants_R_pack$0$anon3_correct@@0)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_update_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_update_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_update_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_update_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 15816) 15844) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 15816) 15824) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestInvariants_invalid_R_update_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_invalid_R_update_$def_verify$0$$t2@1 ($Integer 3)) (= (ControlFlow 0 15862) 15816)) inline$$TestInvariants_R_pack$0$anon0_correct@@0))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 33654) 15862) inline$$TestInvariants_invalid_R_update_$def_verify$0$anon0_correct)))
anon0_correct@@0)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$TestInvariants_R_pack$1$$struct@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$r@1 () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$2$$struct@1 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun inline$$TestInvariants_R_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun b () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestInvariants_R_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 34152) (let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon18_Else_correct true))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon18_Then_correct true))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 3))) (and (=> (= (ControlFlow 0 17968) 18020) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17968) 18010) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 3)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 inline$$TestInvariants_R_pack$1$$struct@1@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (and (=> (= (ControlFlow 0 17994) 18020) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17994) 18010) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 2))) (and (=> (= (ControlFlow 0 17843) 17994) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 17843) 17968) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 inline$$TestInvariants_R_pack$0$$struct@1@@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (and (=> (= (ControlFlow 0 17869) 17994) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 17869) 17968) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 17746) (- 0 34777)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 17746) 17869) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 17746) 17843) inline$$WritebackToValue$0$anon3_Else_correct@@0))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestInvariants_R_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= (ControlFlow 0 17734) 17746)) inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon10$1_correct  (and (=> (= (ControlFlow 0 17750) (- 0 34765)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 17750) 17734) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@0)))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= (ControlFlow 0 17697) 17750)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon10$1_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 17665) 17697)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon17_Then_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= (ControlFlow 0 18030) 17697)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$r@1) (|p#$Mutation| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$r@1) inline$$TestInvariants_R_pack$2$$struct@1)) (and (=> (= (ControlFlow 0 17651) 18030) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 17651) 17665) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestInvariants_R_pack$2$anon3_correct  (and (=> (= (ControlFlow 0 17572) (- 0 34696)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$2$$struct@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$2$$struct@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 17572) 17651) inline$$WriteRef$0$anon0_correct@@0)))))
(let ((inline$$TestInvariants_R_pack$2$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 17586) 17572)) inline$$TestInvariants_R_pack$2$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$2$anon5_Then_correct  (=> (= (ControlFlow 0 17592) 17572) inline$$TestInvariants_R_pack$2$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$2$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 17580) 17592) inline$$TestInvariants_R_pack$2$anon5_Then_correct) (=> (= (ControlFlow 0 17580) 17586) inline$$TestInvariants_R_pack$2$anon5_Else_correct)))))
(let ((inline$$TestInvariants_R_pack$2$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 17560) 17572)) inline$$TestInvariants_R_pack$2$anon3_correct)))
(let ((inline$$TestInvariants_R_pack$2$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t7@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$2$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t7@1) 1)))) (and (=> (= (ControlFlow 0 17552) 17580) inline$$TestInvariants_R_pack$2$anon4_Then_correct) (=> (= (ControlFlow 0 17552) 17560) inline$$TestInvariants_R_pack$2$anon4_Else_correct)))))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$L3_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t7@1 ($Integer 4)) (= (ControlFlow 0 17598) 17552)) inline$$TestInvariants_R_pack$2$anon0_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Then$2_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$r@1 inline$$BorrowLoc$1$dst@1) (= (ControlFlow 0 18123) 17598)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$L3_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$1$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$1$$before@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 18117) 18123)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Then$2_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$1$Entry_correct  (=> (and (= inline$$TestInvariants_R_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 18111) 18117)) inline$$TestInvariants_R_$unpack_ref$1$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 2) $EmptyPath inline$$TestInvariants_R_pack$0$$struct@1@@1)) (= (ControlFlow 0 18084) 18111)) inline$$TestInvariants_R_$unpack_ref$1$Entry_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Then_correct  (=> (and (|b#$Boolean| b) (= (ControlFlow 0 18090) 18084)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Else$2_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$r@1 inline$$BorrowLoc$0$dst@1@@0) (= (ControlFlow 0 17410) 17598)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$L3_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@0  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$0$$before@0@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 17404) 17410)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Else$2_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestInvariants_R_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 17398) 17404)) inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 3) $EmptyPath inline$$TestInvariants_R_pack$1$$struct@1@@0)) (= (ControlFlow 0 17371) 17398)) inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Else_correct  (=> (and (not (|b#$Boolean| b)) (= (ControlFlow 0 17377) 17371)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17313) 18090) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 17313) 17377) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 18131) 18090) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 18131) 17377) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestInvariants_R_pack$1$anon3_correct@@0  (and (=> (= (ControlFlow 0 17279) (- 0 34518)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$1$$struct@1@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$1$$struct@1@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 17279) 18131) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 17279) 17313) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$1$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 17293) 17279)) inline$$TestInvariants_R_pack$1$anon3_correct@@0)))
(let ((inline$$TestInvariants_R_pack$1$anon5_Then_correct@@0  (=> (= (ControlFlow 0 17299) 17279) inline$$TestInvariants_R_pack$1$anon3_correct@@0)))
(let ((inline$$TestInvariants_R_pack$1$anon4_Then_correct@@0  (=> (> 1914 0) (and (=> (= (ControlFlow 0 17287) 17299) inline$$TestInvariants_R_pack$1$anon5_Then_correct@@0) (=> (= (ControlFlow 0 17287) 17293) inline$$TestInvariants_R_pack$1$anon5_Else_correct@@0)))))
(let ((inline$$TestInvariants_R_pack$1$anon4_Else_correct@@0  (=> (and (>= 0 1914) (= (ControlFlow 0 17267) 17279)) inline$$TestInvariants_R_pack$1$anon3_correct@@0)))
(let ((inline$$TestInvariants_R_pack$1$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t6@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t6@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t6@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$1$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t6@1) 1)))) (and (=> (= (ControlFlow 0 17259) 17287) inline$$TestInvariants_R_pack$1$anon4_Then_correct@@0) (=> (= (ControlFlow 0 17259) 17267) inline$$TestInvariants_R_pack$1$anon4_Else_correct@@0)))))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon4_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t6@1 ($Integer 3)) (= (ControlFlow 0 17305) 17259)) inline$$TestInvariants_R_pack$1$anon0_correct@@0)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 17117) 17305)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon4_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 18139) 17305) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon4_correct)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@1  (and (=> (= (ControlFlow 0 17083) (- 0 34429)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 17083) 18139) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 17083) 17117) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 17097) 17083)) inline$$TestInvariants_R_pack$0$anon3_correct@@1)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 17103) 17083) inline$$TestInvariants_R_pack$0$anon3_correct@@1)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@1  (=> (> 1887 0) (and (=> (= (ControlFlow 0 17091) 17103) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 17091) 17097) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@1)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@1  (=> (and (>= 0 1887) (= (ControlFlow 0 17071) 17083)) inline$$TestInvariants_R_pack$0$anon3_correct@@1)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@1  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t5@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t5@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t5@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t5@1) 1)))) (and (=> (= (ControlFlow 0 17063) 17091) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 17063) 17071) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$$t5@1 ($Integer 5)) (= (ControlFlow 0 17109) 17063)) inline$$TestInvariants_R_pack$0$anon0_correct@@1)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 16887) 17109)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 18147) 17109) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16881) 18147) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 16881) 16887) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@1  (=> (and ((_ is $Boolean) b) (= (ControlFlow 0 16574) 16881)) inline$$TestInvariants_invalid_R_update_branching_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 34152) 16574) anon0_correct@@1)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@2 () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestInvariants_update_helper_$def$0$$t3@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$TestInvariants_R_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$$t1@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 34901) (let ((inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon9_Then_correct true))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 0))) (and (=> (= (ControlFlow 0 19929) 19981) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 19929) 19971) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 inline$$TestInvariants_R_pack$0$$struct@1@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (=> (= (ControlFlow 0 19955) 19981) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 19955) 19971) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@1  (and (=> (= (ControlFlow 0 19832) (- 0 35656)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 19832) 19955) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 19832) 19929) inline$$WritebackToValue$1$anon3_Else_correct@@0))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestInvariants_R_$pack_ref$0$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 19820) 19832)) inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1@@1) (= (ControlFlow 0 19731) 19820)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 19787) 19820))) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 19695) 19787) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 19695) 19731) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (and (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) |inline$$WritebackToValue$0$vdst'@2@@0|)) (= (ControlFlow 0 19552) 19695)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon8_Else_correct  (=> (and (not false) (= (ControlFlow 0 19558) 19552)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon8_Then_correct true))
(let ((inline$$TestInvariants_update_helper_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 19461) 19989) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 19461) 19558) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestInvariants_update_helper_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 19471) 19989) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 19471) 19558) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon8_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$ReadRef$0$v@1@@0)) (and (=> (= (ControlFlow 0 19419) 19471) inline$$TestInvariants_update_helper_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 19419) 19461) inline$$TestInvariants_update_helper_$def$0$anon6_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|) 0 inline$$ReadRef$0$v@1@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 19445) 19471) inline$$TestInvariants_update_helper_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 19445) 19461) inline$$TestInvariants_update_helper_$def$0$anon6_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$TestInvariants_update_helper_$def$0$$t3@1)) (and (=> (= (ControlFlow 0 19320) 19445) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 19320) 19419) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$TestInvariants_update_helper_$def$0$anon2$2_correct  (=> (and (= inline$$TestInvariants_update_helper_$def$0$$t3@1 ($Integer 4)) (= (ControlFlow 0 19326) 19320)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$1$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$1$dst@1@@0 ($Mutation ($Local 1) $EmptyPath inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 19257) 19326)) inline$$TestInvariants_update_helper_$def$0$anon2$2_correct)))
(let ((inline$$TestInvariants_update_helper_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 19173) 19257)) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestInvariants_update_helper_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 19479) 19257) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestInvariants_update_helper_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 19167) 19479) inline$$TestInvariants_update_helper_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 19167) 19173) inline$$TestInvariants_update_helper_$def$0$anon5_Else_correct)))))
(let ((inline$$TestInvariants_update_helper_$direct_intra$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$ReadRef$0$v@1@@0) (>= (|i#$Integer| inline$$ReadRef$0$v@1@@0) 0)) (<= (|i#$Integer| inline$$ReadRef$0$v@1@@0) $MAX_U64)) (= (ControlFlow 0 19485) 19167)) inline$$TestInvariants_update_helper_$def$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 18997) 19485)) inline$$TestInvariants_update_helper_$direct_intra$0$anon0_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $TestInvariants_R_x) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $TestInvariants_R_x))) (= (ControlFlow 0 18959) 18997))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@1  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$0$$before@0@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 18837) 18959)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestInvariants_R_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 18831) 18837)) inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 0) $EmptyPath inline$$TestInvariants_R_pack$0$$struct@1@@2)) (= (ControlFlow 0 18804) 18831)) inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 18754) 18804)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 19997) 18804) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@2  (and (=> (= (ControlFlow 0 18720) (- 0 35161)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@2)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@2)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 18720) 19997) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 18720) 18754) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon7_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 18734) 18720)) inline$$TestInvariants_R_pack$0$anon3_correct@@2)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@2  (=> (= (ControlFlow 0 18740) 18720) inline$$TestInvariants_R_pack$0$anon3_correct@@2)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@2  (=> (> 1704 0) (and (=> (= (ControlFlow 0 18728) 18740) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 18728) 18734) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@2)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@2  (=> (and (>= 0 1704) (= (ControlFlow 0 18708) 18720)) inline$$TestInvariants_R_pack$0$anon3_correct@@2)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@2  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$$t1@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$$t1@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$$t1@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$$t1@1) 1)))) (and (=> (= (ControlFlow 0 18700) 18728) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 18700) 18708) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$$t1@1 ($Integer 3)) (= (ControlFlow 0 18746) 18700)) inline$$TestInvariants_R_pack$0$anon0_correct@@2))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 34901) 18746) inline$$TestInvariants_invalid_R_update_indirectly_$def_verify$0$anon0_correct)))
anon0_correct@@2)))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@2| () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$0$$after@0@@2 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$TestInvariants_R_$unpack_ref$0$$before@0@@2 () T@$Value)
(declare-fun inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 35734) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 21392) (- 0 36345)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@1|)) $TestInvariants_R_x) ($Integer 4))))))))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 21356) 21392)) anon0$2_correct@@1)))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 21366) 21392) anon0$2_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@2  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@1| inline$$TestInvariants_R_pack$0$$struct@1@@3)) (and (=> (= (ControlFlow 0 21314) 21366) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 21314) 21356) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@2  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 inline$$TestInvariants_R_pack$0$$struct@1@@3 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@2|)) (and (=> (= (ControlFlow 0 21340) 21366) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 21340) 21356) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon9_Else_correct))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@2  (and (=> (= (ControlFlow 0 21217) (- 0 36265)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@2)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@2)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 21217) 21340) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 21217) 21314) inline$$WritebackToValue$0$anon3_Else_correct@@2))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestInvariants_R_$pack_ref$0$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 21205) 21217)) inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$0$dst@1@@2) (= (ControlFlow 0 21116) 21205)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 21172) 21205))) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@2)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) (and (=> (= (ControlFlow 0 21080) 21172) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 21080) 21116) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 20943) 21080)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon8_Then_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= (ControlFlow 0 21376) 21080)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t4@1)) (and (=> (= (ControlFlow 0 20929) 21376) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 20929) 20943) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon2$3_correct  (=> (and (= inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t4@1 ($Integer 4)) (= (ControlFlow 0 20935) 20929)) inline$$WriteRef$0$anon0_correct@@2)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $TestInvariants_R_x) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $TestInvariants_R_x))) (= (ControlFlow 0 20866) 20935))) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon2$3_correct))))
(let ((inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@2  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$0$$before@0@@2)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 20744) 20866)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestInvariants_R_$unpack_ref$0$$before@0@@2 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (= (ControlFlow 0 20738) 20744)) inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@2)))
(let ((inline$$BorrowLoc$0$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$0$dst@1@@2 ($Mutation ($Local 1) $EmptyPath inline$$TestInvariants_R_pack$0$$struct@1@@3)) (= (ControlFlow 0 20711) 20738)) inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@2)))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 20661) 20711)) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 21384) 20711) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@3  (and (=> (= (ControlFlow 0 20627) (- 0 35956)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@3)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@3)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 20627) 21384) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 20627) 20661) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon7_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 20641) 20627)) inline$$TestInvariants_R_pack$0$anon3_correct@@3)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@3  (=> (= (ControlFlow 0 20647) 20627) inline$$TestInvariants_R_pack$0$anon3_correct@@3)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@3  (=> (> 1505 0) (and (=> (= (ControlFlow 0 20635) 20647) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@3) (=> (= (ControlFlow 0 20635) 20641) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@3)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@3  (=> (and (>= 0 1505) (= (ControlFlow 0 20615) 20627)) inline$$TestInvariants_R_pack$0$anon3_correct@@3)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@3  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@3 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 20607) 20635) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@3) (=> (= (ControlFlow 0 20607) 20615) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@3)))))
(let ((inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$$t2@1 ($Integer 3)) (= (ControlFlow 0 20653) 20607)) inline$$TestInvariants_R_pack$0$anon0_correct@@3))))
(let ((anon0_correct@@3  (=> (= (ControlFlow 0 35734) 20653) inline$$TestInvariants_invalid_R_update_ref_$def_verify$0$anon0_correct)))
anon0_correct@@3)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@2| () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$TestInvariants_R_$unpack_ref$1$$before@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@3| () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$0$$after@0@@3 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$TestInvariants_R_$unpack_ref$0$$before@0@@3 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 36369) (let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon18_Else_correct true))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon18_Then_correct true))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 0))) (and (=> (= (ControlFlow 0 23433) 23485) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 23433) 23475) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@1  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 |inline$$WritebackToValue$0$vdst'@2@@2| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (=> (= (ControlFlow 0 23459) 23485) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 23459) 23475) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestInvariants_R_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 23336) (- 0 37337)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$1$$after@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$1$$after@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 23336) 23459) inline$$WritebackToValue$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 23336) 23433) inline$$WritebackToValue$1$anon3_Else_correct@@1))))))
(let ((inline$$TestInvariants_R_$pack_ref$1$Entry_correct  (=> (and (= inline$$TestInvariants_R_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= (ControlFlow 0 23324) 23336)) inline$$TestInvariants_R_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowLoc$1$dst@1@@1) (= (ControlFlow 0 23235) 23324)) inline$$TestInvariants_R_$pack_ref$1$Entry_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 23291) 23324))) inline$$TestInvariants_R_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) (and (=> (= (ControlFlow 0 23199) 23291) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 23199) 23235) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 23062) 23199)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon17_Then_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@4 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= (ControlFlow 0 23495) 23199)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon16_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 23054) 23495) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 23054) 23062) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon16_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@3 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (and (=> (= (ControlFlow 0 23505) 23495) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 23505) 23062) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t5@1)) (and (=> (= (ControlFlow 0 23040) 23505) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 23040) 23054) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon6$6_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t5@1 ($Integer 2)) (= (ControlFlow 0 23046) 23040)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $TestInvariants_R_x) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) $TestInvariants_R_x))) (= (ControlFlow 0 22977) 23046))) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon6$6_correct))))
(let ((inline$$TestInvariants_R_$unpack_ref$1$anon0_correct@@0  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$1$$before@0@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 22855) 22977)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestInvariants_R_$unpack_ref$1$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (= (ControlFlow 0 22849) 22855)) inline$$TestInvariants_R_$unpack_ref$1$anon0_correct@@0)))
(let ((inline$$BorrowLoc$1$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$1$dst@1@@1 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@2|)) (= (ControlFlow 0 22822) 22849)) inline$$TestInvariants_R_$unpack_ref$1$Entry_correct@@0)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@2| inline$$TestInvariants_R_pack$0$$struct@1@@4) (= (ControlFlow 0 22740) 22822)) inline$$BorrowLoc$1$anon0_correct@@1))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 inline$$TestInvariants_R_pack$0$$struct@1@@4 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@2| |inline$$WritebackToValue$0$vdst'@1@@3|) (= (ControlFlow 0 22766) 22822))) inline$$BorrowLoc$1$anon0_correct@@1)))
(let ((inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@3  (and (=> (= (ControlFlow 0 22643) (- 0 36967)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@3)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@3)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 22643) 22766) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 22643) 22740) inline$$WritebackToValue$0$anon3_Else_correct@@3))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestInvariants_R_$pack_ref$0$$after@0@@3 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 22631) 22643)) inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@3)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@3) (= (ControlFlow 0 22542) 22631)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@3))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 22598) 22631))) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@3)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) (and (=> (= (ControlFlow 0 22506) 22598) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 22506) 22542) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 22369) 22506)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon15_Then_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= (ControlFlow 0 23515) 22506)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon14_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 22361) 23515) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 22361) 22369) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon14_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (and (=> (= (ControlFlow 0 23525) 23515) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 23525) 22369) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@1) (|p#$Mutation| inline$$BorrowField$0$dst@1@@1) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t4@1)) (and (=> (= (ControlFlow 0 22347) 23525) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 22347) 22361) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon2$3_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 22353) 22347)) inline$$WriteRef$0$anon0_correct@@3)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $TestInvariants_R_x) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $TestInvariants_R_x))) (= (ControlFlow 0 22284) 22353))) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon2$3_correct))))
(let ((inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@3  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$0$$before@0@@3)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 22162) 22284)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestInvariants_R_$unpack_ref$0$$before@0@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (= (ControlFlow 0 22156) 22162)) inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@3)))
(let ((inline$$BorrowLoc$0$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$0$dst@1@@3 ($Mutation ($Local 0) $EmptyPath inline$$TestInvariants_R_pack$0$$struct@1@@4)) (= (ControlFlow 0 22129) 22156)) inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@3)))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 22079) 22129)) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 23533) 22129) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@4  (and (=> (= (ControlFlow 0 22045) (- 0 36640)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@4)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@4)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 22045) 23533) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 22045) 22079) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 22059) 22045)) inline$$TestInvariants_R_pack$0$anon3_correct@@4)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@4  (=> (= (ControlFlow 0 22065) 22045) inline$$TestInvariants_R_pack$0$anon3_correct@@4)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@4  (=> (> 2398 0) (and (=> (= (ControlFlow 0 22053) 22065) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@4) (=> (= (ControlFlow 0 22053) 22059) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@4)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@4  (=> (and (>= 0 2398) (= (ControlFlow 0 22033) 22045)) inline$$TestInvariants_R_pack$0$anon3_correct@@4)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@4  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t3@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@4 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t3@1) 1)))) (and (=> (= (ControlFlow 0 22025) 22053) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@4) (=> (= (ControlFlow 0 22025) 22033) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@4)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$$t3@1 ($Integer 3)) (= (ControlFlow 0 22071) 22025)) inline$$TestInvariants_R_pack$0$anon0_correct@@4))))
(let ((anon0_correct@@4  (=> (= (ControlFlow 0 36369) 22071) inline$$TestInvariants_lifetime_invalid_R_$def_verify$0$anon0_correct)))
anon0_correct@@4)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@3| () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@6 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@5 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$TestInvariants_R_$unpack_ref$1$$before@0@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@5 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@4| () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$0$$after@0@@4 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@4| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun inline$$TestInvariants_R_$unpack_ref$0$$before@0@@4 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 37413) (let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon24_Else_correct true))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon24_Then_correct true))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@2  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 0))) (and (=> (= (ControlFlow 0 25854) 25906) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 25854) 25896) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@2  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 |inline$$WritebackToValue$0$vdst'@2@@3| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)))) (and (=> (= (ControlFlow 0 25880) 25906) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 25880) 25896) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestInvariants_R_$pack_ref$1$anon0_correct@@0  (and (=> (= (ControlFlow 0 25757) (- 0 38468)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$1$$after@0@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$1$$after@0@@0)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 25757) 25880) inline$$WritebackToValue$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 25757) 25854) inline$$WritebackToValue$1$anon3_Else_correct@@2))))))
(let ((inline$$TestInvariants_R_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestInvariants_R_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (= (ControlFlow 0 25745) 25757)) inline$$TestInvariants_R_$pack_ref$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| inline$$BorrowLoc$1$dst@1@@2) (= (ControlFlow 0 25656) 25745)) inline$$TestInvariants_R_$pack_ref$1$Entry_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 25712) 25745))) inline$$TestInvariants_R_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@2))) (and (=> (= (ControlFlow 0 25620) 25712) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 25620) 25656) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 25483) 25620)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon23_Then_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@6 (|v#$Mutation| |inline$$WriteRef$2$to'@1|)) (= (ControlFlow 0 25916) 25620)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon22_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 25475) 25916) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 25475) 25483) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon22_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@5 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2)) (and (=> (= (ControlFlow 0 25926) 25916) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 25926) 25483) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t6@1)) (and (=> (= (ControlFlow 0 25461) 25926) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 25461) 25475) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon10$6_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t6@1 ($Integer 3)) (= (ControlFlow 0 25467) 25461)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $TestInvariants_R_x) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2))) $TestInvariants_R_x))) (= (ControlFlow 0 25398) 25467))) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon10$6_correct))))
(let ((inline$$TestInvariants_R_$unpack_ref$1$anon0_correct@@1  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$1$$before@0@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 25276) 25398)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$TestInvariants_R_$unpack_ref$1$Entry_correct@@1  (=> (and (= inline$$TestInvariants_R_$unpack_ref$1$$before@0@@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2)) (= (ControlFlow 0 25270) 25276)) inline$$TestInvariants_R_$unpack_ref$1$anon0_correct@@1)))
(let ((inline$$BorrowLoc$1$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$1$dst@1@@2 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@3|)) (= (ControlFlow 0 25243) 25270)) inline$$TestInvariants_R_$unpack_ref$1$Entry_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@4  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@3| inline$$TestInvariants_R_pack$0$$struct@1@@5) (= (ControlFlow 0 25161) 25243)) inline$$BorrowLoc$1$anon0_correct@@2))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@4  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) 0 inline$$TestInvariants_R_pack$0$$struct@1@@5 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@3| |inline$$WritebackToValue$0$vdst'@1@@4|) (= (ControlFlow 0 25187) 25243))) inline$$BorrowLoc$1$anon0_correct@@2)))
(let ((inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@4  (and (=> (= (ControlFlow 0 25064) (- 0 38098)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@4)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@4)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 25064) 25187) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 25064) 25161) inline$$WritebackToValue$0$anon3_Else_correct@@4))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestInvariants_R_$pack_ref$0$$after@0@@4 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (= (ControlFlow 0 25052) 25064)) inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@4)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowLoc$0$dst@1@@4) (= (ControlFlow 0 24963) 25052)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@4))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|) (= (ControlFlow 0 25019) 25052))) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@4)))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) (and (=> (= (ControlFlow 0 24927) 25019) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 24927) 24963) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 24790) 24927)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon21_Then_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@4 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= (ControlFlow 0 25936) 24927)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24782) 25936) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 24782) 24790) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon20_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (and (=> (= (ControlFlow 0 25946) 25936) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 25946) 24790) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|) (|p#$Mutation| |inline$$WriteRef$0$to'@1@@4|) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t5@1)) (and (=> (= (ControlFlow 0 24768) 25946) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 24768) 24782) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon6_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t5@1 ($Integer 2)) (= (ControlFlow 0 24774) 24768)) inline$$WriteRef$1$anon0_correct@@1)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 24711) 24774)) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon6_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon19_Then_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (= (ControlFlow 0 25956) 24774)) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon6_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon18_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24703) 25956) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 24703) 24711) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon18_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (and (=> (= (ControlFlow 0 25966) 25956) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 25966) 24711) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@4  (=> (= |inline$$WriteRef$0$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) (|p#$Mutation| inline$$BorrowField$0$dst@1@@2) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t4@1)) (and (=> (= (ControlFlow 0 24689) 25966) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 24689) 24703) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon2$3_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 24695) 24689)) inline$$WriteRef$0$anon0_correct@@4)))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $TestInvariants_R_x) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) $TestInvariants_R_x))) (= (ControlFlow 0 24626) 24695))) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon2$3_correct))))
(let ((inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@4  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$0$$before@0@@4)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 24504) 24626)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestInvariants_R_$unpack_ref$0$$before@0@@4 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (= (ControlFlow 0 24498) 24504)) inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@4)))
(let ((inline$$BorrowLoc$0$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$0$dst@1@@4 ($Mutation ($Local 0) $EmptyPath inline$$TestInvariants_R_pack$0$$struct@1@@5)) (= (ControlFlow 0 24471) 24498)) inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@4)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 24421) 24471)) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 25974) 24471) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@5  (and (=> (= (ControlFlow 0 24387) (- 0 37701)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@5)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@5)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 24387) 25974) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 24387) 24421) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@5  (=> (and (not true) (= (ControlFlow 0 24401) 24387)) inline$$TestInvariants_R_pack$0$anon3_correct@@5)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@5  (=> (= (ControlFlow 0 24407) 24387) inline$$TestInvariants_R_pack$0$anon3_correct@@5)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@5  (=> (> 2668 0) (and (=> (= (ControlFlow 0 24395) 24407) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@5) (=> (= (ControlFlow 0 24395) 24401) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@5)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@5  (=> (and (>= 0 2668) (= (ControlFlow 0 24375) 24387)) inline$$TestInvariants_R_pack$0$anon3_correct@@5)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@5  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t3@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@5 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t3@1) 1)))) (and (=> (= (ControlFlow 0 24367) 24395) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@5) (=> (= (ControlFlow 0 24367) 24375) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@5)))))
(let ((inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$$t3@1 ($Integer 4)) (= (ControlFlow 0 24413) 24367)) inline$$TestInvariants_R_pack$0$anon0_correct@@5))))
(let ((anon0_correct@@5  (=> (= (ControlFlow 0 37413) 24413) inline$$TestInvariants_lifetime_invalid_R_2_$def_verify$0$anon0_correct)))
anon0_correct@@5)))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$3$vdst'@1| () T@$Value)
(declare-fun inline$$TestInvariants_S_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$TestInvariants_S_$pack_ref$1$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun inline$$TestInvariants_T_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$TestInvariants_T_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowLoc$0$dst@1@@5 () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@9 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@8 () T@$Value)
(declare-fun |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@7 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@6 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t10@1 () T@$Value)
(declare-fun cond () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@3| () T@$Value)
(declare-fun inline$$TestInvariants_S_$pack_ref$0$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@5| () T@$Value)
(declare-fun inline$$TestInvariants_T_$pack_ref$1$$after@0 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@5 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$TestInvariants_S_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun inline$$TestInvariants_T_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$TestInvariants_S_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$TestInvariants_T_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 38546) (let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon48_Else_correct true))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon48_Then_correct true))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 28811) 28831) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 28811) 28821) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 28839) 28831) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 28839) 28821) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon48_Else_correct))))
(let ((inline$$WritebackToValue$3$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) ($Local 3))) (and (=> (= (ControlFlow 0 29792) 28839) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 29792) 28811) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) ($Local 3)) (= |inline$$WritebackToValue$3$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 inline$$TestInvariants_S_pack$0$$struct@1 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)))) (and (=> (= (ControlFlow 0 29818) 28839) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 29818) 28811) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$TestInvariants_S_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 29695) (- 0 40346)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_$pack_ref$1$$after@0)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_$pack_ref$1$$after@0)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 29695) 29818) inline$$WritebackToValue$3$anon3_Then_correct) (=> (= (ControlFlow 0 29695) 29792) inline$$WritebackToValue$3$anon3_Else_correct))))))
(let ((inline$$TestInvariants_S_$pack_ref$1$Entry_correct  (=> (and (= inline$$TestInvariants_S_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 29673) 29695)) inline$$TestInvariants_S_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 1))) (= (ControlFlow 0 29604) 29673)) inline$$TestInvariants_S_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 inline$$TestInvariants_T_pack$0$$struct@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= (ControlFlow 0 29630) 29673)) inline$$TestInvariants_S_$pack_ref$1$Entry_correct))))
(let ((inline$$TestInvariants_T_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 29507) (- 0 40270)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_$pack_ref$2$$after@0)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_$pack_ref$2$$after@0)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 29507) 29630) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 29507) 29604) inline$$WritebackToValue$2$anon3_Else_correct))))))
(let ((inline$$TestInvariants_T_$pack_ref$2$Entry_correct  (=> (and (= inline$$TestInvariants_T_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 29485) 29507)) inline$$TestInvariants_T_$pack_ref$2$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| inline$$BorrowLoc$1$dst@1@@3) (= (ControlFlow 0 29386) 29485)) inline$$TestInvariants_T_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 29442) 29485))) inline$$TestInvariants_T_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@3))) (and (=> (= (ControlFlow 0 29350) 29442) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 29350) 29386) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowLoc$0$dst@1@@5) (= (ControlFlow 0 29151) 29350)) inline$$WritebackToReference$3$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 29207) 29350))) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) (and (=> (= (ControlFlow 0 29115) 29207) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 29115) 29151) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 28978) 29115)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon42_Then_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@9 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= (ControlFlow 0 29836) 29115)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 28970) 29836) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 28970) 28978) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon41_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@8 (|v#$Mutation| |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1|)) (and (=> (= (ControlFlow 0 29846) 29836) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 29846) 28978) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon40_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 28962) 29846) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 28962) 28970) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon40_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@7 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3)) (and (=> (= (ControlFlow 0 29856) 29846) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 29856) 28970) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon39_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 28954) 29856) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 28954) 28962) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon39_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@6 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (and (=> (= (ControlFlow 0 29866) 29856) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 29866) 28962) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct@@2  (=> (= |inline$$WriteRef$1$to'@1@@2| ($Mutation (|l#$Mutation| |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1|) (|p#$Mutation| |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1|) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t10@1)) (and (=> (= (ControlFlow 0 28940) 29866) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 28940) 28954) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon38_Then_correct  (=> (|b#$Boolean| cond) (=> (and (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t10@1 ($Integer 2)) (= (ControlFlow 0 28946) 28940)) inline$$WriteRef$1$anon0_correct@@2))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) ($Local 3))) (and (=> (= (ControlFlow 0 28767) 28839) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 28767) 28811) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@3  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) ($Local 3)) (= |inline$$WritebackToValue$1$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) 0 inline$$TestInvariants_S_pack$0$$struct@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)))) (and (=> (= (ControlFlow 0 28793) 28839) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 28793) 28811) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$TestInvariants_S_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 28670) (- 0 39862)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_$pack_ref$0$$after@0)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_$pack_ref$0$$after@0)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 28670) 28793) inline$$WritebackToValue$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 28670) 28767) inline$$WritebackToValue$1$anon3_Else_correct@@3))))))
(let ((inline$$TestInvariants_S_$pack_ref$0$Entry_correct  (=> (and (= inline$$TestInvariants_S_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (= (ControlFlow 0 28648) 28670)) inline$$TestInvariants_S_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@5  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) ($Local 1))) (= (ControlFlow 0 28579) 28648)) inline$$TestInvariants_S_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@5  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) 0 inline$$TestInvariants_T_pack$0$$struct@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))) (= (ControlFlow 0 28605) 28648)) inline$$TestInvariants_S_$pack_ref$0$Entry_correct))))
(let ((inline$$TestInvariants_T_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 28482) (- 0 39786)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_$pack_ref$1$$after@0)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_$pack_ref$1$$after@0)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 28482) 28605) inline$$WritebackToValue$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 28482) 28579) inline$$WritebackToValue$0$anon3_Else_correct@@5))))))
(let ((inline$$TestInvariants_T_$pack_ref$1$Entry_correct  (=> (and (= inline$$TestInvariants_T_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (= (ControlFlow 0 28460) 28482)) inline$$TestInvariants_T_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@1| inline$$BorrowLoc$1$dst@1@@3) (= (ControlFlow 0 28361) 28460)) inline$$TestInvariants_T_$pack_ref$1$Entry_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|) (= (ControlFlow 0 28417) 28460))) inline$$TestInvariants_T_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@3))) (and (=> (= (ControlFlow 0 28325) 28417) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 28325) 28361) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| inline$$BorrowLoc$0$dst@1@@5) (= (ControlFlow 0 28126) 28325)) inline$$WritebackToReference$1$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 28182) 28325))) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) (and (=> (= (ControlFlow 0 28090) 28182) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 28090) 28126) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 27953) 28090)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon46_Then_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@5 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (= (ControlFlow 0 28849) 28090)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27945) 28849) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 27945) 27953) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon45_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@4 (|v#$Mutation| |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1|)) (and (=> (= (ControlFlow 0 28859) 28849) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 28859) 27953) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon44_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27937) 28859) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 27937) 27945) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon44_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@3 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3)) (and (=> (= (ControlFlow 0 28869) 28859) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 28869) 27945) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27929) 28869) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 27929) 27937) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon43_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (and (=> (= (ControlFlow 0 28879) 28869) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 28879) 27937) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@5  (=> (= |inline$$WriteRef$0$to'@1@@5| ($Mutation (|l#$Mutation| |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1|) (|p#$Mutation| |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1|) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t11@1)) (and (=> (= (ControlFlow 0 27915) 28879) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 27915) 27929) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon38_Else_correct  (=> (not (|b#$Boolean| cond)) (=> (and (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t11@1 ($Integer 0)) (= (ControlFlow 0 27921) 27915)) inline$$WriteRef$0$anon0_correct@@5))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon37_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27850) 28946) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 27850) 27921) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon37_Then_correct  (=> (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1|)) (and (=> (= (ControlFlow 0 29876) 28946) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 29876) 27921) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Then$2_correct  (=> (= |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1| inline$$BorrowField$1$dst@1@@1) (and (=> (= (ControlFlow 0 30069) 29876) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 30069) 27850) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $TestInvariants_T_x) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) $TestInvariants_T_x))) (= (ControlFlow 0 30061) 30069))) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Then$2_correct))))
(let ((inline$$TestInvariants_S_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 29939) (- 0 39290)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_$pack_ref$2$$after@0)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_$pack_ref$2$$after@0)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 29939) 30061) inline$$BorrowField$1$anon0_correct@@1)))))
(let ((inline$$TestInvariants_S_$pack_ref$2$Entry_correct  (=> (and (= inline$$TestInvariants_S_$pack_ref$2$$after@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3)) (= (ControlFlow 0 29917) 29939)) inline$$TestInvariants_S_$pack_ref$2$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Then_correct  (=> (and (|b#$Boolean| cond) (= (ControlFlow 0 29943) 29917)) inline$$TestInvariants_S_$pack_ref$2$Entry_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Else$2_correct  (=> (= |inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$tmp#$5@1| inline$$BorrowField$0$dst@1@@3) (and (=> (= (ControlFlow 0 27808) 29876) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 27808) 27850) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $TestInvariants_S_y) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3))) $TestInvariants_S_y))) (= (ControlFlow 0 27800) 27808))) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Else$2_correct))))
(let ((inline$$TestInvariants_T_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 27678) (- 0 39190)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_$pack_ref$0$$after@0)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_$pack_ref$0$$after@0)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 27678) 27800) inline$$BorrowField$0$anon0_correct@@3)))))
(let ((inline$$TestInvariants_T_$pack_ref$0$Entry_correct  (=> (and (= inline$$TestInvariants_T_$pack_ref$0$$after@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (= (ControlFlow 0 27656) 27678)) inline$$TestInvariants_T_$pack_ref$0$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Else_correct  (=> (and (not (|b#$Boolean| cond)) (= (ControlFlow 0 27682) 27656)) inline$$TestInvariants_T_$pack_ref$0$Entry_correct)))
(let ((inline$$TestInvariants_S_$unpack_ref$0$anon0_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_$unpack_ref$0$$before@0)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 27607) 29943) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 27607) 27682) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestInvariants_S_$unpack_ref$0$Entry_correct  (=> (and (= inline$$TestInvariants_S_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3)) (= (ControlFlow 0 27601) 27607)) inline$$TestInvariants_S_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$1$dst@1@@3 ($Mutation ($Local 3) $EmptyPath inline$$TestInvariants_S_pack$0$$struct@1)) (= (ControlFlow 0 27574) 27601)) inline$$TestInvariants_S_$unpack_ref$0$Entry_correct)))
(let ((inline$$TestInvariants_T_$unpack_ref$0$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_$unpack_ref$0$$before@0)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 27520) 27574)) inline$$BorrowLoc$1$anon0_correct@@3)))
(let ((inline$$TestInvariants_T_$unpack_ref$0$Entry_correct  (=> (and (= inline$$TestInvariants_T_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (= (ControlFlow 0 27514) 27520)) inline$$TestInvariants_T_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$0$dst@1@@5 ($Mutation ($Local 1) $EmptyPath inline$$TestInvariants_T_pack$0$$struct@1)) (= (ControlFlow 0 27487) 27514)) inline$$TestInvariants_T_$unpack_ref$0$Entry_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 27437) 27487)) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 30077) 27487) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$TestInvariants_S_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 27403) (- 0 39069)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_pack$0$$struct@1)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_S_pack$0$$struct@1)) $TestInvariants_S_y)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 27403) 30077) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 27403) 27437) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$TestInvariants_S_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 27417) 27403)) inline$$TestInvariants_S_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_S_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 27423) 27403) inline$$TestInvariants_S_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_S_pack$0$anon4_Then_correct  (=> (> 3178 0) (and (=> (= (ControlFlow 0 27411) 27423) inline$$TestInvariants_S_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 27411) 27417) inline$$TestInvariants_S_pack$0$anon5_Else_correct)))))
(let ((inline$$TestInvariants_S_pack$0$anon4_Else_correct  (=> (and (>= 0 3178) (= (ControlFlow 0 27381) 27403)) inline$$TestInvariants_S_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_S_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t9@1) (>= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t9@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t9@1) $MAX_U64)) (= inline$$TestInvariants_S_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t9@1) 1)))) (and (=> (= (ControlFlow 0 27373) 27411) inline$$TestInvariants_S_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 27373) 27381) inline$$TestInvariants_S_pack$0$anon4_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon4_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t9@1 ($Integer 4)) (= (ControlFlow 0 27429) 27373)) inline$$TestInvariants_S_pack$0$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 27221) 27429)) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon4_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 30085) 27429) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon4_correct)))
(let ((inline$$TestInvariants_T_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 27187) (- 0 38970)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_pack$0$$struct@1)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_T_pack$0$$struct@1)) $TestInvariants_T_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 27187) 30085) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 27187) 27221) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$TestInvariants_T_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 27201) 27187)) inline$$TestInvariants_T_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_T_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 27207) 27187) inline$$TestInvariants_T_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_T_pack$0$anon4_Then_correct  (=> (> 3154 0) (and (=> (= (ControlFlow 0 27195) 27207) inline$$TestInvariants_T_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 27195) 27201) inline$$TestInvariants_T_pack$0$anon5_Else_correct)))))
(let ((inline$$TestInvariants_T_pack$0$anon4_Else_correct  (=> (and (>= 0 3154) (= (ControlFlow 0 27165) 27187)) inline$$TestInvariants_T_pack$0$anon3_correct)))
(let ((inline$$TestInvariants_T_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t8@1) $MAX_U64)) (= inline$$TestInvariants_T_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t8@1) 1)))) (and (=> (= (ControlFlow 0 27157) 27195) inline$$TestInvariants_T_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 27157) 27165) inline$$TestInvariants_T_pack$0$anon4_Else_correct)))))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$$t8@1 ($Integer 3)) (= (ControlFlow 0 27213) 27157)) inline$$TestInvariants_T_pack$0$anon0_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 26971) 27213)) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 30093) 27213) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 26965) 30093) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 26965) 26971) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon33_Else_correct)))))
(let ((anon0_correct@@6  (=> (and ((_ is $Boolean) cond) (= (ControlFlow 0 26327) 26965)) inline$$TestInvariants_lifetime_invalid_S_branching_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 38546) 26327) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun |inline$$WriteRef$0$to'@1@@6| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@6| () T@$Value)
(declare-fun r@@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@6 () T@$Mutation)
(declare-fun inline$$TestInvariants_update_helper_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 40450) (let ((inline$$TestInvariants_update_helper_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TestInvariants_update_helper_$def_verify$0$anon6_Then_correct true))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@6  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 1))) (and (=> (= (ControlFlow 0 31019) 31071) inline$$TestInvariants_update_helper_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 31019) 31061) inline$$TestInvariants_update_helper_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@6  (=> (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1@@6| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@6|) 0 r@@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@6|)))) (and (=> (= (ControlFlow 0 31045) 31071) inline$$TestInvariants_update_helper_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 31045) 31061) inline$$TestInvariants_update_helper_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@6  (=> (= |inline$$WriteRef$0$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6) inline$$TestInvariants_update_helper_$def_verify$0$$t3@1)) (and (=> (= (ControlFlow 0 30920) 31045) inline$$WritebackToValue$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 30920) 31019) inline$$WritebackToValue$0$anon3_Else_correct@@6)))))
(let ((inline$$TestInvariants_update_helper_$def_verify$0$anon2$2_correct  (=> (and (= inline$$TestInvariants_update_helper_$def_verify$0$$t3@1 ($Integer 4)) (= (ControlFlow 0 30926) 30920)) inline$$WriteRef$0$anon0_correct@@6)))
(let ((inline$$BorrowLoc$0$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$0$dst@1@@6 ($Mutation ($Local 1) $EmptyPath r@@1)) (= (ControlFlow 0 30857) 30926)) inline$$TestInvariants_update_helper_$def_verify$0$anon2$2_correct)))
(let ((inline$$TestInvariants_update_helper_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 30773) 30857)) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$TestInvariants_update_helper_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 31079) 30857) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$TestInvariants_update_helper_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 30767) 31079) inline$$TestInvariants_update_helper_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 30767) 30773) inline$$TestInvariants_update_helper_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and (and ((_ is $Integer) r@@1) (>= (|i#$Integer| r@@1) 0)) (<= (|i#$Integer| r@@1) $MAX_U64)) (= (ControlFlow 0 30641) 30767)) inline$$TestInvariants_update_helper_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 40450) 30641) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@1)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@6 () T@$Value)
(declare-fun inline$$TestInvariants_valid_R_pack_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 40689) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 31500) (- 0 40862)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@6)) $TestInvariants_R_x) ($Integer 2))))))))
(let ((inline$$TestInvariants_valid_R_pack_$def_verify$0$anon3_Else_correct  (=> (and (not true) (= (ControlFlow 0 31482) 31500)) anon0$2_correct@@2)))
(let ((inline$$TestInvariants_valid_R_pack_$def_verify$0$anon3_Then_correct  (=> (= (ControlFlow 0 31492) 31500) anon0$2_correct@@2)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@6  (and (=> (= (ControlFlow 0 31446) (- 0 40836)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@6)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@6)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 31446) 31492) inline$$TestInvariants_valid_R_pack_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 31446) 31482) inline$$TestInvariants_valid_R_pack_$def_verify$0$anon3_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@6  (=> (and (not true) (= (ControlFlow 0 31460) 31446)) inline$$TestInvariants_R_pack$0$anon3_correct@@6)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@6  (=> (= (ControlFlow 0 31466) 31446) inline$$TestInvariants_R_pack$0$anon3_correct@@6)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@6  (=> (> 0 0) (and (=> (= (ControlFlow 0 31454) 31466) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@6) (=> (= (ControlFlow 0 31454) 31460) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@6)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@6  (=> (and (>= 0 0) (= (ControlFlow 0 31434) 31446)) inline$$TestInvariants_R_pack$0$anon3_correct@@6)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@6  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_valid_R_pack_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$TestInvariants_valid_R_pack_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_valid_R_pack_$def_verify$0$$t0@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@6 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_valid_R_pack_$def_verify$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 31426) 31454) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@6) (=> (= (ControlFlow 0 31426) 31434) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@6)))))
(let ((inline$$TestInvariants_valid_R_pack_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_valid_R_pack_$def_verify$0$$t0@1 ($Integer 2)) (= (ControlFlow 0 31472) 31426)) inline$$TestInvariants_R_pack$0$anon0_correct@@6))))
(let ((anon0_correct@@8  (=> (= (ControlFlow 0 40689) 31472) inline$$TestInvariants_valid_R_pack_$def_verify$0$anon0_correct)))
anon0_correct@@8))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@4| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@7| () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$0$$struct@1@@7 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@7| () T@$Value)
(declare-fun inline$$TestInvariants_R_$pack_ref$0$$after@0@@5 () T@$Value)
(declare-fun inline$$TestInvariants_valid_R_update_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@7 () T@$Mutation)
(declare-fun inline$$TestInvariants_R_pack$1$$struct@1@@1 () T@$Value)
(declare-fun inline$$TestInvariants_valid_R_update_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestInvariants_R_$unpack_ref$0$$before@0@@5 () T@$Value)
(declare-fun inline$$TestInvariants_valid_R_update_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 40886) (let ((anon0$2_correct@@3  (=> (= (ControlFlow 0 32498) (- 0 41359)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@4|)) $TestInvariants_R_x) ($Integer 2))))))))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 32462) 32498)) anon0$2_correct@@3)))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 32472) 32498) anon0$2_correct@@3)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@7  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@4| inline$$TestInvariants_R_pack$0$$struct@1@@7)) (and (=> (= (ControlFlow 0 32420) 32472) inline$$TestInvariants_valid_R_update_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 32420) 32462) inline$$TestInvariants_valid_R_update_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@7  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@7| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@7|) 0 inline$$TestInvariants_R_pack$0$$struct@1@@7 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|))) (= |inline$$WritebackToValue$0$vdst'@2@@4| |inline$$WritebackToValue$0$vdst'@1@@7|)) (and (=> (= (ControlFlow 0 32446) 32472) inline$$TestInvariants_valid_R_update_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 32446) 32462) inline$$TestInvariants_valid_R_update_$def_verify$0$anon9_Else_correct))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@5  (and (=> (= (ControlFlow 0 32323) (- 0 41279)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@5)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$pack_ref$0$$after@0@@5)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 32323) 32446) inline$$WritebackToValue$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 32323) 32420) inline$$WritebackToValue$0$anon3_Else_correct@@7))))))
(let ((inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@5  (=> (and (= inline$$TestInvariants_R_$pack_ref$0$$after@0@@5 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (= (ControlFlow 0 32311) 32323)) inline$$TestInvariants_R_$pack_ref$0$anon0_correct@@5)))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 32284) 32311)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@5)))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon8_Then_correct  (=> (and (= inline$$TestInvariants_valid_R_update_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (= (ControlFlow 0 32482) 32311)) inline$$TestInvariants_R_$pack_ref$0$Entry_correct@@5)))
(let ((inline$$WriteRef$0$anon0_correct@@7  (=> (= |inline$$WriteRef$0$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7) inline$$TestInvariants_R_pack$1$$struct@1@@1)) (and (=> (= (ControlFlow 0 32270) 32482) inline$$TestInvariants_valid_R_update_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 32270) 32284) inline$$TestInvariants_valid_R_update_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestInvariants_R_pack$1$anon3_correct@@1  (and (=> (= (ControlFlow 0 32191) (- 0 41217)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$1$$struct@1@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$1$$struct@1@@1)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 32191) 32270) inline$$WriteRef$0$anon0_correct@@7)))))
(let ((inline$$TestInvariants_R_pack$1$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 32205) 32191)) inline$$TestInvariants_R_pack$1$anon3_correct@@1)))
(let ((inline$$TestInvariants_R_pack$1$anon5_Then_correct@@1  (=> (= (ControlFlow 0 32211) 32191) inline$$TestInvariants_R_pack$1$anon3_correct@@1)))
(let ((inline$$TestInvariants_R_pack$1$anon4_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 32199) 32211) inline$$TestInvariants_R_pack$1$anon5_Then_correct@@1) (=> (= (ControlFlow 0 32199) 32205) inline$$TestInvariants_R_pack$1$anon5_Else_correct@@1)))))
(let ((inline$$TestInvariants_R_pack$1$anon4_Else_correct@@1  (=> (and (>= 0 0) (= (ControlFlow 0 32179) 32191)) inline$$TestInvariants_R_pack$1$anon3_correct@@1)))
(let ((inline$$TestInvariants_R_pack$1$anon0_correct@@1  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_valid_R_update_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestInvariants_valid_R_update_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_valid_R_update_$def_verify$0$$t3@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$1$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_valid_R_update_$def_verify$0$$t3@1) 1)))) (and (=> (= (ControlFlow 0 32171) 32199) inline$$TestInvariants_R_pack$1$anon4_Then_correct@@1) (=> (= (ControlFlow 0 32171) 32179) inline$$TestInvariants_R_pack$1$anon4_Else_correct@@1)))))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon2$2_correct  (=> (and (= inline$$TestInvariants_valid_R_update_$def_verify$0$$t3@1 ($Integer 2)) (= (ControlFlow 0 32217) 32171)) inline$$TestInvariants_R_pack$1$anon0_correct@@1)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@5  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_$unpack_ref$0$$before@0@@5)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 32025) 32217)) inline$$TestInvariants_valid_R_update_$def_verify$0$anon2$2_correct)))
(let ((inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@5  (=> (and (= inline$$TestInvariants_R_$unpack_ref$0$$before@0@@5 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7)) (= (ControlFlow 0 32019) 32025)) inline$$TestInvariants_R_$unpack_ref$0$anon0_correct@@5)))
(let ((inline$$BorrowLoc$0$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$0$dst@1@@7 ($Mutation ($Local 1) $EmptyPath inline$$TestInvariants_R_pack$0$$struct@1@@7)) (= (ControlFlow 0 31992) 32019)) inline$$TestInvariants_R_$unpack_ref$0$Entry_correct@@5)))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 31942) 31992)) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 32490) 31992) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$TestInvariants_R_pack$0$anon3_correct@@7  (and (=> (= (ControlFlow 0 31908) (- 0 41092)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@7)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestInvariants_R_pack$0$$struct@1@@7)) $TestInvariants_R_x)) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 31908) 32490) inline$$TestInvariants_valid_R_update_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 31908) 31942) inline$$TestInvariants_valid_R_update_$def_verify$0$anon7_Else_correct))))))
(let ((inline$$TestInvariants_R_pack$0$anon5_Else_correct@@7  (=> (and (not true) (= (ControlFlow 0 31922) 31908)) inline$$TestInvariants_R_pack$0$anon3_correct@@7)))
(let ((inline$$TestInvariants_R_pack$0$anon5_Then_correct@@7  (=> (= (ControlFlow 0 31928) 31908) inline$$TestInvariants_R_pack$0$anon3_correct@@7)))
(let ((inline$$TestInvariants_R_pack$0$anon4_Then_correct@@7  (=> (> 1121 0) (and (=> (= (ControlFlow 0 31916) 31928) inline$$TestInvariants_R_pack$0$anon5_Then_correct@@7) (=> (= (ControlFlow 0 31916) 31922) inline$$TestInvariants_R_pack$0$anon5_Else_correct@@7)))))
(let ((inline$$TestInvariants_R_pack$0$anon4_Else_correct@@7  (=> (and (>= 0 1121) (= (ControlFlow 0 31896) 31908)) inline$$TestInvariants_R_pack$0$anon3_correct@@7)))
(let ((inline$$TestInvariants_R_pack$0$anon0_correct@@7  (=> (and (and (and ((_ is $Integer) inline$$TestInvariants_valid_R_update_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestInvariants_valid_R_update_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestInvariants_valid_R_update_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestInvariants_R_pack$0$$struct@1@@7 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestInvariants_valid_R_update_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 31888) 31916) inline$$TestInvariants_R_pack$0$anon4_Then_correct@@7) (=> (= (ControlFlow 0 31888) 31896) inline$$TestInvariants_R_pack$0$anon4_Else_correct@@7)))))
(let ((inline$$TestInvariants_valid_R_update_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestInvariants_valid_R_update_$def_verify$0$$t2@1 ($Integer 3)) (= (ControlFlow 0 31934) 31888)) inline$$TestInvariants_R_pack$0$anon0_correct@@7))))
(let ((anon0_correct@@9  (=> (= (ControlFlow 0 40886) 31934) inline$$TestInvariants_valid_R_update_$def_verify$0$anon0_correct)))
anon0_correct@@9)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
