(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestModuleInvariants_S () T@$TypeName)
(declare-fun $TestModuleInvariants_SCounter () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestModuleInvariants_S_dummy_field () Int)
(declare-fun $TestModuleInvariants_S_type_value () T@$TypeValue)
(declare-fun $TestModuleInvariants_SCounter_n () Int)
(declare-fun $TestModuleInvariants_SCounter_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestModuleInvariants_S $TestModuleInvariants_SCounter)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestModuleInvariants_S_dummy_field 0))
(assert (= $TestModuleInvariants_S_type_value ($StructType $TestModuleInvariants_S $EmptyTypeValueArray)))
(assert (= $TestModuleInvariants_SCounter_n 0))
(assert (= $TestModuleInvariants_SCounter_type_value ($StructType $TestModuleInvariants_SCounter $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $TestModuleInvariants_SCounter_$memory@0 () T@$Memory)
(declare-fun $TestModuleInvariants_spec_count@0 () T@$Value)
(declare-fun $TestModuleInvariants_SCounter_$memory () T@$Memory)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_delete_S_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_delete_S_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_delete_S_$def_verify$0$$t4@1 () T@$Value)
(declare-fun x@@8 () T@$Value)
(declare-fun inline$$TestModuleInvariants_S_unpack$0$dummy_field@1 () T@$Value)
(declare-fun $TestModuleInvariants_spec_count () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 25677) (let ((anon0$2_correct  (=> (= (ControlFlow 0 12928) (- 0 26743)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count@0)))))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$Abort_correct  (=> (= $TestModuleInvariants_SCounter_$memory@0 $TestModuleInvariants_SCounter_$memory) (=> (and (= $abort_flag@2 true) (= (ControlFlow 0 12886) 12928)) anon0$2_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 12904) 12886)) inline$$TestModuleInvariants_delete_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 12914) 12886) inline$$TestModuleInvariants_delete_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 12898) 12914) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 12898) 12904) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 12880) 12886)) inline$$TestModuleInvariants_delete_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 12894) 12886) inline$$TestModuleInvariants_delete_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 12874) 12894) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 12874) 12880) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon12$2_correct  (=> (= $TestModuleInvariants_SCounter_$memory@0 |inline$$WritebackToGlobal$0$m'@2|) (=> (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 12860) 12928)) anon0$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $TestModuleInvariants_SCounter_$memory) (= (ControlFlow 0 12798) 12860)) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon12$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 12852) 12860))) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon12$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 12788) 12852) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 12788) 12798) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 12610) 12788)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 12666) 12788))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 12574) 12666) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 12574) 12610) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 12437) 12574)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon18_Then_correct  (=> (and (= inline$$TestModuleInvariants_delete_S_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 12870) 12574)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$Sub$0$dst@2)) (and (=> (= (ControlFlow 0 12423) 12870) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 12423) 12437) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 12364) 12423))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 12370) 12364)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 12234) 12874) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 12234) 12370) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$TestModuleInvariants_delete_S_$def_verify$0$$t6@1)) (= (ControlFlow 0 12232) 12234)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$TestModuleInvariants_delete_S_$def_verify$0$$t6@1) (|i#$Integer| inline$$ReadRef$0$v@1)) (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$TestModuleInvariants_delete_S_$def_verify$0$$t6@1))))) (and (= $abort_flag@1 $abort_flag@0) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 12180) 12874) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 12180) 12370) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 12154) (- 0 26278)) true) (and (=> (= (ControlFlow 0 12154) 12232) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 12154) 12180) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Else$1_correct  (=> (and (= inline$$TestModuleInvariants_delete_S_$def_verify$0$$t6@1 ($Integer 1)) (= (ControlFlow 0 12240) 12154)) inline$$Sub$0$Entry_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 12051) 12240)) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 12013) 12051))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 12065) 12013)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 11847) 12898) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 11847) 12065) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 11845) 11847)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@0 false) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 11793) 12898) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 11793) 12065) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$TestModuleInvariants_delete_S_$def_verify$0$$t4@1)) (and (=> (= (ControlFlow 0 11763) 11845) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 11763) 11793) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 11757) (- 0 26076)) true) (=> (= (ControlFlow 0 11757) 11763) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon2$2_correct  (=> (and (= inline$$TestModuleInvariants_delete_S_$def_verify$0$$t4@1 ($Address 0)) (= (ControlFlow 0 11853) 11757)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$TestModuleInvariants_S_unpack$0$anon0_correct  (=> ((_ is $Vector) x@@8) (=> (and (and (= inline$$TestModuleInvariants_S_unpack$0$dummy_field@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@8)) $TestModuleInvariants_S_dummy_field)) ((_ is $Boolean) inline$$TestModuleInvariants_S_unpack$0$dummy_field@1)) (and (= $TestModuleInvariants_spec_count@0 ($Integer (- (|i#$Integer| $TestModuleInvariants_spec_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 11646) 11853))) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon2$2_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 11522) 11646)) inline$$TestModuleInvariants_S_unpack$0$anon0_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 12922) 11646) inline$$TestModuleInvariants_S_unpack$0$anon0_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 11516) 12922) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 11516) 11522) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr))) $TestModuleInvariants_SCounter_n)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr))) $TestModuleInvariants_SCounter_n)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr))) $TestModuleInvariants_SCounter_n)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count))) (= (ControlFlow 0 12926) 11516)) inline$$TestModuleInvariants_delete_S_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) x@@8) (let ((va@@9 (|v#$Vector| x@@8)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@8)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@8)) $TestModuleInvariants_S_dummy_field))) true) (= (ControlFlow 0 11192) 12926)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (and (and (and ((_ is $Integer) $TestModuleInvariants_spec_count) (>= (|i#$Integer| $TestModuleInvariants_spec_count) 0)) (<= (|i#$Integer| $TestModuleInvariants_spec_count) $MAX_U64)) (= (ControlFlow 0 25677) 11192)) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $TestModuleInvariants_spec_count@0@@0 () T@$Value)
(declare-fun x@@11 () T@$Value)
(declare-fun inline$$TestModuleInvariants_S_unpack$0$dummy_field@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26781) (let ((anon0$2_correct@@0  (=> (= (ControlFlow 0 13489) (- 0 26970)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count@0@@0)))))))
(let ((inline$$TestModuleInvariants_S_unpack$0$anon0_correct@@0  (=> ((_ is $Vector) x@@11) (=> (and (and (= inline$$TestModuleInvariants_S_unpack$0$dummy_field@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@11)) $TestModuleInvariants_S_dummy_field)) ((_ is $Boolean) inline$$TestModuleInvariants_S_unpack$0$dummy_field@1@@0)) (and (= $TestModuleInvariants_spec_count@0@@0 ($Integer (- (|i#$Integer| $TestModuleInvariants_spec_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 13467) 13489))) anon0$2_correct@@0))))
(let ((inline$$TestModuleInvariants_delete_S_incorrect_$def_verify$0$anon3_Else_correct  (=> (and (not true) (= (ControlFlow 0 13343) 13467)) inline$$TestModuleInvariants_S_unpack$0$anon0_correct@@0)))
(let ((inline$$TestModuleInvariants_delete_S_incorrect_$def_verify$0$anon3_Then_correct  (=> (= (ControlFlow 0 13483) 13467) inline$$TestModuleInvariants_S_unpack$0$anon0_correct@@0)))
(let ((inline$$TestModuleInvariants_delete_S_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13337) 13483) inline$$TestModuleInvariants_delete_S_incorrect_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 13337) 13343) inline$$TestModuleInvariants_delete_S_incorrect_$def_verify$0$anon3_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count))) (= (ControlFlow 0 13487) 13337)) inline$$TestModuleInvariants_delete_S_incorrect_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) x@@11) (let ((va@@10 (|v#$Vector| x@@11)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@11)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@11)) $TestModuleInvariants_S_dummy_field))) true) (= (ControlFlow 0 13235) 13487)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (and (and (and ((_ is $Integer) $TestModuleInvariants_spec_count) (>= (|i#$Integer| $TestModuleInvariants_spec_count) 0)) (<= (|i#$Integer| $TestModuleInvariants_spec_count) $MAX_U64)) (= (ControlFlow 0 26781) 13235)) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $TestModuleInvariants_SCounter_$memory@0@@0 () T@$Memory)
(declare-fun $TestModuleInvariants_spec_count@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun $TestModuleInvariants_spec_count@0@@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_S_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def_verify$0$$t1@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27001) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 15422) (- 0 28136)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count@1)))))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$Abort_correct  (=> (= inline$$TestModuleInvariants_new_S_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $TestModuleInvariants_SCounter_$memory@0@@0 $TestModuleInvariants_SCounter_$memory) (= $TestModuleInvariants_spec_count@1 $TestModuleInvariants_spec_count)) (and (= $abort_flag@2@@0 true) (= (ControlFlow 0 15386) 15422))) anon0$2_correct@@1))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 15404) 15386)) inline$$TestModuleInvariants_new_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 15414) 15386) inline$$TestModuleInvariants_new_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 15398) 15414) inline$$TestModuleInvariants_new_S_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 15398) 15404) inline$$TestModuleInvariants_new_S_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 15378) 15386)) inline$$TestModuleInvariants_new_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 15394) 15386) inline$$TestModuleInvariants_new_S_$def_verify$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon15_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 15372) 15394) inline$$TestModuleInvariants_new_S_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 15372) 15378) inline$$TestModuleInvariants_new_S_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon12_correct  (=> (and (and (= $TestModuleInvariants_SCounter_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= $TestModuleInvariants_spec_count@1 $TestModuleInvariants_spec_count@0@@1)) (and (= $abort_flag@2@@0 $abort_flag@1@@0) (= (ControlFlow 0 15350) 15422))) anon0$2_correct@@1)))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 15348) 15350)) inline$$TestModuleInvariants_new_S_$def_verify$0$anon12_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 15358) 15350) inline$$TestModuleInvariants_new_S_$def_verify$0$anon12_correct)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon3_correct  (=> (= $TestModuleInvariants_spec_count@0@@1 ($Integer (+ (|i#$Integer| $TestModuleInvariants_spec_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 15312) 15358) inline$$TestModuleInvariants_new_S_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 15312) 15348) inline$$TestModuleInvariants_new_S_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 15326) 15312)) inline$$TestModuleInvariants_S_pack$0$anon3_correct)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 15332) 15312) inline$$TestModuleInvariants_S_pack$0$anon3_correct)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 15320) 15332) inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 15320) 15326) inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 15296) 15312)) inline$$TestModuleInvariants_S_pack$0$anon3_correct)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$TestModuleInvariants_new_S_$def_verify$0$$t6@1) (= inline$$TestModuleInvariants_S_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestModuleInvariants_new_S_$def_verify$0$$t6@1) 1)))) (and (=> (= (ControlFlow 0 15288) 15320) inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 15288) 15296) inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon10$2_correct  (=> (and (= inline$$TestModuleInvariants_new_S_$def_verify$0$$t6@1 ($Boolean false)) (= (ControlFlow 0 15338) 15288)) inline$$TestModuleInvariants_S_pack$0$anon0_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $TestModuleInvariants_SCounter_$memory) (= (ControlFlow 0 15072) 15338)) inline$$TestModuleInvariants_new_S_$def_verify$0$anon10$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 15126) 15338))) inline$$TestModuleInvariants_new_S_$def_verify$0$anon10$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 15062) 15126) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15062) 15072) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 14884) 15062)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 14940) 15062))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 14848) 14940) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 14848) 14884) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 14711) 14848)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon17_Then_correct  (=> (and (= inline$$TestModuleInvariants_new_S_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 15368) 14848)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 14697) 15368) inline$$TestModuleInvariants_new_S_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 14697) 14711) inline$$TestModuleInvariants_new_S_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 14638) 14697))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 14644) 14638)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@0 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 14508) 15372) inline$$TestModuleInvariants_new_S_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 14508) 14644) inline$$TestModuleInvariants_new_S_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def_verify$0$$t3@1)) $MAX_U64) (= (ControlFlow 0 14506) 14508)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def_verify$0$$t3@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def_verify$0$$t3@1))))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 14450) 15372) inline$$TestModuleInvariants_new_S_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 14450) 14644) inline$$TestModuleInvariants_new_S_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 14420) (- 0 27537)) true) (and (=> (= (ControlFlow 0 14420) 14506) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 14420) 14450) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Else$1_correct  (=> (and (= inline$$TestModuleInvariants_new_S_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 14514) 14420)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 14309) 14514)) inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 14271) 14309))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 14323) 14271)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@0 true) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 14105) 15398) inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14105) 14323) inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 14103) 14105)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)))) (and (= $abort_flag@0@@0 false) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 14051) 15398) inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14051) 14323) inline$$TestModuleInvariants_new_S_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| inline$$TestModuleInvariants_new_S_$def_verify$0$$t1@1)) (and (=> (= (ControlFlow 0 14021) 14103) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 14021) 14051) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 14015) (- 0 27335)) true) (=> (= (ControlFlow 0 14015) 14021) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$TestModuleInvariants_new_S_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestModuleInvariants_new_S_$def_verify$0$$t1@1 ($Address 0)) (= (ControlFlow 0 14111) 14015)) inline$$BorrowGlobal$0$Entry_correct@@0))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestModuleInvariants_SCounter_n)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestModuleInvariants_SCounter_n)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestModuleInvariants_SCounter_n)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count))) (= (ControlFlow 0 15420) 14111)) inline$$TestModuleInvariants_new_S_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and (and (and ((_ is $Integer) $TestModuleInvariants_spec_count) (>= (|i#$Integer| $TestModuleInvariants_spec_count) 0)) (<= (|i#$Integer| $TestModuleInvariants_spec_count) $MAX_U64)) (= (ControlFlow 0 27001) 15420)) anon0$1_correct@@1)))
anon0_correct@@1))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $TestModuleInvariants_spec_count@0@@2 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_S_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t3@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t1@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28166) (let ((inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon6_Then_correct true))
(let ((inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon5_Else_correct  (=> (not $abort_flag@2@@1) (and (=> (= (ControlFlow 0 17784) 17800) inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 17784) 17790) inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon5_Then_correct true))
(let ((inline$$TestModuleInvariants_new_S_$def$0$Abort_correct  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$ret0@1 $Error) (= $abort_flag@2@@1 true)) (and (=> (= (ControlFlow 0 17732) 17808) inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 17732) 17784) inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 17750) 17732)) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon14_Then_correct  (=> (= (ControlFlow 0 17760) 17732) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 17744) 17760) inline$$TestModuleInvariants_new_S_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 17744) 17750) inline$$TestModuleInvariants_new_S_$def$0$anon14_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 17724) 17732)) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon16_Then_correct  (=> (= (ControlFlow 0 17740) 17732) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 17718) 17740) inline$$TestModuleInvariants_new_S_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 17718) 17724) inline$$TestModuleInvariants_new_S_$def$0$anon16_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon12_correct  (=> (= $abort_flag@2@@1 $abort_flag@1@@1) (and (=> (= (ControlFlow 0 17696) 17808) inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 17696) 17784) inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 17694) 17696)) inline$$TestModuleInvariants_new_S_$def$0$anon12_correct)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 17704) 17696) inline$$TestModuleInvariants_new_S_$def$0$anon12_correct)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon3_correct@@0  (=> (= $TestModuleInvariants_spec_count@0@@2 ($Integer (+ (|i#$Integer| $TestModuleInvariants_spec_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 17658) 17704) inline$$TestModuleInvariants_new_S_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 17658) 17694) inline$$TestModuleInvariants_new_S_$def$0$anon18_Else_correct)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 17672) 17658)) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@0)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 17678) 17658) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@0)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 17666) 17678) inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 17666) 17672) inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 17642) 17658)) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@0)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon0_correct@@0  (=> (and ((_ is $Boolean) inline$$TestModuleInvariants_new_S_$def$0$$t6@1) (= inline$$TestModuleInvariants_S_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestModuleInvariants_new_S_$def$0$$t6@1) 1)))) (and (=> (= (ControlFlow 0 17634) 17666) inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 17634) 17642) inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t6@1 ($Boolean false)) (= (ControlFlow 0 17684) 17634)) inline$$TestModuleInvariants_S_pack$0$anon0_correct@@0)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (= (ControlFlow 0 17418) 17684)) inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)))) (and (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1))) (= (ControlFlow 0 17472) 17684))) inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 17408) 17472) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 17408) 17418) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 17230) 17408)) inline$$WritebackToGlobal$0$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 17286) 17408))) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 17194) 17286) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 17194) 17230) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 17057) 17194)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon17_Then_correct  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 17714) 17194)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@1) (|p#$Mutation| inline$$BorrowField$1$dst@1@@1) inline$$AddU64$0$dst@2@@0)) (and (=> (= (ControlFlow 0 17043) 17714) inline$$TestModuleInvariants_new_S_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 17043) 17057) inline$$TestModuleInvariants_new_S_$def$0$anon17_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 16984) 17043))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 16990) 16984)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@1 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 16854) 17718) inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 16854) 16990) inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1)) $MAX_U64) (= (ControlFlow 0 16852) 16854)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1))))) (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 16796) 17718) inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 16796) 16990) inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 16766) (- 0 28758)) true) (and (=> (= (ControlFlow 0 16766) 16852) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 16766) 16796) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Else$1_correct  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 16860) 16766)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 16655) 16860)) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 16617) 16655))) inline$$ReadRef$0$anon0_correct@@1))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 16669) 16617)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@1 true) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 16451) 17744) inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 16451) 16669) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 16449) 16451)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1)))) (and (= $abort_flag@0@@1 false) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 16397) 17744) inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 16397) 16669) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| inline$$TestModuleInvariants_new_S_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 16367) 16449) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 16367) 16397) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 16361) (- 0 28556)) true) (=> (= (ControlFlow 0 16361) 16367) inline$$BorrowGlobal$0$anon0_correct@@1))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t1@1 ($Address 0)) (= (ControlFlow 0 16457) 16361)) inline$$BorrowGlobal$0$Entry_correct@@1))))
(let ((inline$$TestModuleInvariants_new_S_$direct_intra$0$Entry_correct  (and (=> (= (ControlFlow 0 15967) (- 0 28457)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count))) (=> (= (ControlFlow 0 15967) 16457) inline$$TestModuleInvariants_new_S_$def$0$anon0_correct)))))
(let ((inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 17774) 15967)) inline$$TestModuleInvariants_new_S_$direct_intra$0$Entry_correct)))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestModuleInvariants_SCounter_n)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestModuleInvariants_SCounter_n)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestModuleInvariants_SCounter_n)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count))) (= (ControlFlow 0 17814) 17774)) inline$$TestModuleInvariants_private_calls_public_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (and (and (and ((_ is $Integer) $TestModuleInvariants_spec_count) (>= (|i#$Integer| $TestModuleInvariants_spec_count) 0)) (<= (|i#$Integer| $TestModuleInvariants_spec_count) $MAX_U64)) (= (ControlFlow 0 28166) 17814)) anon0$1_correct@@2)))
anon0_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $TestModuleInvariants_spec_count@0@@3 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@0 () T@$Value)
(declare-fun inline$$TestModuleInvariants_S_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$trace_temp@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@2 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@2 () Int)
(declare-fun inline$$BorrowField$1$p@2@@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@2 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@2 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t1@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29367) (let ((inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon6_Then_correct true))
(let ((inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon5_Else_correct  (=> (not $abort_flag@2@@2) (and (=> (= (ControlFlow 0 20190) 20206) inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 20190) 20196) inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon5_Then_correct true))
(let ((inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@0  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$ret0@1@@0 $Error) (= $abort_flag@2@@2 true)) (and (=> (= (ControlFlow 0 20138) 20214) inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 20138) 20190) inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon14_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 20156) 20138)) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@0)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon14_Then_correct@@0  (=> (= (ControlFlow 0 20166) 20138) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@0)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct@@0  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 20150) 20166) inline$$TestModuleInvariants_new_S_$def$0$anon14_Then_correct@@0) (=> (= (ControlFlow 0 20150) 20156) inline$$TestModuleInvariants_new_S_$def$0$anon14_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon16_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 20130) 20138)) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@0)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon16_Then_correct@@0  (=> (= (ControlFlow 0 20146) 20138) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@0)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct@@0  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 20124) 20146) inline$$TestModuleInvariants_new_S_$def$0$anon16_Then_correct@@0) (=> (= (ControlFlow 0 20124) 20130) inline$$TestModuleInvariants_new_S_$def$0$anon16_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon12_correct@@0  (=> (= $abort_flag@2@@2 $abort_flag@1@@2) (and (=> (= (ControlFlow 0 20102) 20214) inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 20102) 20190) inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon18_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 20100) 20102)) inline$$TestModuleInvariants_new_S_$def$0$anon12_correct@@0)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon18_Then_correct@@0  (=> (= (ControlFlow 0 20110) 20102) inline$$TestModuleInvariants_new_S_$def$0$anon12_correct@@0)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon3_correct@@1  (=> (= $TestModuleInvariants_spec_count@0@@3 ($Integer (+ (|i#$Integer| $TestModuleInvariants_spec_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 20064) 20110) inline$$TestModuleInvariants_new_S_$def$0$anon18_Then_correct@@0) (=> (= (ControlFlow 0 20064) 20100) inline$$TestModuleInvariants_new_S_$def$0$anon18_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 20078) 20064)) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@1)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 20084) 20064) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@1)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 20072) 20084) inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 20072) 20078) inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct@@1)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct@@1  (=> (and (>= 0 0) (= (ControlFlow 0 20048) 20064)) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@1)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon0_correct@@1  (=> (and ((_ is $Boolean) inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@0) (= inline$$TestModuleInvariants_S_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@0) 1)))) (and (=> (= (ControlFlow 0 20040) 20072) inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 20040) 20048) inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct@@0  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@0 ($Boolean false)) (= (ControlFlow 0 20090) 20040)) inline$$TestModuleInvariants_S_pack$0$anon0_correct@@1)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@2  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2)) (= (ControlFlow 0 19824) 20090)) inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct@@0)))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@2  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2) (= inline$$WritebackToGlobal$0$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@2)) (= inline$$WritebackToGlobal$0$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)))) (and (= |inline$$WritebackToGlobal$0$m'@1@@2| ($Memory (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2 inline$$WritebackToGlobal$0$v@1@@2))) (= (ControlFlow 0 19878) 20090))) inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct@@0))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$0$l@1@@2 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (and (=> (= (ControlFlow 0 19814) 19878) inline$$WritebackToGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 19814) 19824) inline$$WritebackToGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowGlobal$0$dst@2@@2) (= (ControlFlow 0 19636) 19814)) inline$$WritebackToGlobal$0$anon0_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|) (= (ControlFlow 0 19692) 19814))) inline$$WritebackToGlobal$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) (and (=> (= (ControlFlow 0 19600) 19692) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 19600) 19636) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon17_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 19463) 19600)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon17_Then_correct@@0  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$trace_temp@1@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 20120) 19600)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@2) (|p#$Mutation| inline$$BorrowField$1$dst@1@@2) inline$$AddU64$0$dst@2@@1)) (and (=> (= (ControlFlow 0 19449) 20120) inline$$TestModuleInvariants_new_S_$def$0$anon17_Then_correct@@0) (=> (= (ControlFlow 0 19449) 19463) inline$$TestModuleInvariants_new_S_$def$0$anon17_Else_correct@@0)))))
(let ((inline$$BorrowField$1$anon0_correct@@2  (=> (= inline$$BorrowField$1$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@2 (|size#$Path| inline$$BorrowField$1$p@1@@2)) (= inline$$BorrowField$1$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@2) inline$$BorrowField$1$size@1@@2 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$1$size@1@@2 1)))) (and (= inline$$BorrowField$1$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$1$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 19390) 19449))) inline$$WriteRef$0$anon0_correct@@2))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct@@0  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 19396) 19390)) inline$$BorrowField$1$anon0_correct@@2)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@1@@2 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 19260) 20124) inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct@@0) (=> (= (ControlFlow 0 19260) 19396) inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct@@0)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@0)) $MAX_U64) (= (ControlFlow 0 19258) 19260)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@0))) (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@0))))) (and (= $abort_flag@1@@2 $abort_flag@0@@2) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 19202) 20124) inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct@@0) (=> (= (ControlFlow 0 19202) 19396) inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct@@0)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 19172) (- 0 29937)) true) (and (=> (= (ControlFlow 0 19172) 19258) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 19172) 19202) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Else$1_correct@@0  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@0 ($Integer 1)) (= (ControlFlow 0 19266) 19172)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 19061) 19266)) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else$1_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 19023) 19061))) inline$$ReadRef$0$anon0_correct@@2))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct@@0  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 19075) 19023)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@2 true) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 18857) 20150) inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct@@0) (=> (= (ControlFlow 0 18857) 19075) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2)) (= (ControlFlow 0 18855) 18857)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@2  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2) (= inline$$BorrowGlobal$0$dst@1@@2 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2)))) (and (= $abort_flag@0@@2 false) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 18803) 20150) inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct@@0) (=> (= (ControlFlow 0 18803) 19075) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@2  (=> (= inline$$BorrowGlobal$0$a@1@@2 (|a#$Address| inline$$TestModuleInvariants_new_S_$def$0$$t1@1@@0)) (and (=> (= (ControlFlow 0 18773) 18855) inline$$BorrowGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 18773) 18803) inline$$BorrowGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 18767) (- 0 29735)) true) (=> (= (ControlFlow 0 18767) 18773) inline$$BorrowGlobal$0$anon0_correct@@2))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon0_correct@@0  (=> (not false) (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t1@1@@0 ($Address 0)) (= (ControlFlow 0 18863) 18767)) inline$$BorrowGlobal$0$Entry_correct@@2))))
(let ((inline$$TestModuleInvariants_new_S_$direct_intra$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 18373) (- 0 29636)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestModuleInvariants_SCounter_n) $TestModuleInvariants_spec_count))) (=> (= (ControlFlow 0 18373) 18863) inline$$TestModuleInvariants_new_S_$def$0$anon0_correct@@0)))))
(let ((inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 20180) 18373)) inline$$TestModuleInvariants_new_S_$direct_intra$0$Entry_correct@@0)))
(let ((anon0$1_correct@@3  (=> (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestModuleInvariants_SCounter_n)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestModuleInvariants_SCounter_n)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestModuleInvariants_SCounter_n)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (= (ControlFlow 0 20220) 20180)) inline$$TestModuleInvariants_private_calls_public_incorrect_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Integer) $TestModuleInvariants_spec_count) (>= (|i#$Integer| $TestModuleInvariants_spec_count) 0)) (<= (|i#$Integer| $TestModuleInvariants_spec_count) $MAX_U64)) (= (ControlFlow 0 29367) 20220)) anon0$1_correct@@3)))
anon0_correct@@3)))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun $TestModuleInvariants_SCounter_$memory@0@@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_delete_S_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_delete_S_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun inline$$TestModuleInvariants_delete_S_$def$0$$t4@1 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestModuleInvariants_S_unpack$0$dummy_field@1@@1 () T@$Value)
(declare-fun $TestModuleInvariants_spec_count@1@@0 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$ret0@1@@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun inline$$TestModuleInvariants_S_pack$0$$struct@1@@2 () T@$Value)
(declare-fun $TestModuleInvariants_spec_count@0@@4 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@1 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@3 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@3 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@3 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@3| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$trace_temp@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@3 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@3 () Int)
(declare-fun inline$$BorrowField$1$p@2@@3 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@3 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@3 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$TestModuleInvariants_new_S_$def$0$$t1@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30545) (let ((inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon6_Then_correct true))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$Abort_correct  (=> (= $abort_flag@5 true) (and (=> (= (ControlFlow 0 24221) 24279) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 24221) 24275) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 24239) 24221)) inline$$TestModuleInvariants_delete_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 24249) 24221) inline$$TestModuleInvariants_delete_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon14_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 24233) 24249) inline$$TestModuleInvariants_delete_S_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 24233) 24239) inline$$TestModuleInvariants_delete_S_$def$0$anon15_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 24215) 24221)) inline$$TestModuleInvariants_delete_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 24229) 24221) inline$$TestModuleInvariants_delete_S_$def$0$Abort_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon16_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 24209) 24229) inline$$TestModuleInvariants_delete_S_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 24209) 24215) inline$$TestModuleInvariants_delete_S_$def$0$anon17_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon12$2_correct  (=> (= $abort_flag@5 $abort_flag@4) (and (=> (= (ControlFlow 0 24195) 24279) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 24195) 24275) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (= (ControlFlow 0 24133) 24195)) inline$$TestModuleInvariants_delete_S_$def$0$anon12$2_correct)))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory@0@@1) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $TestModuleInvariants_SCounter_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory@0@@1) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1))) (= (ControlFlow 0 24187) 24195))) inline$$TestModuleInvariants_delete_S_$def$0$anon12$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 24123) 24187) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 24123) 24133) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 23945) 24123)) inline$$WritebackToGlobal$1$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 24001) 24123))) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 23909) 24001) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 23909) 23945) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 23772) 23909)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon18_Then_correct  (=> (and (= inline$$TestModuleInvariants_delete_S_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 24205) 23909)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) inline$$Sub$0$dst@2@@0)) (and (=> (= (ControlFlow 0 23758) 24205) inline$$TestModuleInvariants_delete_S_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 23758) 23772) inline$$TestModuleInvariants_delete_S_$def$0$anon18_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 23699) 23758))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 23705) 23699)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@4 true) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@0@@0)) (and (=> (= (ControlFlow 0 23569) 24209) inline$$TestModuleInvariants_delete_S_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 23569) 23705) inline$$TestModuleInvariants_delete_S_$def$0$anon16_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestModuleInvariants_delete_S_$def$0$$t6@1)) (= (ControlFlow 0 23567) 23569)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (and (and (<= (|i#$Integer| inline$$TestModuleInvariants_delete_S_$def$0$$t6@1) (|i#$Integer| inline$$ReadRef$1$v@1)) (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestModuleInvariants_delete_S_$def$0$$t6@1))))) (and (= $abort_flag@4 $abort_flag@3) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@1@@0))) (and (=> (= (ControlFlow 0 23515) 24209) inline$$TestModuleInvariants_delete_S_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 23515) 23705) inline$$TestModuleInvariants_delete_S_$def$0$anon16_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 23489) (- 0 32204)) true) (and (=> (= (ControlFlow 0 23489) 23567) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 23489) 23515) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon14_Else$1_correct  (=> (and (= inline$$TestModuleInvariants_delete_S_$def$0$$t6@1 ($Integer 1)) (= (ControlFlow 0 23575) 23489)) inline$$Sub$0$Entry_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 23386) 23575)) inline$$TestModuleInvariants_delete_S_$def$0$anon14_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 23348) 23386))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon14_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 23400) 23348)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (and (= $abort_flag@3 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 23182) 24233) inline$$TestModuleInvariants_delete_S_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 23182) 23400) inline$$TestModuleInvariants_delete_S_$def$0$anon14_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory@0@@1) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 23180) 23182)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory@0@@1) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory@0@@1) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)))) (and (= $abort_flag@3 $abort_flag@2@@3) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 23128) 24233) inline$$TestModuleInvariants_delete_S_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 23128) 23400) inline$$TestModuleInvariants_delete_S_$def$0$anon14_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$TestModuleInvariants_delete_S_$def$0$$t4@1)) (and (=> (= (ControlFlow 0 23098) 23180) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 23098) 23128) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 23092) (- 0 32000)) true) (=> (= (ControlFlow 0 23092) 23098) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon2$2_correct  (=> (and (= inline$$TestModuleInvariants_delete_S_$def$0$$t4@1 ($Address 0)) (= (ControlFlow 0 23188) 23092)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$TestModuleInvariants_S_unpack$0$anon0_correct@@1  (=> ((_ is $Vector) inline$$TestModuleInvariants_new_S_$def$0$$ret0@2) (=> (and (and (= inline$$TestModuleInvariants_S_unpack$0$dummy_field@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestModuleInvariants_new_S_$def$0$$ret0@2)) $TestModuleInvariants_S_dummy_field)) ((_ is $Boolean) inline$$TestModuleInvariants_S_unpack$0$dummy_field@1@@1)) (and (= $TestModuleInvariants_spec_count@1@@0 ($Integer (- (|i#$Integer| $TestModuleInvariants_spec_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 22981) 23188))) inline$$TestModuleInvariants_delete_S_$def$0$anon2$2_correct))))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 22857) 22981)) inline$$TestModuleInvariants_S_unpack$0$anon0_correct@@1)))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon13_Then_correct  (=> (= (ControlFlow 0 24257) 22981) inline$$TestModuleInvariants_S_unpack$0$anon0_correct@@1)))
(let ((inline$$TestModuleInvariants_delete_S_$def$0$anon0_correct  (=> (not $abort_flag@2@@3) (and (=> (= (ControlFlow 0 22851) 24257) inline$$TestModuleInvariants_delete_S_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 22851) 22857) inline$$TestModuleInvariants_delete_S_$def$0$anon13_Else_correct)))))
(let ((inline$$TestModuleInvariants_delete_S_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$TestModuleInvariants_new_S_$def$0$$ret0@2) (let ((va@@14 (|v#$Vector| inline$$TestModuleInvariants_new_S_$def$0$$ret0@2)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestModuleInvariants_new_S_$def$0$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestModuleInvariants_new_S_$def$0$$ret0@2)) $TestModuleInvariants_S_dummy_field))) true) (= (ControlFlow 0 24261) 22851)) inline$$TestModuleInvariants_delete_S_$def$0$anon0_correct)))
(let ((inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon5_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 24267) 24261)) inline$$TestModuleInvariants_delete_S_$direct_inter$0$anon0_correct)))
(let ((inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon5_Then_correct true))
(let ((inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@1  (=> (and (and (= inline$$TestModuleInvariants_new_S_$def$0$$ret0@1@@1 $Error) (= $TestModuleInvariants_SCounter_$memory@0@@1 $TestModuleInvariants_SCounter_$memory)) (and (= inline$$TestModuleInvariants_new_S_$def$0$$ret0@2 inline$$TestModuleInvariants_new_S_$def$0$$ret0@1@@1) (= $abort_flag@2@@3 true))) (and (=> (= (ControlFlow 0 22474) 24287) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 22474) 24267) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon14_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 22492) 22474)) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@1)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon14_Then_correct@@1  (=> (= (ControlFlow 0 22502) 22474) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@1)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct@@1  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 22486) 22502) inline$$TestModuleInvariants_new_S_$def$0$anon14_Then_correct@@1) (=> (= (ControlFlow 0 22486) 22492) inline$$TestModuleInvariants_new_S_$def$0$anon14_Else_correct@@1)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon16_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 22466) 22474)) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@1)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon16_Then_correct@@1  (=> (= (ControlFlow 0 22482) 22474) inline$$TestModuleInvariants_new_S_$def$0$Abort_correct@@1)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct@@1  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 22460) 22482) inline$$TestModuleInvariants_new_S_$def$0$anon16_Then_correct@@1) (=> (= (ControlFlow 0 22460) 22466) inline$$TestModuleInvariants_new_S_$def$0$anon16_Else_correct@@1)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon12_correct@@1  (=> (= $TestModuleInvariants_SCounter_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@1|) (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$ret0@2 inline$$TestModuleInvariants_S_pack$0$$struct@1@@2) (= $abort_flag@2@@3 $abort_flag@1@@3)) (and (=> (= (ControlFlow 0 22438) 24287) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 22438) 24267) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon5_Else_correct))))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon18_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 22436) 22438)) inline$$TestModuleInvariants_new_S_$def$0$anon12_correct@@1)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon18_Then_correct@@1  (=> (= (ControlFlow 0 22446) 22438) inline$$TestModuleInvariants_new_S_$def$0$anon12_correct@@1)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon3_correct@@2  (=> (= $TestModuleInvariants_spec_count@0@@4 ($Integer (+ (|i#$Integer| $TestModuleInvariants_spec_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 22400) 22446) inline$$TestModuleInvariants_new_S_$def$0$anon18_Then_correct@@1) (=> (= (ControlFlow 0 22400) 22436) inline$$TestModuleInvariants_new_S_$def$0$anon18_Else_correct@@1)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 22414) 22400)) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@2)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct@@2  (=> (= (ControlFlow 0 22420) 22400) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@2)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct@@2  (=> (> 0 0) (and (=> (= (ControlFlow 0 22408) 22420) inline$$TestModuleInvariants_S_pack$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 22408) 22414) inline$$TestModuleInvariants_S_pack$0$anon5_Else_correct@@2)))))
(let ((inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct@@2  (=> (and (>= 0 0) (= (ControlFlow 0 22384) 22400)) inline$$TestModuleInvariants_S_pack$0$anon3_correct@@2)))
(let ((inline$$TestModuleInvariants_S_pack$0$anon0_correct@@2  (=> (and ((_ is $Boolean) inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@1) (= inline$$TestModuleInvariants_S_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@1) 1)))) (and (=> (= (ControlFlow 0 22376) 22408) inline$$TestModuleInvariants_S_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 22376) 22384) inline$$TestModuleInvariants_S_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct@@1  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t6@1@@1 ($Boolean false)) (= (ControlFlow 0 22426) 22376)) inline$$TestModuleInvariants_S_pack$0$anon0_correct@@2)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@3  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@3)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $TestModuleInvariants_SCounter_$memory) (= (ControlFlow 0 22160) 22426)) inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct@@1))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@3  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@3) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@3 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@3)) (= inline$$WritebackToGlobal$0$a@1@@3 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@3))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@3 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@3 inline$$WritebackToGlobal$0$a@1@@3) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))) (= |inline$$WritebackToGlobal$0$m'@1@@3| ($Memory (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) inline$$WritebackToGlobal$0$ta@1@@3 inline$$WritebackToGlobal$0$a@1@@3 inline$$WritebackToGlobal$0$v@1@@3)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@3|) (= (ControlFlow 0 22214) 22426))) inline$$TestModuleInvariants_new_S_$def$0$anon10$2_correct@@1)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@3  (=> (= inline$$WritebackToGlobal$0$l@1@@3 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (and (=> (= (ControlFlow 0 22150) 22214) inline$$WritebackToGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 22150) 22160) inline$$WritebackToGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| inline$$BorrowGlobal$0$dst@2@@3) (= (ControlFlow 0 21972) 22150)) inline$$WritebackToGlobal$0$anon0_correct@@3))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 22028) 22150))) inline$$WritebackToGlobal$0$anon0_correct@@3)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) (and (=> (= (ControlFlow 0 21936) 22028) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 21936) 21972) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon17_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 21799) 21936)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon17_Then_correct@@1  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$trace_temp@1@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (= (ControlFlow 0 22456) 21936)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@3) (|p#$Mutation| inline$$BorrowField$1$dst@1@@3) inline$$AddU64$0$dst@2@@2)) (and (=> (= (ControlFlow 0 21785) 22456) inline$$TestModuleInvariants_new_S_$def$0$anon17_Then_correct@@1) (=> (= (ControlFlow 0 21785) 21799) inline$$TestModuleInvariants_new_S_$def$0$anon17_Else_correct@@1)))))
(let ((inline$$BorrowField$1$anon0_correct@@3  (=> (= inline$$BorrowField$1$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (=> (and (and (= inline$$BorrowField$1$size@1@@3 (|size#$Path| inline$$BorrowField$1$p@1@@3)) (= inline$$BorrowField$1$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@3) inline$$BorrowField$1$size@1@@3 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$1$size@1@@3 1)))) (and (= inline$$BorrowField$1$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$BorrowField$1$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 21726) 21785))) inline$$WriteRef$0$anon0_correct@@3))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct@@1  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 21732) 21726)) inline$$BorrowField$1$anon0_correct@@3)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@1@@3 true) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@0@@2)) (and (=> (= (ControlFlow 0 21596) 22460) inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct@@1) (=> (= (ControlFlow 0 21596) 21732) inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct@@1)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@1)) $MAX_U64) (= (ControlFlow 0 21594) 21596)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@1))) (= inline$$AddU64$0$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@1))))) (and (= $abort_flag@1@@3 $abort_flag@0@@3) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@1@@2))) (and (=> (= (ControlFlow 0 21538) 22460) inline$$TestModuleInvariants_new_S_$def$0$anon15_Then_correct@@1) (=> (= (ControlFlow 0 21538) 21732) inline$$TestModuleInvariants_new_S_$def$0$anon15_Else_correct@@1)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 21508) (- 0 31253)) true) (and (=> (= (ControlFlow 0 21508) 21594) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 21508) 21538) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Else$1_correct@@1  (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t3@1@@1 ($Integer 1)) (= (ControlFlow 0 21602) 21508)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowField$0$dst@1@@3)) (= (ControlFlow 0 21397) 21602)) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else$1_correct@@1)))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $TestModuleInvariants_SCounter_n) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) $TestModuleInvariants_SCounter_n))) (= (ControlFlow 0 21359) 21397))) inline$$ReadRef$0$anon0_correct@@3))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct@@1  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 21411) 21359)) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@0@@3 true) (= inline$$BorrowGlobal$0$dst@2@@3 inline$$BorrowGlobal$0$dst@0@@3)) (and (=> (= (ControlFlow 0 21193) 22486) inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct@@1) (=> (= (ControlFlow 0 21193) 21411) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3)) (= (ControlFlow 0 21191) 21193)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@3)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@3  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3) (= inline$$BorrowGlobal$0$dst@1@@3 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3)))) (and (= $abort_flag@0@@3 false) (= inline$$BorrowGlobal$0$dst@2@@3 inline$$BorrowGlobal$0$dst@1@@3))) (and (=> (= (ControlFlow 0 21139) 22486) inline$$TestModuleInvariants_new_S_$def$0$anon13_Then_correct@@1) (=> (= (ControlFlow 0 21139) 21411) inline$$TestModuleInvariants_new_S_$def$0$anon13_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@3  (=> (= inline$$BorrowGlobal$0$a@1@@3 (|a#$Address| inline$$TestModuleInvariants_new_S_$def$0$$t1@1@@1)) (and (=> (= (ControlFlow 0 21109) 21191) inline$$BorrowGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 21109) 21139) inline$$BorrowGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 21103) (- 0 31051)) true) (=> (= (ControlFlow 0 21103) 21109) inline$$BorrowGlobal$0$anon0_correct@@3))))
(let ((inline$$TestModuleInvariants_new_S_$def$0$anon0_correct@@1  (=> (not false) (=> (and (= inline$$TestModuleInvariants_new_S_$def$0$$t1@1@@1 ($Address 0)) (= (ControlFlow 0 21199) 21103)) inline$$BorrowGlobal$0$Entry_correct@@3))))
(let ((inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 22516) 21199)) inline$$TestModuleInvariants_new_S_$def$0$anon0_correct@@1)))
(let ((anon0$1_correct@@4  (=> (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestModuleInvariants_SCounter_n)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestModuleInvariants_SCounter_n)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestModuleInvariants_SCounter_n)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestModuleInvariants_SCounter_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (= (ControlFlow 0 24291) 22516)) inline$$TestModuleInvariantsExternal_call_other_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and (and (and ((_ is $Integer) $TestModuleInvariants_spec_count) (>= (|i#$Integer| $TestModuleInvariants_spec_count) 0)) (<= (|i#$Integer| $TestModuleInvariants_spec_count) $MAX_U64)) (= (ControlFlow 0 30545) 24291)) anon0$1_correct@@4)))
anon0_correct@@4))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
