(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestMutRefsAccrossModule_T () T@$TypeName)
(declare-fun $TestMutRefsAccrossModule_TSum () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestMutRefsAccrossModule_T_value () Int)
(declare-fun $TestMutRefsAccrossModule_T_type_value () T@$TypeValue)
(declare-fun $TestMutRefsAccrossModule_TSum_sum () Int)
(declare-fun $TestMutRefsAccrossModule_TSum_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestMutRefsAccrossModule_T $TestMutRefsAccrossModule_TSum)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestMutRefsAccrossModule_T_value 0))
(assert (= $TestMutRefsAccrossModule_T_type_value ($StructType $TestMutRefsAccrossModule_T $EmptyTypeValueArray)))
(assert (= $TestMutRefsAccrossModule_TSum_sum 0))
(assert (= $TestMutRefsAccrossModule_TSum_type_value ($StructType $TestMutRefsAccrossModule_TSum $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory () T@$Memory)
(declare-fun $TestMutRefsAccrossModule_spec_sum () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun x@@8 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 58837) (let ((anon0$2_correct  (=> (= (ControlFlow 0 16465) (- 0 59041)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum)))))))
(let ((inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 16439) 16465)) anon0$2_correct)))
(let ((inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 16449) 16465) anon0$2_correct)))
(let ((inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon2$2_correct  (and (=> (= (ControlFlow 0 16433) (- 0 59005)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 16433) 16449) inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 16433) 16439) inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon6_Else_correct))))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 1) $EmptyPath x@@8)) (= (ControlFlow 0 16401) 16433)) inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon2$2_correct)))
(let ((inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 16317) 16401)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 16457) 16401) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16311) 16457) inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 16311) 16317) inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct  (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (= (ControlFlow 0 16463) 16311)) inline$$TestMutRefsAccrossModule_data_invariant_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) x@@8) (let ((va@@8 (|v#$Vector| x@@8)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@8)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@8)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@8)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@8)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@8)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 16158) 16463)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 58837) 16158)) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@0 () T@$Memory)
(declare-fun $TestMutRefsAccrossModule_spec_sum@3 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@2 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1 () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$Sub$1$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t8@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun x@@10 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$r@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_T_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 59082) (let ((anon0$2_correct@@0  (=> (= (ControlFlow 0 19602) (- 0 60898)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum@3)))))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$Abort_correct  (=> (= inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0 $TestMutRefsAccrossModule_TSum_$memory) (= $abort_flag@3 true)) (and (= $TestMutRefsAccrossModule_spec_sum@3 $TestMutRefsAccrossModule_spec_sum@2) (= (ControlFlow 0 19528) 19602))) anon0$2_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon5_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2 $TestMutRefsAccrossModule_spec_sum@0) (= (ControlFlow 0 19578) 19528)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 19576) 19578)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 19586) 19578) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 19570) 19586) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 19570) 19576) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon11_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2 $TestMutRefsAccrossModule_spec_sum@1) (= (ControlFlow 0 19548) 19528)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 19546) 19548)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 19556) 19548) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 19540) 19556) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 19540) 19546) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon15_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2 $TestMutRefsAccrossModule_spec_sum@1) (= (ControlFlow 0 19522) 19528)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 19520) 19522)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon15_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 19536) 19522) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon15_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon27_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 19514) 19536) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 19514) 19520) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon20_correct  (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0 |inline$$WritebackToGlobal$0$m'@2|) (= $abort_flag@3 $abort_flag@2)) (and (= $TestMutRefsAccrossModule_spec_sum@3 $TestMutRefsAccrossModule_spec_sum@1) (= (ControlFlow 0 19492) 19602))) anon0$2_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 19490) 19492)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon20_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 19500) 19492) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon20_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (= |inline$$WritebackToGlobal$0$m'@2| $TestMutRefsAccrossModule_TSum_$memory)) (and (=> (= (ControlFlow 0 19420) 19500) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 19420) 19490) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1))) (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|))) (and (=> (= (ControlFlow 0 19474) 19500) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 19474) 19490) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 19410) 19474) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 19410) 19420) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 19232) 19410)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 19288) 19410))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 19196) 19288) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 19196) 19232) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 19059) 19196)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon29_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 19510) 19196)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) inline$$Sub$1$dst@2)) (and (=> (= (ControlFlow 0 19045) 19510) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 19045) 19059) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 18986) 19045))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 18992) 18986)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$Sub$1$anon3_Then$1_correct  (=> (and (= $abort_flag@2 true) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@0)) (and (=> (= (ControlFlow 0 18856) 19514) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18856) 18992) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t10@1)) (= (ControlFlow 0 18854) 18856)) inline$$Sub$1$anon3_Then$1_correct)))
(let ((inline$$Sub$1$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t10@1) (|i#$Integer| inline$$ReadRef$1$v@1)) (= inline$$Sub$1$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t10@1))))) (and (= $abort_flag@2 $abort_flag@1) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@1))) (and (=> (= (ControlFlow 0 18802) 19514) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18802) 18992) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Sub$1$Entry_correct  (and (=> (= (ControlFlow 0 18776) (- 0 60376)) true) (and (=> (= (ControlFlow 0 18776) 18854) inline$$Sub$1$anon3_Then_correct) (=> (= (ControlFlow 0 18776) 18802) inline$$Sub$1$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Else$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 18862) 18776)) inline$$Sub$1$Entry_correct)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 18673) 18862)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 18635) 18673))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 18687) 18635)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 18469) 19540) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 18469) 18687) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 18467) 18469)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@1 $abort_flag@0) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 18415) 19540) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 18415) 18687) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t8@1)) (and (=> (= (ControlFlow 0 18385) 18467) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 18385) 18415) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 18379) (- 0 60172)) true) (=> (= (ControlFlow 0 18379) 18385) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon8$3_correct  (=> (and (= inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t8@1 ($Address 0)) (= (ControlFlow 0 18475) 18379)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2))) (= (ControlFlow 0 18242) 18475)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon8$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 x@@10 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= (ControlFlow 0 18268) 18475)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon8$3_correct))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 18145) (- 0 60067)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@1 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@0) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 18145) 18268) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 18145) 18242) inline$$WritebackToValue$0$anon3_Else_correct)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 18107) 18145)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1@@0) (= (ControlFlow 0 17983) 18107)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 18039) 18107))) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) (and (=> (= (ControlFlow 0 17947) 18039) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 17947) 17983) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 17810) 17947)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon24_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$r@0)) (= (ControlFlow 0 19566) 17947)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$Sub$0$dst@2)) (and (=> (= (ControlFlow 0 17796) 19566) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17796) 17810) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 17737) 17796))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 17743) 17737)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 17607) 19570) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17607) 17743) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t5@1)) (= (ControlFlow 0 17605) 17607)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t5@1) (|i#$Integer| inline$$ReadRef$0$v@1)) (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t5@1))))) (and (= $abort_flag@0 false) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 17553) 19570) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17553) 17743) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 17527) (- 0 59749)) true) (and (=> (= (ControlFlow 0 17527) 17605) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 17527) 17553) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon2$4_correct  (=> (and (= inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$$t5@1 ($Integer 1)) (= (ControlFlow 0 17613) 17527)) inline$$Sub$0$Entry_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 17424) 17613)) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon2$4_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 17386) 17424))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@0 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 17228) 17386)) inline$$BorrowField$0$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 17206) 17228)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 2) $EmptyPath x@@10)) (= (ControlFlow 0 17154) 17206)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 17070) 17154)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 19594) 17154) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17064) 19594) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17064) 17070) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr))) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr))) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr))) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (= (ControlFlow 0 19600) 17064))) inline$$TestMutRefsAccrossModule_decrement_invalid_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) x@@10) (let ((va@@11 (|v#$Vector| x@@10)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@10)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@10)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@10)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@10)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@10)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 16555) 19600)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 59082) 16555)) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@0@@0 () T@$Memory)
(declare-fun $TestMutRefsAccrossModule_spec_sum@2@@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1@@0 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0@@0 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_delete_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_unpack$0$value@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun x@@14 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_delete_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 60928) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 21875) (- 0 62012)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum@2@@0)))))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$Abort_correct  (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@0 $TestMutRefsAccrossModule_TSum_$memory) (= $abort_flag@2@@0 true)) (and (= $TestMutRefsAccrossModule_spec_sum@2@@0 $TestMutRefsAccrossModule_spec_sum@1@@0) (= (ControlFlow 0 21825) 21875))) anon0$2_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon5_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@1@@0 $TestMutRefsAccrossModule_spec_sum) (= (ControlFlow 0 21853) 21825)) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 21851) 21853)) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 21861) 21853) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 21845) 21861) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 21845) 21851) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon11_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@1@@0 $TestMutRefsAccrossModule_spec_sum@0@@0) (= (ControlFlow 0 21821) 21825)) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 21819) 21821)) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 21833) 21821) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon19_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 21813) 21833) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 21813) 21819) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon14$2_correct  (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (= $TestMutRefsAccrossModule_spec_sum@2@@0 $TestMutRefsAccrossModule_spec_sum@0@@0) (= (ControlFlow 0 21799) 21875))) anon0$2_correct@@1)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $TestMutRefsAccrossModule_TSum_$memory) (= (ControlFlow 0 21737) 21799)) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon14$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 21791) 21799))) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon14$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 21727) 21791) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 21727) 21737) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 21549) 21727)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 21605) 21727))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 21513) 21605) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 21513) 21549) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 21376) 21513)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon21_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_delete_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 21809) 21513)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) inline$$Sub$0$dst@2@@0)) (and (=> (= (ControlFlow 0 21362) 21809) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 21362) 21376) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 21303) 21362))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 21309) 21303)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@0 true) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@0@@0)) (and (=> (= (ControlFlow 0 21173) 21813) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 21173) 21309) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1)) (= (ControlFlow 0 21171) 21173)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1) (|i#$Integer| inline$$ReadRef$0$v@1@@0)) (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1))))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@1@@0))) (and (=> (= (ControlFlow 0 21119) 21813) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 21119) 21309) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 21093) (- 0 61528)) true) (and (=> (= (ControlFlow 0 21093) 21171) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 21093) 21119) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 20994) 21093)) inline$$Sub$0$Entry_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 20956) 20994))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 20802) 20956)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 21841) 20956) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_T_unpack$0$anon0_correct  (=> (and ((_ is $Vector) x@@14) (= inline$$TestMutRefsAccrossModule_T_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@14)) $TestMutRefsAccrossModule_T_value))) (=> (and (and (and ((_ is $Integer) inline$$TestMutRefsAccrossModule_T_unpack$0$value@1) (>= (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1) $MAX_U64)) (= $TestMutRefsAccrossModule_spec_sum@0@@0 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@14)) $TestMutRefsAccrossModule_T_value)))))) (and (=> (= (ControlFlow 0 20788) 21841) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 20788) 20802) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 20794) 20788)) inline$$TestMutRefsAccrossModule_T_unpack$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@0 true) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 20683) 21845) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 20683) 20794) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 20681) 20683)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)))) (and (= $abort_flag@0@@0 false) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 20629) 21845) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 20629) 20794) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| inline$$TestMutRefsAccrossModule_delete_$def_verify$0$$t4@1)) (and (=> (= (ControlFlow 0 20599) 20681) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 20599) 20629) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 20593) (- 0 61277)) true) (=> (= (ControlFlow 0 20593) 20599) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_delete_$def_verify$0$$t4@1 ($Address 0)) (= (ControlFlow 0 20689) 20593)) inline$$BorrowGlobal$0$Entry_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 20454) 20689)) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 21869) 20689) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20448) 21869) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 20448) 20454) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (= (ControlFlow 0 21873) 20448)) inline$$TestMutRefsAccrossModule_delete_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and (and (and (and (and ((_ is $Vector) x@@14) (let ((va@@13 (|v#$Vector| x@@14)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@14)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@14)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@14)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@14)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@14)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 20107) 21873)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 60928) 20107)) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@0@@1 () T@$Memory)
(declare-fun $TestMutRefsAccrossModule_spec_sum@3@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@2@@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0@@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1@@1 () T@$Value)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$1$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@0 () Int)
(declare-fun inline$$BorrowField$3$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$1$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t8@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun x@@17 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def_verify$0$r@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 62043) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 25263) (- 0 63875)) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum@3@@0)))))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$Abort_correct  (=> (= inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@1 $TestMutRefsAccrossModule_TSum_$memory) (= $abort_flag@3@@0 true)) (and (= $TestMutRefsAccrossModule_spec_sum@3@@0 $TestMutRefsAccrossModule_spec_sum@2@@1) (= (ControlFlow 0 25189) 25263))) anon0$2_correct@@2))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon5_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@1 $TestMutRefsAccrossModule_spec_sum@0@@1) (= (ControlFlow 0 25239) 25189)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 25237) 25239)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 25247) 25239) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 25231) 25247) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 25231) 25237) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon11_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@1 $TestMutRefsAccrossModule_spec_sum@1@@1) (= (ControlFlow 0 25209) 25189)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 25207) 25209)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 25217) 25209) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 25201) 25217) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 25201) 25207) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon15_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@1 $TestMutRefsAccrossModule_spec_sum@1@@1) (= (ControlFlow 0 25183) 25189)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 25181) 25183)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon15_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 25197) 25183) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon15_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon27_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 25175) 25197) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 25175) 25181) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon20_correct  (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@1|) (= $abort_flag@3@@0 $abort_flag@2@@1)) (and (= $TestMutRefsAccrossModule_spec_sum@3@@0 $TestMutRefsAccrossModule_spec_sum@1@@1) (= (ControlFlow 0 25153) 25263))) anon0$2_correct@@2)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 25151) 25153)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon20_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 25161) 25153) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon20_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (= |inline$$WritebackToGlobal$0$m'@2@@1| $TestMutRefsAccrossModule_TSum_$memory)) (and (=> (= (ControlFlow 0 25081) 25161) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 25081) 25151) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)))) (and (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1))) (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|))) (and (=> (= (ControlFlow 0 25135) 25161) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 25135) 25151) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (and (=> (= (ControlFlow 0 25071) 25135) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 25071) 25081) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 24893) 25071)) inline$$WritebackToGlobal$0$anon0_correct@@1))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 24949) 25071))) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 24857) 24949) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 24857) 24893) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 24720) 24857)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon29_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 25171) 24857)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@0) (|p#$Mutation| inline$$BorrowField$3$dst@1@@0) inline$$AddU64$1$dst@2)) (and (=> (= (ControlFlow 0 24706) 25171) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 24706) 24720) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@0  (=> (= inline$$BorrowField$3$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$3$size@1@@0 (|size#$Path| inline$$BorrowField$3$p@1@@0)) (= inline$$BorrowField$3$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@0) inline$$BorrowField$3$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$3$size@1@@0 1)))) (and (= inline$$BorrowField$3$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$3$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 24647) 24706))) inline$$WriteRef$1$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 24653) 24647)) inline$$BorrowField$3$anon0_correct@@0)))
(let ((inline$$AddU64$1$anon3_Then$1_correct  (=> (and (= $abort_flag@2@@1 true) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@0)) (and (=> (= (ControlFlow 0 24517) 25175) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 24517) 24653) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t10@1)) $MAX_U64) (= (ControlFlow 0 24515) 24517)) inline$$AddU64$1$anon3_Then$1_correct)))
(let ((inline$$AddU64$1$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t10@1))) (= inline$$AddU64$1$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t10@1))))) (and (= $abort_flag@2@@1 $abort_flag@1@@1) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@1))) (and (=> (= (ControlFlow 0 24459) 25175) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 24459) 24653) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AddU64$1$Entry_correct  (and (=> (= (ControlFlow 0 24429) (- 0 63345)) true) (and (=> (= (ControlFlow 0 24429) 24515) inline$$AddU64$1$anon3_Then_correct) (=> (= (ControlFlow 0 24429) 24459) inline$$AddU64$1$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Else$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 24523) 24429)) inline$$AddU64$1$Entry_correct)))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$2$dst@1@@0)) (= (ControlFlow 0 24318) 24523)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 24280) 24318))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 24332) 24280)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@1@@1 true) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 24114) 25201) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 24114) 24332) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 24112) 24114)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1)))) (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 24060) 25201) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 24060) 24332) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t8@1)) (and (=> (= (ControlFlow 0 24030) 24112) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 24030) 24060) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 24024) (- 0 63141)) true) (=> (= (ControlFlow 0 24024) 24030) inline$$BorrowGlobal$0$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon8$3_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t8@1 ($Address 0)) (= (ControlFlow 0 24120) 24024)) inline$$BorrowGlobal$0$Entry_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 2))) (= (ControlFlow 0 23887) 24120)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon8$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 x@@17 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= (ControlFlow 0 23913) 24120)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon8$3_correct))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 23790) (- 0 63036)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@1@@1 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@0@@1) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@0)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 23790) 23913) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 23790) 23887) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 23752) 23790)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@1) (= (ControlFlow 0 23628) 23752)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 23684) 23752))) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 23592) 23684) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 23592) 23628) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 23455) 23592)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon24_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$r@0)) (= (ControlFlow 0 25227) 23592)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@1) (|p#$Mutation| inline$$BorrowField$1$dst@1@@1) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 23441) 25227) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 23441) 23455) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 23382) 23441))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 23388) 23382)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@1 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 23252) 25231) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 23252) 23388) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t5@1)) $MAX_U64) (= (ControlFlow 0 23250) 23252)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t5@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t5@1))))) (and (= $abort_flag@0@@1 false) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 23194) 25231) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 23194) 23388) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 23164) (- 0 62710)) true) (and (=> (= (ControlFlow 0 23164) 23250) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 23164) 23194) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon2$4_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def_verify$0$$t5@1 ($Integer 1)) (= (ControlFlow 0 23258) 23164)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 23053) 23258)) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon2$4_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 23015) 23053))) inline$$ReadRef$0$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@0  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@0@@1 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@0)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 22857) 23015)) inline$$BorrowField$0$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 22835) 22857)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 2) $EmptyPath x@@17)) (= (ControlFlow 0 22783) 22835)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 22699) 22783)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 25255) 22783) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22693) 25255) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 22693) 22699) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@3))
))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (= (ControlFlow 0 25261) 22693))) inline$$TestMutRefsAccrossModule_increment_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> (and (and (and (and (and ((_ is $Vector) x@@17) (let ((va@@16 (|v#$Vector| x@@17)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@17)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@17)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@17)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@17)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@17)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 22184) 25261)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 62043) 22184)) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $TestMutRefsAccrossModule_spec_sum@2@@2 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0@@2 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun x@@21 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@2 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@2 () Int)
(declare-fun inline$$BorrowField$1$p@2@@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 63906) (let ((anon0$2_correct@@3  (=> (= (ControlFlow 0 27320) (- 0 64840)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum@2@@2)))))))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon5_correct  (=> (and (and (= inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$$ret0@1 $Error) (= $TestMutRefsAccrossModule_spec_sum@2@@2 $TestMutRefsAccrossModule_spec_sum@0@@2)) (and (= $abort_flag@1@@2 true) (= (ControlFlow 0 27296) 27320))) anon0$2_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 27290) 27296)) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 27304) 27296) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 27284) 27304) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 27284) 27290) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon8_correct  (=> (= $TestMutRefsAccrossModule_spec_sum@2@@2 $TestMutRefsAccrossModule_spec_sum@1@@2) (=> (and (= $abort_flag@1@@2 $abort_flag@0@@2) (= (ControlFlow 0 27272) 27320)) anon0$2_correct@@3))))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 27270) 27272)) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon8_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 27280) 27272) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon8_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 1))) (and (=> (= (ControlFlow 0 27228) 27280) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 27228) 27270) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) 0 x@@21 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)))) (and (=> (= (ControlFlow 0 27254) 27280) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 27254) 27270) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@1  (and (=> (= (ControlFlow 0 27131) (- 0 64696)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@1@@2 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@0@@2) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@1)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 27131) 27254) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 27131) 27228) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (= (ControlFlow 0 27093) 27131)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowLoc$0$dst@1@@2) (= (ControlFlow 0 26969) 27093)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|) (= (ControlFlow 0 27025) 27093))) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) (and (=> (= (ControlFlow 0 26933) 27025) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 26933) 26969) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (and (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@2) (|p#$Mutation| inline$$BorrowField$1$dst@1@@2) inline$$AddU64$0$dst@2@@0)) (= (ControlFlow 0 26790) 26933)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$BorrowField$1$anon0_correct@@2  (=> (= inline$$BorrowField$1$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@2 (|size#$Path| inline$$BorrowField$1$p@1@@2)) (= inline$$BorrowField$1$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@2) inline$$BorrowField$1$size@1@@2 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$1$size@1@@2 1)))) (and (= inline$$BorrowField$1$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$1$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 26731) 26790))) inline$$WriteRef$0$anon0_correct@@2))))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon10_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 26737) 26731)) inline$$BorrowField$1$anon0_correct@@2)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@2 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 26601) 27284) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 26601) 26737) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$$t4@1)) $MAX_U64) (= (ControlFlow 0 26599) 26601)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$$t4@1))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$$t4@1))))) (and (= $abort_flag@0@@2 false) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 26543) 27284) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 26543) 26737) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 26513) (- 0 64388)) true) (and (=> (= (ControlFlow 0 26513) 26599) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 26513) 26543) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon2$4_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$$t4@1 ($Integer 1)) (= (ControlFlow 0 26607) 26513)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 26402) 26607)) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon2$4_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 26364) 26402))) inline$$ReadRef$0$anon0_correct@@2))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@1  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@0@@2 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@1)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 26206) 26364)) inline$$BorrowField$0$anon0_correct@@2))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (= (ControlFlow 0 26184) 26206)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$0$dst@1@@2 ($Mutation ($Local 1) $EmptyPath x@@21)) (= (ControlFlow 0 26132) 26184)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 26048) 26132)) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 27312) 26132) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 26042) 27312) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 26042) 26048) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon9_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (= (ControlFlow 0 27318) 26042)) inline$$TestMutRefsAccrossModule_increment_invalid_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@3  (=> (and (and (and (and (and ((_ is $Vector) x@@21) (let ((va@@18 (|v#$Vector| x@@21)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@21)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@21)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@21)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@21)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@21)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 25768) 27318)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 63906) 25768)) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@0@@2 () T@$Memory)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1@@3 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@2| () T@$Memory)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0@@3 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1 () T@$Value)
(declare-fun x@@24 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@3 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@3 () Int)
(declare-fun inline$$BorrowField$1$p@2@@3 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@2 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@2 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 64872) (let ((anon0$2_correct@@4  (=> (= (ControlFlow 0 29573) (- 0 66053)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum@1@@3)))))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$Abort_correct  (=> (= inline$$TestMutRefsAccrossModule_new_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@2 $TestMutRefsAccrossModule_TSum_$memory) (= $TestMutRefsAccrossModule_spec_sum@1@@3 $TestMutRefsAccrossModule_spec_sum)) (and (= $abort_flag@2@@2 true) (= (ControlFlow 0 29529) 29573))) anon0$2_correct@@4))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 29547) 29529)) inline$$TestMutRefsAccrossModule_new_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 29557) 29529) inline$$TestMutRefsAccrossModule_new_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 29541) 29557) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 29541) 29547) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 29521) 29529)) inline$$TestMutRefsAccrossModule_new_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 29537) 29529) inline$$TestMutRefsAccrossModule_new_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 29515) 29537) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 29515) 29521) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon14_correct  (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@2|) (= $TestMutRefsAccrossModule_spec_sum@1@@3 $TestMutRefsAccrossModule_spec_sum@0@@3)) (and (= $abort_flag@2@@2 $abort_flag@1@@3) (= (ControlFlow 0 29493) 29573))) anon0$2_correct@@4)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 29491) 29493)) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon14_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 29501) 29493) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon14_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 29455) (- 0 65931)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@0@@3 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 29455) 29501) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 29455) 29491) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon21_Else_correct)))))))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 29469) 29455)) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 29475) 29455) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 29463) 29475) inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 29463) 29469) inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 29417) 29455)) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) x@@24) (>= (|i#$Integer| x@@24) 0)) (<= (|i#$Integer| x@@24) $MAX_U64)) (= inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 x@@24) 1)))) (and (=> (= (ControlFlow 0 29409) 29463) inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 29409) 29417) inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@2  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@2| $TestMutRefsAccrossModule_TSum_$memory) (= (ControlFlow 0 29176) 29409)) inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@2  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@2)) (= inline$$WritebackToGlobal$0$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))) (= |inline$$WritebackToGlobal$0$m'@1@@2| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2 inline$$WritebackToGlobal$0$v@1@@2)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@2| |inline$$WritebackToGlobal$0$m'@1@@2|) (= (ControlFlow 0 29230) 29409))) inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$0$l@1@@2 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (and (=> (= (ControlFlow 0 29166) 29230) inline$$WritebackToGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 29166) 29176) inline$$WritebackToGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| inline$$BorrowGlobal$0$dst@2@@2) (= (ControlFlow 0 28988) 29166)) inline$$WritebackToGlobal$0$anon0_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 29044) 29166))) inline$$WritebackToGlobal$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) (and (=> (= (ControlFlow 0 28952) 29044) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 28952) 28988) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 28815) 28952)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon20_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_new_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 29511) 28952)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@3) (|p#$Mutation| inline$$BorrowField$1$dst@1@@3) inline$$AddU64$0$dst@2@@1)) (and (=> (= (ControlFlow 0 28801) 29511) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 28801) 28815) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@3  (=> (= inline$$BorrowField$1$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@3 (|size#$Path| inline$$BorrowField$1$p@1@@3)) (= inline$$BorrowField$1$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@3) inline$$BorrowField$1$size@1@@3 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$1$size@1@@3 1)))) (and (= inline$$BorrowField$1$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$1$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 28742) 28801))) inline$$WriteRef$0$anon0_correct@@3))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 28748) 28742)) inline$$BorrowField$1$anon0_correct@@3)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@1@@3 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 28612) 29515) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 28612) 28748) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| x@@24)) $MAX_U64) (= (ControlFlow 0 28610) 28612)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| x@@24))) (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| x@@24))))) (and (= $abort_flag@1@@3 $abort_flag@0@@3) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 28554) 29515) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 28554) 28748) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 28524) (- 0 65444)) true) (and (=> (= (ControlFlow 0 28524) 28610) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 28524) 28554) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowField$0$dst@1@@3)) (= (ControlFlow 0 28417) 28524)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 28379) 28417))) inline$$ReadRef$0$anon0_correct@@3))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 28431) 28379)) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@3 true) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 28213) 29541) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 28213) 28431) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2)) (= (ControlFlow 0 28211) 28213)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@2  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2) (= inline$$BorrowGlobal$0$dst@1@@2 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@2)))) (and (= $abort_flag@0@@3 false) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 28159) 29541) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 28159) 28431) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@2  (=> (= inline$$BorrowGlobal$0$a@1@@2 (|a#$Address| inline$$TestMutRefsAccrossModule_new_$def_verify$0$$t3@1)) (and (=> (= (ControlFlow 0 28129) 28211) inline$$BorrowGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 28129) 28159) inline$$BorrowGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 28123) (- 0 65252)) true) (=> (= (ControlFlow 0 28123) 28129) inline$$BorrowGlobal$0$anon0_correct@@2))))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_new_$def_verify$0$$t3@1 ($Address 0)) (= (ControlFlow 0 28219) 28123)) inline$$BorrowGlobal$0$Entry_correct@@2)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 27984) 28219)) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 29565) 28219) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 27978) 29565) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 27978) 27984) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (|b#$Boolean| ($Boolean (> (|i#$Integer| x@@24) (|i#$Integer| ($Integer 0)))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (= (ControlFlow 0 29571) 27978))) inline$$TestMutRefsAccrossModule_new_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and (and (and ((_ is $Integer) x@@24) (>= (|i#$Integer| x@@24) 0)) (<= (|i#$Integer| x@@24) $MAX_U64)) (= (ControlFlow 0 27603) 29571)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 64872) 27603)) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$BorrowLoc$0$dst@1@@3 () T@$Mutation)
(declare-fun x@@26 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 66084) (let ((inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon6_Then_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon2$2_correct  (and (=> (= (ControlFlow 0 30145) (- 0 66201)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 30145) 30161) inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 30145) 30151) inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon6_Else_correct))))))
(let ((inline$$BorrowLoc$0$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$0$dst@1@@3 ($Mutation ($Local 1) $EmptyPath x@@26)) (= (ControlFlow 0 30113) 30145)) inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon2$2_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 30029) 30113)) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 30169) 30113) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 30023) 30169) inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 30023) 30029) inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and (and (and ((_ is $Vector) x@@26) (let ((va@@20 (|v#$Vector| x@@26)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@26)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@26)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@26)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@26)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (= (ControlFlow 0 29892) 30023)) inline$$TestMutRefsAccrossModule_private_data_invariant_invalid_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 66084) 29892)) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1@@3 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@3 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@3 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@3| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@1 () Int)
(declare-fun inline$$BorrowField$3$p@2@@1 () T@$Path)
(declare-fun inline$$Sub$1$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@1 () Int)
(declare-fun inline$$BorrowField$2$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@3 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@3 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t8@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@4| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@2| () T@$Value)
(declare-fun x@@28 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@4 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@4 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@4| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$r@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@4 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@4 () Int)
(declare-fun inline$$BorrowField$1$p@2@@4 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@4 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@4 () Int)
(declare-fun inline$$BorrowField$0$p@2@@4 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 66243) (let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$Abort_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 33071) 33023)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 33081) 33023) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 33065) 33081) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 33065) 33071) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 33041) 33023)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 33051) 33023) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 33035) 33051) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 33035) 33041) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 33015) 33023)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 33031) 33023) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon27_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 33009) 33031) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 33009) 33015) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon30_Else_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon30_Then_correct true))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@3  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@3)) (and (=> (= (ControlFlow 0 32915) 32995) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 32915) 32985) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@3  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@3) (=> (and (and (= inline$$WritebackToGlobal$0$ta@1@@3 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@3)) (= inline$$WritebackToGlobal$0$a@1@@3 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@3))) (and (= inline$$WritebackToGlobal$0$v@1@@3 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@3 inline$$WritebackToGlobal$0$a@1@@3) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@3| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@3 inline$$WritebackToGlobal$0$a@1@@3 inline$$WritebackToGlobal$0$v@1@@3))))) (and (=> (= (ControlFlow 0 32969) 32995) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 32969) 32985) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@3  (=> (= inline$$WritebackToGlobal$0$l@1@@3 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (and (=> (= (ControlFlow 0 32905) 32969) inline$$WritebackToGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 32905) 32915) inline$$WritebackToGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@3) (= (ControlFlow 0 32727) 32905)) inline$$WritebackToGlobal$0$anon0_correct@@3))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|) (= (ControlFlow 0 32783) 32905))) inline$$WritebackToGlobal$0$anon0_correct@@3)))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) (and (=> (= (ControlFlow 0 32691) 32783) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 32691) 32727) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 32554) 32691)) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon29_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (= (ControlFlow 0 33005) 32691)) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@1) (|p#$Mutation| inline$$BorrowField$3$dst@1@@1) inline$$Sub$1$dst@2@@0)) (and (=> (= (ControlFlow 0 32540) 33005) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 32540) 32554) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@1  (=> (= inline$$BorrowField$3$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (=> (and (and (= inline$$BorrowField$3$size@1@@1 (|size#$Path| inline$$BorrowField$3$p@1@@1)) (= inline$$BorrowField$3$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@1) inline$$BorrowField$3$size@1@@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$3$size@1@@1 1)))) (and (= inline$$BorrowField$3$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$BorrowField$3$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 32481) 32540))) inline$$WriteRef$1$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 32487) 32481)) inline$$BorrowField$3$anon0_correct@@1)))
(let ((inline$$Sub$1$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@2@@3 true) (= inline$$Sub$1$dst@2@@0 inline$$Sub$1$dst@0@@0)) (and (=> (= (ControlFlow 0 32351) 33009) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 32351) 32487) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$ReadRef$1$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t10@1)) (= (ControlFlow 0 32349) 32351)) inline$$Sub$1$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$1$anon3_Else_correct@@0  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t10@1) (|i#$Integer| inline$$ReadRef$1$v@1@@1)) (= inline$$Sub$1$dst@1@@0 ($Integer (- (|i#$Integer| inline$$ReadRef$1$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t10@1))))) (and (= $abort_flag@2@@3 $abort_flag@1@@4) (= inline$$Sub$1$dst@2@@0 inline$$Sub$1$dst@1@@0))) (and (=> (= (ControlFlow 0 32297) 33009) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 32297) 32487) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Sub$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 32271) (- 0 67383)) true) (and (=> (= (ControlFlow 0 32271) 32349) inline$$Sub$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 32271) 32297) inline$$Sub$1$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Else$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 32357) 32271)) inline$$Sub$1$Entry_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@1@@1 (|v#$Mutation| inline$$BorrowField$2$dst@1@@1)) (= (ControlFlow 0 32168) 32357)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct@@1  (=> (= inline$$BorrowField$2$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (=> (and (and (= inline$$BorrowField$2$size@1@@1 (|size#$Path| inline$$BorrowField$2$p@1@@1)) (= inline$$BorrowField$2$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@1) inline$$BorrowField$2$size@1@@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$2$size@1@@1 1)))) (and (= inline$$BorrowField$2$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$BorrowField$2$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 32130) 32168))) inline$$ReadRef$1$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@4) (= (ControlFlow 0 32182) 32130)) inline$$BorrowField$2$anon0_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@1@@4 true) (= inline$$BorrowGlobal$0$dst@2@@3 inline$$BorrowGlobal$0$dst@0@@3)) (and (=> (= (ControlFlow 0 31964) 33035) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 31964) 32182) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3)) (= (ControlFlow 0 31962) 31964)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@3)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@3  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3) (= inline$$BorrowGlobal$0$dst@1@@3 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@3)))) (and (= $abort_flag@1@@4 $abort_flag@0@@4) (= inline$$BorrowGlobal$0$dst@2@@3 inline$$BorrowGlobal$0$dst@1@@3))) (and (=> (= (ControlFlow 0 31910) 33035) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 31910) 32182) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@3  (=> (= inline$$BorrowGlobal$0$a@1@@3 (|a#$Address| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t8@1)) (and (=> (= (ControlFlow 0 31880) 31962) inline$$BorrowGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 31880) 31910) inline$$BorrowGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 31874) (- 0 67179)) true) (=> (= (ControlFlow 0 31874) 31880) inline$$BorrowGlobal$0$anon0_correct@@3))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon8$2_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t8@1 ($Address 0)) (= (ControlFlow 0 31970) 31874)) inline$$BorrowGlobal$0$Entry_correct@@3)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@2  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|) ($Local 2))) (= (ControlFlow 0 31737) 31970)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon8$2_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@2  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|) 0 x@@28 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|))) (= (ControlFlow 0 31763) 31970)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon8$2_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@4  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@4 inline$$WritebackToReference$0$srcPath@1@@4))) (= |inline$$WritebackToReference$0$dst'@2@@4| inline$$BorrowLoc$0$dst@1@@4)) (and (=> (= (ControlFlow 0 31582) 31763) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 31582) 31737) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@4  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@4 inline$$WritebackToReference$0$srcPath@1@@4)) (and (= |inline$$WritebackToReference$0$dst'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$WritebackToReference$0$dstPath@1@@4 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@4 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@4|)))) (= |inline$$WritebackToReference$0$dst'@2@@4| |inline$$WritebackToReference$0$dst'@1@@4|))) (and (=> (= (ControlFlow 0 31638) 31763) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 31638) 31737) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@4  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@4 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (= inline$$WritebackToReference$0$dstPath@1@@4 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) (and (=> (= (ControlFlow 0 31546) 31638) inline$$WritebackToReference$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 31546) 31582) inline$$WritebackToReference$0$anon3_Else_correct@@4)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 31409) 31546)) inline$$WritebackToReference$0$anon0_correct@@4)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon24_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$r@0)) (= (ControlFlow 0 33061) 31546)) inline$$WritebackToReference$0$anon0_correct@@4)))
(let ((inline$$WriteRef$0$anon0_correct@@4  (=> (= |inline$$WriteRef$0$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@4) (|p#$Mutation| inline$$BorrowField$1$dst@1@@4) inline$$Sub$0$dst@2@@1)) (and (=> (= (ControlFlow 0 31395) 33061) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 31395) 31409) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@4  (=> (= inline$$BorrowField$1$p@1@@4 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (=> (and (and (= inline$$BorrowField$1$size@1@@4 (|size#$Path| inline$$BorrowField$1$p@1@@4)) (= inline$$BorrowField$1$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@4) inline$$BorrowField$1$size@1@@4 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$1$size@1@@4 1)))) (and (= inline$$BorrowField$1$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$BorrowField$1$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 31336) 31395))) inline$$WriteRef$0$anon0_correct@@4))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@0@@4) (= (ControlFlow 0 31342) 31336)) inline$$BorrowField$1$anon0_correct@@4)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@4 true) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@0@@1)) (and (=> (= (ControlFlow 0 31206) 33065) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 31206) 31342) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$ReadRef$0$v@1@@4) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t5@1)) (= (ControlFlow 0 31204) 31206)) inline$$Sub$0$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$0$anon3_Else_correct@@1  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t5@1) (|i#$Integer| inline$$ReadRef$0$v@1@@4)) (= inline$$Sub$0$dst@1@@1 ($Integer (- (|i#$Integer| inline$$ReadRef$0$v@1@@4) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t5@1))))) (and (= $abort_flag@0@@4 false) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@1@@1))) (and (=> (= (ControlFlow 0 31152) 33065) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 31152) 31342) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 31126) (- 0 66806)) true) (and (=> (= (ControlFlow 0 31126) 31204) inline$$Sub$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 31126) 31152) inline$$Sub$0$anon3_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon2$3_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$$t5@1 ($Integer 1)) (= (ControlFlow 0 31212) 31126)) inline$$Sub$0$Entry_correct@@1)))
(let ((inline$$ReadRef$0$anon0_correct@@4  (=> (and (= inline$$ReadRef$0$v@1@@4 (|v#$Mutation| inline$$BorrowField$0$dst@1@@4)) (= (ControlFlow 0 31023) 31212)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon2$3_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@4  (=> (= inline$$BorrowField$0$p@1@@4 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (=> (and (and (= inline$$BorrowField$0$size@1@@4 (|size#$Path| inline$$BorrowField$0$p@1@@4)) (= inline$$BorrowField$0$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@4) inline$$BorrowField$0$size@1@@4 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$0$size@1@@4 1)))) (and (= inline$$BorrowField$0$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$BorrowField$0$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 30985) 31023))) inline$$ReadRef$0$anon0_correct@@4))))
(let ((inline$$BorrowLoc$0$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$0$dst@1@@4 ($Mutation ($Local 2) $EmptyPath x@@28)) (= (ControlFlow 0 30825) 30985)) inline$$BorrowField$0$anon0_correct@@4)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 30741) 30825)) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 33089) 30825) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 30735) 33089) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 30735) 30741) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@21 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (=> (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@22 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (= (ControlFlow 0 33095) 30735)) inline$$TestMutRefsAccrossModule_private_decrement_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@6  (=> (and (and (and (and ((_ is $Vector) x@@28) (let ((va@@23 (|v#$Vector| x@@28)))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@28)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@28)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@28)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@28)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (= (ControlFlow 0 30263) 33095)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 66243) 30263)) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $TestMutRefsAccrossModule_spec_sum@3@@1 () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun r@@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@5 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@2@@3 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0@@4 () T@$Value)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1@@4 () T@$Value)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@4 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@4 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@4 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@4| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@4 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@2 () T@$Mutation)
(declare-fun inline$$AddU64$1$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@2 () Int)
(declare-fun inline$$BorrowField$3$p@2@@2 () T@$Path)
(declare-fun inline$$AddU64$1$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@2 () Int)
(declare-fun inline$$BorrowField$2$p@2@@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@4 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@4 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@4 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@5| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@5 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@3| () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@2 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@5 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@5 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@5| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$r@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@5 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@5 () Int)
(declare-fun inline$$BorrowField$1$p@2@@5 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@2 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@5 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@5 () Int)
(declare-fun inline$$BorrowField$0$p@2@@5 () T@$Path)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 67863) (let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon9_Then_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Else$2_correct  (and (=> (= (ControlFlow 0 37454) (- 0 70026)) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestMutRefsAccrossModule_spec_sum@3@@1 ($Integer 1))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestMutRefsAccrossModule_spec_sum@3@@1 ($Integer 1)))) (and (=> (= (ControlFlow 0 37454) 37470) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 37454) 37460) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon9_Else_correct))))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 2))) (= (ControlFlow 0 37406) 37454)) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Else$2_correct)))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1|) 0 r@@1 (|v#$Mutation| |inline$$WriteRef$2$to'@1|))) (= (ControlFlow 0 37432) 37454)) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Else$2_correct))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5) inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 37307) 37432) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 37307) 37406) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Else_correct  (=> (and (not $abort_flag@3@@1) (= (ControlFlow 0 37313) 37307)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Then_correct true))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct  (=> (and (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1 $Error) (= $abort_flag@3@@1 true)) (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2 inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1) (= $TestMutRefsAccrossModule_spec_sum@3@@1 $TestMutRefsAccrossModule_spec_sum@2@@3))) (and (=> (= (ControlFlow 0 37168) 37478) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 37168) 37313) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon5_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@3 $TestMutRefsAccrossModule_spec_sum@0@@4) (= (ControlFlow 0 37218) 37168)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 37216) 37218)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 37226) 37218) inline$$TestMutRefsAccrossModule_increment_$def$0$anon5_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 37210) 37226) inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 37210) 37216) inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon11_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@3 $TestMutRefsAccrossModule_spec_sum@1@@4) (= (ControlFlow 0 37188) 37168)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 37186) 37188)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 37196) 37188) inline$$TestMutRefsAccrossModule_increment_$def$0$anon11_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 37180) 37196) inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 37180) 37186) inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon15_correct  (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@3 $TestMutRefsAccrossModule_spec_sum@1@@4) (= (ControlFlow 0 37162) 37168)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 37160) 37162)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon15_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 37176) 37162) inline$$TestMutRefsAccrossModule_increment_$def$0$anon15_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 37154) 37176) inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 37154) 37160) inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct  (=> (= $abort_flag@3@@1 $abort_flag@2@@4) (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|) (= $TestMutRefsAccrossModule_spec_sum@3@@1 $TestMutRefsAccrossModule_spec_sum@1@@4)) (and (=> (= (ControlFlow 0 37132) 37478) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 37132) 37313) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon8_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 37130) 37132)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 37140) 37132) inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@4  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@4)) (and (=> (= (ControlFlow 0 37060) 37140) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 37060) 37130) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@4  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@4) (=> (and (and (= inline$$WritebackToGlobal$0$ta@1@@4 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@4)) (= inline$$WritebackToGlobal$0$a@1@@4 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@4))) (and (= inline$$WritebackToGlobal$0$v@1@@4 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@4 inline$$WritebackToGlobal$0$a@1@@4) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|))) (= |inline$$WritebackToGlobal$0$m'@1@@4| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@4 inline$$WritebackToGlobal$0$a@1@@4 inline$$WritebackToGlobal$0$v@1@@4))))) (and (=> (= (ControlFlow 0 37114) 37140) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 37114) 37130) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@4  (=> (= inline$$WritebackToGlobal$0$l@1@@4 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (and (=> (= (ControlFlow 0 37050) 37114) inline$$WritebackToGlobal$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 37050) 37060) inline$$WritebackToGlobal$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@2| inline$$BorrowGlobal$0$dst@2@@4) (= (ControlFlow 0 36872) 37050)) inline$$WritebackToGlobal$0$anon0_correct@@4))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2)) (= |inline$$WritebackToReference$1$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) inline$$WritebackToReference$1$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@2| |inline$$WritebackToReference$1$dst'@1@@2|) (= (ControlFlow 0 36928) 37050))) inline$$WritebackToGlobal$0$anon0_correct@@4)))
(let ((inline$$WritebackToReference$1$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= inline$$WritebackToReference$1$dstPath@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@4))) (and (=> (= (ControlFlow 0 36836) 36928) inline$$WritebackToReference$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 36836) 36872) inline$$WritebackToReference$1$anon3_Else_correct@@2)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 36699) 36836)) inline$$WritebackToReference$1$anon0_correct@@2)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@4)) (= (ControlFlow 0 37150) 36836)) inline$$WritebackToReference$1$anon0_correct@@2)))
(let ((inline$$WriteRef$1$anon0_correct@@2  (=> (= |inline$$WriteRef$1$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@2) (|p#$Mutation| inline$$BorrowField$3$dst@1@@2) inline$$AddU64$1$dst@2@@0)) (and (=> (= (ControlFlow 0 36685) 37150) inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 36685) 36699) inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@2  (=> (= inline$$BorrowField$3$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@4)) (=> (and (and (= inline$$BorrowField$3$size@1@@2 (|size#$Path| inline$$BorrowField$3$p@1@@2)) (= inline$$BorrowField$3$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@2) inline$$BorrowField$3$size@1@@2 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$3$size@1@@2 1)))) (and (= inline$$BorrowField$3$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) inline$$BorrowField$3$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@4))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 36626) 36685))) inline$$WriteRef$1$anon0_correct@@2))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct  (=> (and (not $abort_flag@2@@4) (= (ControlFlow 0 36632) 36626)) inline$$BorrowField$3$anon0_correct@@2)))
(let ((inline$$AddU64$1$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@2@@4 true) (= inline$$AddU64$1$dst@2@@0 inline$$AddU64$1$dst@0@@0)) (and (=> (= (ControlFlow 0 36496) 37154) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 36496) 36632) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$2$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1)) $MAX_U64) (= (ControlFlow 0 36494) 36496)) inline$$AddU64$1$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$1$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$2$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1))) (= inline$$AddU64$1$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$2$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1))))) (and (= $abort_flag@2@@4 $abort_flag@1@@5) (= inline$$AddU64$1$dst@2@@0 inline$$AddU64$1$dst@1@@0))) (and (=> (= (ControlFlow 0 36438) 37154) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 36438) 36632) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct)))))
(let ((inline$$AddU64$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 36408) (- 0 69417)) true) (and (=> (= (ControlFlow 0 36408) 36494) inline$$AddU64$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 36408) 36438) inline$$AddU64$1$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 36502) 36408)) inline$$AddU64$1$Entry_correct@@0)))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1@@2)) (= (ControlFlow 0 36297) 36502)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct@@2  (=> (= inline$$BorrowField$2$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@4)) (=> (and (and (= inline$$BorrowField$2$size@1@@2 (|size#$Path| inline$$BorrowField$2$p@1@@2)) (= inline$$BorrowField$2$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@2) inline$$BorrowField$2$size@1@@2 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$2$size@1@@2 1)))) (and (= inline$$BorrowField$2$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) inline$$BorrowField$2$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@4))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 36259) 36297))) inline$$ReadRef$2$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@5) (= (ControlFlow 0 36311) 36259)) inline$$BorrowField$2$anon0_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@4  (=> (and (= $abort_flag@1@@5 true) (= inline$$BorrowGlobal$0$dst@2@@4 inline$$BorrowGlobal$0$dst@0@@4)) (and (=> (= (ControlFlow 0 36093) 37180) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 36093) 36311) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@4  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@4)) (= (ControlFlow 0 36091) 36093)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@4)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@4  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@4) (= inline$$BorrowGlobal$0$dst@1@@4 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@4) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@4)))) (and (= $abort_flag@1@@5 $abort_flag@0@@5) (= inline$$BorrowGlobal$0$dst@2@@4 inline$$BorrowGlobal$0$dst@1@@4))) (and (=> (= (ControlFlow 0 36039) 37180) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 36039) 36311) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@4  (=> (= inline$$BorrowGlobal$0$a@1@@4 (|a#$Address| inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1)) (and (=> (= (ControlFlow 0 36009) 36091) inline$$BorrowGlobal$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 36009) 36039) inline$$BorrowGlobal$0$anon3_Else_correct@@4)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 36003) (- 0 69213)) true) (=> (= (ControlFlow 0 36003) 36009) inline$$BorrowGlobal$0$anon0_correct@@4))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1 ($Address 0)) (= (ControlFlow 0 36099) 36003)) inline$$BorrowGlobal$0$Entry_correct@@4)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$0$v@1@@5) (= (ControlFlow 0 35866) 36099)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|) 0 inline$$ReadRef$0$v@1@@5 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1@@3|) (= (ControlFlow 0 35892) 36099))) inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@2  (and (=> (= (ControlFlow 0 35769) (- 0 69100)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@2)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@2)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@1@@4 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@0@@4) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@2)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 35769) 35892) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 35769) 35866) inline$$WritebackToValue$0$anon3_Else_correct@@3)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|)) (= (ControlFlow 0 35731) 35769)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@5  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@5 inline$$WritebackToReference$0$srcPath@1@@5))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@5| inline$$BorrowLoc$1$dst@1) (= (ControlFlow 0 35607) 35731)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@5  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@5 inline$$WritebackToReference$0$srcPath@1@@5)) (= |inline$$WritebackToReference$0$dst'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$0$dstPath@1@@5 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@5 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@5| |inline$$WritebackToReference$0$dst'@1@@5|) (= (ControlFlow 0 35663) 35731))) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@2)))
(let ((inline$$WritebackToReference$0$anon0_correct@@5  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@5 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (= inline$$WritebackToReference$0$dstPath@1@@5 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 35571) 35663) inline$$WritebackToReference$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 35571) 35607) inline$$WritebackToReference$0$anon3_Else_correct@@5)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 35434) 35571)) inline$$WritebackToReference$0$anon0_correct@@5)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@1 (|v#$Mutation| inline$$TestMutRefsAccrossModule_increment_$def$0$r@0)) (= (ControlFlow 0 37206) 35571)) inline$$WritebackToReference$0$anon0_correct@@5)))
(let ((inline$$WriteRef$0$anon0_correct@@5  (=> (= |inline$$WriteRef$0$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@5) (|p#$Mutation| inline$$BorrowField$1$dst@1@@5) inline$$AddU64$0$dst@2@@2)) (and (=> (= (ControlFlow 0 35420) 37206) inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 35420) 35434) inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@5  (=> (= inline$$BorrowField$1$p@1@@5 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@5 (|size#$Path| inline$$BorrowField$1$p@1@@5)) (= inline$$BorrowField$1$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@5) inline$$BorrowField$1$size@1@@5 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$1$size@1@@5 1)))) (and (= inline$$BorrowField$1$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$1$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 35361) 35420))) inline$$WriteRef$0$anon0_correct@@5))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct  (=> (and (not $abort_flag@0@@5) (= (ControlFlow 0 35367) 35361)) inline$$BorrowField$1$anon0_correct@@5)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@5 true) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@0@@2)) (and (=> (= (ControlFlow 0 35231) 37210) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 35231) 35367) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1@@2) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1)) $MAX_U64) (= (ControlFlow 0 35229) 35231)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1@@2) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1))) (= inline$$AddU64$0$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1@@2) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1))))) (and (= $abort_flag@0@@5 false) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@1@@2))) (and (=> (= (ControlFlow 0 35173) 37210) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 35173) 35367) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 35143) (- 0 68774)) true) (and (=> (= (ControlFlow 0 35143) 35229) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 35143) 35173) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon2$4_correct  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1 ($Integer 1)) (= (ControlFlow 0 35237) 35143)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$ReadRef$1$anon0_correct@@2  (=> (and (= inline$$ReadRef$1$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@5)) (= (ControlFlow 0 35032) 35237)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon2$4_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@5  (=> (= inline$$BorrowField$0$p@1@@5 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@5 (|size#$Path| inline$$BorrowField$0$p@1@@5)) (= inline$$BorrowField$0$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@5) inline$$BorrowField$0$size@1@@5 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$0$size@1@@5 1)))) (and (= inline$$BorrowField$0$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$0$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 34994) 35032))) inline$$ReadRef$1$anon0_correct@@2))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@2  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@2)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@0@@4 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@2)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 34836) 34994)) inline$$BorrowField$0$anon0_correct@@5))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@2 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 34814) 34836)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@2)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 2) $EmptyPath inline$$ReadRef$0$v@1@@5)) (= (ControlFlow 0 34762) 34814)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@2)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 34678) 34762)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 37234) 34762) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 34672) 37234) inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 34672) 34678) inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@5) (let ((va@@24 (|v#$Vector| inline$$ReadRef$0$v@1@@5)))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 37240) 34672)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$Entry_correct  (and (=> (= (ControlFlow 0 34233) (- 0 68482)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (=> (= (ControlFlow 0 34233) 37240) inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$anon0_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon2$4_correct  (and (=> (= (ControlFlow 0 37248) (- 0 68477)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 37248) 34233) inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$Entry_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@5  (=> (and (= inline$$ReadRef$0$v@1@@5 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (= (ControlFlow 0 34123) 37248)) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon2$4_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon2$2_correct  (=> (and (and (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestMutRefsAccrossModule_spec_sum ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) $TestMutRefsAccrossModule_T_value))))))) (= (ControlFlow 0 34091) 34123))) inline$$ReadRef$0$anon0_correct@@5)))
(let ((inline$$BorrowLoc$0$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$0$dst@1@@5 ($Mutation ($Local 2) $EmptyPath r@@1)) (= (ControlFlow 0 33979) 34091)) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon2$2_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 33895) 33979)) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 37486) 33979) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 33889) 37486) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 33889) 33895) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (=> (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@9))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@9))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@9))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (= (ControlFlow 0 37492) 33889)) inline$$TestMutRefsAccrossModule_private_to_public_caller_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@7  (=> (and (and (and (and ((_ is $Vector) r@@1) (let ((va@@27 (|v#$Vector| r@@1)))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (= (ControlFlow 0 33572) 37492)) anon0$1_correct@@6)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 67863) 33572)) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun |inline$$WriteRef$6$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$3$vdst'@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'| () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$3$$after@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@7 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_flag@9 () Bool)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun inline$$WritebackToGlobal$2$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$5$dst'@2| () T@$Mutation)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$2$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$5$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$5$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$5$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$5$dst'@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$9$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$2$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$9$p@1 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1 () Int)
(declare-fun inline$$BorrowField$9$p@2 () T@$Path)
(declare-fun inline$$AddU64$2$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@0 () T@$Value)
(declare-fun inline$$AddU64$2$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$8$p@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1 () Int)
(declare-fun inline$$BorrowField$8$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$2$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$2$a@1 () Int)
(declare-fun inline$$BorrowGlobal$2$dst@1 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$4$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$2$$after@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@6 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@5 () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$4$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$4$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$4$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$4$dst'@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@1@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$r@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$7$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$1$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$7$p@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1 () Int)
(declare-fun inline$$BorrowField$7$p@2 () T@$Path)
(declare-fun inline$$AddU64$1$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@0 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@4 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@3@@2 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@6 () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@3 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@2@@4 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$ret0@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@0@@3 () T@$Memory)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@5 () Bool)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$Sub$1$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t8@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@3| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@4| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$r@0 () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1@@3 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@3 () Int)
(declare-fun inline$$BorrowField$3$p@2@@3 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@3 () Int)
(declare-fun inline$$BorrowField$2$p@2@@3 () T@$Path)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@3 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1@@5 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@3| () T@$Memory)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0@@5 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@5 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@5 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@5 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@5 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@6| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@5| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@5 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@6| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@6 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@6 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@6| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@6 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@3 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@6 () Int)
(declare-fun inline$$BorrowField$1$p@2@@6 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@3 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@6 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@6 () Int)
(declare-fun inline$$BorrowField$0$p@2@@6 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@5 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@5 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@5 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 70058) (let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$Abort_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon16_Then_correct  (=> (and $abort_flag@10 (= (ControlFlow 0 47810) 47816)) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon14_Then_correct  (=> (and $abort_flag@6 (= (ControlFlow 0 47830) 47816)) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Then_correct  (=> (and $abort_flag@2@@5 (= (ControlFlow 0 47834) 47816)) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon18_Else_correct true))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon18_Then_correct true))
(let ((inline$$WritebackToValue$3$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$6$to'@1|) ($Local 1))) (and (=> (= (ControlFlow 0 47710) 47796) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 47710) 47786) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct  (=> (and (= (|l#$Mutation| |inline$$WriteRef$6$to'@1|) ($Local 1)) (= |inline$$WritebackToValue$3$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$6$to'@1|) 0 |inline$$WritebackToValue$1$vdst'| (|v#$Mutation| |inline$$WriteRef$6$to'@1|)))) (and (=> (= (ControlFlow 0 47736) 47796) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 47736) 47786) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$3$anon0_correct  (and (=> (= (ControlFlow 0 47613) (- 0 75299)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$3$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$3$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@7 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$3$$after@0)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 47613) 47736) inline$$WritebackToValue$3$anon3_Then_correct) (=> (= (ControlFlow 0 47613) 47710) inline$$WritebackToValue$3$anon3_Else_correct)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$3$Entry_correct  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$3$$after@0 (|v#$Mutation| |inline$$WriteRef$6$to'@1|)) (= (ControlFlow 0 47575) 47613)) inline$$TestMutRefsAccrossModule_T_$pack_ref$3$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 47513) 47575)) inline$$TestMutRefsAccrossModule_T_$pack_ref$3$Entry_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon17_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 47806) 47575)) inline$$TestMutRefsAccrossModule_T_$pack_ref$3$Entry_correct)))
(let ((inline$$WriteRef$6$anon0_correct  (=> (= |inline$$WriteRef$6$to'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@0)) (and (=> (= (ControlFlow 0 47499) 47806) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 47499) 47513) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 47505) 47499)) inline$$WriteRef$6$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@0  (=> (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1@@0 $Error) (=> (and (= $abort_flag@10 true) (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@0 inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1@@0)) (and (=> (= (ControlFlow 0 47360) 47810) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 47360) 47505) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 47408) 47360)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Then_correct@@0  (=> (= (ControlFlow 0 47418) 47360) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct@@0  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 47402) 47418) inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Then_correct@@0) (=> (= (ControlFlow 0 47402) 47408) inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 47378) 47360)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Then_correct@@0  (=> (= (ControlFlow 0 47388) 47360) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct@@0  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 47372) 47388) inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Then_correct@@0) (=> (= (ControlFlow 0 47372) 47378) inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 47352) 47360)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Then_correct@@0  (=> (= (ControlFlow 0 47368) 47360) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct@@0  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 47346) 47368) inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Then_correct@@0) (=> (= (ControlFlow 0 47346) 47352) inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct@@0  (=> (and (= $abort_flag@10 $abort_flag@9) (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@0 |inline$$WritebackToValue$2$vdst'@2|)) (and (=> (= (ControlFlow 0 47324) 47810) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 47324) 47505) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 47322) 47324)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct@@0  (=> (= (ControlFlow 0 47332) 47324) inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct@@0)))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1)) (and (=> (= (ControlFlow 0 47252) 47332) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 47252) 47322) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct@@0)))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1) (=> (and (and (= inline$$WritebackToGlobal$2$ta@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1)) (= inline$$WritebackToGlobal$2$a@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1))) (and (= inline$$WritebackToGlobal$2$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (= |inline$$WritebackToGlobal$2$m'@1| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1 inline$$WritebackToGlobal$2$v@1))))) (and (=> (= (ControlFlow 0 47306) 47332) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 47306) 47322) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct@@0))))))
(let ((inline$$WritebackToGlobal$2$anon0_correct  (=> (= inline$$WritebackToGlobal$2$l@1 (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (and (=> (= (ControlFlow 0 47242) 47306) inline$$WritebackToGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 47242) 47252) inline$$WritebackToGlobal$2$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$5$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1))) (=> (and (= |inline$$WritebackToReference$5$dst'@2| inline$$BorrowGlobal$2$dst@2) (= (ControlFlow 0 47064) 47242)) inline$$WritebackToGlobal$2$anon0_correct))))
(let ((inline$$WritebackToReference$5$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1)) (= |inline$$WritebackToReference$5$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$WritebackToReference$5$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$5$srcPath@1 (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$2$dst@2) (|v#$Mutation| |inline$$WriteRef$5$to'@1|))))) (and (= |inline$$WritebackToReference$5$dst'@2| |inline$$WritebackToReference$5$dst'@1|) (= (ControlFlow 0 47120) 47242))) inline$$WritebackToGlobal$2$anon0_correct)))
(let ((inline$$WritebackToReference$5$anon0_correct  (=> (and (= inline$$WritebackToReference$5$srcPath@1 (|p#$Mutation| |inline$$WriteRef$5$to'@1|)) (= inline$$WritebackToReference$5$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2))) (and (=> (= (ControlFlow 0 47028) 47120) inline$$WritebackToReference$5$anon3_Then_correct) (=> (= (ControlFlow 0 47028) 47064) inline$$WritebackToReference$5$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 46891) 47028)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Then_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@2@@0 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 47342) 47028)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$WriteRef$5$anon0_correct  (=> (= |inline$$WriteRef$5$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$9$dst@1) (|p#$Mutation| inline$$BorrowField$9$dst@1) inline$$AddU64$2$dst@2)) (and (=> (= (ControlFlow 0 46877) 47342) inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Then_correct@@0) (=> (= (ControlFlow 0 46877) 46891) inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Else_correct@@0)))))
(let ((inline$$BorrowField$9$anon0_correct  (=> (= inline$$BorrowField$9$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$9$size@1 (|size#$Path| inline$$BorrowField$9$p@1)) (= inline$$BorrowField$9$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1) inline$$BorrowField$9$size@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$9$size@1 1)))) (and (= inline$$BorrowField$9$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$9$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 46818) 46877))) inline$$WriteRef$5$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct@@0  (=> (and (not $abort_flag@9) (= (ControlFlow 0 46824) 46818)) inline$$BorrowField$9$anon0_correct)))
(let ((inline$$AddU64$2$anon3_Then$1_correct  (=> (and (= $abort_flag@9 true) (= inline$$AddU64$2$dst@2 inline$$AddU64$2$dst@0)) (and (=> (= (ControlFlow 0 46688) 47346) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct@@0) (=> (= (ControlFlow 0 46688) 46824) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct@@0)))))
(let ((inline$$AddU64$2$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@0)) $MAX_U64) (= (ControlFlow 0 46686) 46688)) inline$$AddU64$2$anon3_Then$1_correct)))
(let ((inline$$AddU64$2$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@0))) (= inline$$AddU64$2$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@0))))) (and (= $abort_flag@9 $abort_flag@8) (= inline$$AddU64$2$dst@2 inline$$AddU64$2$dst@1))) (and (=> (= (ControlFlow 0 46630) 47346) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct@@0) (=> (= (ControlFlow 0 46630) 46824) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct@@0)))))
(let ((inline$$AddU64$2$Entry_correct  (and (=> (= (ControlFlow 0 46600) (- 0 74741)) true) (and (=> (= (ControlFlow 0 46600) 46686) inline$$AddU64$2$anon3_Then_correct) (=> (= (ControlFlow 0 46600) 46630) inline$$AddU64$2$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else$1_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@0 ($Integer 1)) (= (ControlFlow 0 46694) 46600)) inline$$AddU64$2$Entry_correct)))
(let ((inline$$ReadRef$6$anon0_correct  (=> (and (= inline$$ReadRef$6$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 46489) 46694)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else$1_correct@@0)))
(let ((inline$$BorrowField$8$anon0_correct  (=> (= inline$$BorrowField$8$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$8$size@1 (|size#$Path| inline$$BorrowField$8$p@1)) (= inline$$BorrowField$8$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1) inline$$BorrowField$8$size@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$8$size@1 1)))) (and (= inline$$BorrowField$8$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$8$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 46451) 46489))) inline$$ReadRef$6$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct@@0  (=> (and (not $abort_flag@8) (= (ControlFlow 0 46503) 46451)) inline$$BorrowField$8$anon0_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Then$1_correct  (=> (and (= $abort_flag@8 true) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 46285) 47372) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct@@0) (=> (= (ControlFlow 0 46285) 46503) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1)) (= (ControlFlow 0 46283) 46285)) inline$$BorrowGlobal$2$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1) (= inline$$BorrowGlobal$2$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1)))) (and (= $abort_flag@8 $abort_flag@7) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 46231) 47372) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct@@0) (=> (= (ControlFlow 0 46231) 46503) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$2$anon0_correct  (=> (= inline$$BorrowGlobal$2$a@1 (|a#$Address| inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1@@0)) (and (=> (= (ControlFlow 0 46201) 46283) inline$$BorrowGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 46201) 46231) inline$$BorrowGlobal$2$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$2$Entry_correct  (and (=> (= (ControlFlow 0 46195) (- 0 74537)) true) (=> (= (ControlFlow 0 46195) 46201) inline$$BorrowGlobal$2$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1@@0 ($Address 0)) (= (ControlFlow 0 46291) 46195)) inline$$BorrowGlobal$2$Entry_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2| inline$$ReadRef$4$v@1) (= (ControlFlow 0 46058) 46291)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct@@0))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) ($Local 2)) (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|) 0 inline$$ReadRef$4$v@1 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)))) (and (= |inline$$WritebackToValue$2$vdst'@2| |inline$$WritebackToValue$2$vdst'@1|) (= (ControlFlow 0 46084) 46291))) inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 45961) (- 0 74425)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$2$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$2$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@6 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@5) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$2$$after@0)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 45961) 46084) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 45961) 46058) inline$$WritebackToValue$2$anon3_Else_correct)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$2$Entry_correct  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (= (ControlFlow 0 45923) 45961)) inline$$TestMutRefsAccrossModule_T_$pack_ref$2$anon0_correct)))
(let ((inline$$WritebackToReference$4$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$4$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1))) (=> (and (= |inline$$WritebackToReference$4$dst'@2| inline$$BorrowLoc$2$dst@1) (= (ControlFlow 0 45799) 45923)) inline$$TestMutRefsAccrossModule_T_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$4$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$4$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1)) (= |inline$$WritebackToReference$4$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$WritebackToReference$4$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$4$srcPath@1 (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$2$dst@1) (|v#$Mutation| |inline$$WriteRef$4$to'@1|))))) (and (= |inline$$WritebackToReference$4$dst'@2| |inline$$WritebackToReference$4$dst'@1|) (= (ControlFlow 0 45855) 45923))) inline$$TestMutRefsAccrossModule_T_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$4$anon0_correct  (=> (and (= inline$$WritebackToReference$4$srcPath@1 (|p#$Mutation| |inline$$WriteRef$4$to'@1|)) (= inline$$WritebackToReference$4$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1))) (and (=> (= (ControlFlow 0 45763) 45855) inline$$WritebackToReference$4$anon3_Then_correct) (=> (= (ControlFlow 0 45763) 45799) inline$$WritebackToReference$4$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 45626) 45763)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Then_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@1@@0 (|v#$Mutation| inline$$TestMutRefsAccrossModule_increment_$def$0$r@0@@0)) (= (ControlFlow 0 47398) 45763)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$WriteRef$4$anon0_correct  (=> (= |inline$$WriteRef$4$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$7$dst@1) (|p#$Mutation| inline$$BorrowField$7$dst@1) inline$$AddU64$1$dst@2@@1)) (and (=> (= (ControlFlow 0 45612) 47398) inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Then_correct@@0) (=> (= (ControlFlow 0 45612) 45626) inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Else_correct@@0)))))
(let ((inline$$BorrowField$7$anon0_correct  (=> (= inline$$BorrowField$7$p@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$7$size@1 (|size#$Path| inline$$BorrowField$7$p@1)) (= inline$$BorrowField$7$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1) inline$$BorrowField$7$size@1 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$7$size@1 1)))) (and (= inline$$BorrowField$7$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$7$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 45553) 45612))) inline$$WriteRef$4$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct@@0  (=> (and (not $abort_flag@7) (= (ControlFlow 0 45559) 45553)) inline$$BorrowField$7$anon0_correct)))
(let ((inline$$AddU64$1$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@7 true) (= inline$$AddU64$1$dst@2@@1 inline$$AddU64$1$dst@0@@1)) (and (=> (= (ControlFlow 0 45423) 47402) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct@@0) (=> (= (ControlFlow 0 45423) 45559) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct@@0)))))
(let ((inline$$AddU64$1$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$5$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@0)) $MAX_U64) (= (ControlFlow 0 45421) 45423)) inline$$AddU64$1$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$1$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$5$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@0))) (= inline$$AddU64$1$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$5$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@0))))) (and (= $abort_flag@7 $abort_flag@6) (= inline$$AddU64$1$dst@2@@1 inline$$AddU64$1$dst@1@@1))) (and (=> (= (ControlFlow 0 45365) 47402) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct@@0) (=> (= (ControlFlow 0 45365) 45559) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct@@0)))))
(let ((inline$$AddU64$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 45335) (- 0 74097)) true) (and (=> (= (ControlFlow 0 45335) 45421) inline$$AddU64$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 45335) 45365) inline$$AddU64$1$anon3_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon2$4_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@0 ($Integer 1)) (= (ControlFlow 0 45429) 45335)) inline$$AddU64$1$Entry_correct@@1)))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowField$6$dst@1)) (= (ControlFlow 0 45224) 45429)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon2$4_correct@@0)))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 45186) 45224))) inline$$ReadRef$5$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$anon0_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@5 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@4) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 45028) 45186)) inline$$BorrowField$6$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$Entry_correct  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowLoc$2$dst@1)) (= (ControlFlow 0 45006) 45028)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$anon0_correct)))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@1 ($Mutation ($Local 2) $EmptyPath inline$$ReadRef$4$v@1)) (= (ControlFlow 0 44954) 45006)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$Entry_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 44870) 44954)) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Then_correct@@0  (=> (= (ControlFlow 0 47426) 44954) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon0_correct@@0  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 44864) 47426) inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Then_correct@@0) (=> (= (ControlFlow 0 44864) 44870) inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$4$v@1) (let ((va@@28 (|v#$Vector| inline$$ReadRef$4$v@1)))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 47432) 44864)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 44425) (- 0 73811)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum@4)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum@4))) (=> (= (ControlFlow 0 44425) 47432) inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$anon0_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon6$6_correct  (and (=> (= (ControlFlow 0 47440) (- 0 73806)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 47440) 44425) inline$$TestMutRefsAccrossModule_increment_$direct_intra$0$Entry_correct@@0)))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 44315) 47440)) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon6$6_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) ($Local 1))) (= (ControlFlow 0 44251) 44315)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) (= (ControlFlow 0 44277) 44315)) inline$$ReadRef$4$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 44154) (- 0 73703)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@4 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@3@@2) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 44154) 44277) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 44154) 44251) inline$$WritebackToValue$1$anon3_Else_correct@@0)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$1$Entry_correct  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 44116) 44154)) inline$$TestMutRefsAccrossModule_T_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| inline$$BorrowLoc$0$dst@1@@6) (= (ControlFlow 0 43958) 44116)) inline$$TestMutRefsAccrossModule_T_$pack_ref$1$Entry_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|v#$Mutation| |inline$$WriteRef$3$to'@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 44014) 44116))) inline$$TestMutRefsAccrossModule_T_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6))) (and (=> (= (ControlFlow 0 43922) 44014) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 43922) 43958) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@3  (and (=> (= (ControlFlow 0 43781) (- 0 73526)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@3)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@3)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@3@@2 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@2@@4) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@3)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 43781) 43922)) inline$$WritebackToReference$3$anon0_correct)))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@3 (|v#$Mutation| |inline$$WriteRef$3$to'@1|)) (= (ControlFlow 0 43743) 43781)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 43681) 43743)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon15_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (= (ControlFlow 0 47826) 43743)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@3)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 43667) 47826) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 43667) 43681) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 43673) 43667)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$Abort_correct  (=> (and (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$ret0@1 $Error) (= $TestMutRefsAccrossModule_TSum_$memory@1 $TestMutRefsAccrossModule_TSum_$memory@0@@3)) (and (= $abort_flag@6 true) (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$ret0@2 inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 43528) 47830) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 43528) 43673) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 43576) 43528)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 43586) 43528) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon22_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 43570) 43586) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 43570) 43576) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon23_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 43546) 43528)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 43556) 43528) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 43540) 43556) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 43540) 43546) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon26_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 43520) 43528)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 43536) 43528) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon27_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 43514) 43536) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 43514) 43520) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon28_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon20_correct  (=> (= $TestMutRefsAccrossModule_TSum_$memory@1 |inline$$WritebackToGlobal$1$m'@2|) (=> (and (= $abort_flag@6 $abort_flag@5) (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@0|)) (and (=> (= (ControlFlow 0 43492) 47830) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 43492) 43673) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 43490) 43492)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon20_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 43500) 43492) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon20_correct)))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (= |inline$$WritebackToGlobal$1$m'@2| $TestMutRefsAccrossModule_TSum_$memory@0@@3)) (and (=> (= (ControlFlow 0 43420) 43500) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 43420) 43490) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon30_Else_correct)))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@3) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)))) (and (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@3) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@3) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1))) (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|))) (and (=> (= (ControlFlow 0 43474) 43500) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 43474) 43490) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon30_Else_correct))))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (and (=> (= (ControlFlow 0 43410) 43474) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 43410) 43420) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 43232) 43410)) inline$$WritebackToGlobal$1$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@0|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 43288) 43410))) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 43196) 43288) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 43196) 43232) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 43059) 43196)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon29_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 43510) 43196)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct@@0  (=> (= |inline$$WriteRef$2$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1) (|p#$Mutation| inline$$BorrowField$5$dst@1) inline$$Sub$1$dst@2@@1)) (and (=> (= (ControlFlow 0 43045) 43510) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 43045) 43059) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon29_Else_correct)))))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 42986) 43045))) inline$$WriteRef$2$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon27_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 42992) 42986)) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$Sub$1$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@5 true) (= inline$$Sub$1$dst@2@@1 inline$$Sub$1$dst@0@@1)) (and (=> (= (ControlFlow 0 42856) 43514) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 42856) 42992) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon27_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$ReadRef$3$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t10@1)) (= (ControlFlow 0 42854) 42856)) inline$$Sub$1$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$1$anon3_Else_correct@@1  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t10@1) (|i#$Integer| inline$$ReadRef$3$v@1)) (= inline$$Sub$1$dst@1@@1 ($Integer (- (|i#$Integer| inline$$ReadRef$3$v@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t10@1))))) (and (= $abort_flag@5 $abort_flag@4) (= inline$$Sub$1$dst@2@@1 inline$$Sub$1$dst@1@@1))) (and (=> (= (ControlFlow 0 42802) 43514) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 42802) 42992) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon27_Else_correct)))))
(let ((inline$$Sub$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 42776) (- 0 72960)) true) (and (=> (= (ControlFlow 0 42776) 42854) inline$$Sub$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 42776) 42802) inline$$Sub$1$anon3_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Else$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 42862) 42776)) inline$$Sub$1$Entry_correct@@1)))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 42673) 42862)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Else$1_correct)))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 42635) 42673))) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 42687) 42635)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (and (= $abort_flag@4 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 42469) 43540) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 42469) 42687) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@3) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 42467) 42469)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@3) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@3) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)))) (and (= $abort_flag@4 $abort_flag@3@@2) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 42415) 43540) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 42415) 42687) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon25_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t8@1)) (and (=> (= (ControlFlow 0 42385) 42467) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 42385) 42415) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 42379) (- 0 72756)) true) (=> (= (ControlFlow 0 42379) 42385) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon8$2_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t8@1 ($Address 0)) (= (ControlFlow 0 42475) 42379)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@4  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$ReadRef$1$v@1@@3) (= (ControlFlow 0 42242) 42475)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon8$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@4  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) 0 inline$$ReadRef$1$v@1@@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@4|) (= (ControlFlow 0 42268) 42475))) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon8$2_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@3  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3))) (= |inline$$WritebackToReference$1$dst'@2@@3| inline$$BorrowLoc$1$dst@1@@0)) (and (=> (= (ControlFlow 0 42087) 42268) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 42087) 42242) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@3  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3)) (and (= |inline$$WritebackToReference$1$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$WritebackToReference$1$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@3|)))) (= |inline$$WritebackToReference$1$dst'@2@@3| |inline$$WritebackToReference$1$dst'@1@@3|))) (and (=> (= (ControlFlow 0 42143) 42268) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 42143) 42242) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$1$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (= inline$$WritebackToReference$1$dstPath@1@@3 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) (and (=> (= (ControlFlow 0 42051) 42143) inline$$WritebackToReference$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 42051) 42087) inline$$WritebackToReference$1$anon3_Else_correct@@3)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 41914) 42051)) inline$$WritebackToReference$1$anon0_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon24_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$trace_temp@1 (|v#$Mutation| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$r@0)) (= (ControlFlow 0 43566) 42051)) inline$$WritebackToReference$1$anon0_correct@@3)))
(let ((inline$$WriteRef$1$anon0_correct@@3  (=> (= |inline$$WriteRef$1$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@3) (|p#$Mutation| inline$$BorrowField$3$dst@1@@3) inline$$Sub$0$dst@2@@2)) (and (=> (= (ControlFlow 0 41900) 43566) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 41900) 41914) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon24_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@3  (=> (= inline$$BorrowField$3$p@1@@3 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (=> (and (and (= inline$$BorrowField$3$size@1@@3 (|size#$Path| inline$$BorrowField$3$p@1@@3)) (= inline$$BorrowField$3$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@3) inline$$BorrowField$3$size@1@@3 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$3$size@1@@3 1)))) (and (= inline$$BorrowField$3$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$BorrowField$3$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 41841) 41900))) inline$$WriteRef$1$anon0_correct@@3))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon22_Else_correct  (=> (and (not $abort_flag@3@@2) (= (ControlFlow 0 41847) 41841)) inline$$BorrowField$3$anon0_correct@@3)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@3@@2 true) (= inline$$Sub$0$dst@2@@2 inline$$Sub$0$dst@0@@2)) (and (=> (= (ControlFlow 0 41711) 43570) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 41711) 41847) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon22_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@2  (=> (and (< (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t5@1)) (= (ControlFlow 0 41709) 41711)) inline$$Sub$0$anon3_Then$1_correct@@2)))
(let ((inline$$Sub$0$anon3_Else_correct@@2  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t5@1) (|i#$Integer| inline$$ReadRef$2$v@1@@0)) (= inline$$Sub$0$dst@1@@2 ($Integer (- (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t5@1))))) (and (= $abort_flag@3@@2 $abort_flag@2@@5) (= inline$$Sub$0$dst@2@@2 inline$$Sub$0$dst@1@@2))) (and (=> (= (ControlFlow 0 41657) 43570) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 41657) 41847) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon22_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 41631) (- 0 72374)) true) (and (=> (= (ControlFlow 0 41631) 41709) inline$$Sub$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 41631) 41657) inline$$Sub$0$anon3_Else_correct@@2)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon2$3_correct  (=> (and (= inline$$TestMutRefsAccrossModule_private_decrement_$def$0$$t5@1 ($Integer 1)) (= (ControlFlow 0 41717) 41631)) inline$$Sub$0$Entry_correct@@2)))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowField$2$dst@1@@3)) (= (ControlFlow 0 41528) 41717)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon2$3_correct)))
(let ((inline$$BorrowField$2$anon0_correct@@3  (=> (= inline$$BorrowField$2$p@1@@3 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (=> (and (and (= inline$$BorrowField$2$size@1@@3 (|size#$Path| inline$$BorrowField$2$p@1@@3)) (= inline$$BorrowField$2$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@3) inline$$BorrowField$2$size@1@@3 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$2$size@1@@3 1)))) (and (= inline$$BorrowField$2$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$BorrowField$2$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 41490) 41528))) inline$$ReadRef$2$anon0_correct@@0))))
(let ((inline$$BorrowLoc$1$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$1$dst@1@@0 ($Mutation ($Local 2) $EmptyPath inline$$ReadRef$1$v@1@@3)) (= (ControlFlow 0 41330) 41490)) inline$$BorrowField$2$anon0_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 41246) 41330)) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 43594) 41330) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon0_correct  (=> (not $abort_flag@2@@5) (and (=> (= (ControlFlow 0 41240) 43594) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 41240) 41246) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon21_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_private_decrement_$direct_intra$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1@@3) (let ((va@@29 (|v#$Vector| inline$$ReadRef$1$v@1@@3)))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (= (ControlFlow 0 43600) 41240)) inline$$TestMutRefsAccrossModule_private_decrement_$def$0$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Else$4_correct  (and (=> (= (ControlFlow 0 43608) (- 0 72141)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 43608) 43600) inline$$TestMutRefsAccrossModule_private_decrement_$direct_intra$0$anon0_correct)))))
(let ((inline$$ReadRef$1$anon0_correct@@3  (=> (and (= inline$$ReadRef$1$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (= (ControlFlow 0 40758) 43608)) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Else$4_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@3  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@3)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@4 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@1@@5) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@3)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 40688) 40758)) inline$$ReadRef$1$anon0_correct@@3))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (= (ControlFlow 0 40666) 40688)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@3)))
(let ((inline$$BorrowLoc$0$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$0$dst@1@@6 ($Mutation ($Local 1) $EmptyPath inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2)) (= (ControlFlow 0 40614) 40666)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@3)))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@2@@5) (= (ControlFlow 0 40620) 40614)) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct  (=> (= inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@1 $Error) (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@3 $TestMutRefsAccrossModule_TSum_$memory) (= $TestMutRefsAccrossModule_spec_sum@1@@5 $TestMutRefsAccrossModule_spec_sum)) (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2 inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@1) (= $abort_flag@2@@5 true))) (and (=> (= (ControlFlow 0 40508) 47834) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 40508) 40620) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 40526) 40508)) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 40536) 40508) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 40520) 40536) inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 40520) 40526) inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 40500) 40508)) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 40516) 40508) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 40494) 40516) inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 40494) 40500) inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon14_correct  (=> (and (and (= $TestMutRefsAccrossModule_TSum_$memory@0@@3 |inline$$WritebackToGlobal$0$m'@2@@3|) (= $TestMutRefsAccrossModule_spec_sum@1@@5 $TestMutRefsAccrossModule_spec_sum@0@@5)) (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2 inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@0) (= $abort_flag@2@@5 $abort_flag@1@@6))) (and (=> (= (ControlFlow 0 40472) 47834) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 40472) 40620) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 40470) 40472)) inline$$TestMutRefsAccrossModule_new_$def$0$anon14_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 40480) 40472) inline$$TestMutRefsAccrossModule_new_$def$0$anon14_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@0  (and (=> (= (ControlFlow 0 40434) (- 0 71922)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@0@@5 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@0)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 40434) 40480) inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 40434) 40470) inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Else_correct)))))))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 40448) 40434)) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 40454) 40434) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 40442) 40454) inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 40442) 40448) inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 40396) 40434)) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 40388) 40442) inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 40388) 40396) inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@5  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@5)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@3| $TestMutRefsAccrossModule_TSum_$memory) (= (ControlFlow 0 40155) 40388)) inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct@@0))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@5  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@5) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@5 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@5)) (= inline$$WritebackToGlobal$0$a@1@@5 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@5))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@5 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@5 inline$$WritebackToGlobal$0$a@1@@5) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|))) (= |inline$$WritebackToGlobal$0$m'@1@@5| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@5 inline$$WritebackToGlobal$0$a@1@@5 inline$$WritebackToGlobal$0$v@1@@5)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@3| |inline$$WritebackToGlobal$0$m'@1@@5|) (= (ControlFlow 0 40209) 40388))) inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct@@0)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@5  (=> (= inline$$WritebackToGlobal$0$l@1@@5 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (and (=> (= (ControlFlow 0 40145) 40209) inline$$WritebackToGlobal$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 40145) 40155) inline$$WritebackToGlobal$0$anon3_Else_correct@@5)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@6  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@6 inline$$WritebackToReference$0$srcPath@1@@6))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@6| inline$$BorrowGlobal$0$dst@2@@5) (= (ControlFlow 0 39967) 40145)) inline$$WritebackToGlobal$0$anon0_correct@@5))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@6  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@6 inline$$WritebackToReference$0$srcPath@1@@6)) (= |inline$$WritebackToReference$0$dst'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$WritebackToReference$0$dstPath@1@@6 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@6 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@6|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@6| |inline$$WritebackToReference$0$dst'@1@@6|) (= (ControlFlow 0 40023) 40145))) inline$$WritebackToGlobal$0$anon0_correct@@5)))
(let ((inline$$WritebackToReference$0$anon0_correct@@6  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@6 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@6|)) (= inline$$WritebackToReference$0$dstPath@1@@6 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) (and (=> (= (ControlFlow 0 39931) 40023) inline$$WritebackToReference$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 39931) 39967) inline$$WritebackToReference$0$anon3_Else_correct@@6)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 39794) 39931)) inline$$WritebackToReference$0$anon0_correct@@6)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (= (ControlFlow 0 40490) 39931)) inline$$WritebackToReference$0$anon0_correct@@6)))
(let ((inline$$WriteRef$0$anon0_correct@@6  (=> (= |inline$$WriteRef$0$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@6) (|p#$Mutation| inline$$BorrowField$1$dst@1@@6) inline$$AddU64$0$dst@2@@3)) (and (=> (= (ControlFlow 0 39780) 40490) inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 39780) 39794) inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@6  (=> (= inline$$BorrowField$1$p@1@@6 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (=> (and (and (= inline$$BorrowField$1$size@1@@6 (|size#$Path| inline$$BorrowField$1$p@1@@6)) (= inline$$BorrowField$1$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@6) inline$$BorrowField$1$size@1@@6 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$1$size@1@@6 1)))) (and (= inline$$BorrowField$1$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$BorrowField$1$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 39721) 39780))) inline$$WriteRef$0$anon0_correct@@6))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Else_correct  (=> (and (not $abort_flag@1@@6) (= (ControlFlow 0 39727) 39721)) inline$$BorrowField$1$anon0_correct@@6)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@1@@6 true) (= inline$$AddU64$0$dst@2@@3 inline$$AddU64$0$dst@0@@3)) (and (=> (= (ControlFlow 0 39591) 40494) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 39591) 39727) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@3  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@6) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1)) $MAX_U64) (= (ControlFlow 0 39589) 39591)) inline$$AddU64$0$anon3_Then$1_correct@@3)))
(let ((inline$$AddU64$0$anon3_Else_correct@@3  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@6) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1))) (= inline$$AddU64$0$dst@1@@3 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@6) (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1))))) (and (= $abort_flag@1@@6 $abort_flag@0@@6) (= inline$$AddU64$0$dst@2@@3 inline$$AddU64$0$dst@1@@3))) (and (=> (= (ControlFlow 0 39533) 40494) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 39533) 39727) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 39503) (- 0 71435)) true) (and (=> (= (ControlFlow 0 39503) 39589) inline$$AddU64$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 39503) 39533) inline$$AddU64$0$anon3_Else_correct@@3)))))
(let ((inline$$ReadRef$0$anon0_correct@@6  (=> (and (= inline$$ReadRef$0$v@1@@6 (|v#$Mutation| inline$$BorrowField$0$dst@1@@6)) (= (ControlFlow 0 39396) 39503)) inline$$AddU64$0$Entry_correct@@3)))
(let ((inline$$BorrowField$0$anon0_correct@@6  (=> (= inline$$BorrowField$0$p@1@@6 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (=> (and (and (= inline$$BorrowField$0$size@1@@6 (|size#$Path| inline$$BorrowField$0$p@1@@6)) (= inline$$BorrowField$0$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@6) inline$$BorrowField$0$size@1@@6 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$0$size@1@@6 1)))) (and (= inline$$BorrowField$0$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$BorrowField$0$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 39358) 39396))) inline$$ReadRef$0$anon0_correct@@6))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@0@@6) (= (ControlFlow 0 39410) 39358)) inline$$BorrowField$0$anon0_correct@@6)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@5  (=> (and (= $abort_flag@0@@6 true) (= inline$$BorrowGlobal$0$dst@2@@5 inline$$BorrowGlobal$0$dst@0@@5)) (and (=> (= (ControlFlow 0 39192) 40520) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 39192) 39410) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@5  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@5)) (= (ControlFlow 0 39190) 39192)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@5)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@5  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@5) (= inline$$BorrowGlobal$0$dst@1@@5 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@5) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@5)))) (and (= $abort_flag@0@@6 false) (= inline$$BorrowGlobal$0$dst@2@@5 inline$$BorrowGlobal$0$dst@1@@5))) (and (=> (= (ControlFlow 0 39138) 40520) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 39138) 39410) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@5  (=> (= inline$$BorrowGlobal$0$a@1@@5 (|a#$Address| inline$$TestMutRefsAccrossModule_new_$def$0$$t3@1)) (and (=> (= (ControlFlow 0 39108) 39190) inline$$BorrowGlobal$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 39108) 39138) inline$$BorrowGlobal$0$anon3_Else_correct@@5)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 39102) (- 0 71243)) true) (=> (= (ControlFlow 0 39102) 39108) inline$$BorrowGlobal$0$anon0_correct@@5))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon2$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$t3@1 ($Address 0)) (= (ControlFlow 0 39198) 39102)) inline$$BorrowGlobal$0$Entry_correct@@5)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 38963) 39198)) inline$$TestMutRefsAccrossModule_new_$def$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 40544) 39198) inline$$TestMutRefsAccrossModule_new_$def$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 38957) 40544) inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 38957) 38963) inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_new_$direct_intra$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 40550) 38957)) inline$$TestMutRefsAccrossModule_new_$def$0$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_new_$direct_intra$0$Entry_correct  (and (=> (= (ControlFlow 0 38642) (- 0 71107)) (|b#$Boolean| ($Boolean (> (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 38642) (- 0 71122)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum))) (=> (= (ControlFlow 0 38642) 40550) inline$$TestMutRefsAccrossModule_new_$direct_intra$0$anon0_correct)))))))
(let ((inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon0_correct  (=> (and (and (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 0))))) $TestMutRefsAccrossModule_TSum_sum) $TestMutRefsAccrossModule_spec_sum)))) (and (= inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 40558) 38642))) inline$$TestMutRefsAccrossModule_new_$direct_intra$0$Entry_correct)))
(let ((anon0$1_correct@@7  (=> (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (=> (and (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@11))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@11))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@11))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@11))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@11))
)) (= (ControlFlow 0 47840) 40558)) inline$$TestMutRefsAccrossModule_private_to_public_caller_invalid_data_invariant_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@8  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 70058) 47840)) anon0$1_correct@@7)))
anon0_correct@@8)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun inline$$WritebackToGlobal$2$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2@@0| () T@$Mutation)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@1@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$2$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$4$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_delete_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1@@0 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@3 () T@$Value)
(declare-fun inline$$BorrowField$7$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1@@0 () Int)
(declare-fun inline$$BorrowField$7$p@2@@0 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@3 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1@@0 () Int)
(declare-fun inline$$BorrowField$6$p@2@@0 () T@$Path)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@5@@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@4@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$2$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$2$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$2$dst@1@@0 () T@$Mutation)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun inline$$TestMutRefsAccrossModule_delete_$def$0$$t4@1 () T@$Value)
(declare-fun |inline$$WriteRef$3$to'@1@@0| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@1| () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@7 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1@@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_TSum_$memory@0@@4 () T@$Memory)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@0| () T@$Memory)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun inline$$WritebackToGlobal$1$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$1$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$2$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@0 () Int)
(declare-fun inline$$BorrowField$5$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$2$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@0 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@1 () T@$Value)
(declare-fun inline$$AddU64$2$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@0 () Int)
(declare-fun inline$$BorrowField$4$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@4| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@5| () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@4 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@3@@3 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@2@@5 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@4 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@4 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@4| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@1@@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$r@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1@@4 () T@$Mutation)
(declare-fun inline$$AddU64$1$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@4 () Int)
(declare-fun inline$$BorrowField$3$p@2@@4 () T@$Path)
(declare-fun inline$$AddU64$1$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@1 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1@@2 () T@$Value)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun inline$$BorrowField$2$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@4 () Int)
(declare-fun inline$$BorrowField$2$p@2@@4 () T@$Path)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0@@0 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@1@@6 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@4 () T@$Value)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@4| () T@$Memory)
(declare-fun inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@1 () T@$Value)
(declare-fun $TestMutRefsAccrossModule_spec_sum@0@@6 () T@$Value)
(declare-fun inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@6 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@6 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@6 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@7| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@6| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@6 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@7| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@7 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@7 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@7| () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$trace_temp@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@7 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@4 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@7 () Int)
(declare-fun inline$$BorrowField$1$p@2@@7 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@4 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@7 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@4 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@7 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@7 () Int)
(declare-fun inline$$BorrowField$0$p@2@@7 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@6 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@6 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@6 () T@$Mutation)
(declare-fun inline$$TestMutRefsAccrossModule_new_$def$0$$t3@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 75427) (let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon9_Then_correct true))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$Abort_correct  (=> (= $abort_flag@9@@0 true) (and (=> (= (ControlFlow 0 56797) 56863) inline$$TestMutRefsUser_valid_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 56797) 56859) inline$$TestMutRefsUser_valid_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 56823) 56797)) inline$$TestMutRefsAccrossModule_delete_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 56833) 56797) inline$$TestMutRefsAccrossModule_delete_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon16_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 56817) 56833) inline$$TestMutRefsAccrossModule_delete_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 56817) 56823) inline$$TestMutRefsAccrossModule_delete_$def$0$anon17_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 56791) 56797)) inline$$TestMutRefsAccrossModule_delete_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 56805) 56797) inline$$TestMutRefsAccrossModule_delete_$def$0$Abort_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon19_Then_correct  (=> $abort_flag@8@@0 (and (=> (= (ControlFlow 0 56785) 56805) inline$$TestMutRefsAccrossModule_delete_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 56785) 56791) inline$$TestMutRefsAccrossModule_delete_$def$0$anon20_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon14$2_correct  (=> (= $abort_flag@9@@0 $abort_flag@8@@0) (and (=> (= (ControlFlow 0 56771) 56863) inline$$TestMutRefsUser_valid_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 56771) 56859) inline$$TestMutRefsUser_valid_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@0  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0)) (= (ControlFlow 0 56709) 56771)) inline$$TestMutRefsAccrossModule_delete_$def$0$anon14$2_correct)))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@0  (=> (and ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0) (= inline$$WritebackToGlobal$2$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$2$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@0)) (= inline$$WritebackToGlobal$2$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1@@0) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|)))) (and (= |inline$$WritebackToGlobal$2$m'@1@@0| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1@@0) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0 inline$$WritebackToGlobal$2$v@1@@0))) (= (ControlFlow 0 56763) 56771))) inline$$TestMutRefsAccrossModule_delete_$def$0$anon14$2_correct))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$2$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|)) (and (=> (= (ControlFlow 0 56699) 56763) inline$$WritebackToGlobal$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 56699) 56709) inline$$WritebackToGlobal$2$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$3$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$4$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@0 inline$$WritebackToReference$3$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$3$dst'@2@@0| inline$$BorrowGlobal$2$dst@2@@0) (= (ControlFlow 0 56521) 56699)) inline$$WritebackToGlobal$2$anon0_correct@@0))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$4$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@0 inline$$WritebackToReference$3$srcPath@1@@0)) (= |inline$$WritebackToReference$3$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2@@0) inline$$WritebackToReference$3$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$2$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$4$to'@1@@0|))))) (and (= |inline$$WritebackToReference$3$dst'@2@@0| |inline$$WritebackToReference$3$dst'@1@@0|) (= (ControlFlow 0 56577) 56699))) inline$$WritebackToGlobal$2$anon0_correct@@0)))
(let ((inline$$WritebackToReference$3$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$3$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$4$to'@1@@0|)) (= inline$$WritebackToReference$3$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2@@0))) (and (=> (= (ControlFlow 0 56485) 56577) inline$$WritebackToReference$3$anon3_Then_correct@@0) (=> (= (ControlFlow 0 56485) 56521) inline$$WritebackToReference$3$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 56348) 56485)) inline$$WritebackToReference$3$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon21_Then_correct  (=> (and (= inline$$TestMutRefsAccrossModule_delete_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2@@0)) (= (ControlFlow 0 56781) 56485)) inline$$WritebackToReference$3$anon0_correct@@0)))
(let ((inline$$WriteRef$4$anon0_correct@@0  (=> (= |inline$$WriteRef$4$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$7$dst@1@@0) (|p#$Mutation| inline$$BorrowField$7$dst@1@@0) inline$$Sub$0$dst@2@@3)) (and (=> (= (ControlFlow 0 56334) 56781) inline$$TestMutRefsAccrossModule_delete_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 56334) 56348) inline$$TestMutRefsAccrossModule_delete_$def$0$anon21_Else_correct)))))
(let ((inline$$BorrowField$7$anon0_correct@@0  (=> (= inline$$BorrowField$7$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2@@0)) (=> (and (and (= inline$$BorrowField$7$size@1@@0 (|size#$Path| inline$$BorrowField$7$p@1@@0)) (= inline$$BorrowField$7$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1@@0) inline$$BorrowField$7$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$7$size@1@@0 1)))) (and (= inline$$BorrowField$7$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2@@0) inline$$BorrowField$7$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2@@0))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 56275) 56334))) inline$$WriteRef$4$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon19_Else_correct  (=> (and (not $abort_flag@8@@0) (= (ControlFlow 0 56281) 56275)) inline$$BorrowField$7$anon0_correct@@0)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@8@@0 true) (= inline$$Sub$0$dst@2@@3 inline$$Sub$0$dst@0@@3)) (and (=> (= (ControlFlow 0 56145) 56785) inline$$TestMutRefsAccrossModule_delete_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 56145) 56281) inline$$TestMutRefsAccrossModule_delete_$def$0$anon19_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@3  (=> (and (< (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0)) (= (ControlFlow 0 56143) 56145)) inline$$Sub$0$anon3_Then$1_correct@@3)))
(let ((inline$$Sub$0$anon3_Else_correct@@3  (=> (and (and (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0) (|i#$Integer| inline$$ReadRef$4$v@1@@0)) (= inline$$Sub$0$dst@1@@3 ($Integer (- (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0))))) (and (= $abort_flag@8@@0 $abort_flag@7@@0) (= inline$$Sub$0$dst@2@@3 inline$$Sub$0$dst@1@@3))) (and (=> (= (ControlFlow 0 56091) 56785) inline$$TestMutRefsAccrossModule_delete_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 56091) 56281) inline$$TestMutRefsAccrossModule_delete_$def$0$anon19_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 56065) (- 0 79159)) true) (and (=> (= (ControlFlow 0 56065) 56143) inline$$Sub$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 56065) 56091) inline$$Sub$0$anon3_Else_correct@@3)))))
(let ((inline$$ReadRef$4$anon0_correct@@0  (=> (and (= inline$$ReadRef$4$v@1@@0 (|v#$Mutation| inline$$BorrowField$6$dst@1@@0)) (= (ControlFlow 0 55966) 56065)) inline$$Sub$0$Entry_correct@@3)))
(let ((inline$$BorrowField$6$anon0_correct@@0  (=> (= inline$$BorrowField$6$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2@@0)) (=> (and (and (= inline$$BorrowField$6$size@1@@0 (|size#$Path| inline$$BorrowField$6$p@1@@0)) (= inline$$BorrowField$6$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1@@0) inline$$BorrowField$6$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$6$size@1@@0 1)))) (and (= inline$$BorrowField$6$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2@@0) inline$$BorrowField$6$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2@@0))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 55928) 55966))) inline$$ReadRef$4$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 55774) 55928)) inline$$BorrowField$6$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 56813) 55928) inline$$BorrowField$6$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_T_unpack$0$anon0_correct@@0  (=> (and ((_ is $Vector) |inline$$WritebackToValue$1$vdst'@2|) (= inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)) $TestMutRefsAccrossModule_T_value))) (=> (and (and (and ((_ is $Integer) inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0) (>= (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0) 0)) (<= (|i#$Integer| inline$$TestMutRefsAccrossModule_T_unpack$0$value@1@@0) $MAX_U64)) (= $TestMutRefsAccrossModule_spec_sum@5@@0 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@4@@0) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)) $TestMutRefsAccrossModule_T_value)))))) (and (=> (= (ControlFlow 0 55760) 56813) inline$$TestMutRefsAccrossModule_delete_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 55760) 55774) inline$$TestMutRefsAccrossModule_delete_$def$0$anon18_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 55766) 55760)) inline$$TestMutRefsAccrossModule_T_unpack$0$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$2$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@7@@0 true) (= inline$$BorrowGlobal$2$dst@2@@0 inline$$BorrowGlobal$2$dst@0@@0)) (and (=> (= (ControlFlow 0 55655) 56817) inline$$TestMutRefsAccrossModule_delete_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 55655) 55766) inline$$TestMutRefsAccrossModule_delete_$def$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$2$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1@@0) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1@@0)) (= (ControlFlow 0 55653) 55655)) inline$$BorrowGlobal$2$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$2$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1@@0) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1@@0) (= inline$$BorrowGlobal$2$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@1@@0) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1@@0)))) (and (= $abort_flag@7@@0 $abort_flag@6@@0) (= inline$$BorrowGlobal$2$dst@2@@0 inline$$BorrowGlobal$2$dst@1@@0))) (and (=> (= (ControlFlow 0 55601) 56817) inline$$TestMutRefsAccrossModule_delete_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 55601) 55766) inline$$TestMutRefsAccrossModule_delete_$def$0$anon16_Else_correct)))))
(let ((inline$$BorrowGlobal$2$anon0_correct@@0  (=> (= inline$$BorrowGlobal$2$a@1@@0 (|a#$Address| inline$$TestMutRefsAccrossModule_delete_$def$0$$t4@1)) (and (=> (= (ControlFlow 0 55571) 55653) inline$$BorrowGlobal$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 55571) 55601) inline$$BorrowGlobal$2$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$2$Entry_correct@@0  (and (=> (= (ControlFlow 0 55565) (- 0 78908)) true) (=> (= (ControlFlow 0 55565) 55571) inline$$BorrowGlobal$2$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon2$1_correct  (=> (and (= inline$$TestMutRefsAccrossModule_delete_$def$0$$t4@1 ($Address 0)) (= (ControlFlow 0 55661) 55565)) inline$$BorrowGlobal$2$Entry_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 55426) 55661)) inline$$TestMutRefsAccrossModule_delete_$def$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 56841) 55661) inline$$TestMutRefsAccrossModule_delete_$def$0$anon2$1_correct)))
(let ((inline$$TestMutRefsAccrossModule_delete_$def$0$anon0_correct  (=> (not $abort_flag@6@@0) (and (=> (= (ControlFlow 0 55420) 56841) inline$$TestMutRefsAccrossModule_delete_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 55420) 55426) inline$$TestMutRefsAccrossModule_delete_$def$0$anon15_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_delete_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) |inline$$WritebackToValue$1$vdst'@2|) (let ((va@@32 (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$1$vdst'@2|)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 56845) 55420)) inline$$TestMutRefsAccrossModule_delete_$def$0$anon0_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@0|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2@@0) (= (ControlFlow 0 55042) 56845)) inline$$TestMutRefsAccrossModule_delete_$direct_inter$0$anon0_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@0|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1@@0|) 0 inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2@@0 (|v#$Mutation| |inline$$WriteRef$3$to'@1@@0|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1@@1|) (= (ControlFlow 0 55068) 56845))) inline$$TestMutRefsAccrossModule_delete_$direct_inter$0$anon0_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$1$anon0_correct@@0  (and (=> (= (ControlFlow 0 54945) (- 0 78720)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@4@@0 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0@@0)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 54945) 55068) inline$$WritebackToValue$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 54945) 55042) inline$$WritebackToValue$1$anon3_Else_correct@@1)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WriteRef$3$to'@1@@0|)) (= (ControlFlow 0 54907) 54945)) inline$$TestMutRefsAccrossModule_T_$pack_ref$1$anon0_correct@@0)))
(let ((inline$$WriteRef$3$anon0_correct@@0  (=> (and (= |inline$$WriteRef$3$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7) inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@1)) (= (ControlFlow 0 54839) 54907)) inline$$TestMutRefsAccrossModule_T_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon8_Else_correct  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 54845) 54839)) inline$$WriteRef$3$anon0_correct@@0)))
(let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon8_Then_correct true))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@1  (=> (and (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1@@1 $Error) (= $TestMutRefsAccrossModule_TSum_$memory@1@@0 $TestMutRefsAccrossModule_TSum_$memory@0@@4)) (and (= $abort_flag@6@@0 true) (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@1 inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@1@@1))) (and (=> (= (ControlFlow 0 54700) 56871) inline$$TestMutRefsUser_valid_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 54700) 54845) inline$$TestMutRefsUser_valid_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 54748) 54700)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Then_correct@@1  (=> (= (ControlFlow 0 54758) 54700) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct@@1  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 54742) 54758) inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Then_correct@@1) (=> (= (ControlFlow 0 54742) 54748) inline$$TestMutRefsAccrossModule_increment_$def$0$anon23_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 54718) 54700)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Then_correct@@1  (=> (= (ControlFlow 0 54728) 54700) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct@@1  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 54712) 54728) inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Then_correct@@1) (=> (= (ControlFlow 0 54712) 54718) inline$$TestMutRefsAccrossModule_increment_$def$0$anon26_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 54692) 54700)) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Then_correct@@1  (=> (= (ControlFlow 0 54708) 54700) inline$$TestMutRefsAccrossModule_increment_$def$0$Abort_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct@@1  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 54686) 54708) inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Then_correct@@1) (=> (= (ControlFlow 0 54686) 54692) inline$$TestMutRefsAccrossModule_increment_$def$0$anon28_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct@@1  (=> (= $TestMutRefsAccrossModule_TSum_$memory@1@@0 |inline$$WritebackToGlobal$1$m'@2@@0|) (=> (and (= $abort_flag@6@@0 $abort_flag@5@@0) (= inline$$TestMutRefsAccrossModule_increment_$def$0$$ret0@2@@1 |inline$$WritebackToValue$0$vdst'@2@@1|)) (and (=> (= (ControlFlow 0 54664) 56871) inline$$TestMutRefsUser_valid_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 54664) 54845) inline$$TestMutRefsUser_valid_$def_verify$0$anon8_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 54662) 54664)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct@@1  (=> (= (ControlFlow 0 54672) 54664) inline$$TestMutRefsAccrossModule_increment_$def$0$anon20_correct@@1)))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@0  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0)) (= |inline$$WritebackToGlobal$1$m'@2@@0| $TestMutRefsAccrossModule_TSum_$memory@0@@4)) (and (=> (= (ControlFlow 0 54592) 54672) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct@@1) (=> (= (ControlFlow 0 54592) 54662) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct@@1)))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@0  (=> (and ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0) (= inline$$WritebackToGlobal$1$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$1$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@0)) (= inline$$WritebackToGlobal$1$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@4) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|)))) (and (= |inline$$WritebackToGlobal$1$m'@1@@0| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@4) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@4) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0 inline$$WritebackToGlobal$1$v@1@@0))) (= |inline$$WritebackToGlobal$1$m'@2@@0| |inline$$WritebackToGlobal$1$m'@1@@0|))) (and (=> (= (ControlFlow 0 54646) 54672) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Then_correct@@1) (=> (= (ControlFlow 0 54646) 54662) inline$$TestMutRefsAccrossModule_increment_$def$0$anon30_Else_correct@@1))))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$1$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|)) (and (=> (= (ControlFlow 0 54582) 54646) inline$$WritebackToGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 54582) 54592) inline$$WritebackToGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@0| inline$$BorrowGlobal$1$dst@2@@0) (= (ControlFlow 0 54404) 54582)) inline$$WritebackToGlobal$1$anon0_correct@@0))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0)) (= |inline$$WritebackToReference$2$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$WritebackToReference$2$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@0| |inline$$WritebackToReference$2$dst'@1@@0|) (= (ControlFlow 0 54460) 54582))) inline$$WritebackToGlobal$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$2$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (= inline$$WritebackToReference$2$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) (and (=> (= (ControlFlow 0 54368) 54460) inline$$WritebackToReference$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 54368) 54404) inline$$WritebackToReference$2$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 54231) 54368)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Then_correct@@1  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@2@@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 54682) 54368)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$WriteRef$2$anon0_correct@@1  (=> (= |inline$$WriteRef$2$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1@@0) (|p#$Mutation| inline$$BorrowField$5$dst@1@@0) inline$$AddU64$2$dst@2@@0)) (and (=> (= (ControlFlow 0 54217) 54682) inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Then_correct@@1) (=> (= (ControlFlow 0 54217) 54231) inline$$TestMutRefsAccrossModule_increment_$def$0$anon29_Else_correct@@1)))))
(let ((inline$$BorrowField$5$anon0_correct@@0  (=> (= inline$$BorrowField$5$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$5$size@1@@0 (|size#$Path| inline$$BorrowField$5$p@1@@0)) (= inline$$BorrowField$5$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@0) inline$$BorrowField$5$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$5$size@1@@0 1)))) (and (= inline$$BorrowField$5$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$5$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 54158) 54217))) inline$$WriteRef$2$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct@@1  (=> (and (not $abort_flag@5@@0) (= (ControlFlow 0 54164) 54158)) inline$$BorrowField$5$anon0_correct@@0)))
(let ((inline$$AddU64$2$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@5@@0 true) (= inline$$AddU64$2$dst@2@@0 inline$$AddU64$2$dst@0@@0)) (and (=> (= (ControlFlow 0 54028) 54686) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct@@1) (=> (= (ControlFlow 0 54028) 54164) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct@@1)))))
(let ((inline$$AddU64$2$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$3$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@1)) $MAX_U64) (= (ControlFlow 0 54026) 54028)) inline$$AddU64$2$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$2$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$3$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@1))) (= inline$$AddU64$2$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$3$v@1@@0) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@1))))) (and (= $abort_flag@5@@0 $abort_flag@4@@0) (= inline$$AddU64$2$dst@2@@0 inline$$AddU64$2$dst@1@@0))) (and (=> (= (ControlFlow 0 53970) 54686) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Then_correct@@1) (=> (= (ControlFlow 0 53970) 54164) inline$$TestMutRefsAccrossModule_increment_$def$0$anon27_Else_correct@@1)))))
(let ((inline$$AddU64$2$Entry_correct@@0  (and (=> (= (ControlFlow 0 53940) (- 0 78163)) true) (and (=> (= (ControlFlow 0 53940) 54026) inline$$AddU64$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 53940) 53970) inline$$AddU64$2$anon3_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else$1_correct@@1  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t10@1@@1 ($Integer 1)) (= (ControlFlow 0 54034) 53940)) inline$$AddU64$2$Entry_correct@@0)))
(let ((inline$$ReadRef$3$anon0_correct@@0  (=> (and (= inline$$ReadRef$3$v@1@@0 (|v#$Mutation| inline$$BorrowField$4$dst@1@@0)) (= (ControlFlow 0 53829) 54034)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else$1_correct@@1)))
(let ((inline$$BorrowField$4$anon0_correct@@0  (=> (= inline$$BorrowField$4$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$4$size@1@@0 (|size#$Path| inline$$BorrowField$4$p@1@@0)) (= inline$$BorrowField$4$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@0) inline$$BorrowField$4$size@1@@0 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$4$size@1@@0 1)))) (and (= inline$$BorrowField$4$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$4$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 53791) 53829))) inline$$ReadRef$3$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct@@1  (=> (and (not $abort_flag@4@@0) (= (ControlFlow 0 53843) 53791)) inline$$BorrowField$4$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@4@@0 true) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@0@@0)) (and (=> (= (ControlFlow 0 53625) 54712) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct@@1) (=> (= (ControlFlow 0 53625) 53843) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@4) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0)) (= (ControlFlow 0 53623) 53625)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@4) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0) (= inline$$BorrowGlobal$1$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory@0@@4) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0)))) (and (= $abort_flag@4@@0 $abort_flag@3@@3) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@1@@0))) (and (=> (= (ControlFlow 0 53571) 54712) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Then_correct@@1) (=> (= (ControlFlow 0 53571) 53843) inline$$TestMutRefsAccrossModule_increment_$def$0$anon25_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@0  (=> (= inline$$BorrowGlobal$1$a@1@@0 (|a#$Address| inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1@@1)) (and (=> (= (ControlFlow 0 53541) 53623) inline$$BorrowGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 53541) 53571) inline$$BorrowGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 53535) (- 0 77959)) true) (=> (= (ControlFlow 0 53535) 53541) inline$$BorrowGlobal$1$anon0_correct@@0))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct@@1  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t8@1@@1 ($Address 0)) (= (ControlFlow 0 53631) 53535)) inline$$BorrowGlobal$1$Entry_correct@@0)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@5  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@1| inline$$ReadRef$1$v@1@@4) (= (ControlFlow 0 53398) 53631)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct@@1))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@5  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) 0 inline$$ReadRef$1$v@1@@4 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@5|) (= (ControlFlow 0 53424) 53631))) inline$$TestMutRefsAccrossModule_increment_$def$0$anon8$3_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@4  (and (=> (= (ControlFlow 0 53301) (- 0 77847)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@4)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@4)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@3@@3 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@2@@5) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@4)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 53301) 53424) inline$$WritebackToValue$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 53301) 53398) inline$$WritebackToValue$0$anon3_Else_correct@@5)))))))
(let ((inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestMutRefsAccrossModule_T_$pack_ref$0$$after@0@@4 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)) (= (ControlFlow 0 53263) 53301)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$anon0_correct@@4)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@4  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@4 inline$$WritebackToReference$1$srcPath@1@@4))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@4| inline$$BorrowLoc$1$dst@1@@1) (= (ControlFlow 0 53139) 53263)) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@4))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@4  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@4 inline$$WritebackToReference$1$srcPath@1@@4)) (= |inline$$WritebackToReference$1$dst'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$WritebackToReference$1$dstPath@1@@4 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@4 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@4|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@4| |inline$$WritebackToReference$1$dst'@1@@4|) (= (ControlFlow 0 53195) 53263))) inline$$TestMutRefsAccrossModule_T_$pack_ref$0$Entry_correct@@4)))
(let ((inline$$WritebackToReference$1$anon0_correct@@4  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@4 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (= inline$$WritebackToReference$1$dstPath@1@@4 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) (and (=> (= (ControlFlow 0 53103) 53195) inline$$WritebackToReference$1$anon3_Then_correct@@4) (=> (= (ControlFlow 0 53103) 53139) inline$$WritebackToReference$1$anon3_Else_correct@@4)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 52966) 53103)) inline$$WritebackToReference$1$anon0_correct@@4)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Then_correct@@1  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$trace_temp@1@@1 (|v#$Mutation| inline$$TestMutRefsAccrossModule_increment_$def$0$r@0@@1)) (= (ControlFlow 0 54738) 53103)) inline$$WritebackToReference$1$anon0_correct@@4)))
(let ((inline$$WriteRef$1$anon0_correct@@4  (=> (= |inline$$WriteRef$1$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@4) (|p#$Mutation| inline$$BorrowField$3$dst@1@@4) inline$$AddU64$1$dst@2@@2)) (and (=> (= (ControlFlow 0 52952) 54738) inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Then_correct@@1) (=> (= (ControlFlow 0 52952) 52966) inline$$TestMutRefsAccrossModule_increment_$def$0$anon24_Else_correct@@1)))))
(let ((inline$$BorrowField$3$anon0_correct@@4  (=> (= inline$$BorrowField$3$p@1@@4 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (=> (and (and (= inline$$BorrowField$3$size@1@@4 (|size#$Path| inline$$BorrowField$3$p@1@@4)) (= inline$$BorrowField$3$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@4) inline$$BorrowField$3$size@1@@4 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$3$size@1@@4 1)))) (and (= inline$$BorrowField$3$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$BorrowField$3$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 52893) 52952))) inline$$WriteRef$1$anon0_correct@@4))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct@@1  (=> (and (not $abort_flag@3@@3) (= (ControlFlow 0 52899) 52893)) inline$$BorrowField$3$anon0_correct@@4)))
(let ((inline$$AddU64$1$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@3@@3 true) (= inline$$AddU64$1$dst@2@@2 inline$$AddU64$1$dst@0@@2)) (and (=> (= (ControlFlow 0 52763) 54742) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct@@1) (=> (= (ControlFlow 0 52763) 52899) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct@@1)))))
(let ((inline$$AddU64$1$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$2$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@1)) $MAX_U64) (= (ControlFlow 0 52761) 52763)) inline$$AddU64$1$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$1$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$2$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@1))) (= inline$$AddU64$1$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$ReadRef$2$v@1@@1) (|i#$Integer| inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@1))))) (and (= $abort_flag@3@@3 $abort_flag@2@@6) (= inline$$AddU64$1$dst@2@@2 inline$$AddU64$1$dst@1@@2))) (and (=> (= (ControlFlow 0 52705) 54742) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Then_correct@@1) (=> (= (ControlFlow 0 52705) 52899) inline$$TestMutRefsAccrossModule_increment_$def$0$anon22_Else_correct@@1)))))
(let ((inline$$AddU64$1$Entry_correct@@2  (and (=> (= (ControlFlow 0 52675) (- 0 77519)) true) (and (=> (= (ControlFlow 0 52675) 52761) inline$$AddU64$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 52675) 52705) inline$$AddU64$1$anon3_Else_correct@@2)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon2$4_correct@@1  (=> (and (= inline$$TestMutRefsAccrossModule_increment_$def$0$$t5@1@@1 ($Integer 1)) (= (ControlFlow 0 52769) 52675)) inline$$AddU64$1$Entry_correct@@2)))
(let ((inline$$ReadRef$2$anon0_correct@@1  (=> (and (= inline$$ReadRef$2$v@1@@1 (|v#$Mutation| inline$$BorrowField$2$dst@1@@4)) (= (ControlFlow 0 52564) 52769)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon2$4_correct@@1)))
(let ((inline$$BorrowField$2$anon0_correct@@4  (=> (= inline$$BorrowField$2$p@1@@4 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (=> (and (and (= inline$$BorrowField$2$size@1@@4 (|size#$Path| inline$$BorrowField$2$p@1@@4)) (= inline$$BorrowField$2$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@4) inline$$BorrowField$2$size@1@@4 $TestMutRefsAccrossModule_T_value) (+ inline$$BorrowField$2$size@1@@4 1)))) (and (= inline$$BorrowField$2$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$BorrowField$2$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) $TestMutRefsAccrossModule_T_value))) (= (ControlFlow 0 52526) 52564))) inline$$ReadRef$2$anon0_correct@@1))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$anon0_correct@@0  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0@@0)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@2@@5 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum@1@@6) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0@@0)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 52368) 52526)) inline$$BorrowField$2$anon0_correct@@4))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (= (ControlFlow 0 52346) 52368)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$anon0_correct@@0)))
(let ((inline$$BorrowLoc$1$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$1$dst@1@@1 ($Mutation ($Local 2) $EmptyPath inline$$ReadRef$1$v@1@@4)) (= (ControlFlow 0 52294) 52346)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$1$Entry_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 52210) 52294)) inline$$BorrowLoc$1$anon0_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Then_correct@@1  (=> (= (ControlFlow 0 54766) 52294) inline$$BorrowLoc$1$anon0_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_increment_$def$0$anon0_correct@@1  (=> (not $abort_flag@2@@6) (and (=> (= (ControlFlow 0 52204) 54766) inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Then_correct@@1) (=> (= (ControlFlow 0 52204) 52210) inline$$TestMutRefsAccrossModule_increment_$def$0$anon21_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_increment_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1@@4) (let ((va@@33 (|v#$Vector| inline$$ReadRef$1$v@1@@4)))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 54772) 52204)) inline$$TestMutRefsAccrossModule_increment_$def$0$anon0_correct@@1)))
(let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Else$3_correct  (and (=> (= (ControlFlow 0 54780) (- 0 77248)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 54780) 54772) inline$$TestMutRefsAccrossModule_increment_$direct_inter$0$anon0_correct)))))
(let ((inline$$ReadRef$1$anon0_correct@@4  (=> (and (= inline$$ReadRef$1$v@1@@4 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7)) (= (ControlFlow 0 51700) 54780)) inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Else$3_correct)))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@4  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@4)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestMutRefsAccrossModule_spec_sum@1@@6 ($Integer (- (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@4)) $TestMutRefsAccrossModule_T_value))))) (= (ControlFlow 0 51664) 51700)) inline$$ReadRef$1$anon0_correct@@4))))
(let ((inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$$before@0@@4 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7)) (= (ControlFlow 0 51642) 51664)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$anon0_correct@@4)))
(let ((inline$$BorrowLoc$0$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$0$dst@1@@7 ($Mutation ($Local 0) $EmptyPath inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2@@0)) (= (ControlFlow 0 51590) 51642)) inline$$TestMutRefsAccrossModule_T_$unpack_ref$0$Entry_correct@@4)))
(let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Else_correct  (=> (and (not $abort_flag@2@@6) (= (ControlFlow 0 51596) 51590)) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Then_correct true))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct@@0  (=> (and (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@1@@0 $Error) (= $TestMutRefsAccrossModule_TSum_$memory@0@@4 $TestMutRefsAccrossModule_TSum_$memory)) (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2@@0 inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@1@@0) (= $abort_flag@2@@6 true))) (and (=> (= (ControlFlow 0 51484) 56875) inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 51484) 51596) inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Else_correct)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 51502) 51484)) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Then_correct@@0  (=> (= (ControlFlow 0 51512) 51484) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Then_correct@@0  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 51496) 51512) inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Then_correct@@0) (=> (= (ControlFlow 0 51496) 51502) inline$$TestMutRefsAccrossModule_new_$def$0$anon17_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 51476) 51484)) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Then_correct@@0  (=> (= (ControlFlow 0 51492) 51484) inline$$TestMutRefsAccrossModule_new_$def$0$Abort_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Then_correct@@0  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 51470) 51492) inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Then_correct@@0) (=> (= (ControlFlow 0 51470) 51476) inline$$TestMutRefsAccrossModule_new_$def$0$anon19_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon14_correct@@0  (=> (= $TestMutRefsAccrossModule_TSum_$memory@0@@4 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$ret0@2@@0 inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@1) (= $abort_flag@2@@6 $abort_flag@1@@7)) (and (=> (= (ControlFlow 0 51448) 56875) inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 51448) 51596) inline$$TestMutRefsUser_valid_$def_verify$0$anon7_Else_correct))))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 51446) 51448)) inline$$TestMutRefsAccrossModule_new_$def$0$anon14_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Then_correct@@0  (=> (= (ControlFlow 0 51456) 51448) inline$$TestMutRefsAccrossModule_new_$def$0$anon14_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@1  (and (=> (= (ControlFlow 0 51410) (- 0 77046)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@1)) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestMutRefsAccrossModule_spec_sum@0@@6 ($Integer (+ (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@1)) $TestMutRefsAccrossModule_T_value))))) (and (=> (= (ControlFlow 0 51410) 51456) inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Then_correct@@0) (=> (= (ControlFlow 0 51410) 51446) inline$$TestMutRefsAccrossModule_new_$def$0$anon21_Else_correct@@0)))))))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 51424) 51410)) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 51430) 51410) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 51418) 51430) inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 51418) 51424) inline$$TestMutRefsAccrossModule_T_pack$0$anon5_Else_correct@@1)))))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Else_correct@@1  (=> (and (>= 0 0) (= (ControlFlow 0 51372) 51410)) inline$$TestMutRefsAccrossModule_T_pack$0$anon3_correct@@1)))
(let ((inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct@@1  (=> (and (and (and ((_ is $Integer) inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) (>= (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) 0)) (<= (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) $MAX_U64)) (= inline$$TestMutRefsAccrossModule_T_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) 1)))) (and (=> (= (ControlFlow 0 51364) 51418) inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 51364) 51372) inline$$TestMutRefsAccrossModule_T_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@6  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@6)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@4| $TestMutRefsAccrossModule_TSum_$memory) (= (ControlFlow 0 51131) 51364)) inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct@@1))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@6  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@6) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@6 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@6)) (= inline$$WritebackToGlobal$0$a@1@@6 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@6))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@6 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@6 inline$$WritebackToGlobal$0$a@1@@6) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|))) (= |inline$$WritebackToGlobal$0$m'@1@@6| ($Memory (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) inline$$WritebackToGlobal$0$ta@1@@6 inline$$WritebackToGlobal$0$a@1@@6 inline$$WritebackToGlobal$0$v@1@@6)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@4| |inline$$WritebackToGlobal$0$m'@1@@6|) (= (ControlFlow 0 51185) 51364))) inline$$TestMutRefsAccrossModule_T_pack$0$anon0_correct@@1)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@6  (=> (= inline$$WritebackToGlobal$0$l@1@@6 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|)) (and (=> (= (ControlFlow 0 51121) 51185) inline$$WritebackToGlobal$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 51121) 51131) inline$$WritebackToGlobal$0$anon3_Else_correct@@6)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@7  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@7 inline$$WritebackToReference$0$srcPath@1@@7))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@7| inline$$BorrowGlobal$0$dst@2@@6) (= (ControlFlow 0 50943) 51121)) inline$$WritebackToGlobal$0$anon0_correct@@6))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@7  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@7 inline$$WritebackToReference$0$srcPath@1@@7)) (= |inline$$WritebackToReference$0$dst'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) inline$$WritebackToReference$0$dstPath@1@@7 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@7 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@7| |inline$$WritebackToReference$0$dst'@1@@7|) (= (ControlFlow 0 50999) 51121))) inline$$WritebackToGlobal$0$anon0_correct@@6)))
(let ((inline$$WritebackToReference$0$anon0_correct@@7  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@7 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (= inline$$WritebackToReference$0$dstPath@1@@7 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@6))) (and (=> (= (ControlFlow 0 50907) 50999) inline$$WritebackToReference$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 50907) 50943) inline$$WritebackToReference$0$anon3_Else_correct@@7)))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 50770) 50907)) inline$$WritebackToReference$0$anon0_correct@@7)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Then_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$trace_temp@1@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@6)) (= (ControlFlow 0 51466) 50907)) inline$$WritebackToReference$0$anon0_correct@@7)))
(let ((inline$$WriteRef$0$anon0_correct@@7  (=> (= |inline$$WriteRef$0$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@7) (|p#$Mutation| inline$$BorrowField$1$dst@1@@7) inline$$AddU64$0$dst@2@@4)) (and (=> (= (ControlFlow 0 50756) 51466) inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Then_correct@@0) (=> (= (ControlFlow 0 50756) 50770) inline$$TestMutRefsAccrossModule_new_$def$0$anon20_Else_correct@@0)))))
(let ((inline$$BorrowField$1$anon0_correct@@7  (=> (= inline$$BorrowField$1$p@1@@7 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@6)) (=> (and (and (= inline$$BorrowField$1$size@1@@7 (|size#$Path| inline$$BorrowField$1$p@1@@7)) (= inline$$BorrowField$1$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@7) inline$$BorrowField$1$size@1@@7 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$1$size@1@@7 1)))) (and (= inline$$BorrowField$1$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) inline$$BorrowField$1$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@6))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 50697) 50756))) inline$$WriteRef$0$anon0_correct@@7))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Else_correct@@0  (=> (and (not $abort_flag@1@@7) (= (ControlFlow 0 50703) 50697)) inline$$BorrowField$1$anon0_correct@@7)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@4  (=> (and (= $abort_flag@1@@7 true) (= inline$$AddU64$0$dst@2@@4 inline$$AddU64$0$dst@0@@4)) (and (=> (= (ControlFlow 0 50567) 51470) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Then_correct@@0) (=> (= (ControlFlow 0 50567) 50703) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Else_correct@@0)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@4  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@7) (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1)) $MAX_U64) (= (ControlFlow 0 50565) 50567)) inline$$AddU64$0$anon3_Then$1_correct@@4)))
(let ((inline$$AddU64$0$anon3_Else_correct@@4  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@7) (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1))) (= inline$$AddU64$0$dst@1@@4 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@7) (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1))))) (and (= $abort_flag@1@@7 $abort_flag@0@@7) (= inline$$AddU64$0$dst@2@@4 inline$$AddU64$0$dst@1@@4))) (and (=> (= (ControlFlow 0 50509) 51470) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Then_correct@@0) (=> (= (ControlFlow 0 50509) 50703) inline$$TestMutRefsAccrossModule_new_$def$0$anon18_Else_correct@@0)))))
(let ((inline$$AddU64$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 50479) (- 0 76559)) true) (and (=> (= (ControlFlow 0 50479) 50565) inline$$AddU64$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 50479) 50509) inline$$AddU64$0$anon3_Else_correct@@4)))))
(let ((inline$$ReadRef$0$anon0_correct@@7  (=> (and (= inline$$ReadRef$0$v@1@@7 (|v#$Mutation| inline$$BorrowField$0$dst@1@@7)) (= (ControlFlow 0 50372) 50479)) inline$$AddU64$0$Entry_correct@@4)))
(let ((inline$$BorrowField$0$anon0_correct@@7  (=> (= inline$$BorrowField$0$p@1@@7 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@6)) (=> (and (and (= inline$$BorrowField$0$size@1@@7 (|size#$Path| inline$$BorrowField$0$p@1@@7)) (= inline$$BorrowField$0$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@7) inline$$BorrowField$0$size@1@@7 $TestMutRefsAccrossModule_TSum_sum) (+ inline$$BorrowField$0$size@1@@7 1)))) (and (= inline$$BorrowField$0$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) inline$$BorrowField$0$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@6))) $TestMutRefsAccrossModule_TSum_sum))) (= (ControlFlow 0 50334) 50372))) inline$$ReadRef$0$anon0_correct@@7))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Else_correct@@0  (=> (and (not $abort_flag@0@@7) (= (ControlFlow 0 50386) 50334)) inline$$BorrowField$0$anon0_correct@@7)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@6  (=> (and (= $abort_flag@0@@7 true) (= inline$$BorrowGlobal$0$dst@2@@6 inline$$BorrowGlobal$0$dst@0@@6)) (and (=> (= (ControlFlow 0 50168) 51496) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Then_correct@@0) (=> (= (ControlFlow 0 50168) 50386) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@6  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@6)) (= (ControlFlow 0 50166) 50168)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@6)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@6  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@6) (= inline$$BorrowGlobal$0$dst@1@@6 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@6) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@6)))) (and (= $abort_flag@0@@7 false) (= inline$$BorrowGlobal$0$dst@2@@6 inline$$BorrowGlobal$0$dst@1@@6))) (and (=> (= (ControlFlow 0 50114) 51496) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Then_correct@@0) (=> (= (ControlFlow 0 50114) 50386) inline$$TestMutRefsAccrossModule_new_$def$0$anon16_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@6  (=> (= inline$$BorrowGlobal$0$a@1@@6 (|a#$Address| inline$$TestMutRefsAccrossModule_new_$def$0$$t3@1@@0)) (and (=> (= (ControlFlow 0 50084) 50166) inline$$BorrowGlobal$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 50084) 50114) inline$$BorrowGlobal$0$anon3_Else_correct@@6)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@6  (and (=> (= (ControlFlow 0 50078) (- 0 76367)) true) (=> (= (ControlFlow 0 50078) 50084) inline$$BorrowGlobal$0$anon0_correct@@6))))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon2$1_correct@@0  (=> (and (= inline$$TestMutRefsAccrossModule_new_$def$0$$t3@1@@0 ($Address 0)) (= (ControlFlow 0 50174) 50078)) inline$$BorrowGlobal$0$Entry_correct@@6)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 49939) 50174)) inline$$TestMutRefsAccrossModule_new_$def$0$anon2$1_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Then_correct@@0  (=> (= (ControlFlow 0 51520) 50174) inline$$TestMutRefsAccrossModule_new_$def$0$anon2$1_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 49933) 51520) inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Then_correct@@0) (=> (= (ControlFlow 0 49933) 49939) inline$$TestMutRefsAccrossModule_new_$def$0$anon15_Else_correct@@0)))))
(let ((inline$$TestMutRefsAccrossModule_new_$direct_inter$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) (>= (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) 0)) (<= (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) $MAX_U64)) (= (ControlFlow 0 51526) 49933)) inline$$TestMutRefsAccrossModule_new_$def$0$anon0_correct@@0)))
(let ((inline$$TestMutRefsAccrossModule_new_$direct_inter$0$Entry_correct  (and (=> (= (ControlFlow 0 49618) (- 0 76253)) (|b#$Boolean| ($Boolean (> (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 49618) 51526) inline$$TestMutRefsAccrossModule_new_$direct_inter$0$anon0_correct)))))
(let ((inline$$TestMutRefsUser_valid_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestMutRefsUser_valid_$def_verify$0$$t1@1 ($Integer 4)) (= (ControlFlow 0 51534) 49618)) inline$$TestMutRefsAccrossModule_new_$direct_inter$0$Entry_correct))))
(let ((anon0$1_correct@@8  (=> (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12))) $TestMutRefsAccrossModule_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12))) $TestMutRefsAccrossModule_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12))) $TestMutRefsAccrossModule_T_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12))) $TestMutRefsAccrossModule_T_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_T_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (=> (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@13))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@13))) $TestMutRefsAccrossModule_TSum_sum)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@13))) $TestMutRefsAccrossModule_TSum_sum)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@13))) $TestMutRefsAccrossModule_TSum_sum)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMutRefsAccrossModule_TSum_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (= (ControlFlow 0 56879) 51534)) inline$$TestMutRefsUser_valid_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@9  (=> (and (and (and ((_ is $Integer) $TestMutRefsAccrossModule_spec_sum) (>= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) 0)) (<= (|i#$Integer| $TestMutRefsAccrossModule_spec_sum) $MAX_U64)) (= (ControlFlow 0 75427) 56879)) anon0$1_correct@@8)))
anon0_correct@@9))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
