(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestPackUnpack_R () T@$TypeName)
(declare-fun $TestPackUnpack_S () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestPackUnpack_R_nested () Int)
(declare-fun $TestPackUnpack_R_type_value () T@$TypeValue)
(declare-fun $TestPackUnpack_S_value () Int)
(declare-fun $TestPackUnpack_S_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestPackUnpack_R $TestPackUnpack_S)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestPackUnpack_R_nested 0))
(assert (= $TestPackUnpack_R_type_value ($StructType $TestPackUnpack_R $EmptyTypeValueArray)))
(assert (= $TestPackUnpack_S_value 0))
(assert (= $TestPackUnpack_S_type_value ($StructType $TestPackUnpack_S $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun r@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun $TestPackUnpack_r_count@1 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0 () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun $TestPackUnpack_r_count () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 59714) (let ((anon0$2_correct  (=> (= (ControlFlow 0 23488) (- 0 61255)) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 1))))))))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon10_correct  (=> (= $abort_flag@0 false) (=> (and (= inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2|) (= (ControlFlow 0 23436) 23488)) anon0$2_correct))))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 23434) 23436)) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon10_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 23444) 23436) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon10_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 2))) (= |inline$$WritebackToValue$1$vdst'@2| r@@1)) (and (=> (= (ControlFlow 0 23392) 23444) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 23392) 23434) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 r@@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|)) (and (=> (= (ControlFlow 0 23418) 23444) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 23418) 23434) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct  (=> (= $TestPackUnpack_r_count@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@0) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 23295) 23418) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 23295) 23392) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 23279) 23295)) inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowLoc$0$dst@1) (= (ControlFlow 0 23176) 23279)) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 23232) 23279))) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 23140) 23232) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 23140) 23176) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 22999) (- 0 60979)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@0) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 22999) 23140)) inline$$WritebackToReference$2$anon0_correct)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= (ControlFlow 0 22961) 22999)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WriteRef$1$to'@1|) (= (ControlFlow 0 22837) 22961)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$1$to'@1|) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1|) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 22893) 22961))) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|))) (and (=> (= (ControlFlow 0 22801) 22893) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 22801) 22837) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 22664) 22801)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon14_Then_correct  (=> (and (= inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)) (= (ControlFlow 0 23454) 22801)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1) (|p#$Mutation| inline$$BorrowField$2$dst@1) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t6@1)) (and (=> (= (ControlFlow 0 22650) 23454) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 22650) 22664) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $TestPackUnpack_S_value) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$1$to'@1|) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$1$to'@1|))) $TestPackUnpack_S_value))) (= (ControlFlow 0 22591) 22650))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon6_correct  (=> (and (= inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t6@1 ($Integer 1)) (= (ControlFlow 0 22597) 22591)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 22469) 22597)) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon6_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon13_Then_correct  (=> (and (= inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)) (= (ControlFlow 0 23464) 22597)) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon6_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) |inline$$WritebackToValue$0$vdst'@2|)) (and (=> (= (ControlFlow 0 22455) 23464) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 22455) 22469) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon12_Else_correct  (=> (and (not false) (= (ControlFlow 0 22461) 22455)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon12_Then_correct true))
(let ((inline$$TestPackUnpack_private_update_value_$def$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 22356) 23472) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 22356) 22461) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestPackUnpack_private_update_value_$def$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 22366) 23472) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 22366) 22461) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon12_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$0$v@1)) (and (=> (= (ControlFlow 0 22314) 22366) inline$$TestPackUnpack_private_update_value_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 22314) 22356) inline$$TestPackUnpack_private_update_value_$def$0$anon9_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 inline$$ReadRef$0$v@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|)) (and (=> (= (ControlFlow 0 22340) 22366) inline$$TestPackUnpack_private_update_value_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 22340) 22356) inline$$TestPackUnpack_private_update_value_$def$0$anon9_Else_correct))))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 22159) 22340) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 22159) 22314) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 22215) 22340) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 22215) 22314) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 22123) 22215) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 22123) 22159) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t4@1)) (= (ControlFlow 0 21980) 22123)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $TestPackUnpack_S_value))) (= (ControlFlow 0 21921) 21980))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 2) $EmptyPath inline$$ReadRef$0$v@1)) (= (ControlFlow 0 21797) 21921)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$TestPackUnpack_private_update_value_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 21679) 21797)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestPackUnpack_private_update_value_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 22374) 21797) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestPackUnpack_private_update_value_$def$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 21671) 22374) inline$$TestPackUnpack_private_update_value_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 21671) 21679) inline$$TestPackUnpack_private_update_value_$def$0$anon8_Else_correct)))))
(let ((inline$$TestPackUnpack_private_update_value_$def$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 22382) 22374) inline$$TestPackUnpack_private_update_value_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 22382) 21679) inline$$TestPackUnpack_private_update_value_$def$0$anon8_Else_correct))))
(let ((inline$$TestPackUnpack_private_update_value_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 21665) 22382) inline$$TestPackUnpack_private_update_value_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 21665) 21671) inline$$TestPackUnpack_private_update_value_$def$0$anon7_Else_correct)))))
(let ((inline$$TestPackUnpack_private_update_value_$direct_intra$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1) (let ((va@@8 (|v#$Vector| inline$$ReadRef$0$v@1)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $TestPackUnpack_S_value)) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t4@1) (>= (|i#$Integer| inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t4@1) 0)) (<= (|i#$Integer| inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t4@1) $MAX_U64)) (= (ControlFlow 0 22388) 21665))) inline$$TestPackUnpack_private_update_value_$def$0$anon0_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon2$6_correct  (and (=> (= (ControlFlow 0 22396) (- 0 60273)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 22396) 22388) inline$$TestPackUnpack_private_update_value_$direct_intra$0$anon0_correct)))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 21436) 22396)) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon2$6_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon2$5_correct  (=> (and (= inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 21442) 21436)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 21396) 21442)) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon2$5_correct))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 21374) 21396)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 21322) 21374))) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$0$$before@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@0 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 21200) 21322)) inline$$BorrowField$0$anon0_correct))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 21180) 21200)) inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 2) $EmptyPath r@@1)) (= (ControlFlow 0 21129) 21180)) inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 21045) 21129)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 23480) 21129) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 21039) 23480) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 21039) 21045) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) r@@1) (let ((va@@9 (|v#$Vector| r@@1)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestPackUnpack_R_nested)) (let ((va@@10 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestPackUnpack_R_nested))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 20758) 21039)) inline$$TestPackUnpack_call_private_violating_invariant_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 59714) 20758)) anon0_correct))))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@0| () T@$Mutation)
(declare-fun r@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@0 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$1$$after@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@3 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2 () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 61295) (let ((anon0$2_correct@@0  (=> (= (ControlFlow 0 26910) (- 0 62940)) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 1))))))))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon10_correct  (=> (= $abort_flag@0@@0 false) (=> (and (= inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@0|) (= (ControlFlow 0 26858) 26910)) anon0$2_correct@@0))))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 26856) 26858)) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 26866) 26858) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|) ($Local 2))) (= |inline$$WritebackToValue$1$vdst'@2@@0| r@@2)) (and (=> (= (ControlFlow 0 26814) 26866) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 26814) 26856) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|) 0 r@@2 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|))) (= |inline$$WritebackToValue$1$vdst'@2@@0| |inline$$WritebackToValue$1$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 26840) 26866) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 26840) 26856) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@0  (=> (= $TestPackUnpack_r_count@1@@0 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@0@@0) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 26717) 26840) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 26717) 26814) inline$$WritebackToValue$1$anon3_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|)) (= (ControlFlow 0 26701) 26717)) inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@0| inline$$BorrowLoc$0$dst@1@@0) (= (ControlFlow 0 26598) 26701)) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0)) (= |inline$$WritebackToReference$2$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$WritebackToReference$2$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@0| |inline$$WritebackToReference$2$dst'@1@@0|) (= (ControlFlow 0 26654) 26701))) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$2$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (= inline$$WritebackToReference$2$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) (and (=> (= (ControlFlow 0 26562) 26654) inline$$WritebackToReference$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 26562) 26598) inline$$WritebackToReference$2$anon3_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 26421) (- 0 62664)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@3 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@2) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 26421) 26562)) inline$$WritebackToReference$2$anon0_correct@@0)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (= (ControlFlow 0 26383) 26421)) inline$$TestPackUnpack_S_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WriteRef$1$to'@1@@0|) (= (ControlFlow 0 26259) 26383)) inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 26315) 26383))) inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|))) (and (=> (= (ControlFlow 0 26223) 26315) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 26223) 26259) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 26086) 26223)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon14_Then_correct  (=> (and (= inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= (ControlFlow 0 26876) 26223)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$WriteRef$2$anon0_correct@@0  (=> (= |inline$$WriteRef$2$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@0) (|p#$Mutation| inline$$BorrowField$2$dst@1@@0) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t6@1)) (and (=> (= (ControlFlow 0 26072) 26876) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 26072) 26086) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $TestPackUnpack_S_value) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))) $TestPackUnpack_S_value))) (= (ControlFlow 0 26013) 26072))) inline$$WriteRef$2$anon0_correct@@0))))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon6_correct  (=> (and (= inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t6@1 ($Integer 1)) (= (ControlFlow 0 26019) 26013)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 25891) 26019)) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon13_Then_correct  (=> (and (= inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= (ControlFlow 0 26886) 26019)) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) |inline$$WritebackToValue$0$vdst'@2@@0|)) (and (=> (= (ControlFlow 0 25877) 26886) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 25877) 25891) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not false) (= (ControlFlow 0 25883) 25877)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct true))
(let ((inline$$TestPackUnpack_public_update_value_$def$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 25778) 26894) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 25778) 25883) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestPackUnpack_public_update_value_$def$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 25788) 26894) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 25788) 25883) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$ReadRef$0$v@1@@0)) (and (=> (= (ControlFlow 0 25736) 25788) inline$$TestPackUnpack_public_update_value_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 25736) 25778) inline$$TestPackUnpack_public_update_value_$def$0$anon9_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 inline$$ReadRef$0$v@1@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 25762) 25788) inline$$TestPackUnpack_public_update_value_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 25762) 25778) inline$$TestPackUnpack_public_update_value_$def$0$anon9_Else_correct))))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 25639) (- 0 62242)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestPackUnpack_s_sum@2 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@1@@0) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@0)) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 25639) 25762) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 25639) 25736) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 25601) 25639)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$1$dst@1@@0) (= (ControlFlow 0 25477) 25601)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 25533) 25601))) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) (and (=> (= (ControlFlow 0 25441) 25533) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 25441) 25477) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t4@1)) (= (ControlFlow 0 25298) 25441)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) $TestPackUnpack_S_value))) (= (ControlFlow 0 25239) 25298))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$1$anon0_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$1$$before@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@0 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum@0@@0) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$1$$before@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 25117) 25239)) inline$$BorrowField$1$anon0_correct@@0))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$1$Entry_correct  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (= (ControlFlow 0 25095) 25117)) inline$$TestPackUnpack_S_$unpack_ref$1$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$1$dst@1@@0 ($Mutation ($Local 2) $EmptyPath inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 25043) 25095)) inline$$TestPackUnpack_S_$unpack_ref$1$Entry_correct)))
(let ((inline$$TestPackUnpack_public_update_value_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 24925) 25043)) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_public_update_value_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 25796) 25043) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_public_update_value_$def$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24917) 25796) inline$$TestPackUnpack_public_update_value_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 24917) 24925) inline$$TestPackUnpack_public_update_value_$def$0$anon8_Else_correct)))))
(let ((inline$$TestPackUnpack_public_update_value_$def$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 25804) 25796) inline$$TestPackUnpack_public_update_value_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 25804) 24925) inline$$TestPackUnpack_public_update_value_$def$0$anon8_Else_correct))))
(let ((inline$$TestPackUnpack_public_update_value_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24911) 25804) inline$$TestPackUnpack_public_update_value_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 24911) 24917) inline$$TestPackUnpack_public_update_value_$def$0$anon7_Else_correct)))))
(let ((inline$$TestPackUnpack_public_update_value_$direct_intra$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (let ((va@@11 (|v#$Vector| inline$$ReadRef$0$v@1@@0)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (and (and (and ((_ is $Integer) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t4@1) (>= (|i#$Integer| inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t4@1) 0)) (<= (|i#$Integer| inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t4@1) $MAX_U64)) (= (ControlFlow 0 25810) 24911))) inline$$TestPackUnpack_public_update_value_$def$0$anon0_correct)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon2$6_correct  (and (=> (= (ControlFlow 0 25818) (- 0 61870)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 25818) 25810) inline$$TestPackUnpack_public_update_value_$direct_intra$0$anon0_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 24660) 25818)) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon2$6_correct)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon2$5_correct  (=> (and (= inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 24666) 24660)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@0  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@0 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 24620) 24666)) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon2$5_correct))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 24598) 24620)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 24546) 24598))) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@0))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@0  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@0@@0 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 24424) 24546)) inline$$BorrowField$0$anon0_correct@@0))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 24404) 24424)) inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 2) $EmptyPath r@@2)) (= (ControlFlow 0 24353) 24404)) inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 24269) 24353)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 26902) 24353) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24263) 26902) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 24263) 24269) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) r@@2) (let ((va@@12 (|v#$Vector| r@@2)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@2)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $TestPackUnpack_R_nested)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $TestPackUnpack_R_nested))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 23982) 24263)) inline$$TestPackUnpack_call_public_violating_invariant_incorrect_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 61295) 23982)) anon0_correct@@0))))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun inline$$TestPackUnpack_R_pack$0$$struct@1 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@1 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_create_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 62971) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 28015) (- 0 63369)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_R_pack$0$$struct@1 ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 3)) (+ len@@1 1))))) (+ len@@0 1))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_R_pack$0$$struct@1 ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 3)) (+ len@@1 1))))) (+ len@@0 1)))))))) (and (=> (= (ControlFlow 0 28015) (- 0 63397)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@0@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@0@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1)))))))) (=> (= (ControlFlow 0 28015) (- 0 63422)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@0@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| ($Integer 3)))))))))))))))
(let ((inline$$TestPackUnpack_create_$def_verify$0$anon3_Else_correct  (=> (and (not true) (= (ControlFlow 0 27997) 28015)) anon0$2_correct@@1)))
(let ((inline$$TestPackUnpack_create_$def_verify$0$anon3_Then_correct  (=> (= (ControlFlow 0 28007) 28015) anon0$2_correct@@1)))
(let ((inline$$TestPackUnpack_R_pack$0$anon3_correct  (=> (= $TestPackUnpack_r_count@0@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 27961) 28007) inline$$TestPackUnpack_create_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 27961) 27997) inline$$TestPackUnpack_create_$def_verify$0$anon3_Else_correct)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 27975) 27961)) inline$$TestPackUnpack_R_pack$0$anon3_correct)))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 27981) 27961) inline$$TestPackUnpack_R_pack$0$anon3_correct)))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 27969) 27981) inline$$TestPackUnpack_R_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 27969) 27975) inline$$TestPackUnpack_R_pack$0$anon5_Else_correct)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 27945) 27961)) inline$$TestPackUnpack_R_pack$0$anon3_correct)))
(let ((inline$$TestPackUnpack_R_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$TestPackUnpack_S_pack$0$$struct@1) (let ((va@@14 (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= inline$$TestPackUnpack_R_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_S_pack$0$$struct@1) 1)))) (and (=> (= (ControlFlow 0 27937) 27969) inline$$TestPackUnpack_R_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 27937) 27945) inline$$TestPackUnpack_R_pack$0$anon4_Else_correct)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 27759) (- 0 63230)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 27759) 27937)) inline$$TestPackUnpack_R_pack$0$anon0_correct)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 27773) 27759)) inline$$TestPackUnpack_S_pack$0$anon3_correct)))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 27779) 27759) inline$$TestPackUnpack_S_pack$0$anon3_correct)))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 27767) 27779) inline$$TestPackUnpack_S_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 27767) 27773) inline$$TestPackUnpack_S_pack$0$anon5_Else_correct)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 27721) 27759)) inline$$TestPackUnpack_S_pack$0$anon3_correct)))
(let ((inline$$TestPackUnpack_S_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestPackUnpack_create_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$TestPackUnpack_create_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$TestPackUnpack_create_$def_verify$0$$t0@1) $MAX_U64)) (= inline$$TestPackUnpack_S_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_create_$def_verify$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 27713) 27767) inline$$TestPackUnpack_S_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 27713) 27721) inline$$TestPackUnpack_S_pack$0$anon4_Else_correct)))))
(let ((inline$$TestPackUnpack_create_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestPackUnpack_create_$def_verify$0$$t0@1 ($Integer 3)) (= (ControlFlow 0 27785) 27713)) inline$$TestPackUnpack_S_pack$0$anon0_correct))))
(let ((anon0_correct@@1  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 62971) 27785)) inline$$TestPackUnpack_create_$def_verify$0$anon0_correct))))
anon0_correct@@1))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestPackUnpack_S_unpack$0$value@1 () T@$Value)
(declare-fun r@@3 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@2 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@2 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_unpack$0$nested@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 63454) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 28598) (- 0 63802)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_S_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_S_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 28598) (- 0 63824)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@0@@2 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@0@@2 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1)))))))) (=> (= (ControlFlow 0 28598) (- 0 63849)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@0@@2 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)))))))))))))))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 28556) 28598)) anon0$2_correct@@2)))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 28566) 28598) anon0$2_correct@@2)))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 28546) 28566) inline$$TestPackUnpack_destroy_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 28546) 28556) inline$$TestPackUnpack_destroy_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 28574) 28566) inline$$TestPackUnpack_destroy_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 28574) 28556) inline$$TestPackUnpack_destroy_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestPackUnpack_S_unpack$0$anon0_correct  (=> (and ((_ is $Vector) inline$$TestPackUnpack_R_unpack$0$nested@1) (= inline$$TestPackUnpack_S_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)) $TestPackUnpack_S_value))) (=> (and (and (and ((_ is $Integer) inline$$TestPackUnpack_S_unpack$0$value@1) (>= (|i#$Integer| inline$$TestPackUnpack_S_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$TestPackUnpack_S_unpack$0$value@1) $MAX_U64)) (= $TestPackUnpack_s_sum@0@@2 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)) $TestPackUnpack_S_value)))))) (and (=> (= (ControlFlow 0 28532) 28574) inline$$TestPackUnpack_destroy_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 28532) 28546) inline$$TestPackUnpack_destroy_$def_verify$0$anon11_Else_correct))))))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 28439) 28532)) inline$$TestPackUnpack_S_unpack$0$anon0_correct)))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 28582) 28532) inline$$TestPackUnpack_S_unpack$0$anon0_correct)))
(let ((inline$$TestPackUnpack_R_unpack$0$anon0_correct  (=> (and ((_ is $Vector) r@@3) (= inline$$TestPackUnpack_R_unpack$0$nested@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) (=> (and (and (and (and (and ((_ is $Vector) inline$$TestPackUnpack_R_unpack$0$nested@1) (let ((va@@15 (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= $TestPackUnpack_r_count@0@@2 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 28425) 28582) inline$$TestPackUnpack_destroy_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 28425) 28439) inline$$TestPackUnpack_destroy_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 28301) 28425)) inline$$TestPackUnpack_R_unpack$0$anon0_correct)))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 28590) 28425) inline$$TestPackUnpack_R_unpack$0$anon0_correct)))
(let ((inline$$TestPackUnpack_destroy_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 28295) 28590) inline$$TestPackUnpack_destroy_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 28295) 28301) inline$$TestPackUnpack_destroy_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and (and (and (and ((_ is $Vector) r@@3) (let ((va@@16 (|v#$Vector| r@@3)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@3)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 28117) 28295)) inline$$TestPackUnpack_destroy_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 63454) 28117)) anon0_correct@@2))))
PreconditionGeneratedEntry_correct@@1)))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun r@@4 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@3 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $TestPackUnpack_s_sum@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_R_unpack$0$nested@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@3 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_extract_and_update_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $TestPackUnpack_S_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 63887) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 30244) (- 0 64873)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@2 ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 3))))) (+ len@@2 1))))))))) (=> (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@2 ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 3))))) (+ len@@2 1)))))))) (and (=> (= (ControlFlow 0 30244) (- 0 64913)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@0@@3 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@0@@3 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1)))))))) (=> (= (ControlFlow 0 30244) (- 0 64938)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@2@@0 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| ($Integer 3)))))))))))))))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon7_correct  (=> (= inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $TestPackUnpack_s_sum@2@@0 $TestPackUnpack_s_sum) (= inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@2 inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@1)) (and (= $abort_flag@1 true) (= (ControlFlow 0 30212) 30244))) anon0$2_correct@@3))))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 30206) 30212)) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon7_correct)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 30220) 30212) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon7_correct)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 30200) 30220) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 30200) 30206) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon10_correct  (=> (and (and (= $TestPackUnpack_s_sum@2@@0 $TestPackUnpack_s_sum@1@@1) (= inline$$TestPackUnpack_extract_and_update_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@1|)) (and (= $abort_flag@1 $abort_flag@0@@1) (= (ControlFlow 0 30188) 30244))) anon0$2_correct@@3)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 30186) 30188)) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon10_correct)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 30196) 30188) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon10_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@1| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) (and (=> (= (ControlFlow 0 30144) 30196) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 30144) 30186) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 inline$$TestPackUnpack_R_unpack$0$nested@1@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 30170) 30196) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 30170) 30186) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@1  (and (=> (= (ControlFlow 0 30047) (- 0 64712)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= $TestPackUnpack_s_sum@1@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@0@@3) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@1)) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 30047) 30170) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 30047) 30144) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 30009) 30047)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@1) (= (ControlFlow 0 29885) 30009)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 29941) 30009))) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 29849) 29941) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 29849) 29885) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@1) (|p#$Mutation| inline$$BorrowField$0$dst@1@@1) inline$$AddU64$0$dst@2)) (= (ControlFlow 0 29706) 29849)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $TestPackUnpack_S_value) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $TestPackUnpack_S_value))) (= (ControlFlow 0 29647) 29706))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@1  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@3 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@1)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 29525) 29647)) inline$$BorrowField$0$anon0_correct@@1))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 29503) 29525)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 1) $EmptyPath inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) (= (ControlFlow 0 29451) 29503)) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 29457) 29451)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@1 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 29389) 30200) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 29389) 29457) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1) (|i#$Integer| inline$$TestPackUnpack_extract_and_update_$def_verify$0$$t4@1)) $MAX_U64) (= (ControlFlow 0 29387) 29389)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1) (|i#$Integer| inline$$TestPackUnpack_extract_and_update_$def_verify$0$$t4@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1) (|i#$Integer| inline$$TestPackUnpack_extract_and_update_$def_verify$0$$t4@1))))) (and (= $abort_flag@0@@1 false) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 29331) 30200) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 29331) 29457) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 29301) (- 0 64344)) true) (and (=> (= (ControlFlow 0 29301) 29387) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 29301) 29331) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon4$1_correct  (=> (and (= inline$$TestPackUnpack_extract_and_update_$def_verify$0$$t4@1 ($Integer 3)) (= (ControlFlow 0 29395) 29301)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) $TestPackUnpack_S_value)) (= (ControlFlow 0 29198) 29395)) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon4$1_correct)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 29156) 29198)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 30228) 29198) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$TestPackUnpack_R_unpack$0$anon0_correct@@0  (=> (and ((_ is $Vector) r@@4) (= inline$$TestPackUnpack_R_unpack$0$nested@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) (=> (and (and (and (and (and ((_ is $Vector) inline$$TestPackUnpack_R_unpack$0$nested@1@@0) (let ((va@@18 (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_unpack$0$nested@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= $TestPackUnpack_r_count@0@@3 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 29142) 30228) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 29142) 29156) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 29018) 29142)) inline$$TestPackUnpack_R_unpack$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 30236) 29142) inline$$TestPackUnpack_R_unpack$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 29012) 30236) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 29012) 29018) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 30242) 29012)) inline$$TestPackUnpack_extract_and_update_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and (and (and ((_ is $Vector) r@@4) (let ((va@@20 (|v#$Vector| r@@4)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@4)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@4)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 28722) 30242)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 63887) 28722)) anon0_correct@@3))))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestPackUnpack_get_value_ref_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowLoc$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun r@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 64971) (let ((inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon9_Then_correct true))
(let ((inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon8_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 31030) 31050) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 31030) 31040) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon8_Then_correct  (=> (= inline$$TestPackUnpack_get_value_ref_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@1)) (and (=> (= (ControlFlow 0 31060) 31050) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 31060) 31040) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (and (and (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1))) (and (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@1 1))) (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@2))) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 31014) 31060) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 31014) 31030) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 30890) 31014))) inline$$BorrowField$1$anon0_correct@@1))))
(let ((inline$$BorrowLoc$0$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$0$dst@1@@2 ($Mutation ($Local 1) $EmptyPath r@@5)) (= (ControlFlow 0 30766) 30890)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 30682) 30766)) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 31068) 30766) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 30676) 31068) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 30676) 30682) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and (and (and ((_ is $Vector) r@@5) (let ((va@@22 (|v#$Vector| r@@5)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@5)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@5)) $TestPackUnpack_R_nested)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@5)) $TestPackUnpack_R_nested))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@5)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@5)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@5)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@5)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (= (ControlFlow 0 30517) 30676)) inline$$TestPackUnpack_get_value_ref_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 64971) 30517)) anon0_correct@@4))))
PreconditionGeneratedEntry_correct@@3)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun r2 () T@$Value)
(declare-fun r1 () T@$Value)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $TestPackUnpack_r_count@4 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@4 () T@$Value)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@1 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $TestPackUnpack_s_sum@3@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@2| () T@$Value)
(declare-fun $TestPackUnpack_r_count@3 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@1| () T@$Value)
(declare-fun $TestPackUnpack_r_count@2 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@2| () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@2 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@4 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@2 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@1 () Int)
(declare-fun inline$$BorrowField$2$p@2@@1 () T@$Path)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@2 () Int)
(declare-fun inline$$BorrowField$1$p@2@@2 () T@$Path)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@4 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun $TestPackUnpack_R_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 65325) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 35361) (- 0 67852)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer (- (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value))))) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer (- (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value))))) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 35361) (- 0 67912)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 1)))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 1))))) (and (=> (= (ControlFlow 0 35361) (- 0 67936)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@4 $TestPackUnpack_r_count))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@4 $TestPackUnpack_r_count)))) (=> (= (ControlFlow 0 35361) (- 0 67949)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@4 $TestPackUnpack_s_sum)))))))))))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$Abort_correct  (=> (and (and (and (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@1 $Error) (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@1 $Error)) (and (= $TestPackUnpack_s_sum@4 $TestPackUnpack_s_sum) (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@2 inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@1))) (and (and (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@2 inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@1) (= $TestPackUnpack_r_count@4 $TestPackUnpack_r_count@1@@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 35307) 35361)))) anon0$2_correct@@4)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 35325) 35307)) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$Abort_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 35335) 35307) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$Abort_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 35319) 35335) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 35319) 35325) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 35297) 35307)) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$Abort_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 35315) 35307) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$Abort_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 35291) 35315) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 35291) 35297) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon16_correct  (=> (and (= $TestPackUnpack_s_sum@4 $TestPackUnpack_s_sum@3@@0) (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@1|)) (=> (and (and (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@2|) (= $TestPackUnpack_r_count@4 $TestPackUnpack_r_count@3)) (and (= $abort_flag@2 $abort_flag@1@@0) (= (ControlFlow 0 35271) 35361))) anon0$2_correct@@4))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 35269) 35271)) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon16_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 35279) 35271) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon16_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 35259) 35279) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 35259) 35269) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 35287) 35279) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 35287) 35269) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon24_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) ($Local 2))) (= |inline$$WritebackToValue$1$vdst'@2@@1| r1)) (and (=> (= (ControlFlow 0 35217) 35287) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 35217) 35259) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 r1 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) (= |inline$$WritebackToValue$1$vdst'@2@@1| |inline$$WritebackToValue$1$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 35243) 35287) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 35243) 35259) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$TestPackUnpack_R_$pack_ref$1$anon0_correct  (=> (= $TestPackUnpack_r_count@3 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@2) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 35120) 35243) inline$$WritebackToValue$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 35120) 35217) inline$$WritebackToValue$1$anon3_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$1$Entry_correct  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 35104) 35120)) inline$$TestPackUnpack_R_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| inline$$BorrowLoc$0$dst@1@@3) (= (ControlFlow 0 35001) 35104)) inline$$TestPackUnpack_R_$pack_ref$1$Entry_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 35057) 35104))) inline$$TestPackUnpack_R_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) (and (=> (= (ControlFlow 0 34965) 35057) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 34965) 35001) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$1$anon0_correct@@0  (and (=> (= (ControlFlow 0 34824) (- 0 67490)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@3@@0 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@2@@1) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 34824) 34965)) inline$$WritebackToReference$3$anon0_correct)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (= (ControlFlow 0 34786) 34824)) inline$$TestPackUnpack_S_$pack_ref$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowField$4$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@1 inline$$WritebackToReference$2$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@1| inline$$BorrowField$4$dst@1) (= (ControlFlow 0 34662) 34786)) inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct@@0))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowField$4$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@1 inline$$WritebackToReference$2$srcPath@1@@1)) (= |inline$$WritebackToReference$2$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1) inline$$WritebackToReference$2$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@1) (|v#$Mutation| inline$$BorrowField$4$dst@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@1| |inline$$WritebackToReference$2$dst'@1@@1|) (= (ControlFlow 0 34718) 34786))) inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$WritebackToReference$2$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$2$dstPath@1@@1 (|p#$Mutation| inline$$BorrowField$4$dst@1))) (and (=> (= (ControlFlow 0 34626) 34718) inline$$WritebackToReference$2$anon3_Then_correct@@1) (=> (= (ControlFlow 0 34626) 34662) inline$$WritebackToReference$2$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (and (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1) (|p#$Mutation| inline$$BorrowField$5$dst@1) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t15@1)) (= (ControlFlow 0 34483) 34626)) inline$$WritebackToReference$2$anon0_correct@@1)))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| inline$$BorrowField$4$dst@1)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $TestPackUnpack_S_value) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$4$dst@1))) $TestPackUnpack_S_value))) (= (ControlFlow 0 34424) 34483))) inline$$WriteRef$1$anon0_correct@@1))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$1$anon0_correct@@0  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@2@@1 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum@1@@2) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 34302) 34424)) inline$$BorrowField$5$anon0_correct))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@0 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 34280) 34302)) inline$$TestPackUnpack_S_$unpack_ref$1$anon0_correct@@0)))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $TestPackUnpack_R_nested) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 34228) 34280))) inline$$TestPackUnpack_S_$unpack_ref$1$Entry_correct@@0))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Else$9_correct  (=> (and (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t15@1 ($Integer 1)) (= (ControlFlow 0 34234) 34228)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@2  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@2| r2) (= (ControlFlow 0 34074) 34234)) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Else$9_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@2  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) 0 r2 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@2| |inline$$WritebackToValue$0$vdst'@1@@2|) (= (ControlFlow 0 34100) 34234))) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Else$9_correct)))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@1  (=> (= $TestPackUnpack_r_count@2 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@1@@1) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 33977) 34100) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 33977) 34074) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (= (ControlFlow 0 33961) 33977)) inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@1| inline$$BorrowLoc$1$dst@1@@1) (= (ControlFlow 0 33858) 33961)) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@1))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|) (= (ControlFlow 0 33914) 33961))) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) (and (=> (= (ControlFlow 0 33822) 33914) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 33822) 33858) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@2  (and (=> (= (ControlFlow 0 33681) (- 0 66906)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@2 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@0@@4) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@2)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 33681) 33822)) inline$$WritebackToReference$1$anon0_correct@@1)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (= (ControlFlow 0 33643) 33681)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowField$2$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowField$2$dst@1@@1) (= (ControlFlow 0 33519) 33643)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowField$2$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowField$2$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|) (= (ControlFlow 0 33575) 33643))) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@2)))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowField$2$dst@1@@1))) (and (=> (= (ControlFlow 0 33483) 33575) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 33483) 33519) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (and (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) inline$$Sub$0$dst@2)) (= (ControlFlow 0 33340) 33483)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowField$2$dst@1@@1)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $TestPackUnpack_S_value) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@1) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$2$dst@1@@1))) $TestPackUnpack_S_value))) (= (ControlFlow 0 33281) 33340))) inline$$WriteRef$0$anon0_correct@@2))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@2  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@4 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@2)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 33159) 33281)) inline$$BorrowField$3$anon0_correct))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@2 (|v#$Mutation| inline$$BorrowField$2$dst@1@@1)) (= (ControlFlow 0 33137) 33159)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@2)))
(let ((inline$$BorrowField$2$anon0_correct@@1  (=> (= inline$$BorrowField$2$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (=> (and (and (= inline$$BorrowField$2$size@1@@1 (|size#$Path| inline$$BorrowField$2$p@1@@1)) (= inline$$BorrowField$2$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@1) inline$$BorrowField$2$size@1@@1 $TestPackUnpack_R_nested) (+ inline$$BorrowField$2$size@1@@1 1)))) (and (= inline$$BorrowField$2$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$BorrowField$2$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 33085) 33137))) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@2))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 33091) 33085)) inline$$BorrowField$2$anon0_correct@@1)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@0 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 32955) 35291) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 32955) 33091) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$AddU64$0$dst@2@@0) (|i#$Integer| inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t11@1)) (= (ControlFlow 0 32953) 32955)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t11@1) (|i#$Integer| inline$$AddU64$0$dst@2@@0)) (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$AddU64$0$dst@2@@0) (|i#$Integer| inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t11@1))))) (and (= $abort_flag@1@@0 $abort_flag@0@@2) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 32901) 35291) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 32901) 33091) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 32875) (- 0 66496)) true) (and (=> (= (ControlFlow 0 32875) 32953) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 32875) 32901) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@0@@2) (=> (and (= inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$$t11@1 ($Integer 1)) (= (ControlFlow 0 32961) 32875)) inline$$Sub$0$Entry_correct))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@2 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 32774) 35319) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 32774) 32961) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)) $MAX_U64) (= (ControlFlow 0 32772) 32774)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1))))) (and (= $abort_flag@0@@2 false) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 32716) 35319) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 32716) 32961) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 32686) (- 0 66399)) true) (and (=> (= (ControlFlow 0 32686) 32772) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 32686) 32716) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $TestPackUnpack_S_value)) (= (ControlFlow 0 32587) 32686)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon4$9_correct  (and (=> (= (ControlFlow 0 32593) (- 0 66372)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 32593) 32587) inline$$GetFieldFromValue$1$anon0_correct)))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@2)) (= (ControlFlow 0 32527) 32593)) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon4$9_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@2  (=> (= inline$$BorrowField$1$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$1$size@1@@2 (|size#$Path| inline$$BorrowField$1$p@1@@2)) (= inline$$BorrowField$1$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@2) inline$$BorrowField$1$size@1@@2 $TestPackUnpack_R_nested) (+ inline$$BorrowField$1$size@1@@2 1)))) (and (= inline$$BorrowField$1$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$1$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 32489) 32527))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $TestPackUnpack_S_value)) (= (ControlFlow 0 32329) 32489)) inline$$BorrowField$1$anon0_correct@@2)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon4$7_correct  (and (=> (= (ControlFlow 0 32335) (- 0 66249)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 32335) 32329) inline$$GetFieldFromValue$0$anon0_correct@@0)))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@3)) (= (ControlFlow 0 32269) 32335)) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon4$7_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 32231) 32269))) inline$$ReadRef$0$anon0_correct@@1))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$1$anon0_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$1$$before@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@1@@1 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count@0@@4) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 32073) 32231)) inline$$BorrowField$0$anon0_correct@@3))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$1$Entry_correct  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (= (ControlFlow 0 32053) 32073)) inline$$TestPackUnpack_R_$unpack_ref$1$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$1$dst@1@@1 ($Mutation ($Local 3) $EmptyPath r2)) (= (ControlFlow 0 32002) 32053)) inline$$TestPackUnpack_R_$unpack_ref$1$Entry_correct)))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@1  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@0@@4 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 31948) 32002)) inline$$BorrowLoc$1$anon0_correct@@1))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (= (ControlFlow 0 31928) 31948)) inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$0$dst@1@@3 ($Mutation ($Local 2) $EmptyPath r1)) (= (ControlFlow 0 31877) 31928)) inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 31759) 31877)) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 35343) 31877) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 31751) 35343) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 31751) 31759) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 35351) 35343) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 35351) 31759) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 31745) 35351) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 31745) 31751) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestPackUnpack_R_nested)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestPackUnpack_R_nested))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (=> (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (= (ControlFlow 0 35359) 31745)) inline$$TestPackUnpack_move_ref_unchanged_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@5  (=> (and (and (and (and ((_ is $Vector) r1) (let ((va@@27 (|v#$Vector| r1)))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| r1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (and (and (and (and (and ((_ is $Vector) r2) (let ((va@@29 (|v#$Vector| r2)))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| r2)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 31226) 35359)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 65325) 31226)) anon0_correct@@5))))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun r2@@0 () T@$Value)
(declare-fun r1@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $TestPackUnpack_r_count@4@@0 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@4@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@2 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $TestPackUnpack_s_sum@3@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@3| () T@$Value)
(declare-fun $TestPackUnpack_r_count@3@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@2| () T@$Value)
(declare-fun $TestPackUnpack_r_count@2@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@1 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$BorrowField$5$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@0 () Int)
(declare-fun inline$$BorrowField$5$p@2@@0 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@1 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@0 () Int)
(declare-fun inline$$BorrowField$4$p@2@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@3| () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@2 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@3 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@5 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@0 () Int)
(declare-fun inline$$BorrowField$3$p@2@@0 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@3 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@2 () Int)
(declare-fun inline$$BorrowField$2$p@2@@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@3 () Int)
(declare-fun inline$$BorrowField$1$p@2@@3 () T@$Path)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@4 () Int)
(declare-fun inline$$BorrowField$0$p@2@@4 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$1$$before@0@@0 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@5 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 67971) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 39946) (- 0 70353)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)))))))) (and (=> (= (ControlFlow 0 39946) (- 0 70401)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 0)))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 0))))) (and (=> (= (ControlFlow 0 39946) (- 0 70425)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@4@@0 $TestPackUnpack_r_count))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@4@@0 $TestPackUnpack_r_count)))) (=> (= (ControlFlow 0 39946) (- 0 70438)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@4@@0 $TestPackUnpack_s_sum)))))))))))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon7_correct  (=> (and (and (and (= inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@1 $Error) (= inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@1 $Error)) (and (= $TestPackUnpack_s_sum@4@@0 $TestPackUnpack_s_sum) (= inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@2 inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@1))) (and (and (= inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@2 inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@1) (= $TestPackUnpack_r_count@4@@0 $TestPackUnpack_r_count@1@@2)) (and (= $abort_flag@1@@1 true) (= (ControlFlow 0 39912) 39946)))) anon0$2_correct@@5)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 39904) 39912)) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 39920) 39912) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 39898) 39920) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 39898) 39904) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon12_correct  (=> (and (= $TestPackUnpack_s_sum@4@@0 $TestPackUnpack_s_sum@3@@1) (= inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@2|)) (=> (and (and (= inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@3|) (= $TestPackUnpack_r_count@4@@0 $TestPackUnpack_r_count@3@@0)) (and (= $abort_flag@1@@1 $abort_flag@0@@3) (= (ControlFlow 0 39878) 39946))) anon0$2_correct@@5))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 39876) 39878)) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 39886) 39878) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 39866) 39886) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 39866) 39876) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 39894) 39886) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 39894) 39876) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon18_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@2  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|) ($Local 2))) (= |inline$$WritebackToValue$1$vdst'@2@@2| r1@@0)) (and (=> (= (ControlFlow 0 39824) 39894) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 39824) 39866) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@2  (=> (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|) 0 r1@@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|))) (= |inline$$WritebackToValue$1$vdst'@2@@2| |inline$$WritebackToValue$1$vdst'@1@@2|)) (and (=> (= (ControlFlow 0 39850) 39894) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 39850) 39866) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$TestPackUnpack_R_$pack_ref$1$anon0_correct@@0  (=> (= $TestPackUnpack_r_count@3@@0 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@2@@0) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 39727) 39850) inline$$WritebackToValue$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 39727) 39824) inline$$WritebackToValue$1$anon3_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|)) (= (ControlFlow 0 39711) 39727)) inline$$TestPackUnpack_R_$pack_ref$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@0 inline$$WritebackToReference$3$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$3$dst'@2@@0| inline$$BorrowLoc$0$dst@1@@4) (= (ControlFlow 0 39608) 39711)) inline$$TestPackUnpack_R_$pack_ref$1$Entry_correct@@0))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@0 inline$$WritebackToReference$3$srcPath@1@@0)) (= |inline$$WritebackToReference$3$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$WritebackToReference$3$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|))))) (and (= |inline$$WritebackToReference$3$dst'@2@@0| |inline$$WritebackToReference$3$dst'@1@@0|) (= (ControlFlow 0 39664) 39711))) inline$$TestPackUnpack_R_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$WritebackToReference$3$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$3$srcPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (= inline$$WritebackToReference$3$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) (and (=> (= (ControlFlow 0 39572) 39664) inline$$WritebackToReference$3$anon3_Then_correct@@0) (=> (= (ControlFlow 0 39572) 39608) inline$$WritebackToReference$3$anon3_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$1$anon0_correct@@1  (and (=> (= (ControlFlow 0 39431) (- 0 70003)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@3@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@2@@2) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@1)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 39431) 39572)) inline$$WritebackToReference$3$anon0_correct@@0)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$1$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (= (ControlFlow 0 39393) 39431)) inline$$TestPackUnpack_S_$pack_ref$1$anon0_correct@@1)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowField$4$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@2 inline$$WritebackToReference$2$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@2| inline$$BorrowField$4$dst@1@@0) (= (ControlFlow 0 39269) 39393)) inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct@@1))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowField$4$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@2 inline$$WritebackToReference$2$srcPath@1@@2)) (= |inline$$WritebackToReference$2$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@0) inline$$WritebackToReference$2$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@2) (|v#$Mutation| inline$$BorrowField$4$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@2| |inline$$WritebackToReference$2$dst'@1@@2|) (= (ControlFlow 0 39325) 39393))) inline$$TestPackUnpack_S_$pack_ref$1$Entry_correct@@1)))
(let ((inline$$WritebackToReference$2$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= inline$$WritebackToReference$2$dstPath@1@@2 (|p#$Mutation| inline$$BorrowField$4$dst@1@@0))) (and (=> (= (ControlFlow 0 39233) 39325) inline$$WritebackToReference$2$anon3_Then_correct@@2) (=> (= (ControlFlow 0 39233) 39269) inline$$WritebackToReference$2$anon3_Else_correct@@2)))))
(let ((inline$$WriteRef$1$anon0_correct@@2  (=> (and (= |inline$$WriteRef$1$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1@@0) (|p#$Mutation| inline$$BorrowField$5$dst@1@@0) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$t13@1)) (= (ControlFlow 0 39090) 39233)) inline$$WritebackToReference$2$anon0_correct@@2)))
(let ((inline$$BorrowField$5$anon0_correct@@0  (=> (= inline$$BorrowField$5$p@1@@0 (|p#$Mutation| inline$$BorrowField$4$dst@1@@0)) (=> (and (and (= inline$$BorrowField$5$size@1@@0 (|size#$Path| inline$$BorrowField$5$p@1@@0)) (= inline$$BorrowField$5$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@0) inline$$BorrowField$5$size@1@@0 $TestPackUnpack_S_value) (+ inline$$BorrowField$5$size@1@@0 1)))) (and (= inline$$BorrowField$5$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@0) inline$$BorrowField$5$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$4$dst@1@@0))) $TestPackUnpack_S_value))) (= (ControlFlow 0 39031) 39090))) inline$$WriteRef$1$anon0_correct@@2))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$1$anon0_correct@@1  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@2@@2 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum@1@@3) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@1)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 38909) 39031)) inline$$BorrowField$5$anon0_correct@@0))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$1$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$1$$before@0@@1 (|v#$Mutation| inline$$BorrowField$4$dst@1@@0)) (= (ControlFlow 0 38887) 38909)) inline$$TestPackUnpack_S_$unpack_ref$1$anon0_correct@@1)))
(let ((inline$$BorrowField$4$anon0_correct@@0  (=> (= inline$$BorrowField$4$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (=> (and (and (= inline$$BorrowField$4$size@1@@0 (|size#$Path| inline$$BorrowField$4$p@1@@0)) (= inline$$BorrowField$4$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@0) inline$$BorrowField$4$size@1@@0 $TestPackUnpack_R_nested) (+ inline$$BorrowField$4$size@1@@0 1)))) (and (= inline$$BorrowField$4$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$BorrowField$4$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 38835) 38887))) inline$$TestPackUnpack_S_$unpack_ref$1$Entry_correct@@1))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Else$9_correct  (=> (and (= inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$$t13@1 ($Integer 0)) (= (ControlFlow 0 38841) 38835)) inline$$BorrowField$4$anon0_correct@@0)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@3| r2@@0) (= (ControlFlow 0 38681) 38841)) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Else$9_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) 0 r2@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@3| |inline$$WritebackToValue$0$vdst'@1@@3|) (= (ControlFlow 0 38707) 38841))) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Else$9_correct)))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@2  (=> (= $TestPackUnpack_r_count@2@@0 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@1@@2) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 38584) 38707) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 38584) 38681) inline$$WritebackToValue$0$anon3_Else_correct@@3)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (= (ControlFlow 0 38568) 38584)) inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@2| inline$$BorrowLoc$1$dst@1@@2) (= (ControlFlow 0 38465) 38568)) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@2))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2)) (= |inline$$WritebackToReference$1$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) inline$$WritebackToReference$1$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@2| |inline$$WritebackToReference$1$dst'@1@@2|) (= (ControlFlow 0 38521) 38568))) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@2)))
(let ((inline$$WritebackToReference$1$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@2 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (= inline$$WritebackToReference$1$dstPath@1@@2 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@2))) (and (=> (= (ControlFlow 0 38429) 38521) inline$$WritebackToReference$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 38429) 38465) inline$$WritebackToReference$1$anon3_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@3  (and (=> (= (ControlFlow 0 38288) (- 0 69419)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@3)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@3)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@3 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@0@@5) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@3)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 38288) 38429)) inline$$WritebackToReference$1$anon0_correct@@2)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@3 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (= (ControlFlow 0 38250) 38288)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@3)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowField$2$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| inline$$BorrowField$2$dst@1@@2) (= (ControlFlow 0 38126) 38250)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@3))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowField$2$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@2) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| inline$$BorrowField$2$dst@1@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 38182) 38250))) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@3)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| inline$$BorrowField$2$dst@1@@2))) (and (=> (= (ControlFlow 0 38090) 38182) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 38090) 38126) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (and (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@0) (|p#$Mutation| inline$$BorrowField$3$dst@1@@0) inline$$AddU64$0$dst@2@@1)) (= (ControlFlow 0 37947) 38090)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$BorrowField$3$anon0_correct@@0  (=> (= inline$$BorrowField$3$p@1@@0 (|p#$Mutation| inline$$BorrowField$2$dst@1@@2)) (=> (and (and (= inline$$BorrowField$3$size@1@@0 (|size#$Path| inline$$BorrowField$3$p@1@@0)) (= inline$$BorrowField$3$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@0) inline$$BorrowField$3$size@1@@0 $TestPackUnpack_S_value) (+ inline$$BorrowField$3$size@1@@0 1)))) (and (= inline$$BorrowField$3$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@2) inline$$BorrowField$3$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$2$dst@1@@2))) $TestPackUnpack_S_value))) (= (ControlFlow 0 37888) 37947))) inline$$WriteRef$0$anon0_correct@@3))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@3  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@3)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@5 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@3)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 37766) 37888)) inline$$BorrowField$3$anon0_correct@@0))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@3 (|v#$Mutation| inline$$BorrowField$2$dst@1@@2)) (= (ControlFlow 0 37744) 37766)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@3)))
(let ((inline$$BorrowField$2$anon0_correct@@2  (=> (= inline$$BorrowField$2$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@2)) (=> (and (and (= inline$$BorrowField$2$size@1@@2 (|size#$Path| inline$$BorrowField$2$p@1@@2)) (= inline$$BorrowField$2$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@2) inline$$BorrowField$2$size@1@@2 $TestPackUnpack_R_nested) (+ inline$$BorrowField$2$size@1@@2 1)))) (and (= inline$$BorrowField$2$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) inline$$BorrowField$2$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 37692) 37744))) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@3))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 37698) 37692)) inline$$BorrowField$2$anon0_correct@@2)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@3 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 37562) 39898) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 37562) 37698) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1@@0)) $MAX_U64) (= (ControlFlow 0 37560) 37562)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1@@0))) (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1@@0))))) (and (= $abort_flag@0@@3 false) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 37504) 39898) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 37504) 37698) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 37474) (- 0 69003)) true) (and (=> (= (ControlFlow 0 37474) 37560) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 37474) 37504) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $TestPackUnpack_S_value)) (= (ControlFlow 0 37375) 37474)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon4$9_correct  (and (=> (= (ControlFlow 0 37381) (- 0 68976)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 37381) 37375) inline$$GetFieldFromValue$1$anon0_correct@@0)))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@3)) (= (ControlFlow 0 37315) 37381)) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon4$9_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@3  (=> (= inline$$BorrowField$1$p@1@@3 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (=> (and (and (= inline$$BorrowField$1$size@1@@3 (|size#$Path| inline$$BorrowField$1$p@1@@3)) (= inline$$BorrowField$1$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@3) inline$$BorrowField$1$size@1@@3 $TestPackUnpack_R_nested) (+ inline$$BorrowField$1$size@1@@3 1)))) (and (= inline$$BorrowField$1$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$BorrowField$1$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 37277) 37315))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $TestPackUnpack_S_value)) (= (ControlFlow 0 37117) 37277)) inline$$BorrowField$1$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon4$7_correct  (and (=> (= (ControlFlow 0 37123) (- 0 68853)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 37123) 37117) inline$$GetFieldFromValue$0$anon0_correct@@1)))))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@4)) (= (ControlFlow 0 37057) 37123)) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon4$7_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@4  (=> (= inline$$BorrowField$0$p@1@@4 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@4 (|size#$Path| inline$$BorrowField$0$p@1@@4)) (= inline$$BorrowField$0$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@4) inline$$BorrowField$0$size@1@@4 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@4 1)))) (and (= inline$$BorrowField$0$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) inline$$BorrowField$0$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 37019) 37057))) inline$$ReadRef$0$anon0_correct@@2))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$1$anon0_correct@@0  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$1$$before@0@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@1@@2 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count@0@@5) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 36861) 37019)) inline$$BorrowField$0$anon0_correct@@4))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$1$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$1$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2)) (= (ControlFlow 0 36841) 36861)) inline$$TestPackUnpack_R_$unpack_ref$1$anon0_correct@@0)))
(let ((inline$$BorrowLoc$1$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$1$dst@1@@2 ($Mutation ($Local 3) $EmptyPath r2@@0)) (= (ControlFlow 0 36790) 36841)) inline$$TestPackUnpack_R_$unpack_ref$1$Entry_correct@@0)))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@2  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@0@@5 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 36736) 36790)) inline$$BorrowLoc$1$anon0_correct@@2))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@2 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (= (ControlFlow 0 36716) 36736)) inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@2)))
(let ((inline$$BorrowLoc$0$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$0$dst@1@@4 ($Mutation ($Local 2) $EmptyPath r1@@0)) (= (ControlFlow 0 36665) 36716)) inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@2)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 36547) 36665)) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 39928) 36665) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 36539) 39928) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 36539) 36547) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 39936) 39928) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 39936) 36547) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon14_Else_correct))))
(let ((inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 36533) 39936) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 36533) 36539) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestPackUnpack_R_nested)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestPackUnpack_R_nested))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (=> (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@33 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (= (ControlFlow 0 39944) 36533)) inline$$TestPackUnpack_move_ref_unchanged_invariant_incorrect_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@6  (=> (and (and (and (and ((_ is $Vector) r1@@0) (let ((va@@34 (|v#$Vector| r1@@0)))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| r1@@0)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r1@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (and (and (and (and (and ((_ is $Vector) r2@@0) (let ((va@@36 (|v#$Vector| r2@@0)))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| r2@@0)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r2@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 36074) 39944)) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 67971) 36074)) anon0_correct@@6))))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun s () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@5 () T@$Mutation)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 70459) (let ((anon0$2_correct@@6  (=> (= (ControlFlow 0 41332) (- 0 70869)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$$ret1@2)) $TestPackUnpack_S_value))))))))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon8_correct  (=> (and (and (= $abort_flag@0@@4 false) (= inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@2)) (and (= inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$$ret1@2 s) (= (ControlFlow 0 41288) 41332))) anon0$2_correct@@6)))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 41286) 41288)) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 41296) 41288) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41276) 41296) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 41276) 41286) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 41304) 41296) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 41304) 41286) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon10_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 41270) 41304) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 41270) 41276) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon10_Then_correct true))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41228) 41314) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 41228) 41270) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 41238) 41314) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 41238) 41270) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $TestPackUnpack_S_value)) (and (=> (= (ControlFlow 0 41212) 41238) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 41212) 41228) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Else_correct)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 41136) 41212)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 41246) 41212) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 41130) 41246) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 41130) 41136) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Else_correct)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$direct_intra$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@3) (let ((va@@38 (|v#$Vector| inline$$ReadRef$0$v@1@@3)))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 41252) 41130)) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon0_correct)))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon2$3_correct  (and (=> (= (ControlFlow 0 41260) (- 0 70700)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 41260) 41252) inline$$TestPackUnpack_read_S_from_immutable_$direct_intra$0$anon0_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (= (ControlFlow 0 40973) 41260)) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon2$3_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$0$dst@1@@5 ($Mutation ($Local 1) $EmptyPath s)) (= (ControlFlow 0 40935) 40973)) inline$$ReadRef$0$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 40851) 40935)) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 41322) 40935) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 40845) 41322) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 40845) 40851) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (= (ControlFlow 0 41330) 40845)) inline$$TestPackUnpack_private_pass_value_violating_invariant_incorrect_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@7  (=> (and (and (and (and ((_ is $Vector) s) (let ((va@@40 (|v#$Vector| s)))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| s)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s)) $TestPackUnpack_S_value)) $MAX_U64))) (= (ControlFlow 0 40633) 41330)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 70459) 40633)) anon0_correct@@7))))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@3 () T@$Value)
(declare-fun r@@6 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@4 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@5 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowLoc$0$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$0$size@1@@5 () Int)
(declare-fun inline$$BorrowField$0$p@2@@5 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 70895) (let ((anon0$2_correct@@7  (=> (= (ControlFlow 0 42392) (- 0 71439)) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value))))))))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon8_correct  (=> (and (and (= $abort_flag@0@@5 false) (= inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@3)) (and (= inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$$ret1@2 r@@6) (= (ControlFlow 0 42348) 42392))) anon0$2_correct@@7)))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 42346) 42348)) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 42356) 42348) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42336) 42356) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 42336) 42346) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 42364) 42356) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 42364) 42346) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon10_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 42330) 42364) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 42330) 42336) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon10_Then_correct true))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 42288) 42374) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 42288) 42330) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 42298) 42374) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 42298) 42330) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@3  (=> (= inline$$GetFieldFromValue$0$dst@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $TestPackUnpack_S_value)) (and (=> (= (ControlFlow 0 42272) 42298) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 42272) 42288) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 42196) 42272)) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 42306) 42272) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 42190) 42306) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 42190) 42196) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$direct_intra$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@4) (let ((va@@41 (|v#$Vector| inline$$ReadRef$0$v@1@@4)))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 42312) 42190)) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon2$3_correct  (and (=> (= (ControlFlow 0 42320) (- 0 71270)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 42320) 42312) inline$$TestPackUnpack_read_S_from_immutable_$direct_intra$0$anon0_correct@@0)))))
(let ((inline$$ReadRef$0$anon0_correct@@4  (=> (and (= inline$$ReadRef$0$v@1@@4 (|v#$Mutation| inline$$BorrowField$0$dst@1@@5)) (= (ControlFlow 0 42025) 42320)) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon2$3_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@5  (=> (= inline$$BorrowField$0$p@1@@5 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (=> (and (and (= inline$$BorrowField$0$size@1@@5 (|size#$Path| inline$$BorrowField$0$p@1@@5)) (= inline$$BorrowField$0$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@5) inline$$BorrowField$0$size@1@@5 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@5 1)))) (and (= inline$$BorrowField$0$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) inline$$BorrowField$0$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 41987) 42025))) inline$$ReadRef$0$anon0_correct@@4))))
(let ((inline$$BorrowLoc$0$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$0$dst@1@@6 ($Mutation ($Local 1) $EmptyPath r@@6)) (= (ControlFlow 0 41827) 41987)) inline$$BorrowField$0$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 41743) 41827)) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 42382) 41827) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 41737) 42382) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 41737) 41743) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@42 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestPackUnpack_R_nested)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestPackUnpack_R_nested))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_R_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (=> (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@44 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (= (ControlFlow 0 42390) 41737)) inline$$TestPackUnpack_private_select_value_violating_invariant_incorrect_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@8  (=> (and (and (and (and ((_ is $Vector) r@@6) (let ((va@@45 (|v#$Vector| r@@6)))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@6)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@6)) $TestPackUnpack_R_nested)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@6)) $TestPackUnpack_R_nested))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@6)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@6)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@6)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@6)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (= (ControlFlow 0 41497) 42390)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 70895) 41497)) anon0_correct@@8))))
PreconditionGeneratedEntry_correct@@7))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@4| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@4| () T@$Value)
(declare-fun s@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@7 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@4 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@4 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@4| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@6 () T@$Mutation)
(declare-fun v@@14 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@6 () Int)
(declare-fun inline$$BorrowField$0$p@2@@6 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 71469) (let ((inline$$TestPackUnpack_private_update_value_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestPackUnpack_private_update_value_$def_verify$0$anon9_Then_correct true))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@4  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|) ($Local 2))) (and (=> (= (ControlFlow 0 43414) 43466) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 43414) 43456) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@4  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|) 0 s@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|)))) (and (=> (= (ControlFlow 0 43440) 43466) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 43440) 43456) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@4  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@4 inline$$WritebackToReference$0$srcPath@1@@4))) (= |inline$$WritebackToReference$0$dst'@2@@4| inline$$BorrowLoc$0$dst@1@@7)) (and (=> (= (ControlFlow 0 43259) 43440) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 43259) 43414) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@4  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@4 inline$$WritebackToReference$0$srcPath@1@@4)) (and (= |inline$$WritebackToReference$0$dst'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) inline$$WritebackToReference$0$dstPath@1@@4 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@4 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@4|)))) (= |inline$$WritebackToReference$0$dst'@2@@4| |inline$$WritebackToReference$0$dst'@1@@4|))) (and (=> (= (ControlFlow 0 43315) 43440) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 43315) 43414) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@4  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@4 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (= inline$$WritebackToReference$0$dstPath@1@@4 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7))) (and (=> (= (ControlFlow 0 43223) 43315) inline$$WritebackToReference$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 43223) 43259) inline$$WritebackToReference$0$anon3_Else_correct@@4)))))
(let ((inline$$WriteRef$0$anon0_correct@@4  (=> (and (= |inline$$WriteRef$0$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@6) (|p#$Mutation| inline$$BorrowField$0$dst@1@@6) v@@14)) (= (ControlFlow 0 43080) 43223)) inline$$WritebackToReference$0$anon0_correct@@4)))
(let ((inline$$BorrowField$0$anon0_correct@@6  (=> (= inline$$BorrowField$0$p@1@@6 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7)) (=> (and (and (= inline$$BorrowField$0$size@1@@6 (|size#$Path| inline$$BorrowField$0$p@1@@6)) (= inline$$BorrowField$0$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@6) inline$$BorrowField$0$size@1@@6 $TestPackUnpack_S_value) (+ inline$$BorrowField$0$size@1@@6 1)))) (and (= inline$$BorrowField$0$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) inline$$BorrowField$0$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7))) $TestPackUnpack_S_value))) (= (ControlFlow 0 43021) 43080))) inline$$WriteRef$0$anon0_correct@@4))))
(let ((inline$$BorrowLoc$0$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$0$dst@1@@7 ($Mutation ($Local 2) $EmptyPath s@@0)) (= (ControlFlow 0 42897) 43021)) inline$$BorrowField$0$anon0_correct@@6)))
(let ((inline$$TestPackUnpack_private_update_value_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 42779) 42897)) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$TestPackUnpack_private_update_value_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 43474) 42897) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$TestPackUnpack_private_update_value_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42771) 43474) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 42771) 42779) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestPackUnpack_private_update_value_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 43482) 43474) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 43482) 42779) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestPackUnpack_private_update_value_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 42765) 43482) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 42765) 42771) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@9  (=> (and (and (and (and ((_ is $Vector) s@@0) (let ((va@@47 (|v#$Vector| s@@0)))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| s@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@0)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@0)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@0)) $TestPackUnpack_S_value)) $MAX_U64))) (and (and (and ((_ is $Integer) v@@14) (>= (|i#$Integer| v@@14) 0)) (<= (|i#$Integer| v@@14) $MAX_U64)) (= (ControlFlow 0 42600) 42765))) inline$$TestPackUnpack_private_update_value_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 71469) 42600)) anon0_correct@@9))))
PreconditionGeneratedEntry_correct@@8))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@4 () T@$Value)
(declare-fun s@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 71965) (let ((inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon6_Then_correct true))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@4  (=> (= inline$$GetFieldFromValue$0$dst@1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@1)) $TestPackUnpack_S_value)) (and (=> (= (ControlFlow 0 43906) 43932) inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 43906) 43922) inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 43830) 43906)) inline$$GetFieldFromValue$0$anon0_correct@@4)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 43940) 43906) inline$$GetFieldFromValue$0$anon0_correct@@4)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 43824) 43940) inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 43824) 43830) inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@48 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (= (ControlFlow 0 43946) 43824)) inline$$TestPackUnpack_read_S_from_immutable_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@10  (=> (and (and (and (and (and ((_ is $Vector) s@@1) (let ((va@@49 (|v#$Vector| s@@1)))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| s@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@1)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@1)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@1)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| s@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 43689) 43946)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@9  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 71965) 43689)) anon0_correct@@10))))
PreconditionGeneratedEntry_correct@@9))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$ReadRef$0$v@1@@5 () T@$Value)
(declare-fun r@@7 () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@3 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@4 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@6 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@3 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@8 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@4 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@6 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@7 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@4 () Int)
(declare-fun inline$$BorrowField$1$p@2@@4 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@4 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@7 () Int)
(declare-fun inline$$BorrowField$0$p@2@@7 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@3 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 72131) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 45040) (- 0 72779)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ReadRef$0$v@1@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ReadRef$0$v@1@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 45040) (- 0 72800)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@1@@3 $TestPackUnpack_r_count))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@1@@3 $TestPackUnpack_r_count)))) (=> (= (ControlFlow 0 45040) (- 0 72813)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@1@@4 $TestPackUnpack_s_sum)))))))))))
(let ((inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 45004) 45040)) anon0$2_correct@@8)))
(let ((inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 45014) 45040) anon0$2_correct@@8)))
(let ((inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon8_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 44994) 45014) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 44994) 45004) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon8_Then_correct  (and (=> (= (ControlFlow 0 45022) 45014) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 45022) 45004) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon9_Else_correct))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@3  (=> (= $TestPackUnpack_r_count@1@@3 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@0@@6) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 44980) 45022) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 44980) 44994) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)) (= (ControlFlow 0 44964) 44980)) inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@4  (and (=> (= (ControlFlow 0 44919) (- 0 72680)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@4)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@4)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@4 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@0@@6) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@4)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 44919) 44964)) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@3)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@4 (|v#$Mutation| inline$$BorrowField$0$dst@1@@7)) (= (ControlFlow 0 44881) 44919)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@4)))
(let ((inline$$ReadRef$0$anon0_correct@@5  (=> (and (= inline$$ReadRef$0$v@1@@5 (|v#$Mutation| inline$$BorrowField$1$dst@1@@4)) (= (ControlFlow 0 44805) 44881)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@4)))
(let ((inline$$BorrowField$1$anon0_correct@@4  (=> (= inline$$BorrowField$1$p@1@@4 (|p#$Mutation| inline$$BorrowField$0$dst@1@@7)) (=> (and (and (= inline$$BorrowField$1$size@1@@4 (|size#$Path| inline$$BorrowField$1$p@1@@4)) (= inline$$BorrowField$1$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@4) inline$$BorrowField$1$size@1@@4 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@4 1)))) (and (= inline$$BorrowField$1$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@7) inline$$BorrowField$1$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@7))) $TestPackUnpack_S_value))) (= (ControlFlow 0 44767) 44805))) inline$$ReadRef$0$anon0_correct@@5))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@4  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@4)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@6 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@4)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 44609) 44767)) inline$$BorrowField$1$anon0_correct@@4))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@4 (|v#$Mutation| inline$$BorrowField$0$dst@1@@7)) (= (ControlFlow 0 44587) 44609)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@4)))
(let ((inline$$BorrowField$0$anon0_correct@@7  (=> (= inline$$BorrowField$0$p@1@@7 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@8)) (=> (and (and (= inline$$BorrowField$0$size@1@@7 (|size#$Path| inline$$BorrowField$0$p@1@@7)) (= inline$$BorrowField$0$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@7) inline$$BorrowField$0$size@1@@7 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@7 1)))) (and (= inline$$BorrowField$0$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@8) inline$$BorrowField$0$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 44535) 44587))) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@4))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@3  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@3)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@0@@6 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 44413) 44535)) inline$$BorrowField$0$anon0_correct@@7))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@3  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)) (= (ControlFlow 0 44393) 44413)) inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@3)))
(let ((inline$$BorrowLoc$0$anon0_correct@@8  (=> (and (= inline$$BorrowLoc$0$dst@1@@8 ($Mutation ($Local 3) $EmptyPath r@@7)) (= (ControlFlow 0 44342) 44393)) inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@3)))
(let ((inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 44258) 44342)) inline$$BorrowLoc$0$anon0_correct@@8)))
(let ((inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 45030) 44342) inline$$BorrowLoc$0$anon0_correct@@8)))
(let ((inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 44252) 45030) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 44252) 44258) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@50 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (= (ControlFlow 0 45038) 44252)) inline$$TestPackUnpack_read_ref_unchanged_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@11  (=> (and (and (and (and (and ((_ is $Vector) r@@7) (let ((va@@51 (|v#$Vector| r@@7)))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@7)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@7)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 44039) 45038)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@10  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 72131) 44039)) anon0_correct@@11))))
PreconditionGeneratedEntry_correct@@10))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@5 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@5| () T@$Value)
(declare-fun r@@8 () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@4 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@7 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@4 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@9 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@5 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@5 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@7 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@8 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@5 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@5 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@5| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@5 () T@$Mutation)
(declare-fun inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@5 () Int)
(declare-fun inline$$BorrowField$1$p@2@@5 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@5 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@8 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@8 () Int)
(declare-fun inline$$BorrowField$0$p@2@@8 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 72834) (let ((anon0$2_correct@@9  (=> (= (ControlFlow 0 47279) (- 0 73989)) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 ($Integer 0))))))))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon10_correct  (=> (= $abort_flag@0@@6 false) (=> (and (= inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@5) (= (ControlFlow 0 47225) 47279)) anon0$2_correct@@9))))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 47223) 47225)) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 47233) 47225) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon14_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 47213) 47233) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 47213) 47223) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon14_Then_correct  (and (=> (= (ControlFlow 0 47241) 47233) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 47241) 47223) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon15_Else_correct))))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon13_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 47207) 47241) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 47207) 47213) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon13_Then_correct true))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 47165) 47251) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 47165) 47207) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Then_correct@@1  (and (=> (= (ControlFlow 0 47175) 47251) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 47175) 47207) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon13_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@5  (=> (= inline$$GetFieldFromValue$0$dst@1@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $TestPackUnpack_S_value)) (and (=> (= (ControlFlow 0 47149) 47175) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 47149) 47165) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 47073) 47149)) inline$$GetFieldFromValue$0$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 47183) 47149) inline$$GetFieldFromValue$0$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon0_correct@@1  (=> (not false) (and (=> (= (ControlFlow 0 47067) 47183) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 47067) 47073) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_read_S_from_immutable_$direct_intra$0$anon0_correct@@1  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@6) (let ((va@@53 (|v#$Vector| inline$$ReadRef$0$v@1@@6)))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 47189) 47067)) inline$$TestPackUnpack_read_S_from_immutable_$def$0$anon0_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@5  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) ($Local 2))) (= (ControlFlow 0 46888) 47189)) inline$$TestPackUnpack_read_S_from_immutable_$direct_intra$0$anon0_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@5  (=> (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) 0 r@@8 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|))) (= (ControlFlow 0 46914) 47189)) inline$$TestPackUnpack_read_S_from_immutable_$direct_intra$0$anon0_correct@@1))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@4  (=> (= $TestPackUnpack_r_count@1@@4 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@0@@7) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 46791) 46914) inline$$WritebackToValue$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 46791) 46888) inline$$WritebackToValue$0$anon3_Else_correct@@5)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@4 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|)) (= (ControlFlow 0 46775) 46791)) inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@4)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@9) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@3| inline$$BorrowLoc$0$dst@1@@9) (= (ControlFlow 0 46672) 46775)) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@4))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@9) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3)) (= |inline$$WritebackToReference$1$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@9) inline$$WritebackToReference$1$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@3| |inline$$WritebackToReference$1$dst'@1@@3|) (= (ControlFlow 0 46728) 46775))) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@4)))
(let ((inline$$WritebackToReference$1$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@3 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|)) (= inline$$WritebackToReference$1$dstPath@1@@3 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) (and (=> (= (ControlFlow 0 46636) 46728) inline$$WritebackToReference$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 46636) 46672) inline$$WritebackToReference$1$anon3_Else_correct@@3)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@5  (and (=> (= (ControlFlow 0 46495) (- 0 73596)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@5)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@5)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@5 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@0@@7) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@5)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 46495) 46636)) inline$$WritebackToReference$1$anon0_correct@@3)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@5  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@5 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|)) (= (ControlFlow 0 46457) 46495)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon4$2_correct  (and (=> (= (ControlFlow 0 46499) (- 0 73582)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 46499) 46457) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@5)))))
(let ((inline$$ReadRef$0$anon0_correct@@6  (=> (and (= inline$$ReadRef$0$v@1@@6 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|)) (= (ControlFlow 0 46385) 46499)) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon4$2_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@5  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowField$0$dst@1@@8) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@5 inline$$WritebackToReference$0$srcPath@1@@5))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@5| inline$$BorrowField$0$dst@1@@8) (= (ControlFlow 0 46291) 46385)) inline$$ReadRef$0$anon0_correct@@6))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@5  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowField$0$dst@1@@8) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@5 inline$$WritebackToReference$0$srcPath@1@@5)) (= |inline$$WritebackToReference$0$dst'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@8) inline$$WritebackToReference$0$dstPath@1@@5 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@5 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|v#$Mutation| inline$$BorrowField$0$dst@1@@8) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@5| |inline$$WritebackToReference$0$dst'@1@@5|) (= (ControlFlow 0 46347) 46385))) inline$$ReadRef$0$anon0_correct@@6)))
(let ((inline$$WritebackToReference$0$anon0_correct@@5  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@5 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (= inline$$WritebackToReference$0$dstPath@1@@5 (|p#$Mutation| inline$$BorrowField$0$dst@1@@8))) (and (=> (= (ControlFlow 0 46255) 46347) inline$$WritebackToReference$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 46255) 46291) inline$$WritebackToReference$0$anon3_Else_correct@@5)))))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 46118) 46255)) inline$$WritebackToReference$0$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct  (=> (and (= inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@8)) (= (ControlFlow 0 47261) 46255)) inline$$WritebackToReference$0$anon0_correct@@5)))
(let ((inline$$WriteRef$0$anon0_correct@@5  (=> (= |inline$$WriteRef$0$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@5) (|p#$Mutation| inline$$BorrowField$1$dst@1@@5) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$t4@1)) (and (=> (= (ControlFlow 0 46104) 47261) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 46104) 46118) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@5  (=> (= inline$$BorrowField$1$p@1@@5 (|p#$Mutation| inline$$BorrowField$0$dst@1@@8)) (=> (and (and (= inline$$BorrowField$1$size@1@@5 (|size#$Path| inline$$BorrowField$1$p@1@@5)) (= inline$$BorrowField$1$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@5) inline$$BorrowField$1$size@1@@5 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@5 1)))) (and (= inline$$BorrowField$1$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@8) inline$$BorrowField$1$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@8))) $TestPackUnpack_S_value))) (= (ControlFlow 0 46045) 46104))) inline$$WriteRef$0$anon0_correct@@5))))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon2$5_correct  (=> (and (= inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 46051) 46045)) inline$$BorrowField$1$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@5  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@5)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@7 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@5)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 45919) 46051)) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon2$5_correct))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@5  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@5 (|v#$Mutation| inline$$BorrowField$0$dst@1@@8)) (= (ControlFlow 0 45897) 45919)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@5)))
(let ((inline$$BorrowField$0$anon0_correct@@8  (=> (= inline$$BorrowField$0$p@1@@8 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@9)) (=> (and (and (= inline$$BorrowField$0$size@1@@8 (|size#$Path| inline$$BorrowField$0$p@1@@8)) (= inline$$BorrowField$0$p@2@@8 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@8) inline$$BorrowField$0$size@1@@8 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@8 1)))) (and (= inline$$BorrowField$0$dst@1@@8 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@9) inline$$BorrowField$0$p@2@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 45845) 45897))) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@5))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@4  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@4)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@0@@7 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 45723) 45845)) inline$$BorrowField$0$anon0_correct@@8))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@4  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@4 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9)) (= (ControlFlow 0 45703) 45723)) inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@4)))
(let ((inline$$BorrowLoc$0$anon0_correct@@9  (=> (and (= inline$$BorrowLoc$0$dst@1@@9 ($Mutation ($Local 2) $EmptyPath r@@8)) (= (ControlFlow 0 45652) 45703)) inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@4)))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 45568) 45652)) inline$$BorrowLoc$0$anon0_correct@@9)))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 47269) 45652) inline$$BorrowLoc$0$anon0_correct@@9)))
(let ((inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 45562) 47269) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 45562) 45568) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@54 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (= (ControlFlow 0 47277) 45562)) inline$$TestPackUnpack_select_value_violating_invariant_incorrect_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@12  (=> (and (and (and (and (and ((_ is $Vector) r@@8) (let ((va@@55 (|v#$Vector| r@@8)))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@8)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@8)) $TestPackUnpack_R_nested)) (let ((va@@56 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@8)) $TestPackUnpack_R_nested))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@8)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 45255) 47277)) anon0$1_correct@@6)))
(let ((PreconditionGeneratedEntry_correct@@11  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 72834) 45255)) anon0_correct@@12))))
PreconditionGeneratedEntry_correct@@11)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun r@@9 () T@$Value)
(declare-fun $TestPackUnpack_r_count@2@@1 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2@@3 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@8 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@8 () T@$Value)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun inline$$ReadRef$1$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@4| () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@5 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@4| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@6| () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@5 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@10 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@6| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@4 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@4 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@4| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@6 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@1 () Int)
(declare-fun inline$$BorrowField$3$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$dst@1@@9 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@6| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@6 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@6 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@6| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@3 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@3 () Int)
(declare-fun inline$$BorrowField$2$p@2@@3 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@7 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@6 () Int)
(declare-fun inline$$BorrowField$1$p@2@@6 () T@$Path)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@6 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@9 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@9 () Int)
(declare-fun inline$$BorrowField$0$p@2@@9 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 74014) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 50019) (- 0 75536)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)))))) (=> (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 50019) (- 0 75557)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 2))))))))) (=> (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 50019) (- 0 75599)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@2@@1 $TestPackUnpack_r_count))))) (=> (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@2@@1 $TestPackUnpack_r_count)))) (=> (= (ControlFlow 0 50019) (- 0 75612)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@2@@3 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| ($Integer 2)))))))))))))))))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon5_correct  (=> (and (and (and (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@1 $Error) (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@1 $Error)) (and (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@2 inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@1) (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@2 inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@1))) (and (and (= $TestPackUnpack_r_count@2@@1 $TestPackUnpack_r_count@0@@8) (= $TestPackUnpack_s_sum@2@@3 $TestPackUnpack_s_sum@0@@8)) (and (= $abort_flag@1@@2 true) (= (ControlFlow 0 49993) 50019)))) anon0$2_correct@@10)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 49985) 49993)) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon5_correct)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 50001) 49993) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon5_correct)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 49979) 50001) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 49979) 49985) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon12_correct  (=> (and (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret0@2 inline$$ReadRef$1$v@1@@1) (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@4|)) (=> (and (and (= $TestPackUnpack_r_count@2@@1 $TestPackUnpack_r_count@1@@5) (= $TestPackUnpack_s_sum@2@@3 $TestPackUnpack_s_sum@1@@6)) (and (= $abort_flag@1@@2 $abort_flag@0@@7) (= (ControlFlow 0 49949) 50019))) anon0$2_correct@@10))))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 49947) 49949)) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon12_correct)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 49957) 49949) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon12_correct)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 49937) 49957) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 49937) 49947) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 49965) 49957) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 49965) 49947) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon18_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@6  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@4| r@@9)) (and (=> (= (ControlFlow 0 49895) 49965) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 49895) 49937) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@6  (=> (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@6| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) 0 r@@9 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|))) (= |inline$$WritebackToValue$0$vdst'@2@@4| |inline$$WritebackToValue$0$vdst'@1@@6|)) (and (=> (= (ControlFlow 0 49921) 49965) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 49921) 49937) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@5  (=> (= $TestPackUnpack_r_count@1@@5 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@0@@8) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 49798) 49921) inline$$WritebackToValue$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 49798) 49895) inline$$WritebackToValue$0$anon3_Else_correct@@6)))))
(let ((inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@5  (=> (and (= inline$$TestPackUnpack_R_$pack_ref$0$$after@0@@5 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)) (= (ControlFlow 0 49782) 49798)) inline$$TestPackUnpack_R_$pack_ref$0$anon0_correct@@5)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@4  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@4 inline$$WritebackToReference$1$srcPath@1@@4))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@4| inline$$BorrowLoc$0$dst@1@@10) (= (ControlFlow 0 49679) 49782)) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@5))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@4  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@4 inline$$WritebackToReference$1$srcPath@1@@4)) (= |inline$$WritebackToReference$1$dst'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) inline$$WritebackToReference$1$dstPath@1@@4 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@4 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@4| |inline$$WritebackToReference$1$dst'@1@@4|) (= (ControlFlow 0 49735) 49782))) inline$$TestPackUnpack_R_$pack_ref$0$Entry_correct@@5)))
(let ((inline$$WritebackToReference$1$anon0_correct@@4  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@4 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (= inline$$WritebackToReference$1$dstPath@1@@4 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10))) (and (=> (= (ControlFlow 0 49643) 49735) inline$$WritebackToReference$1$anon3_Then_correct@@4) (=> (= (ControlFlow 0 49643) 49679) inline$$WritebackToReference$1$anon3_Else_correct@@4)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@6  (and (=> (= (ControlFlow 0 49502) (- 0 75187)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@6)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@6)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@6 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@0@@8) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@6)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 49502) 49643)) inline$$WritebackToReference$1$anon0_correct@@4)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@6  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@6 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (= (ControlFlow 0 49464) 49502)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@6)))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@1@@1 (|v#$Mutation| inline$$BorrowField$3$dst@1@@1)) (= (ControlFlow 0 49388) 49464)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@6)))
(let ((inline$$BorrowField$3$anon0_correct@@1  (=> (= inline$$BorrowField$3$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (=> (and (and (= inline$$BorrowField$3$size@1@@1 (|size#$Path| inline$$BorrowField$3$p@1@@1)) (= inline$$BorrowField$3$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@1) inline$$BorrowField$3$size@1@@1 $TestPackUnpack_S_value) (+ inline$$BorrowField$3$size@1@@1 1)))) (and (= inline$$BorrowField$3$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) inline$$BorrowField$3$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|))) $TestPackUnpack_S_value))) (= (ControlFlow 0 49350) 49388))) inline$$ReadRef$1$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@6  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowField$0$dst@1@@9) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@6 inline$$WritebackToReference$0$srcPath@1@@6))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@6| inline$$BorrowField$0$dst@1@@9) (= (ControlFlow 0 49134) 49350)) inline$$BorrowField$3$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@6  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowField$0$dst@1@@9) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@6 inline$$WritebackToReference$0$srcPath@1@@6)) (= |inline$$WritebackToReference$0$dst'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@9) inline$$WritebackToReference$0$dstPath@1@@6 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@6 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|v#$Mutation| inline$$BorrowField$0$dst@1@@9) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@6|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@6| |inline$$WritebackToReference$0$dst'@1@@6|) (= (ControlFlow 0 49190) 49350))) inline$$BorrowField$3$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@6  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@6 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@6|)) (= inline$$WritebackToReference$0$dstPath@1@@6 (|p#$Mutation| inline$$BorrowField$0$dst@1@@9))) (and (=> (= (ControlFlow 0 49098) 49190) inline$$WritebackToReference$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 49098) 49134) inline$$WritebackToReference$0$anon3_Else_correct@@6)))))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 48961) 49098)) inline$$WritebackToReference$0$anon0_correct@@6)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon16_Then_correct  (=> (and (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@9)) (= (ControlFlow 0 49975) 49098)) inline$$WritebackToReference$0$anon0_correct@@6)))
(let ((inline$$WriteRef$0$anon0_correct@@6  (=> (= |inline$$WriteRef$0$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@3) (|p#$Mutation| inline$$BorrowField$2$dst@1@@3) inline$$AddU64$0$dst@2@@2)) (and (=> (= (ControlFlow 0 48947) 49975) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 48947) 48961) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct@@3  (=> (= inline$$BorrowField$2$p@1@@3 (|p#$Mutation| inline$$BorrowField$0$dst@1@@9)) (=> (and (and (= inline$$BorrowField$2$size@1@@3 (|size#$Path| inline$$BorrowField$2$p@1@@3)) (= inline$$BorrowField$2$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@3) inline$$BorrowField$2$size@1@@3 $TestPackUnpack_S_value) (+ inline$$BorrowField$2$size@1@@3 1)))) (and (= inline$$BorrowField$2$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@9) inline$$BorrowField$2$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@9))) $TestPackUnpack_S_value))) (= (ControlFlow 0 48888) 48947))) inline$$WriteRef$0$anon0_correct@@6))))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@0@@7) (= (ControlFlow 0 48894) 48888)) inline$$BorrowField$2$anon0_correct@@3)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@7 true) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@0@@2)) (and (=> (= (ControlFlow 0 48758) 49979) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 48758) 48894) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@7) (|i#$Integer| inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$t6@1)) $MAX_U64) (= (ControlFlow 0 48756) 48758)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@7) (|i#$Integer| inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$t6@1))) (= inline$$AddU64$0$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@7) (|i#$Integer| inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$t6@1))))) (and (= $abort_flag@0@@7 false) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@1@@2))) (and (=> (= (ControlFlow 0 48700) 49979) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 48700) 48894) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 48670) (- 0 74761)) true) (and (=> (= (ControlFlow 0 48670) 48756) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 48670) 48700) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon2$6_correct  (=> (and (= inline$$TestPackUnpack_update_ref_changed_$def_verify$0$$t6@1 ($Integer 2)) (= (ControlFlow 0 48764) 48670)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$ReadRef$0$anon0_correct@@7  (=> (and (= inline$$ReadRef$0$v@1@@7 (|v#$Mutation| inline$$BorrowField$1$dst@1@@6)) (= (ControlFlow 0 48559) 48764)) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon2$6_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@6  (=> (= inline$$BorrowField$1$p@1@@6 (|p#$Mutation| inline$$BorrowField$0$dst@1@@9)) (=> (and (and (= inline$$BorrowField$1$size@1@@6 (|size#$Path| inline$$BorrowField$1$p@1@@6)) (= inline$$BorrowField$1$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@6) inline$$BorrowField$1$size@1@@6 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@6 1)))) (and (= inline$$BorrowField$1$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@9) inline$$BorrowField$1$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@9))) $TestPackUnpack_S_value))) (= (ControlFlow 0 48521) 48559))) inline$$ReadRef$0$anon0_correct@@7))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@6  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@6)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@8 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@6)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 48363) 48521)) inline$$BorrowField$1$anon0_correct@@6))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@6  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@6 (|v#$Mutation| inline$$BorrowField$0$dst@1@@9)) (= (ControlFlow 0 48341) 48363)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@6)))
(let ((inline$$BorrowField$0$anon0_correct@@9  (=> (= inline$$BorrowField$0$p@1@@9 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10)) (=> (and (and (= inline$$BorrowField$0$size@1@@9 (|size#$Path| inline$$BorrowField$0$p@1@@9)) (= inline$$BorrowField$0$p@2@@9 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@9) inline$$BorrowField$0$size@1@@9 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@9 1)))) (and (= inline$$BorrowField$0$dst@1@@9 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) inline$$BorrowField$0$p@2@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 48289) 48341))) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@6))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@5  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@5)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@0@@8 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 48167) 48289)) inline$$BorrowField$0$anon0_correct@@9))))
(let ((inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@5  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref$0$$before@0@@5 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10)) (= (ControlFlow 0 48147) 48167)) inline$$TestPackUnpack_R_$unpack_ref$0$anon0_correct@@5)))
(let ((inline$$BorrowLoc$0$anon0_correct@@10  (=> (and (= inline$$BorrowLoc$0$dst@1@@10 ($Mutation ($Local 3) $EmptyPath r@@9)) (= (ControlFlow 0 48096) 48147)) inline$$TestPackUnpack_R_$unpack_ref$0$Entry_correct@@5)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 48012) 48096)) inline$$BorrowLoc$0$anon0_correct@@10)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 50009) 48096) inline$$BorrowLoc$0$anon0_correct@@10)))
(let ((inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 48006) 50009) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 48006) 48012) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (and (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@57 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestPackUnpack_S_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (= (ControlFlow 0 50017) 48006)) inline$$TestPackUnpack_update_ref_changed_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@13  (=> (and (and (and (and (and ((_ is $Vector) r@@9) (let ((va@@58 (|v#$Vector| r@@9)))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@9)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 47656) 50017)) anon0$1_correct@@7)))
(let ((PreconditionGeneratedEntry_correct@@12  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 74014) 47656)) anon0_correct@@13))))
PreconditionGeneratedEntry_correct@@12)))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $TestPackUnpack_r_count@3@@1 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@3@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@5| () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2@@4 () T@$Value)
(declare-fun $TestPackUnpack_r_count@2@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@7| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_R_pack$0$$struct@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@7| () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@6 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@7 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@7 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@7| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@7 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@7 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@7| () T@$Mutation)
(declare-fun |inline$$Splice1$0$dst'@1| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@7 () T@$Mutation)
(declare-fun inline$$BorrowLoc$0$dst@1@@11 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@8 () T@$Value)
(declare-fun inline$$TestPackUnpack_get_value_ref_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$0$dst@1@@10 () T@$Mutation)
(declare-fun inline$$BorrowField$1$size@1@@7 () Int)
(declare-fun inline$$BorrowField$1$p@2@@7 () T@$Path)
(declare-fun inline$$BorrowField$0$p@1@@10 () T@$Path)
(declare-fun inline$$BorrowLoc$1$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$0$size@1@@10 () Int)
(declare-fun inline$$BorrowField$0$p@2@@10 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@9 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@7 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@9 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 75643) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 52856) (- 0 77053)) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 2)))))) (=> (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 2))))) (and (=> (= (ControlFlow 0 52856) (- 0 77077)) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@3@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@3@@1 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1)))))))) (=> (= (ControlFlow 0 52856) (- 0 77102)) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@3@@2 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| ($Integer 2)))))))))))))))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon8_correct  (=> (= $abort_flag@0@@8 false) (=> (and (and (= inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@5|) (= $TestPackUnpack_s_sum@3@@2 $TestPackUnpack_s_sum@2@@4)) (and (= $TestPackUnpack_r_count@3@@1 $TestPackUnpack_r_count@2@@2) (= (ControlFlow 0 52814) 52856))) anon0$2_correct@@11))))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 52812) 52814)) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon8_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 52822) 52814) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon8_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@7  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|) ($Local 0))) (= |inline$$WritebackToValue$0$vdst'@2@@5| inline$$TestPackUnpack_R_pack$0$$struct@1@@0)) (and (=> (= (ControlFlow 0 52770) 52822) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 52770) 52812) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@7  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@7| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|) 0 inline$$TestPackUnpack_R_pack$0$$struct@1@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|))) (= |inline$$WritebackToValue$0$vdst'@2@@5| |inline$$WritebackToValue$0$vdst'@1@@7|)) (and (=> (= (ControlFlow 0 52796) 52822) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 52796) 52812) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestPackUnpack_R_$pack_ref_deep$0$anon0$1_correct  (=> (= $TestPackUnpack_r_count@2@@2 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@1@@6) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 52673) 52796) inline$$WritebackToValue$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 52673) 52770) inline$$WritebackToValue$0$anon3_Else_correct@@7)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@7  (and (=> (= (ControlFlow 0 52653) (- 0 76888)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@7)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@7)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@2@@4 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@1@@7) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@7)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 52653) 52673)) inline$$TestPackUnpack_R_$pack_ref_deep$0$anon0$1_correct)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@7  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0)) $TestPackUnpack_R_nested)) (= (ControlFlow 0 52615) 52653)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@7)))
(let ((inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct  (=> (and (= inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|)) (= (ControlFlow 0 52551) 52615)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@7)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@7  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@7 inline$$WritebackToReference$0$srcPath@1@@7))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@7| |inline$$WriteRef$0$to'@1@@7|) (= (ControlFlow 0 52435) 52551)) inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@7  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@7 inline$$WritebackToReference$0$srcPath@1@@7)) (= |inline$$WritebackToReference$0$dst'@1@@7| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) inline$$WritebackToReference$0$dstPath@1@@7 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@7 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@7| |inline$$WritebackToReference$0$dst'@1@@7|) (= (ControlFlow 0 52491) 52551))) inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@7  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@7 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@7 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@7|))) (and (=> (= (ControlFlow 0 52399) 52491) inline$$WritebackToReference$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 52399) 52435) inline$$WritebackToReference$0$anon3_Else_correct@@7)))))
(let ((inline$$WriteRef$1$anon0_correct@@3  (=> (and (= |inline$$WriteRef$1$to'@1@@3| ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1|) (|p#$Mutation| |inline$$Splice1$0$dst'@1|) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t7@1)) (= (ControlFlow 0 52256) 52399)) inline$$WritebackToReference$0$anon0_correct@@7)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon6_correct  (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t7@1 ($Integer 2)) (= (ControlFlow 0 52262) 52256)) inline$$WriteRef$1$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 52199) 52262)) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon6_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon11_Then_correct  (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$Splice1$0$dst'@1|)) (= (ControlFlow 0 52832) 52262)) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon6_correct)))
(let ((inline$$Splice1$0$anon0_correct  (=> (= |inline$$Splice1$0$dst'@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) ($ConcatPath_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@7|) (|p#$Mutation| inline$$BorrowField$1$dst@1@@7)) (|v#$Mutation| inline$$BorrowField$1$dst@1@@7))) (and (=> (= (ControlFlow 0 52151) 52832) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 52151) 52199) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@7  (=> (and (= |inline$$WriteRef$0$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@11) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@11) inline$$ReadRef$0$v@1@@8)) (= (ControlFlow 0 52070) 52151)) inline$$Splice1$0$anon0_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon10_Else_correct  (=> (and (not false) (= (ControlFlow 0 52076) 52070)) inline$$WriteRef$0$anon0_correct@@7)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon10_Then_correct true))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 51965) 52840) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 51965) 52076) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 51975) 52840) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 51975) 52076) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 51955) 51975) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 51955) 51965) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct)))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Then_correct  (=> (= inline$$TestPackUnpack_get_value_ref_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@7)) (and (=> (= (ControlFlow 0 51985) 51975) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 51985) 51965) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@7  (=> (and (and (= inline$$BorrowField$1$p@1@@7 (|p#$Mutation| inline$$BorrowField$0$dst@1@@10)) (= inline$$BorrowField$1$size@1@@7 (|size#$Path| inline$$BorrowField$1$p@1@@7))) (and (= inline$$BorrowField$1$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@7) inline$$BorrowField$1$size@1@@7 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@7 1))) (= inline$$BorrowField$1$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@10) inline$$BorrowField$1$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@10))) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 51939) 51985) inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 51939) 51955) inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@10  (=> (= inline$$BorrowField$0$p@1@@10 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@10 (|size#$Path| inline$$BorrowField$0$p@1@@10)) (= inline$$BorrowField$0$p@2@@10 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@10) inline$$BorrowField$0$size@1@@10 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@10 1)))) (and (= inline$$BorrowField$0$dst@1@@10 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) inline$$BorrowField$0$p@2@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 51815) 51939))) inline$$BorrowField$1$anon0_correct@@7))))
(let ((inline$$BorrowLoc$1$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$1$dst@1@@3 ($Mutation ($Local 1) $EmptyPath inline$$ReadRef$0$v@1@@8)) (= (ControlFlow 0 51691) 51815)) inline$$BorrowField$0$anon0_correct@@10)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 51607) 51691)) inline$$BorrowLoc$1$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 51993) 51691) inline$$BorrowLoc$1$anon0_correct@@3)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 51601) 51993) inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 51601) 51607) inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Else_correct)))))
(let ((inline$$TestPackUnpack_get_value_ref_$direct_intra$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@8) (let ((va@@60 (|v#$Vector| inline$$ReadRef$0$v@1@@8)))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (= (ControlFlow 0 52001) 51601)) inline$$TestPackUnpack_get_value_ref_$def$0$anon0_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon2$3_correct  (and (=> (= (ControlFlow 0 52011) (- 0 76337)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 52011) 52001) inline$$TestPackUnpack_get_value_ref_$direct_intra$0$anon0_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@8  (=> (and (= inline$$ReadRef$0$v@1@@8 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@11)) (= (ControlFlow 0 51389) 52011)) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon2$3_correct)))
(let ((inline$$TestPackUnpack_R_$unpack_ref_deep$0$anon0$1_correct  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@1@@6 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count@0@@9) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 51353) 51389)) inline$$ReadRef$0$anon0_correct@@8))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@7  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@7)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@7 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum@0@@9) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@7)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 51329) 51353)) inline$$TestPackUnpack_R_$unpack_ref_deep$0$anon0$1_correct))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@7  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0)) $TestPackUnpack_R_nested)) (= (ControlFlow 0 51307) 51329)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@7)))
(let ((inline$$TestPackUnpack_R_$unpack_ref_deep$0$Entry_correct  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@11)) (= (ControlFlow 0 51259) 51307)) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@7)))
(let ((inline$$BorrowLoc$0$anon0_correct@@11  (=> (and (= inline$$BorrowLoc$0$dst@1@@11 ($Mutation ($Local 0) $EmptyPath inline$$TestPackUnpack_R_pack$0$$struct@1@@0)) (= (ControlFlow 0 51195) 51259)) inline$$TestPackUnpack_R_$unpack_ref_deep$0$Entry_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 51145) 51195)) inline$$BorrowLoc$0$anon0_correct@@11)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 52848) 51195) inline$$BorrowLoc$0$anon0_correct@@11)))
(let ((inline$$TestPackUnpack_R_pack$0$anon3_correct@@0  (=> (= $TestPackUnpack_r_count@0@@9 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 51111) 52848) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 51111) 51145) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 51125) 51111)) inline$$TestPackUnpack_R_pack$0$anon3_correct@@0)))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 51131) 51111) inline$$TestPackUnpack_R_pack$0$anon3_correct@@0)))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Then_correct@@0  (=> (> 6175 0) (and (=> (= (ControlFlow 0 51119) 51131) inline$$TestPackUnpack_R_pack$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 51119) 51125) inline$$TestPackUnpack_R_pack$0$anon5_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Else_correct@@0  (=> (and (>= 0 6175) (= (ControlFlow 0 51095) 51111)) inline$$TestPackUnpack_R_pack$0$anon3_correct@@0)))
(let ((inline$$TestPackUnpack_R_pack$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) inline$$TestPackUnpack_S_pack$0$$struct@1@@0) (let ((va@@62 (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= inline$$TestPackUnpack_R_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_S_pack$0$$struct@1@@0) 1)))) (and (=> (= (ControlFlow 0 51087) 51119) inline$$TestPackUnpack_R_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 51087) 51095) inline$$TestPackUnpack_R_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon3_correct@@0  (and (=> (= (ControlFlow 0 50909) (- 0 76091)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@9 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@0)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 50909) 51087)) inline$$TestPackUnpack_R_pack$0$anon0_correct@@0)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 50923) 50909)) inline$$TestPackUnpack_S_pack$0$anon3_correct@@0)))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 50929) 50909) inline$$TestPackUnpack_S_pack$0$anon3_correct@@0)))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 50917) 50929) inline$$TestPackUnpack_S_pack$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 50917) 50923) inline$$TestPackUnpack_S_pack$0$anon5_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 50871) 50909)) inline$$TestPackUnpack_S_pack$0$anon3_correct@@0)))
(let ((inline$$TestPackUnpack_S_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestPackUnpack_S_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 50863) 50917) inline$$TestPackUnpack_S_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 50863) 50871) inline$$TestPackUnpack_S_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 50935) 50863)) inline$$TestPackUnpack_S_pack$0$anon0_correct@@0))))
(let ((anon0_correct@@14  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 75643) 50935)) inline$$TestPackUnpack_update_via_returned_ref_$def_verify$0$anon0_correct))))
anon0_correct@@14))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@8| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@8| () T@$Value)
(declare-fun inline$$TestPackUnpack_R_pack$0$$struct@1@@1 () T@$Value)
(declare-fun $TestPackUnpack_r_count@2@@3 () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@7 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@8 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2@@5 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@8 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0@@0 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@8| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@8 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@8 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@8| () T@$Mutation)
(declare-fun |inline$$Splice1$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@8 () T@$Mutation)
(declare-fun inline$$BorrowLoc$0$dst@1@@12 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@9 () T@$Value)
(declare-fun inline$$TestPackUnpack_get_value_ref_$def$0$$trace_temp@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@8 () T@$Path)
(declare-fun inline$$BorrowField$0$dst@1@@11 () T@$Mutation)
(declare-fun inline$$BorrowField$1$size@1@@8 () Int)
(declare-fun inline$$BorrowField$1$p@2@@8 () T@$Path)
(declare-fun inline$$BorrowField$0$p@1@@11 () T@$Path)
(declare-fun inline$$BorrowLoc$1$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$0$size@1@@11 () Int)
(declare-fun inline$$BorrowField$0$p@2@@11 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@0 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@10 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@8 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@10 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 77134) (let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon12_Else_correct true))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon12_Then_correct true))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@8  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|) ($Local 0))) (and (=> (= (ControlFlow 0 55592) 55644) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 55592) 55634) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@8  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@8| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|) 0 inline$$TestPackUnpack_R_pack$0$$struct@1@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|)))) (and (=> (= (ControlFlow 0 55618) 55644) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 55618) 55634) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestPackUnpack_R_$pack_ref_deep$0$anon0$1_correct@@0  (=> (= $TestPackUnpack_r_count@2@@3 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@1@@7) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 55495) 55618) inline$$WritebackToValue$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 55495) 55592) inline$$WritebackToValue$0$anon3_Else_correct@@8)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@8  (and (=> (= (ControlFlow 0 55475) (- 0 78293)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@8)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@8)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@2@@5 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@1@@8) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@8)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 55475) 55495)) inline$$TestPackUnpack_R_$pack_ref_deep$0$anon0$1_correct@@0)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@8  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0@@0)) $TestPackUnpack_R_nested)) (= (ControlFlow 0 55437) 55475)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@8)))
(let ((inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|)) (= (ControlFlow 0 55373) 55437)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@8)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@8  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@8) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@8))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@8 inline$$WritebackToReference$0$srcPath@1@@8))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@8| |inline$$WriteRef$0$to'@1@@8|) (= (ControlFlow 0 55257) 55373)) inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@8  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@8) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@8))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@8 inline$$WritebackToReference$0$srcPath@1@@8)) (= |inline$$WritebackToReference$0$dst'@1@@8| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) inline$$WritebackToReference$0$dstPath@1@@8 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@8 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@8) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@8|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@4|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@8| |inline$$WritebackToReference$0$dst'@1@@8|) (= (ControlFlow 0 55313) 55373))) inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@8  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@8 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (= inline$$WritebackToReference$0$dstPath@1@@8 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@8|))) (and (=> (= (ControlFlow 0 55221) 55313) inline$$WritebackToReference$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 55221) 55257) inline$$WritebackToReference$0$anon3_Else_correct@@8)))))
(let ((inline$$WriteRef$1$anon0_correct@@4  (=> (and (= |inline$$WriteRef$1$to'@1@@4| ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1@@0|) (|p#$Mutation| |inline$$Splice1$0$dst'@1@@0|) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t7@1)) (= (ControlFlow 0 55078) 55221)) inline$$WritebackToReference$0$anon0_correct@@8)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon6_correct  (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t7@1 ($Integer 0)) (= (ControlFlow 0 55084) 55078)) inline$$WriteRef$1$anon0_correct@@4)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 55021) 55084)) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon11_Then_correct  (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$Splice1$0$dst'@1@@0|)) (= (ControlFlow 0 55654) 55084)) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$Splice1$0$anon0_correct@@0  (=> (= |inline$$Splice1$0$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) ($ConcatPath_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@8|) (|p#$Mutation| inline$$BorrowField$1$dst@1@@8)) (|v#$Mutation| inline$$BorrowField$1$dst@1@@8))) (and (=> (= (ControlFlow 0 54973) 55654) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 54973) 55021) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@8  (=> (and (= |inline$$WriteRef$0$to'@1@@8| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@12) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@12) inline$$ReadRef$0$v@1@@9)) (= (ControlFlow 0 54892) 54973)) inline$$Splice1$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon10_Else_correct  (=> (and (not false) (= (ControlFlow 0 54898) 54892)) inline$$WriteRef$0$anon0_correct@@8)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon10_Then_correct true))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 54787) 55662) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 54787) 54898) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct@@0  (and (=> (= (ControlFlow 0 54797) 55662) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 54797) 54898) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 54777) 54797) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 54777) 54787) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Then_correct@@0  (=> (= inline$$TestPackUnpack_get_value_ref_$def$0$$trace_temp@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@8)) (and (=> (= (ControlFlow 0 54807) 54797) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 54807) 54787) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$BorrowField$1$anon0_correct@@8  (=> (and (and (= inline$$BorrowField$1$p@1@@8 (|p#$Mutation| inline$$BorrowField$0$dst@1@@11)) (= inline$$BorrowField$1$size@1@@8 (|size#$Path| inline$$BorrowField$1$p@1@@8))) (and (= inline$$BorrowField$1$p@2@@8 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@8) inline$$BorrowField$1$size@1@@8 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@8 1))) (= inline$$BorrowField$1$dst@1@@8 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@11) inline$$BorrowField$1$p@2@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@11))) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 54761) 54807) inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Then_correct@@0) (=> (= (ControlFlow 0 54761) 54777) inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Else_correct@@0)))))
(let ((inline$$BorrowField$0$anon0_correct@@11  (=> (= inline$$BorrowField$0$p@1@@11 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@4)) (=> (and (and (= inline$$BorrowField$0$size@1@@11 (|size#$Path| inline$$BorrowField$0$p@1@@11)) (= inline$$BorrowField$0$p@2@@11 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@11) inline$$BorrowField$0$size@1@@11 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@11 1)))) (and (= inline$$BorrowField$0$dst@1@@11 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@4) inline$$BorrowField$0$p@2@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@4))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 54637) 54761))) inline$$BorrowField$1$anon0_correct@@8))))
(let ((inline$$BorrowLoc$1$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$1$dst@1@@4 ($Mutation ($Local 1) $EmptyPath inline$$ReadRef$0$v@1@@9)) (= (ControlFlow 0 54513) 54637)) inline$$BorrowField$0$anon0_correct@@11)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 54429) 54513)) inline$$BorrowLoc$1$anon0_correct@@4)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Then_correct@@0  (=> (= (ControlFlow 0 54815) 54513) inline$$BorrowLoc$1$anon0_correct@@4)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 54423) 54815) inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Then_correct@@0) (=> (= (ControlFlow 0 54423) 54429) inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Else_correct@@0)))))
(let ((inline$$TestPackUnpack_get_value_ref_$direct_intra$0$anon0_correct@@0  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@9) (let ((va@@63 (|v#$Vector| inline$$ReadRef$0$v@1@@9)))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (= (ControlFlow 0 54823) 54423)) inline$$TestPackUnpack_get_value_ref_$def$0$anon0_correct@@0)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon2$3_correct  (and (=> (= (ControlFlow 0 54833) (- 0 77742)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 54833) 54823) inline$$TestPackUnpack_get_value_ref_$direct_intra$0$anon0_correct@@0)))))
(let ((inline$$ReadRef$0$anon0_correct@@9  (=> (and (= inline$$ReadRef$0$v@1@@9 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@12)) (= (ControlFlow 0 54211) 54833)) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon2$3_correct)))
(let ((inline$$TestPackUnpack_R_$unpack_ref_deep$0$anon0$1_correct@@0  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@0)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@1@@7 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count@0@@10) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 54175) 54211)) inline$$ReadRef$0$anon0_correct@@9))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@8  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@8)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@8 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum@0@@10) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@8)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 54151) 54175)) inline$$TestPackUnpack_R_$unpack_ref_deep$0$anon0$1_correct@@0))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@8  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@0)) $TestPackUnpack_R_nested)) (= (ControlFlow 0 54129) 54151)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@8)))
(let ((inline$$TestPackUnpack_R_$unpack_ref_deep$0$Entry_correct@@0  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@12)) (= (ControlFlow 0 54081) 54129)) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@8)))
(let ((inline$$BorrowLoc$0$anon0_correct@@12  (=> (and (= inline$$BorrowLoc$0$dst@1@@12 ($Mutation ($Local 0) $EmptyPath inline$$TestPackUnpack_R_pack$0$$struct@1@@1)) (= (ControlFlow 0 54017) 54081)) inline$$TestPackUnpack_R_$unpack_ref_deep$0$Entry_correct@@0)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 53967) 54017)) inline$$BorrowLoc$0$anon0_correct@@12)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 55670) 54017) inline$$BorrowLoc$0$anon0_correct@@12)))
(let ((inline$$TestPackUnpack_R_pack$0$anon3_correct@@1  (=> (= $TestPackUnpack_r_count@0@@10 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 53933) 55670) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 53933) 53967) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 53947) 53933)) inline$$TestPackUnpack_R_pack$0$anon3_correct@@1)))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 53953) 53933) inline$$TestPackUnpack_R_pack$0$anon3_correct@@1)))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Then_correct@@1  (=> (> 6613 0) (and (=> (= (ControlFlow 0 53941) 53953) inline$$TestPackUnpack_R_pack$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 53941) 53947) inline$$TestPackUnpack_R_pack$0$anon5_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Else_correct@@1  (=> (and (>= 0 6613) (= (ControlFlow 0 53917) 53933)) inline$$TestPackUnpack_R_pack$0$anon3_correct@@1)))
(let ((inline$$TestPackUnpack_R_pack$0$anon0_correct@@1  (=> (and (and (and (and (and ((_ is $Vector) inline$$TestPackUnpack_S_pack$0$$struct@1@@1) (let ((va@@65 (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= inline$$TestPackUnpack_R_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_S_pack$0$$struct@1@@1) 1)))) (and (=> (= (ControlFlow 0 53909) 53941) inline$$TestPackUnpack_R_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 53909) 53917) inline$$TestPackUnpack_R_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon3_correct@@1  (and (=> (= (ControlFlow 0 53731) (- 0 77496)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@10 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@1)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 53731) 53909)) inline$$TestPackUnpack_R_pack$0$anon0_correct@@1)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 53745) 53731)) inline$$TestPackUnpack_S_pack$0$anon3_correct@@1)))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 53751) 53731) inline$$TestPackUnpack_S_pack$0$anon3_correct@@1)))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 53739) 53751) inline$$TestPackUnpack_S_pack$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 53739) 53745) inline$$TestPackUnpack_S_pack$0$anon5_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Else_correct@@1  (=> (and (>= 0 0) (= (ControlFlow 0 53693) 53731)) inline$$TestPackUnpack_S_pack$0$anon3_correct@@1)))
(let ((inline$$TestPackUnpack_S_pack$0$anon0_correct@@1  (=> (and (and (and ((_ is $Integer) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestPackUnpack_S_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 53685) 53739) inline$$TestPackUnpack_S_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 53685) 53693) inline$$TestPackUnpack_S_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 53757) 53685)) inline$$TestPackUnpack_S_pack$0$anon0_correct@@1))))
(let ((anon0_correct@@15  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 77134) 53757)) inline$$TestPackUnpack_update_via_returned_ref_invariant_incorrect_$def_verify$0$anon0_correct))))
anon0_correct@@15))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $TestPackUnpack_r_count@3@@2 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@3@@3 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@6| () T@$Value)
(declare-fun $TestPackUnpack_s_sum@2@@6 () T@$Value)
(declare-fun $TestPackUnpack_r_count@2@@4 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@9| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_R_pack$0$$struct@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@9| () T@$Value)
(declare-fun $TestPackUnpack_r_count@1@@8 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@9 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@1@@9 () T@$Value)
(declare-fun inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0@@1 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@9| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@9 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@9 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@9| () T@$Mutation)
(declare-fun |inline$$Splice1$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@9 () T@$Mutation)
(declare-fun inline$$BorrowLoc$0$dst@1@@13 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@10 () T@$Value)
(declare-fun inline$$TestPackUnpack_get_value_ref_$def$0$$trace_temp@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@9 () T@$Path)
(declare-fun inline$$BorrowField$0$dst@1@@12 () T@$Mutation)
(declare-fun inline$$BorrowField$1$size@1@@9 () Int)
(declare-fun inline$$BorrowField$1$p@2@@9 () T@$Path)
(declare-fun inline$$BorrowField$0$p@1@@12 () T@$Path)
(declare-fun inline$$BorrowLoc$1$dst@1@@5 () T@$Mutation)
(declare-fun inline$$BorrowField$0$size@1@@12 () Int)
(declare-fun inline$$BorrowField$0$p@2@@12 () T@$Path)
(declare-fun inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@1 () T@$Value)
(declare-fun $TestPackUnpack_r_count@0@@11 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@9 () T@$Value)
(declare-fun $TestPackUnpack_s_sum@0@@11 () T@$Value)
(declare-fun inline$$TestPackUnpack_S_pack$0$$struct@1@@2 () T@$Value)
(declare-fun inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 78422) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 58500) (- 0 79832)) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 1)))))) (=> (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$ret0@2)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value) ($Integer 1))))) (and (=> (= (ControlFlow 0 58500) (- 0 79856)) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@3@@2 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_r_count@3@@2 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1)))))))) (=> (= (ControlFlow 0 58500) (- 0 79881)) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified $TestPackUnpack_s_sum@3@@3 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| ($Integer 2)))))))))))))))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon8_correct  (=> (= $abort_flag@0@@9 false) (=> (and (and (= inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@6|) (= $TestPackUnpack_s_sum@3@@3 $TestPackUnpack_s_sum@2@@6)) (and (= $TestPackUnpack_r_count@3@@2 $TestPackUnpack_r_count@2@@4) (= (ControlFlow 0 58458) 58500))) anon0$2_correct@@12))))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 58456) 58458)) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 58466) 58458) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@9  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|) ($Local 0))) (= |inline$$WritebackToValue$0$vdst'@2@@6| inline$$TestPackUnpack_R_pack$0$$struct@1@@2)) (and (=> (= (ControlFlow 0 58414) 58466) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 58414) 58456) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@9  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@9| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|) 0 inline$$TestPackUnpack_R_pack$0$$struct@1@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|))) (= |inline$$WritebackToValue$0$vdst'@2@@6| |inline$$WritebackToValue$0$vdst'@1@@9|)) (and (=> (= (ControlFlow 0 58440) 58466) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 58440) 58456) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestPackUnpack_R_$pack_ref_deep$0$anon0$1_correct@@1  (=> (= $TestPackUnpack_r_count@2@@4 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count@1@@8) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 58317) 58440) inline$$WritebackToValue$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 58317) 58414) inline$$WritebackToValue$0$anon3_Else_correct@@9)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@9  (and (=> (= (ControlFlow 0 58297) (- 0 79667)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@9)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@9)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@2@@6 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum@1@@9) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@9)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 58297) 58317)) inline$$TestPackUnpack_R_$pack_ref_deep$0$anon0$1_correct@@1)))))
(let ((inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@9  (=> (and (= inline$$TestPackUnpack_S_$pack_ref$0$$after@0@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0@@1)) $TestPackUnpack_R_nested)) (= (ControlFlow 0 58259) 58297)) inline$$TestPackUnpack_S_$pack_ref$0$anon0_correct@@9)))
(let ((inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_R_$pack_ref_deep$0$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|)) (= (ControlFlow 0 58195) 58259)) inline$$TestPackUnpack_S_$pack_ref$0$Entry_correct@@9)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@9  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@9) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@9))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@9 inline$$WritebackToReference$0$srcPath@1@@9))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@9| |inline$$WriteRef$0$to'@1@@9|) (= (ControlFlow 0 58079) 58195)) inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@9  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@9) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@9))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@9 inline$$WritebackToReference$0$srcPath@1@@9)) (= |inline$$WritebackToReference$0$dst'@1@@9| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) inline$$WritebackToReference$0$dstPath@1@@9 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@9 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@9) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@9|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@5|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@9| |inline$$WritebackToReference$0$dst'@1@@9|) (= (ControlFlow 0 58135) 58195))) inline$$TestPackUnpack_R_$pack_ref_deep$0$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@9  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@9 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@5|)) (= inline$$WritebackToReference$0$dstPath@1@@9 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@9|))) (and (=> (= (ControlFlow 0 58043) 58135) inline$$WritebackToReference$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 58043) 58079) inline$$WritebackToReference$0$anon3_Else_correct@@9)))))
(let ((inline$$WriteRef$1$anon0_correct@@5  (=> (and (= |inline$$WriteRef$1$to'@1@@5| ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1@@1|) (|p#$Mutation| |inline$$Splice1$0$dst'@1@@1|) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t7@1)) (= (ControlFlow 0 57900) 58043)) inline$$WritebackToReference$0$anon0_correct@@9)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon6_correct  (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t7@1 ($Integer 1)) (= (ControlFlow 0 57906) 57900)) inline$$WriteRef$1$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 57843) 57906)) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon11_Then_correct  (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$Splice1$0$dst'@1@@1|)) (= (ControlFlow 0 58476) 57906)) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$Splice1$0$anon0_correct@@1  (=> (= |inline$$Splice1$0$dst'@1@@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) ($ConcatPath_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@9|) (|p#$Mutation| inline$$BorrowField$1$dst@1@@9)) (|v#$Mutation| inline$$BorrowField$1$dst@1@@9))) (and (=> (= (ControlFlow 0 57795) 58476) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 57795) 57843) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@9  (=> (and (= |inline$$WriteRef$0$to'@1@@9| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@13) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@13) inline$$ReadRef$0$v@1@@10)) (= (ControlFlow 0 57714) 57795)) inline$$Splice1$0$anon0_correct@@1)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon10_Else_correct  (=> (and (not false) (= (ControlFlow 0 57720) 57714)) inline$$WriteRef$0$anon0_correct@@9)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon10_Then_correct true))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 57609) 58484) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 57609) 57720) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct@@1  (and (=> (= (ControlFlow 0 57619) 58484) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 57619) 57720) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 57599) 57619) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct@@1) (=> (= (ControlFlow 0 57599) 57609) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Then_correct@@1  (=> (= inline$$TestPackUnpack_get_value_ref_$def$0$$trace_temp@1@@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@9)) (and (=> (= (ControlFlow 0 57629) 57619) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Then_correct@@1) (=> (= (ControlFlow 0 57629) 57609) inline$$TestPackUnpack_get_value_ref_$def$0$anon9_Else_correct@@1)))))
(let ((inline$$BorrowField$1$anon0_correct@@9  (=> (and (and (= inline$$BorrowField$1$p@1@@9 (|p#$Mutation| inline$$BorrowField$0$dst@1@@12)) (= inline$$BorrowField$1$size@1@@9 (|size#$Path| inline$$BorrowField$1$p@1@@9))) (and (= inline$$BorrowField$1$p@2@@9 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@9) inline$$BorrowField$1$size@1@@9 $TestPackUnpack_S_value) (+ inline$$BorrowField$1$size@1@@9 1))) (= inline$$BorrowField$1$dst@1@@9 ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@12) inline$$BorrowField$1$p@2@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowField$0$dst@1@@12))) $TestPackUnpack_S_value))))) (and (=> (= (ControlFlow 0 57583) 57629) inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Then_correct@@1) (=> (= (ControlFlow 0 57583) 57599) inline$$TestPackUnpack_get_value_ref_$def$0$anon8_Else_correct@@1)))))
(let ((inline$$BorrowField$0$anon0_correct@@12  (=> (= inline$$BorrowField$0$p@1@@12 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@5)) (=> (and (and (= inline$$BorrowField$0$size@1@@12 (|size#$Path| inline$$BorrowField$0$p@1@@12)) (= inline$$BorrowField$0$p@2@@12 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@12) inline$$BorrowField$0$size@1@@12 $TestPackUnpack_R_nested) (+ inline$$BorrowField$0$size@1@@12 1)))) (and (= inline$$BorrowField$0$dst@1@@12 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@5) inline$$BorrowField$0$p@2@@12 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@5))) $TestPackUnpack_R_nested))) (= (ControlFlow 0 57459) 57583))) inline$$BorrowField$1$anon0_correct@@9))))
(let ((inline$$BorrowLoc$1$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$1$dst@1@@5 ($Mutation ($Local 1) $EmptyPath inline$$ReadRef$0$v@1@@10)) (= (ControlFlow 0 57335) 57459)) inline$$BorrowField$0$anon0_correct@@12)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 57251) 57335)) inline$$BorrowLoc$1$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Then_correct@@1  (=> (= (ControlFlow 0 57637) 57335) inline$$BorrowLoc$1$anon0_correct@@5)))
(let ((inline$$TestPackUnpack_get_value_ref_$def$0$anon0_correct@@1  (=> (not false) (and (=> (= (ControlFlow 0 57245) 57637) inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Then_correct@@1) (=> (= (ControlFlow 0 57245) 57251) inline$$TestPackUnpack_get_value_ref_$def$0$anon7_Else_correct@@1)))))
(let ((inline$$TestPackUnpack_get_value_ref_$direct_intra$0$anon0_correct@@1  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@10) (let ((va@@66 (|v#$Vector| inline$$ReadRef$0$v@1@@10)))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested)) (let ((va@@67 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested))))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) $MAX_U64)))) (= (ControlFlow 0 57645) 57245)) inline$$TestPackUnpack_get_value_ref_$def$0$anon0_correct@@1)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon2$3_correct  (and (=> (= (ControlFlow 0 57655) (- 0 79116)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 57655) 57645) inline$$TestPackUnpack_get_value_ref_$direct_intra$0$anon0_correct@@1)))))
(let ((inline$$ReadRef$0$anon0_correct@@10  (=> (and (= inline$$ReadRef$0$v@1@@10 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@13)) (= (ControlFlow 0 57033) 57655)) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon2$3_correct)))
(let ((inline$$TestPackUnpack_R_$unpack_ref_deep$0$anon0$1_correct@@1  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@1)) $TestPackUnpack_R_nested))) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_r_count@1@@8 ($Integer (- (|i#$Integer| $TestPackUnpack_r_count@0@@11) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 56997) 57033)) inline$$ReadRef$0$anon0_correct@@10))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@9  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@9)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@1@@9 ($Integer (- (|i#$Integer| $TestPackUnpack_s_sum@0@@11) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@9)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 56973) 56997)) inline$$TestPackUnpack_R_$unpack_ref_deep$0$anon0$1_correct@@1))))
(let ((inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@9  (=> (and (= inline$$TestPackUnpack_S_$unpack_ref$0$$before@0@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@1)) $TestPackUnpack_R_nested)) (= (ControlFlow 0 56951) 56973)) inline$$TestPackUnpack_S_$unpack_ref$0$anon0_correct@@9)))
(let ((inline$$TestPackUnpack_R_$unpack_ref_deep$0$Entry_correct@@1  (=> (and (= inline$$TestPackUnpack_R_$unpack_ref_deep$0$$before@0@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@13)) (= (ControlFlow 0 56903) 56951)) inline$$TestPackUnpack_S_$unpack_ref$0$Entry_correct@@9)))
(let ((inline$$BorrowLoc$0$anon0_correct@@13  (=> (and (= inline$$BorrowLoc$0$dst@1@@13 ($Mutation ($Local 0) $EmptyPath inline$$TestPackUnpack_R_pack$0$$struct@1@@2)) (= (ControlFlow 0 56839) 56903)) inline$$TestPackUnpack_R_$unpack_ref_deep$0$Entry_correct@@1)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 56789) 56839)) inline$$BorrowLoc$0$anon0_correct@@13)))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 58492) 56839) inline$$BorrowLoc$0$anon0_correct@@13)))
(let ((inline$$TestPackUnpack_R_pack$0$anon3_correct@@2  (=> (= $TestPackUnpack_r_count@0@@11 ($Integer (+ (|i#$Integer| $TestPackUnpack_r_count) (|i#$Integer| ($Integer 1))))) (and (=> (= (ControlFlow 0 56755) 58492) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 56755) 56789) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 56769) 56755)) inline$$TestPackUnpack_R_pack$0$anon3_correct@@2)))
(let ((inline$$TestPackUnpack_R_pack$0$anon5_Then_correct@@2  (=> (= (ControlFlow 0 56775) 56755) inline$$TestPackUnpack_R_pack$0$anon3_correct@@2)))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Then_correct@@2  (=> (> 6793 0) (and (=> (= (ControlFlow 0 56763) 56775) inline$$TestPackUnpack_R_pack$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 56763) 56769) inline$$TestPackUnpack_R_pack$0$anon5_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_R_pack$0$anon4_Else_correct@@2  (=> (and (>= 0 6793) (= (ControlFlow 0 56739) 56755)) inline$$TestPackUnpack_R_pack$0$anon3_correct@@2)))
(let ((inline$$TestPackUnpack_R_pack$0$anon0_correct@@2  (=> (and (and (and (and (and ((_ is $Vector) inline$$TestPackUnpack_S_pack$0$$struct@1@@2) (let ((va@@68 (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) $TestPackUnpack_S_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) $TestPackUnpack_S_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) $TestPackUnpack_S_value)) $MAX_U64))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (= inline$$TestPackUnpack_R_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_S_pack$0$$struct@1@@2) 1)))) (and (=> (= (ControlFlow 0 56731) 56763) inline$$TestPackUnpack_R_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 56731) 56739) inline$$TestPackUnpack_R_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon3_correct@@2  (and (=> (= (ControlFlow 0 56553) (- 0 78870)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) $TestPackUnpack_S_value)) (|i#$Integer| ($Integer 0))))) (=> (and (= $TestPackUnpack_s_sum@0@@11 ($Integer (+ (|i#$Integer| $TestPackUnpack_s_sum) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestPackUnpack_S_pack$0$$struct@1@@2)) $TestPackUnpack_S_value))))) (= (ControlFlow 0 56553) 56731)) inline$$TestPackUnpack_R_pack$0$anon0_correct@@2)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 56567) 56553)) inline$$TestPackUnpack_S_pack$0$anon3_correct@@2)))
(let ((inline$$TestPackUnpack_S_pack$0$anon5_Then_correct@@2  (=> (= (ControlFlow 0 56573) 56553) inline$$TestPackUnpack_S_pack$0$anon3_correct@@2)))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Then_correct@@2  (=> (> 0 0) (and (=> (= (ControlFlow 0 56561) 56573) inline$$TestPackUnpack_S_pack$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 56561) 56567) inline$$TestPackUnpack_S_pack$0$anon5_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_S_pack$0$anon4_Else_correct@@2  (=> (and (>= 0 0) (= (ControlFlow 0 56515) 56553)) inline$$TestPackUnpack_S_pack$0$anon3_correct@@2)))
(let ((inline$$TestPackUnpack_S_pack$0$anon0_correct@@2  (=> (and (and (and ((_ is $Integer) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestPackUnpack_S_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 56507) 56561) inline$$TestPackUnpack_S_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 56507) 56515) inline$$TestPackUnpack_S_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 56579) 56507)) inline$$TestPackUnpack_S_pack$0$anon0_correct@@2))))
(let ((anon0_correct@@16  (=> ((_ is $Integer) $TestPackUnpack_r_count) (=> (and ((_ is $Integer) $TestPackUnpack_s_sum) (= (ControlFlow 0 78422) 56579)) inline$$TestPackUnpack_update_via_returned_ref_var_incorrect_$def_verify$0$anon0_correct))))
anon0_correct@@16))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
