(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@8 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@9 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory () T@$Memory)
(declare-fun $tv0@@13 () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $VASP_ParentVASP_$memory () T@$Memory)
(declare-fun $VASP_ChildVASP_$memory () T@$Memory)
(declare-fun $AccountLimits_Window_$memory () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun amount () T@$Value)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $abort_code@5 () Int)
(declare-fun $DiemAccount_Balance_$memory@2 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@1 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@2 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@1 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@2 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@4 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@3 () T@$Memory)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@1 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@0 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@0 () T@$Memory)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@2 () T@$Memory)
(declare-fun $abort_flag@2 () Bool)
(declare-fun call1formal@$DiemAccount_DiemAccount_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun call4formal@$DiemAccount_DiemAccount_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call1formal@$DiemAccount_DiemAccount_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Diem_Diem_$memory () T@$Memory)
(declare-fun $Option_Option_$memory () T@$Memory)
(declare-fun $DiemAccount_WithdrawCapability_$memory () T@$Memory)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory () T@$Memory)
(declare-fun $ChainId_ChainId_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory () T@$Memory)
(declare-fun $TransactionFee_TransactionFee_$memory () T@$Memory)
(declare-fun $SlidingNonce_SlidingNonce_$memory () T@$Memory)
(declare-fun $DualAttestation_Limit_$memory () T@$Memory)
(declare-fun $DualAttestation_Credential_$memory () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 308450) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 307272) (- 0 322239)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322259)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322273)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322288)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322313)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322352)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322367)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322383)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@0 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@0 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322476)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322527)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322542)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322562)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322643)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322746)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1)))) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@5 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1)))) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@5 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 322909)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323106)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323211)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323232)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323261)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323295)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323325)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323361)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323377)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 307272) (- 0 323411)) (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@10 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@15 (|l#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1)))) len@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@15 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))))))))) (=> (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@10 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@15 (|l#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1)))) len@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@15 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))))) (and (=> (= (ControlFlow 0 307272) (- 0 324561)) (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1)))) len@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@20 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@25 (|l#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1)))) len@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@25 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1)))) len@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@20 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@25 (|l#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1)))) len@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@25 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 307272) (- 0 325964)) (=> $abort_flag@3 (or (or (or (= $abort_code@5 (|i#$Integer| ($Integer 5))) (= $abort_code@5 (|i#$Integer| ($Integer 1)))) (= $abort_code@5 (|i#$Integer| ($Integer 3)))) (= $abort_code@5 (|i#$Integer| ($Integer 8)))))) (=> (=> $abort_flag@3 (or (or (or (= $abort_code@5 (|i#$Integer| ($Integer 5))) (= $abort_code@5 (|i#$Integer| ($Integer 1)))) (= $abort_code@5 (|i#$Integer| ($Integer 3)))) (= $abort_code@5 (|i#$Integer| ($Integer 8))))) (and (=> (= (ControlFlow 0 307272) (- 0 326009)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))))) (=> (= (ControlFlow 0 307272) (- 0 326052)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$preburn_preburn_$def_verify$0$Abort_correct  (=> (and (and (and (= $abort_flag@3 true) (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1)) (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1))) (and (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@1) (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3)) (and (= $abort_code@5 $abort_code@4) (= (ControlFlow 0 307202) 307272)))) anon0$2_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon7_correct  (=> (= $abort_code@4 $abort_code@1) (=> (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@0) (= $AccountLimits_Window_$memory@1 $AccountLimits_Window_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory)) (and (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 307242) 307202))) inline$$preburn_preburn_$def_verify$0$Abort_correct)))))
(let ((inline$$preburn_preburn_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 307240) 307242)) inline$$preburn_preburn_$def_verify$0$anon7_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 307250) 307242) inline$$preburn_preburn_$def_verify$0$anon7_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 307234) 307250) inline$$preburn_preburn_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 307234) 307240) inline$$preburn_preburn_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$preburn_preburn_$def_verify$0$anon11_correct  (=> (= $abort_code@4 $abort_code@2) (=> (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@1) (= $AccountLimits_Window_$memory@1 $AccountLimits_Window_$memory@0)) (=> (and (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0)) (and (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory@0) (= (ControlFlow 0 307222) 307202))) inline$$preburn_preburn_$def_verify$0$Abort_correct)))))
(let ((inline$$preburn_preburn_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 307220) 307222)) inline$$preburn_preburn_$def_verify$0$anon11_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 307230) 307222) inline$$preburn_preburn_$def_verify$0$anon11_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 307214) 307230) inline$$preburn_preburn_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 307214) 307220) inline$$preburn_preburn_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$preburn_preburn_$def_verify$0$anon15_correct  (=> (= $abort_code@4 $abort_code@3) (=> (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@2) (= $AccountLimits_Window_$memory@1 $AccountLimits_Window_$memory@0)) (=> (and (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0)) (and (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory@0) (= (ControlFlow 0 307198) 307202))) inline$$preburn_preburn_$def_verify$0$Abort_correct)))))
(let ((inline$$preburn_preburn_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 307196) 307198)) inline$$preburn_preburn_$def_verify$0$anon15_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 307210) 307198) inline$$preburn_preburn_$def_verify$0$anon15_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon23_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 307190) 307210) inline$$preburn_preburn_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 307190) 307196) inline$$preburn_preburn_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$preburn_preburn_$def_verify$0$anon23_Else_correct  (=> (not $abort_flag@2) (=> (and (and (and (= $abort_flag@3 $abort_flag@2) (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@0)) (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@0) (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@0))) (and (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@0) (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@2)) (and (= $abort_code@5 $abort_code@3) (= (ControlFlow 0 307186) 307272)))) anon0$2_correct))))
(let ((inline$$preburn_preburn_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@1) (= call1formal@$DiemAccount_DiemAccount_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 307180) (- 0 321842)) (|Select_[$TypeValueArray,$int]$bool| call1formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))) (=> (|Select_[$TypeValueArray,$int]$bool| call1formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@2) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) $abort_flag@2) (=> $abort_flag@2 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0)))))))))) (=> (and (and (=> $abort_flag@2 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (= $abort_code@3 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@2) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))) (and (=> (= (ControlFlow 0 307180) 307190) inline$$preburn_preburn_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 307180) 307186) inline$$preburn_preburn_$def_verify$0$anon23_Else_correct))))))))))
(let ((inline$$preburn_preburn_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0) (= call4formal@$DiemAccount_DiemAccount_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 307174) (- 0 318623)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@1)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@1))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@30 (|l#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@31 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@31 1)))) len@@30 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@30 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) $abort_flag@1)) (and (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@1))) (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@1)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@35 (|l#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@36 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@36 1)))) len@@35 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@35 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) $abort_flag@1)))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@1)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@1))) (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@1)) (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1)))) (and (and (and (=> $abort_flag@1 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@45 (|l#$ValueArray| (let ((len@@46 (|l#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1)))) len@@46 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@46 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@46 (|l#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1)))) len@@46 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@46 1)))) len@@45 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@45 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (=> $abort_flag@1 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) (= $abort_code@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@2 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@55 (|l#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@56 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@56 1)))) len@@55 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@55 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) (= $abort_code@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@2 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account@@0)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@2 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))))) (and (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)))))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability))))))) (and (and (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))))))) (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))))))))) (and (=> (= (ControlFlow 0 307174) 307214) inline$$preburn_preburn_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 307174) 307180) inline$$preburn_preburn_$def_verify$0$anon21_Else_correct))))))))))
(let ((inline$$preburn_preburn_$def_verify$0$anon4$2_correct  (=> (= call1formal@$DiemAccount_DiemAccount_$CallerDomain@0@@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 307168) (- 0 318318)) (|Select_[$TypeValueArray,$int]$bool| call1formal@$DiemAccount_DiemAccount_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| account@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| call1formal@$DiemAccount_DiemAccount_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| account@@0)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) $abort_flag@0)) (and (=> $abort_flag@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))))) (=> $abort_flag@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))))) (and (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| account@@0))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0 ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0))))))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| account@@0)) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_withdraw_capability ($Vector (let ((len@@60 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@60 ($Vector $EmptyValueArray)) (+ len@@60 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address) account@@0))))))) (=> (and (and (and (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@10 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $DiemAccount_WithdrawCapability_account_address))) true) (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| account@@0)))))) (and (=> (= (ControlFlow 0 307168) 307234) inline$$preburn_preburn_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 307168) 307174) inline$$preburn_preburn_$def_verify$0$anon19_Else_correct)))))))))
(let ((inline$$preburn_preburn_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 307098) 307168)) inline$$preburn_preburn_$def_verify$0$anon4$2_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 307258) 307168) inline$$preburn_preburn_$def_verify$0$anon4$2_correct)))
(let ((inline$$preburn_preburn_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307090) 307258) inline$$preburn_preburn_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 307090) 307098) inline$$preburn_preburn_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$preburn_preburn_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 307266) 307258) inline$$preburn_preburn_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 307266) 307098) inline$$preburn_preburn_$def_verify$0$anon18_Else_correct))))
(let ((inline$$preburn_preburn_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 307084) 307266) inline$$preburn_preburn_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 307084) 307090) inline$$preburn_preburn_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))
)))) (and (and (forall (($inv_addr@@3 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))
))) (and (forall (($inv_addr@@5 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_currency_code)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_currency_code))) $$0@@1))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@24 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))
)) (forall (($inv_addr@@6 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Preburn_to_burn)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Preburn_to_burn))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))
))))) (=> (and (and (and (and (forall (($inv_addr@@7 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Option_Option_vec)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Option_Option_vec))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))
))) (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@36 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_authentication_key))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_authentication_key))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_authentication_key))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_authentication_key))) $$0@@7))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@9))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@10))
)))) (and (and (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@46 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@47 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@10))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@11))
)) (forall (($inv_addr@@12 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12)) (let ((va@@50 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))) $DiemAccount_Balance_coin)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))) $DiemAccount_Balance_coin))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))) $DiemAccount_Balance_coin))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@12))
))) (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@52 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@13))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@13))) $DiemAccount_WithdrawCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean (forall ((window_addr T@$Value) )  (=> ((_ is $Address) window_addr) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) $AccountLimits_Window_limit_address)))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))))) (=> (and (and (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 173345816)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@0 ($Address 173345816)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((child_addr T@$Value) )  (=> ((_ is $Address) child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@7 T@$Value) )  (=> ((_ is $Address) addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((token T@$Value) )  (=> ((_ is $Type) token) (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token)) 1) (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@11 T@$Value) )  (=> ((_ is $Address) addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))))))))))) (and (|b#$Boolean| (let ((addr@@12 account@@0))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (= (ControlFlow 0 307270) 307084)))))) inline$$preburn_preburn_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> ((_ is $Address) account@@0) (=> (and (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (= (ControlFlow 0 304772) 307270)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 308450) 304772) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
