(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $Authenticator_MultiEd25519PublicKey () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Authenticator_spec_ed25519_authentication_key (T@$Value) T@$Value)
(declare-fun $Authenticator_spec_multi_ed25519_authentication_key (T@$Value) T@$Value)
(declare-fun $Authenticator_MultiEd25519PublicKey_public_keys () Int)
(declare-fun $Authenticator_MultiEd25519PublicKey_threshold () Int)
(declare-fun $Authenticator_MultiEd25519PublicKey_type_value () T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_key () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $Authenticator_MultiEd25519PublicKey $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability $SharedEd25519PublicKey_SharedEd25519PublicKey)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (forall ((public_key@@1 T@$Value) )  (and (and ((_ is $Vector) ($Authenticator_spec_ed25519_authentication_key public_key@@1)) (let ((va@@8 (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0))
)))))
(assert (forall ((k T@$Value) )  (and (and ((_ is $Vector) ($Authenticator_spec_multi_ed25519_authentication_key k)) (let ((va@@9 (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0))
)))))
(assert (= $Authenticator_MultiEd25519PublicKey_public_keys 0))
(assert (= $Authenticator_MultiEd25519PublicKey_threshold 1))
(assert (= $Authenticator_MultiEd25519PublicKey_type_value ($StructType $Authenticator_MultiEd25519PublicKey $EmptyTypeValueArray)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@10 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@11 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (= $SharedEd25519PublicKey_SharedEd25519PublicKey_key 0))
(assert (= $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap 1))
(assert (= $SharedEd25519PublicKey_SharedEd25519PublicKey_type_value ($StructType $SharedEd25519PublicKey_SharedEd25519PublicKey $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k@@0 Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k@@0) (ite  (and (<= |l#0@@3| k@@0) (< k@@0 |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k@@0)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k@@0))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory () T@$Memory)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun public_key@@2 () T@$Value)
(declare-fun $abort_code@33 () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1 () T@$Memory)
(declare-fun $abort_flag@20 () Bool)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory@5 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@3 () T@$Memory)
(declare-fun $abort_code@31 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@4 () T@$Memory)
(declare-fun $abort_code@32 () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 () T@$Memory)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_code@29 () Int)
(declare-fun $abort_flag@18 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@30 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_publish_$def$0$$t14@1 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_code@27 () Int)
(declare-fun $abort_code@25 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory@1 () T@$Memory)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@26 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@2 () T@$Memory)
(declare-fun $abort_code@15 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@16 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_flag@14 () Bool)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun $abort_code@22 () Int)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1 () T@$Value)
(declare-fun $abort_code@24 () Int)
(declare-fun $abort_code@19 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_code@21 () Int)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_code@23 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$2$$t2@1 () T@$Value)
(declare-fun $abort_code@20 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$Signature_ed25519_validate_pubkey$0$res@1 () T@$Value)
(declare-fun $abort_code@17 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$t8@1 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun inline$$Option_Option_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$1$$t2@1 () T@$Value)
(declare-fun $abort_code@11 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@9 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_code@5 () Int)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 () T@$Value)
(declare-fun $Option_Option_$memory () T@$Memory)
(declare-fun $DiemAccount_KeyRotationCapability_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 318562) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 316375) (- 0 326107)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@21) (and (=> (= (ControlFlow 0 316375) (- 0 326119)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@21) (and (=> (= (ControlFlow 0 316375) (- 0 326137)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@21) (and (=> (= (ControlFlow 0 316375) (- 0 326149)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey public_key@@2))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey public_key@@2))))) $abort_flag@21) (and (=> (= (ControlFlow 0 316375) (- 0 326164)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1)))) len@@0 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@0 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1)))) len@@0 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@0 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@21) (and (=> (= (ControlFlow 0 316375) (- 0 326211)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@2)))) ($Integer 32))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@2)))) ($Integer 32))))) $abort_flag@21) (and (=> (= (ControlFlow 0 316375) (- 0 326232)) (=> $abort_flag@21 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey public_key@@2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1)))) len@@2 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@2 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@2)))) ($Integer 32)))))))) (=> (=> $abort_flag@21 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey public_key@@2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1)))) len@@2 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@2 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@2)))) ($Integer 32))))))) (and (=> (= (ControlFlow 0 316375) (- 0 326352)) (=> $abort_flag@21 (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@33 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@33 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey public_key@@2))))) (= $abort_code@33 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1)))) len@@4 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@4 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@2)))) ($Integer 32))))) (= $abort_code@33 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@21 (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@33 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@33 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey public_key@@2))))) (= $abort_code@33 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1)))) len@@4 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@4 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@2)))) ($Integer 32))))) (= $abort_code@33 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 316375) (- 0 326538)) (=> $abort_flag@21 (or (or (= $abort_code@33 (|i#$Integer| ($Integer 1))) (= $abort_code@33 (|i#$Integer| ($Integer 6)))) (= $abort_code@33 (|i#$Integer| ($Integer 7)))))) (=> (=> $abort_flag@21 (or (or (= $abort_code@33 (|i#$Integer| ($Integer 1))) (= $abort_code@33 (|i#$Integer| ($Integer 6)))) (= $abort_code@33 (|i#$Integer| ($Integer 7))))) (and (=> (= (ControlFlow 0 316375) (- 0 326572)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0))))) (=> (= (ControlFlow 0 316375) (- 0 326586)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key) public_key@@2)))))))))))))))))))))))))))
(let ((inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon9_Else_correct  (=> (not $abort_flag@20) (=> (and (= $abort_flag@21 $abort_flag@20) (= (ControlFlow 0 316347) 316375)) anon0$2_correct))))
(let ((inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon9_Then_correct  (=> $abort_flag@20 (=> (and (= $abort_flag@21 true) (= (ControlFlow 0 316353) 316375)) anon0$2_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon41_Else_correct  (=> (not $abort_flag@19) (=> (and (and (= $DiemAccount_DiemAccount_$memory@5 $DiemAccount_DiemAccount_$memory@3) (= $abort_flag@20 $abort_flag@19)) (and (= $abort_code@33 $abort_code@31) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1 |inline$$MoveToRaw$0$m'@2|))) (and (=> (= (ControlFlow 0 316233) 316353) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 316233) 316347) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon9_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct  (=> (and (and (= $DiemAccount_DiemAccount_$memory@5 $DiemAccount_DiemAccount_$memory@4) (= $abort_flag@20 true)) (and (= $abort_code@33 $abort_code@32) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0))) (and (=> (= (ControlFlow 0 315891) 316353) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 315891) 316347) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon13_correct  (=> (and (and (= $abort_code@32 $abort_code@28) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 316289) 315891))) inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 316287) 316289)) inline$$SharedEd25519PublicKey_publish_$def$0$anon13_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon35_Then_correct  (=> (= (ControlFlow 0 316297) 316289) inline$$SharedEd25519PublicKey_publish_$def$0$anon13_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon34_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 316281) 316297) inline$$SharedEd25519PublicKey_publish_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 316281) 316287) inline$$SharedEd25519PublicKey_publish_$def$0$anon35_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon19_correct  (=> (and (and (= $abort_code@32 $abort_code@29) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 316265) 315891))) inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 316263) 316265)) inline$$SharedEd25519PublicKey_publish_$def$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 316273) 316265) inline$$SharedEd25519PublicKey_publish_$def$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon37_Then_correct  (=> $abort_flag@18 (and (=> (= (ControlFlow 0 316257) 316273) inline$$SharedEd25519PublicKey_publish_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 316257) 316263) inline$$SharedEd25519PublicKey_publish_$def$0$anon38_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon27_correct  (=> (and (and (= $abort_code@32 $abort_code@31) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 |inline$$MoveToRaw$0$m'@2|)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 316245) 315891))) inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 316243) 316245)) inline$$SharedEd25519PublicKey_publish_$def$0$anon27_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 316253) 316245) inline$$SharedEd25519PublicKey_publish_$def$0$anon27_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon41_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 316237) 316253) inline$$SharedEd25519PublicKey_publish_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 316237) 316243) inline$$SharedEd25519PublicKey_publish_$def$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_code@31 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@19 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 316211) 316237) inline$$SharedEd25519PublicKey_publish_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 316211) 316233) inline$$SharedEd25519PublicKey_publish_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 316209) 316211)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 |inline$$WritebackToValue$1$vdst'@2|))) (= $abort_code@31 $abort_code@29)) (and (= $abort_flag@19 $abort_flag@18) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 316159) 316237) inline$$SharedEd25519PublicKey_publish_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 316159) 316233) inline$$SharedEd25519PublicKey_publish_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account@@0)) (and (=> (= (ControlFlow 0 316217) 316209) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 316217) 316159) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 316005) (- 0 325826)) true) (=> (= (ControlFlow 0 316005) 316217) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 316225) 316005)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon24_correct  (=> (and (and (= $abort_code@32 $abort_code@30) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 315887) 315891))) inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 315885) 315887)) inline$$SharedEd25519PublicKey_publish_$def$0$anon24_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 315899) 315887) inline$$SharedEd25519PublicKey_publish_$def$0$anon24_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@30 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 315879) 315899) inline$$SharedEd25519PublicKey_publish_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 315879) 315885) inline$$SharedEd25519PublicKey_publish_$def$0$anon40_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon37_Else_correct  (=> (not $abort_flag@18) (and (=> (= (ControlFlow 0 315867) 316225) inline$$SharedEd25519PublicKey_publish_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 315867) 315879) inline$$SharedEd25519PublicKey_publish_$def$0$anon39_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Else$1_correct  (=> (and (and (and (= inline$$SharedEd25519PublicKey_publish_$def$0$$t14@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@18)) (and (=> $abort_flag@18 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 315861) 316257) inline$$SharedEd25519PublicKey_publish_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 315861) 315867) inline$$SharedEd25519PublicKey_publish_$def$0$anon37_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1)))) (= (ControlFlow 0 315849) 315861)) inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 315839) (- 0 325685)) true) (=> (= (ControlFlow 0 315839) 315849) inline$$Not$1$anon0_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 315855) 315839)) inline$$Not$1$Entry_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Then_correct  (=> $abort_flag@17 (=> (and (and (= $abort_code@32 $abort_code@28) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 316277) 315891))) inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 315767) 316277) inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 315767) 315855) inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 315777) 316277) inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 315777) 315855) inline$$SharedEd25519PublicKey_publish_$def$0$anon36_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct  (=> (= inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0)))) (and (=> (= (ControlFlow 0 315761) 315777) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 315761) 315767) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 315715) 315761)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 315785) 315761) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct  (=> (not $abort_flag@17) (and (=> (= (ControlFlow 0 315709) 315785) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 315709) 315715) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@0) (= (ControlFlow 0 315791) 315709)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon34_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 315799) 315791)) inline$$SharedEd25519PublicKey_exists_at$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Else$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@17) (=> $abort_flag@17 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 315553) 316281) inline$$SharedEd25519PublicKey_publish_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 315553) 315799) inline$$SharedEd25519PublicKey_publish_$def$0$anon34_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1) (= (ControlFlow 0 315519) 315553)) inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Else$2_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1|) ($Local 2)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1|) 0 inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1 (|v#$Mutation| |inline$$WriteRef$3$to'@1|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 315545) 315553))) inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Else$2_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 315420) 315545) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 315420) 315519) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@16) (= (ControlFlow 0 315426) 315420)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Then_correct  (=> $abort_flag@16 (=> (and (and (= $abort_code@32 $abort_code@27) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 316301) 315891))) inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct  (=> (and (and (= $abort_code@27 $abort_code@25) (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|)) (and (= $abort_flag@16 $abort_flag@15) (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@1))) (and (=> (= (ControlFlow 0 315259) 316301) inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 315259) 315426) inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 315257) 315259)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 315267) 315259) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 4))) (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$1$v@1)) (and (=> (= (ControlFlow 0 315215) 315267) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 315215) 315257) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 4)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|)) (and (=> (= (ControlFlow 0 315241) 315267) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 315241) 315257) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct))))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 315060) 315241) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 315060) 315215) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (and (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$2$to'@1|)))) (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|))) (and (=> (= (ControlFlow 0 315116) 315241) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 315116) 315215) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 315024) 315116) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 315024) 315060) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (and (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) public_key@@2)) (= (ControlFlow 0 314881) 315024)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_key) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) (= (ControlFlow 0 314822) 314881))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 314828) 314822)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct  (=> (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1 $Error) (=> (and (and (= $abort_code@27 $abort_code@26) (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2 inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1)) (and (= $abort_flag@16 true) (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@2))) (and (=> (= (ControlFlow 0 312168) 316301) inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 312168) 315426) inline$$SharedEd25519PublicKey_publish_$def$0$anon33_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct  (=> (= $abort_code@26 $abort_code@15) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 315323) 312168)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 315321) 315323)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 315331) 315323) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 315315) 315331) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 315315) 315321) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct  (=> (= $abort_code@26 $abort_code@16) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 315303) 312168)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 315301) 315303)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 315311) 315303) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 315295) 315311) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 315295) 315301) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct  (=> (= $abort_code@26 $abort_code@18) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 315283) 312168)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 315281) 315283)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 315291) 315283) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 315275) 315291) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 315275) 315281) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct  (=> (and (and $abort_flag@15 (= $abort_code@26 $abort_code@25)) (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@1) (= (ControlFlow 0 315271) 312168))) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct  (=> (= $abort_flag@15 $abort_flag@14) (=> (and (= $DiemAccount_DiemAccount_$memory@1 |inline$$WritebackToGlobal$1$m'@2|) (= $abort_code@25 $abort_code@22)) (and (=> (= (ControlFlow 0 314578) 315271) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 314578) 314828) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 314516) 314578)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 314570) 314578))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 314506) 314570) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 314506) 314516) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= (ControlFlow 0 314384) 314506)) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 314305) 314384)) inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 314361) 314384))) inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 314269) 314361) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 314269) 314305) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 314132) 314269)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct  (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 314588) 314269)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1) (|p#$Mutation| inline$$BorrowField$2$dst@1) call3formal@$ret0@0@@1)) (and (=> (= (ControlFlow 0 314118) 314588) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 314118) 314132) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $DiemAccount_DiemAccount_authentication_key) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $DiemAccount_DiemAccount_authentication_key))) (= (ControlFlow 0 314059) 314118))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1) (= (ControlFlow 0 314065) 314059)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct  (=> (= $abort_flag@15 true) (=> (and (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory@0) (= $abort_code@25 $abort_code@24)) (and (=> (= (ControlFlow 0 313505) 315271) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 313505) 314828) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct  (=> (and (= $abort_code@24 $abort_code@19) (= (ControlFlow 0 314660) 313505)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 314658) 314660)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 314668) 314660) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 314652) 314668) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 314652) 314658) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct  (=> (and (= $abort_code@24 $abort_code@21) (= (ControlFlow 0 314640) 313505)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 314638) 314640)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 314648) 314640) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 314632) 314648) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 314632) 314638) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct  (=> (and (= $abort_code@24 $abort_code@21) (= (ControlFlow 0 314620) 313505)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 314618) 314620)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct  (=> (= (ControlFlow 0 314628) 314620) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 314612) 314628) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 314612) 314618) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct  (=> (and (= $abort_code@24 $abort_code@22) (= (ControlFlow 0 314600) 313505)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 314598) 314600)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct  (=> (= (ControlFlow 0 314608) 314600) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 314592) 314608) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 314592) 314598) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct  (=> (and (= $abort_code@24 $abort_code@23) (= (ControlFlow 0 313929) 313505)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 313927) 313929)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct  (=> (= (ControlFlow 0 313937) 313929) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct  (=> (= $abort_code@23 (|i#$Integer| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 313921) 313937) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 313921) 313927) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 313909) 313921)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1)) (= (ControlFlow 0 313915) 313909)) inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct  (=> (not $abort_flag@14) (and (=> (= (ControlFlow 0 313886) 314065) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 313886) 313915) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct  (=> (not $abort_flag@13) (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1 ($Integer 32)) (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1 inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1)))) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@14)) (and (=> $abort_flag@14 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 313880) 314592) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 313880) 313886) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct)))))))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) call3formal@$ret0@0@@1) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1))))) (and (=> (= (ControlFlow 0 313850) 314612) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 313850) 313880) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 313838) 313850)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$1$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 313795) 313838)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$1$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 313789) 313795)) inline$$DiemAccount_DiemAccount_$unpack_ref$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@13) (= (ControlFlow 0 313799) 313789)) inline$$DiemAccount_DiemAccount_$unpack_ref$1$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@21 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@13 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 313756) 314632) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 313756) 313799) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 313754) 313756)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1))) (= $abort_code@21 $abort_code@19)) (and (= $abort_flag@13 $abort_flag@12) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 313702) 314632) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 313702) 313799) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$GetFieldFromValue$2$dst@1)) (and (=> (= (ControlFlow 0 313672) 313754) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 313672) 313702) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 313666) (- 0 324335)) true) (=> (= (ControlFlow 0 313666) 313672) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 313559) 313666)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$2$$t2@1) (= (ControlFlow 0 313565) 313559)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct  (=> (and (= $abort_code@24 $abort_code@20) (= (ControlFlow 0 313501) 313505)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 313499) 313501)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 313513) 313501) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$2$$t2@1)) (= $abort_code@20 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 313493) 313513) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 313493) 313499) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 313481) 313565) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 313481) 313493) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct  (=> (not $abort_flag@11) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@12)) (and (=> $abort_flag@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 313475) 314652) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 313475) 313481) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct  (=> $abort_flag@11 (=> (and (= $abort_code@24 $abort_code@18) (= (ControlFlow 0 314672) 313505)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 313431) 314672) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 313431) 313475) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon6_Then_correct  (and (=> (= (ControlFlow 0 313441) 314672) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 313441) 313475) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$2$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$1$dst@1)))) (and (=> (= (ControlFlow 0 313425) 313441) inline$$DiemAccount_exists_at_$def$2$anon6_Then_correct) (=> (= (ControlFlow 0 313425) 313431) inline$$DiemAccount_exists_at_$def$2$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 313379) 313425)) inline$$DiemAccount_exists_at_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$2$anon5_Then_correct  (=> (= (ControlFlow 0 313449) 313425) inline$$DiemAccount_exists_at_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$2$anon0_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 313373) 313449) inline$$DiemAccount_exists_at_$def$2$anon5_Then_correct) (=> (= (ControlFlow 0 313373) 313379) inline$$DiemAccount_exists_at_$def$2$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$2$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$1$dst@1) (= (ControlFlow 0 313455) 313373)) inline$$DiemAccount_exists_at_$def$2$anon0_correct)))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 313215) 313455)) inline$$DiemAccount_exists_at$2$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 313105) 313215)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 314680) 313215) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 313097) 314680) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 313097) 313105) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 314688) 314680) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 314688) 313105) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 313091) 314688) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 313091) 313097) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$2$v@1) (let ((va@@12 (|v#$Vector| inline$$ReadRef$2$v@1)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $DiemAccount_KeyRotationCapability_account_address))) true) (and (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@13 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (forall ((inline$$DiemAccount_rotate_authentication_key$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_rotate_authentication_key$0$$$0 0) (< inline$$DiemAccount_rotate_authentication_key$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0))
))) (= (ControlFlow 0 314692) 313091))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 314698) 314692)) inline$$DiemAccount_rotate_authentication_key$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then$1_correct  (and (=> (= (ControlFlow 0 312392) (- 0 323863)) true) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11) (=> (and (=> $abort_flag@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Authenticator_spec_ed25519_authentication_key public_key@@2)))))) (=> (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@14 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@3))
))) (and (=> (= (ControlFlow 0 312392) 315275) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 312392) 314698) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Else_correct))))))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 312372) 312392)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then$1_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) (= (ControlFlow 0 312334) 312372))) inline$$ReadRef$2$anon0_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1) (= (ControlFlow 0 312386) 312334)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct  (=> (= $abort_code@26 $abort_code@17) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 312162) 312168)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 312160) 312162)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 312176) 312162) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1)) (= $abort_code@17 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 312154) 312176) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 312154) 312160) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Else_correct  (=> (not $abort_flag@10) (and (=> (= (ControlFlow 0 312142) 312386) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 312142) 312154) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Else_correct  (=> (not $abort_flag@9) (=> (and (and (and (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10)) (and (=> $abort_flag@10 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 312136) 315295) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 312136) 312142) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Else_correct))))))
(let ((inline$$Signature_ed25519_validate_pubkey$0$anon0_correct  (=> (= inline$$Signature_ed25519_validate_pubkey$0$res@1 ($Signature_$ed25519_validate_pubkey public_key@@2)) (and (=> (= (ControlFlow 0 312118) 315315) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 312118) 312136) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Else_correct)))))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 4) $EmptyPath inline$$ReadRef$1$v@1)) (= (ControlFlow 0 312080) 312118)) inline$$Signature_ed25519_validate_pubkey$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 311962) 312080)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 315339) 312080) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 311954) 315339) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 311954) 311962) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 315347) 315339) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 315347) 311962) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon0_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 311948) 315347) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 311948) 311954) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$0$anon0_correct  (=> (and (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1) (let ((va@@15 (|v#$Vector| inline$$ReadRef$1$v@1)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@4))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) (and (and (and ((_ is $Vector) public_key@@2) (let ((va@@18 (|v#$Vector| public_key@@2)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (forall ((inline$$SharedEd25519PublicKey_rotate_key_$0$$$0 Int) ) (!  (=> (and (>= inline$$SharedEd25519PublicKey_rotate_key_$0$$$0 0) (< inline$$SharedEd25519PublicKey_rotate_key_$0$$$0 (|l#$ValueArray| (|v#$Vector| public_key@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_rotate_key_$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_rotate_key_$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_rotate_key_$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_rotate_key_$0$$$0))
))) (= (ControlFlow 0 315353) 311948))) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon8$2_correct  (and (=> (= (ControlFlow 0 315361) (- 0 323477)) true) (=> (= (ControlFlow 0 315361) 315353) inline$$SharedEd25519PublicKey_rotate_key_$0$anon0_correct))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 311371) 315361)) inline$$SharedEd25519PublicKey_publish_$def$0$anon8$2_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 2) $EmptyPath inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1)) (= (ControlFlow 0 311333) 311371)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 311283) 311333)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 316309) 311333) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 311263) 316309) inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 311263) 311283) inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 311269) 316309) inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 311269) 311283) inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Then_correct  (=> (> 1476 0) (and (=> (= (ControlFlow 0 311257) 311269) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 311257) 311263) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Else_correct  (=> (>= 0 1476) (and (=> (= (ControlFlow 0 311249) 316309) inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 311249) 311283) inline$$SharedEd25519PublicKey_publish_$def$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon0_correct  (=> (and (and ((_ is $Vector) inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1) (let ((va@@19 (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1)))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (forall ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0 0) (< inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0))
))) (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) (let ((va@@20 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (= inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1) 1 inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) 2)))) (and (=> (= (ControlFlow 0 311241) 311257) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 311241) 311249) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 311275) 311241)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon31_Then_correct  (=> $abort_flag@9 (=> (and (and (= $abort_code@32 $abort_code@15) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 316313) 315891))) inline$$SharedEd25519PublicKey_publish_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct  (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0) (= $abort_flag@9 $abort_flag@8)) (and (= $abort_code@15 $abort_code@13) (= $DiemAccount_DiemAccount_$memory@0 |inline$$WritebackToGlobal$0$m'@2|))) (and (=> (= (ControlFlow 0 310863) 316313) inline$$SharedEd25519PublicKey_publish_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 310863) 311275) inline$$SharedEd25519PublicKey_publish_$def$0$anon31_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 310861) 310863)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 310871) 310863) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (= |inline$$WritebackToGlobal$0$m'@2| $DiemAccount_DiemAccount_$memory)) (and (=> (= (ControlFlow 0 310791) 310871) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 310791) 310861) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1))) (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|))) (and (=> (= (ControlFlow 0 310845) 310871) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 310845) 310861) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 310781) 310845) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 310781) 310791) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 310659) 310781)) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 310580) 310659)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 310636) 310659))) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 310544) 310636) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 310544) 310580) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 310403) (- 0 322910)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 310403) 310544) inline$$WritebackToReference$0$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)) (= (ControlFlow 0 310379) 310403)) inline$$Option_Option_$pack_ref$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 310333) 310379)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct  (=> (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 310881) 310379)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 310319) 310881) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 310319) 310333) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 310325) 310319)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct  (=> (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@9 true)) (and (= $abort_code@15 $abort_code@14) (= $DiemAccount_DiemAccount_$memory@0 $DiemAccount_DiemAccount_$memory))) (and (=> (= (ControlFlow 0 309518) 316313) inline$$SharedEd25519PublicKey_publish_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 309518) 311275) inline$$SharedEd25519PublicKey_publish_$def$0$anon31_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct  (=> (and (= $abort_code@14 $abort_code@1) (= (ControlFlow 0 310981) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 310979) 310981)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 310989) 310981) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 310973) 310989) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 310973) 310979) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct  (=> (and (= $abort_code@14 $abort_code@8) (= (ControlFlow 0 310957) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 310955) 310957)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 310965) 310957) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 310949) 310965) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 310949) 310955) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct  (=> (and (= $abort_code@14 $abort_code@10) (= (ControlFlow 0 310933) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 310931) 310933)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 310941) 310933) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 310925) 310941) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 310925) 310931) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct  (=> (and (= $abort_code@14 $abort_code@12) (= (ControlFlow 0 310913) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 310911) 310913)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 310921) 310913) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 310905) 310921) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 310905) 310911) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct  (=> (and (= $abort_code@14 $abort_code@13) (= (ControlFlow 0 310893) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 310891) 310893)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 310901) 310893) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 310885) 310901) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 310885) 310891) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct  (and (=> (= (ControlFlow 0 310262) (- 0 322746)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (and (= call0formal@$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@8)) (=> (and (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0))))) (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@13 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Vector_$borrow call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec) ($Integer 0)))))) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) ($Integer 0))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@21 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 310262) 310885) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 310262) 310325) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct)))))))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 310250) 310262)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$0$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 310214) 310250)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 310208) 310214)) inline$$Option_Option_$unpack_ref$0$anon0_correct))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemAccount_DiemAccount_key_rotation_capability) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemAccount_DiemAccount_key_rotation_capability))) (= (ControlFlow 0 310174) 310208))) inline$$Option_Option_$unpack_ref$0$Entry_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 310052) 310174)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 310046) 310052)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 310056) 310046)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_code@12 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 310013) 310905) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 310013) 310056) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 310011) 310013)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_code@12 $abort_code@10)) (and (= $abort_flag@7 $abort_flag@6) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 309959) 310905) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 309959) 310056) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@5)) (and (=> (= (ControlFlow 0 309929) 310011) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 309929) 309959) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 309923) (- 0 322529)) true) (=> (= (ControlFlow 0 309923) 309929) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1) (= (ControlFlow 0 310019) 309923)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct  (=> (and (= $abort_code@14 $abort_code@11) (= (ControlFlow 0 309810) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 309808) 309810)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 309818) 309810) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1)) (= $abort_code@11 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 309802) 309818) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 309802) 309808) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 309790) 310019) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 309790) 309802) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct  (=> (not $abort_flag@5) (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 309784) 310925) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 309784) 309790) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct  (=> $abort_flag@5 (=> (and (= $abort_code@14 $abort_code@8) (= (ControlFlow 0 310945) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 309740) 310945) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 309740) 309784) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 309750) 310945) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 309750) 309784) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$1$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5)))) (and (=> (= (ControlFlow 0 309734) 309750) inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 309734) 309740) inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 309688) 309734)) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 309758) 309734) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon0_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 309682) 309758) inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 309682) 309688) inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$1$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@5) (= (ControlFlow 0 309764) 309682)) inline$$DiemAccount_exists_at_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 309772) 309764)) inline$$DiemAccount_exists_at$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct  (=> (and (= $abort_code@14 $abort_code@9) (= (ControlFlow 0 309512) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 309510) 309512)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 309526) 309512) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@9 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 309504) 309526) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 309504) 309510) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 309492) 309772) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 309492) 309504) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 309486) 310949) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 309486) 309492) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2)))) (= (ControlFlow 0 309474) 309486)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 309464) (- 0 322226)) true) (=> (= (ControlFlow 0 309464) 309474) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 309480) 309464)) inline$$Not$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct  (=> $abort_flag@4 (=> (and (= $abort_code@14 $abort_code@7) (= (ControlFlow 0 310969) 309518)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct  (=> (= $abort_code@7 $abort_code@5) (=> (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0@@0) (= $abort_flag@4 $abort_flag@3)) (and (=> (= (ControlFlow 0 309330) 310969) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 309330) 309480) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 309328) 309330)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 309338) 309330) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 309322) 309338) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 309322) 309328) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct  (=> (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 $Error) (= $abort_code@7 $abort_code@6)) (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@4 true))) (and (=> (= (ControlFlow 0 309071) 310969) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 309071) 309480) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct  (=> (and (= $abort_code@6 $abort_code@2) (= (ControlFlow 0 309390) 309071)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 309388) 309390)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 309398) 309390) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 309382) 309398) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 309382) 309388) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct  (=> (and (= $abort_code@6 $abort_code@4) (= (ControlFlow 0 309370) 309071)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 309368) 309370)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 309378) 309370) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 309362) 309378) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 309362) 309368) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct  (=> (and (= $abort_code@6 $abort_code@5) (= (ControlFlow 0 309350) 309071)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 309348) 309350)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 309358) 309350) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 309342) 309358) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 309342) 309348) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct  (=> (= call0formal@$tv0@0@@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3) (=> $abort_flag@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)) $Option_Option_vec)) ($Integer 0))))))) ((_ is $Boolean) call4formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 309314) 309342) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 309314) 309322) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $DiemAccount_DiemAccount_key_rotation_capability)) (= (ControlFlow 0 309306) 309314)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 309312) 309306)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@2 true) (=> (and (= $abort_code@4 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 309252) 309362) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 309252) 309312) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 309250) 309252)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5))) (= $abort_flag@2 $abort_flag@1)) (and (= $abort_code@4 $abort_code@2) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 309198) 309362) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 309198) 309312) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@5)) (and (=> (= (ControlFlow 0 309180) 309250) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 309180) 309198) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 309174) (- 0 321941)) true) (=> (= (ControlFlow 0 309174) 309180) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1) (= (ControlFlow 0 309258) 309174)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct  (=> (and (= $abort_code@6 $abort_code@3) (= (ControlFlow 0 309065) 309071)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 309063) 309065)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 309079) 309065) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 309057) 309079) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 309057) 309063) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 309045) 309258) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 309045) 309057) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct  (=> (not $abort_flag@0) (=> (and (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 309039) 309382) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 309039) 309045) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct  (=> $abort_flag@0 (=> (and (= $abort_code@6 $abort_code@1) (= (ControlFlow 0 309402) 309071)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308995) 309402) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 308995) 309039) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 309005) 309402) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 309005) 309039) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5)))) (and (=> (= (ControlFlow 0 308989) 309005) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 308989) 308995) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 308943) 308989)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 309013) 308989) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 308937) 309013) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 308937) 308943) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@5) (= (ControlFlow 0 309019) 308937)) inline$$DiemAccount_exists_at_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 308751) 309019)) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 309410) 309019) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 308745) 309410) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 308745) 308751) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@5) (= (ControlFlow 0 309416) 308745)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 309424) 309416)) inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 308335) 310973) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 308335) 309424) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 308299) 308335)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 310997) 308335) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 308293) 310997) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 308293) 308299) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability$0$anon0_correct  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 311003) 308293)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon4$2_correct  (=> (and (= inline$$SharedEd25519PublicKey_publish_$def$0$$t7@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (= (ControlFlow 0 311011) 311003)) inline$$DiemAccount_extract_key_rotation_capability$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 307545) 311011)) inline$$SharedEd25519PublicKey_publish_$def$0$anon4$2_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 316321) 311011) inline$$SharedEd25519PublicKey_publish_$def$0$anon4$2_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307537) 316321) inline$$SharedEd25519PublicKey_publish_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 307537) 307545) inline$$SharedEd25519PublicKey_publish_$def$0$anon30_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 316329) 316321) inline$$SharedEd25519PublicKey_publish_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 316329) 307545) inline$$SharedEd25519PublicKey_publish_$def$0$anon30_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 307531) 316329) inline$$SharedEd25519PublicKey_publish_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 307531) 307537) inline$$SharedEd25519PublicKey_publish_$def$0$anon29_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$direct_inter$0$anon0_correct  (=> ((_ is $Address) account@@0) (=> (and (and (and ((_ is $Vector) public_key@@2) (let ((va@@23 (|v#$Vector| public_key@@2)))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (forall ((inline$$SharedEd25519PublicKey_publish_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$SharedEd25519PublicKey_publish_$direct_inter$0$$$0 0) (< inline$$SharedEd25519PublicKey_publish_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| public_key@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_publish_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_publish_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_publish_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) inline$$SharedEd25519PublicKey_publish_$direct_inter$0$$$0))
))) (= (ControlFlow 0 316333) 307531)) inline$$SharedEd25519PublicKey_publish_$def$0$anon0_correct))))
(let ((inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 306835) 316333)) inline$$SharedEd25519PublicKey_publish_$direct_inter$0$anon0_correct)))
(let ((inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 316361) 316333) inline$$SharedEd25519PublicKey_publish_$direct_inter$0$anon0_correct)))
(let ((inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306827) 316361) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 306827) 306835) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 316369) 316361) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 316369) 306835) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon8_Else_correct))))
(let ((inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 306821) 316369) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 306821) 306827) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $Option_Option_vec)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $Option_Option_vec))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_authentication_key))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_authentication_key))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_authentication_key))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_authentication_key))) $$0@@5))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (=> (and (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@36 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_KeyRotationCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@37 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@8))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@2))
))) (and (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))))))))))) (and (|b#$Boolean| (let ((addr@@3 account@@0))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (= (ControlFlow 0 316373) 306821)))) inline$$publish_shared_ed25519_public_key_publish_shared_ed25519_public_key_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> ((_ is $Address) account@@0) (=> (and (and (and ((_ is $Vector) public_key@@2) (let ((va@@40 (|v#$Vector| public_key@@2)))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| public_key@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@9))
))) (= (ControlFlow 0 306358) 316373)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 318562) 306358) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
