(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestResources_A () T@$TypeName)
(declare-fun $TestResources_B () T@$TypeName)
(declare-fun $TestResources_C () T@$TypeName)
(declare-fun $TestResources_R () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestResources_A_addr () Int)
(declare-fun $TestResources_A_val () Int)
(declare-fun $TestResources_A_type_value () T@$TypeValue)
(declare-fun $TestResources_B_val () Int)
(declare-fun $TestResources_B_a () Int)
(declare-fun $TestResources_B_type_value () T@$TypeValue)
(declare-fun $TestResources_C_val () Int)
(declare-fun $TestResources_C_b () Int)
(declare-fun $TestResources_C_type_value () T@$TypeValue)
(declare-fun $TestResources_R_x () Int)
(declare-fun $TestResources_R_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestResources_A $TestResources_B $TestResources_C $TestResources_R)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestResources_A_addr 0))
(assert (= $TestResources_A_val 1))
(assert (= $TestResources_A_type_value ($StructType $TestResources_A $EmptyTypeValueArray)))
(assert (= $TestResources_B_val 0))
(assert (= $TestResources_B_a 1))
(assert (= $TestResources_B_type_value ($StructType $TestResources_B $EmptyTypeValueArray)))
(assert (= $TestResources_C_val 0))
(assert (= $TestResources_C_b 1))
(assert (= $TestResources_C_type_value ($StructType $TestResources_C $EmptyTypeValueArray)))
(assert (= $TestResources_R_x 0))
(assert (= $TestResources_R_type_value ($StructType $TestResources_R $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $TestResources_R_$memory () T@$Memory)
(declare-fun a () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 45200) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 24518) (- 0 45618)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a))))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a))))))) $abort_flag@2) (=> (= (ControlFlow 0 24518) (- 0 45637)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a)))))))))))))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@2 true) (= (ControlFlow 0 24476) 24518)) anon0$2_correct)))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 24494) 24476)) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 24504) 24476) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon12_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 24488) 24504) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 24488) 24494) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 24470) 24476)) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 24484) 24476) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon14_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 24464) 24484) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 24464) 24470) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@1) (=> (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 24460) 24518)) anon0$2_correct))))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_flag@1 true) (and (=> (= (ControlFlow 0 24446) 24464) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 24446) 24460) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 24444) 24446)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (=> (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1))) (= $abort_flag@1 $abort_flag@0)) (and (=> (= (ControlFlow 0 24392) 24464) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 24392) 24460) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| a)) (and (=> (= (ControlFlow 0 24362) 24444) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 24362) 24392) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 24356) (- 0 45500)) true) (=> (= (ControlFlow 0 24356) 24362) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon12_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 24452) 24356)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@0 true) (and (=> (= (ControlFlow 0 24243) 24488) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 24243) 24452) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 24241) 24243)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_flag@0 false)) (and (=> (= (ControlFlow 0 24189) 24488) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 24189) 24452) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| a)) (and (=> (= (ControlFlow 0 24159) 24241) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 24159) 24189) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 24153) (- 0 45412)) true) (=> (= (ControlFlow 0 24153) 24159) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 24018) 24153)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 24512) 24153) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24012) 24512) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 24012) 24018) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 24516) 24012)) inline$$TestResources_borrow_global_mut_correct_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) a) (= (ControlFlow 0 23797) 24516)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 45200) 23797) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$TestResources_R_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$TestResources_create_resource_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 45668) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 25391) (- 0 46121)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $abort_flag@1@@0)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $abort_flag@1@@0) (and (=> (= (ControlFlow 0 25391) (- 0 46135)) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account)))))) (=> (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account))))) (=> (= (ControlFlow 0 25391) (- 0 46149)) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| account))))))))))))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon5_correct  (=> (and (= $abort_flag@1@@0 true) (= (ControlFlow 0 25369) 25391)) anon0$2_correct@@0)))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 25365) 25369)) inline$$TestResources_create_resource_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 25377) 25369) inline$$TestResources_create_resource_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon8_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 25359) 25377) inline$$TestResources_create_resource_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 25359) 25365) inline$$TestResources_create_resource_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= (ControlFlow 0 25355) 25391)) anon0$2_correct@@0))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@0 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 25333) 25359) inline$$TestResources_create_resource_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 25333) 25355) inline$$TestResources_create_resource_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 25331) 25333)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$TestResources_R_pack$0$$struct@1)))) (and (= $abort_flag@0@@0 false) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 25281) 25359) inline$$TestResources_create_resource_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 25281) 25355) inline$$TestResources_create_resource_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account)) (and (=> (= (ControlFlow 0 25339) 25331) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 25339) 25281) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 25127) (- 0 45991)) true) (=> (= (ControlFlow 0 25127) 25339) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$TestResources_R_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 25013) 25127)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$TestResources_R_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 25019) 25127) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$TestResources_R_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 25007) 25019) inline$$TestResources_R_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 25007) 25013) inline$$TestResources_R_pack$0$anon4_Else_correct)))))
(let ((inline$$TestResources_R_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 24999) 25127)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$TestResources_R_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestResources_create_resource_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestResources_create_resource_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestResources_create_resource_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestResources_R_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_create_resource_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 24991) 25007) inline$$TestResources_R_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 24991) 24999) inline$$TestResources_R_pack$0$anon3_Else_correct)))))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestResources_create_resource_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 25025) 24991)) inline$$TestResources_R_pack$0$anon0_correct)))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 24827) 25025)) inline$$TestResources_create_resource_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 25385) 25025) inline$$TestResources_create_resource_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_create_resource_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24821) 25385) inline$$TestResources_create_resource_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 24821) 24827) inline$$TestResources_create_resource_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (= (ControlFlow 0 25389) 24821)) inline$$TestResources_create_resource_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) account) (= (ControlFlow 0 24634) 25389)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 45668) 24634) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$TestResources_R_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$TestResources_create_resource_at_signer_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 46169) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 26284) (- 0 46622)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@1@@1)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@1@@1) (and (=> (= (ControlFlow 0 26284) (- 0 46636)) (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))) (=> (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))) (=> (= (ControlFlow 0 26284) (- 0 46650)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| account@@0))))))))))))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon5_correct  (=> (and (= $abort_flag@1@@1 true) (= (ControlFlow 0 26262) 26284)) anon0$2_correct@@1)))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 26258) 26262)) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 26270) 26262) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon8_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 26252) 26270) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 26252) 26258) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@0@@1) (=> (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= (ControlFlow 0 26248) 26284)) anon0$2_correct@@1))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@1 true) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 26226) 26252) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 26226) 26248) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 26224) 26226)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$TestResources_R_pack$0$$struct@1@@0)))) (and (= $abort_flag@0@@1 false) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 26174) 26252) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 26174) 26248) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| account@@0)) (and (=> (= (ControlFlow 0 26232) 26224) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 26232) 26174) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 26020) (- 0 46492)) true) (=> (= (ControlFlow 0 26020) 26232) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$TestResources_R_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 25906) 26020)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$TestResources_R_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 25912) 26020) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$TestResources_R_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 25900) 25912) inline$$TestResources_R_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 25900) 25906) inline$$TestResources_R_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestResources_R_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 25892) 26020)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$TestResources_R_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestResources_create_resource_at_signer_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestResources_create_resource_at_signer_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestResources_create_resource_at_signer_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestResources_R_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_create_resource_at_signer_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 25884) 25900) inline$$TestResources_R_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 25884) 25892) inline$$TestResources_R_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestResources_create_resource_at_signer_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 25918) 25884)) inline$$TestResources_R_pack$0$anon0_correct@@0)))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 25720) 25918)) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 26278) 25918) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_create_resource_at_signer_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 25714) 26278) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 25714) 25720) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (= (ControlFlow 0 26282) 25714)) inline$$TestResources_create_resource_at_signer_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 25527) 26282)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 46169) 25527) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@1 () T@$Value)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$TestResources_create_resource_incorrect_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestResources_create_resource_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 46670) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 26783) (- 0 47047)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $abort_flag@1@@2)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $abort_flag@1@@2) (and (=> (= (ControlFlow 0 26783) (- 0 47062)) (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))))) (=> (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))) (=> (= (ControlFlow 0 26783) (- 0 47077)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))))))))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@1@@2 true) (= (ControlFlow 0 26741) 26783)) anon0$2_correct@@2)))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 26759) 26741)) inline$$TestResources_create_resource_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 26769) 26741) inline$$TestResources_create_resource_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon12_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 26753) 26769) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 26753) 26759) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 26735) 26741)) inline$$TestResources_create_resource_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 26749) 26741) inline$$TestResources_create_resource_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon14_Then_correct  (=> (|b#$Boolean| inline$$TestResources_create_resource_incorrect_$def_verify$0$$t3@1) (=> (and (= inline$$TestResources_create_resource_incorrect_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@2 (|i#$Integer| inline$$TestResources_create_resource_incorrect_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 26729) 26749) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 26729) 26735) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$TestResources_create_resource_incorrect_$def_verify$0$$t3@1)) (=> (and (= $abort_flag@1@@2 $abort_flag@0@@2) (= (ControlFlow 0 26715) 26783)) anon0$2_correct@@2))))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not $abort_flag@0@@2) (= inline$$TestResources_create_resource_incorrect_$def_verify$0$$t3@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0))))) (and (=> (= (ControlFlow 0 26707) 26729) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 26707) 26715) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2) (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 account@@1)))) ((_ is $Address) call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 26693) 26753) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 26693) 26707) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 26657) 26693)) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 26777) 26693) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_create_resource_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 26651) 26777) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 26651) 26657) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (= (ControlFlow 0 26781) 26651)) inline$$TestResources_create_resource_incorrect_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) account@@1) (= (ControlFlow 0 26420) 26781)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 46670) 26420) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun a@@0 () T@$Value)
(declare-fun b () T@$Value)
(declare-fun c () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 47103) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 27333) (- 0 47393)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 27333) (- 0 47402)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 27333) (- 0 47411)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@0 a@@0))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@0 a@@0)))) (and (=> (= (ControlFlow 0 27333) (- 0 47425)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified b b))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified b b)))) (=> (= (ControlFlow 0 27333) (- 0 47439)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified c c)))))))))))))))
(let ((inline$$TestResources_identity_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 27271) 27333)) anon0$2_correct@@3)))
(let ((inline$$TestResources_identity_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 27281) 27333) anon0$2_correct@@3)))
(let ((inline$$TestResources_identity_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27261) 27281) inline$$TestResources_identity_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 27261) 27271) inline$$TestResources_identity_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_identity_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 27289) 27281) inline$$TestResources_identity_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 27289) 27271) inline$$TestResources_identity_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestResources_identity_$def_verify$0$anon16_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27251) 27289) inline$$TestResources_identity_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 27251) 27261) inline$$TestResources_identity_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestResources_identity_$def_verify$0$anon16_Then_correct  (and (=> (= (ControlFlow 0 27297) 27289) inline$$TestResources_identity_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 27297) 27261) inline$$TestResources_identity_$def_verify$0$anon17_Else_correct))))
(let ((inline$$TestResources_identity_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27139) 27297) inline$$TestResources_identity_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 27139) 27251) inline$$TestResources_identity_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestResources_identity_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 27305) 27297) inline$$TestResources_identity_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 27305) 27251) inline$$TestResources_identity_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestResources_identity_$def_verify$0$anon14_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27131) 27305) inline$$TestResources_identity_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 27131) 27139) inline$$TestResources_identity_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestResources_identity_$def_verify$0$anon14_Then_correct  (and (=> (= (ControlFlow 0 27313) 27305) inline$$TestResources_identity_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 27313) 27139) inline$$TestResources_identity_$def_verify$0$anon15_Else_correct))))
(let ((inline$$TestResources_identity_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27123) 27313) inline$$TestResources_identity_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 27123) 27131) inline$$TestResources_identity_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestResources_identity_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 27321) 27313) inline$$TestResources_identity_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 27321) 27131) inline$$TestResources_identity_$def_verify$0$anon14_Else_correct))))
(let ((inline$$TestResources_identity_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 27117) 27321) inline$$TestResources_identity_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 27117) 27123) inline$$TestResources_identity_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and (and (and (and (and (and ((_ is $Vector) a@@0) (let ((va@@12 (|v#$Vector| a@@0)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| a@@0)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| a@@0)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| a@@0)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| a@@0)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| a@@0)) $TestResources_A_val)) $MAX_U64))) true) (and (and (and (and (and ((_ is $Vector) b) (let ((va@@13 (|v#$Vector| b)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| b)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_val)) $MAX_U64))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_a)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_a))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_a))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_a))) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_a))) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_a))) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| b)) $TestResources_B_a))) $TestResources_A_val)) $MAX_U64)))) true)) (and (and (and (and (and (and ((_ is $Vector) c) (let ((va@@15 (|v#$Vector| c)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| c)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_val)) $MAX_U64))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_val)) $MAX_U64))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_a)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_a))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_a))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_a))) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_a))) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_a))) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| c)) $TestResources_C_b))) $TestResources_B_a))) $TestResources_A_val)) $MAX_U64))))) true) (= (ControlFlow 0 26871) 27117))) inline$$TestResources_identity_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 47103) 26871) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun a@@1 () T@$Value)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$MoveFrom$0$dst@2 () T@$Value)
(declare-fun inline$$TestResources_R_unpack$0$x@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@2| () T@$Memory)
(declare-fun |inline$$MoveFrom$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 47457) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 28055) (- 0 47839)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@1))))))) $abort_flag@1@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@1))))))) $abort_flag@1@@3) (=> (= (ControlFlow 0 28055) (- 0 47857)) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@1)))))))))))))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon5_correct  (=> (and (= $abort_flag@1@@3 true) (= (ControlFlow 0 28033) 28055)) anon0$2_correct@@4)))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 28029) 28033)) inline$$TestResources_move_from_addr_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 28041) 28033) inline$$TestResources_move_from_addr_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 28023) 28041) inline$$TestResources_move_from_addr_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 28023) 28029) inline$$TestResources_move_from_addr_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon8$1_correct  (=> (and (= $abort_flag@1@@3 $abort_flag@0@@3) (= (ControlFlow 0 28011) 28055)) anon0$2_correct@@4)))
(let ((inline$$TestResources_R_unpack$0$anon0_correct  (=> (and ((_ is $Vector) inline$$MoveFrom$0$dst@2) (= inline$$TestResources_R_unpack$0$x@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2)) $TestResources_R_x))) (=> (and (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1) $MAX_U64)) (= (ControlFlow 0 28003) 28011)) inline$$TestResources_move_from_addr_$def_verify$0$anon8$1_correct))))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 27951) 28003)) inline$$TestResources_R_unpack$0$anon0_correct)))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 28019) 28003) inline$$TestResources_R_unpack$0$anon0_correct)))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@3) (and (=> (= (ControlFlow 0 27945) 28019) inline$$TestResources_move_from_addr_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 27945) 27951) inline$$TestResources_move_from_addr_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@3 true) (=> (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@0|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@0)) (and (=> (= (ControlFlow 0 27929) 28023) inline$$TestResources_move_from_addr_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 27929) 27945) inline$$TestResources_move_from_addr_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 27927) 27929)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1) (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1))) (=> (and (and (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 $Error))) (= $abort_flag@0@@3 false)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@1|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@1))) (and (=> (= (ControlFlow 0 27875) 28023) inline$$TestResources_move_from_addr_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 27875) 27945) inline$$TestResources_move_from_addr_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| a@@1)) (and (=> (= (ControlFlow 0 27829) 27927) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 27829) 27875) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (and (=> (= (ControlFlow 0 27823) (- 0 47660)) true) (=> (= (ControlFlow 0 27823) 27829) inline$$MoveFrom$0$anon0_correct))))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 27669) 27823)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 28049) 27823) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$TestResources_move_from_addr_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 27663) 28049) inline$$TestResources_move_from_addr_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 27663) 27669) inline$$TestResources_move_from_addr_$def_verify$0$anon9_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (= (ControlFlow 0 28053) 27663)) inline$$TestResources_move_from_addr_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) a@@1) (= (ControlFlow 0 27463) 28053)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 47457) 27463) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun a@@2 () T@$Value)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun inline$$TestResources_R_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$TestResources_R_unpack$0$x@1@@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$dst@2@@0 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@2@@0| () T@$Memory)
(declare-fun |inline$$MoveFrom$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0@@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1@@0 () Int)
(declare-fun inline$$MoveFrom$0$dst@1@@0 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1@@0| () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 47880) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 29038) (- 0 48461)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2))))))) $abort_flag@1@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2))))))) $abort_flag@1@@4) (and (=> (= (ControlFlow 0 29038) (- 0 48479)) (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2))))))))) (=> (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2)))))))) (and (=> (= (ControlFlow 0 29038) (- 0 48497)) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2)))))) (=> (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2))))) (and (=> (= (ControlFlow 0 29038) (- 0 48511)) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@2)) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2)))) $TestResources_R_x)))))) (=> (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@2)) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2)))) $TestResources_R_x))))) (=> (= (ControlFlow 0 29038) (- 0 48538)) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2)))))))))))))))))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon5_correct  (=> (and (and (= inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@1 $Error) (= inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@2 inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@1)) (and (= $abort_flag@1@@4 true) (= (ControlFlow 0 29014) 29038))) anon0$2_correct@@5)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 29008) 29014)) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 29022) 29014) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 29002) 29022) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 29002) 29008) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon12_correct  (=> (= inline$$TestResources_move_from_addr_and_return_$def_verify$0$$ret0@2 inline$$TestResources_R_pack$0$$struct@1@@1) (=> (and (= $abort_flag@1@@4 $abort_flag@0@@4) (= (ControlFlow 0 28974) 29038)) anon0$2_correct@@5))))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 28972) 28974)) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon12_correct)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 28982) 28974) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon12_correct)))
(let ((inline$$TestResources_R_pack$0$anon4_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 28950) 28982) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 28950) 28972) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_R_pack$0$anon4_Then_correct@@1  (and (=> (= (ControlFlow 0 28956) 28982) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 28956) 28972) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestResources_R_pack$0$anon3_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 28944) 28956) inline$$TestResources_R_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 28944) 28950) inline$$TestResources_R_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestResources_R_pack$0$anon3_Else_correct@@1  (=> (>= 0 0) (and (=> (= (ControlFlow 0 28936) 28982) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 28936) 28972) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_R_pack$0$anon0_correct@@1  (=> (and (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@0) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@0) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@0) $MAX_U64)) (= inline$$TestResources_R_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_R_unpack$0$x@1@@0) 1)))) (and (=> (= (ControlFlow 0 28928) 28944) inline$$TestResources_R_pack$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 28928) 28936) inline$$TestResources_R_pack$0$anon3_Else_correct@@1)))))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 28802) 28928)) inline$$TestResources_R_pack$0$anon0_correct@@1)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 28990) 28928) inline$$TestResources_R_pack$0$anon0_correct@@1)))
(let ((inline$$TestResources_R_unpack$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$MoveFrom$0$dst@2@@0) (= inline$$TestResources_R_unpack$0$x@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2@@0)) $TestResources_R_x))) (=> (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@0) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@0) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@0) $MAX_U64)) (and (=> (= (ControlFlow 0 28788) 28990) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 28788) 28802) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 28736) 28788)) inline$$TestResources_R_unpack$0$anon0_correct@@0)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 28998) 28788) inline$$TestResources_R_unpack$0$anon0_correct@@0)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@0@@4) (and (=> (= (ControlFlow 0 28730) 28998) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 28730) 28736) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@4 true) (=> (and (= |inline$$MoveFrom$0$m'@2@@0| |inline$$MoveFrom$0$m'@0@@0|) (= inline$$MoveFrom$0$dst@2@@0 inline$$MoveFrom$0$dst@0@@0)) (and (=> (= (ControlFlow 0 28714) 29002) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 28714) 28730) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0)) (= (ControlFlow 0 28712) 28714)) inline$$MoveFrom$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveFrom$0$anon3_Else_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0) (= inline$$MoveFrom$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0))) (=> (and (and (= |inline$$MoveFrom$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0 $Error))) (= $abort_flag@0@@4 false)) (and (= |inline$$MoveFrom$0$m'@2@@0| |inline$$MoveFrom$0$m'@1@@0|) (= inline$$MoveFrom$0$dst@2@@0 inline$$MoveFrom$0$dst@1@@0))) (and (=> (= (ControlFlow 0 28660) 29002) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 28660) 28730) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct@@0  (=> (= inline$$MoveFrom$0$a@1@@0 (|a#$Address| a@@2)) (and (=> (= (ControlFlow 0 28614) 28712) inline$$MoveFrom$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 28614) 28660) inline$$MoveFrom$0$anon3_Else_correct@@0)))))
(let ((inline$$MoveFrom$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 28608) (- 0 48180)) true) (=> (= (ControlFlow 0 28608) 28614) inline$$MoveFrom$0$anon0_correct@@0))))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 28454) 28608)) inline$$MoveFrom$0$Entry_correct@@0)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 29030) 28608) inline$$MoveFrom$0$Entry_correct@@0)))
(let ((inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 28448) 29030) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 28448) 28454) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (= (ControlFlow 0 29036) 28448)) inline$$TestResources_move_from_addr_and_return_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) a@@2) (= (ControlFlow 0 28173) 29036)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 47880) 28173) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun a@@3 () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun account@@2 () T@$Value)
(declare-fun $TestResources_R_$memory@1 () T@$Memory)
(declare-fun $TestResources_R_$memory@0 () T@$Memory)
(declare-fun |inline$$MoveFrom$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@1| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$TestResources_R_pack$0$$struct@1@@2 () T@$Value)
(declare-fun inline$$TestResources_R_unpack$0$x@1@@1 () T@$Value)
(declare-fun inline$$MoveFrom$0$dst@2@@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@0@@1| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0@@1 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1@@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1@@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1@@1| () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 48562) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 30483) (- 0 49475)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3))))))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3))))))) $abort_flag@2@@0) (and (=> (= (ControlFlow 0 30483) (- 0 49493)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 a@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 a@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@2@@0) (and (=> (= (ControlFlow 0 30483) (- 0 49527)) (=> $abort_flag@2@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 a@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))))))))) (=> (=> $abort_flag@2@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 a@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))))) (and (=> (= (ControlFlow 0 30483) (- 0 49578)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@2)))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@2))))) (and (=> (= (ControlFlow 0 30483) (- 0 49594)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 a@@3)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory@1) $EmptyTypeValueArray (|a#$Address| a@@3)))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 a@@3)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory@1) $EmptyTypeValueArray (|a#$Address| a@@3))))))))))) (and (=> (= (ControlFlow 0 30483) (- 0 49634)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3)))) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@2)))) $TestResources_R_x)))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3)))) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@2)))) $TestResources_R_x))))) (=> (= (ControlFlow 0 30483) (- 0 49669)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@2)))))))))))))))))))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$Abort_correct  (=> (= $abort_flag@2@@0 true) (=> (and (= $TestResources_R_$memory@1 $TestResources_R_$memory@0) (= (ControlFlow 0 30417) 30483)) anon0$2_correct@@6))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon7_correct  (=> (and (= $TestResources_R_$memory@0 |inline$$MoveFrom$0$m'@2@@1|) (= (ControlFlow 0 30453) 30417)) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 30451) 30453)) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon7_correct)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 30461) 30453) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon7_correct)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 30445) 30461) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 30445) 30451) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon15_correct  (=> (and (= $TestResources_R_$memory@0 |inline$$MoveToRaw$0$m'@2@@1|) (= (ControlFlow 0 30413) 30417)) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 30411) 30413)) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon15_correct)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 30425) 30413) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon15_correct)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon23_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 30405) 30425) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 30405) 30411) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon23_Else_correct  (=> (and (and (not $abort_flag@1@@5) (= $abort_flag@2@@0 $abort_flag@1@@5)) (and (= $TestResources_R_$memory@1 |inline$$MoveToRaw$0$m'@2@@1|) (= (ControlFlow 0 30401) 30483))) anon0$2_correct@@6)))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@1@@5 true) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@0@@1|)) (and (=> (= (ControlFlow 0 30379) 30405) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 30379) 30401) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@1|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@1) (= (ControlFlow 0 30377) 30379)) inline$$MoveToRaw$0$anon3_Then$1_correct@@1)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@1  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@1|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@1)) (= |inline$$MoveToRaw$0$m'@1@@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@1|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveFrom$0$m'@2@@1|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@1 inline$$TestResources_R_pack$0$$struct@1@@2)))) (and (= $abort_flag@1@@5 $abort_flag@0@@5) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@1@@1|))) (and (=> (= (ControlFlow 0 30327) 30405) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 30327) 30401) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct@@1  (=> (= inline$$MoveTo$0$a@1@@1 (|a#$Address| account@@2)) (and (=> (= (ControlFlow 0 30385) 30377) inline$$MoveToRaw$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 30385) 30327) inline$$MoveToRaw$0$anon3_Else_correct@@1)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 30173) (- 0 49313)) true) (=> (= (ControlFlow 0 30173) 30385) inline$$MoveTo$0$anon0$1_correct@@1))))
(let ((inline$$TestResources_R_pack$0$anon4_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 30059) 30173)) inline$$Signer_borrow_address$0$Entry_correct@@1)))
(let ((inline$$TestResources_R_pack$0$anon4_Then_correct@@2  (=> (= (ControlFlow 0 30065) 30173) inline$$Signer_borrow_address$0$Entry_correct@@1)))
(let ((inline$$TestResources_R_pack$0$anon3_Then_correct@@2  (=> (> 0 0) (and (=> (= (ControlFlow 0 30053) 30065) inline$$TestResources_R_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 30053) 30059) inline$$TestResources_R_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$TestResources_R_pack$0$anon3_Else_correct@@2  (=> (and (>= 0 0) (= (ControlFlow 0 30045) 30173)) inline$$Signer_borrow_address$0$Entry_correct@@1)))
(let ((inline$$TestResources_R_pack$0$anon0_correct@@2  (=> (and (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@1) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@1) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@1) $MAX_U64)) (= inline$$TestResources_R_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_R_unpack$0$x@1@@1) 1)))) (and (=> (= (ControlFlow 0 30037) 30053) inline$$TestResources_R_pack$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 30037) 30045) inline$$TestResources_R_pack$0$anon3_Else_correct@@2)))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 29911) 30037)) inline$$TestResources_R_pack$0$anon0_correct@@2)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 30433) 30037) inline$$TestResources_R_pack$0$anon0_correct@@2)))
(let ((inline$$TestResources_R_unpack$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$MoveFrom$0$dst@2@@1) (= inline$$TestResources_R_unpack$0$x@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2@@1)) $TestResources_R_x))) (=> (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@1) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@1) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@1) $MAX_U64)) (and (=> (= (ControlFlow 0 29897) 30433) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 29897) 29911) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 29845) 29897)) inline$$TestResources_R_unpack$0$anon0_correct@@1)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 30441) 29897) inline$$TestResources_R_unpack$0$anon0_correct@@1)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@0@@5) (and (=> (= (ControlFlow 0 29839) 30441) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 29839) 29845) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@0@@5 true) (=> (and (= |inline$$MoveFrom$0$m'@2@@1| |inline$$MoveFrom$0$m'@0@@1|) (= inline$$MoveFrom$0$dst@2@@1 inline$$MoveFrom$0$dst@0@@1)) (and (=> (= (ControlFlow 0 29823) 30445) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 29823) 29839) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@1)) (= (ControlFlow 0 29821) 29823)) inline$$MoveFrom$0$anon3_Then$1_correct@@1)))
(let ((inline$$MoveFrom$0$anon3_Else_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@1) (= inline$$MoveFrom$0$dst@1@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@1))) (=> (and (and (= |inline$$MoveFrom$0$m'@1@@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@1 $Error))) (= $abort_flag@0@@5 false)) (and (= |inline$$MoveFrom$0$m'@2@@1| |inline$$MoveFrom$0$m'@1@@1|) (= inline$$MoveFrom$0$dst@2@@1 inline$$MoveFrom$0$dst@1@@1))) (and (=> (= (ControlFlow 0 29769) 30445) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 29769) 29839) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct@@1  (=> (= inline$$MoveFrom$0$a@1@@1 (|a#$Address| a@@3)) (and (=> (= (ControlFlow 0 29723) 29821) inline$$MoveFrom$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 29723) 29769) inline$$MoveFrom$0$anon3_Else_correct@@1)))))
(let ((inline$$MoveFrom$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 29717) (- 0 49063)) true) (=> (= (ControlFlow 0 29717) 29723) inline$$MoveFrom$0$anon0_correct@@1))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 29529) 29717)) inline$$MoveFrom$0$Entry_correct@@1)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 30469) 29717) inline$$MoveFrom$0$Entry_correct@@1)))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 29521) 30469) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 29521) 29529) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 30477) 30469) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 30477) 29529) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 29515) 30477) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 29515) 29521) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (= (ControlFlow 0 30481) 29515)) inline$$TestResources_move_from_addr_to_sender_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@6  (=> ((_ is $Address) account@@2) (=> (and ((_ is $Address) a@@3) (= (ControlFlow 0 29187) 30481)) anon0$1_correct@@5))))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 48562) 29187) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@3 () T@$Value)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $TestResources_R_$memory@1@@0 () T@$Memory)
(declare-fun $TestResources_R_$memory@0@@0 () T@$Memory)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@2@@2| () T@$Memory)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun inline$$TestResources_R_pack$0$$struct@1@@3 () T@$Value)
(declare-fun inline$$TestResources_R_unpack$0$x@1@@2 () T@$Value)
(declare-fun inline$$MoveFrom$0$dst@2@@2 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@0@@2| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0@@2 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1@@2 () Int)
(declare-fun inline$$MoveFrom$0$dst@1@@2 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1@@2| () T@$Memory)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 49701) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 31630) (- 0 50436)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 31630) (- 0 50456)) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))))) (=> (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))))))) (and (=> (= (ControlFlow 0 31630) (- 0 50476)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@2)) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $TestResources_R_x)))))) (=> (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@2)) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $TestResources_R_x))))) (=> (= (ControlFlow 0 31630) (- 0 50505)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))))))))))))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$Abort_correct  (=> (= inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $TestResources_R_$memory@1@@0 $TestResources_R_$memory@0@@0) (= inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@2 inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@1 true) (= (ControlFlow 0 31586) 31630))) anon0$2_correct@@7))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon5_correct  (=> (and (= $TestResources_R_$memory@0@@0 $TestResources_R_$memory) (= (ControlFlow 0 31606) 31586)) inline$$TestResources_move_from_sender_and_return_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 31604) 31606)) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 31614) 31606) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 31598) 31614) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 31598) 31604) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon9_correct  (=> (and (= $TestResources_R_$memory@0@@0 |inline$$MoveFrom$0$m'@2@@2|) (= (ControlFlow 0 31580) 31586)) inline$$TestResources_move_from_sender_and_return_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 31578) 31580)) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon9_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 31594) 31580) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon9_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon20_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 31572) 31594) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 31572) 31578) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon16_correct  (=> (and (and (= $TestResources_R_$memory@1@@0 |inline$$MoveFrom$0$m'@2@@2|) (= inline$$TestResources_move_from_sender_and_return_$def_verify$0$$ret0@2 inline$$TestResources_R_pack$0$$struct@1@@3)) (and (= $abort_flag@2@@1 $abort_flag@1@@6) (= (ControlFlow 0 31544) 31630))) anon0$2_correct@@7)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 31542) 31544)) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon16_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 31552) 31544) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon16_correct)))
(let ((inline$$TestResources_R_pack$0$anon4_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 31520) 31552) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 31520) 31542) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestResources_R_pack$0$anon4_Then_correct@@3  (and (=> (= (ControlFlow 0 31526) 31552) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 31526) 31542) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestResources_R_pack$0$anon3_Then_correct@@3  (=> (> 0 0) (and (=> (= (ControlFlow 0 31514) 31526) inline$$TestResources_R_pack$0$anon4_Then_correct@@3) (=> (= (ControlFlow 0 31514) 31520) inline$$TestResources_R_pack$0$anon4_Else_correct@@3)))))
(let ((inline$$TestResources_R_pack$0$anon3_Else_correct@@3  (=> (>= 0 0) (and (=> (= (ControlFlow 0 31506) 31552) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 31506) 31542) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestResources_R_pack$0$anon0_correct@@3  (=> (and (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@2) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@2) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@2) $MAX_U64)) (= inline$$TestResources_R_pack$0$$struct@1@@3 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_R_unpack$0$x@1@@2) 1)))) (and (=> (= (ControlFlow 0 31498) 31514) inline$$TestResources_R_pack$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 31498) 31506) inline$$TestResources_R_pack$0$anon3_Else_correct@@3)))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 31372) 31498)) inline$$TestResources_R_pack$0$anon0_correct@@3)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 31560) 31498) inline$$TestResources_R_pack$0$anon0_correct@@3)))
(let ((inline$$TestResources_R_unpack$0$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$MoveFrom$0$dst@2@@2) (= inline$$TestResources_R_unpack$0$x@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2@@2)) $TestResources_R_x))) (=> (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@2) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@2) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@2) $MAX_U64)) (and (=> (= (ControlFlow 0 31358) 31560) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 31358) 31372) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 31306) 31358)) inline$$TestResources_R_unpack$0$anon0_correct@@2)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 31568) 31358) inline$$TestResources_R_unpack$0$anon0_correct@@2)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@1@@6) (and (=> (= (ControlFlow 0 31300) 31568) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 31300) 31306) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@1@@6 true) (=> (and (= |inline$$MoveFrom$0$m'@2@@2| |inline$$MoveFrom$0$m'@0@@2|) (= inline$$MoveFrom$0$dst@2@@2 inline$$MoveFrom$0$dst@0@@2)) (and (=> (= (ControlFlow 0 31284) 31572) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 31284) 31300) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@2)) (= (ControlFlow 0 31282) 31284)) inline$$MoveFrom$0$anon3_Then$1_correct@@2)))
(let ((inline$$MoveFrom$0$anon3_Else_correct@@2  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@2) (= inline$$MoveFrom$0$dst@1@@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@2))) (=> (and (and (= |inline$$MoveFrom$0$m'@1@@2| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@2 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@2 $Error))) (= $abort_flag@1@@6 $abort_flag@0@@6)) (and (= |inline$$MoveFrom$0$m'@2@@2| |inline$$MoveFrom$0$m'@1@@2|) (= inline$$MoveFrom$0$dst@2@@2 inline$$MoveFrom$0$dst@1@@2))) (and (=> (= (ControlFlow 0 31230) 31572) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 31230) 31300) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct@@2  (=> (= inline$$MoveFrom$0$a@1@@2 (|a#$Address| call3formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 31184) 31282) inline$$MoveFrom$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 31184) 31230) inline$$MoveFrom$0$anon3_Else_correct@@2)))))
(let ((inline$$MoveFrom$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 31178) (- 0 50125)) true) (=> (= (ControlFlow 0 31178) 31184) inline$$MoveFrom$0$anon0_correct@@2))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@0@@6) (= (ControlFlow 0 31292) 31178)) inline$$MoveFrom$0$Entry_correct@@2)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@6) (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 account@@3)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 31054) 31598) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 31054) 31292) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 31018) 31054)) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 31622) 31054) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 31012) 31622) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 31012) 31018) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@21 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (= (ControlFlow 0 31628) 31012)) inline$$TestResources_move_from_sender_and_return_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@7  (=> (and ((_ is $Address) account@@3) (= (ControlFlow 0 30687) 31628)) anon0$1_correct@@6)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 49701) 30687) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@4 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $TestResources_R_$memory@1@@1 () T@$Memory)
(declare-fun $TestResources_R_$memory@0@@1 () T@$Memory)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@2@@3| () T@$Memory)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@2| () T@$Memory)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@2| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@2 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$TestResources_R_pack$0$$struct@1@@4 () T@$Value)
(declare-fun inline$$TestResources_R_unpack$0$x@1@@3 () T@$Value)
(declare-fun inline$$MoveFrom$0$dst@2@@3 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@0@@3| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0@@3 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1@@3 () Int)
(declare-fun inline$$MoveFrom$0$dst@1@@3 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1@@3| () T@$Memory)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 50530) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 33059) (- 0 51452)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 33059) (- 0 51472)) (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))))) (=> (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))))))) (and (=> (= (ControlFlow 0 33059) (- 0 51492)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory@1@@1) $EmptyTypeValueArray (|a#$Address| account@@4)))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory@1@@1) $EmptyTypeValueArray (|a#$Address| account@@4))))) (and (=> (= (ControlFlow 0 33059) (- 0 51508)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory@1@@1) $EmptyTypeValueArray (|a#$Address| account@@4)))) $TestResources_R_x)))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $TestResources_R_x) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory@1@@1) $EmptyTypeValueArray (|a#$Address| account@@4)))) $TestResources_R_x))))) (=> (= (ControlFlow 0 33059) (- 0 51545)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory@1@@1) $EmptyTypeValueArray (|a#$Address| account@@4)))))))))))))))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$Abort_correct  (=> (= $TestResources_R_$memory@1@@1 $TestResources_R_$memory@0@@1) (=> (and (= $abort_flag@3 true) (= (ControlFlow 0 32981) 33059)) anon0$2_correct@@8))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon5_correct  (=> (and (= $TestResources_R_$memory@0@@1 $TestResources_R_$memory) (= (ControlFlow 0 33037) 32981)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 33035) 33037)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 33045) 33037) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 33029) 33045) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 33029) 33035) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon9_correct  (=> (and (= $TestResources_R_$memory@0@@1 |inline$$MoveFrom$0$m'@2@@3|) (= (ControlFlow 0 33017) 32981)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 33015) 33017)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon9_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 33025) 33017) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon9_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 33009) 33025) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 33009) 33015) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon17_correct  (=> (and (= $TestResources_R_$memory@0@@1 |inline$$MoveToRaw$0$m'@2@@2|) (= (ControlFlow 0 32977) 32981)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$Abort_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 32975) 32977)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon17_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 32989) 32977) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon17_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 32969) 32989) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 32969) 32975) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon26_Else_correct  (=> (and (and (not $abort_flag@2@@2) (= $TestResources_R_$memory@1@@1 |inline$$MoveToRaw$0$m'@2@@2|)) (and (= $abort_flag@3 $abort_flag@2@@2) (= (ControlFlow 0 32965) 33059))) anon0$2_correct@@8)))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@2@@2 true) (= |inline$$MoveToRaw$0$m'@2@@2| |inline$$MoveToRaw$0$m'@0@@2|)) (and (=> (= (ControlFlow 0 32943) 32969) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 32943) 32965) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@2  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@3|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@2) (= (ControlFlow 0 32941) 32943)) inline$$MoveToRaw$0$anon3_Then$1_correct@@2)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@2  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@3|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@2)) (= |inline$$MoveToRaw$0$m'@1@@2| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@3|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@2 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveFrom$0$m'@2@@3|) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@2 inline$$TestResources_R_pack$0$$struct@1@@4)))) (and (= $abort_flag@2@@2 $abort_flag@1@@7) (= |inline$$MoveToRaw$0$m'@2@@2| |inline$$MoveToRaw$0$m'@1@@2|))) (and (=> (= (ControlFlow 0 32891) 32969) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 32891) 32965) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct@@2  (=> (= inline$$MoveTo$0$a@1@@2 (|a#$Address| account@@4)) (and (=> (= (ControlFlow 0 32949) 32941) inline$$MoveToRaw$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 32949) 32891) inline$$MoveToRaw$0$anon3_Else_correct@@2)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 32737) (- 0 51275)) true) (=> (= (ControlFlow 0 32737) 32949) inline$$MoveTo$0$anon0$1_correct@@2))))
(let ((inline$$TestResources_R_pack$0$anon4_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 32623) 32737)) inline$$Signer_borrow_address$0$Entry_correct@@2)))
(let ((inline$$TestResources_R_pack$0$anon4_Then_correct@@4  (=> (= (ControlFlow 0 32629) 32737) inline$$Signer_borrow_address$0$Entry_correct@@2)))
(let ((inline$$TestResources_R_pack$0$anon3_Then_correct@@4  (=> (> 0 0) (and (=> (= (ControlFlow 0 32617) 32629) inline$$TestResources_R_pack$0$anon4_Then_correct@@4) (=> (= (ControlFlow 0 32617) 32623) inline$$TestResources_R_pack$0$anon4_Else_correct@@4)))))
(let ((inline$$TestResources_R_pack$0$anon3_Else_correct@@4  (=> (and (>= 0 0) (= (ControlFlow 0 32609) 32737)) inline$$Signer_borrow_address$0$Entry_correct@@2)))
(let ((inline$$TestResources_R_pack$0$anon0_correct@@4  (=> (and (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@3) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@3) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@3) $MAX_U64)) (= inline$$TestResources_R_pack$0$$struct@1@@4 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_R_unpack$0$x@1@@3) 1)))) (and (=> (= (ControlFlow 0 32601) 32617) inline$$TestResources_R_pack$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 32601) 32609) inline$$TestResources_R_pack$0$anon3_Else_correct@@4)))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 32475) 32601)) inline$$TestResources_R_pack$0$anon0_correct@@4)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 32997) 32601) inline$$TestResources_R_pack$0$anon0_correct@@4)))
(let ((inline$$TestResources_R_unpack$0$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$MoveFrom$0$dst@2@@3) (= inline$$TestResources_R_unpack$0$x@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2@@3)) $TestResources_R_x))) (=> (and (and ((_ is $Integer) inline$$TestResources_R_unpack$0$x@1@@3) (>= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@3) 0)) (<= (|i#$Integer| inline$$TestResources_R_unpack$0$x@1@@3) $MAX_U64)) (and (=> (= (ControlFlow 0 32461) 32997) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 32461) 32475) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 32409) 32461)) inline$$TestResources_R_unpack$0$anon0_correct@@3)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 33005) 32461) inline$$TestResources_R_unpack$0$anon0_correct@@3)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@1@@7) (and (=> (= (ControlFlow 0 32403) 33005) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 32403) 32409) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct@@3  (=> (= $abort_flag@1@@7 true) (=> (and (= |inline$$MoveFrom$0$m'@2@@3| |inline$$MoveFrom$0$m'@0@@3|) (= inline$$MoveFrom$0$dst@2@@3 inline$$MoveFrom$0$dst@0@@3)) (and (=> (= (ControlFlow 0 32387) 33009) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 32387) 32403) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@3)) (= (ControlFlow 0 32385) 32387)) inline$$MoveFrom$0$anon3_Then$1_correct@@3)))
(let ((inline$$MoveFrom$0$anon3_Else_correct@@3  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@3) (= inline$$MoveFrom$0$dst@1@@3 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@3))) (=> (and (and (= |inline$$MoveFrom$0$m'@1@@3| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@3 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@3 $Error))) (= $abort_flag@1@@7 $abort_flag@0@@7)) (and (= |inline$$MoveFrom$0$m'@2@@3| |inline$$MoveFrom$0$m'@1@@3|) (= inline$$MoveFrom$0$dst@2@@3 inline$$MoveFrom$0$dst@1@@3))) (and (=> (= (ControlFlow 0 32333) 33009) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 32333) 32403) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct@@3  (=> (= inline$$MoveFrom$0$a@1@@3 (|a#$Address| call3formal@$ret0@0@@1)) (and (=> (= (ControlFlow 0 32287) 32385) inline$$MoveFrom$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 32287) 32333) inline$$MoveFrom$0$anon3_Else_correct@@3)))))
(let ((inline$$MoveFrom$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 32281) (- 0 51025)) true) (=> (= (ControlFlow 0 32281) 32287) inline$$MoveFrom$0$anon0_correct@@3))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@7) (= (ControlFlow 0 32395) 32281)) inline$$MoveFrom$0$Entry_correct@@3)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@7) (=> $abort_flag@0@@7 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 account@@4)))) ((_ is $Address) call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 32157) 33029) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 32157) 32395) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 32121) 32157)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 33053) 32157) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 32115) 33053) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 32115) 32121) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@22 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestResources_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestResources_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@7))) $TestResources_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_R_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (= (ControlFlow 0 33057) 32115)) inline$$TestResources_move_from_sender_to_sender_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@8  (=> (and ((_ is $Address) account@@4) (= (ControlFlow 0 31777) 33057)) anon0$1_correct@@7)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 50530) 31777) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@8)))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestResources_A_pack$0$$struct@1 () T@$Value)
(declare-fun a@@4 () T@$Value)
(declare-fun va@@23 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 51580) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 33714) (- 0 51861)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 33714) (- 0 51870)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 33714) (- 0 51879)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1)) $TestResources_A_addr) a@@4))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1)) $TestResources_A_addr) a@@4)))) (=> (= (ControlFlow 0 33714) (- 0 51897)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1)) $TestResources_A_val) va@@23)))))))))))))
(let ((inline$$TestResources_pack_A_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 33680) 33714)) anon0$2_correct@@9)))
(let ((inline$$TestResources_pack_A_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 33690) 33714) anon0$2_correct@@9)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 33658) 33690) inline$$TestResources_pack_A_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 33658) 33680) inline$$TestResources_pack_A_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 33664) 33690) inline$$TestResources_pack_A_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 33664) 33680) inline$$TestResources_pack_A_$def_verify$0$anon9_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 33652) 33664) inline$$TestResources_A_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 33652) 33658) inline$$TestResources_A_pack$0$anon4_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 33644) 33690) inline$$TestResources_pack_A_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 33644) 33680) inline$$TestResources_pack_A_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct  (=> ((_ is $Address) a@@4) (=> (and (and (and ((_ is $Integer) va@@23) (>= (|i#$Integer| va@@23) 0)) (<= (|i#$Integer| va@@23) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@4) 1 va@@23) 2)))) (and (=> (= (ControlFlow 0 33636) 33652) inline$$TestResources_A_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 33636) 33644) inline$$TestResources_A_pack$0$anon3_Else_correct))))))
(let ((inline$$TestResources_pack_A_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 33416) 33636)) inline$$TestResources_A_pack$0$anon0_correct)))
(let ((inline$$TestResources_pack_A_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 33698) 33636) inline$$TestResources_A_pack$0$anon0_correct)))
(let ((inline$$TestResources_pack_A_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 33408) 33698) inline$$TestResources_pack_A_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 33408) 33416) inline$$TestResources_pack_A_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestResources_pack_A_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 33706) 33698) inline$$TestResources_pack_A_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 33706) 33416) inline$$TestResources_pack_A_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestResources_pack_A_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 33402) 33706) inline$$TestResources_pack_A_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 33402) 33408) inline$$TestResources_pack_A_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@9  (=> ((_ is $Address) a@@4) (=> (and (and (and ((_ is $Integer) va@@23) (>= (|i#$Integer| va@@23) 0)) (<= (|i#$Integer| va@@23) $MAX_U64)) (= (ControlFlow 0 33250) 33402)) inline$$TestResources_pack_A_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 51580) 33250) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@9))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestResources_B_pack$0$$struct@1 () T@$Value)
(declare-fun vb () T@$Value)
(declare-fun va@@24 () T@$Value)
(declare-fun a@@5 () T@$Value)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 51922) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 34665) (- 0 52382)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 34665) (- 0 52391)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 34665) (- 0 52400)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1)) $TestResources_B_val) vb))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1)) $TestResources_B_val) vb)))) (and (=> (= (ControlFlow 0 34665) (- 0 52418)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1)) $TestResources_B_a))) $TestResources_A_val) va@@24))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1)) $TestResources_B_a))) $TestResources_A_val) va@@24)))) (=> (= (ControlFlow 0 34665) (- 0 52440)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1)) $TestResources_B_a))) $TestResources_A_addr) a@@5)))))))))))))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 34607) 34665)) anon0$2_correct@@10)))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 34617) 34665) anon0$2_correct@@10)))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 34597) 34617) inline$$TestResources_pack_B_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 34597) 34607) inline$$TestResources_pack_B_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 34625) 34617) inline$$TestResources_pack_B_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 34625) 34607) inline$$TestResources_pack_B_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestResources_B_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 34577) 34625) inline$$TestResources_pack_B_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 34577) 34597) inline$$TestResources_pack_B_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 34583) 34625) inline$$TestResources_pack_B_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 34583) 34597) inline$$TestResources_pack_B_$def_verify$0$anon17_Else_correct))))
(let ((inline$$TestResources_B_pack$0$anon3_Then_correct  (=> (> 4432 0) (and (=> (= (ControlFlow 0 34571) 34583) inline$$TestResources_B_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 34571) 34577) inline$$TestResources_B_pack$0$anon4_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon3_Else_correct  (=> (>= 0 4432) (and (=> (= (ControlFlow 0 34563) 34625) inline$$TestResources_pack_B_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 34563) 34597) inline$$TestResources_pack_B_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) vb) (>= (|i#$Integer| vb) 0)) (<= (|i#$Integer| vb) $MAX_U64)) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_A_pack$0$$struct@1@@0) (let ((va@@25 (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@0)))
(let ((l@@23 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@0)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@0)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@0)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@0)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@0)) $TestResources_A_val)) $MAX_U64))) true) (= inline$$TestResources_B_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 vb) 1 inline$$TestResources_A_pack$0$$struct@1@@0) 2)))) (and (=> (= (ControlFlow 0 34555) 34571) inline$$TestResources_B_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 34555) 34563) inline$$TestResources_B_pack$0$anon3_Else_correct))))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 34403) 34555)) inline$$TestResources_B_pack$0$anon0_correct)))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 34633) 34555) inline$$TestResources_B_pack$0$anon0_correct)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 34383) 34633) inline$$TestResources_pack_B_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 34383) 34403) inline$$TestResources_pack_B_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 34389) 34633) inline$$TestResources_pack_B_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 34389) 34403) inline$$TestResources_pack_B_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@0  (=> (> 4389 0) (and (=> (= (ControlFlow 0 34377) 34389) inline$$TestResources_A_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 34377) 34383) inline$$TestResources_A_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@0  (=> (>= 0 4389) (and (=> (= (ControlFlow 0 34369) 34633) inline$$TestResources_pack_B_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 34369) 34403) inline$$TestResources_pack_B_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@0  (=> ((_ is $Address) a@@5) (=> (and (and (and ((_ is $Integer) va@@24) (>= (|i#$Integer| va@@24) 0)) (<= (|i#$Integer| va@@24) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@5) 1 va@@24) 2)))) (and (=> (= (ControlFlow 0 34361) 34377) inline$$TestResources_A_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 34361) 34369) inline$$TestResources_A_pack$0$anon3_Else_correct@@0))))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 34107) 34361)) inline$$TestResources_A_pack$0$anon0_correct@@0)))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 34641) 34361) inline$$TestResources_A_pack$0$anon0_correct@@0)))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon14_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 34099) 34641) inline$$TestResources_pack_B_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 34099) 34107) inline$$TestResources_pack_B_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon14_Then_correct  (and (=> (= (ControlFlow 0 34649) 34641) inline$$TestResources_pack_B_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 34649) 34107) inline$$TestResources_pack_B_$def_verify$0$anon15_Else_correct))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 34091) 34649) inline$$TestResources_pack_B_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 34091) 34099) inline$$TestResources_pack_B_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 34657) 34649) inline$$TestResources_pack_B_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 34657) 34099) inline$$TestResources_pack_B_$def_verify$0$anon14_Else_correct))))
(let ((inline$$TestResources_pack_B_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 34085) 34657) inline$$TestResources_pack_B_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 34085) 34091) inline$$TestResources_pack_B_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@10  (=> ((_ is $Address) a@@5) (=> (and (and ((_ is $Integer) va@@24) (>= (|i#$Integer| va@@24) 0)) (<= (|i#$Integer| va@@24) $MAX_U64)) (=> (and (and (and ((_ is $Integer) vb) (>= (|i#$Integer| vb) 0)) (<= (|i#$Integer| vb) $MAX_U64)) (= (ControlFlow 0 33831) 34085)) inline$$TestResources_pack_B_$def_verify$0$anon0_correct)))))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (= (ControlFlow 0 51922) 33831) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@10)))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestResources_C_pack$0$$struct@1 () T@$Value)
(declare-fun vc () T@$Value)
(declare-fun vb@@0 () T@$Value)
(declare-fun va@@26 () T@$Value)
(declare-fun a@@6 () T@$Value)
(declare-fun inline$$TestResources_B_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 52470) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 35991) (- 0 53100)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 35991) (- 0 53109)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 35991) (- 0 53118)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1)) $TestResources_C_val) vc))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1)) $TestResources_C_val) vc)))) (and (=> (= (ControlFlow 0 35991) (- 0 53136)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1)) $TestResources_C_b))) $TestResources_B_val) vb@@0))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1)) $TestResources_C_b))) $TestResources_B_val) vb@@0)))) (and (=> (= (ControlFlow 0 35991) (- 0 53158)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1)) $TestResources_C_b))) $TestResources_B_a))) $TestResources_A_val) va@@26))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1)) $TestResources_C_b))) $TestResources_B_a))) $TestResources_A_val) va@@26)))) (=> (= (ControlFlow 0 35991) (- 0 53184)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1)) $TestResources_C_b))) $TestResources_B_a))) $TestResources_A_addr) a@@6)))))))))))))))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 35917) 35991)) anon0$2_correct@@11)))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 35927) 35991) anon0$2_correct@@11)))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 35907) 35927) inline$$TestResources_pack_C_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 35907) 35917) inline$$TestResources_pack_C_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 35935) 35927) inline$$TestResources_pack_C_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 35935) 35917) inline$$TestResources_pack_C_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestResources_C_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 35887) 35935) inline$$TestResources_pack_C_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 35887) 35907) inline$$TestResources_pack_C_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestResources_C_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 35893) 35935) inline$$TestResources_pack_C_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 35893) 35907) inline$$TestResources_pack_C_$def_verify$0$anon23_Else_correct))))
(let ((inline$$TestResources_C_pack$0$anon3_Then_correct  (=> (> 4809 0) (and (=> (= (ControlFlow 0 35881) 35893) inline$$TestResources_C_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 35881) 35887) inline$$TestResources_C_pack$0$anon4_Else_correct)))))
(let ((inline$$TestResources_C_pack$0$anon3_Else_correct  (=> (>= 0 4809) (and (=> (= (ControlFlow 0 35873) 35935) inline$$TestResources_pack_C_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 35873) 35907) inline$$TestResources_pack_C_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestResources_C_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) vc) (>= (|i#$Integer| vc) 0)) (<= (|i#$Integer| vc) $MAX_U64)) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_B_pack$0$$struct@1@@0) (let ((va@@27 (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)))
(let ((l@@24 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_val)) $MAX_U64))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_a)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_a))))
(let ((l@@25 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_a))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_a))) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_a))) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_a))) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@0)) $TestResources_B_a))) $TestResources_A_val)) $MAX_U64)))) true) (= inline$$TestResources_C_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 vc) 1 inline$$TestResources_B_pack$0$$struct@1@@0) 2)))) (and (=> (= (ControlFlow 0 35865) 35881) inline$$TestResources_C_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 35865) 35873) inline$$TestResources_C_pack$0$anon3_Else_correct))))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 35713) 35865)) inline$$TestResources_C_pack$0$anon0_correct)))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 35943) 35865) inline$$TestResources_C_pack$0$anon0_correct)))
(let ((inline$$TestResources_B_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 35693) 35943) inline$$TestResources_pack_C_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 35693) 35713) inline$$TestResources_pack_C_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 35699) 35943) inline$$TestResources_pack_C_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 35699) 35713) inline$$TestResources_pack_C_$def_verify$0$anon22_Else_correct))))
(let ((inline$$TestResources_B_pack$0$anon3_Then_correct@@0  (=> (> 4765 0) (and (=> (= (ControlFlow 0 35687) 35699) inline$$TestResources_B_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 35687) 35693) inline$$TestResources_B_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestResources_B_pack$0$anon3_Else_correct@@0  (=> (>= 0 4765) (and (=> (= (ControlFlow 0 35679) 35943) inline$$TestResources_pack_C_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 35679) 35713) inline$$TestResources_pack_C_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon0_correct@@0  (=> (and (and ((_ is $Integer) vb@@0) (>= (|i#$Integer| vb@@0) 0)) (<= (|i#$Integer| vb@@0) $MAX_U64)) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_A_pack$0$$struct@1@@1) (let ((va@@29 (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@1)))
(let ((l@@26 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@1)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@1)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@1)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@1)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@1)) $TestResources_A_val)) $MAX_U64))) true) (= inline$$TestResources_B_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 vb@@0) 1 inline$$TestResources_A_pack$0$$struct@1@@1) 2)))) (and (=> (= (ControlFlow 0 35671) 35687) inline$$TestResources_B_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 35671) 35679) inline$$TestResources_B_pack$0$anon3_Else_correct@@0))))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 35519) 35671)) inline$$TestResources_B_pack$0$anon0_correct@@0)))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 35951) 35671) inline$$TestResources_B_pack$0$anon0_correct@@0)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 35499) 35951) inline$$TestResources_pack_C_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 35499) 35519) inline$$TestResources_pack_C_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@1  (and (=> (= (ControlFlow 0 35505) 35951) inline$$TestResources_pack_C_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 35505) 35519) inline$$TestResources_pack_C_$def_verify$0$anon21_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@1  (=> (> 4722 0) (and (=> (= (ControlFlow 0 35493) 35505) inline$$TestResources_A_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 35493) 35499) inline$$TestResources_A_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@1  (=> (>= 0 4722) (and (=> (= (ControlFlow 0 35485) 35951) inline$$TestResources_pack_C_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 35485) 35519) inline$$TestResources_pack_C_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@1  (=> ((_ is $Address) a@@6) (=> (and (and (and ((_ is $Integer) va@@26) (>= (|i#$Integer| va@@26) 0)) (<= (|i#$Integer| va@@26) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@6) 1 va@@26) 2)))) (and (=> (= (ControlFlow 0 35477) 35493) inline$$TestResources_A_pack$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 35477) 35485) inline$$TestResources_A_pack$0$anon3_Else_correct@@1))))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 35189) 35477)) inline$$TestResources_A_pack$0$anon0_correct@@1)))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 35959) 35477) inline$$TestResources_A_pack$0$anon0_correct@@1)))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 35181) 35959) inline$$TestResources_pack_C_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 35181) 35189) inline$$TestResources_pack_C_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 35967) 35959) inline$$TestResources_pack_C_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 35967) 35189) inline$$TestResources_pack_C_$def_verify$0$anon20_Else_correct))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon18_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 35173) 35967) inline$$TestResources_pack_C_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 35173) 35181) inline$$TestResources_pack_C_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon18_Then_correct  (and (=> (= (ControlFlow 0 35975) 35967) inline$$TestResources_pack_C_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 35975) 35181) inline$$TestResources_pack_C_$def_verify$0$anon19_Else_correct))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 35165) 35975) inline$$TestResources_pack_C_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 35165) 35173) inline$$TestResources_pack_C_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 35983) 35975) inline$$TestResources_pack_C_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 35983) 35173) inline$$TestResources_pack_C_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestResources_pack_C_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 35159) 35983) inline$$TestResources_pack_C_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 35159) 35165) inline$$TestResources_pack_C_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@11  (=> ((_ is $Address) a@@6) (=> (and (and (and (and ((_ is $Integer) va@@26) (>= (|i#$Integer| va@@26) 0)) (<= (|i#$Integer| va@@26) $MAX_U64)) (and (and ((_ is $Integer) vb@@0) (>= (|i#$Integer| vb@@0) 0)) (<= (|i#$Integer| vb@@0) $MAX_U64))) (and (and (and ((_ is $Integer) vc) (>= (|i#$Integer| vc) 0)) (<= (|i#$Integer| vc) $MAX_U64)) (= (ControlFlow 0 34829) 35159))) inline$$TestResources_pack_C_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (= (ControlFlow 0 52470) 34829) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@11))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun b@@0 () T@$Value)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun inline$$TestResources_ref_A_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun a@@7 () T@$Value)
(declare-fun inline$$TestResources_ref_A_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestResources_ref_A_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$TestResources_ref_A_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@1 () Int)
(declare-fun |inline$$TestResources_ref_A_$def_verify$0$tmp#$4@1| () T@$Value)
(declare-fun inline$$TestResources_ref_A_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$TestResources_A_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$TestResources_ref_A_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@2 () T@$Value)
(declare-fun inline$$TestResources_ref_A_$def_verify$0$$t10@1 () T@$Value)
(declare-fun $TestResources_A_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 53216) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 37515) (- 0 53912)) (=> (|b#$Boolean| b@@0) $abort_flag@0@@8)) (=> (=> (|b#$Boolean| b@@0) $abort_flag@0@@8) (and (=> (= (ControlFlow 0 37515) (- 0 53919)) (=> $abort_flag@0@@8 (|b#$Boolean| b@@0))) (=> (=> $abort_flag@0@@8 (|b#$Boolean| b@@0)) (=> (= (ControlFlow 0 37515) (- 0 53926)) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_ref_A_$def_verify$0$$ret0@2)) $TestResources_A_addr) a@@7)))))))))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon22_correct  (=> (and (and (= inline$$TestResources_ref_A_$def_verify$0$$ret0@1 $Error) (= $abort_flag@0@@8 true)) (and (= inline$$TestResources_ref_A_$def_verify$0$$ret0@2 inline$$TestResources_ref_A_$def_verify$0$$ret0@1) (= (ControlFlow 0 37231) 37515))) anon0$2_correct@@12)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 37225) 37231)) inline$$TestResources_ref_A_$def_verify$0$anon22_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 37239) 37231) inline$$TestResources_ref_A_$def_verify$0$anon22_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon34_Then_correct  (=> (|b#$Boolean| inline$$TestResources_ref_A_$def_verify$0$$t12@1) (=> (and (= inline$$TestResources_ref_A_$def_verify$0$$t13@1 ($Integer 42)) (= $abort_code@1 (|i#$Integer| inline$$TestResources_ref_A_$def_verify$0$$t13@1))) (and (=> (= (ControlFlow 0 37219) 37239) inline$$TestResources_ref_A_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 37219) 37225) inline$$TestResources_ref_A_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon24_correct  (=> (= $abort_flag@0@@8 false) (=> (and (= inline$$TestResources_ref_A_$def_verify$0$$ret0@2 |inline$$TestResources_ref_A_$def_verify$0$tmp#$4@1|) (= (ControlFlow 0 37197) 37515)) anon0$2_correct@@12))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 37195) 37197)) inline$$TestResources_ref_A_$def_verify$0$anon24_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 37205) 37197) inline$$TestResources_ref_A_$def_verify$0$anon24_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon34_Else_correct  (=> (not (|b#$Boolean| inline$$TestResources_ref_A_$def_verify$0$$t12@1)) (and (=> (= (ControlFlow 0 37189) 37205) inline$$TestResources_ref_A_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 37189) 37195) inline$$TestResources_ref_A_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon18_correct  (=> (and (= inline$$TestResources_ref_A_$def_verify$0$$t11@1 ($Integer 42)) (= inline$$TestResources_ref_A_$def_verify$0$$t12@1 ($Boolean  (not ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1 inline$$TestResources_ref_A_$def_verify$0$$t11@1))))) (and (=> (= (ControlFlow 0 37179) 37219) inline$$TestResources_ref_A_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 37179) 37189) inline$$TestResources_ref_A_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 37163) 37179)) inline$$TestResources_ref_A_$def_verify$0$anon18_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 37247) 37179) inline$$TestResources_ref_A_$def_verify$0$anon18_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 37121) 37247) inline$$TestResources_ref_A_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 37121) 37163) inline$$TestResources_ref_A_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 37255) 37247) inline$$TestResources_ref_A_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 37255) 37163) inline$$TestResources_ref_A_$def_verify$0$anon33_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$TestResources_ref_A_$def_verify$0$tmp#$4@1|)) $TestResources_A_val)) (and (=> (= (ControlFlow 0 37107) 37255) inline$$TestResources_ref_A_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 37107) 37121) inline$$TestResources_ref_A_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 37065) 37107)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 37263) 37107) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon30_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 37023) 37263) inline$$TestResources_ref_A_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 37023) 37065) inline$$TestResources_ref_A_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon30_Then_correct  (and (=> (= (ControlFlow 0 37271) 37263) inline$$TestResources_ref_A_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 37271) 37065) inline$$TestResources_ref_A_$def_verify$0$anon31_Else_correct))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon8_correct  (=> (= |inline$$TestResources_ref_A_$def_verify$0$tmp#$4@1| inline$$TestResources_A_pack$1$$struct@1) (and (=> (= (ControlFlow 0 37483) 37271) inline$$TestResources_ref_A_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 37483) 37023) inline$$TestResources_ref_A_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 37481) 37483)) inline$$TestResources_ref_A_$def_verify$0$anon8_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 37491) 37483) inline$$TestResources_ref_A_$def_verify$0$anon8_correct)))
(let ((inline$$TestResources_A_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 37461) 37491) inline$$TestResources_ref_A_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 37461) 37481) inline$$TestResources_ref_A_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestResources_A_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 37467) 37491) inline$$TestResources_ref_A_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 37467) 37481) inline$$TestResources_ref_A_$def_verify$0$anon28_Else_correct))))
(let ((inline$$TestResources_A_pack$1$anon3_Then_correct  (=> (> 6321 0) (and (=> (= (ControlFlow 0 37455) 37467) inline$$TestResources_A_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 37455) 37461) inline$$TestResources_A_pack$1$anon4_Else_correct)))))
(let ((inline$$TestResources_A_pack$1$anon3_Else_correct  (=> (>= 0 6321) (and (=> (= (ControlFlow 0 37447) 37491) inline$$TestResources_ref_A_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 37447) 37481) inline$$TestResources_ref_A_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestResources_A_pack$1$anon0_correct  (=> ((_ is $Address) a@@7) (=> (and (and (and ((_ is $Integer) inline$$TestResources_ref_A_$def_verify$0$$t9@1) (>= (|i#$Integer| inline$$TestResources_ref_A_$def_verify$0$$t9@1) 0)) (<= (|i#$Integer| inline$$TestResources_ref_A_$def_verify$0$$t9@1) $MAX_U64)) (= inline$$TestResources_A_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@7) 1 inline$$TestResources_ref_A_$def_verify$0$$t9@1) 2)))) (and (=> (= (ControlFlow 0 37439) 37455) inline$$TestResources_A_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 37439) 37447) inline$$TestResources_A_pack$1$anon3_Else_correct))))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon27_Then_correct  (=> (|b#$Boolean| b@@0) (=> (and (= inline$$TestResources_ref_A_$def_verify$0$$t9@1 ($Integer 1)) (= (ControlFlow 0 37473) 37439)) inline$$TestResources_A_pack$1$anon0_correct))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon10_correct  (=> (= |inline$$TestResources_ref_A_$def_verify$0$tmp#$4@1| inline$$TestResources_A_pack$0$$struct@1@@2) (and (=> (= (ControlFlow 0 36981) 37271) inline$$TestResources_ref_A_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 36981) 37023) inline$$TestResources_ref_A_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 36979) 36981)) inline$$TestResources_ref_A_$def_verify$0$anon10_correct)))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 37279) 36981) inline$$TestResources_ref_A_$def_verify$0$anon10_correct)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 36959) 37279) inline$$TestResources_ref_A_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 36959) 36979) inline$$TestResources_ref_A_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@2  (and (=> (= (ControlFlow 0 36965) 37279) inline$$TestResources_ref_A_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 36965) 36979) inline$$TestResources_ref_A_$def_verify$0$anon29_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@2  (=> (> 6367 0) (and (=> (= (ControlFlow 0 36953) 36965) inline$$TestResources_A_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 36953) 36959) inline$$TestResources_A_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@2  (=> (>= 0 6367) (and (=> (= (ControlFlow 0 36945) 37279) inline$$TestResources_ref_A_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 36945) 36979) inline$$TestResources_ref_A_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@2  (=> ((_ is $Address) a@@7) (=> (and (and (and ((_ is $Integer) inline$$TestResources_ref_A_$def_verify$0$$t10@1) (>= (|i#$Integer| inline$$TestResources_ref_A_$def_verify$0$$t10@1) 0)) (<= (|i#$Integer| inline$$TestResources_ref_A_$def_verify$0$$t10@1) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@7) 1 inline$$TestResources_ref_A_$def_verify$0$$t10@1) 2)))) (and (=> (= (ControlFlow 0 36937) 36953) inline$$TestResources_A_pack$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 36937) 36945) inline$$TestResources_A_pack$0$anon3_Else_correct@@2))))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon27_Else_correct  (=> (not (|b#$Boolean| b@@0)) (=> (and (= inline$$TestResources_ref_A_$def_verify$0$$t10@1 ($Integer 42)) (= (ControlFlow 0 36971) 36937)) inline$$TestResources_A_pack$0$anon0_correct@@2))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon26_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 36705) 37473) inline$$TestResources_ref_A_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 36705) 36971) inline$$TestResources_ref_A_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon26_Then_correct  (and (=> (= (ControlFlow 0 37499) 37473) inline$$TestResources_ref_A_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 37499) 36971) inline$$TestResources_ref_A_$def_verify$0$anon27_Else_correct))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 36697) 37499) inline$$TestResources_ref_A_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 36697) 36705) inline$$TestResources_ref_A_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 37507) 37499) inline$$TestResources_ref_A_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 37507) 36705) inline$$TestResources_ref_A_$def_verify$0$anon26_Else_correct))))
(let ((inline$$TestResources_ref_A_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 36691) 37507) inline$$TestResources_ref_A_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 36691) 36697) inline$$TestResources_ref_A_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@8  (=> (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@27 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8))) $TestResources_A_val)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestResources_A_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (= (ControlFlow 0 37513) 36691)) inline$$TestResources_ref_A_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@12  (=> ((_ is $Address) a@@7) (=> (and ((_ is $Boolean) b@@0) (= (ControlFlow 0 36187) 37513)) anon0$1_correct@@8))))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (= (ControlFlow 0 53216) 36187) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@12))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun account@@5 () T@$Value)
(declare-fun inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@3 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$TestResources_spec_pack_A_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 53949) (let ((anon0$2_correct@@13  (and (=> (= (ControlFlow 0 38219) (- 0 54452)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@8)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@8) (and (=> (= (ControlFlow 0 38219) (- 0 54461)) (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 38219) (- 0 54470)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2)) $TestResources_A_addr) account@@5))))) (=> (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2)) $TestResources_A_addr) account@@5)))) (and (=> (= (ControlFlow 0 38219) (- 0 54490)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2)) $TestResources_A_val) ($Integer 7)))))) (=> (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2)) $TestResources_A_val) ($Integer 7))))) (and (=> (= (ControlFlow 0 38219) (- 0 54510)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2 ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 account@@5) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 account@@5) (+ len@@1 1)))) len@@0 ($Integer 7)) (+ len@@0 1))))))))) (=> (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2 ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 account@@5) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 account@@5) (+ len@@1 1)))) len@@0 ($Integer 7)) (+ len@@0 1)))))))) (=> (= (ControlFlow 0 38219) (- 0 54538)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2 ($Vector (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 account@@5) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 account@@5) (+ len@@3 1)))) len@@2 ($Integer 7)) (+ len@@2 1)))))))))))))))))))))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon5_correct  (=> (and (and (= inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@8 true)) (and (= inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2 inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@1) (= (ControlFlow 0 38195) 38219))) anon0$2_correct@@13)))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 38189) 38195)) inline$$TestResources_spec_pack_A_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 38203) 38195) inline$$TestResources_spec_pack_A_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 38183) 38203) inline$$TestResources_spec_pack_A_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 38183) 38189) inline$$TestResources_spec_pack_A_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@8 $abort_flag@0@@9) (=> (and (= inline$$TestResources_spec_pack_A_$def_verify$0$$ret0@2 inline$$TestResources_A_pack$0$$struct@1@@3) (= (ControlFlow 0 38171) 38219)) anon0$2_correct@@13))))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 38169) 38171)) inline$$TestResources_spec_pack_A_$def_verify$0$anon8_correct)))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 38179) 38171) inline$$TestResources_spec_pack_A_$def_verify$0$anon8_correct)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 38147) 38179) inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38147) 38169) inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@3  (and (=> (= (ControlFlow 0 38153) 38179) inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38153) 38169) inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@3  (=> (> 0 0) (and (=> (= (ControlFlow 0 38141) 38153) inline$$TestResources_A_pack$0$anon4_Then_correct@@3) (=> (= (ControlFlow 0 38141) 38147) inline$$TestResources_A_pack$0$anon4_Else_correct@@3)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@3  (=> (>= 0 0) (and (=> (= (ControlFlow 0 38133) 38179) inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38133) 38169) inline$$TestResources_spec_pack_A_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@3  (=> ((_ is $Address) call3formal@$ret0@0@@2) (=> (and (and (and ((_ is $Integer) inline$$TestResources_spec_pack_A_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestResources_spec_pack_A_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestResources_spec_pack_A_$def_verify$0$$t3@1) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@3 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 call3formal@$ret0@0@@2) 1 inline$$TestResources_spec_pack_A_$def_verify$0$$t3@1) 2)))) (and (=> (= (ControlFlow 0 38125) 38141) inline$$TestResources_A_pack$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 38125) 38133) inline$$TestResources_A_pack$0$anon3_Else_correct@@3))))))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@9) (=> (and (= inline$$TestResources_spec_pack_A_$def_verify$0$$t3@1 ($Integer 7)) (= (ControlFlow 0 38159) 38125)) inline$$TestResources_A_pack$0$anon0_correct@@3))))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9) (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 account@@5)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 37965) 38183) inline$$TestResources_spec_pack_A_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 37965) 38159) inline$$TestResources_spec_pack_A_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 37929) 37965)) inline$$TestResources_spec_pack_A_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 38211) 37965) inline$$TestResources_spec_pack_A_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_spec_pack_A_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 37923) 38211) inline$$TestResources_spec_pack_A_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 37923) 37929) inline$$TestResources_spec_pack_A_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@13  (=> (and ((_ is $Address) account@@5) (= (ControlFlow 0 37733) 37923)) inline$$TestResources_spec_pack_A_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@13  (=> (= (ControlFlow 0 53949) 37733) anon0_correct@@13)))
PreconditionGeneratedEntry_correct@@13)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun account@@6 () T@$Value)
(declare-fun inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun inline$$TestResources_B_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$TestResources_spec_pack_B_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@4 () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$TestResources_spec_pack_B_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 54571) (let ((anon0$2_correct@@14  (and (=> (= (ControlFlow 0 39012) (- 0 55311)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9) (and (=> (= (ControlFlow 0 39012) (- 0 55320)) (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 39012) (- 0 55329)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2)) $TestResources_B_val) ($Integer 77)))))) (=> (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2)) $TestResources_B_val) ($Integer 77))))) (and (=> (= (ControlFlow 0 39012) (- 0 55349)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2)) $TestResources_B_a))) $TestResources_A_val) ($Integer 7)))))) (=> (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2)) $TestResources_B_a))) $TestResources_A_val) ($Integer 7))))) (and (=> (= (ControlFlow 0 39012) (- 0 55373)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2)) $TestResources_B_a))) $TestResources_A_addr) account@@6))))) (=> (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2)) $TestResources_B_a))) $TestResources_A_addr) account@@6)))) (and (=> (= (ControlFlow 0 39012) (- 0 55397)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Integer 77)) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Integer 77)) (+ len@@5 1)))) len@@4 ($Vector (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@7 account@@6) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@7 account@@6) (+ len@@7 1)))) len@@6 ($Integer 7)) (+ len@@6 1))))) (+ len@@4 1))))))))) (=> (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Integer 77)) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Integer 77)) (+ len@@5 1)))) len@@4 ($Vector (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@7 account@@6) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@7 account@@6) (+ len@@7 1)))) len@@6 ($Integer 7)) (+ len@@6 1))))) (+ len@@4 1)))))))) (and (=> (= (ControlFlow 0 39012) (- 0 55437)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 ($Vector (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 ($Integer 77)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 ($Integer 77)) (+ len@@9 1)))) len@@8 ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 account@@6) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 account@@6) (+ len@@11 1)))) len@@10 ($Integer 7)) (+ len@@10 1))))) (+ len@@8 1))))))))) (=> (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 ($Vector (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 ($Integer 77)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 ($Integer 77)) (+ len@@9 1)))) len@@8 ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 account@@6) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 account@@6) (+ len@@11 1)))) len@@10 ($Integer 7)) (+ len@@10 1))))) (+ len@@8 1)))))))) (and (=> (= (ControlFlow 0 39012) (- 0 55477)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 ($Vector (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@13 ($Integer 77)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@13 ($Integer 77)) (+ len@@13 1)))) len@@12 ($Vector (let ((len@@14 (|l#$ValueArray| (let ((len@@15 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@15 account@@6) (+ len@@15 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@15 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@15 account@@6) (+ len@@15 1)))) len@@14 ($Integer 7)) (+ len@@14 1))))) (+ len@@12 1))))))))) (=> (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 ($Vector (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@13 ($Integer 77)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@13 ($Integer 77)) (+ len@@13 1)))) len@@12 ($Vector (let ((len@@14 (|l#$ValueArray| (let ((len@@15 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@15 account@@6) (+ len@@15 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@15 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@15 account@@6) (+ len@@15 1)))) len@@14 ($Integer 7)) (+ len@@14 1))))) (+ len@@12 1)))))))) (=> (= (ControlFlow 0 39012) (- 0 55517)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 ($Vector (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@17 ($Integer 77)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@17 ($Integer 77)) (+ len@@17 1)))) len@@16 ($Vector (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 account@@6) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 account@@6) (+ len@@19 1)))) len@@18 ($Integer 7)) (+ len@@18 1))))) (+ len@@16 1)))))))))))))))))))))))))))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon5_correct  (=> (and (and (= inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@9 true)) (and (= inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@1) (= (ControlFlow 0 38988) 39012))) anon0$2_correct@@14)))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 38982) 38988)) inline$$TestResources_spec_pack_B_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 38996) 38988) inline$$TestResources_spec_pack_B_$def_verify$0$anon5_correct)))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 38976) 38996) inline$$TestResources_spec_pack_B_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 38976) 38982) inline$$TestResources_spec_pack_B_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@9 $abort_flag@0@@10) (=> (and (= inline$$TestResources_spec_pack_B_$def_verify$0$$ret0@2 inline$$TestResources_B_pack$0$$struct@1@@1) (= (ControlFlow 0 38964) 39012)) anon0$2_correct@@14))))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 38962) 38964)) inline$$TestResources_spec_pack_B_$def_verify$0$anon8_correct)))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 38972) 38964) inline$$TestResources_spec_pack_B_$def_verify$0$anon8_correct)))
(let ((inline$$TestResources_B_pack$0$anon4_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 38940) 38972) inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38940) 38962) inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon4_Then_correct@@1  (and (=> (= (ControlFlow 0 38946) 38972) inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38946) 38962) inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestResources_B_pack$0$anon3_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 38934) 38946) inline$$TestResources_B_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 38934) 38940) inline$$TestResources_B_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestResources_B_pack$0$anon3_Else_correct@@1  (=> (>= 0 0) (and (=> (= (ControlFlow 0 38926) 38972) inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38926) 38962) inline$$TestResources_spec_pack_B_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon0_correct@@1  (=> (and (and ((_ is $Integer) inline$$TestResources_spec_pack_B_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestResources_spec_pack_B_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestResources_spec_pack_B_$def_verify$0$$t2@1) $MAX_U64)) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_A_pack$0$$struct@1@@4) (let ((va@@31 (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@4)))
(let ((l@@28 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@4)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@4)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@4)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@4)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@4)) $TestResources_A_val)) $MAX_U64))) true) (= inline$$TestResources_B_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_spec_pack_B_$def_verify$0$$t2@1) 1 inline$$TestResources_A_pack$0$$struct@1@@4) 2)))) (and (=> (= (ControlFlow 0 38918) 38934) inline$$TestResources_B_pack$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 38918) 38926) inline$$TestResources_B_pack$0$anon3_Else_correct@@1))))))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 38754) 38918)) inline$$TestResources_B_pack$0$anon0_correct@@1)))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@4  (=> (= (ControlFlow 0 38760) 38918) inline$$TestResources_B_pack$0$anon0_correct@@1)))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@4  (=> (> 0 0) (and (=> (= (ControlFlow 0 38748) 38760) inline$$TestResources_A_pack$0$anon4_Then_correct@@4) (=> (= (ControlFlow 0 38748) 38754) inline$$TestResources_A_pack$0$anon4_Else_correct@@4)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@4  (=> (and (>= 0 0) (= (ControlFlow 0 38740) 38918)) inline$$TestResources_B_pack$0$anon0_correct@@1)))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@4  (=> ((_ is $Address) call3formal@$ret0@0@@3) (=> (and (and (and ((_ is $Integer) inline$$TestResources_spec_pack_B_$def_verify$0$$t4@1) (>= (|i#$Integer| inline$$TestResources_spec_pack_B_$def_verify$0$$t4@1) 0)) (<= (|i#$Integer| inline$$TestResources_spec_pack_B_$def_verify$0$$t4@1) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@4 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 call3formal@$ret0@0@@3) 1 inline$$TestResources_spec_pack_B_$def_verify$0$$t4@1) 2)))) (and (=> (= (ControlFlow 0 38732) 38748) inline$$TestResources_A_pack$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 38732) 38740) inline$$TestResources_A_pack$0$anon3_Else_correct@@4))))))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@10) (=> (and (= inline$$TestResources_spec_pack_B_$def_verify$0$$t4@1 ($Integer 7)) (= (ControlFlow 0 38766) 38732)) inline$$TestResources_A_pack$0$anon0_correct@@4))))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon2$1_correct  (=> (= inline$$TestResources_spec_pack_B_$def_verify$0$$t2@1 ($Integer 77)) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@10) (=> $abort_flag@0@@10 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 account@@6)))) ((_ is $Address) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 38572) 38976) inline$$TestResources_spec_pack_B_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 38572) 38766) inline$$TestResources_spec_pack_B_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 38532) 38572)) inline$$TestResources_spec_pack_B_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 39004) 38572) inline$$TestResources_spec_pack_B_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestResources_spec_pack_B_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 38526) 39004) inline$$TestResources_spec_pack_B_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 38526) 38532) inline$$TestResources_spec_pack_B_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@14  (=> (and ((_ is $Address) account@@6) (= (ControlFlow 0 38315) 38526)) inline$$TestResources_spec_pack_B_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@14  (=> (= (ControlFlow 0 54571) 38315) anon0_correct@@14)))
PreconditionGeneratedEntry_correct@@14))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestResources_R_pack$0$$struct@1@@5 () T@$Value)
(declare-fun inline$$TestResources_spec_pack_R_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 55561) (let ((anon0$2_correct@@15  (and (=> (= (ControlFlow 0 39399) (- 0 55773)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 39399) (- 0 55782)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 39399) (- 0 55791)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_R_pack$0$$struct@1@@5)) $TestResources_R_x) ($Integer 7)))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_R_pack$0$$struct@1@@5)) $TestResources_R_x) ($Integer 7))))) (=> (= (ControlFlow 0 39399) (- 0 55811)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_R_pack$0$$struct@1@@5 ($Vector (let ((len@@20 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@20 ($Integer 7)) (+ len@@20 1)))))))))))))))))
(let ((inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Else_correct  (=> (and (not true) (= (ControlFlow 0 39381) 39399)) anon0$2_correct@@15)))
(let ((inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Then_correct  (=> (= (ControlFlow 0 39391) 39399) anon0$2_correct@@15)))
(let ((inline$$TestResources_R_pack$0$anon4_Else_correct@@5  (=> (not true) (and (=> (= (ControlFlow 0 39359) 39391) inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 39359) 39381) inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Else_correct)))))
(let ((inline$$TestResources_R_pack$0$anon4_Then_correct@@5  (and (=> (= (ControlFlow 0 39365) 39391) inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 39365) 39381) inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Else_correct))))
(let ((inline$$TestResources_R_pack$0$anon3_Then_correct@@5  (=> (> 0 0) (and (=> (= (ControlFlow 0 39353) 39365) inline$$TestResources_R_pack$0$anon4_Then_correct@@5) (=> (= (ControlFlow 0 39353) 39359) inline$$TestResources_R_pack$0$anon4_Else_correct@@5)))))
(let ((inline$$TestResources_R_pack$0$anon3_Else_correct@@5  (=> (>= 0 0) (and (=> (= (ControlFlow 0 39345) 39391) inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 39345) 39381) inline$$TestResources_spec_pack_R_$def_verify$0$anon3_Else_correct)))))
(let ((inline$$TestResources_R_pack$0$anon0_correct@@5  (=> (and (and (and ((_ is $Integer) inline$$TestResources_spec_pack_R_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$TestResources_spec_pack_R_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$TestResources_spec_pack_R_$def_verify$0$$t0@1) $MAX_U64)) (= inline$$TestResources_R_pack$0$$struct@1@@5 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestResources_spec_pack_R_$def_verify$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 39337) 39353) inline$$TestResources_R_pack$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 39337) 39345) inline$$TestResources_R_pack$0$anon3_Else_correct@@5)))))
(let ((inline$$TestResources_spec_pack_R_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestResources_spec_pack_R_$def_verify$0$$t0@1 ($Integer 7)) (= (ControlFlow 0 39371) 39337)) inline$$TestResources_R_pack$0$anon0_correct@@5))))
(let ((anon0_correct@@15  (=> (= (ControlFlow 0 55561) 39371) inline$$TestResources_spec_pack_R_$def_verify$0$anon0_correct)))
anon0_correct@@15)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestResources_A_unpack$0$addr@1 () T@$Value)
(declare-fun a@@8 () T@$Value)
(declare-fun inline$$TestResources_A_unpack$0$val@1 () T@$Value)
(declare-fun va@@32 () T@$Value)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 55840) (let ((anon0$2_correct@@16  (and (=> (= (ControlFlow 0 40288) (- 0 56271)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 40288) (- 0 56280)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 40288) (- 0 56289)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$addr@1 a@@8))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$addr@1 a@@8)))) (=> (= (ControlFlow 0 40288) (- 0 56303)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$val@1 va@@32)))))))))))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 40220) 40288)) anon0$2_correct@@16)))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 40230) 40288) anon0$2_correct@@16)))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40210) 40230) inline$$TestResources_unpack_A_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 40210) 40220) inline$$TestResources_unpack_A_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 40238) 40230) inline$$TestResources_unpack_A_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 40238) 40220) inline$$TestResources_unpack_A_$def_verify$0$anon21_Else_correct))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40200) 40238) inline$$TestResources_unpack_A_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 40200) 40210) inline$$TestResources_unpack_A_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 40246) 40238) inline$$TestResources_unpack_A_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 40246) 40210) inline$$TestResources_unpack_A_$def_verify$0$anon20_Else_correct))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon18_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40158) 40246) inline$$TestResources_unpack_A_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 40158) 40200) inline$$TestResources_unpack_A_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon18_Then_correct  (and (=> (= (ControlFlow 0 40254) 40246) inline$$TestResources_unpack_A_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 40254) 40200) inline$$TestResources_unpack_A_$def_verify$0$anon19_Else_correct))))
(let ((inline$$TestResources_A_unpack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) inline$$TestResources_A_pack$0$$struct@1@@5) (= inline$$TestResources_A_unpack$0$addr@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@5)) $TestResources_A_addr))) (and ((_ is $Address) inline$$TestResources_A_unpack$0$addr@1) (= inline$$TestResources_A_unpack$0$val@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@5)) $TestResources_A_val)))) (and (and ((_ is $Integer) inline$$TestResources_A_unpack$0$val@1) (>= (|i#$Integer| inline$$TestResources_A_unpack$0$val@1) 0)) (<= (|i#$Integer| inline$$TestResources_A_unpack$0$val@1) $MAX_U64))) (and (=> (= (ControlFlow 0 40108) 40254) inline$$TestResources_unpack_A_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 40108) 40158) inline$$TestResources_unpack_A_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 40030) 40108)) inline$$TestResources_A_unpack$0$anon0_correct)))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 40262) 40108) inline$$TestResources_A_unpack$0$anon0_correct)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@5  (=> (not true) (and (=> (= (ControlFlow 0 40010) 40262) inline$$TestResources_unpack_A_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 40010) 40030) inline$$TestResources_unpack_A_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@5  (and (=> (= (ControlFlow 0 40016) 40262) inline$$TestResources_unpack_A_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 40016) 40030) inline$$TestResources_unpack_A_$def_verify$0$anon17_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@5  (=> (> 5136 0) (and (=> (= (ControlFlow 0 40004) 40016) inline$$TestResources_A_pack$0$anon4_Then_correct@@5) (=> (= (ControlFlow 0 40004) 40010) inline$$TestResources_A_pack$0$anon4_Else_correct@@5)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@5  (=> (>= 0 5136) (and (=> (= (ControlFlow 0 39996) 40262) inline$$TestResources_unpack_A_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 39996) 40030) inline$$TestResources_unpack_A_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@5  (=> ((_ is $Address) a@@8) (=> (and (and (and ((_ is $Integer) va@@32) (>= (|i#$Integer| va@@32) 0)) (<= (|i#$Integer| va@@32) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@5 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@8) 1 va@@32) 2)))) (and (=> (= (ControlFlow 0 39988) 40004) inline$$TestResources_A_pack$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 39988) 39996) inline$$TestResources_A_pack$0$anon3_Else_correct@@5))))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 39768) 39988)) inline$$TestResources_A_pack$0$anon0_correct@@5)))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 40270) 39988) inline$$TestResources_A_pack$0$anon0_correct@@5)))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 39760) 40270) inline$$TestResources_unpack_A_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 39760) 39768) inline$$TestResources_unpack_A_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 40278) 40270) inline$$TestResources_unpack_A_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 40278) 39768) inline$$TestResources_unpack_A_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestResources_unpack_A_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 39754) 40278) inline$$TestResources_unpack_A_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 39754) 39760) inline$$TestResources_unpack_A_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@16  (=> ((_ is $Address) a@@8) (=> (and (and (and ((_ is $Integer) va@@32) (>= (|i#$Integer| va@@32) 0)) (<= (|i#$Integer| va@@32) $MAX_U64)) (= (ControlFlow 0 39472) 39754)) inline$$TestResources_unpack_A_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@15  (=> (= (ControlFlow 0 55840) 39472) anon0_correct@@16)))
PreconditionGeneratedEntry_correct@@15)))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestResources_A_unpack$0$addr@1@@0 () T@$Value)
(declare-fun a@@9 () T@$Value)
(declare-fun inline$$TestResources_A_unpack$0$val@1@@0 () T@$Value)
(declare-fun va@@33 () T@$Value)
(declare-fun inline$$TestResources_B_unpack$0$val@1 () T@$Value)
(declare-fun vb@@1 () T@$Value)
(declare-fun inline$$TestResources_B_unpack$0$a@1 () T@$Value)
(declare-fun inline$$TestResources_B_pack$0$$struct@1@@2 () T@$Value)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@6 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 56326) (let ((anon0$2_correct@@17  (and (=> (= (ControlFlow 0 41843) (- 0 57025)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 41843) (- 0 57034)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 41843) (- 0 57043)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$addr@1@@0 a@@9))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$addr@1@@0 a@@9)))) (and (=> (= (ControlFlow 0 41843) (- 0 57057)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$val@1@@0 va@@33))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$val@1@@0 va@@33)))) (=> (= (ControlFlow 0 41843) (- 0 57071)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_B_unpack$0$val@1 vb@@1)))))))))))))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 41741) 41843)) anon0$2_correct@@17)))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 41751) 41843) anon0$2_correct@@17)))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41731) 41751) inline$$TestResources_unpack_B_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 41731) 41741) inline$$TestResources_unpack_B_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 41759) 41751) inline$$TestResources_unpack_B_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 41759) 41741) inline$$TestResources_unpack_B_$def_verify$0$anon33_Else_correct))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon31_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41721) 41759) inline$$TestResources_unpack_B_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 41721) 41731) inline$$TestResources_unpack_B_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon31_Then_correct  (and (=> (= (ControlFlow 0 41767) 41759) inline$$TestResources_unpack_B_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 41767) 41731) inline$$TestResources_unpack_B_$def_verify$0$anon32_Else_correct))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon30_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41711) 41767) inline$$TestResources_unpack_B_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 41711) 41721) inline$$TestResources_unpack_B_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon30_Then_correct  (and (=> (= (ControlFlow 0 41775) 41767) inline$$TestResources_unpack_B_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 41775) 41721) inline$$TestResources_unpack_B_$def_verify$0$anon31_Else_correct))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41669) 41775) inline$$TestResources_unpack_B_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 41669) 41711) inline$$TestResources_unpack_B_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 41783) 41775) inline$$TestResources_unpack_B_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 41783) 41711) inline$$TestResources_unpack_B_$def_verify$0$anon30_Else_correct))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon28_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41627) 41783) inline$$TestResources_unpack_B_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 41627) 41669) inline$$TestResources_unpack_B_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon28_Then_correct  (and (=> (= (ControlFlow 0 41791) 41783) inline$$TestResources_unpack_B_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 41791) 41669) inline$$TestResources_unpack_B_$def_verify$0$anon29_Else_correct))))
(let ((inline$$TestResources_A_unpack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Vector) inline$$TestResources_B_unpack$0$a@1) (= inline$$TestResources_A_unpack$0$addr@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)) $TestResources_A_addr))) (and ((_ is $Address) inline$$TestResources_A_unpack$0$addr@1@@0) (= inline$$TestResources_A_unpack$0$val@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)) $TestResources_A_val)))) (and (and ((_ is $Integer) inline$$TestResources_A_unpack$0$val@1@@0) (>= (|i#$Integer| inline$$TestResources_A_unpack$0$val@1@@0) 0)) (<= (|i#$Integer| inline$$TestResources_A_unpack$0$val@1@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 41577) 41791) inline$$TestResources_unpack_B_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 41577) 41627) inline$$TestResources_unpack_B_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestResources_B_unpack$0$anon0_correct  (=> (and ((_ is $Vector) inline$$TestResources_B_pack$0$$struct@1@@2) (= inline$$TestResources_B_unpack$0$val@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@2)) $TestResources_B_val))) (=> (and (and (and ((_ is $Integer) inline$$TestResources_B_unpack$0$val@1) (>= (|i#$Integer| inline$$TestResources_B_unpack$0$val@1) 0)) (<= (|i#$Integer| inline$$TestResources_B_unpack$0$val@1) $MAX_U64)) (= inline$$TestResources_B_unpack$0$a@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@2)) $TestResources_B_a))) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_B_unpack$0$a@1) (let ((va@@34 (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)))
(let ((l@@29 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1)) $TestResources_A_val)) $MAX_U64))) true) (= (ControlFlow 0 41491) 41577)) inline$$TestResources_A_unpack$0$anon0_correct@@0)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 41413) 41491)) inline$$TestResources_B_unpack$0$anon0_correct)))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 41799) 41491) inline$$TestResources_B_unpack$0$anon0_correct)))
(let ((inline$$TestResources_B_pack$0$anon4_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 41393) 41799) inline$$TestResources_unpack_B_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 41393) 41413) inline$$TestResources_unpack_B_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon4_Then_correct@@2  (and (=> (= (ControlFlow 0 41399) 41799) inline$$TestResources_unpack_B_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 41399) 41413) inline$$TestResources_unpack_B_$def_verify$0$anon27_Else_correct))))
(let ((inline$$TestResources_B_pack$0$anon3_Then_correct@@2  (=> (> 5480 0) (and (=> (= (ControlFlow 0 41387) 41399) inline$$TestResources_B_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 41387) 41393) inline$$TestResources_B_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$TestResources_B_pack$0$anon3_Else_correct@@2  (=> (>= 0 5480) (and (=> (= (ControlFlow 0 41379) 41799) inline$$TestResources_unpack_B_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 41379) 41413) inline$$TestResources_unpack_B_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon0_correct@@2  (=> (and (and ((_ is $Integer) vb@@1) (>= (|i#$Integer| vb@@1) 0)) (<= (|i#$Integer| vb@@1) $MAX_U64)) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_A_pack$0$$struct@1@@6) (let ((va@@35 (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@6)))
(let ((l@@30 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@6)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@6)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@6)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@6)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@6)) $TestResources_A_val)) $MAX_U64))) true) (= inline$$TestResources_B_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 vb@@1) 1 inline$$TestResources_A_pack$0$$struct@1@@6) 2)))) (and (=> (= (ControlFlow 0 41371) 41387) inline$$TestResources_B_pack$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 41371) 41379) inline$$TestResources_B_pack$0$anon3_Else_correct@@2))))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 41219) 41371)) inline$$TestResources_B_pack$0$anon0_correct@@2)))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 41807) 41371) inline$$TestResources_B_pack$0$anon0_correct@@2)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@6  (=> (not true) (and (=> (= (ControlFlow 0 41199) 41807) inline$$TestResources_unpack_B_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 41199) 41219) inline$$TestResources_unpack_B_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@6  (and (=> (= (ControlFlow 0 41205) 41807) inline$$TestResources_unpack_B_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 41205) 41219) inline$$TestResources_unpack_B_$def_verify$0$anon26_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@6  (=> (> 5437 0) (and (=> (= (ControlFlow 0 41193) 41205) inline$$TestResources_A_pack$0$anon4_Then_correct@@6) (=> (= (ControlFlow 0 41193) 41199) inline$$TestResources_A_pack$0$anon4_Else_correct@@6)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@6  (=> (>= 0 5437) (and (=> (= (ControlFlow 0 41185) 41807) inline$$TestResources_unpack_B_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 41185) 41219) inline$$TestResources_unpack_B_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@6  (=> ((_ is $Address) a@@9) (=> (and (and (and ((_ is $Integer) va@@33) (>= (|i#$Integer| va@@33) 0)) (<= (|i#$Integer| va@@33) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@6 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@9) 1 va@@33) 2)))) (and (=> (= (ControlFlow 0 41177) 41193) inline$$TestResources_A_pack$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 41177) 41185) inline$$TestResources_A_pack$0$anon3_Else_correct@@6))))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 40923) 41177)) inline$$TestResources_A_pack$0$anon0_correct@@6)))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 41815) 41177) inline$$TestResources_A_pack$0$anon0_correct@@6)))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40915) 41815) inline$$TestResources_unpack_B_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 40915) 40923) inline$$TestResources_unpack_B_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 41823) 41815) inline$$TestResources_unpack_B_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 41823) 40923) inline$$TestResources_unpack_B_$def_verify$0$anon25_Else_correct))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40907) 41823) inline$$TestResources_unpack_B_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 40907) 40915) inline$$TestResources_unpack_B_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 41831) 41823) inline$$TestResources_unpack_B_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 41831) 40915) inline$$TestResources_unpack_B_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestResources_unpack_B_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 40901) 41831) inline$$TestResources_unpack_B_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 40901) 40907) inline$$TestResources_unpack_B_$def_verify$0$anon23_Else_correct)))))
(let ((anon0_correct@@17  (=> ((_ is $Address) a@@9) (=> (and (and ((_ is $Integer) va@@33) (>= (|i#$Integer| va@@33) 0)) (<= (|i#$Integer| va@@33) $MAX_U64)) (=> (and (and (and ((_ is $Integer) vb@@1) (>= (|i#$Integer| vb@@1) 0)) (<= (|i#$Integer| vb@@1) $MAX_U64)) (= (ControlFlow 0 40470) 40901)) inline$$TestResources_unpack_B_$def_verify$0$anon0_correct)))))
(let ((PreconditionGeneratedEntry_correct@@16  (=> (= (ControlFlow 0 56326) 40470) anon0_correct@@17)))
PreconditionGeneratedEntry_correct@@16)))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestResources_A_unpack$0$addr@1@@1 () T@$Value)
(declare-fun a@@10 () T@$Value)
(declare-fun inline$$TestResources_A_unpack$0$val@1@@1 () T@$Value)
(declare-fun va@@36 () T@$Value)
(declare-fun inline$$TestResources_B_unpack$0$val@1@@0 () T@$Value)
(declare-fun vb@@2 () T@$Value)
(declare-fun inline$$TestResources_C_unpack$0$val@1 () T@$Value)
(declare-fun vc@@0 () T@$Value)
(declare-fun inline$$TestResources_B_unpack$0$a@1@@0 () T@$Value)
(declare-fun inline$$TestResources_C_unpack$0$b@1 () T@$Value)
(declare-fun inline$$TestResources_C_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$TestResources_B_pack$0$$struct@1@@3 () T@$Value)
(declare-fun inline$$TestResources_A_pack$0$$struct@1@@7 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 57096) (let ((anon0$2_correct@@18  (and (=> (= (ControlFlow 0 44047) (- 0 58063)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 44047) (- 0 58072)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 44047) (- 0 58081)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$addr@1@@1 a@@10))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$addr@1@@1 a@@10)))) (and (=> (= (ControlFlow 0 44047) (- 0 58095)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$val@1@@1 va@@36))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_A_unpack$0$val@1@@1 va@@36)))) (and (=> (= (ControlFlow 0 44047) (- 0 58109)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_B_unpack$0$val@1@@0 vb@@2))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_B_unpack$0$val@1@@0 vb@@2)))) (=> (= (ControlFlow 0 44047) (- 0 58123)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestResources_C_unpack$0$val@1 vc@@0)))))))))))))))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 43911) 44047)) anon0$2_correct@@18)))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 43921) 44047) anon0$2_correct@@18)))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon44_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43901) 43921) inline$$TestResources_unpack_C_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 43901) 43911) inline$$TestResources_unpack_C_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon44_Then_correct  (and (=> (= (ControlFlow 0 43929) 43921) inline$$TestResources_unpack_C_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 43929) 43911) inline$$TestResources_unpack_C_$def_verify$0$anon45_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43891) 43929) inline$$TestResources_unpack_C_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 43891) 43901) inline$$TestResources_unpack_C_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon43_Then_correct  (and (=> (= (ControlFlow 0 43937) 43929) inline$$TestResources_unpack_C_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 43937) 43901) inline$$TestResources_unpack_C_$def_verify$0$anon44_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon42_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43881) 43937) inline$$TestResources_unpack_C_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 43881) 43891) inline$$TestResources_unpack_C_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon42_Then_correct  (and (=> (= (ControlFlow 0 43945) 43937) inline$$TestResources_unpack_C_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 43945) 43891) inline$$TestResources_unpack_C_$def_verify$0$anon43_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43871) 43945) inline$$TestResources_unpack_C_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 43871) 43881) inline$$TestResources_unpack_C_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 43953) 43945) inline$$TestResources_unpack_C_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 43953) 43881) inline$$TestResources_unpack_C_$def_verify$0$anon42_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon40_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43829) 43953) inline$$TestResources_unpack_C_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 43829) 43871) inline$$TestResources_unpack_C_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon40_Then_correct  (and (=> (= (ControlFlow 0 43961) 43953) inline$$TestResources_unpack_C_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 43961) 43871) inline$$TestResources_unpack_C_$def_verify$0$anon41_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon39_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43787) 43961) inline$$TestResources_unpack_C_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 43787) 43829) inline$$TestResources_unpack_C_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon39_Then_correct  (and (=> (= (ControlFlow 0 43969) 43961) inline$$TestResources_unpack_C_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 43969) 43829) inline$$TestResources_unpack_C_$def_verify$0$anon40_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon38_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43745) 43969) inline$$TestResources_unpack_C_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 43745) 43787) inline$$TestResources_unpack_C_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon38_Then_correct  (and (=> (= (ControlFlow 0 43977) 43969) inline$$TestResources_unpack_C_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 43977) 43787) inline$$TestResources_unpack_C_$def_verify$0$anon39_Else_correct))))
(let ((inline$$TestResources_A_unpack$0$anon0_correct@@1  (=> (and (and (and ((_ is $Vector) inline$$TestResources_B_unpack$0$a@1@@0) (= inline$$TestResources_A_unpack$0$addr@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)) $TestResources_A_addr))) (and ((_ is $Address) inline$$TestResources_A_unpack$0$addr@1@@1) (= inline$$TestResources_A_unpack$0$val@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)) $TestResources_A_val)))) (and (and ((_ is $Integer) inline$$TestResources_A_unpack$0$val@1@@1) (>= (|i#$Integer| inline$$TestResources_A_unpack$0$val@1@@1) 0)) (<= (|i#$Integer| inline$$TestResources_A_unpack$0$val@1@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 43695) 43977) inline$$TestResources_unpack_C_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 43695) 43745) inline$$TestResources_unpack_C_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$TestResources_B_unpack$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$TestResources_C_unpack$0$b@1) (= inline$$TestResources_B_unpack$0$val@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_val))) (=> (and (and (and ((_ is $Integer) inline$$TestResources_B_unpack$0$val@1@@0) (>= (|i#$Integer| inline$$TestResources_B_unpack$0$val@1@@0) 0)) (<= (|i#$Integer| inline$$TestResources_B_unpack$0$val@1@@0) $MAX_U64)) (= inline$$TestResources_B_unpack$0$a@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a))) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_B_unpack$0$a@1@@0) (let ((va@@37 (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)))
(let ((l@@31 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_unpack$0$a@1@@0)) $TestResources_A_val)) $MAX_U64))) true) (= (ControlFlow 0 43609) 43695)) inline$$TestResources_A_unpack$0$anon0_correct@@1)))))
(let ((inline$$TestResources_C_unpack$0$anon0_correct  (=> (and ((_ is $Vector) inline$$TestResources_C_pack$0$$struct@1@@0) (= inline$$TestResources_C_unpack$0$val@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1@@0)) $TestResources_C_val))) (=> (and (and (and ((_ is $Integer) inline$$TestResources_C_unpack$0$val@1) (>= (|i#$Integer| inline$$TestResources_C_unpack$0$val@1) 0)) (<= (|i#$Integer| inline$$TestResources_C_unpack$0$val@1) $MAX_U64)) (= inline$$TestResources_C_unpack$0$b@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_pack$0$$struct@1@@0)) $TestResources_C_b))) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_C_unpack$0$b@1) (let ((va@@38 (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)))
(let ((l@@32 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_val)) $MAX_U64))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a))))
(let ((l@@33 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a))) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a))) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a))) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_C_unpack$0$b@1)) $TestResources_B_a))) $TestResources_A_val)) $MAX_U64)))) true) (= (ControlFlow 0 43523) 43609)) inline$$TestResources_B_unpack$0$anon0_correct@@0)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 43445) 43523)) inline$$TestResources_C_unpack$0$anon0_correct)))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 43985) 43523) inline$$TestResources_C_unpack$0$anon0_correct)))
(let ((inline$$TestResources_C_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 43425) 43985) inline$$TestResources_unpack_C_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 43425) 43445) inline$$TestResources_unpack_C_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$TestResources_C_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 43431) 43985) inline$$TestResources_unpack_C_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 43431) 43445) inline$$TestResources_unpack_C_$def_verify$0$anon37_Else_correct))))
(let ((inline$$TestResources_C_pack$0$anon3_Then_correct@@0  (=> (> 5937 0) (and (=> (= (ControlFlow 0 43419) 43431) inline$$TestResources_C_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 43419) 43425) inline$$TestResources_C_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestResources_C_pack$0$anon3_Else_correct@@0  (=> (>= 0 5937) (and (=> (= (ControlFlow 0 43411) 43985) inline$$TestResources_unpack_C_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 43411) 43445) inline$$TestResources_unpack_C_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$TestResources_C_pack$0$anon0_correct@@0  (=> (and (and ((_ is $Integer) vc@@0) (>= (|i#$Integer| vc@@0) 0)) (<= (|i#$Integer| vc@@0) $MAX_U64)) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_B_pack$0$$struct@1@@3) (let ((va@@40 (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)))
(let ((l@@34 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_val)) $MAX_U64))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_a)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_a))))
(let ((l@@35 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_a))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_a))) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_a))) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_a))) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_B_pack$0$$struct@1@@3)) $TestResources_B_a))) $TestResources_A_val)) $MAX_U64)))) true) (= inline$$TestResources_C_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 vc@@0) 1 inline$$TestResources_B_pack$0$$struct@1@@3) 2)))) (and (=> (= (ControlFlow 0 43403) 43419) inline$$TestResources_C_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 43403) 43411) inline$$TestResources_C_pack$0$anon3_Else_correct@@0))))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 43251) 43403)) inline$$TestResources_C_pack$0$anon0_correct@@0)))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 43993) 43403) inline$$TestResources_C_pack$0$anon0_correct@@0)))
(let ((inline$$TestResources_B_pack$0$anon4_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 43231) 43993) inline$$TestResources_unpack_C_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 43231) 43251) inline$$TestResources_unpack_C_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon4_Then_correct@@3  (and (=> (= (ControlFlow 0 43237) 43993) inline$$TestResources_unpack_C_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 43237) 43251) inline$$TestResources_unpack_C_$def_verify$0$anon36_Else_correct))))
(let ((inline$$TestResources_B_pack$0$anon3_Then_correct@@3  (=> (> 5893 0) (and (=> (= (ControlFlow 0 43225) 43237) inline$$TestResources_B_pack$0$anon4_Then_correct@@3) (=> (= (ControlFlow 0 43225) 43231) inline$$TestResources_B_pack$0$anon4_Else_correct@@3)))))
(let ((inline$$TestResources_B_pack$0$anon3_Else_correct@@3  (=> (>= 0 5893) (and (=> (= (ControlFlow 0 43217) 43993) inline$$TestResources_unpack_C_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 43217) 43251) inline$$TestResources_unpack_C_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestResources_B_pack$0$anon0_correct@@3  (=> (and (and ((_ is $Integer) vb@@2) (>= (|i#$Integer| vb@@2) 0)) (<= (|i#$Integer| vb@@2) $MAX_U64)) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$TestResources_A_pack$0$$struct@1@@7) (let ((va@@42 (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@7)))
(let ((l@@36 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@7)) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@7)) $TestResources_A_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@7)) $TestResources_A_val)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@7)) $TestResources_A_val)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestResources_A_pack$0$$struct@1@@7)) $TestResources_A_val)) $MAX_U64))) true) (= inline$$TestResources_B_pack$0$$struct@1@@3 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 vb@@2) 1 inline$$TestResources_A_pack$0$$struct@1@@7) 2)))) (and (=> (= (ControlFlow 0 43209) 43225) inline$$TestResources_B_pack$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 43209) 43217) inline$$TestResources_B_pack$0$anon3_Else_correct@@3))))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 43057) 43209)) inline$$TestResources_B_pack$0$anon0_correct@@3)))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 44001) 43209) inline$$TestResources_B_pack$0$anon0_correct@@3)))
(let ((inline$$TestResources_A_pack$0$anon4_Else_correct@@7  (=> (not true) (and (=> (= (ControlFlow 0 43037) 44001) inline$$TestResources_unpack_C_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 43037) 43057) inline$$TestResources_unpack_C_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon4_Then_correct@@7  (and (=> (= (ControlFlow 0 43043) 44001) inline$$TestResources_unpack_C_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 43043) 43057) inline$$TestResources_unpack_C_$def_verify$0$anon35_Else_correct))))
(let ((inline$$TestResources_A_pack$0$anon3_Then_correct@@7  (=> (> 5850 0) (and (=> (= (ControlFlow 0 43031) 43043) inline$$TestResources_A_pack$0$anon4_Then_correct@@7) (=> (= (ControlFlow 0 43031) 43037) inline$$TestResources_A_pack$0$anon4_Else_correct@@7)))))
(let ((inline$$TestResources_A_pack$0$anon3_Else_correct@@7  (=> (>= 0 5850) (and (=> (= (ControlFlow 0 43023) 44001) inline$$TestResources_unpack_C_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 43023) 43057) inline$$TestResources_unpack_C_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$TestResources_A_pack$0$anon0_correct@@7  (=> ((_ is $Address) a@@10) (=> (and (and (and ((_ is $Integer) va@@36) (>= (|i#$Integer| va@@36) 0)) (<= (|i#$Integer| va@@36) $MAX_U64)) (= inline$$TestResources_A_pack$0$$struct@1@@7 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 a@@10) 1 va@@36) 2)))) (and (=> (= (ControlFlow 0 43015) 43031) inline$$TestResources_A_pack$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 43015) 43023) inline$$TestResources_A_pack$0$anon3_Else_correct@@7))))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 42727) 43015)) inline$$TestResources_A_pack$0$anon0_correct@@7)))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 44009) 43015) inline$$TestResources_A_pack$0$anon0_correct@@7)))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42719) 44009) inline$$TestResources_unpack_C_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 42719) 42727) inline$$TestResources_unpack_C_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 44017) 44009) inline$$TestResources_unpack_C_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 44017) 42727) inline$$TestResources_unpack_C_$def_verify$0$anon34_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42711) 44017) inline$$TestResources_unpack_C_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 42711) 42719) inline$$TestResources_unpack_C_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 44025) 44017) inline$$TestResources_unpack_C_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 44025) 42719) inline$$TestResources_unpack_C_$def_verify$0$anon33_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon31_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42703) 44025) inline$$TestResources_unpack_C_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 42703) 42711) inline$$TestResources_unpack_C_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon31_Then_correct  (and (=> (= (ControlFlow 0 44033) 44025) inline$$TestResources_unpack_C_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 44033) 42711) inline$$TestResources_unpack_C_$def_verify$0$anon32_Else_correct))))
(let ((inline$$TestResources_unpack_C_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 42697) 44033) inline$$TestResources_unpack_C_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 42697) 42703) inline$$TestResources_unpack_C_$def_verify$0$anon31_Else_correct)))))
(let ((anon0_correct@@18  (=> ((_ is $Address) a@@10) (=> (and (and (and (and ((_ is $Integer) va@@36) (>= (|i#$Integer| va@@36) 0)) (<= (|i#$Integer| va@@36) $MAX_U64)) (and (and ((_ is $Integer) vb@@2) (>= (|i#$Integer| vb@@2) 0)) (<= (|i#$Integer| vb@@2) $MAX_U64))) (and (and (and ((_ is $Integer) vc@@0) (>= (|i#$Integer| vc@@0) 0)) (<= (|i#$Integer| vc@@0) $MAX_U64)) (= (ControlFlow 0 42117) 42697))) inline$$TestResources_unpack_C_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@17  (=> (= (ControlFlow 0 57096) 42117) anon0_correct@@18)))
PreconditionGeneratedEntry_correct@@17)))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
