(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestMarketCapWithSchemas_MarketCap () T@$TypeName)
(declare-fun $TestMarketCapWithSchemas_T () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestMarketCapWithSchemas_MarketCap_total_value () Int)
(declare-fun $TestMarketCapWithSchemas_MarketCap_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $TestMarketCapWithSchemas_T_value () Int)
(declare-fun $TestMarketCapWithSchemas_T_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestMarketCapWithSchemas_MarketCap $TestMarketCapWithSchemas_T)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestMarketCapWithSchemas_MarketCap_total_value 0))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($TestMarketCapWithSchemas_MarketCap_type_value $tv0) ($StructType $TestMarketCapWithSchemas_MarketCap ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($TestMarketCapWithSchemas_MarketCap_type_value $tv0))
)))
(assert (= $TestMarketCapWithSchemas_T_value 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($TestMarketCapWithSchemas_T_type_value $tv0@@0) ($StructType $TestMarketCapWithSchemas_T ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($TestMarketCapWithSchemas_T_type_value $tv0@@0))
)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun coin_ref () T@$Value)
(declare-fun check () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $TestMarketCapWithSchemas_MarketCap_$memory () T@$Memory)
(declare-fun $tv0@@1 () T@$TypeValue)
(declare-sort |T@[$TypeValue]$Value| 0)
(declare-fun |Select_[$TypeValue]$Value| (|T@[$TypeValue]$Value| T@$TypeValue) T@$Value)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@3 () |T@[$TypeValue]$Value|)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@1 () |T@[$TypeValue]$Value|)
(declare-fun $abort_flag@0 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@2 () |T@[$TypeValue]$Value|)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun |Store_[$TypeValue]$Value| (|T@[$TypeValue]$Value| T@$TypeValue T@$Value) |T@[$TypeValue]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValue]$Value|) ( ?x1 T@$TypeValue) ( ?x2 T@$Value)) (= (|Select_[$TypeValue]$Value| (|Store_[$TypeValue]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[$TypeValue]$Value|) ( ?x1 T@$TypeValue) ( ?y1 T@$TypeValue) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$TypeValue]$Value| (|Store_[$TypeValue]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$TypeValue]$Value| ?x0 ?y1)))))
(declare-fun inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_T_unpack$0$value@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@0 () |T@[$TypeValue]$Value|)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins () |T@[$TypeValue]$Value|)
(declare-fun inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun $TestMarketCapWithSchemas_T_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26933) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 16002) (- 0 28174)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1) (and (=> (= (ControlFlow 0 16002) (- 0 28211)) (=> $abort_flag@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value))))) (|i#$Integer| ($Integer $MAX_U64)))))) (and (=> (= (ControlFlow 0 16002) (- 0 28248)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_MarketCap_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| ($Address 173345816))))) $TestMarketCapWithSchemas_MarketCap_total_value) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@3 $tv0@@1)))))) (=> (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_MarketCap_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| ($Address 173345816))))) $TestMarketCapWithSchemas_MarketCap_total_value) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@3 $tv0@@1))))) (=> (= (ControlFlow 0 16002) (- 0 28290)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$$ret0@2)) $TestMarketCapWithSchemas_T_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value)))))))))))))))))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon9_correct  (=> (= inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$$ret0@2 inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$$ret0@1) (= $TestMarketCapWithSchemas_sum_of_coins@3 $TestMarketCapWithSchemas_sum_of_coins@1)) (and (= $abort_flag@1 true) (= (ControlFlow 0 15962) 16002))) anon0$2_correct))))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 15956) 15962)) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon9_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 15970) 15962) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon9_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 15950) 15970) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 15950) 15956) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon12_correct  (=> (and (and (= inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|) (= $TestMarketCapWithSchemas_sum_of_coins@3 $TestMarketCapWithSchemas_sum_of_coins@2)) (and (= $abort_flag@1 $abort_flag@0) (= (ControlFlow 0 15938) 16002))) anon0$2_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 15936) 15938)) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon12_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 15946) 15938) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon12_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2| coin_ref)) (and (=> (= (ControlFlow 0 15894) 15946) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 15894) 15936) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 coin_ref (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|)) (and (=> (= (ControlFlow 0 15920) 15946) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 15920) 15936) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct  (=> (= $TestMarketCapWithSchemas_sum_of_coins@2 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1 $tv0@@1 ($Integer (+ (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1 $tv0@@1)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0)) $TestMarketCapWithSchemas_T_value)))))) (and (=> (= (ControlFlow 0 15797) 15920) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 15797) 15894) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct  (=> (and (= inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 15769) 15797)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1) (= (ControlFlow 0 15650) 15769)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 15706) 15769))) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 15614) 15706) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 15614) 15650) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$AddU64$0$dst@2)) (= (ControlFlow 0 15471) 15614)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 15412) 15471))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 15418) 15412)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 15282) 15950) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 15282) 15418) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1)) $MAX_U64) (= (ControlFlow 0 15280) 15282)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1))))) (and (= $abort_flag@0 false) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 15224) 15950) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 15224) 15418) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 15194) (- 0 27716)) true) (and (=> (= (ControlFlow 0 15194) 15280) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 15194) 15224) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 15087) 15194)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 15049) 15087))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 14895) 15049)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 15978) 15049) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct  (=> (and ((_ is $Vector) check) (= inline$$TestMarketCapWithSchemas_T_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value))) (=> (and (and (and ((_ is $Integer) inline$$TestMarketCapWithSchemas_T_unpack$0$value@1) (>= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1) $MAX_U64)) (= $TestMarketCapWithSchemas_sum_of_coins@1 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0 $tv0@@1 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0 $tv0@@1)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value))))))) (and (=> (= (ControlFlow 0 14881) 15978) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 14881) 14895) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct  (=> (and (= $TestMarketCapWithSchemas_sum_of_coins@0 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@1 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@1)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0)) $TestMarketCapWithSchemas_T_value)))))) (= (ControlFlow 0 14759) 14881)) inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct)))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct  (=> (and (= inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 14727) 14759)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 3) $EmptyPath coin_ref)) (= (ControlFlow 0 14660) 14727)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 14542) 14660)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 15986) 14660) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14534) 15986) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 14534) 14542) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 15994) 15986) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 15994) 14542) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon14_Else_correct))))
(let ((inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14528) 15994) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14528) 14534) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))
)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_MarketCap_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| ($Address 173345816))))) $TestMarketCapWithSchemas_MarketCap_total_value) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@1)))) (= (ControlFlow 0 16000) 14528)) inline$$TestMarketCapWithSchemas_deposit_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and (and (and (and ((_ is $Vector) coin_ref) (let ((va@@9 (|v#$Vector| coin_ref)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin_ref)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) check) (let ((va@@10 (|v#$Vector| check)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| check)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (= (ControlFlow 0 14144) 16000)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (and (forall (($tv0@@2 T@$TypeValue) ) ((_ is $Integer) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@2))) (= (ControlFlow 0 26933) 14144)) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin_ref@@0 () T@$Value)
(declare-fun check@@0 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@2@@0 () |T@[$TypeValue]$Value|)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@1@@0 () |T@[$TypeValue]$Value|)
(declare-fun $tv0@@3 () T@$TypeValue)
(declare-fun inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$Div$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Div$0$dst@0 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Div$0$dst@1 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@0@@0 () |T@[$TypeValue]$Value|)
(declare-fun inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28343) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 18479) (- 0 29666)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2) (and (=> (= (ControlFlow 0 18479) (- 0 29715)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64)))))) (=> (= (ControlFlow 0 18479) (- 0 29764)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$ret0@2)) $TestMarketCapWithSchemas_T_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2))))))))))))))))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$ret0@1 $Error) (= inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$ret0@2 inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$ret0@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 18419) 18479))) anon0$2_correct@@0)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 18437) 18419)) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 18447) 18419) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 18431) 18447) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 18431) 18437) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 18411) 18419)) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 18427) 18419) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 18405) 18427) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 18405) 18411) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon16_correct  (=> (= inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@0|) (=> (and (= $abort_flag@2 $abort_flag@1@@0) (= (ControlFlow 0 18393) 18479)) anon0$2_correct@@0))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 18391) 18393)) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon16_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 18401) 18393) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon16_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@0| coin_ref@@0)) (and (=> (= (ControlFlow 0 18349) 18401) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 18349) 18391) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 coin_ref@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 18375) 18401) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 18375) 18391) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct@@0  (=> (= $TestMarketCapWithSchemas_sum_of_coins@2@@0 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1@@0 $tv0@@3 ($Integer (+ (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1@@0 $tv0@@3)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@0)) $TestMarketCapWithSchemas_T_value)))))) (and (=> (= (ControlFlow 0 18252) 18375) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 18252) 18349) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 18224) 18252)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$0$dst@1@@0) (= (ControlFlow 0 18105) 18224)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 18161) 18224))) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) (and (=> (= (ControlFlow 0 18069) 18161) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 18069) 18105) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) inline$$AddU64$0$dst@2@@0)) (= (ControlFlow 0 17926) 18069)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 17867) 17926))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 17873) 17867)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@0 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 17737) 18405) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17737) 17873) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$Div$0$dst@2)) $MAX_U64) (= (ControlFlow 0 17735) 17737)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$Div$0$dst@2))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@0) (|i#$Integer| inline$$Div$0$dst@2))))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 17679) 18405) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17679) 17873) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 17649) (- 0 29203)) true) (and (=> (= (ControlFlow 0 17649) 17735) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 17649) 17679) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 17743) 17649)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$Div$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@0 true) (= inline$$Div$0$dst@2 inline$$Div$0$dst@0)) (and (=> (= (ControlFlow 0 17544) 18431) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17544) 17743) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct  (=> (and (= (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$t7@1) 0) (= (ControlFlow 0 17542) 17544)) inline$$Div$0$anon3_Then$1_correct)))
(let ((inline$$Div$0$anon3_Else_correct  (=> (and (and (not (= (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$t7@1) 0)) (= inline$$Div$0$dst@1 ($Integer (div (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@0) (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$t7@1))))) (and (= $abort_flag@0@@0 false) (= inline$$Div$0$dst@2 inline$$Div$0$dst@1))) (and (=> (= (ControlFlow 0 17492) 18431) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17492) 17743) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$Entry_correct  (and (=> (= (ControlFlow 0 17468) (- 0 29126)) true) (and (=> (= (ControlFlow 0 17468) 17542) inline$$Div$0$anon3_Then_correct) (=> (= (ControlFlow 0 17468) 17492) inline$$Div$0$anon3_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon6$1_correct  (=> (and (= inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$$t7@1 ($Integer 2)) (= (ControlFlow 0 17550) 17468)) inline$$Div$0$Entry_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 17367) 17550)) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon6$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 17329) 17367))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 17175) 17329)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 18455) 17329) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@0  (=> (and ((_ is $Vector) check@@0) (= inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value))) (=> (and (and (and ((_ is $Integer) inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@0) (>= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@0) 0)) (<= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@0) $MAX_U64)) (= $TestMarketCapWithSchemas_sum_of_coins@1@@0 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0@@0 $tv0@@3 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0@@0 $tv0@@3)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value))))))) (and (=> (= (ControlFlow 0 17161) 18455) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17161) 17175) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct@@0  (=> (and (= $TestMarketCapWithSchemas_sum_of_coins@0@@0 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@3 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@3)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@0)) $TestMarketCapWithSchemas_T_value)))))) (= (ControlFlow 0 17039) 17161)) inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@0)))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 17007) 17039)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 3) $EmptyPath coin_ref@@0)) (= (ControlFlow 0 16940) 17007)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 16822) 16940)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 18463) 16940) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16814) 18463) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 16814) 16822) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 18471) 18463) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 18471) 16822) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16808) 18471) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 16808) 16814) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))
)) (= (ControlFlow 0 18477) 16808)) inline$$TestMarketCapWithSchemas_deposit_different_type_params_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and (and (and (and ((_ is $Vector) coin_ref@@0) (let ((va@@12 (|v#$Vector| coin_ref@@0)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin_ref@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@0)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) check@@0) (let ((va@@13 (|v#$Vector| check@@0)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| check@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@0)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (= (ControlFlow 0 16395) 18477)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (and (forall (($tv0@@4 T@$TypeValue) ) ((_ is $Integer) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@4))) (= (ControlFlow 0 28343) 16395)) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin_ref@@1 () T@$Value)
(declare-fun check@@1 () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $tv0@@5 () T@$TypeValue)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@3@@0 () |T@[$TypeValue]$Value|)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@1@@1 () |T@[$TypeValue]$Value|)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@2@@1 () |T@[$TypeValue]$Value|)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$Div$0$dst@2@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Div$0$dst@0@@0 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Div$0$dst@1@@0 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@0@@1 () |T@[$TypeValue]$Value|)
(declare-fun inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29820) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 21004) (- 0 31228)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2@@0) (and (=> (= (ControlFlow 0 21004) (- 0 31277)) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64)))))) (and (=> (= (ControlFlow 0 21004) (- 0 31326)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_MarketCap_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816))))) $TestMarketCapWithSchemas_MarketCap_total_value) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@3@@0 $tv0@@5)))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_MarketCap_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816))))) $TestMarketCapWithSchemas_MarketCap_total_value) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@3@@0 $tv0@@5))))) (=> (= (ControlFlow 0 21004) (- 0 31368)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$ret0@2)) $TestMarketCapWithSchemas_T_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2))))))))))))))))))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$Abort_correct  (=> (= inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$ret0@2 inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$ret0@1) (= $TestMarketCapWithSchemas_sum_of_coins@3@@0 $TestMarketCapWithSchemas_sum_of_coins@1@@1)) (and (= $abort_flag@2@@0 true) (= (ControlFlow 0 20944) 21004))) anon0$2_correct@@1))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 20962) 20944)) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 20972) 20944) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 20956) 20972) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 20956) 20962) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 20936) 20944)) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 20952) 20944) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 20930) 20952) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 20930) 20936) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon16_correct  (=> (and (and (= inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@1|) (= $TestMarketCapWithSchemas_sum_of_coins@3@@0 $TestMarketCapWithSchemas_sum_of_coins@2@@1)) (and (= $abort_flag@2@@0 $abort_flag@1@@1) (= (ControlFlow 0 20918) 21004))) anon0$2_correct@@1)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 20916) 20918)) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon16_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 20926) 20918) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon16_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@1| coin_ref@@1)) (and (=> (= (ControlFlow 0 20874) 20926) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 20874) 20916) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 coin_ref@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 20900) 20926) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 20900) 20916) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct@@1  (=> (= $TestMarketCapWithSchemas_sum_of_coins@2@@1 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1@@1 $tv0@@5 ($Integer (+ (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1@@1 $tv0@@5)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@1)) $TestMarketCapWithSchemas_T_value)))))) (and (=> (= (ControlFlow 0 20777) 20900) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 20777) 20874) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 20749) 20777)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@1) (= (ControlFlow 0 20630) 20749)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 20686) 20749))) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 20594) 20686) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 20594) 20630) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@1) (|p#$Mutation| inline$$BorrowField$1$dst@1@@1) inline$$AddU64$0$dst@2@@1)) (= (ControlFlow 0 20451) 20594)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 20392) 20451))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 20398) 20392)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@1@@1 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 20262) 20930) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 20262) 20398) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$Div$0$dst@2@@0)) $MAX_U64) (= (ControlFlow 0 20260) 20262)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$Div$0$dst@2@@0))) (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$Div$0$dst@2@@0))))) (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 20204) 20930) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 20204) 20398) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 20174) (- 0 30756)) true) (and (=> (= (ControlFlow 0 20174) 20260) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 20174) 20204) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 20268) 20174)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$Div$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@1 true) (= inline$$Div$0$dst@2@@0 inline$$Div$0$dst@0@@0)) (and (=> (= (ControlFlow 0 20069) 20956) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 20069) 20268) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct@@0  (=> (and (= (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$t7@1) 0) (= (ControlFlow 0 20067) 20069)) inline$$Div$0$anon3_Then$1_correct@@0)))
(let ((inline$$Div$0$anon3_Else_correct@@0  (=> (and (and (not (= (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$t7@1) 0)) (= inline$$Div$0$dst@1@@0 ($Integer (div (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@1) (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$t7@1))))) (and (= $abort_flag@0@@1 false) (= inline$$Div$0$dst@2@@0 inline$$Div$0$dst@1@@0))) (and (=> (= (ControlFlow 0 20017) 20956) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 20017) 20268) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 19993) (- 0 30679)) true) (and (=> (= (ControlFlow 0 19993) 20067) inline$$Div$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 19993) 20017) inline$$Div$0$anon3_Else_correct@@0)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon6$1_correct  (=> (and (= inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$$t7@1 ($Integer 2)) (= (ControlFlow 0 20075) 19993)) inline$$Div$0$Entry_correct@@0)))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 19892) 20075)) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon6$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 19854) 19892))) inline$$ReadRef$0$anon0_correct@@1))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 19700) 19854)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 20980) 19854) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@1  (=> (and ((_ is $Vector) check@@1) (= inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value))) (=> (and (and (and ((_ is $Integer) inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@1) (>= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@1) 0)) (<= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@1) $MAX_U64)) (= $TestMarketCapWithSchemas_sum_of_coins@1@@1 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0@@1 $tv0@@5 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0@@1 $tv0@@5)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value))))))) (and (=> (= (ControlFlow 0 19686) 20980) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 19686) 19700) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct@@1  (=> (and (= $TestMarketCapWithSchemas_sum_of_coins@0@@1 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@5 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@5)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@1)) $TestMarketCapWithSchemas_T_value)))))) (= (ControlFlow 0 19564) 19686)) inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@1)))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 19532) 19564)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 3) $EmptyPath coin_ref@@1)) (= (ControlFlow 0 19465) 19532)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 19347) 19465)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 20988) 19465) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 19339) 20988) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 19339) 19347) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 20996) 20988) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 20996) 19347) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 19333) 20996) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 19333) 19339) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@1 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))
)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_MarketCap_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816))))) $TestMarketCapWithSchemas_MarketCap_total_value) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@5)))) (= (ControlFlow 0 21002) 19333)) inline$$TestMarketCapWithSchemas_deposit_incorrect_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and (and (and (and ((_ is $Vector) coin_ref@@1) (let ((va@@15 (|v#$Vector| coin_ref@@1)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin_ref@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@1)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) check@@1) (let ((va@@16 (|v#$Vector| check@@1)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| check@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@1)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (= (ControlFlow 0 18889) 21002)) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (and (forall (($tv0@@6 T@$TypeValue) ) ((_ is $Integer) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@6))) (= (ControlFlow 0 29820) 18889)) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun coin_ref@@2 () T@$Value)
(declare-fun check@@2 () T@$Value)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@2 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@2 () Int)
(declare-fun inline$$BorrowField$1$p@2@@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$Div$0$dst@2@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$Div$0$dst@0@@1 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Div$0$dst@1@@1 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@0@@2 () |T@[$TypeValue]$Value|)
(declare-fun $tv0@@7 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 31424) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 23298) (- 0 32643)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 23298) (- 0 32692)) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64)))))) (=> (= (ControlFlow 0 23298) (- 0 32741)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$ret0@2)) $TestMarketCapWithSchemas_T_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2))))))))))))))))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$ret0@1 $Error) (= inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$ret0@2 inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@1 true) (= (ControlFlow 0 23238) 23298))) anon0$2_correct@@2)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 23256) 23238)) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 23266) 23238) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 23250) 23266) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 23250) 23256) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 23230) 23238)) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 23246) 23238) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 23224) 23246) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 23224) 23230) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon16_correct  (=> (= inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@2|) (=> (and (= $abort_flag@2@@1 $abort_flag@1@@2) (= (ControlFlow 0 23212) 23298)) anon0$2_correct@@2))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 23210) 23212)) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon16_correct)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 23220) 23212) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon16_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@2  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@2| coin_ref@@2)) (and (=> (= (ControlFlow 0 23168) 23220) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 23168) 23210) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@2  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) 0 coin_ref@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|))) (= |inline$$WritebackToValue$0$vdst'@2@@2| |inline$$WritebackToValue$0$vdst'@1@@2|)) (and (=> (= (ControlFlow 0 23194) 23220) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 23194) 23210) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowLoc$0$dst@1@@2)) (and (=> (= (ControlFlow 0 23013) 23194) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 23013) 23168) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (and (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|)))) (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|))) (and (=> (= (ControlFlow 0 23069) 23194) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 23069) 23168) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) (and (=> (= (ControlFlow 0 22977) 23069) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 22977) 23013) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (and (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@2) (|p#$Mutation| inline$$BorrowField$1$dst@1@@2) inline$$AddU64$0$dst@2@@2)) (= (ControlFlow 0 22834) 22977)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$BorrowField$1$anon0_correct@@2  (=> (= inline$$BorrowField$1$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@2 (|size#$Path| inline$$BorrowField$1$p@1@@2)) (= inline$$BorrowField$1$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@2) inline$$BorrowField$1$size@1@@2 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$1$size@1@@2 1)))) (and (= inline$$BorrowField$1$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$1$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 22775) 22834))) inline$$WriteRef$0$anon0_correct@@2))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 22781) 22775)) inline$$BorrowField$1$anon0_correct@@2)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@1@@2 true) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@0@@2)) (and (=> (= (ControlFlow 0 22645) 23224) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 22645) 22781) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$Div$0$dst@2@@1)) $MAX_U64) (= (ControlFlow 0 22643) 22645)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$Div$0$dst@2@@1))) (= inline$$AddU64$0$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@2) (|i#$Integer| inline$$Div$0$dst@2@@1))))) (and (= $abort_flag@1@@2 $abort_flag@0@@2) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@1@@2))) (and (=> (= (ControlFlow 0 22587) 23224) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 22587) 22781) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 22557) (- 0 32220)) true) (and (=> (= (ControlFlow 0 22557) 22643) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 22557) 22587) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 22651) 22557)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$Div$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@2 true) (= inline$$Div$0$dst@2@@1 inline$$Div$0$dst@0@@1)) (and (=> (= (ControlFlow 0 22452) 23250) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 22452) 22651) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct@@1  (=> (and (= (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$t7@1) 0) (= (ControlFlow 0 22450) 22452)) inline$$Div$0$anon3_Then$1_correct@@1)))
(let ((inline$$Div$0$anon3_Else_correct@@1  (=> (and (and (not (= (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$t7@1) 0)) (= inline$$Div$0$dst@1@@1 ($Integer (div (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@2) (|i#$Integer| inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$t7@1))))) (and (= $abort_flag@0@@2 false) (= inline$$Div$0$dst@2@@1 inline$$Div$0$dst@1@@1))) (and (=> (= (ControlFlow 0 22400) 23250) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 22400) 22651) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 22376) (- 0 32143)) true) (and (=> (= (ControlFlow 0 22376) 22450) inline$$Div$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 22376) 22400) inline$$Div$0$anon3_Else_correct@@1)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon6$1_correct  (=> (and (= inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$$t7@1 ($Integer 2)) (= (ControlFlow 0 22458) 22376)) inline$$Div$0$Entry_correct@@1)))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 22275) 22458)) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon6$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 22237) 22275))) inline$$ReadRef$0$anon0_correct@@2))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 22083) 22237)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 23274) 22237) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@2  (=> (and ((_ is $Vector) check@@2) (= inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value))) (=> (and (and (and ((_ is $Integer) inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@2) (>= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@2) 0)) (<= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@2) $MAX_U64)) (= $TestMarketCapWithSchemas_sum_of_coins@0@@2 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@7 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@7)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value))))))) (and (=> (= (ControlFlow 0 22069) 23274) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 22069) 22083) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$BorrowLoc$0$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$0$dst@1@@2 ($Mutation ($Local 3) $EmptyPath coin_ref@@2)) (= (ControlFlow 0 21945) 22069)) inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@2)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 21827) 21945)) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 23282) 21945) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 21819) 23282) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 21819) 21827) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 23290) 23282) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 23290) 21827) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 21813) 23290) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 21813) 21819) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@2 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))
)) (= (ControlFlow 0 23296) 21813)) inline$$TestMarketCapWithSchemas_deposit_not_public_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> (and (and (and ((_ is $Vector) coin_ref@@2) (let ((va@@18 (|v#$Vector| coin_ref@@2)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin_ref@@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@2)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) (=> (and (and (and (and (and ((_ is $Vector) check@@2) (let ((va@@19 (|v#$Vector| check@@2)))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| check@@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@2)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (= (ControlFlow 0 21417) 23296)) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (and (forall (($tv0@@8 T@$TypeValue) ) ((_ is $Integer) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@8))) (= (ControlFlow 0 31424) 21417)) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin_ref@@3 () T@$Value)
(declare-fun check@@3 () T@$Value)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@3| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@3| () T@$Value)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@2@@2 () |T@[$TypeValue]$Value|)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@1@@2 () |T@[$TypeValue]$Value|)
(declare-fun $tv0@@9 () T@$TypeValue)
(declare-fun inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@2 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@3 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@3 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@3 () Int)
(declare-fun inline$$BorrowField$1$p@2@@3 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@3 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun inline$$Div$0$dst@2@@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@3 () T@$Value)
(declare-fun inline$$Div$0$dst@0@@2 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Div$0$dst@1@@2 () T@$Value)
(declare-fun inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun $TestMarketCapWithSchemas_sum_of_coins@0@@3 () |T@[$TypeValue]$Value|)
(declare-fun inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 32797) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 25724) (- 0 34115)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2@@2)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2@@2) (and (=> (= (ControlFlow 0 25724) (- 0 34164)) (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2)))))))) (|i#$Integer| ($Integer $MAX_U64)))))) (=> (= (ControlFlow 0 25724) (- 0 34213)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$ret0@2)) $TestMarketCapWithSchemas_T_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) (|i#$Integer| ($Integer 2))))))))))))))))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$ret0@1 $Error) (= inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$ret0@2 inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@2 true) (= (ControlFlow 0 25664) 25724))) anon0$2_correct@@3)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 25682) 25664)) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 25692) 25664) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 25676) 25692) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 25676) 25682) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 25656) 25664)) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 25672) 25664) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 25650) 25672) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 25650) 25656) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon16_correct  (=> (= inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@3|) (=> (and (= $abort_flag@2@@2 $abort_flag@1@@3) (= (ControlFlow 0 25638) 25724)) anon0$2_correct@@3))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 25636) 25638)) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon16_correct)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 25646) 25638) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon16_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@3  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@3| coin_ref@@3)) (and (=> (= (ControlFlow 0 25594) 25646) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 25594) 25636) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@3  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) 0 coin_ref@@3 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))) (= |inline$$WritebackToValue$0$vdst'@2@@3| |inline$$WritebackToValue$0$vdst'@1@@3|)) (and (=> (= (ControlFlow 0 25620) 25646) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 25620) 25636) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct@@2  (=> (= $TestMarketCapWithSchemas_sum_of_coins@2@@2 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1@@2 $tv0@@9 ($Integer (+ (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@1@@2 $tv0@@9)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@2)) $TestMarketCapWithSchemas_T_value)))))) (and (=> (= (ControlFlow 0 25497) 25620) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 25497) 25594) inline$$WritebackToValue$0$anon3_Else_correct@@3)))))
(let ((inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestMarketCapWithSchemas_T_$pack_ref$0$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (= (ControlFlow 0 25469) 25497)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| inline$$BorrowLoc$0$dst@1@@3) (= (ControlFlow 0 25350) 25469)) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 25406) 25469))) inline$$TestMarketCapWithSchemas_T_$pack_ref$0$Entry_correct@@2)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) (and (=> (= (ControlFlow 0 25314) 25406) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 25314) 25350) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (and (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@3) (|p#$Mutation| inline$$BorrowField$1$dst@1@@3) inline$$AddU64$0$dst@2@@3)) (= (ControlFlow 0 25171) 25314)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$BorrowField$1$anon0_correct@@3  (=> (= inline$$BorrowField$1$p@1@@3 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$1$size@1@@3 (|size#$Path| inline$$BorrowField$1$p@1@@3)) (= inline$$BorrowField$1$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@3) inline$$BorrowField$1$size@1@@3 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$1$size@1@@3 1)))) (and (= inline$$BorrowField$1$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$1$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 25112) 25171))) inline$$WriteRef$0$anon0_correct@@3))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 25118) 25112)) inline$$BorrowField$1$anon0_correct@@3)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@1@@3 true) (= inline$$AddU64$0$dst@2@@3 inline$$AddU64$0$dst@0@@3)) (and (=> (= (ControlFlow 0 24982) 25650) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 24982) 25118) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@3  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| inline$$Div$0$dst@2@@2)) $MAX_U64) (= (ControlFlow 0 24980) 24982)) inline$$AddU64$0$anon3_Then$1_correct@@3)))
(let ((inline$$AddU64$0$anon3_Else_correct@@3  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| inline$$Div$0$dst@2@@2))) (= inline$$AddU64$0$dst@1@@3 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1@@3) (|i#$Integer| inline$$Div$0$dst@2@@2))))) (and (= $abort_flag@1@@3 $abort_flag@0@@3) (= inline$$AddU64$0$dst@2@@3 inline$$AddU64$0$dst@1@@3))) (and (=> (= (ControlFlow 0 24924) 25650) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 24924) 25118) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 24894) (- 0 33652)) true) (and (=> (= (ControlFlow 0 24894) 24980) inline$$AddU64$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 24894) 24924) inline$$AddU64$0$anon3_Else_correct@@3)))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 24988) 24894)) inline$$AddU64$0$Entry_correct@@3)))
(let ((inline$$Div$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@3 true) (= inline$$Div$0$dst@2@@2 inline$$Div$0$dst@0@@2)) (and (=> (= (ControlFlow 0 24789) 25676) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 24789) 24988) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct@@2  (=> (and (= (|i#$Integer| inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$t7@1) 0) (= (ControlFlow 0 24787) 24789)) inline$$Div$0$anon3_Then$1_correct@@2)))
(let ((inline$$Div$0$anon3_Else_correct@@2  (=> (and (and (not (= (|i#$Integer| inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$t7@1) 0)) (= inline$$Div$0$dst@1@@2 ($Integer (div (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@3) (|i#$Integer| inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$t7@1))))) (and (= $abort_flag@0@@3 false) (= inline$$Div$0$dst@2@@2 inline$$Div$0$dst@1@@2))) (and (=> (= (ControlFlow 0 24737) 25676) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 24737) 24988) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Div$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 24713) (- 0 33575)) true) (and (=> (= (ControlFlow 0 24713) 24787) inline$$Div$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 24713) 24737) inline$$Div$0$anon3_Else_correct@@2)))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon6$1_correct  (=> (and (= inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$$t7@1 ($Integer 2)) (= (ControlFlow 0 24795) 24713)) inline$$Div$0$Entry_correct@@2)))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowField$0$dst@1@@3)) (= (ControlFlow 0 24612) 24795)) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon6$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $TestMarketCapWithSchemas_T_value) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $TestMarketCapWithSchemas_T_value))) (= (ControlFlow 0 24574) 24612))) inline$$ReadRef$0$anon0_correct@@3))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 24420) 24574)) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 25700) 24574) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@3  (=> (and ((_ is $Vector) check@@3) (= inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value))) (=> (and (and (and ((_ is $Integer) inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@3) (>= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@3) 0)) (<= (|i#$Integer| inline$$TestMarketCapWithSchemas_T_unpack$0$value@1@@3) $MAX_U64)) (= $TestMarketCapWithSchemas_sum_of_coins@1@@2 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0@@3 $tv0@@9 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins@0@@3 $tv0@@9)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value))))))) (and (=> (= (ControlFlow 0 24406) 25700) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 24406) 24420) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct@@2  (=> (and (= $TestMarketCapWithSchemas_sum_of_coins@0@@3 (|Store_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@9 ($Integer (- (|i#$Integer| (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@9)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@2)) $TestMarketCapWithSchemas_T_value)))))) (= (ControlFlow 0 24284) 24406)) inline$$TestMarketCapWithSchemas_T_unpack$0$anon0_correct@@3)))
(let ((inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct@@2  (=> (and (= inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$$before@0@@2 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (= (ControlFlow 0 24252) 24284)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$anon0_correct@@2)))
(let ((inline$$BorrowLoc$0$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$0$dst@1@@3 ($Mutation ($Local 3) $EmptyPath coin_ref@@3)) (= (ControlFlow 0 24185) 24252)) inline$$TestMarketCapWithSchemas_T_$unpack_ref$0$Entry_correct@@2)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 24067) 24185)) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 25708) 24185) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24059) 25708) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 24059) 24067) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 25716) 25708) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 25716) 24067) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24053) 25716) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 24053) 24059) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (forall (($inv_addr@@3 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@3)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@3))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@3))) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@3))) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@3))) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestMarketCapWithSchemas_T_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@3))
)) (= (ControlFlow 0 25722) 24053)) inline$$TestMarketCapWithSchemas_excepted_deposit_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and (and ((_ is $Vector) coin_ref@@3) (let ((va@@21 (|v#$Vector| coin_ref@@3)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin_ref@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin_ref@@3)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) check@@3) (let ((va@@22 (|v#$Vector| check@@3)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| check@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check@@3)) $TestMarketCapWithSchemas_T_value)) $MAX_U64))) true) (= (ControlFlow 0 23647) 25722)) anon0$1_correct@@3))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (and (forall (($tv0@@10 T@$TypeValue) ) ((_ is $Integer) (|Select_[$TypeValue]$Value| $TestMarketCapWithSchemas_sum_of_coins $tv0@@10))) (= (ControlFlow 0 32797) 23647)) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
