(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestVector_T_v () Int)
(declare-fun $TestVector_T_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $TestVector_T () T@$TypeName)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestVector_T_v 0))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($TestVector_T_type_value $tv0) ($StructType $TestVector_T ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($TestVector_T_type_value $tv0))
)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$TestVector_T_pack$0$$struct@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 99892) (let ((inline$$TestVector_none_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestVector_none_$def_verify$0$anon9_Then_correct true))
(let ((inline$$TestVector_T_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 37013) 37045) inline$$TestVector_none_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 37013) 37035) inline$$TestVector_none_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestVector_T_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 37019) 37045) inline$$TestVector_none_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 37019) 37035) inline$$TestVector_none_$def_verify$0$anon9_Else_correct))))
(let ((inline$$TestVector_T_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 37007) 37019) inline$$TestVector_T_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 37007) 37013) inline$$TestVector_T_pack$0$anon4_Else_correct)))))
(let ((inline$$TestVector_T_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 36999) 37045) inline$$TestVector_none_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 36999) 37035) inline$$TestVector_none_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestVector_T_pack$0$anon0_correct  (=> (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@8 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= inline$$TestVector_T_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Vector_empty$0$v@1) 1)))) (and (=> (= (ControlFlow 0 36991) 37007) inline$$TestVector_T_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 36991) 36999) inline$$TestVector_T_pack$0$anon3_Else_correct)))))
(let ((inline$$TestVector_none_$def_verify$0$anon7_Else_correct  (=> (and (not false) (= (ControlFlow 0 37025) 36991)) inline$$TestVector_T_pack$0$anon0_correct)))
(let ((inline$$TestVector_none_$def_verify$0$anon7_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 36846) 37049) inline$$TestVector_none_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 36846) 37025) inline$$TestVector_none_$def_verify$0$anon7_Else_correct)))))
(let ((inline$$TestVector_none_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 36852) 36846)) inline$$Vector_empty$0$anon0_correct)))
(let ((anon0_correct  (=> (= (ControlFlow 0 99892) 36852) inline$$TestVector_none_$def_verify$0$anon0_correct)))
anon0_correct)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@8 () Bool)
(declare-fun inline$$TestVector_option_type_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_option_type_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestVector_option_type_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestVector_option_type_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$TestVector_unwrap_or_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_unwrap_or_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_unwrap_or_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_flag@6 () Bool)
(declare-fun |inline$$TestVector_unwrap_or_$def$1$tmp#$2@1| () T@$Value)
(declare-fun inline$$TestVector_option_type_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Vector_is_empty$1$b@1 () T@$Value)
(declare-fun inline$$Vector_pop_back$1$e@2 () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun inline$$TestVector_T_unpack$1$v@1 () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_pop_back$1$v'@2| () T@$Value)
(declare-fun inline$$Vector_pop_back$1$e@0 () T@$Value)
(declare-fun |inline$$Vector_pop_back$1$v'@0| () T@$Value)
(declare-fun inline$$Vector_pop_back$1$len@1 () Int)
(declare-fun inline$$Vector_pop_back$1$e@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun |inline$$Vector_pop_back$1$v'@1| () T@$Value)
(declare-fun inline$$TestVector_some_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_unwrap_or_$direct_intra$1$$tv0@0 () T@$TypeValue)
(declare-fun inline$$TestVector_unwrap_or_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@3 () Bool)
(declare-fun |inline$$TestVector_unwrap_or_$def$0$tmp#$2@1| () T@$Value)
(declare-fun inline$$TestVector_option_type_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$b@1 () T@$Value)
(declare-fun inline$$Vector_pop_back$0$e@2 () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$TestVector_T_unpack$0$v@1 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_pop_back$0$v'@2| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$e@0 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@0| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$len@1 () Int)
(declare-fun inline$$Vector_pop_back$0$e@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@1| () T@$Value)
(declare-fun inline$$TestVector_none_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_unwrap_or_$direct_intra$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$TestVector_some_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestVector_T_pack$1$$struct@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$TestVector_option_type_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$TestVector_some_$direct_intra$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$TestVector_T_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1@@0 () T@$Value)
(declare-fun inline$$TestVector_none_$direct_intra$0$$tv0@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 100102) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 41657) (- 0 102379)) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_option_type_$def_verify$0$$ret0@2 ($Integer 0)))))) (=> (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_option_type_$def_verify$0$$ret0@2 ($Integer 0))))) (=> (= (ControlFlow 0 41657) (- 0 102395)) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_option_type_$def_verify$0$$ret1@2 ($Integer 42))))))))))
(let ((inline$$TestVector_option_type_$def_verify$0$Abort_correct  (=> (and (= inline$$TestVector_option_type_$def_verify$0$$ret0@1 $Error) (= inline$$TestVector_option_type_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@8 true) (= inline$$TestVector_option_type_$def_verify$0$$ret0@2 inline$$TestVector_option_type_$def_verify$0$$ret0@1)) (and (= inline$$TestVector_option_type_$def_verify$0$$ret1@2 inline$$TestVector_option_type_$def_verify$0$$ret1@1) (= (ControlFlow 0 41635) 41657))) anon0$2_correct))))
(let ((inline$$TestVector_option_type_$def_verify$0$anon16_Then_correct  (=> (and $abort_flag@7 (= (ControlFlow 0 41627) 41635)) inline$$TestVector_option_type_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon15_Then_correct  (=> (and $abort_flag@4 (= (ControlFlow 0 41639) 41635)) inline$$TestVector_option_type_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon14_Then_correct  (=> (and $abort_flag@1 (= (ControlFlow 0 41643) 41635)) inline$$TestVector_option_type_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon13_Then_correct  (=> (and $abort_flag@0 (= (ControlFlow 0 41647) 41635)) inline$$TestVector_option_type_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon12_correct  (=> (and (and (= $abort_flag@8 $abort_flag@7) (= inline$$TestVector_option_type_$def_verify$0$$ret0@2 inline$$TestVector_unwrap_or_$def$0$$ret0@2)) (and (= inline$$TestVector_option_type_$def_verify$0$$ret1@2 inline$$TestVector_unwrap_or_$def$1$$ret0@2) (= (ControlFlow 0 41607) 41657))) anon0$2_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 41605) 41607)) inline$$TestVector_option_type_$def_verify$0$anon12_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 41615) 41607) inline$$TestVector_option_type_$def_verify$0$anon12_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41595) 41615) inline$$TestVector_option_type_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 41595) 41605) inline$$TestVector_option_type_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestVector_option_type_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 41623) 41615) inline$$TestVector_option_type_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 41623) 41605) inline$$TestVector_option_type_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestVector_option_type_$def_verify$0$anon16_Else_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 41589) 41623) inline$$TestVector_option_type_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 41589) 41595) inline$$TestVector_option_type_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$Abort_correct  (=> (= inline$$TestVector_unwrap_or_$def$1$$ret0@1 $Error) (=> (and (= $abort_flag@7 true) (= inline$$TestVector_unwrap_or_$def$1$$ret0@2 inline$$TestVector_unwrap_or_$def$1$$ret0@1)) (and (=> (= (ControlFlow 0 41457) 41627) inline$$TestVector_option_type_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 41457) 41589) inline$$TestVector_option_type_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 41531) 41457)) inline$$TestVector_unwrap_or_$def$1$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon27_Then_correct  (=> (= (ControlFlow 0 41541) 41457) inline$$TestVector_unwrap_or_$def$1$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon26_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 41525) 41541) inline$$TestVector_unwrap_or_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 41525) 41531) inline$$TestVector_unwrap_or_$def$1$anon27_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 41449) 41457)) inline$$TestVector_unwrap_or_$def$1$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon31_Then_correct  (=> (= (ControlFlow 0 41465) 41457) inline$$TestVector_unwrap_or_$def$1$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon30_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 41443) 41465) inline$$TestVector_unwrap_or_$def$1$anon31_Then_correct) (=> (= (ControlFlow 0 41443) 41449) inline$$TestVector_unwrap_or_$def$1$anon31_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon22_correct  (=> (and (= $abort_flag@7 $abort_flag@6) (= inline$$TestVector_unwrap_or_$def$1$$ret0@2 |inline$$TestVector_unwrap_or_$def$1$tmp#$2@1|)) (and (=> (= (ControlFlow 0 41423) 41627) inline$$TestVector_option_type_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 41423) 41589) inline$$TestVector_option_type_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 41421) 41423)) inline$$TestVector_unwrap_or_$def$1$anon22_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon33_Then_correct  (=> (= (ControlFlow 0 41431) 41423) inline$$TestVector_unwrap_or_$def$1$anon22_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon14_correct  (=> (and (= $abort_flag@6 $abort_flag@4) (= |inline$$TestVector_unwrap_or_$def$1$tmp#$2@1| inline$$TestVector_option_type_$def_verify$0$$t5@1)) (and (=> (= (ControlFlow 0 41513) 41431) inline$$TestVector_unwrap_or_$def$1$anon33_Then_correct) (=> (= (ControlFlow 0 41513) 41421) inline$$TestVector_unwrap_or_$def$1$anon33_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 41511) 41513)) inline$$TestVector_unwrap_or_$def$1$anon14_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon29_Then_correct  (=> (= (ControlFlow 0 41521) 41513) inline$$TestVector_unwrap_or_$def$1$anon14_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon28_Then_correct  (=> (|b#$Boolean| inline$$Vector_is_empty$1$b@1) (and (=> (= (ControlFlow 0 41503) 41521) inline$$TestVector_unwrap_or_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 41503) 41511) inline$$TestVector_unwrap_or_$def$1$anon29_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon20_correct  (=> (and (= $abort_flag@6 $abort_flag@5) (= |inline$$TestVector_unwrap_or_$def$1$tmp#$2@1| inline$$Vector_pop_back$1$e@2)) (and (=> (= (ControlFlow 0 41411) 41431) inline$$TestVector_unwrap_or_$def$1$anon33_Then_correct) (=> (= (ControlFlow 0 41411) 41421) inline$$TestVector_unwrap_or_$def$1$anon33_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 41409) 41411)) inline$$TestVector_unwrap_or_$def$1$anon20_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon32_Then_correct  (=> (= (ControlFlow 0 41439) 41411) inline$$TestVector_unwrap_or_$def$1$anon20_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 3))) (and (=> (= (ControlFlow 0 41335) 41439) inline$$TestVector_unwrap_or_$def$1$anon32_Then_correct) (=> (= (ControlFlow 0 41335) 41409) inline$$TestVector_unwrap_or_$def$1$anon32_Else_correct)))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 3)) (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1|) 0 inline$$TestVector_T_unpack$1$v@1 (|v#$Mutation| |inline$$WriteRef$2$to'@1|)))) (and (=> (= (ControlFlow 0 41361) 41439) inline$$TestVector_unwrap_or_$def$1$anon32_Then_correct) (=> (= (ControlFlow 0 41361) 41409) inline$$TestVector_unwrap_or_$def$1$anon32_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|p#$Mutation| inline$$BorrowLoc$2$dst@1) |inline$$Vector_pop_back$1$v'@2|)) (and (=> (= (ControlFlow 0 41236) 41361) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 41236) 41335) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon30_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 41242) 41236)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$Vector_pop_back$1$anon3_Then$1_correct  (=> (= $abort_flag@5 true) (=> (and (= inline$$Vector_pop_back$1$e@2 inline$$Vector_pop_back$1$e@0) (= |inline$$Vector_pop_back$1$v'@2| |inline$$Vector_pop_back$1$v'@0|)) (and (=> (= (ControlFlow 0 41169) 41443) inline$$TestVector_unwrap_or_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 41169) 41242) inline$$TestVector_unwrap_or_$def$1$anon30_Else_correct))))))
(let ((inline$$Vector_pop_back$1$anon3_Then_correct  (=> (and (= inline$$Vector_pop_back$1$len@1 0) (= (ControlFlow 0 41167) 41169)) inline$$Vector_pop_back$1$anon3_Then$1_correct)))
(let ((inline$$Vector_pop_back$1$anon3_Else_correct  (=> (and (not (= inline$$Vector_pop_back$1$len@1 0)) (= inline$$Vector_pop_back$1$e@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) (- inline$$Vector_pop_back$1$len@1 1)))) (=> (and (and (= |inline$$Vector_pop_back$1$v'@1| ($Vector (let ((l@@9 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) 1)))
($ValueArray (|lambda#0| 0 l@@9 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Error) l@@9)))) (= $abort_flag@5 $abort_flag@4)) (and (= inline$$Vector_pop_back$1$e@2 inline$$Vector_pop_back$1$e@1) (= |inline$$Vector_pop_back$1$v'@2| |inline$$Vector_pop_back$1$v'@1|))) (and (=> (= (ControlFlow 0 41119) 41443) inline$$TestVector_unwrap_or_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 41119) 41242) inline$$TestVector_unwrap_or_$def$1$anon30_Else_correct))))))
(let ((inline$$Vector_pop_back$1$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1) (= inline$$Vector_pop_back$1$len@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)))) (and (=> (= (ControlFlow 0 41097) 41167) inline$$Vector_pop_back$1$anon3_Then_correct) (=> (= (ControlFlow 0 41097) 41119) inline$$Vector_pop_back$1$anon3_Else_correct)))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowLoc$2$dst@1)) (= (ControlFlow 0 40986) 41097)) inline$$Vector_pop_back$1$anon0_correct)))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@1 ($Mutation ($Local 3) $EmptyPath inline$$TestVector_T_unpack$1$v@1)) (= (ControlFlow 0 40948) 40986)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon28_Else_correct  (=> (and (not (|b#$Boolean| inline$$Vector_is_empty$1$b@1)) (= (ControlFlow 0 40954) 40948)) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon26_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 40892) 41503) inline$$TestVector_unwrap_or_$def$1$anon28_Then_correct) (=> (= (ControlFlow 0 40892) 40954) inline$$TestVector_unwrap_or_$def$1$anon28_Else_correct)))))
(let ((inline$$Vector_is_empty$1$anon0_correct  (=> (and ((_ is $Vector) inline$$TestVector_T_unpack$1$v@1) (= inline$$Vector_is_empty$1$b@1 ($Boolean (= (|l#$ValueArray| (|v#$Vector| inline$$TestVector_T_unpack$1$v@1)) 0)))) (and (=> (= (ControlFlow 0 40878) 41525) inline$$TestVector_unwrap_or_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 40878) 40892) inline$$TestVector_unwrap_or_$def$1$anon26_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 40819) 40878)) inline$$Vector_is_empty$1$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon25_Then_correct  (=> (= (ControlFlow 0 41549) 40878) inline$$Vector_is_empty$1$anon0_correct)))
(let ((inline$$TestVector_T_unpack$1$anon0_correct  (=> (and (and ((_ is $Vector) inline$$TestVector_some_$def$0$$ret0@2) (= inline$$TestVector_T_unpack$1$v@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_some_$def$0$$ret0@2)) $TestVector_T_v))) (and ((_ is $Vector) inline$$TestVector_T_unpack$1$v@1) (let ((va@@9 (|v#$Vector| inline$$TestVector_T_unpack$1$v@1)))
(let ((l@@10 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
))))))) (and (=> (= (ControlFlow 0 40805) 41549) inline$$TestVector_unwrap_or_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 40805) 40819) inline$$TestVector_unwrap_or_$def$1$anon25_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 40678) 40805)) inline$$TestVector_T_unpack$1$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon24_Then_correct  (=> (= (ControlFlow 0 41557) 40805) inline$$TestVector_T_unpack$1$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$1$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40670) 41557) inline$$TestVector_unwrap_or_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 40670) 40678) inline$$TestVector_unwrap_or_$def$1$anon24_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon23_Then_correct  (and (=> (= (ControlFlow 0 41565) 41557) inline$$TestVector_unwrap_or_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 41565) 40678) inline$$TestVector_unwrap_or_$def$1$anon24_Else_correct))))
(let ((inline$$TestVector_unwrap_or_$def$1$anon0_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 40664) 41565) inline$$TestVector_unwrap_or_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 40664) 40670) inline$$TestVector_unwrap_or_$def$1$anon23_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$direct_intra$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$TestVector_some_$def$0$$ret0@2) (let ((va@@10 (|v#$Vector| inline$$TestVector_some_$def$0$$ret0@2)))
(let ((l@@11 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestVector_some_$def$0$$ret0@2)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_some_$def$0$$ret0@2)) $TestVector_T_v)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_some_$def$0$$ret0@2)) $TestVector_T_v))))
(let ((l@@12 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
))))))) true) (= (ControlFlow 0 41571) 40664)) inline$$TestVector_unwrap_or_$def$1$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$direct_intra$1$Entry_correct  (=> (and (= inline$$TestVector_unwrap_or_$direct_intra$1$$tv0@0 $IntegerType) (= (ControlFlow 0 40263) 41571)) inline$$TestVector_unwrap_or_$direct_intra$1$anon0_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon15_Else_correct  (=> (not $abort_flag@4) (=> (and (= inline$$TestVector_option_type_$def_verify$0$$t5@1 ($Integer 0)) (= (ControlFlow 0 41579) 40263)) inline$$TestVector_unwrap_or_$direct_intra$1$Entry_correct))))
(let ((inline$$TestVector_unwrap_or_$def$0$Abort_correct  (=> (= inline$$TestVector_unwrap_or_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@4 true) (= inline$$TestVector_unwrap_or_$def$0$$ret0@2 inline$$TestVector_unwrap_or_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 40074) 41639) inline$$TestVector_option_type_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 40074) 41579) inline$$TestVector_option_type_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 40148) 40074)) inline$$TestVector_unwrap_or_$def$0$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 40158) 40074) inline$$TestVector_unwrap_or_$def$0$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon26_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 40142) 40158) inline$$TestVector_unwrap_or_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 40142) 40148) inline$$TestVector_unwrap_or_$def$0$anon27_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 40066) 40074)) inline$$TestVector_unwrap_or_$def$0$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon31_Then_correct  (=> (= (ControlFlow 0 40082) 40074) inline$$TestVector_unwrap_or_$def$0$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon30_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 40060) 40082) inline$$TestVector_unwrap_or_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 40060) 40066) inline$$TestVector_unwrap_or_$def$0$anon31_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon22_correct  (=> (and (= $abort_flag@4 $abort_flag@3) (= inline$$TestVector_unwrap_or_$def$0$$ret0@2 |inline$$TestVector_unwrap_or_$def$0$tmp#$2@1|)) (and (=> (= (ControlFlow 0 40040) 41639) inline$$TestVector_option_type_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 40040) 41579) inline$$TestVector_option_type_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 40038) 40040)) inline$$TestVector_unwrap_or_$def$0$anon22_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 40048) 40040) inline$$TestVector_unwrap_or_$def$0$anon22_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon14_correct  (=> (and (= $abort_flag@3 $abort_flag@1) (= |inline$$TestVector_unwrap_or_$def$0$tmp#$2@1| inline$$TestVector_option_type_$def_verify$0$$t3@1)) (and (=> (= (ControlFlow 0 40130) 40048) inline$$TestVector_unwrap_or_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 40130) 40038) inline$$TestVector_unwrap_or_$def$0$anon33_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 40128) 40130)) inline$$TestVector_unwrap_or_$def$0$anon14_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 40138) 40130) inline$$TestVector_unwrap_or_$def$0$anon14_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon28_Then_correct  (=> (|b#$Boolean| inline$$Vector_is_empty$0$b@1) (and (=> (= (ControlFlow 0 40120) 40138) inline$$TestVector_unwrap_or_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 40120) 40128) inline$$TestVector_unwrap_or_$def$0$anon29_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon20_correct  (=> (and (= $abort_flag@3 $abort_flag@2) (= |inline$$TestVector_unwrap_or_$def$0$tmp#$2@1| inline$$Vector_pop_back$0$e@2)) (and (=> (= (ControlFlow 0 40028) 40048) inline$$TestVector_unwrap_or_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 40028) 40038) inline$$TestVector_unwrap_or_$def$0$anon33_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 40026) 40028)) inline$$TestVector_unwrap_or_$def$0$anon20_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 40056) 40028) inline$$TestVector_unwrap_or_$def$0$anon20_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 3))) (and (=> (= (ControlFlow 0 39952) 40056) inline$$TestVector_unwrap_or_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 39952) 40026) inline$$TestVector_unwrap_or_$def$0$anon32_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 3)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 inline$$TestVector_T_unpack$0$v@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (and (=> (= (ControlFlow 0 39978) 40056) inline$$TestVector_unwrap_or_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 39978) 40026) inline$$TestVector_unwrap_or_$def$0$anon32_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) |inline$$Vector_pop_back$0$v'@2|)) (and (=> (= (ControlFlow 0 39853) 39978) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 39853) 39952) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon30_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 39859) 39853)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Vector_pop_back$0$anon3_Then$1_correct  (=> (= $abort_flag@2 true) (=> (and (= inline$$Vector_pop_back$0$e@2 inline$$Vector_pop_back$0$e@0) (= |inline$$Vector_pop_back$0$v'@2| |inline$$Vector_pop_back$0$v'@0|)) (and (=> (= (ControlFlow 0 39786) 40060) inline$$TestVector_unwrap_or_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 39786) 39859) inline$$TestVector_unwrap_or_$def$0$anon30_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon3_Then_correct  (=> (and (= inline$$Vector_pop_back$0$len@1 0) (= (ControlFlow 0 39784) 39786)) inline$$Vector_pop_back$0$anon3_Then$1_correct)))
(let ((inline$$Vector_pop_back$0$anon3_Else_correct  (=> (and (not (= inline$$Vector_pop_back$0$len@1 0)) (= inline$$Vector_pop_back$0$e@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) (- inline$$Vector_pop_back$0$len@1 1)))) (=> (and (and (= |inline$$Vector_pop_back$0$v'@1| ($Vector (let ((l@@13 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) 1)))
($ValueArray (|lambda#0| 0 l@@13 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Error) l@@13)))) (= $abort_flag@2 $abort_flag@1)) (and (= inline$$Vector_pop_back$0$e@2 inline$$Vector_pop_back$0$e@1) (= |inline$$Vector_pop_back$0$v'@2| |inline$$Vector_pop_back$0$v'@1|))) (and (=> (= (ControlFlow 0 39736) 40060) inline$$TestVector_unwrap_or_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 39736) 39859) inline$$TestVector_unwrap_or_$def$0$anon30_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1) (= inline$$Vector_pop_back$0$len@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)))) (and (=> (= (ControlFlow 0 39714) 39784) inline$$Vector_pop_back$0$anon3_Then_correct) (=> (= (ControlFlow 0 39714) 39736) inline$$Vector_pop_back$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 39603) 39714)) inline$$Vector_pop_back$0$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 3) $EmptyPath inline$$TestVector_T_unpack$0$v@1)) (= (ControlFlow 0 39565) 39603)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon28_Else_correct  (=> (and (not (|b#$Boolean| inline$$Vector_is_empty$0$b@1)) (= (ControlFlow 0 39571) 39565)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon26_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 39509) 40120) inline$$TestVector_unwrap_or_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 39509) 39571) inline$$TestVector_unwrap_or_$def$0$anon28_Else_correct)))))
(let ((inline$$Vector_is_empty$0$anon0_correct  (=> (and ((_ is $Vector) inline$$TestVector_T_unpack$0$v@1) (= inline$$Vector_is_empty$0$b@1 ($Boolean (= (|l#$ValueArray| (|v#$Vector| inline$$TestVector_T_unpack$0$v@1)) 0)))) (and (=> (= (ControlFlow 0 39495) 40142) inline$$TestVector_unwrap_or_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 39495) 39509) inline$$TestVector_unwrap_or_$def$0$anon26_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 39436) 39495)) inline$$Vector_is_empty$0$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 40166) 39495) inline$$Vector_is_empty$0$anon0_correct)))
(let ((inline$$TestVector_T_unpack$0$anon0_correct  (=> (and (and ((_ is $Vector) inline$$TestVector_none_$def$0$$ret0@2) (= inline$$TestVector_T_unpack$0$v@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_none_$def$0$$ret0@2)) $TestVector_T_v))) (and ((_ is $Vector) inline$$TestVector_T_unpack$0$v@1) (let ((va@@12 (|v#$Vector| inline$$TestVector_T_unpack$0$v@1)))
(let ((l@@14 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
))))))) (and (=> (= (ControlFlow 0 39422) 40166) inline$$TestVector_unwrap_or_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 39422) 39436) inline$$TestVector_unwrap_or_$def$0$anon25_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 39295) 39422)) inline$$TestVector_T_unpack$0$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 40174) 39422) inline$$TestVector_T_unpack$0$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$def$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 39287) 40174) inline$$TestVector_unwrap_or_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 39287) 39295) inline$$TestVector_unwrap_or_$def$0$anon24_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 40182) 40174) inline$$TestVector_unwrap_or_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 40182) 39295) inline$$TestVector_unwrap_or_$def$0$anon24_Else_correct))))
(let ((inline$$TestVector_unwrap_or_$def$0$anon0_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 39281) 40182) inline$$TestVector_unwrap_or_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 39281) 39287) inline$$TestVector_unwrap_or_$def$0$anon23_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$direct_intra$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$TestVector_none_$def$0$$ret0@2) (let ((va@@13 (|v#$Vector| inline$$TestVector_none_$def$0$$ret0@2)))
(let ((l@@15 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$TestVector_none_$def$0$$ret0@2)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_none_$def$0$$ret0@2)) $TestVector_T_v)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_none_$def$0$$ret0@2)) $TestVector_T_v))))
(let ((l@@16 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
))))))) true) (= (ControlFlow 0 40188) 39281)) inline$$TestVector_unwrap_or_$def$0$anon0_correct)))
(let ((inline$$TestVector_unwrap_or_$direct_intra$0$Entry_correct  (=> (and (= inline$$TestVector_unwrap_or_$direct_intra$0$$tv0@0 $IntegerType) (= (ControlFlow 0 38880) 40188)) inline$$TestVector_unwrap_or_$direct_intra$0$anon0_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@1) (=> (and (= inline$$TestVector_option_type_$def_verify$0$$t3@1 ($Integer 0)) (= (ControlFlow 0 40196) 38880)) inline$$TestVector_unwrap_or_$direct_intra$0$Entry_correct))))
(let ((inline$$TestVector_some_$def$0$Abort_correct  (=> (= inline$$TestVector_some_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@1 true) (= inline$$TestVector_some_$def$0$$ret0@2 inline$$TestVector_some_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 38763) 41643) inline$$TestVector_option_type_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 38763) 40196) inline$$TestVector_option_type_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestVector_some_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 38781) 38763)) inline$$TestVector_some_$def$0$Abort_correct)))
(let ((inline$$TestVector_some_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 38791) 38763) inline$$TestVector_some_$def$0$Abort_correct)))
(let ((inline$$TestVector_some_$def$0$anon14_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 38775) 38791) inline$$TestVector_some_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 38775) 38781) inline$$TestVector_some_$def$0$anon15_Else_correct)))))
(let ((inline$$TestVector_some_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 38755) 38763)) inline$$TestVector_some_$def$0$Abort_correct)))
(let ((inline$$TestVector_some_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 38771) 38763) inline$$TestVector_some_$def$0$Abort_correct)))
(let ((inline$$TestVector_some_$def$0$anon16_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 38749) 38771) inline$$TestVector_some_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 38749) 38755) inline$$TestVector_some_$def$0$anon17_Else_correct)))))
(let ((inline$$TestVector_some_$def$0$anon12_correct  (=> (and (= $abort_flag@1 $abort_flag@0) (= inline$$TestVector_some_$def$0$$ret0@2 inline$$TestVector_T_pack$1$$struct@1)) (and (=> (= (ControlFlow 0 38737) 41643) inline$$TestVector_option_type_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 38737) 40196) inline$$TestVector_option_type_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestVector_some_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 38735) 38737)) inline$$TestVector_some_$def$0$anon12_correct)))
(let ((inline$$TestVector_some_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 38745) 38737) inline$$TestVector_some_$def$0$anon12_correct)))
(let ((inline$$TestVector_T_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 38713) 38745) inline$$TestVector_some_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 38713) 38735) inline$$TestVector_some_$def$0$anon18_Else_correct)))))
(let ((inline$$TestVector_T_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 38719) 38745) inline$$TestVector_some_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 38719) 38735) inline$$TestVector_some_$def$0$anon18_Else_correct))))
(let ((inline$$TestVector_T_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 38707) 38719) inline$$TestVector_T_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 38707) 38713) inline$$TestVector_T_pack$1$anon4_Else_correct)))))
(let ((inline$$TestVector_T_pack$1$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 38699) 38745) inline$$TestVector_some_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 38699) 38735) inline$$TestVector_some_$def$0$anon18_Else_correct)))))
(let ((inline$$TestVector_T_pack$1$anon0_correct  (=> (and (and ((_ is $Vector) |inline$$WritebackToValue$0$vdst'@2|) (let ((va@@15 (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)))
(let ((l@@17 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= inline$$TestVector_T_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 |inline$$WritebackToValue$0$vdst'@2|) 1)))) (and (=> (= (ControlFlow 0 38691) 38707) inline$$TestVector_T_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 38691) 38699) inline$$TestVector_T_pack$1$anon3_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| inline$$Vector_empty$1$v@1) (= (ControlFlow 0 38526) 38691)) inline$$TestVector_T_pack$1$anon0_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 inline$$Vector_empty$1$v@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 38552) 38691))) inline$$TestVector_T_pack$1$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (and (=> (= (ControlFlow 0 38427) 38552) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 38427) 38526) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$TestVector_some_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 38433) 38427)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) len@@0 inline$$TestVector_option_type_$def_verify$0$$t2@1) (+ len@@0 1)))))) (and (=> (= (ControlFlow 0 38362) 38749) inline$$TestVector_some_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 38362) 38433) inline$$TestVector_some_$def$0$anon16_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 38299) 38362)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1)) (= (ControlFlow 0 38261) 38299)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$TestVector_some_$def$0$anon14_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 38267) 38261)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Vector_empty$1$anon0_correct  (=> (= inline$$Vector_empty$1$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 38199) 38775) inline$$TestVector_some_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 38199) 38267) inline$$TestVector_some_$def$0$anon14_Else_correct)))))
(let ((inline$$TestVector_some_$def$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 38136) 38199)) inline$$Vector_empty$1$anon0_correct)))
(let ((inline$$TestVector_some_$def$0$anon13_Then_correct  (=> (= (ControlFlow 0 38799) 38199) inline$$Vector_empty$1$anon0_correct)))
(let ((inline$$TestVector_some_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 38130) 38799) inline$$TestVector_some_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 38130) 38136) inline$$TestVector_some_$def$0$anon13_Else_correct)))))
(let ((inline$$TestVector_some_$direct_intra$0$Entry_correct  (=> (and (= inline$$TestVector_some_$direct_intra$0$$tv0@0 $IntegerType) (= (ControlFlow 0 37880) 38130)) inline$$TestVector_some_$def$0$anon0_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0) (=> (and (= inline$$TestVector_option_type_$def_verify$0$$t2@1 ($Integer 42)) (= (ControlFlow 0 38813) 37880)) inline$$TestVector_some_$direct_intra$0$Entry_correct))))
(let ((inline$$TestVector_none_$def$0$anon6_correct  (=> (and (= $abort_flag@0 false) (= inline$$TestVector_none_$def$0$$ret0@2 inline$$TestVector_T_pack$0$$struct@1@@0)) (and (=> (= (ControlFlow 0 37786) 41647) inline$$TestVector_option_type_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 37786) 38813) inline$$TestVector_option_type_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestVector_none_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 37784) 37786)) inline$$TestVector_none_$def$0$anon6_correct)))
(let ((inline$$TestVector_none_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 37794) 37786) inline$$TestVector_none_$def$0$anon6_correct)))
(let ((inline$$TestVector_T_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 37762) 37794) inline$$TestVector_none_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 37762) 37784) inline$$TestVector_none_$def$0$anon9_Else_correct)))))
(let ((inline$$TestVector_T_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 37768) 37794) inline$$TestVector_none_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 37768) 37784) inline$$TestVector_none_$def$0$anon9_Else_correct))))
(let ((inline$$TestVector_T_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 37756) 37768) inline$$TestVector_T_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 37756) 37762) inline$$TestVector_T_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestVector_T_pack$0$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 37748) 37794) inline$$TestVector_none_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 37748) 37784) inline$$TestVector_none_$def$0$anon9_Else_correct)))))
(let ((inline$$TestVector_T_pack$0$anon0_correct@@0  (=> (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1@@0) (let ((va@@16 (|v#$Vector| inline$$Vector_empty$0$v@1@@0)))
(let ((l@@18 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= inline$$TestVector_T_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Vector_empty$0$v@1@@0) 1)))) (and (=> (= (ControlFlow 0 37740) 37756) inline$$TestVector_T_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 37740) 37748) inline$$TestVector_T_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_none_$def$0$anon7_Else_correct  (=> (and (not false) (= (ControlFlow 0 37774) 37740)) inline$$TestVector_T_pack$0$anon0_correct@@0)))
(let ((inline$$TestVector_none_$def$0$anon7_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@0  (=> (= inline$$Vector_empty$0$v@1@@0 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 37595) 37798) inline$$TestVector_none_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 37595) 37774) inline$$TestVector_none_$def$0$anon7_Else_correct)))))
(let ((inline$$TestVector_none_$def$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 37601) 37595)) inline$$Vector_empty$0$anon0_correct@@0)))
(let ((inline$$TestVector_none_$direct_intra$0$Entry_correct  (=> (and (= inline$$TestVector_none_$direct_intra$0$$tv0@0 $IntegerType) (= (ControlFlow 0 37425) 37601)) inline$$TestVector_none_$def$0$anon0_correct)))
(let ((inline$$TestVector_option_type_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 37832) 37425)) inline$$TestVector_none_$direct_intra$0$Entry_correct)))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 100102) 37832) inline$$TestVector_option_type_$def_verify$0$anon0_correct)))
anon0_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun inline$$TestVector_T_pack$0$$struct@1@@1 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun e () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 102418) (let ((inline$$TestVector_some_$def_verify$0$anon18_Else_correct true))
(let ((inline$$TestVector_some_$def_verify$0$anon18_Then_correct true))
(let ((inline$$TestVector_T_pack$0$anon4_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 43158) 43190) inline$$TestVector_some_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 43158) 43180) inline$$TestVector_some_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestVector_T_pack$0$anon4_Then_correct@@1  (and (=> (= (ControlFlow 0 43164) 43190) inline$$TestVector_some_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 43164) 43180) inline$$TestVector_some_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestVector_T_pack$0$anon3_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 43152) 43164) inline$$TestVector_T_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 43152) 43158) inline$$TestVector_T_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$TestVector_T_pack$0$anon3_Else_correct@@1  (=> (>= 0 0) (and (=> (= (ControlFlow 0 43144) 43190) inline$$TestVector_some_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 43144) 43180) inline$$TestVector_some_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestVector_T_pack$0$anon0_correct@@1  (=> (and (and ((_ is $Vector) |inline$$WritebackToValue$0$vdst'@2@@0|) (let ((va@@17 (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@0|)))
(let ((l@@19 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= inline$$TestVector_T_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 |inline$$WritebackToValue$0$vdst'@2@@0|) 1)))) (and (=> (= (ControlFlow 0 43136) 43152) inline$$TestVector_T_pack$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 43136) 43144) inline$$TestVector_T_pack$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$Vector_empty$0$v@1@@1) (= (ControlFlow 0 42971) 43136)) inline$$TestVector_T_pack$0$anon0_correct@@1))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 inline$$Vector_empty$0$v@1@@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|) (= (ControlFlow 0 42997) 43136))) inline$$TestVector_T_pack$0$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0) |inline$$Vector_push_back$0$v'@1@@0|)) (and (=> (= (ControlFlow 0 42872) 42997) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 42872) 42971) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_some_$def_verify$0$anon16_Else_correct  (=> (and (not false) (= (ControlFlow 0 42878) 42872)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$TestVector_some_$def_verify$0$anon16_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (= |inline$$Vector_push_back$0$v'@1@@0| ($Vector (let ((len@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) len@@1 e) (+ len@@1 1)))))) (and (=> (= (ControlFlow 0 42807) 43194) inline$$TestVector_some_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 42807) 42878) inline$$TestVector_some_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 42744) 42807)) inline$$Vector_push_back$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$0$v@1@@1)) (= (ControlFlow 0 42706) 42744)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$TestVector_some_$def_verify$0$anon14_Else_correct  (=> (and (not false) (= (ControlFlow 0 42712) 42706)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestVector_some_$def_verify$0$anon14_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@1  (=> (= inline$$Vector_empty$0$v@1@@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 42644) 43220) inline$$TestVector_some_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 42644) 42712) inline$$TestVector_some_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestVector_some_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 42581) 42644)) inline$$Vector_empty$0$anon0_correct@@1)))
(let ((inline$$TestVector_some_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 43244) 42644) inline$$Vector_empty$0$anon0_correct@@1)))
(let ((inline$$TestVector_some_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 42575) 43244) inline$$TestVector_some_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 42575) 42581) inline$$TestVector_some_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@1  (=> (= (ControlFlow 0 102418) 42575) inline$$TestVector_some_$def_verify$0$anon0_correct)))
anon0_correct@@1)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$TestVector_test_borrow1_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_borrow1_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1 () T@$Value)
(declare-fun inline$$TestVector_test_borrow1_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$TestVector_test_borrow1_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 102867) (let ((anon0$2_correct@@0  (=> (= (ControlFlow 0 44403) (- 0 103422)) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_borrow1_$def_verify$0$$ret0@2 ($Integer 7))))))))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestVector_test_borrow1_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@0 true)) (and (= inline$$TestVector_test_borrow1_$def_verify$0$$ret0@2 inline$$TestVector_test_borrow1_$def_verify$0$$ret0@1) (= (ControlFlow 0 44347) 44403))) anon0$2_correct@@0)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 44339) 44347)) inline$$TestVector_test_borrow1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 44355) 44347) inline$$TestVector_test_borrow1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 44333) 44355) inline$$TestVector_test_borrow1_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 44333) 44339) inline$$TestVector_test_borrow1_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon14_correct  (=> (= $abort_flag@1@@0 $abort_flag@0@@0) (=> (and (= inline$$TestVector_test_borrow1_$def_verify$0$$ret0@2 inline$$Vector_borrow$0$dst@2) (= (ControlFlow 0 44321) 44403)) anon0$2_correct@@0))))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 44319) 44321)) inline$$TestVector_test_borrow1_$def_verify$0$anon14_correct)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 44329) 44321) inline$$TestVector_test_borrow1_$def_verify$0$anon14_correct)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 44313) 44329) inline$$TestVector_test_borrow1_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 44313) 44319) inline$$TestVector_test_borrow1_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@0 true) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@0)) (and (=> (= (ControlFlow 0 44297) 44333) inline$$TestVector_test_borrow1_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 44297) 44313) inline$$TestVector_test_borrow1_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@1|)))) (= (ControlFlow 0 44295) 44297)) inline$$Vector_borrow$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@1|))))) (= inline$$Vector_borrow$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@1|)) inline$$Vector_borrow$0$i_ind@1))) (and (= $abort_flag@0@@0 false) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@1))) (and (=> (= (ControlFlow 0 44237) 44333) inline$$TestVector_test_borrow1_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 44237) 44313) inline$$TestVector_test_borrow1_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct  (=> ((_ is $Vector) |inline$$WritebackToValue$0$vdst'@2@@1|) (=> (and ((_ is $Integer) inline$$TestVector_test_borrow1_$def_verify$0$$t4@1) (= inline$$Vector_borrow$0$i_ind@1 (|i#$Integer| inline$$TestVector_test_borrow1_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 44211) 44295) inline$$Vector_borrow$0$anon3_Then_correct) (=> (= (ControlFlow 0 44211) 44237) inline$$Vector_borrow$0$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$0$Entry_correct  (=> (and (= inline$$Vector_borrow$0$ta@0 $IntegerType) (= (ControlFlow 0 44197) 44211)) inline$$Vector_borrow$0$anon0_correct)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon17_Else$2_correct  (=> (and (= inline$$TestVector_test_borrow1_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 44303) 44197)) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@1| inline$$Vector_empty$0$v@1@@2) (= (ControlFlow 0 44051) 44303)) inline$$TestVector_test_borrow1_$def_verify$0$anon17_Else$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|) 0 inline$$Vector_empty$0$v@1@@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|) (= (ControlFlow 0 44077) 44303))) inline$$TestVector_test_borrow1_$def_verify$0$anon17_Else$2_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1) |inline$$Vector_push_back$0$v'@1@@1|)) (and (=> (= (ControlFlow 0 43952) 44077) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 43952) 44051) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon17_Else_correct  (=> (and (not false) (= (ControlFlow 0 43958) 43952)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon17_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@1) (= |inline$$Vector_push_back$0$v'@1@@1| ($Vector (let ((len@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) len@@2 inline$$TestVector_test_borrow1_$def_verify$0$$t2@1) (+ len@@2 1)))))) (and (=> (= (ControlFlow 0 43887) 44359) inline$$TestVector_test_borrow1_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 43887) 43958) inline$$TestVector_test_borrow1_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 $IntegerType) (= (ControlFlow 0 43875) 43887)) inline$$Vector_push_back$0$anon0_correct@@1)))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 43824) 43875)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon15_Else$1_correct  (=> (and (= inline$$TestVector_test_borrow1_$def_verify$0$$t2@1 ($Integer 7)) (= (ControlFlow 0 43830) 43824)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@2)) (= (ControlFlow 0 43782) 43830)) inline$$TestVector_test_borrow1_$def_verify$0$anon15_Else$1_correct)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon15_Else_correct  (=> (and (not false) (= (ControlFlow 0 43788) 43782)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon15_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@2  (=> (= inline$$Vector_empty$0$v@1@@2 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 43720) 44379) inline$$TestVector_test_borrow1_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 43720) 43788) inline$$TestVector_test_borrow1_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 43716) 43720)) inline$$Vector_empty$0$anon0_correct@@2)))
(let ((inline$$TestVector_test_borrow1_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 43726) 43716)) inline$$Vector_empty$0$Entry_correct)))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 102867) 43726) inline$$TestVector_test_borrow1_$def_verify$0$anon0_correct)))
anon0_correct@@2))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$TestVector_test_borrow2_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_borrow2_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@2@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1@@0 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@2| () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@0 () T@$Value)
(declare-fun inline$$TestVector_test_borrow2_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@2| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$TestVector_test_borrow2_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 103444) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 45541) (- 0 104001)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_borrow2_$def_verify$0$$ret0@2 ($Integer 7)))))))))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestVector_test_borrow2_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@1 true)) (and (= inline$$TestVector_test_borrow2_$def_verify$0$$ret0@2 inline$$TestVector_test_borrow2_$def_verify$0$$ret0@1) (= (ControlFlow 0 45485) 45541))) anon0$2_correct@@1)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 45477) 45485)) inline$$TestVector_test_borrow2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 45493) 45485) inline$$TestVector_test_borrow2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 45471) 45493) inline$$TestVector_test_borrow2_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 45471) 45477) inline$$TestVector_test_borrow2_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon14_correct  (=> (= $abort_flag@1@@1 $abort_flag@0@@1) (=> (and (= inline$$TestVector_test_borrow2_$def_verify$0$$ret0@2 inline$$Vector_borrow$0$dst@2@@0) (= (ControlFlow 0 45459) 45541)) anon0$2_correct@@1))))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 45457) 45459)) inline$$TestVector_test_borrow2_$def_verify$0$anon14_correct)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 45467) 45459) inline$$TestVector_test_borrow2_$def_verify$0$anon14_correct)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 45451) 45467) inline$$TestVector_test_borrow2_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 45451) 45457) inline$$TestVector_test_borrow2_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@1 true) (= inline$$Vector_borrow$0$dst@2@@0 inline$$Vector_borrow$0$dst@0@@0)) (and (=> (= (ControlFlow 0 45435) 45471) inline$$TestVector_test_borrow2_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 45435) 45451) inline$$TestVector_test_borrow2_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@0  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1@@0 0) (>= inline$$Vector_borrow$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@2|)))) (= (ControlFlow 0 45433) 45435)) inline$$Vector_borrow$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@0  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@1@@0 0) (>= inline$$Vector_borrow$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@2|))))) (= inline$$Vector_borrow$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@2|)) inline$$Vector_borrow$0$i_ind@1@@0))) (and (= $abort_flag@0@@1 false) (= inline$$Vector_borrow$0$dst@2@@0 inline$$Vector_borrow$0$dst@1@@0))) (and (=> (= (ControlFlow 0 45375) 45471) inline$$TestVector_test_borrow2_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 45375) 45451) inline$$TestVector_test_borrow2_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct@@0  (=> ((_ is $Vector) |inline$$WritebackToValue$0$vdst'@2@@2|) (=> (and ((_ is $Integer) inline$$TestVector_test_borrow2_$def_verify$0$$t4@1) (= inline$$Vector_borrow$0$i_ind@1@@0 (|i#$Integer| inline$$TestVector_test_borrow2_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 45349) 45433) inline$$Vector_borrow$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 45349) 45375) inline$$Vector_borrow$0$anon3_Else_correct@@0))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@0  (=> (and (= inline$$Vector_borrow$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 45335) 45349)) inline$$Vector_borrow$0$anon0_correct@@0)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon17_Else$2_correct  (=> (and (= inline$$TestVector_test_borrow2_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 45441) 45335)) inline$$Vector_borrow$0$Entry_correct@@0)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@2  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@2| inline$$Vector_empty$0$v@1@@3) (= (ControlFlow 0 45189) 45441)) inline$$TestVector_test_borrow2_$def_verify$0$anon17_Else$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@2  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|) 0 inline$$Vector_empty$0$v@1@@3 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@2| |inline$$WritebackToValue$0$vdst'@1@@2|) (= (ControlFlow 0 45215) 45441))) inline$$TestVector_test_borrow2_$def_verify$0$anon17_Else$2_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2) |inline$$Vector_push_back$0$v'@1@@2|)) (and (=> (= (ControlFlow 0 45090) 45215) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 45090) 45189) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon17_Else_correct  (=> (and (not false) (= (ControlFlow 0 45096) 45090)) inline$$WriteRef$0$anon0_correct@@2)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon17_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@2) (= |inline$$Vector_push_back$0$v'@1@@2| ($Vector (let ((len@@3 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) len@@3 inline$$TestVector_test_borrow2_$def_verify$0$$t2@1) (+ len@@3 1)))))) (and (=> (= (ControlFlow 0 45025) 45497) inline$$TestVector_test_borrow2_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 45025) 45096) inline$$TestVector_test_borrow2_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 45013) 45025)) inline$$Vector_push_back$0$anon0_correct@@2)))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (= (ControlFlow 0 44962) 45013)) inline$$Vector_push_back$0$Entry_correct@@0)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon15_Else$1_correct  (=> (and (= inline$$TestVector_test_borrow2_$def_verify$0$$t2@1 ($Integer 0)) (= (ControlFlow 0 44968) 44962)) inline$$ReadRef$0$anon0_correct@@2)))
(let ((inline$$BorrowLoc$0$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$0$dst@1@@2 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@3)) (= (ControlFlow 0 44920) 44968)) inline$$TestVector_test_borrow2_$def_verify$0$anon15_Else$1_correct)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon15_Else_correct  (=> (and (not false) (= (ControlFlow 0 44926) 44920)) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon15_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@3  (=> (= inline$$Vector_empty$0$v@1@@3 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 44858) 45517) inline$$TestVector_test_borrow2_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 44858) 44926) inline$$TestVector_test_borrow2_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@0  (=> (and (= inline$$Vector_empty$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 44854) 44858)) inline$$Vector_empty$0$anon0_correct@@3)))
(let ((inline$$TestVector_test_borrow2_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 44864) 44854)) inline$$Vector_empty$0$Entry_correct@@0)))
(let ((anon0_correct@@3  (=> (= (ControlFlow 0 103444) 44864) inline$$TestVector_test_borrow2_$def_verify$0$anon0_correct)))
anon0_correct@@3))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$TestVector_test_borrow3_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$Vector_borrow$0$i_ind@1@@1 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@3| () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@1 () T@$Value)
(declare-fun inline$$TestVector_test_borrow3_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0@@1 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@3| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@3| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun inline$$TestVector_test_borrow3_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@1 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@1 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 104025) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 46679) (- 0 104570)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@2)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@2) (=> (= (ControlFlow 0 46679) (- 0 104579)) (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$Abort_correct  (=> (= inline$$TestVector_test_borrow3_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@2 true) (= (ControlFlow 0 46623) 46679)) anon0$2_correct@@2))))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 46615) 46623)) inline$$TestVector_test_borrow3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 46631) 46623) inline$$TestVector_test_borrow3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 46609) 46631) inline$$TestVector_test_borrow3_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 46609) 46615) inline$$TestVector_test_borrow3_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon14_correct  (=> (and (= $abort_flag@1@@2 $abort_flag@0@@2) (= (ControlFlow 0 46597) 46679)) anon0$2_correct@@2)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 46595) 46597)) inline$$TestVector_test_borrow3_$def_verify$0$anon14_correct)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 46605) 46597) inline$$TestVector_test_borrow3_$def_verify$0$anon14_correct)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 46589) 46605) inline$$TestVector_test_borrow3_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 46589) 46595) inline$$TestVector_test_borrow3_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@0@@2 true) (and (=> (= (ControlFlow 0 46573) 46609) inline$$TestVector_test_borrow3_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 46573) 46589) inline$$TestVector_test_borrow3_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@1  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1@@1 0) (>= inline$$Vector_borrow$0$i_ind@1@@1 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@3|)))) (= (ControlFlow 0 46571) 46573)) inline$$Vector_borrow$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@1  (=> (not (or (< inline$$Vector_borrow$0$i_ind@1@@1 0) (>= inline$$Vector_borrow$0$i_ind@1@@1 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@3|))))) (=> (and (= inline$$Vector_borrow$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@3|)) inline$$Vector_borrow$0$i_ind@1@@1)) (= $abort_flag@0@@2 false)) (and (=> (= (ControlFlow 0 46513) 46609) inline$$TestVector_test_borrow3_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 46513) 46589) inline$$TestVector_test_borrow3_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon0_correct@@1  (=> ((_ is $Vector) |inline$$WritebackToValue$0$vdst'@2@@3|) (=> (and ((_ is $Integer) inline$$TestVector_test_borrow3_$def_verify$0$$t4@1) (= inline$$Vector_borrow$0$i_ind@1@@1 (|i#$Integer| inline$$TestVector_test_borrow3_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 46487) 46571) inline$$Vector_borrow$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 46487) 46513) inline$$Vector_borrow$0$anon3_Else_correct@@1))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@1  (=> (and (= inline$$Vector_borrow$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 46473) 46487)) inline$$Vector_borrow$0$anon0_correct@@1)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon17_Else$2_correct  (=> (and (= inline$$TestVector_test_borrow3_$def_verify$0$$t4@1 ($Integer 1)) (= (ControlFlow 0 46579) 46473)) inline$$Vector_borrow$0$Entry_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@3| inline$$Vector_empty$0$v@1@@4) (= (ControlFlow 0 46327) 46579)) inline$$TestVector_test_borrow3_$def_verify$0$anon17_Else$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|) 0 inline$$Vector_empty$0$v@1@@4 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@3| |inline$$WritebackToValue$0$vdst'@1@@3|) (= (ControlFlow 0 46353) 46579))) inline$$TestVector_test_borrow3_$def_verify$0$anon17_Else$2_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3) |inline$$Vector_push_back$0$v'@1@@3|)) (and (=> (= (ControlFlow 0 46228) 46353) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 46228) 46327) inline$$WritebackToValue$0$anon3_Else_correct@@3)))))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon17_Else_correct  (=> (and (not false) (= (ControlFlow 0 46234) 46228)) inline$$WriteRef$0$anon0_correct@@3)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon17_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@3) (= |inline$$Vector_push_back$0$v'@1@@3| ($Vector (let ((len@@4 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) len@@4 inline$$TestVector_test_borrow3_$def_verify$0$$t2@1) (+ len@@4 1)))))) (and (=> (= (ControlFlow 0 46163) 46635) inline$$TestVector_test_borrow3_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 46163) 46234) inline$$TestVector_test_borrow3_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@1  (=> (and (= inline$$Vector_push_back$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 46151) 46163)) inline$$Vector_push_back$0$anon0_correct@@3)))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (= (ControlFlow 0 46100) 46151)) inline$$Vector_push_back$0$Entry_correct@@1)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon15_Else$1_correct  (=> (and (= inline$$TestVector_test_borrow3_$def_verify$0$$t2@1 ($Integer 7)) (= (ControlFlow 0 46106) 46100)) inline$$ReadRef$0$anon0_correct@@3)))
(let ((inline$$BorrowLoc$0$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$0$dst@1@@3 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@4)) (= (ControlFlow 0 46058) 46106)) inline$$TestVector_test_borrow3_$def_verify$0$anon15_Else$1_correct)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon15_Else_correct  (=> (and (not false) (= (ControlFlow 0 46064) 46058)) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon15_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@4  (=> (= inline$$Vector_empty$0$v@1@@4 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 45996) 46655) inline$$TestVector_test_borrow3_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 45996) 46064) inline$$TestVector_test_borrow3_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@1  (=> (and (= inline$$Vector_empty$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 45992) 45996)) inline$$Vector_empty$0$anon0_correct@@4)))
(let ((inline$$TestVector_test_borrow3_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 46002) 45992)) inline$$Vector_empty$0$Entry_correct@@1)))
(let ((anon0_correct@@4  (=> (= (ControlFlow 0 104025) 46002) inline$$TestVector_test_borrow3_$def_verify$0$anon0_correct)))
anon0_correct@@4))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun v@@14 () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun inline$$TestVector_test_borrow_mut_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestVector_test_borrow_mut_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@4| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun |inline$$Splice1$0$dst'@1| () T@$Mutation)
(declare-fun inline$$TestVector_test_borrow_mut_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@4| () T@$Mutation)
(declare-fun |inline$$Vector_borrow_mut$0$v'| () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@0 () T@$Mutation)
(declare-fun inline$$Vector_borrow_mut$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@1 () T@$Mutation)
(declare-fun inline$$TestVector_test_borrow_mut_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_borrow$0$i_ind@1@@2 () Int)
(declare-fun inline$$ReadRef$0$v@1@@4 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@2 () T@$Value)
(declare-fun inline$$TestVector_test_borrow_mut_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0@@2 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 104596) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 48662) (- 0 105635)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer 0)))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer 0)))) $abort_flag@2@@0) (=> (= (ControlFlow 0 48662) (- 0 105652)) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer 0))))))))))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestVector_test_borrow_mut_$def_verify$0$$ret0@1 $Error) (= inline$$TestVector_test_borrow_mut_$def_verify$0$$ret1@1 $Error)) (and (= $abort_flag@2@@0 true) (= (ControlFlow 0 48608) 48662))) anon0$2_correct@@3)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 48634) 48608)) inline$$TestVector_test_borrow_mut_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 48644) 48608) inline$$TestVector_test_borrow_mut_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 48628) 48644) inline$$TestVector_test_borrow_mut_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 48628) 48634) inline$$TestVector_test_borrow_mut_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 48598) 48608)) inline$$TestVector_test_borrow_mut_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 48616) 48608) inline$$TestVector_test_borrow_mut_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 48592) 48616) inline$$TestVector_test_borrow_mut_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 48592) 48598) inline$$TestVector_test_borrow_mut_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon16_correct  (=> (and (= $abort_flag@2@@0 $abort_flag@1@@3) (= (ControlFlow 0 48572) 48662)) anon0$2_correct@@3)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 48570) 48572)) inline$$TestVector_test_borrow_mut_$def_verify$0$anon16_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 48580) 48572) inline$$TestVector_test_borrow_mut_$def_verify$0$anon16_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 48560) 48580) inline$$TestVector_test_borrow_mut_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 48560) 48570) inline$$TestVector_test_borrow_mut_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 48588) 48580) inline$$TestVector_test_borrow_mut_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 48588) 48570) inline$$TestVector_test_borrow_mut_$def_verify$0$anon24_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@4  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 4))) (and (=> (= (ControlFlow 0 48518) 48588) inline$$TestVector_test_borrow_mut_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 48518) 48560) inline$$TestVector_test_borrow_mut_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@4  (=> (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 4)) (= |inline$$WritebackToValue$0$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 v@@14 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (=> (= (ControlFlow 0 48544) 48588) inline$$TestVector_test_borrow_mut_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 48544) 48560) inline$$TestVector_test_borrow_mut_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1@@4)) (and (=> (= (ControlFlow 0 48363) 48544) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 48363) 48518) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 48419) 48544) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 48419) 48518) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4))) (and (=> (= (ControlFlow 0 48327) 48419) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 48327) 48363) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (and (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1|) (|p#$Mutation| |inline$$Splice1$0$dst'@1|) inline$$TestVector_test_borrow_mut_$def_verify$0$$t9@1)) (= (ControlFlow 0 48184) 48327)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$Splice1$0$anon0_correct  (=> (and (= |inline$$Splice1$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) ($ConcatPath_stratified (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|p#$Mutation| inline$$Vector_borrow_mut$0$dst@2)) (|v#$Mutation| inline$$Vector_borrow_mut$0$dst@2))) (= (ControlFlow 0 48125) 48184)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@4  (=> (and (= |inline$$WriteRef$0$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4) |inline$$Vector_borrow_mut$0$v'|)) (= (ControlFlow 0 48044) 48125)) inline$$Splice1$0$anon0_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 48050) 48044)) inline$$WriteRef$0$anon0_correct@@4)))
(let ((inline$$Vector_borrow_mut$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@3 true) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@0)) (and (=> (= (ControlFlow 0 47977) 48592) inline$$TestVector_test_borrow_mut_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 47977) 48050) inline$$TestVector_test_borrow_mut_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)))) (= (ControlFlow 0 47975) 47977)) inline$$Vector_borrow_mut$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow_mut$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0))))) (= inline$$Vector_borrow_mut$0$dst@1 ($Mutation ($Local 0) ($Path (|Store_[$int]$int| (|p#$Path| $EmptyPath) 0 inline$$Vector_borrow_mut$0$i_ind@1) 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) inline$$Vector_borrow_mut$0$i_ind@1)))) (and (= $abort_flag@1@@3 $abort_flag@0@@3) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@1))) (and (=> (= (ControlFlow 0 47917) 48592) inline$$TestVector_test_borrow_mut_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 47917) 48050) inline$$TestVector_test_borrow_mut_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$anon0_correct  (=> (and (= inline$$Vector_borrow_mut$0$i_ind@1 (|i#$Integer| inline$$TestVector_test_borrow_mut_$def_verify$0$$t11@1)) ((_ is $Vector) inline$$ReadRef$1$v@1@@0)) (and (=> (= (ControlFlow 0 47869) 47975) inline$$Vector_borrow_mut$0$anon3_Then_correct) (=> (= (ControlFlow 0 47869) 47917) inline$$Vector_borrow_mut$0$anon3_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$Entry_correct  (=> (= inline$$Vector_borrow_mut$0$ta@0 $IntegerType) (and (=> (= (ControlFlow 0 47859) (- 0 105178)) true) (=> (= (ControlFlow 0 47859) 47869) inline$$Vector_borrow_mut$0$anon0_correct)))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (= (ControlFlow 0 47716) 47859)) inline$$Vector_borrow_mut$0$Entry_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon8$1_correct  (=> (and (= inline$$TestVector_test_borrow_mut_$def_verify$0$$t11@1 ($Integer 0)) (= (ControlFlow 0 47722) 47716)) inline$$ReadRef$1$anon0_correct@@0)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon8_correct  (=> (and (= inline$$TestVector_test_borrow_mut_$def_verify$0$$t9@1 ($Integer 7)) (= (ControlFlow 0 47680) 47722)) inline$$TestVector_test_borrow_mut_$def_verify$0$anon8$1_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 47642) 47680)) inline$$TestVector_test_borrow_mut_$def_verify$0$anon8_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 48624) 47680) inline$$TestVector_test_borrow_mut_$def_verify$0$anon8_correct)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@3) (and (=> (= (ControlFlow 0 47634) 48624) inline$$TestVector_test_borrow_mut_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 47634) 47642) inline$$TestVector_test_borrow_mut_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@0@@3 true) (and (=> (= (ControlFlow 0 47588) 48628) inline$$TestVector_test_borrow_mut_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 47588) 47634) inline$$TestVector_test_borrow_mut_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@2  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1@@2 0) (>= inline$$Vector_borrow$0$i_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)))) (= (ControlFlow 0 47586) 47588)) inline$$Vector_borrow$0$anon3_Then$1_correct@@2)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@2  (=> (not (or (< inline$$Vector_borrow$0$i_ind@1@@2 0) (>= inline$$Vector_borrow$0$i_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4))))) (=> (and (= inline$$Vector_borrow$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) inline$$Vector_borrow$0$i_ind@1@@2)) (= $abort_flag@0@@3 false)) (and (=> (= (ControlFlow 0 47528) 48628) inline$$TestVector_test_borrow_mut_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 47528) 47634) inline$$TestVector_test_borrow_mut_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon0_correct@@2  (=> ((_ is $Vector) inline$$ReadRef$0$v@1@@4) (=> (and ((_ is $Integer) inline$$TestVector_test_borrow_mut_$def_verify$0$$t7@1) (= inline$$Vector_borrow$0$i_ind@1@@2 (|i#$Integer| inline$$TestVector_test_borrow_mut_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 47502) 47586) inline$$Vector_borrow$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 47502) 47528) inline$$Vector_borrow$0$anon3_Else_correct@@2))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@2  (=> (and (= inline$$Vector_borrow$0$ta@0@@2 $IntegerType) (= (ControlFlow 0 47488) 47502)) inline$$Vector_borrow$0$anon0_correct@@2)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon2$3_correct  (=> (and (= inline$$TestVector_test_borrow_mut_$def_verify$0$$t7@1 ($Integer 0)) (= (ControlFlow 0 47594) 47488)) inline$$Vector_borrow$0$Entry_correct@@2)))
(let ((inline$$ReadRef$0$anon0_correct@@4  (=> (and (= inline$$ReadRef$0$v@1@@4 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (= (ControlFlow 0 47368) 47594)) inline$$TestVector_test_borrow_mut_$def_verify$0$anon2$3_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$0$dst@1@@4 ($Mutation ($Local 4) $EmptyPath v@@14)) (= (ControlFlow 0 47330) 47368)) inline$$ReadRef$0$anon0_correct@@4)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 47246) 47330)) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 48652) 47330) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$TestVector_test_borrow_mut_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 47240) 48652) inline$$TestVector_test_borrow_mut_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 47240) 47246) inline$$TestVector_test_borrow_mut_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and (and ((_ is $Vector) v@@14) (let ((va@@18 (|v#$Vector| v@@14)))
(let ((l@@20 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| v@@14)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $$0)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $$0))
))) (= (ControlFlow 0 46878) 47240)) inline$$TestVector_test_borrow_mut_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 104596) 46878) anon0_correct@@5)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$ret2@2 () T@$Value)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@2| () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1 () T@$Value)
(declare-fun inline$$Vector_contains$1$res@1 () T@$Value)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$Vector_contains$1$ta@0 () T@$TypeValue)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$3$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$3$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$Vector_push_back$3$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$2$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@4| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@1 () T@$Value)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@5| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@5 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@5| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@5 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@4| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@5 () T@$Value)
(declare-fun inline$$TestVector_test_contains_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@2 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@2 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 105675) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 51398) (- 0 107377)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4) (and (=> (= (ControlFlow 0 51398) (- 0 107386)) (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 51398) (- 0 107395)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_contains_$def_verify$0$$ret1@2 ($Boolean true)))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_contains_$def_verify$0$$ret1@2 ($Boolean true))))) (and (=> (= (ControlFlow 0 51398) (- 0 107411)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_contains_$def_verify$0$$ret2@2 ($Boolean false)))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_contains_$def_verify$0$$ret2@2 ($Boolean false))))) (and (=> (= (ControlFlow 0 51398) (- 0 107427)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2))) ($Integer 4)))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2))) ($Integer 4))))) (and (=> (= (ControlFlow 0 51398) (- 0 107445)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 0))) ($Integer 1)))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 0))) ($Integer 1))))) (and (=> (= (ControlFlow 0 51398) (- 0 107467)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 1))) ($Integer 2)))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 1))) ($Integer 2))))) (and (=> (= (ControlFlow 0 51398) (- 0 107489)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 2))) ($Integer 3)))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 2))) ($Integer 3))))) (and (=> (= (ControlFlow 0 51398) (- 0 107511)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 3))) ($Integer 5)))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_contains_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 3))) ($Integer 5))))) (and (=> (= (ControlFlow 0 51398) (- 0 107533)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (let (($range_1 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@19 ($Integer 1)))))))))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (let (($range_1 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@19 ($Integer 1))))))))))) (and (=> (= (ControlFlow 0 51398) (- 0 107576)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (let (($range_3 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_2 Int) )  (and (and (>= $i_2 0) (< $i_2 (|l#$ValueArray| (|v#$Vector| $range_3)))) (let ((x@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_3)) $i_2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@20 ($Integer 2)))))))))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (let (($range_3 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_2@@0 Int) )  (and (and (>= $i_2@@0 0) (< $i_2@@0 (|l#$ValueArray| (|v#$Vector| $range_3)))) (let ((x@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_3)) $i_2@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@20 ($Integer 2))))))))))) (and (=> (= (ControlFlow 0 51398) (- 0 107619)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (let (($range_5 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_4 Int) )  (and (and (>= $i_4 0) (< $i_4 (|l#$ValueArray| (|v#$Vector| $range_5)))) (let ((x@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_5)) $i_4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@21 ($Integer 3)))))))))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (let (($range_5 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_4@@0 Int) )  (and (and (>= $i_4@@0 0) (< $i_4@@0 (|l#$ValueArray| (|v#$Vector| $range_5)))) (let ((x@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_5)) $i_4@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@21 ($Integer 3))))))))))) (and (=> (= (ControlFlow 0 51398) (- 0 107662)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_7 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_6 Int) )  (and (and (>= $i_6 0) (< $i_6 (|l#$ValueArray| (|v#$Vector| $range_7)))) (let ((x@@22 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_7)) $i_6)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@22 ($Integer 4))))))))))))))) (=> (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_7 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_6@@0 Int) )  (and (and (>= $i_6@@0 0) (< $i_6@@0 (|l#$ValueArray| (|v#$Vector| $range_7)))) (let ((x@@22 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_7)) $i_6@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@22 ($Integer 4)))))))))))))) (=> (= (ControlFlow 0 51398) (- 0 107711)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (let (($range_9 inline$$TestVector_test_contains_$def_verify$0$$ret0@2))
(exists (($i_8 Int) )  (and (and (>= $i_8 0) (< $i_8 (|l#$ValueArray| (|v#$Vector| $range_9)))) (let ((x@@23 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_9)) $i_8)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@23 ($Integer 5))))))))))))))))))))))))))))))))))))))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon34_correct  (=> (= $abort_flag@0@@4 false) (=> (and (and (= inline$$TestVector_test_contains_$def_verify$0$$ret0@2 |inline$$WritebackToValue$3$vdst'@2|) (= inline$$TestVector_test_contains_$def_verify$0$$ret1@2 inline$$Vector_contains$0$res@1)) (and (= inline$$TestVector_test_contains_$def_verify$0$$ret2@2 inline$$Vector_contains$1$res@1) (= (ControlFlow 0 51212) 51398))) anon0$2_correct@@4))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 51210) 51212)) inline$$TestVector_test_contains_$def_verify$0$anon34_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 51220) 51212) inline$$TestVector_test_contains_$def_verify$0$anon34_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon50_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 51200) 51220) inline$$TestVector_test_contains_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 51200) 51210) inline$$TestVector_test_contains_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon50_Then_correct  (and (=> (= (ControlFlow 0 51228) 51220) inline$$TestVector_test_contains_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 51228) 51210) inline$$TestVector_test_contains_$def_verify$0$anon51_Else_correct))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon49_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 51190) 51228) inline$$TestVector_test_contains_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 51190) 51200) inline$$TestVector_test_contains_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon49_Then_correct  (and (=> (= (ControlFlow 0 51236) 51228) inline$$TestVector_test_contains_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 51236) 51200) inline$$TestVector_test_contains_$def_verify$0$anon50_Else_correct))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon47_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 51184) 51236) inline$$TestVector_test_contains_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 51184) 51190) inline$$TestVector_test_contains_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon47_Then_correct true))
(let ((inline$$Vector_contains$1$anon0_correct  (=> (and ((_ is $Vector) |inline$$WritebackToValue$3$vdst'@2|) (= inline$$Vector_contains$1$res@1 ($Boolean (exists ((i@@10 Int) )  (and (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$3$vdst'@2|)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$3$vdst'@2|)) i@@10) inline$$TestVector_test_contains_$def_verify$0$$t17@1)))))) (and (=> (= (ControlFlow 0 51168) 51240) inline$$TestVector_test_contains_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 51168) 51184) inline$$TestVector_test_contains_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$Vector_contains$1$Entry_correct  (=> (and (= inline$$Vector_contains$1$ta@0 $IntegerType) (= (ControlFlow 0 51154) 51168)) inline$$Vector_contains$1$anon0_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon45_Else_correct  (=> (not false) (=> (and (= inline$$TestVector_test_contains_$def_verify$0$$t17@1 ($Integer 4)) (= (ControlFlow 0 51174) 51154)) inline$$Vector_contains$1$Entry_correct))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon45_Then_correct true))
(let ((inline$$Vector_contains$0$anon0_correct  (=> (and ((_ is $Vector) |inline$$WritebackToValue$3$vdst'@2|) (= inline$$Vector_contains$0$res@1 ($Boolean (exists ((i@@11 Int) )  (and (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$3$vdst'@2|)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$3$vdst'@2|)) i@@11) inline$$TestVector_test_contains_$def_verify$0$$t16@1)))))) (and (=> (= (ControlFlow 0 51091) 51270) inline$$TestVector_test_contains_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 51091) 51174) inline$$TestVector_test_contains_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Vector_contains$0$Entry_correct  (=> (and (= inline$$Vector_contains$0$ta@0 $IntegerType) (= (ControlFlow 0 51077) 51091)) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon43_Else$2_correct  (=> (and (= inline$$TestVector_test_contains_$def_verify$0$$t16@1 ($Integer 3)) (= (ControlFlow 0 51097) 51077)) inline$$Vector_contains$0$Entry_correct)))
(let ((inline$$WritebackToValue$3$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$3$vdst'@2| |inline$$WritebackToValue$2$vdst'@2|) (= (ControlFlow 0 50994) 51097)) inline$$TestVector_test_contains_$def_verify$0$anon43_Else$2_correct))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1|) ($Local 2)) (= |inline$$WritebackToValue$3$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1|) 0 |inline$$WritebackToValue$2$vdst'@2| (|v#$Mutation| |inline$$WriteRef$3$to'@1|)))) (and (= |inline$$WritebackToValue$3$vdst'@2| |inline$$WritebackToValue$3$vdst'@1|) (= (ControlFlow 0 51020) 51097))) inline$$TestVector_test_contains_$def_verify$0$anon43_Else$2_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$3$dst@1) (|p#$Mutation| inline$$BorrowLoc$3$dst@1) |inline$$Vector_push_back$3$v'@1|)) (and (=> (= (ControlFlow 0 50895) 51020) inline$$WritebackToValue$3$anon3_Then_correct) (=> (= (ControlFlow 0 50895) 50994) inline$$WritebackToValue$3$anon3_Else_correct)))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon43_Else_correct  (=> (and (not false) (= (ControlFlow 0 50901) 50895)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon43_Then_correct true))
(let ((inline$$Vector_push_back$3$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$3$v@1) (= |inline$$Vector_push_back$3$v'@1| ($Vector (let ((len@@5 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) len@@5 inline$$TestVector_test_contains_$def_verify$0$$t15@1) (+ len@@5 1)))))) (and (=> (= (ControlFlow 0 50830) 51290) inline$$TestVector_test_contains_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 50830) 50901) inline$$TestVector_test_contains_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Vector_push_back$3$Entry_correct  (=> (and (= inline$$Vector_push_back$3$ta@0 $IntegerType) (= (ControlFlow 0 50818) 50830)) inline$$Vector_push_back$3$anon0_correct)))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowLoc$3$dst@1)) (= (ControlFlow 0 50767) 50818)) inline$$Vector_push_back$3$Entry_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon41_Else$3_correct  (=> (and (= inline$$TestVector_test_contains_$def_verify$0$$t15@1 ($Integer 5)) (= (ControlFlow 0 50773) 50767)) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$BorrowLoc$3$anon0_correct  (=> (and (= inline$$BorrowLoc$3$dst@1 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$2$vdst'@2|)) (= (ControlFlow 0 50725) 50773)) inline$$TestVector_test_contains_$def_verify$0$anon41_Else$3_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2| |inline$$WritebackToValue$1$vdst'@2|) (= (ControlFlow 0 50643) 50725)) inline$$BorrowLoc$3$anon0_correct))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|) ($Local 2)) (= |inline$$WritebackToValue$2$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@0|) 0 |inline$$WritebackToValue$1$vdst'@2| (|v#$Mutation| |inline$$WriteRef$2$to'@1@@0|)))) (and (= |inline$$WritebackToValue$2$vdst'@2| |inline$$WritebackToValue$2$vdst'@1@@0|) (= (ControlFlow 0 50669) 50725))) inline$$BorrowLoc$3$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct@@0  (=> (= |inline$$WriteRef$2$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@0) |inline$$Vector_push_back$2$v'@1|)) (and (=> (= (ControlFlow 0 50544) 50669) inline$$WritebackToValue$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 50544) 50643) inline$$WritebackToValue$2$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon41_Else_correct  (=> (and (not false) (= (ControlFlow 0 50550) 50544)) inline$$WriteRef$2$anon0_correct@@0)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon41_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@0) (= |inline$$Vector_push_back$2$v'@1| ($Vector (let ((len@@6 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) len@@6 inline$$TestVector_test_contains_$def_verify$0$$t13@1) (+ len@@6 1)))))) (and (=> (= (ControlFlow 0 50479) 51310) inline$$TestVector_test_contains_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 50479) 50550) inline$$TestVector_test_contains_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct  (=> (and (= inline$$Vector_push_back$2$ta@0 $IntegerType) (= (ControlFlow 0 50467) 50479)) inline$$Vector_push_back$2$anon0_correct)))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@0)) (= (ControlFlow 0 50416) 50467)) inline$$Vector_push_back$2$Entry_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon39_Else$3_correct  (=> (and (= inline$$TestVector_test_contains_$def_verify$0$$t13@1 ($Integer 3)) (= (ControlFlow 0 50422) 50416)) inline$$ReadRef$2$anon0_correct@@0)))
(let ((inline$$BorrowLoc$2$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$2$dst@1@@0 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$1$vdst'@2|)) (= (ControlFlow 0 50374) 50422)) inline$$TestVector_test_contains_$def_verify$0$anon39_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$0$vdst'@2@@4|) (= (ControlFlow 0 50292) 50374)) inline$$BorrowLoc$2$anon0_correct@@0))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|) ($Local 2)) (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|) 0 |inline$$WritebackToValue$0$vdst'@2@@4| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1@@0|) (= (ControlFlow 0 50318) 50374))) inline$$BorrowLoc$2$anon0_correct@@0)))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0) |inline$$Vector_push_back$1$v'@1|)) (and (=> (= (ControlFlow 0 50193) 50318) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 50193) 50292) inline$$WritebackToValue$1$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon39_Else_correct  (=> (and (not false) (= (ControlFlow 0 50199) 50193)) inline$$WriteRef$1$anon0_correct@@1)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon39_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@1) (= |inline$$Vector_push_back$1$v'@1| ($Vector (let ((len@@7 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@1)) len@@7 inline$$TestVector_test_contains_$def_verify$0$$t11@1) (+ len@@7 1)))))) (and (=> (= (ControlFlow 0 50128) 51330) inline$$TestVector_test_contains_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 50128) 50199) inline$$TestVector_test_contains_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct  (=> (and (= inline$$Vector_push_back$1$ta@0 $IntegerType) (= (ControlFlow 0 50116) 50128)) inline$$Vector_push_back$1$anon0_correct)))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (= (ControlFlow 0 50065) 50116)) inline$$Vector_push_back$1$Entry_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon37_Else$3_correct  (=> (and (= inline$$TestVector_test_contains_$def_verify$0$$t11@1 ($Integer 2)) (= (ControlFlow 0 50071) 50065)) inline$$ReadRef$1$anon0_correct@@1)))
(let ((inline$$BorrowLoc$1$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$1$dst@1@@0 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@4|)) (= (ControlFlow 0 50023) 50071)) inline$$TestVector_test_contains_$def_verify$0$anon37_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@5  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@4| inline$$Vector_empty$0$v@1@@5) (= (ControlFlow 0 49941) 50023)) inline$$BorrowLoc$1$anon0_correct@@0))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@5  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|) 0 inline$$Vector_empty$0$v@1@@5 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@4| |inline$$WritebackToValue$0$vdst'@1@@5|) (= (ControlFlow 0 49967) 50023))) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@5  (=> (= |inline$$WriteRef$0$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5) |inline$$Vector_push_back$0$v'@1@@4|)) (and (=> (= (ControlFlow 0 49842) 49967) inline$$WritebackToValue$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 49842) 49941) inline$$WritebackToValue$0$anon3_Else_correct@@5)))))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon37_Else_correct  (=> (and (not false) (= (ControlFlow 0 49848) 49842)) inline$$WriteRef$0$anon0_correct@@5)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon37_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@4  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@5) (= |inline$$Vector_push_back$0$v'@1@@4| ($Vector (let ((len@@8 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) len@@8 inline$$TestVector_test_contains_$def_verify$0$$t8@1) (+ len@@8 1)))))) (and (=> (= (ControlFlow 0 49777) 51350) inline$$TestVector_test_contains_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 49777) 49848) inline$$TestVector_test_contains_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@2  (=> (and (= inline$$Vector_push_back$0$ta@0@@2 $IntegerType) (= (ControlFlow 0 49765) 49777)) inline$$Vector_push_back$0$anon0_correct@@4)))
(let ((inline$$ReadRef$0$anon0_correct@@5  (=> (and (= inline$$ReadRef$0$v@1@@5 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (= (ControlFlow 0 49714) 49765)) inline$$Vector_push_back$0$Entry_correct@@2)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon35_Else$1_correct  (=> (and (= inline$$TestVector_test_contains_$def_verify$0$$t8@1 ($Integer 1)) (= (ControlFlow 0 49720) 49714)) inline$$ReadRef$0$anon0_correct@@5)))
(let ((inline$$BorrowLoc$0$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$0$dst@1@@5 ($Mutation ($Local 2) $EmptyPath inline$$Vector_empty$0$v@1@@5)) (= (ControlFlow 0 49672) 49720)) inline$$TestVector_test_contains_$def_verify$0$anon35_Else$1_correct)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon35_Else_correct  (=> (and (not false) (= (ControlFlow 0 49678) 49672)) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon35_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@5  (=> (= inline$$Vector_empty$0$v@1@@5 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 49610) 51370) inline$$TestVector_test_contains_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 49610) 49678) inline$$TestVector_test_contains_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@2  (=> (and (= inline$$Vector_empty$0$ta@0@@2 $IntegerType) (= (ControlFlow 0 49606) 49610)) inline$$Vector_empty$0$anon0_correct@@5)))
(let ((inline$$TestVector_test_contains_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 49616) 49606)) inline$$Vector_empty$0$Entry_correct@@2)))
(let ((anon0_correct@@6  (=> (= (ControlFlow 0 105675) 49616) inline$$TestVector_test_contains_$def_verify$0$anon0_correct)))
anon0_correct@@6))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$TestVector_test_destroy_empty1_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@15 () T@$Value)
(declare-fun inline$$TestVector_test_destroy_empty1_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun |inline$$TestVector_test_destroy_empty1_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1@@6 () T@$Value)
(declare-fun inline$$Vector_empty$0$ta@0@@3 () T@$TypeValue)
(declare-fun inline$$Vector_destroy_empty$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_is_empty$0$b@1@@0 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 107766) (let ((anon0$2_correct@@5  (=> (= (ControlFlow 0 52625) (- 0 108196)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_destroy_empty1_$def_verify$0$$ret0@2 v@@15)))))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestVector_test_destroy_empty1_$def_verify$0$$ret0@1 $Error) (= $abort_flag@2@@1 true)) (and (= inline$$TestVector_test_destroy_empty1_$def_verify$0$$ret0@2 inline$$TestVector_test_destroy_empty1_$def_verify$0$$ret0@1) (= (ControlFlow 0 52561) 52625))) anon0$2_correct@@5)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 52579) 52561)) inline$$TestVector_test_destroy_empty1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 52589) 52561) inline$$TestVector_test_destroy_empty1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon25_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 52573) 52589) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 52573) 52579) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 52553) 52561)) inline$$TestVector_test_destroy_empty1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 52569) 52561) inline$$TestVector_test_destroy_empty1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon27_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 52547) 52569) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 52547) 52553) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon20_correct  (=> (= $abort_flag@2@@1 $abort_flag@1@@4) (=> (and (= inline$$TestVector_test_destroy_empty1_$def_verify$0$$ret0@2 |inline$$TestVector_test_destroy_empty1_$def_verify$0$tmp#$1@1|) (= (ControlFlow 0 52345) 52625)) anon0$2_correct@@5))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 52343) 52345)) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 52353) 52345) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@0@@5) (=> (and (= $abort_flag@1@@4 $abort_flag@0@@5) (= |inline$$TestVector_test_destroy_empty1_$def_verify$0$tmp#$1@1| inline$$Vector_empty$0$v@1@@6)) (and (=> (= (ControlFlow 0 52543) 52353) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 52543) 52343) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$Vector_empty$0$anon0_correct@@6  (=> (= inline$$Vector_empty$0$v@1@@6 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 52529) 52547) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 52529) 52543) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@3  (=> (and (= inline$$Vector_empty$0$ta@0@@3 $IntegerType) (= (ControlFlow 0 52525) 52529)) inline$$Vector_empty$0$anon0_correct@@6)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@0@@5) (= (ControlFlow 0 52535) 52525)) inline$$Vector_empty$0$Entry_correct@@3)))
(let ((inline$$Vector_destroy_empty$0$anon2_Then$1_correct  (=> (= $abort_flag@0@@5 true) (and (=> (= (ControlFlow 0 52490) 52573) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 52490) 52535) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_destroy_empty$0$anon2_Then_correct  (=> (and (not (= (|l#$ValueArray| (|v#$Vector| v@@15)) 0)) (= (ControlFlow 0 52488) 52490)) inline$$Vector_destroy_empty$0$anon2_Then$1_correct)))
(let ((inline$$Vector_destroy_empty$0$anon2_Else_correct  (=> (and (= (|l#$ValueArray| (|v#$Vector| v@@15)) 0) (= $abort_flag@0@@5 false)) (and (=> (= (ControlFlow 0 52438) 52573) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 52438) 52535) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_destroy_empty$0$Entry_correct  (=> (= inline$$Vector_destroy_empty$0$ta@0 $IntegerType) (and (=> (= (ControlFlow 0 52426) 52488) inline$$Vector_destroy_empty$0$anon2_Then_correct) (=> (= (ControlFlow 0 52426) 52438) inline$$Vector_destroy_empty$0$anon2_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon24_Then_correct  (=> (and (|b#$Boolean| inline$$Vector_is_empty$0$b@1@@0) (= (ControlFlow 0 52494) 52426)) inline$$Vector_destroy_empty$0$Entry_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon18_correct  (=> (and (= $abort_flag@1@@4 false) (= |inline$$TestVector_test_destroy_empty1_$def_verify$0$tmp#$1@1| v@@15)) (and (=> (= (ControlFlow 0 52333) 52353) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 52333) 52343) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 52331) 52333)) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon18_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 52361) 52333) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon18_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon24_Else_correct  (=> (not (|b#$Boolean| inline$$Vector_is_empty$0$b@1@@0)) (and (=> (= (ControlFlow 0 52323) 52361) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 52323) 52331) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon22_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 52283) 52494) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 52283) 52323) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon22_Then_correct true))
(let ((inline$$Vector_is_empty$0$anon0_correct@@0  (=> (and ((_ is $Vector) v@@15) (= inline$$Vector_is_empty$0$b@1@@0 ($Boolean (= (|l#$ValueArray| (|v#$Vector| v@@15)) 0)))) (and (=> (= (ControlFlow 0 52269) 52593) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 52269) 52283) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Vector_is_empty$0$Entry_correct  (=> (and (= inline$$Vector_is_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 52253) 52269)) inline$$Vector_is_empty$0$anon0_correct@@0)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 52176) 52253)) inline$$Vector_is_empty$0$Entry_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 52617) 52253) inline$$Vector_is_empty$0$Entry_correct)))
(let ((inline$$TestVector_test_destroy_empty1_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 52170) 52617) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 52170) 52176) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon21_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and (and ((_ is $Vector) v@@15) (let ((va@@19 (|v#$Vector| v@@15)))
(let ((l@@21 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@24))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| v@@15)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $$0@@0)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $$0@@0))
))) (= (ControlFlow 0 51853) 52170)) inline$$TestVector_test_destroy_empty1_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 107766) 51853) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun |inline$$WriteRef$0$to'@1@@6| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@6| () T@$Value)
(declare-fun v@@16 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@6 () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@2| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@0| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$0$v@1@@6 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@1 () Int)
(declare-fun |inline$$Vector_swap$0$v'@1| () T@$Value)
(declare-fun inline$$TestVector_test_destroy_empty2_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$TestVector_test_destroy_empty2_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Vector_swap$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_is_empty$0$b@1@@1 () T@$Value)
(declare-fun inline$$Vector_destroy_empty$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$Vector_is_empty$0$ta@0@@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 108215) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 54006) (- 0 108903)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@3@@0)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@3@@0) (=> (= (ControlFlow 0 54006) (- 0 108912)) (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@3@@0 true) (= (ControlFlow 0 53346) 54006)) anon0$2_correct@@6)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 53962) 53346)) inline$$TestVector_test_destroy_empty2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 53972) 53346) inline$$TestVector_test_destroy_empty2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 53956) 53972) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 53956) 53962) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 53340) 53346)) inline$$TestVector_test_destroy_empty2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 53354) 53346) inline$$TestVector_test_destroy_empty2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 53334) 53354) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 53334) 53340) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$L3_correct  (=> (and (= $abort_flag@3@@0 $abort_flag@2@@2) (= (ControlFlow 0 53330) 54006)) anon0$2_correct@@6)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Else$2_correct  (=> (and (= $abort_flag@2@@2 $abort_flag@1@@5) (= (ControlFlow 0 53952) 53330)) inline$$TestVector_test_destroy_empty2_$def_verify$0$L3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@6  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 1))) (= (ControlFlow 0 53918) 53952)) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Else$2_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@6  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@6| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@6|) 0 v@@16 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@6|))) (= (ControlFlow 0 53944) 53952)) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Else$2_correct))))
(let ((inline$$WriteRef$0$anon0_correct@@6  (=> (= |inline$$WriteRef$0$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6) |inline$$Vector_swap$0$v'@2|)) (and (=> (= (ControlFlow 0 53819) 53944) inline$$WritebackToValue$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 53819) 53918) inline$$WritebackToValue$0$anon3_Else_correct@@6)))))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@1@@5) (= (ControlFlow 0 53825) 53819)) inline$$WriteRef$0$anon0_correct@@6)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@5 true) (= |inline$$Vector_swap$0$v'@2| |inline$$Vector_swap$0$v'@0|)) (and (=> (= (ControlFlow 0 53754) 53956) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 53754) 53825) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6))) (>= inline$$Vector_swap$0$j_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)))) (< inline$$Vector_swap$0$i_ind@1 0)) (< inline$$Vector_swap$0$j_ind@1 0)) (= (ControlFlow 0 53752) 53754)) inline$$Vector_swap$0$anon3_Then$1_correct)))
(let ((inline$$Vector_swap$0$anon3_Else_correct  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6))) (>= inline$$Vector_swap$0$j_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)))) (< inline$$Vector_swap$0$i_ind@1 0)) (< inline$$Vector_swap$0$j_ind@1 0))) (= |inline$$Vector_swap$0$v'@1| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) inline$$Vector_swap$0$i_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) inline$$Vector_swap$0$j_ind@1)) inline$$Vector_swap$0$j_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) inline$$Vector_swap$0$i_ind@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)))))) (and (= $abort_flag@1@@5 false) (= |inline$$Vector_swap$0$v'@2| |inline$$Vector_swap$0$v'@1|))) (and (=> (= (ControlFlow 0 53676) 53956) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 53676) 53825) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$0$v@1@@6) (=> (and (= inline$$Vector_swap$0$i_ind@1 (|i#$Integer| inline$$TestVector_test_destroy_empty2_$def_verify$0$$t4@1)) (= inline$$Vector_swap$0$j_ind@1 (|i#$Integer| inline$$TestVector_test_destroy_empty2_$def_verify$0$$t5@1))) (and (=> (= (ControlFlow 0 53630) 53752) inline$$Vector_swap$0$anon3_Then_correct) (=> (= (ControlFlow 0 53630) 53676) inline$$Vector_swap$0$anon3_Else_correct))))))
(let ((inline$$Vector_swap$0$Entry_correct  (=> (= inline$$Vector_swap$0$ta@0 $IntegerType) (and (=> (= (ControlFlow 0 53616) (- 0 108648)) true) (=> (= (ControlFlow 0 53616) 53630) inline$$Vector_swap$0$anon0_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@6  (=> (and (= inline$$ReadRef$0$v@1@@6 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (= (ControlFlow 0 53454) 53616)) inline$$Vector_swap$0$Entry_correct)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon20_Then$1_correct  (=> (= inline$$TestVector_test_destroy_empty2_$def_verify$0$$t4@1 ($Integer 0)) (=> (and (= inline$$TestVector_test_destroy_empty2_$def_verify$0$$t5@1 ($Integer 0)) (= (ControlFlow 0 53460) 53454)) inline$$ReadRef$0$anon0_correct@@6))))
(let ((inline$$BorrowLoc$0$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$0$dst@1@@6 ($Mutation ($Local 1) $EmptyPath v@@16)) (= (ControlFlow 0 53408) 53460)) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon20_Then$1_correct)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$Vector_is_empty$0$b@1@@1) (= (ControlFlow 0 53414) 53408)) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon23_Else_correct  (=> (not $abort_flag@0@@6) (=> (and (= $abort_flag@2@@2 $abort_flag@0@@6) (= (ControlFlow 0 53328) 53330)) inline$$TestVector_test_destroy_empty2_$def_verify$0$L3_correct))))
(let ((inline$$Vector_destroy_empty$0$anon2_Then$1_correct@@0  (=> (= $abort_flag@0@@6 true) (and (=> (= (ControlFlow 0 53316) 53334) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 53316) 53328) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Vector_destroy_empty$0$anon2_Then_correct@@0  (=> (and (not (= (|l#$ValueArray| (|v#$Vector| v@@16)) 0)) (= (ControlFlow 0 53314) 53316)) inline$$Vector_destroy_empty$0$anon2_Then$1_correct@@0)))
(let ((inline$$Vector_destroy_empty$0$anon2_Else_correct@@0  (=> (and (= (|l#$ValueArray| (|v#$Vector| v@@16)) 0) (= $abort_flag@0@@6 false)) (and (=> (= (ControlFlow 0 53264) 53334) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 53264) 53328) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Vector_destroy_empty$0$Entry_correct@@0  (=> (= inline$$Vector_destroy_empty$0$ta@0@@0 $IntegerType) (and (=> (= (ControlFlow 0 53252) 53314) inline$$Vector_destroy_empty$0$anon2_Then_correct@@0) (=> (= (ControlFlow 0 53252) 53264) inline$$Vector_destroy_empty$0$anon2_Else_correct@@0)))))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$Vector_is_empty$0$b@1@@1)) (= (ControlFlow 0 53320) 53252)) inline$$Vector_destroy_empty$0$Entry_correct@@0)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon18_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 53185) 53414) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 53185) 53320) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon18_Then_correct true))
(let ((inline$$Vector_is_empty$0$anon0_correct@@1  (=> (and ((_ is $Vector) v@@16) (= inline$$Vector_is_empty$0$b@1@@1 ($Boolean (= (|l#$ValueArray| (|v#$Vector| v@@16)) 0)))) (and (=> (= (ControlFlow 0 53171) 53976) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 53171) 53185) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Vector_is_empty$0$Entry_correct@@0  (=> (and (= inline$$Vector_is_empty$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 53155) 53171)) inline$$Vector_is_empty$0$anon0_correct@@1)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 53078) 53155)) inline$$Vector_is_empty$0$Entry_correct@@0)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 54000) 53155) inline$$Vector_is_empty$0$Entry_correct@@0)))
(let ((inline$$TestVector_test_destroy_empty2_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 53072) 54000) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 53072) 53078) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@8  (=> (and (and (and ((_ is $Vector) v@@16) (let ((va@@20 (|v#$Vector| v@@16)))
(let ((l@@22 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@25))
)))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| v@@16)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $$0@@1)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $$0@@1))
))) (= (ControlFlow 0 52783) 53072)) inline$$TestVector_test_destroy_empty2_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 108215) 52783) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun inline$$TestVector_test_empty_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_empty_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1@@7 () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1@@0 () T@$Value)
(declare-fun inline$$Vector_empty$1$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@4 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 108927) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 54565) (- 0 109208)) (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_empty_$def_verify$0$$ret0@2 inline$$TestVector_test_empty_$def_verify$0$$ret1@2))))) (=> (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_empty_$def_verify$0$$ret0@2 inline$$TestVector_test_empty_$def_verify$0$$ret1@2)))) (and (=> (= (ControlFlow 0 54565) (- 0 109221)) (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_empty_$def_verify$0$$ret0@2))) ($Integer 0)))))) (=> (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_empty_$def_verify$0$$ret0@2))) ($Integer 0))))) (=> (= (ControlFlow 0 54565) (- 0 109239)) (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_empty_$def_verify$0$$ret1@2))) ($Integer 0))))))))))))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon12_correct  (=> (and (and (= $abort_flag@0@@7 false) (= inline$$TestVector_test_empty_$def_verify$0$$ret0@2 inline$$Vector_empty$0$v@1@@7)) (and (= inline$$TestVector_test_empty_$def_verify$0$$ret1@2 inline$$Vector_empty$1$v@1@@0) (= (ControlFlow 0 54491) 54565))) anon0$2_correct@@7)))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 54489) 54491)) inline$$TestVector_test_empty_$def_verify$0$anon12_correct)))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 54499) 54491) inline$$TestVector_test_empty_$def_verify$0$anon12_correct)))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 54479) 54499) inline$$TestVector_test_empty_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 54479) 54489) inline$$TestVector_test_empty_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 54507) 54499) inline$$TestVector_test_empty_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 54507) 54489) inline$$TestVector_test_empty_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon15_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 54473) 54507) inline$$TestVector_test_empty_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 54473) 54479) inline$$TestVector_test_empty_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon15_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@0  (=> (= inline$$Vector_empty$1$v@1@@0 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 54457) 54511) inline$$TestVector_test_empty_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 54457) 54473) inline$$TestVector_test_empty_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct  (=> (and (= inline$$Vector_empty$1$ta@0 $IntegerType) (= (ControlFlow 0 54453) 54457)) inline$$Vector_empty$1$anon0_correct@@0)))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon13_Else_correct  (=> (and (not false) (= (ControlFlow 0 54463) 54453)) inline$$Vector_empty$1$Entry_correct)))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon13_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@7  (=> (= inline$$Vector_empty$0$v@1@@7 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 54416) 54539) inline$$TestVector_test_empty_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 54416) 54463) inline$$TestVector_test_empty_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@4  (=> (and (= inline$$Vector_empty$0$ta@0@@4 $IntegerType) (= (ControlFlow 0 54412) 54416)) inline$$Vector_empty$0$anon0_correct@@7)))
(let ((inline$$TestVector_test_empty_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 54422) 54412)) inline$$Vector_empty$0$Entry_correct@@4)))
(let ((anon0_correct@@9  (=> (= (ControlFlow 0 108927) 54422) inline$$TestVector_test_empty_$def_verify$0$anon0_correct)))
anon0_correct@@9)))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun v@@17 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 109264) (let ((anon0$2_correct@@8  (=> (= (ControlFlow 0 54864) (- 0 109410)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified v@@17 v@@17)))))))
(let ((inline$$TestVector_test_id1_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 54838) 54864)) anon0$2_correct@@8)))
(let ((inline$$TestVector_test_id1_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 54848) 54864) anon0$2_correct@@8)))
(let ((inline$$TestVector_test_id1_$def_verify$0$anon5_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 54794) 54848) inline$$TestVector_test_id1_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 54794) 54838) inline$$TestVector_test_id1_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestVector_test_id1_$def_verify$0$anon5_Then_correct  (and (=> (= (ControlFlow 0 54856) 54848) inline$$TestVector_test_id1_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 54856) 54838) inline$$TestVector_test_id1_$def_verify$0$anon6_Else_correct))))
(let ((inline$$TestVector_test_id1_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 54788) 54856) inline$$TestVector_test_id1_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 54788) 54794) inline$$TestVector_test_id1_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct@@10  (=> (and (and (and ((_ is $Vector) v@@17) (let ((va@@21 (|v#$Vector| v@@17)))
(let ((l@@23 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@26))
)))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| v@@17)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@17)) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@17)) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@17)) $$0@@2)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@17)) $$0@@2))
))) (= (ControlFlow 0 54686) 54788)) inline$$TestVector_test_id1_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 109264) 54686) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@2)))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun inline$$TestVector_test_id2_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@18 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@5| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$1$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@2 () T@$Value)
(declare-fun inline$$Vector_reverse$1$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@7| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@7| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@7 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@7 () T@$Value)
(declare-fun inline$$Vector_reverse$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 109429) (let ((anon0$2_correct@@9  (=> (= (ControlFlow 0 56020) (- 0 110032)) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_id2_$def_verify$0$$ret0@2 v@@18)))))))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon12_correct  (=> (= $abort_flag@0@@8 false) (=> (and (= inline$$TestVector_test_id2_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@0|) (= (ControlFlow 0 55950) 56020)) anon0$2_correct@@9))))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 55948) 55950)) inline$$TestVector_test_id2_$def_verify$0$anon12_correct)))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 55958) 55950) inline$$TestVector_test_id2_$def_verify$0$anon12_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|) ($Local 1))) (= |inline$$WritebackToValue$1$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@2@@5|)) (and (=> (= (ControlFlow 0 55906) 55958) inline$$TestVector_test_id2_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 55906) 55948) inline$$TestVector_test_id2_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|) 0 |inline$$WritebackToValue$0$vdst'@2@@5| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))) (= |inline$$WritebackToValue$1$vdst'@2@@0| |inline$$WritebackToValue$1$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 55932) 55958) inline$$TestVector_test_id2_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 55932) 55948) inline$$TestVector_test_id2_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct@@2  (=> (= |inline$$WriteRef$1$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1) |inline$$Vector_reverse$1$v'@1|)) (and (=> (= (ControlFlow 0 55807) 55932) inline$$WritebackToValue$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 55807) 55906) inline$$WritebackToValue$1$anon3_Else_correct@@1)))))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon16_Else_correct  (=> (and (not false) (= (ControlFlow 0 55813) 55807)) inline$$WriteRef$1$anon0_correct@@2)))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon16_Then_correct true))
(let ((inline$$Vector_reverse$1$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@2) (= |inline$$Vector_reverse$1$v'@1| ($Vector (let ((l@@24 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@2))))
($ValueArray (|lambda#3| 0 l@@24 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@2)) l@@24 1 $Error) l@@24))))) (and (=> (= (ControlFlow 0 55742) 55962) inline$$TestVector_test_id2_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 55742) 55813) inline$$TestVector_test_id2_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Vector_reverse$1$Entry_correct  (=> (and (= inline$$Vector_reverse$1$ta@0 $IntegerType) (= (ControlFlow 0 55732) 55742)) inline$$Vector_reverse$1$anon0_correct)))
(let ((inline$$ReadRef$1$anon0_correct@@2  (=> (and (= inline$$ReadRef$1$v@1@@2 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1)) (= (ControlFlow 0 55689) 55732)) inline$$Vector_reverse$1$Entry_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$1$dst@1@@1 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@5|)) (= (ControlFlow 0 55651) 55689)) inline$$ReadRef$1$anon0_correct@@2)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@7  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@5| v@@18) (= (ControlFlow 0 55569) 55651)) inline$$BorrowLoc$1$anon0_correct@@1))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@7  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1@@7| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@7|) 0 v@@18 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@5| |inline$$WritebackToValue$0$vdst'@1@@7|) (= (ControlFlow 0 55595) 55651))) inline$$BorrowLoc$1$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@7  (=> (= |inline$$WriteRef$0$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7) |inline$$Vector_reverse$0$v'@1|)) (and (=> (= (ControlFlow 0 55470) 55595) inline$$WritebackToValue$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 55470) 55569) inline$$WritebackToValue$0$anon3_Else_correct@@7)))))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon14_Else_correct  (=> (and (not false) (= (ControlFlow 0 55476) 55470)) inline$$WriteRef$0$anon0_correct@@7)))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon14_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@7) (= |inline$$Vector_reverse$0$v'@1| ($Vector (let ((l@@25 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7))))
($ValueArray (|lambda#3| 0 l@@25 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) l@@25 1 $Error) l@@25))))) (and (=> (= (ControlFlow 0 55405) 55988) inline$$TestVector_test_id2_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 55405) 55476) inline$$TestVector_test_id2_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Vector_reverse$0$Entry_correct  (=> (and (= inline$$Vector_reverse$0$ta@0 $IntegerType) (= (ControlFlow 0 55395) 55405)) inline$$Vector_reverse$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@7  (=> (and (= inline$$ReadRef$0$v@1@@7 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7)) (= (ControlFlow 0 55352) 55395)) inline$$Vector_reverse$0$Entry_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$0$dst@1@@7 ($Mutation ($Local 1) $EmptyPath v@@18)) (= (ControlFlow 0 55314) 55352)) inline$$ReadRef$0$anon0_correct@@7)))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 55230) 55314)) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 56012) 55314) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$TestVector_test_id2_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 55224) 56012) inline$$TestVector_test_id2_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 55224) 55230) inline$$TestVector_test_id2_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@11  (=> (and (and (and ((_ is $Vector) v@@18) (let ((va@@22 (|v#$Vector| v@@18)))
(let ((l@@26 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@27))
)))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| v@@18)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@18)) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@18)) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@18)) $$0@@3)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@18)) $$0@@3))
))) (= (ControlFlow 0 54977) 55224)) inline$$TestVector_test_id2_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 109429) 54977) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun inline$$TestVector_test_id3_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@19 () T@$Value)
(declare-fun inline$$TestVector_test_id3_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@3| () T@$Mutation)
(declare-fun inline$$TestVector_test_id3_$def_verify$0$$t2@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$1$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@3 () T@$Value)
(declare-fun inline$$Vector_reverse$1$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@2@@0| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@0@@0| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@1@@0 () Int)
(declare-fun inline$$ReadRef$2$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@1@@0 () Int)
(declare-fun |inline$$Vector_swap$0$v'@1@@0| () T@$Value)
(declare-fun inline$$TestVector_test_id3_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$Vector_swap$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$TestVector_test_id3_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$Le$1$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@6| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@8| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@8| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@8 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1@@0| () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@8 () T@$Value)
(declare-fun inline$$Vector_reverse$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$TestVector_test_id3_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestVector_test_id3_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 110053) (let ((anon0$2_correct@@10  (=> (= (ControlFlow 0 58625) (- 0 111364)) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_id3_$def_verify$0$$ret0@2 v@@19)))))))
(let ((inline$$TestVector_test_id3_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestVector_test_id3_$def_verify$0$$ret0@1 $Error) (= $abort_flag@3@@1 true)) (and (= inline$$TestVector_test_id3_$def_verify$0$$ret0@2 inline$$TestVector_test_id3_$def_verify$0$$ret0@1) (= (ControlFlow 0 57740) 58625))) anon0$2_correct@@10)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 58573) 57740)) inline$$TestVector_test_id3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 58583) 57740) inline$$TestVector_test_id3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon34_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 58567) 58583) inline$$TestVector_test_id3_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 58567) 58573) inline$$TestVector_test_id3_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 58553) 57740)) inline$$TestVector_test_id3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 58563) 57740) inline$$TestVector_test_id3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon36_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 58547) 58563) inline$$TestVector_test_id3_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 58547) 58553) inline$$TestVector_test_id3_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 57732) 57740)) inline$$TestVector_test_id3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 57748) 57740) inline$$TestVector_test_id3_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon40_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 57726) 57748) inline$$TestVector_test_id3_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 57726) 57732) inline$$TestVector_test_id3_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon28_correct  (=> (= $abort_flag@3@@1 $abort_flag@2@@3) (=> (and (= inline$$TestVector_test_id3_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@1|) (= (ControlFlow 0 57714) 58625)) anon0$2_correct@@10))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 57712) 57714)) inline$$TestVector_test_id3_$def_verify$0$anon28_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 57722) 57714) inline$$TestVector_test_id3_$def_verify$0$anon28_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@2  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|) ($Local 2))) (= |inline$$WritebackToValue$1$vdst'@2@@1| inline$$TestVector_test_id3_$def_verify$0$$t2@1)) (and (=> (= (ControlFlow 0 57670) 57722) inline$$TestVector_test_id3_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 57670) 57712) inline$$TestVector_test_id3_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@2  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@3|) 0 inline$$TestVector_test_id3_$def_verify$0$$t2@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@3|))) (= |inline$$WritebackToValue$1$vdst'@2@@1| |inline$$WritebackToValue$1$vdst'@1@@2|)) (and (=> (= (ControlFlow 0 57696) 57722) inline$$TestVector_test_id3_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 57696) 57712) inline$$TestVector_test_id3_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct@@3  (=> (= |inline$$WriteRef$1$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@2) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@2) |inline$$Vector_reverse$1$v'@1@@0|)) (and (=> (= (ControlFlow 0 57571) 57696) inline$$WritebackToValue$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 57571) 57670) inline$$WritebackToValue$1$anon3_Else_correct@@2)))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon40_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 57577) 57571)) inline$$WriteRef$1$anon0_correct@@3)))
(let ((inline$$Vector_reverse$1$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@3) (= |inline$$Vector_reverse$1$v'@1@@0| ($Vector (let ((l@@27 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3))))
($ValueArray (|lambda#3| 0 l@@27 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@3)) l@@27 1 $Error) l@@27))))) (and (=> (= (ControlFlow 0 57506) 57726) inline$$TestVector_test_id3_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 57506) 57577) inline$$TestVector_test_id3_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$Vector_reverse$1$Entry_correct@@0  (=> (and (= inline$$Vector_reverse$1$ta@0@@0 $IntegerType) (= (ControlFlow 0 57496) 57506)) inline$$Vector_reverse$1$anon0_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct@@3  (=> (and (= inline$$ReadRef$1$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@2)) (= (ControlFlow 0 57453) 57496)) inline$$Vector_reverse$1$Entry_correct@@0)))
(let ((inline$$BorrowLoc$1$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$1$dst@1@@2 ($Mutation ($Local 2) $EmptyPath inline$$TestVector_test_id3_$def_verify$0$$t2@1)) (= (ControlFlow 0 57415) 57453)) inline$$ReadRef$1$anon0_correct@@3)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon36_Else$2_correct  (=> (= inline$$TestVector_test_id3_$def_verify$0$$t2@1 |inline$$WritebackToValue$2$vdst'@2@@0|) (=> (and (= $abort_flag@2@@3 $abort_flag@1@@6) (= (ControlFlow 0 58543) 57415)) inline$$BorrowLoc$1$anon0_correct@@2))))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@0| v@@19) (= (ControlFlow 0 58509) 58543)) inline$$TestVector_test_id3_$def_verify$0$anon36_Else$2_correct))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|) ($Local 2)) (= |inline$$WritebackToValue$2$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@1|) 0 v@@19 (|v#$Mutation| |inline$$WriteRef$2$to'@1@@1|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@0| |inline$$WritebackToValue$2$vdst'@1@@1|) (= (ControlFlow 0 58535) 58543))) inline$$TestVector_test_id3_$def_verify$0$anon36_Else$2_correct)))
(let ((inline$$WriteRef$2$anon0_correct@@1  (=> (= |inline$$WriteRef$2$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@1) |inline$$Vector_swap$0$v'@2@@0|)) (and (=> (= (ControlFlow 0 58410) 58535) inline$$WritebackToValue$2$anon3_Then_correct@@1) (=> (= (ControlFlow 0 58410) 58509) inline$$WritebackToValue$2$anon3_Else_correct@@1)))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@1@@6) (= (ControlFlow 0 58416) 58410)) inline$$WriteRef$2$anon0_correct@@1)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@6 true) (= |inline$$Vector_swap$0$v'@2@@0| |inline$$Vector_swap$0$v'@0@@0|)) (and (=> (= (ControlFlow 0 58345) 58547) inline$$TestVector_test_id3_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 58345) 58416) inline$$TestVector_test_id3_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct@@0  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1))) (>= inline$$Vector_swap$0$j_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)))) (< inline$$Vector_swap$0$i_ind@1@@0 0)) (< inline$$Vector_swap$0$j_ind@1@@0 0)) (= (ControlFlow 0 58343) 58345)) inline$$Vector_swap$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_swap$0$anon3_Else_correct@@0  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1))) (>= inline$$Vector_swap$0$j_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)))) (< inline$$Vector_swap$0$i_ind@1@@0 0)) (< inline$$Vector_swap$0$j_ind@1@@0 0))) (= |inline$$Vector_swap$0$v'@1@@0| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)) inline$$Vector_swap$0$i_ind@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)) inline$$Vector_swap$0$j_ind@1@@0)) inline$$Vector_swap$0$j_ind@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)) inline$$Vector_swap$0$i_ind@1@@0)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)))))) (and (= $abort_flag@1@@6 $abort_flag@0@@9) (= |inline$$Vector_swap$0$v'@2@@0| |inline$$Vector_swap$0$v'@1@@0|))) (and (=> (= (ControlFlow 0 58267) 58547) inline$$TestVector_test_id3_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 58267) 58416) inline$$TestVector_test_id3_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct@@0  (=> ((_ is $Vector) inline$$ReadRef$2$v@1@@1) (=> (and (= inline$$Vector_swap$0$i_ind@1@@0 (|i#$Integer| inline$$TestVector_test_id3_$def_verify$0$$t8@1)) (= inline$$Vector_swap$0$j_ind@1@@0 (|i#$Integer| inline$$Sub$0$dst@2))) (and (=> (= (ControlFlow 0 58221) 58343) inline$$Vector_swap$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 58221) 58267) inline$$Vector_swap$0$anon3_Else_correct@@0))))))
(let ((inline$$Vector_swap$0$Entry_correct@@0  (=> (= inline$$Vector_swap$0$ta@0@@0 $IntegerType) (and (=> (= (ControlFlow 0 58207) (- 0 110877)) true) (=> (= (ControlFlow 0 58207) 58221) inline$$Vector_swap$0$anon0_correct@@0)))))
(let ((inline$$ReadRef$2$anon0_correct@@1  (=> (and (= inline$$ReadRef$2$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@1)) (= (ControlFlow 0 58045) 58207)) inline$$Vector_swap$0$Entry_correct@@0)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@0@@9) (= (ControlFlow 0 58051) 58045)) inline$$ReadRef$2$anon0_correct@@1)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@9 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 58001) 58567) inline$$TestVector_test_id3_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 58001) 58051) inline$$TestVector_test_id3_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$TestVector_test_id3_$def_verify$0$$t9@1)) (= (ControlFlow 0 57999) 58001)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$TestVector_test_id3_$def_verify$0$$t9@1) (|i#$Integer| inline$$Vector_length$0$l@1)) (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$TestVector_test_id3_$def_verify$0$$t9@1))))) (and (= $abort_flag@0@@9 false) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 57947) 58567) inline$$TestVector_test_id3_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 57947) 58051) inline$$TestVector_test_id3_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 57921) (- 0 110772)) true) (and (=> (= (ControlFlow 0 57921) 57999) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 57921) 57947) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon33_Then$1_correct  (=> (= inline$$TestVector_test_id3_$def_verify$0$$t8@1 ($Integer 0)) (=> (and (= inline$$TestVector_test_id3_$def_verify$0$$t9@1 ($Integer 1)) (= (ControlFlow 0 58007) 57921)) inline$$Sub$0$Entry_correct))))
(let ((inline$$BorrowLoc$2$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$2$dst@1@@1 ($Mutation ($Local 2) $EmptyPath v@@19)) (= (ControlFlow 0 57822) 58007)) inline$$TestVector_test_id3_$def_verify$0$anon33_Then$1_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon33_Then_correct  (=> (and (|b#$Boolean| inline$$Le$1$dst@1) (= (ControlFlow 0 57828) 57822)) inline$$BorrowLoc$2$anon0_correct@@1)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon38_Else$2_correct  (=> (= inline$$TestVector_test_id3_$def_verify$0$$t2@1 |inline$$WritebackToValue$0$vdst'@2@@6|) (=> (and (= $abort_flag@2@@3 false) (= (ControlFlow 0 57365) 57415)) inline$$BorrowLoc$1$anon0_correct@@2))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@8  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@6| v@@19) (= (ControlFlow 0 57331) 57365)) inline$$TestVector_test_id3_$def_verify$0$anon38_Else$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@8  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@8| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@8|) 0 v@@19 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@8|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@6| |inline$$WritebackToValue$0$vdst'@1@@8|) (= (ControlFlow 0 57357) 57365))) inline$$TestVector_test_id3_$def_verify$0$anon38_Else$2_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@8  (=> (= |inline$$WriteRef$0$to'@1@@8| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@8) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@8) |inline$$Vector_reverse$0$v'@1@@0|)) (and (=> (= (ControlFlow 0 57232) 57357) inline$$WritebackToValue$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 57232) 57331) inline$$WritebackToValue$0$anon3_Else_correct@@8)))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon38_Else_correct  (=> (and (not false) (= (ControlFlow 0 57238) 57232)) inline$$WriteRef$0$anon0_correct@@8)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon32_Then_correct  (=> (and (and (|b#$Boolean| inline$$Le$0$dst@1) (= inline$$TestVector_test_id3_$def_verify$0$$t2@1 v@@19)) (and (= $abort_flag@2@@3 false) (= (ControlFlow 0 58589) 57415))) inline$$BorrowLoc$1$anon0_correct@@2)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon38_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@8) (= |inline$$Vector_reverse$0$v'@1@@0| ($Vector (let ((l@@28 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8))))
($ValueArray (|lambda#3| 0 l@@28 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) l@@28 1 $Error) l@@28))))) (and (=> (= (ControlFlow 0 57167) 57752) inline$$TestVector_test_id3_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 57167) 57238) inline$$TestVector_test_id3_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Vector_reverse$0$Entry_correct@@0  (=> (and (= inline$$Vector_reverse$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 57157) 57167)) inline$$Vector_reverse$0$anon0_correct@@0)))
(let ((inline$$ReadRef$0$anon0_correct@@8  (=> (and (= inline$$ReadRef$0$v@1@@8 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)) (= (ControlFlow 0 57114) 57157)) inline$$Vector_reverse$0$Entry_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@8  (=> (and (= inline$$BorrowLoc$0$dst@1@@8 ($Mutation ($Local 2) $EmptyPath v@@19)) (= (ControlFlow 0 57076) 57114)) inline$$ReadRef$0$anon0_correct@@8)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon33_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$1$dst@1)) (= (ControlFlow 0 57082) 57076)) inline$$BorrowLoc$0$anon0_correct@@8)))
(let ((inline$$Le$1$anon0_correct  (=> (= inline$$Le$1$dst@1 ($Boolean (<= (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$TestVector_test_id3_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 57012) 57828) inline$$TestVector_test_id3_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 57012) 57082) inline$$TestVector_test_id3_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Le$1$Entry_correct  (and (=> (= (ControlFlow 0 56998) (- 0 110531)) true) (=> (= (ControlFlow 0 56998) 57012) inline$$Le$1$anon0_correct))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon32_Else_correct  (=> (not (|b#$Boolean| inline$$Le$0$dst@1)) (=> (and (= inline$$TestVector_test_id3_$def_verify$0$$t5@1 ($Integer 3)) (= (ControlFlow 0 57018) 56998)) inline$$Le$1$Entry_correct))))
(let ((inline$$Le$0$anon0_correct  (=> (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$TestVector_test_id3_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 56936) 58589) inline$$TestVector_test_id3_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 56936) 57018) inline$$TestVector_test_id3_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 56922) (- 0 110486)) true) (=> (= (ControlFlow 0 56922) 56936) inline$$Le$0$anon0_correct))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon30_Else_correct  (=> (not false) (=> (and (= inline$$TestVector_test_id3_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 56942) 56922)) inline$$Le$0$Entry_correct))))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon30_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) v@@19) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| v@@19))))) (and (=> (= (ControlFlow 0 56862) 58593) inline$$TestVector_test_id3_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 56862) 56942) inline$$TestVector_test_id3_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 56850) 56862)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 56777) 56850)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 58617) 56850) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$TestVector_test_id3_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 56771) 58617) inline$$TestVector_test_id3_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 56771) 56777) inline$$TestVector_test_id3_$def_verify$0$anon29_Else_correct)))))
(let ((anon0_correct@@12  (=> (and (and (and ((_ is $Vector) v@@19) (let ((va@@23 (|v#$Vector| v@@19)))
(let ((l@@29 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@28))
)))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| v@@19)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@19)) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@19)) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@19)) $$0@@4)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@19)) $$0@@4))
))) (= (ControlFlow 0 56266) 56771)) inline$$TestVector_test_id3_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 110053) 56266) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$ret2@2 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$ret3@2 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$ret4@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$6$vdst'@2| () T@$Value)
(declare-fun call3formal@res1@0 () T@$Value)
(declare-fun call4formal@res2@0 () T@$Value)
(declare-fun call3formal@res1@0@@0 () T@$Value)
(declare-fun call4formal@res2@0@@0 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t26@1 () T@$Value)
(declare-fun call0formal@ta@0 () T@$TypeValue)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t23@1 () T@$Value)
(declare-fun call0formal@ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$6$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$5$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$6$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$6$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1@@1| () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$Vector_reverse$0$ta@0@@1 () T@$TypeValue)
(declare-fun |inline$$WriteRef$5$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$4$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$5$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$5$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$5$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$Vector_push_back$5$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$4$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$3$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToValue$4$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$4$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$4$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$Vector_push_back$4$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$3$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$3$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$3$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@0 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$Vector_push_back$3$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$2$to'@1@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@2 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@4| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@7| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@3| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@4 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@9| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@8 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@9| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@9 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@5| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@9 () T@$Value)
(declare-fun inline$$TestVector_test_index_of_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@3 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@5 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 111388) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 63049) (- 0 114148)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@10)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@10) (and (=> (= (ControlFlow 0 63049) (- 0 114157)) (=> $abort_flag@0@@10 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@10 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 63049) (- 0 114166)) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_index_of_$def_verify$0$$ret1@2 ($Boolean false)))))) (=> (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_index_of_$def_verify$0$$ret1@2 ($Boolean false))))) (and (=> (= (ControlFlow 0 63049) (- 0 114182)) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_index_of_$def_verify$0$$ret2@2 ($Integer 0)))))) (=> (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_index_of_$def_verify$0$$ret2@2 ($Integer 0))))) (and (=> (= (ControlFlow 0 63049) (- 0 114198)) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_index_of_$def_verify$0$$ret3@2 ($Boolean true)))))) (=> (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_index_of_$def_verify$0$$ret3@2 ($Boolean true))))) (and (=> (= (ControlFlow 0 63049) (- 0 114214)) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_index_of_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 1))) ($Integer 7)))))) (=> (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_index_of_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 1))) ($Integer 7))))) (and (=> (= (ControlFlow 0 63049) (- 0 114236)) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_index_of_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 2))) ($Integer 7)))))) (=> (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_index_of_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 2))) ($Integer 7))))) (=> (= (ControlFlow 0 63049) (- 0 114258)) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_index_of_$def_verify$0$$ret4@2 ($Integer 1))))))))))))))))))))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon58_correct  (=> (= $abort_flag@0@@10 false) (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$ret0@2 |inline$$WritebackToValue$6$vdst'@2|) (= inline$$TestVector_test_index_of_$def_verify$0$$ret1@2 call3formal@res1@0)) (=> (and (and (= inline$$TestVector_test_index_of_$def_verify$0$$ret2@2 call4formal@res2@0) (= inline$$TestVector_test_index_of_$def_verify$0$$ret3@2 call3formal@res1@0@@0)) (and (= inline$$TestVector_test_index_of_$def_verify$0$$ret4@2 call4formal@res2@0@@0) (= (ControlFlow 0 62747) 63049))) anon0$2_correct@@11)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 62745) 62747)) inline$$TestVector_test_index_of_$def_verify$0$anon58_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 62755) 62747) inline$$TestVector_test_index_of_$def_verify$0$anon58_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon86_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62735) 62755) inline$$TestVector_test_index_of_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 62735) 62745) inline$$TestVector_test_index_of_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon86_Then_correct  (and (=> (= (ControlFlow 0 62763) 62755) inline$$TestVector_test_index_of_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 62763) 62745) inline$$TestVector_test_index_of_$def_verify$0$anon87_Else_correct))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon85_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62725) 62763) inline$$TestVector_test_index_of_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 62725) 62735) inline$$TestVector_test_index_of_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon85_Then_correct  (and (=> (= (ControlFlow 0 62771) 62763) inline$$TestVector_test_index_of_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 62771) 62735) inline$$TestVector_test_index_of_$def_verify$0$anon86_Else_correct))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon84_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62715) 62771) inline$$TestVector_test_index_of_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 62715) 62725) inline$$TestVector_test_index_of_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon84_Then_correct  (and (=> (= (ControlFlow 0 62779) 62771) inline$$TestVector_test_index_of_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 62779) 62725) inline$$TestVector_test_index_of_$def_verify$0$anon85_Else_correct))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon83_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62705) 62779) inline$$TestVector_test_index_of_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 62705) 62715) inline$$TestVector_test_index_of_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon83_Then_correct  (and (=> (= (ControlFlow 0 62787) 62779) inline$$TestVector_test_index_of_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 62787) 62715) inline$$TestVector_test_index_of_$def_verify$0$anon84_Else_correct))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon82_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62695) 62787) inline$$TestVector_test_index_of_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 62695) 62705) inline$$TestVector_test_index_of_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon82_Then_correct  (and (=> (= (ControlFlow 0 62795) 62787) inline$$TestVector_test_index_of_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 62795) 62705) inline$$TestVector_test_index_of_$def_verify$0$anon83_Else_correct))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62653) 62795) inline$$TestVector_test_index_of_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 62653) 62695) inline$$TestVector_test_index_of_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon81_Then_correct  (and (=> (= (ControlFlow 0 62803) 62795) inline$$TestVector_test_index_of_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 62803) 62695) inline$$TestVector_test_index_of_$def_verify$0$anon82_Else_correct))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon79_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 62645) 62803) inline$$TestVector_test_index_of_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 62645) 62653) inline$$TestVector_test_index_of_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon79_Then_correct true))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon40_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t26@1 ($Integer 7)) (= call0formal@ta@0 $IntegerType)) (and (=> (= (ControlFlow 0 62607) (- 0 113714)) ((_ is $Vector) |inline$$WritebackToValue$6$vdst'@2|)) (=> ((_ is $Vector) |inline$$WritebackToValue$6$vdst'@2|) (=> (and (and (and ((_ is $Boolean) call3formal@res1@0@@0) ((_ is $Integer) call4formal@res2@0@@0)) (and (<= 0 (|i#$Integer| call4formal@res2@0@@0)) (< (|i#$Integer| call4formal@res2@0@@0) (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|))))) (and (and (= call3formal@res1@0@@0 ($Boolean (exists ((i@@12 Int) )  (and (and (<= 0 i@@12) (< i@@12 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)) i@@12) inline$$TestVector_test_index_of_$def_verify$0$$t26@1))))) (=> (|b#$Boolean| call3formal@res1@0@@0) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)) (|i#$Integer| call4formal@res2@0@@0)) inline$$TestVector_test_index_of_$def_verify$0$$t26@1))) (and (=> (|b#$Boolean| call3formal@res1@0@@0) (forall ((i@@13 Int) )  (=> (and (<= 0 i@@13) (< i@@13 (|i#$Integer| call4formal@res2@0@@0))) (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)) i@@13) inline$$TestVector_test_index_of_$def_verify$0$$t26@1))))) (=> (not (|b#$Boolean| call3formal@res1@0@@0)) (= (|i#$Integer| call4formal@res2@0@@0) 0))))) (and (=> (= (ControlFlow 0 62607) 62807) inline$$TestVector_test_index_of_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 62607) 62645) inline$$TestVector_test_index_of_$def_verify$0$anon79_Else_correct))))))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 62601) 62607)) inline$$TestVector_test_index_of_$def_verify$0$anon40_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 62845) 62607) inline$$TestVector_test_index_of_$def_verify$0$anon40_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62559) 62845) inline$$TestVector_test_index_of_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 62559) 62601) inline$$TestVector_test_index_of_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon77_Then_correct  (and (=> (= (ControlFlow 0 62853) 62845) inline$$TestVector_test_index_of_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 62853) 62601) inline$$TestVector_test_index_of_$def_verify$0$anon78_Else_correct))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon75_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 62551) 62853) inline$$TestVector_test_index_of_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 62551) 62559) inline$$TestVector_test_index_of_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon75_Then_correct true))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon73_Else$2_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t23@1 ($Integer 4)) (= call0formal@ta@0@@0 $IntegerType)) (and (=> (= (ControlFlow 0 62513) (- 0 113540)) ((_ is $Vector) |inline$$WritebackToValue$6$vdst'@2|)) (=> ((_ is $Vector) |inline$$WritebackToValue$6$vdst'@2|) (=> (and (and (and ((_ is $Boolean) call3formal@res1@0) ((_ is $Integer) call4formal@res2@0)) (and (<= 0 (|i#$Integer| call4formal@res2@0)) (< (|i#$Integer| call4formal@res2@0) (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|))))) (and (and (= call3formal@res1@0 ($Boolean (exists ((i@@14 Int) )  (and (and (<= 0 i@@14) (< i@@14 (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)) i@@14) inline$$TestVector_test_index_of_$def_verify$0$$t23@1))))) (=> (|b#$Boolean| call3formal@res1@0) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)) (|i#$Integer| call4formal@res2@0)) inline$$TestVector_test_index_of_$def_verify$0$$t23@1))) (and (=> (|b#$Boolean| call3formal@res1@0) (forall ((i@@15 Int) )  (=> (and (<= 0 i@@15) (< i@@15 (|i#$Integer| call4formal@res2@0))) (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$6$vdst'@2|)) i@@15) inline$$TestVector_test_index_of_$def_verify$0$$t23@1))))) (=> (not (|b#$Boolean| call3formal@res1@0)) (= (|i#$Integer| call4formal@res2@0) 0))))) (and (=> (= (ControlFlow 0 62513) 62857) inline$$TestVector_test_index_of_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 62513) 62551) inline$$TestVector_test_index_of_$def_verify$0$anon75_Else_correct))))))))
(let ((inline$$WritebackToValue$6$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$6$to'@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$6$vdst'@2| |inline$$WritebackToValue$5$vdst'@2|) (= (ControlFlow 0 62475) 62513)) inline$$TestVector_test_index_of_$def_verify$0$anon73_Else$2_correct))))
(let ((inline$$WritebackToValue$6$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$6$to'@1|) ($Local 2)) (= |inline$$WritebackToValue$6$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$6$to'@1|) 0 |inline$$WritebackToValue$5$vdst'@2| (|v#$Mutation| |inline$$WriteRef$6$to'@1|)))) (and (= |inline$$WritebackToValue$6$vdst'@2| |inline$$WritebackToValue$6$vdst'@1|) (= (ControlFlow 0 62501) 62513))) inline$$TestVector_test_index_of_$def_verify$0$anon73_Else$2_correct)))
(let ((inline$$WriteRef$6$anon0_correct  (=> (= |inline$$WriteRef$6$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$6$dst@1) (|p#$Mutation| inline$$BorrowLoc$6$dst@1) |inline$$Vector_reverse$0$v'@1@@1|)) (and (=> (= (ControlFlow 0 62376) 62501) inline$$WritebackToValue$6$anon3_Then_correct) (=> (= (ControlFlow 0 62376) 62475) inline$$WritebackToValue$6$anon3_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon73_Else_correct  (=> (and (not false) (= (ControlFlow 0 62382) 62376)) inline$$WriteRef$6$anon0_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon73_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$6$v@1) (= |inline$$Vector_reverse$0$v'@1@@1| ($Vector (let ((l@@30 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1))))
($ValueArray (|lambda#3| 0 l@@30 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1)) l@@30 1 $Error) l@@30))))) (and (=> (= (ControlFlow 0 62311) 62877) inline$$TestVector_test_index_of_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 62311) 62382) inline$$TestVector_test_index_of_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$Vector_reverse$0$Entry_correct@@1  (=> (and (= inline$$Vector_reverse$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 62301) 62311)) inline$$Vector_reverse$0$anon0_correct@@1)))
(let ((inline$$ReadRef$6$anon0_correct  (=> (and (= inline$$ReadRef$6$v@1 (|v#$Mutation| inline$$BorrowLoc$6$dst@1)) (= (ControlFlow 0 62258) 62301)) inline$$Vector_reverse$0$Entry_correct@@1)))
(let ((inline$$BorrowLoc$6$anon0_correct  (=> (and (= inline$$BorrowLoc$6$dst@1 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$5$vdst'@2|)) (= (ControlFlow 0 62220) 62258)) inline$$ReadRef$6$anon0_correct)))
(let ((inline$$WritebackToValue$5$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$5$to'@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$5$vdst'@2| |inline$$WritebackToValue$4$vdst'@2|) (= (ControlFlow 0 62138) 62220)) inline$$BorrowLoc$6$anon0_correct))))
(let ((inline$$WritebackToValue$5$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$5$to'@1|) ($Local 2)) (= |inline$$WritebackToValue$5$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$5$to'@1|) 0 |inline$$WritebackToValue$4$vdst'@2| (|v#$Mutation| |inline$$WriteRef$5$to'@1|)))) (and (= |inline$$WritebackToValue$5$vdst'@2| |inline$$WritebackToValue$5$vdst'@1|) (= (ControlFlow 0 62164) 62220))) inline$$BorrowLoc$6$anon0_correct)))
(let ((inline$$WriteRef$5$anon0_correct  (=> (= |inline$$WriteRef$5$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$5$dst@1) (|p#$Mutation| inline$$BorrowLoc$5$dst@1) |inline$$Vector_push_back$5$v'@1|)) (and (=> (= (ControlFlow 0 62039) 62164) inline$$WritebackToValue$5$anon3_Then_correct) (=> (= (ControlFlow 0 62039) 62138) inline$$WritebackToValue$5$anon3_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon71_Else_correct  (=> (and (not false) (= (ControlFlow 0 62045) 62039)) inline$$WriteRef$5$anon0_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon71_Then_correct true))
(let ((inline$$Vector_push_back$5$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$5$v@1) (= |inline$$Vector_push_back$5$v'@1| ($Vector (let ((len@@9 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) len@@9 inline$$TestVector_test_index_of_$def_verify$0$$t21@1) (+ len@@9 1)))))) (and (=> (= (ControlFlow 0 61974) 62897) inline$$TestVector_test_index_of_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 61974) 62045) inline$$TestVector_test_index_of_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Vector_push_back$5$Entry_correct  (=> (and (= inline$$Vector_push_back$5$ta@0 $IntegerType) (= (ControlFlow 0 61962) 61974)) inline$$Vector_push_back$5$anon0_correct)))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowLoc$5$dst@1)) (= (ControlFlow 0 61911) 61962)) inline$$Vector_push_back$5$Entry_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon69_Else$3_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t21@1 ($Integer 1)) (= (ControlFlow 0 61917) 61911)) inline$$ReadRef$5$anon0_correct)))
(let ((inline$$BorrowLoc$5$anon0_correct  (=> (and (= inline$$BorrowLoc$5$dst@1 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$4$vdst'@2|)) (= (ControlFlow 0 61869) 61917)) inline$$TestVector_test_index_of_$def_verify$0$anon69_Else$3_correct)))
(let ((inline$$WritebackToValue$4$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$4$to'@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$4$vdst'@2| |inline$$WritebackToValue$3$vdst'@2@@0|) (= (ControlFlow 0 61787) 61869)) inline$$BorrowLoc$5$anon0_correct))))
(let ((inline$$WritebackToValue$4$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$4$to'@1|) ($Local 2)) (= |inline$$WritebackToValue$4$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$4$to'@1|) 0 |inline$$WritebackToValue$3$vdst'@2@@0| (|v#$Mutation| |inline$$WriteRef$4$to'@1|)))) (and (= |inline$$WritebackToValue$4$vdst'@2| |inline$$WritebackToValue$4$vdst'@1|) (= (ControlFlow 0 61813) 61869))) inline$$BorrowLoc$5$anon0_correct)))
(let ((inline$$WriteRef$4$anon0_correct  (=> (= |inline$$WriteRef$4$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$4$dst@1) (|p#$Mutation| inline$$BorrowLoc$4$dst@1) |inline$$Vector_push_back$4$v'@1|)) (and (=> (= (ControlFlow 0 61688) 61813) inline$$WritebackToValue$4$anon3_Then_correct) (=> (= (ControlFlow 0 61688) 61787) inline$$WritebackToValue$4$anon3_Else_correct)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon69_Else_correct  (=> (and (not false) (= (ControlFlow 0 61694) 61688)) inline$$WriteRef$4$anon0_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon69_Then_correct true))
(let ((inline$$Vector_push_back$4$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$4$v@1) (= |inline$$Vector_push_back$4$v'@1| ($Vector (let ((len@@10 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) len@@10 inline$$TestVector_test_index_of_$def_verify$0$$t19@1) (+ len@@10 1)))))) (and (=> (= (ControlFlow 0 61623) 62917) inline$$TestVector_test_index_of_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 61623) 61694) inline$$TestVector_test_index_of_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$Vector_push_back$4$Entry_correct  (=> (and (= inline$$Vector_push_back$4$ta@0 $IntegerType) (= (ControlFlow 0 61611) 61623)) inline$$Vector_push_back$4$anon0_correct)))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowLoc$4$dst@1)) (= (ControlFlow 0 61560) 61611)) inline$$Vector_push_back$4$Entry_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon67_Else$3_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t19@1 ($Integer 7)) (= (ControlFlow 0 61566) 61560)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$BorrowLoc$4$anon0_correct  (=> (and (= inline$$BorrowLoc$4$dst@1 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$3$vdst'@2@@0|)) (= (ControlFlow 0 61518) 61566)) inline$$TestVector_test_index_of_$def_verify$0$anon67_Else$3_correct)))
(let ((inline$$WritebackToValue$3$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@0|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$3$vdst'@2@@0| |inline$$WritebackToValue$2$vdst'@2@@1|) (= (ControlFlow 0 61436) 61518)) inline$$BorrowLoc$4$anon0_correct))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@0|) ($Local 2)) (= |inline$$WritebackToValue$3$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1@@0|) 0 |inline$$WritebackToValue$2$vdst'@2@@1| (|v#$Mutation| |inline$$WriteRef$3$to'@1@@0|)))) (and (= |inline$$WritebackToValue$3$vdst'@2@@0| |inline$$WritebackToValue$3$vdst'@1@@0|) (= (ControlFlow 0 61462) 61518))) inline$$BorrowLoc$4$anon0_correct)))
(let ((inline$$WriteRef$3$anon0_correct@@0  (=> (= |inline$$WriteRef$3$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$3$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$3$dst@1@@0) |inline$$Vector_push_back$3$v'@1@@0|)) (and (=> (= (ControlFlow 0 61337) 61462) inline$$WritebackToValue$3$anon3_Then_correct@@0) (=> (= (ControlFlow 0 61337) 61436) inline$$WritebackToValue$3$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon67_Else_correct  (=> (and (not false) (= (ControlFlow 0 61343) 61337)) inline$$WriteRef$3$anon0_correct@@0)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon67_Then_correct true))
(let ((inline$$Vector_push_back$3$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$3$v@1@@0) (= |inline$$Vector_push_back$3$v'@1@@0| ($Vector (let ((len@@11 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@0))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@0)) len@@11 inline$$TestVector_test_index_of_$def_verify$0$$t17@1) (+ len@@11 1)))))) (and (=> (= (ControlFlow 0 61272) 62937) inline$$TestVector_test_index_of_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 61272) 61343) inline$$TestVector_test_index_of_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$Vector_push_back$3$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$3$ta@0@@0 $IntegerType) (= (ControlFlow 0 61260) 61272)) inline$$Vector_push_back$3$anon0_correct@@0)))
(let ((inline$$ReadRef$3$anon0_correct@@0  (=> (and (= inline$$ReadRef$3$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$3$dst@1@@0)) (= (ControlFlow 0 61209) 61260)) inline$$Vector_push_back$3$Entry_correct@@0)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon65_Else$3_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t17@1 ($Integer 7)) (= (ControlFlow 0 61215) 61209)) inline$$ReadRef$3$anon0_correct@@0)))
(let ((inline$$BorrowLoc$3$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$3$dst@1@@0 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$2$vdst'@2@@1|)) (= (ControlFlow 0 61167) 61215)) inline$$TestVector_test_index_of_$def_verify$0$anon65_Else$3_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@2  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@2|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@1| |inline$$WritebackToValue$1$vdst'@2@@2|) (= (ControlFlow 0 61085) 61167)) inline$$BorrowLoc$3$anon0_correct@@0))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@2  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@2|) ($Local 2)) (= |inline$$WritebackToValue$2$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@2|) 0 |inline$$WritebackToValue$1$vdst'@2@@2| (|v#$Mutation| |inline$$WriteRef$2$to'@1@@2|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@1| |inline$$WritebackToValue$2$vdst'@1@@2|) (= (ControlFlow 0 61111) 61167))) inline$$BorrowLoc$3$anon0_correct@@0)))
(let ((inline$$WriteRef$2$anon0_correct@@2  (=> (= |inline$$WriteRef$2$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@2) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@2) |inline$$Vector_push_back$2$v'@1@@0|)) (and (=> (= (ControlFlow 0 60986) 61111) inline$$WritebackToValue$2$anon3_Then_correct@@2) (=> (= (ControlFlow 0 60986) 61085) inline$$WritebackToValue$2$anon3_Else_correct@@2)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon65_Else_correct  (=> (and (not false) (= (ControlFlow 0 60992) 60986)) inline$$WriteRef$2$anon0_correct@@2)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon65_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@2) (= |inline$$Vector_push_back$2$v'@1@@0| ($Vector (let ((len@@12 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@2))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@2)) len@@12 inline$$TestVector_test_index_of_$def_verify$0$$t15@1) (+ len@@12 1)))))) (and (=> (= (ControlFlow 0 60921) 62957) inline$$TestVector_test_index_of_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 60921) 60992) inline$$TestVector_test_index_of_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$2$ta@0@@0 $IntegerType) (= (ControlFlow 0 60909) 60921)) inline$$Vector_push_back$2$anon0_correct@@0)))
(let ((inline$$ReadRef$2$anon0_correct@@2  (=> (and (= inline$$ReadRef$2$v@1@@2 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@2)) (= (ControlFlow 0 60858) 60909)) inline$$Vector_push_back$2$Entry_correct@@0)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon63_Else$3_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t15@1 ($Integer 3)) (= (ControlFlow 0 60864) 60858)) inline$$ReadRef$2$anon0_correct@@2)))
(let ((inline$$BorrowLoc$2$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$2$dst@1@@2 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$1$vdst'@2@@2|)) (= (ControlFlow 0 60816) 60864)) inline$$TestVector_test_index_of_$def_verify$0$anon63_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@2| |inline$$WritebackToValue$0$vdst'@2@@7|) (= (ControlFlow 0 60734) 60816)) inline$$BorrowLoc$2$anon0_correct@@2))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|) ($Local 2)) (= |inline$$WritebackToValue$1$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@4|) 0 |inline$$WritebackToValue$0$vdst'@2@@7| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@4|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@2| |inline$$WritebackToValue$1$vdst'@1@@3|) (= (ControlFlow 0 60760) 60816))) inline$$BorrowLoc$2$anon0_correct@@2)))
(let ((inline$$WriteRef$1$anon0_correct@@4  (=> (= |inline$$WriteRef$1$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@3) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@3) |inline$$Vector_push_back$1$v'@1@@0|)) (and (=> (= (ControlFlow 0 60635) 60760) inline$$WritebackToValue$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 60635) 60734) inline$$WritebackToValue$1$anon3_Else_correct@@3)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon63_Else_correct  (=> (and (not false) (= (ControlFlow 0 60641) 60635)) inline$$WriteRef$1$anon0_correct@@4)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon63_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@4) (= |inline$$Vector_push_back$1$v'@1@@0| ($Vector (let ((len@@13 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@4)) len@@13 inline$$TestVector_test_index_of_$def_verify$0$$t13@1) (+ len@@13 1)))))) (and (=> (= (ControlFlow 0 60570) 62977) inline$$TestVector_test_index_of_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 60570) 60641) inline$$TestVector_test_index_of_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$1$ta@0@@0 $IntegerType) (= (ControlFlow 0 60558) 60570)) inline$$Vector_push_back$1$anon0_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct@@4  (=> (and (= inline$$ReadRef$1$v@1@@4 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@3)) (= (ControlFlow 0 60507) 60558)) inline$$Vector_push_back$1$Entry_correct@@0)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon61_Else$3_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t13@1 ($Integer 2)) (= (ControlFlow 0 60513) 60507)) inline$$ReadRef$1$anon0_correct@@4)))
(let ((inline$$BorrowLoc$1$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$1$dst@1@@3 ($Mutation ($Local 2) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@7|)) (= (ControlFlow 0 60465) 60513)) inline$$TestVector_test_index_of_$def_verify$0$anon61_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@9  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@7| inline$$Vector_empty$0$v@1@@8) (= (ControlFlow 0 60383) 60465)) inline$$BorrowLoc$1$anon0_correct@@3))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@9  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@9| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@9|) 0 inline$$Vector_empty$0$v@1@@8 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@9|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@7| |inline$$WritebackToValue$0$vdst'@1@@9|) (= (ControlFlow 0 60409) 60465))) inline$$BorrowLoc$1$anon0_correct@@3)))
(let ((inline$$WriteRef$0$anon0_correct@@9  (=> (= |inline$$WriteRef$0$to'@1@@9| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@9) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@9) |inline$$Vector_push_back$0$v'@1@@5|)) (and (=> (= (ControlFlow 0 60284) 60409) inline$$WritebackToValue$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 60284) 60383) inline$$WritebackToValue$0$anon3_Else_correct@@9)))))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon61_Else_correct  (=> (and (not false) (= (ControlFlow 0 60290) 60284)) inline$$WriteRef$0$anon0_correct@@9)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon61_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@5  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@9) (= |inline$$Vector_push_back$0$v'@1@@5| ($Vector (let ((len@@14 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) len@@14 inline$$TestVector_test_index_of_$def_verify$0$$t10@1) (+ len@@14 1)))))) (and (=> (= (ControlFlow 0 60219) 62997) inline$$TestVector_test_index_of_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 60219) 60290) inline$$TestVector_test_index_of_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@3  (=> (and (= inline$$Vector_push_back$0$ta@0@@3 $IntegerType) (= (ControlFlow 0 60207) 60219)) inline$$Vector_push_back$0$anon0_correct@@5)))
(let ((inline$$ReadRef$0$anon0_correct@@9  (=> (and (= inline$$ReadRef$0$v@1@@9 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9)) (= (ControlFlow 0 60156) 60207)) inline$$Vector_push_back$0$Entry_correct@@3)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon59_Else$1_correct  (=> (and (= inline$$TestVector_test_index_of_$def_verify$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 60162) 60156)) inline$$ReadRef$0$anon0_correct@@9)))
(let ((inline$$BorrowLoc$0$anon0_correct@@9  (=> (and (= inline$$BorrowLoc$0$dst@1@@9 ($Mutation ($Local 2) $EmptyPath inline$$Vector_empty$0$v@1@@8)) (= (ControlFlow 0 60114) 60162)) inline$$TestVector_test_index_of_$def_verify$0$anon59_Else$1_correct)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon59_Else_correct  (=> (and (not false) (= (ControlFlow 0 60120) 60114)) inline$$BorrowLoc$0$anon0_correct@@9)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon59_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@8  (=> (= inline$$Vector_empty$0$v@1@@8 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 60052) 63017) inline$$TestVector_test_index_of_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 60052) 60120) inline$$TestVector_test_index_of_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@5  (=> (and (= inline$$Vector_empty$0$ta@0@@5 $IntegerType) (= (ControlFlow 0 60048) 60052)) inline$$Vector_empty$0$anon0_correct@@8)))
(let ((inline$$TestVector_test_index_of_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 60058) 60048)) inline$$Vector_empty$0$Entry_correct@@5)))
(let ((anon0_correct@@13  (=> (= (ControlFlow 0 111388) 60058) inline$$TestVector_test_index_of_$def_verify$0$anon0_correct)))
anon0_correct@@13))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@11 () Bool)
(declare-fun inline$$TestVector_test_length1_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_length1_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@0 () T@$Value)
(declare-fun inline$$Vector_length$1$l@1 () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_length$1$ta@0 () T@$TypeValue)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@8| () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@10| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@9 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@10| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@10 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@6| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@10 () T@$Value)
(declare-fun inline$$TestVector_test_length1_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@4 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@6 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 114289) (let ((anon0$2_correct@@12  (=> (= (ControlFlow 0 64825) (- 0 114888)) (=> (not $abort_flag@0@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_length1_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| inline$$TestVector_test_length1_$def_verify$0$$ret1@2) (|i#$Integer| ($Integer 1)))))))))))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon24_correct  (=> (and (and (= $abort_flag@0@@11 false) (= inline$$TestVector_test_length1_$def_verify$0$$ret0@2 inline$$Vector_length$0$l@1@@0)) (and (= inline$$TestVector_test_length1_$def_verify$0$$ret1@2 inline$$Vector_length$1$l@1) (= (ControlFlow 0 64691) 64825))) anon0$2_correct@@12)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 64689) 64691)) inline$$TestVector_test_length1_$def_verify$0$anon24_correct)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 64699) 64691) inline$$TestVector_test_length1_$def_verify$0$anon24_correct)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon35_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 64679) 64699) inline$$TestVector_test_length1_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 64679) 64689) inline$$TestVector_test_length1_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon35_Then_correct  (and (=> (= (ControlFlow 0 64707) 64699) inline$$TestVector_test_length1_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 64707) 64689) inline$$TestVector_test_length1_$def_verify$0$anon36_Else_correct))))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon33_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 64673) 64707) inline$$TestVector_test_length1_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 64673) 64679) inline$$TestVector_test_length1_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon33_Then_correct true))
(let ((inline$$Vector_length$1$anon0_correct  (=> (and ((_ is $Vector) inline$$Vector_empty$1$v@1@@1) (= inline$$Vector_length$1$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1@@1))))) (and (=> (= (ControlFlow 0 64657) 64711) inline$$TestVector_test_length1_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 64657) 64673) inline$$TestVector_test_length1_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Vector_length$1$Entry_correct  (=> (and (= inline$$Vector_length$1$ta@0 $IntegerType) (= (ControlFlow 0 64645) 64657)) inline$$Vector_length$1$anon0_correct)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon31_Else_correct  (=> (and (not false) (= (ControlFlow 0 64663) 64645)) inline$$Vector_length$1$Entry_correct)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon31_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@0  (=> (and ((_ is $Vector) |inline$$WritebackToValue$0$vdst'@2@@8|) (= inline$$Vector_length$0$l@1@@0 ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@8|))))) (and (=> (= (ControlFlow 0 64594) 64739) inline$$TestVector_test_length1_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 64594) 64663) inline$$TestVector_test_length1_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@0  (=> (and (= inline$$Vector_length$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 64582) 64594)) inline$$Vector_length$0$anon0_correct@@0)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@10  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@10|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@8| inline$$Vector_empty$0$v@1@@9) (= (ControlFlow 0 64511) 64582)) inline$$Vector_length$0$Entry_correct@@0))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@10  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@10|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@10| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@10|) 0 inline$$Vector_empty$0$v@1@@9 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@10|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@8| |inline$$WritebackToValue$0$vdst'@1@@10|) (= (ControlFlow 0 64537) 64582))) inline$$Vector_length$0$Entry_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@10  (=> (= |inline$$WriteRef$0$to'@1@@10| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10) |inline$$Vector_push_back$0$v'@1@@6|)) (and (=> (= (ControlFlow 0 64412) 64537) inline$$WritebackToValue$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 64412) 64511) inline$$WritebackToValue$0$anon3_Else_correct@@10)))))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon29_Else_correct  (=> (and (not false) (= (ControlFlow 0 64418) 64412)) inline$$WriteRef$0$anon0_correct@@10)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon29_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@6  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@10) (= |inline$$Vector_push_back$0$v'@1@@6| ($Vector (let ((len@@15 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) len@@15 inline$$TestVector_test_length1_$def_verify$0$$t3@1) (+ len@@15 1)))))) (and (=> (= (ControlFlow 0 64347) 64759) inline$$TestVector_test_length1_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 64347) 64418) inline$$TestVector_test_length1_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@4  (=> (and (= inline$$Vector_push_back$0$ta@0@@4 $IntegerType) (= (ControlFlow 0 64335) 64347)) inline$$Vector_push_back$0$anon0_correct@@6)))
(let ((inline$$ReadRef$0$anon0_correct@@10  (=> (and (= inline$$ReadRef$0$v@1@@10 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10)) (= (ControlFlow 0 64284) 64335)) inline$$Vector_push_back$0$Entry_correct@@4)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon27_Else$1_correct  (=> (and (= inline$$TestVector_test_length1_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 64290) 64284)) inline$$ReadRef$0$anon0_correct@@10)))
(let ((inline$$BorrowLoc$0$anon0_correct@@10  (=> (and (= inline$$BorrowLoc$0$dst@1@@10 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@9)) (= (ControlFlow 0 64242) 64290)) inline$$TestVector_test_length1_$def_verify$0$anon27_Else$1_correct)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon27_Else_correct  (=> (and (not false) (= (ControlFlow 0 64248) 64242)) inline$$BorrowLoc$0$anon0_correct@@10)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon27_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@1  (=> (= inline$$Vector_empty$1$v@1@@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 64180) 64779) inline$$TestVector_test_length1_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 64180) 64248) inline$$TestVector_test_length1_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@0  (=> (and (= inline$$Vector_empty$1$ta@0@@0 $IntegerType) (= (ControlFlow 0 64176) 64180)) inline$$Vector_empty$1$anon0_correct@@1)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon25_Else_correct  (=> (and (not false) (= (ControlFlow 0 64186) 64176)) inline$$Vector_empty$1$Entry_correct@@0)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon25_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@9  (=> (= inline$$Vector_empty$0$v@1@@9 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 64139) 64799) inline$$TestVector_test_length1_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 64139) 64186) inline$$TestVector_test_length1_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@6  (=> (and (= inline$$Vector_empty$0$ta@0@@6 $IntegerType) (= (ControlFlow 0 64135) 64139)) inline$$Vector_empty$0$anon0_correct@@9)))
(let ((inline$$TestVector_test_length1_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 64145) 64135)) inline$$Vector_empty$0$Entry_correct@@6)))
(let ((anon0_correct@@14  (=> (= (ControlFlow 0 114289) 64145) inline$$TestVector_test_length1_$def_verify$0$anon0_correct)))
anon0_correct@@14)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@12 () Bool)
(declare-fun inline$$TestVector_test_length2_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_length2_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@1 () T@$Value)
(declare-fun inline$$Vector_length$1$l@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@2| () T@$Value)
(declare-fun inline$$Vector_length$1$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$2$to'@1@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@3| () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@3| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@1| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@3 () T@$Value)
(declare-fun inline$$TestVector_test_length2_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@1 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@5| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@9| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@4| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@1| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@5 () T@$Value)
(declare-fun inline$$TestVector_test_length2_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@1 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@11| () T@$Mutation)
(declare-fun v@@20 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@11| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@11 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@7| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@11 () T@$Value)
(declare-fun inline$$TestVector_test_length2_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@5 () T@$TypeValue)
(declare-fun inline$$Vector_length$0$ta@0@@1 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 114924) (let ((anon0$2_correct@@13  (=> (= (ControlFlow 0 66910) (- 0 115965)) (=> (not $abort_flag@0@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$TestVector_test_length2_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 3)))) inline$$TestVector_test_length2_$def_verify$0$$ret1@2)))))))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon26_correct  (=> (and (and (= $abort_flag@0@@12 false) (= inline$$TestVector_test_length2_$def_verify$0$$ret0@2 inline$$Vector_length$0$l@1@@1)) (and (= inline$$TestVector_test_length2_$def_verify$0$$ret1@2 inline$$Vector_length$1$l@1@@0) (= (ControlFlow 0 66768) 66910))) anon0$2_correct@@13)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 66766) 66768)) inline$$TestVector_test_length2_$def_verify$0$anon26_correct)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 66776) 66768) inline$$TestVector_test_length2_$def_verify$0$anon26_correct)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon38_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 66756) 66776) inline$$TestVector_test_length2_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 66756) 66766) inline$$TestVector_test_length2_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon38_Then_correct  (and (=> (= (ControlFlow 0 66784) 66776) inline$$TestVector_test_length2_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 66784) 66766) inline$$TestVector_test_length2_$def_verify$0$anon39_Else_correct))))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon36_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 66750) 66784) inline$$TestVector_test_length2_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 66750) 66756) inline$$TestVector_test_length2_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon36_Then_correct true))
(let ((inline$$Vector_length$1$anon0_correct@@0  (=> (and ((_ is $Vector) |inline$$WritebackToValue$2$vdst'@2@@2|) (= inline$$Vector_length$1$l@1@@0 ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@2@@2|))))) (and (=> (= (ControlFlow 0 66734) 66788) inline$$TestVector_test_length2_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 66734) 66750) inline$$TestVector_test_length2_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Vector_length$1$Entry_correct@@0  (=> (and (= inline$$Vector_length$1$ta@0@@0 $IntegerType) (= (ControlFlow 0 66722) 66734)) inline$$Vector_length$1$anon0_correct@@0)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@3|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@2| |inline$$WritebackToValue$1$vdst'@2@@3|) (= (ControlFlow 0 66651) 66722)) inline$$Vector_length$1$Entry_correct@@0))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@3|) ($Local 3)) (= |inline$$WritebackToValue$2$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@3|) 0 |inline$$WritebackToValue$1$vdst'@2@@3| (|v#$Mutation| |inline$$WriteRef$2$to'@1@@3|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@2| |inline$$WritebackToValue$2$vdst'@1@@3|) (= (ControlFlow 0 66677) 66722))) inline$$Vector_length$1$Entry_correct@@0)))
(let ((inline$$WriteRef$2$anon0_correct@@3  (=> (= |inline$$WriteRef$2$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@3) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@3) |inline$$Vector_push_back$2$v'@1@@1|)) (and (=> (= (ControlFlow 0 66552) 66677) inline$$WritebackToValue$2$anon3_Then_correct@@3) (=> (= (ControlFlow 0 66552) 66651) inline$$WritebackToValue$2$anon3_Else_correct@@3)))))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon34_Else_correct  (=> (and (not false) (= (ControlFlow 0 66558) 66552)) inline$$WriteRef$2$anon0_correct@@3)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon34_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@3) (= |inline$$Vector_push_back$2$v'@1@@1| ($Vector (let ((len@@16 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@3))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@3)) len@@16 inline$$TestVector_test_length2_$def_verify$0$$t10@1) (+ len@@16 1)))))) (and (=> (= (ControlFlow 0 66487) 66816) inline$$TestVector_test_length2_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 66487) 66558) inline$$TestVector_test_length2_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@1  (=> (and (= inline$$Vector_push_back$2$ta@0@@1 $IntegerType) (= (ControlFlow 0 66475) 66487)) inline$$Vector_push_back$2$anon0_correct@@1)))
(let ((inline$$ReadRef$2$anon0_correct@@3  (=> (and (= inline$$ReadRef$2$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@3)) (= (ControlFlow 0 66424) 66475)) inline$$Vector_push_back$2$Entry_correct@@1)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon32_Else$3_correct  (=> (and (= inline$$TestVector_test_length2_$def_verify$0$$t10@1 ($Integer 3)) (= (ControlFlow 0 66430) 66424)) inline$$ReadRef$2$anon0_correct@@3)))
(let ((inline$$BorrowLoc$2$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$2$dst@1@@3 ($Mutation ($Local 3) $EmptyPath |inline$$WritebackToValue$1$vdst'@2@@3|)) (= (ControlFlow 0 66382) 66430)) inline$$TestVector_test_length2_$def_verify$0$anon32_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@4  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@5|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@3| |inline$$WritebackToValue$0$vdst'@2@@9|) (= (ControlFlow 0 66300) 66382)) inline$$BorrowLoc$2$anon0_correct@@3))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@4  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@5|) ($Local 3)) (= |inline$$WritebackToValue$1$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@5|) 0 |inline$$WritebackToValue$0$vdst'@2@@9| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@5|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@3| |inline$$WritebackToValue$1$vdst'@1@@4|) (= (ControlFlow 0 66326) 66382))) inline$$BorrowLoc$2$anon0_correct@@3)))
(let ((inline$$WriteRef$1$anon0_correct@@5  (=> (= |inline$$WriteRef$1$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@4) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@4) |inline$$Vector_push_back$1$v'@1@@1|)) (and (=> (= (ControlFlow 0 66201) 66326) inline$$WritebackToValue$1$anon3_Then_correct@@4) (=> (= (ControlFlow 0 66201) 66300) inline$$WritebackToValue$1$anon3_Else_correct@@4)))))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon32_Else_correct  (=> (and (not false) (= (ControlFlow 0 66207) 66201)) inline$$WriteRef$1$anon0_correct@@5)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon32_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@5) (= |inline$$Vector_push_back$1$v'@1@@1| ($Vector (let ((len@@17 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@5)) len@@17 inline$$TestVector_test_length2_$def_verify$0$$t8@1) (+ len@@17 1)))))) (and (=> (= (ControlFlow 0 66136) 66836) inline$$TestVector_test_length2_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 66136) 66207) inline$$TestVector_test_length2_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@1  (=> (and (= inline$$Vector_push_back$1$ta@0@@1 $IntegerType) (= (ControlFlow 0 66124) 66136)) inline$$Vector_push_back$1$anon0_correct@@1)))
(let ((inline$$ReadRef$1$anon0_correct@@5  (=> (and (= inline$$ReadRef$1$v@1@@5 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@4)) (= (ControlFlow 0 66073) 66124)) inline$$Vector_push_back$1$Entry_correct@@1)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon30_Else$3_correct  (=> (and (= inline$$TestVector_test_length2_$def_verify$0$$t8@1 ($Integer 2)) (= (ControlFlow 0 66079) 66073)) inline$$ReadRef$1$anon0_correct@@5)))
(let ((inline$$BorrowLoc$1$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$1$dst@1@@4 ($Mutation ($Local 3) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@9|)) (= (ControlFlow 0 66031) 66079)) inline$$TestVector_test_length2_$def_verify$0$anon30_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@11  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@11|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@9| v@@20) (= (ControlFlow 0 65949) 66031)) inline$$BorrowLoc$1$anon0_correct@@4))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@11  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@11|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1@@11| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@11|) 0 v@@20 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@11|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@9| |inline$$WritebackToValue$0$vdst'@1@@11|) (= (ControlFlow 0 65975) 66031))) inline$$BorrowLoc$1$anon0_correct@@4)))
(let ((inline$$WriteRef$0$anon0_correct@@11  (=> (= |inline$$WriteRef$0$to'@1@@11| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@11) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@11) |inline$$Vector_push_back$0$v'@1@@7|)) (and (=> (= (ControlFlow 0 65850) 65975) inline$$WritebackToValue$0$anon3_Then_correct@@11) (=> (= (ControlFlow 0 65850) 65949) inline$$WritebackToValue$0$anon3_Else_correct@@11)))))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon30_Else_correct  (=> (and (not false) (= (ControlFlow 0 65856) 65850)) inline$$WriteRef$0$anon0_correct@@11)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon30_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@7  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@11) (= |inline$$Vector_push_back$0$v'@1@@7| ($Vector (let ((len@@18 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@11))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@11)) len@@18 inline$$TestVector_test_length2_$def_verify$0$$t5@1) (+ len@@18 1)))))) (and (=> (= (ControlFlow 0 65785) 66856) inline$$TestVector_test_length2_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 65785) 65856) inline$$TestVector_test_length2_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@5  (=> (and (= inline$$Vector_push_back$0$ta@0@@5 $IntegerType) (= (ControlFlow 0 65773) 65785)) inline$$Vector_push_back$0$anon0_correct@@7)))
(let ((inline$$ReadRef$0$anon0_correct@@11  (=> (and (= inline$$ReadRef$0$v@1@@11 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@11)) (= (ControlFlow 0 65722) 65773)) inline$$Vector_push_back$0$Entry_correct@@5)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon28_Else$1_correct  (=> (and (= inline$$TestVector_test_length2_$def_verify$0$$t5@1 ($Integer 1)) (= (ControlFlow 0 65728) 65722)) inline$$ReadRef$0$anon0_correct@@11)))
(let ((inline$$BorrowLoc$0$anon0_correct@@11  (=> (and (= inline$$BorrowLoc$0$dst@1@@11 ($Mutation ($Local 3) $EmptyPath v@@20)) (= (ControlFlow 0 65680) 65728)) inline$$TestVector_test_length2_$def_verify$0$anon28_Else$1_correct)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon28_Else_correct  (=> (and (not false) (= (ControlFlow 0 65686) 65680)) inline$$BorrowLoc$0$anon0_correct@@11)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon28_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@1  (=> (and ((_ is $Vector) v@@20) (= inline$$Vector_length$0$l@1@@1 ($Integer (|l#$ValueArray| (|v#$Vector| v@@20))))) (and (=> (= (ControlFlow 0 65618) 66876) inline$$TestVector_test_length2_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 65618) 65686) inline$$TestVector_test_length2_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@1  (=> (and (= inline$$Vector_length$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 65606) 65618)) inline$$Vector_length$0$anon0_correct@@1)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 65533) 65606)) inline$$Vector_length$0$Entry_correct@@1)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 66900) 65606) inline$$Vector_length$0$Entry_correct@@1)))
(let ((inline$$TestVector_test_length2_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 65527) 66900) inline$$TestVector_test_length2_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 65527) 65533) inline$$TestVector_test_length2_$def_verify$0$anon27_Else_correct)))))
(let ((anon0_correct@@15  (=> (and (and (and ((_ is $Vector) v@@20) (let ((va@@24 (|v#$Vector| v@@20)))
(let ((l@@31 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@29))
)))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| v@@20)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@20)) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@20)) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@20)) $$0@@5)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@20)) $$0@@5))
))) (= (ControlFlow 0 65048) 65527)) inline$$TestVector_test_length2_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 114924) 65048) anon0_correct@@15)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@13 () Bool)
(declare-fun v@@21 () T@$Value)
(declare-fun inline$$TestVector_test_length3_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_length3_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@2 () T@$Value)
(declare-fun inline$$Vector_length$1$l@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@10| () T@$Value)
(declare-fun inline$$Vector_length$1$ta@0@@1 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@12| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@12| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@12 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@8| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@12 () T@$Value)
(declare-fun inline$$TestVector_test_length3_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@6 () T@$TypeValue)
(declare-fun inline$$Vector_length$0$ta@0@@2 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 116001) (let ((anon0$2_correct@@14  (and (=> (= (ControlFlow 0 68253) (- 0 116637)) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@21))) inline$$TestVector_test_length3_$def_verify$0$$ret0@2))))) (=> (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@21))) inline$$TestVector_test_length3_$def_verify$0$$ret0@2)))) (and (=> (= (ControlFlow 0 68253) (- 0 116653)) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$TestVector_test_length3_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 1)))) inline$$TestVector_test_length3_$def_verify$0$$ret1@2))))) (=> (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$TestVector_test_length3_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 1)))) inline$$TestVector_test_length3_$def_verify$0$$ret1@2)))) (and (=> (= (ControlFlow 0 68253) (- 0 116678)) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified v@@21 v@@21))))) (=> (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified v@@21 v@@21)))) (=> (= (ControlFlow 0 68253) (- 0 116693)) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@21))) inline$$TestVector_test_length3_$def_verify$0$$ret1@2))))))))))))))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon18_correct  (=> (and (and (= $abort_flag@0@@13 false) (= inline$$TestVector_test_length3_$def_verify$0$$ret0@2 inline$$Vector_length$0$l@1@@2)) (and (= inline$$TestVector_test_length3_$def_verify$0$$ret1@2 inline$$Vector_length$1$l@1@@1) (= (ControlFlow 0 68151) 68253))) anon0$2_correct@@14)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 68149) 68151)) inline$$TestVector_test_length3_$def_verify$0$anon18_correct)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 68159) 68151) inline$$TestVector_test_length3_$def_verify$0$anon18_correct)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon26_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 68139) 68159) inline$$TestVector_test_length3_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 68139) 68149) inline$$TestVector_test_length3_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon26_Then_correct  (and (=> (= (ControlFlow 0 68167) 68159) inline$$TestVector_test_length3_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 68167) 68149) inline$$TestVector_test_length3_$def_verify$0$anon27_Else_correct))))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon24_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 68133) 68167) inline$$TestVector_test_length3_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 68133) 68139) inline$$TestVector_test_length3_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon24_Then_correct true))
(let ((inline$$Vector_length$1$anon0_correct@@1  (=> (and ((_ is $Vector) |inline$$WritebackToValue$0$vdst'@2@@10|) (= inline$$Vector_length$1$l@1@@1 ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2@@10|))))) (and (=> (= (ControlFlow 0 68117) 68171) inline$$TestVector_test_length3_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 68117) 68133) inline$$TestVector_test_length3_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Vector_length$1$Entry_correct@@1  (=> (and (= inline$$Vector_length$1$ta@0@@1 $IntegerType) (= (ControlFlow 0 68105) 68117)) inline$$Vector_length$1$anon0_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@12  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@12|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@10| v@@21) (= (ControlFlow 0 68034) 68105)) inline$$Vector_length$1$Entry_correct@@1))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@12  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@12|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@12| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@12|) 0 v@@21 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@12|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@10| |inline$$WritebackToValue$0$vdst'@1@@12|) (= (ControlFlow 0 68060) 68105))) inline$$Vector_length$1$Entry_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@12  (=> (= |inline$$WriteRef$0$to'@1@@12| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@12) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@12) |inline$$Vector_push_back$0$v'@1@@8|)) (and (=> (= (ControlFlow 0 67935) 68060) inline$$WritebackToValue$0$anon3_Then_correct@@12) (=> (= (ControlFlow 0 67935) 68034) inline$$WritebackToValue$0$anon3_Else_correct@@12)))))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon22_Else_correct  (=> (and (not false) (= (ControlFlow 0 67941) 67935)) inline$$WriteRef$0$anon0_correct@@12)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon22_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@8  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@12) (= |inline$$Vector_push_back$0$v'@1@@8| ($Vector (let ((len@@19 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@12))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@12)) len@@19 inline$$TestVector_test_length3_$def_verify$0$$t4@1) (+ len@@19 1)))))) (and (=> (= (ControlFlow 0 67870) 68199) inline$$TestVector_test_length3_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 67870) 67941) inline$$TestVector_test_length3_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@6  (=> (and (= inline$$Vector_push_back$0$ta@0@@6 $IntegerType) (= (ControlFlow 0 67858) 67870)) inline$$Vector_push_back$0$anon0_correct@@8)))
(let ((inline$$ReadRef$0$anon0_correct@@12  (=> (and (= inline$$ReadRef$0$v@1@@12 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@12)) (= (ControlFlow 0 67807) 67858)) inline$$Vector_push_back$0$Entry_correct@@6)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon20_Else$1_correct  (=> (and (= inline$$TestVector_test_length3_$def_verify$0$$t4@1 ($Integer 1)) (= (ControlFlow 0 67813) 67807)) inline$$ReadRef$0$anon0_correct@@12)))
(let ((inline$$BorrowLoc$0$anon0_correct@@12  (=> (and (= inline$$BorrowLoc$0$dst@1@@12 ($Mutation ($Local 2) $EmptyPath v@@21)) (= (ControlFlow 0 67765) 67813)) inline$$TestVector_test_length3_$def_verify$0$anon20_Else$1_correct)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon20_Else_correct  (=> (and (not false) (= (ControlFlow 0 67771) 67765)) inline$$BorrowLoc$0$anon0_correct@@12)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon20_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@2  (=> (and ((_ is $Vector) v@@21) (= inline$$Vector_length$0$l@1@@2 ($Integer (|l#$ValueArray| (|v#$Vector| v@@21))))) (and (=> (= (ControlFlow 0 67703) 68219) inline$$TestVector_test_length3_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 67703) 67771) inline$$TestVector_test_length3_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@2  (=> (and (= inline$$Vector_length$0$ta@0@@2 $IntegerType) (= (ControlFlow 0 67691) 67703)) inline$$Vector_length$0$anon0_correct@@2)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 67618) 67691)) inline$$Vector_length$0$Entry_correct@@2)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 68243) 67691) inline$$Vector_length$0$Entry_correct@@2)))
(let ((inline$$TestVector_test_length3_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 67612) 68243) inline$$TestVector_test_length3_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 67612) 67618) inline$$TestVector_test_length3_$def_verify$0$anon19_Else_correct)))))
(let ((anon0_correct@@16  (=> (and (and (and ((_ is $Vector) v@@21) (let ((va@@25 (|v#$Vector| v@@21)))
(let ((l@@32 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@30))
)))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| v@@21)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@21)) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@21)) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@21)) $$0@@6)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@21)) $$0@@6))
))) (= (ControlFlow 0 67281) 67612)) inline$$TestVector_test_length3_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 116001) 67281) anon0_correct@@16)))
PreconditionGeneratedEntry_correct@@6))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@14 () Bool)
(declare-fun v@@22 () T@$Value)
(declare-fun inline$$TestVector_test_length4_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_length4_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestVector_test_length4_$def_verify$0$$ret2@2 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@3 () T@$Value)
(declare-fun inline$$Vector_length$1$l@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@11| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@4 () T@$Value)
(declare-fun inline$$Vector_length$1$ta@0@@2 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@13| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@13| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@13 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@9| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@6 () T@$Value)
(declare-fun inline$$TestVector_test_length4_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@7 () T@$TypeValue)
(declare-fun inline$$ReadRef$0$v@1@@13 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@3 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 116721) (let ((anon0$2_correct@@15  (and (=> (= (ControlFlow 0 69598) (- 0 117450)) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@22))) inline$$TestVector_test_length4_$def_verify$0$$ret0@2))))) (=> (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@22))) inline$$TestVector_test_length4_$def_verify$0$$ret0@2)))) (and (=> (= (ControlFlow 0 69598) (- 0 117466)) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$TestVector_test_length4_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 1)))) inline$$TestVector_test_length4_$def_verify$0$$ret1@2))))) (=> (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$TestVector_test_length4_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 1)))) inline$$TestVector_test_length4_$def_verify$0$$ret1@2)))) (and (=> (= (ControlFlow 0 69598) (- 0 117491)) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_length4_$def_verify$0$$ret2@2 v@@22)))))) (=> (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_length4_$def_verify$0$$ret2@2 v@@22))))) (=> (= (ControlFlow 0 69598) (- 0 117507)) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_length4_$def_verify$0$$ret2@2))) inline$$TestVector_test_length4_$def_verify$0$$ret1@2)))))))))))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon20_correct  (=> (= $abort_flag@0@@14 false) (=> (and (and (= inline$$TestVector_test_length4_$def_verify$0$$ret0@2 inline$$Vector_length$0$l@1@@3) (= inline$$TestVector_test_length4_$def_verify$0$$ret1@2 inline$$Vector_length$1$l@1@@2)) (and (= inline$$TestVector_test_length4_$def_verify$0$$ret2@2 |inline$$WritebackToValue$0$vdst'@2@@11|) (= (ControlFlow 0 69484) 69598))) anon0$2_correct@@15))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 69482) 69484)) inline$$TestVector_test_length4_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 69492) 69484) inline$$TestVector_test_length4_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 69472) 69492) inline$$TestVector_test_length4_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 69472) 69482) inline$$TestVector_test_length4_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 69500) 69492) inline$$TestVector_test_length4_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 69500) 69482) inline$$TestVector_test_length4_$def_verify$0$anon30_Else_correct))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon28_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 69462) 69500) inline$$TestVector_test_length4_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 69462) 69472) inline$$TestVector_test_length4_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon28_Then_correct  (and (=> (= (ControlFlow 0 69508) 69500) inline$$TestVector_test_length4_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 69508) 69472) inline$$TestVector_test_length4_$def_verify$0$anon29_Else_correct))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon26_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 69456) 69508) inline$$TestVector_test_length4_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 69456) 69462) inline$$TestVector_test_length4_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon26_Then_correct true))
(let ((inline$$Vector_length$1$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@4) (= inline$$Vector_length$1$l@1@@2 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@4))))) (and (=> (= (ControlFlow 0 69440) 69512) inline$$TestVector_test_length4_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 69440) 69456) inline$$TestVector_test_length4_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Vector_length$1$Entry_correct@@2  (=> (and (= inline$$Vector_length$1$ta@0@@2 $IntegerType) (= (ControlFlow 0 69428) 69440)) inline$$Vector_length$1$anon0_correct@@2)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@13  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@13|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@11| v@@22) (= (ControlFlow 0 69357) 69428)) inline$$Vector_length$1$Entry_correct@@2))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@13  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@13|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@13| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@13|) 0 v@@22 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@13|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@11| |inline$$WritebackToValue$0$vdst'@1@@13|) (= (ControlFlow 0 69383) 69428))) inline$$Vector_length$1$Entry_correct@@2)))
(let ((inline$$ReadRef$2$anon0_correct@@4  (=> (= inline$$ReadRef$2$v@1@@4 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@13|)) (and (=> (= (ControlFlow 0 69258) 69383) inline$$WritebackToValue$0$anon3_Then_correct@@13) (=> (= (ControlFlow 0 69258) 69357) inline$$WritebackToValue$0$anon3_Else_correct@@13)))))
(let ((inline$$WriteRef$0$anon0_correct@@13  (=> (and (= |inline$$WriteRef$0$to'@1@@13| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@13) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@13) |inline$$Vector_push_back$0$v'@1@@9|)) (= (ControlFlow 0 69220) 69258)) inline$$ReadRef$2$anon0_correct@@4)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon24_Else_correct  (=> (and (not false) (= (ControlFlow 0 69226) 69220)) inline$$WriteRef$0$anon0_correct@@13)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon24_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@9  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@6) (= |inline$$Vector_push_back$0$v'@1@@9| ($Vector (let ((len@@20 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@6))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@6)) len@@20 inline$$TestVector_test_length4_$def_verify$0$$t5@1) (+ len@@20 1)))))) (and (=> (= (ControlFlow 0 69155) 69542) inline$$TestVector_test_length4_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 69155) 69226) inline$$TestVector_test_length4_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@7  (=> (and (= inline$$Vector_push_back$0$ta@0@@7 $IntegerType) (= (ControlFlow 0 69143) 69155)) inline$$Vector_push_back$0$anon0_correct@@9)))
(let ((inline$$ReadRef$1$anon0_correct@@6  (=> (and (= inline$$ReadRef$1$v@1@@6 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@13)) (= (ControlFlow 0 69092) 69143)) inline$$Vector_push_back$0$Entry_correct@@7)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon22_Else_correct  (=> (not false) (=> (and (= inline$$TestVector_test_length4_$def_verify$0$$t5@1 ($Integer 1)) (= (ControlFlow 0 69098) 69092)) inline$$ReadRef$1$anon0_correct@@6))))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon22_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@13) (= inline$$Vector_length$0$l@1@@3 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@13))))) (and (=> (= (ControlFlow 0 69044) 69562) inline$$TestVector_test_length4_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 69044) 69098) inline$$TestVector_test_length4_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@3  (=> (and (= inline$$Vector_length$0$ta@0@@3 $IntegerType) (= (ControlFlow 0 69032) 69044)) inline$$Vector_length$0$anon0_correct@@3)))
(let ((inline$$ReadRef$0$anon0_correct@@13  (=> (and (= inline$$ReadRef$0$v@1@@13 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@13)) (= (ControlFlow 0 68987) 69032)) inline$$Vector_length$0$Entry_correct@@3)))
(let ((inline$$BorrowLoc$0$anon0_correct@@13  (=> (and (= inline$$BorrowLoc$0$dst@1@@13 ($Mutation ($Local 2) $EmptyPath v@@22)) (= (ControlFlow 0 68949) 68987)) inline$$ReadRef$0$anon0_correct@@13)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 68865) 68949)) inline$$BorrowLoc$0$anon0_correct@@13)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 69586) 68949) inline$$BorrowLoc$0$anon0_correct@@13)))
(let ((inline$$TestVector_test_length4_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 68859) 69586) inline$$TestVector_test_length4_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 68859) 68865) inline$$TestVector_test_length4_$def_verify$0$anon21_Else_correct)))))
(let ((anon0_correct@@17  (=> (and (and (and ((_ is $Vector) v@@22) (let ((va@@26 (|v#$Vector| v@@22)))
(let ((l@@33 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@31))
)))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| v@@22)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) $$0@@7)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) $$0@@7))
))) (= (ControlFlow 0 68480) 68859)) inline$$TestVector_test_length4_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 116721) 68480) anon0_correct@@17)))
PreconditionGeneratedEntry_correct@@7)))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@15 () Bool)
(declare-fun inline$$TestVector_test_neq1_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_neq1_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@4| () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@3| () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1@@4| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@4| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@2| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@5 () T@$Value)
(declare-fun inline$$TestVector_test_neq1_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@2 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@6| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@12| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@5| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@5 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@2| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@7 () T@$Value)
(declare-fun inline$$TestVector_test_neq1_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@2 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@14| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@10 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@14| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@14 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@10| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@14 () T@$Value)
(declare-fun inline$$TestVector_test_neq1_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@8 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@1 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@7 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 117530) (let ((anon0$2_correct@@16  (=> (= (ControlFlow 0 71544) (- 0 118463)) (=> (not $abort_flag@0@@15) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_neq1_$def_verify$0$$ret0@2 inline$$TestVector_test_neq1_$def_verify$0$$ret1@2))))))))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon24_correct  (=> (and (and (= $abort_flag@0@@15 false) (= inline$$TestVector_test_neq1_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@4|)) (and (= inline$$TestVector_test_neq1_$def_verify$0$$ret1@2 |inline$$WritebackToValue$2$vdst'@2@@3|) (= (ControlFlow 0 71410) 71544))) anon0$2_correct@@16)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 71408) 71410)) inline$$TestVector_test_neq1_$def_verify$0$anon24_correct)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 71418) 71410) inline$$TestVector_test_neq1_$def_verify$0$anon24_correct)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon35_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 71398) 71418) inline$$TestVector_test_neq1_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 71398) 71408) inline$$TestVector_test_neq1_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon35_Then_correct  (and (=> (= (ControlFlow 0 71426) 71418) inline$$TestVector_test_neq1_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 71426) 71408) inline$$TestVector_test_neq1_$def_verify$0$anon36_Else_correct))))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@4  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@4|) ($Local 1))) (= |inline$$WritebackToValue$2$vdst'@2@@3| inline$$Vector_empty$1$v@1@@2)) (and (=> (= (ControlFlow 0 71356) 71426) inline$$TestVector_test_neq1_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 71356) 71398) inline$$TestVector_test_neq1_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@4  (=> (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@4|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$2$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@4|) 0 inline$$Vector_empty$1$v@1@@2 (|v#$Mutation| |inline$$WriteRef$2$to'@1@@4|))) (= |inline$$WritebackToValue$2$vdst'@2@@3| |inline$$WritebackToValue$2$vdst'@1@@4|)) (and (=> (= (ControlFlow 0 71382) 71426) inline$$TestVector_test_neq1_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 71382) 71398) inline$$TestVector_test_neq1_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$WriteRef$2$anon0_correct@@4  (=> (= |inline$$WriteRef$2$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@4) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@4) |inline$$Vector_push_back$2$v'@1@@2|)) (and (=> (= (ControlFlow 0 71257) 71382) inline$$WritebackToValue$2$anon3_Then_correct@@4) (=> (= (ControlFlow 0 71257) 71356) inline$$WritebackToValue$2$anon3_Else_correct@@4)))))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon33_Else_correct  (=> (and (not false) (= (ControlFlow 0 71263) 71257)) inline$$WriteRef$2$anon0_correct@@4)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon33_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@5) (= |inline$$Vector_push_back$2$v'@1@@2| ($Vector (let ((len@@21 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@5)) len@@21 inline$$TestVector_test_neq1_$def_verify$0$$t8@1) (+ len@@21 1)))))) (and (=> (= (ControlFlow 0 71192) 71430) inline$$TestVector_test_neq1_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 71192) 71263) inline$$TestVector_test_neq1_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@2  (=> (and (= inline$$Vector_push_back$2$ta@0@@2 $IntegerType) (= (ControlFlow 0 71180) 71192)) inline$$Vector_push_back$2$anon0_correct@@2)))
(let ((inline$$ReadRef$2$anon0_correct@@5  (=> (and (= inline$$ReadRef$2$v@1@@5 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@4)) (= (ControlFlow 0 71129) 71180)) inline$$Vector_push_back$2$Entry_correct@@2)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon31_Else$3_correct  (=> (and (= inline$$TestVector_test_neq1_$def_verify$0$$t8@1 ($Integer 1)) (= (ControlFlow 0 71135) 71129)) inline$$ReadRef$2$anon0_correct@@5)))
(let ((inline$$BorrowLoc$2$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$2$dst@1@@4 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1@@2)) (= (ControlFlow 0 71087) 71135)) inline$$TestVector_test_neq1_$def_verify$0$anon31_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@5  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@6|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@4| |inline$$WritebackToValue$0$vdst'@2@@12|) (= (ControlFlow 0 71005) 71087)) inline$$BorrowLoc$2$anon0_correct@@4))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@5  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@6|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@6|) 0 |inline$$WritebackToValue$0$vdst'@2@@12| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@6|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@4| |inline$$WritebackToValue$1$vdst'@1@@5|) (= (ControlFlow 0 71031) 71087))) inline$$BorrowLoc$2$anon0_correct@@4)))
(let ((inline$$WriteRef$1$anon0_correct@@6  (=> (= |inline$$WriteRef$1$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@5) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@5) |inline$$Vector_push_back$1$v'@1@@2|)) (and (=> (= (ControlFlow 0 70906) 71031) inline$$WritebackToValue$1$anon3_Then_correct@@5) (=> (= (ControlFlow 0 70906) 71005) inline$$WritebackToValue$1$anon3_Else_correct@@5)))))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon31_Else_correct  (=> (and (not false) (= (ControlFlow 0 70912) 70906)) inline$$WriteRef$1$anon0_correct@@6)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon31_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@7) (= |inline$$Vector_push_back$1$v'@1@@2| ($Vector (let ((len@@22 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@7))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@7)) len@@22 inline$$TestVector_test_neq1_$def_verify$0$$t6@1) (+ len@@22 1)))))) (and (=> (= (ControlFlow 0 70841) 71458) inline$$TestVector_test_neq1_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 70841) 70912) inline$$TestVector_test_neq1_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@2  (=> (and (= inline$$Vector_push_back$1$ta@0@@2 $IntegerType) (= (ControlFlow 0 70829) 70841)) inline$$Vector_push_back$1$anon0_correct@@2)))
(let ((inline$$ReadRef$1$anon0_correct@@7  (=> (and (= inline$$ReadRef$1$v@1@@7 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@5)) (= (ControlFlow 0 70778) 70829)) inline$$Vector_push_back$1$Entry_correct@@2)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon29_Else$3_correct  (=> (and (= inline$$TestVector_test_neq1_$def_verify$0$$t6@1 ($Integer 2)) (= (ControlFlow 0 70784) 70778)) inline$$ReadRef$1$anon0_correct@@7)))
(let ((inline$$BorrowLoc$1$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$1$dst@1@@5 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@12|)) (= (ControlFlow 0 70736) 70784)) inline$$TestVector_test_neq1_$def_verify$0$anon29_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@14  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@14|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@12| inline$$Vector_empty$0$v@1@@10) (= (ControlFlow 0 70654) 70736)) inline$$BorrowLoc$1$anon0_correct@@5))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@14  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@14|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@14| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@14|) 0 inline$$Vector_empty$0$v@1@@10 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@14|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@12| |inline$$WritebackToValue$0$vdst'@1@@14|) (= (ControlFlow 0 70680) 70736))) inline$$BorrowLoc$1$anon0_correct@@5)))
(let ((inline$$WriteRef$0$anon0_correct@@14  (=> (= |inline$$WriteRef$0$to'@1@@14| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@14) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@14) |inline$$Vector_push_back$0$v'@1@@10|)) (and (=> (= (ControlFlow 0 70555) 70680) inline$$WritebackToValue$0$anon3_Then_correct@@14) (=> (= (ControlFlow 0 70555) 70654) inline$$WritebackToValue$0$anon3_Else_correct@@14)))))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon29_Else_correct  (=> (and (not false) (= (ControlFlow 0 70561) 70555)) inline$$WriteRef$0$anon0_correct@@14)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon29_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@10  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@14) (= |inline$$Vector_push_back$0$v'@1@@10| ($Vector (let ((len@@23 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@14))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@14)) len@@23 inline$$TestVector_test_neq1_$def_verify$0$$t3@1) (+ len@@23 1)))))) (and (=> (= (ControlFlow 0 70490) 71478) inline$$TestVector_test_neq1_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 70490) 70561) inline$$TestVector_test_neq1_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@8  (=> (and (= inline$$Vector_push_back$0$ta@0@@8 $IntegerType) (= (ControlFlow 0 70478) 70490)) inline$$Vector_push_back$0$anon0_correct@@10)))
(let ((inline$$ReadRef$0$anon0_correct@@14  (=> (and (= inline$$ReadRef$0$v@1@@14 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@14)) (= (ControlFlow 0 70427) 70478)) inline$$Vector_push_back$0$Entry_correct@@8)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon27_Else$1_correct  (=> (and (= inline$$TestVector_test_neq1_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 70433) 70427)) inline$$ReadRef$0$anon0_correct@@14)))
(let ((inline$$BorrowLoc$0$anon0_correct@@14  (=> (and (= inline$$BorrowLoc$0$dst@1@@14 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@10)) (= (ControlFlow 0 70385) 70433)) inline$$TestVector_test_neq1_$def_verify$0$anon27_Else$1_correct)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon27_Else_correct  (=> (and (not false) (= (ControlFlow 0 70391) 70385)) inline$$BorrowLoc$0$anon0_correct@@14)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon27_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@2  (=> (= inline$$Vector_empty$1$v@1@@2 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 70323) 71498) inline$$TestVector_test_neq1_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 70323) 70391) inline$$TestVector_test_neq1_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@1  (=> (and (= inline$$Vector_empty$1$ta@0@@1 $IntegerType) (= (ControlFlow 0 70319) 70323)) inline$$Vector_empty$1$anon0_correct@@2)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon25_Else_correct  (=> (and (not false) (= (ControlFlow 0 70329) 70319)) inline$$Vector_empty$1$Entry_correct@@1)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon25_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@10  (=> (= inline$$Vector_empty$0$v@1@@10 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 70282) 71518) inline$$TestVector_test_neq1_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 70282) 70329) inline$$TestVector_test_neq1_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@7  (=> (and (= inline$$Vector_empty$0$ta@0@@7 $IntegerType) (= (ControlFlow 0 70278) 70282)) inline$$Vector_empty$0$anon0_correct@@10)))
(let ((inline$$TestVector_test_neq1_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 70288) 70278)) inline$$Vector_empty$0$Entry_correct@@7)))
(let ((anon0_correct@@18  (=> (= (ControlFlow 0 117530) 70288) inline$$TestVector_test_neq1_$def_verify$0$anon0_correct)))
anon0_correct@@18)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@16 () Bool)
(declare-fun inline$$TestVector_test_neq2_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_neq2_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@13| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@5| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@7| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@6| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@6 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@3| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@8 () T@$Value)
(declare-fun inline$$TestVector_test_neq2_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@3 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@15| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@11 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@15| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@15 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@11| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@15 () T@$Value)
(declare-fun inline$$TestVector_test_neq2_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@9 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@2 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@8 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 118488) (let ((anon0$2_correct@@17  (=> (= (ControlFlow 0 73124) (- 0 119192)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_neq2_$def_verify$0$$ret0@2 inline$$TestVector_test_neq2_$def_verify$0$$ret1@2))))))))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon20_correct  (=> (and (and (= $abort_flag@0@@16 false) (= inline$$TestVector_test_neq2_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@13|)) (and (= inline$$TestVector_test_neq2_$def_verify$0$$ret1@2 |inline$$WritebackToValue$1$vdst'@2@@5|) (= (ControlFlow 0 73010) 73124))) anon0$2_correct@@17)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 73008) 73010)) inline$$TestVector_test_neq2_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 73018) 73010) inline$$TestVector_test_neq2_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 72998) 73018) inline$$TestVector_test_neq2_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 72998) 73008) inline$$TestVector_test_neq2_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 73026) 73018) inline$$TestVector_test_neq2_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 73026) 73008) inline$$TestVector_test_neq2_$def_verify$0$anon30_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@6  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@7|) ($Local 1))) (= |inline$$WritebackToValue$1$vdst'@2@@5| inline$$Vector_empty$1$v@1@@3)) (and (=> (= (ControlFlow 0 72956) 73026) inline$$TestVector_test_neq2_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 72956) 72998) inline$$TestVector_test_neq2_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@6  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@7|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@6| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@7|) 0 inline$$Vector_empty$1$v@1@@3 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@7|))) (= |inline$$WritebackToValue$1$vdst'@2@@5| |inline$$WritebackToValue$1$vdst'@1@@6|)) (and (=> (= (ControlFlow 0 72982) 73026) inline$$TestVector_test_neq2_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 72982) 72998) inline$$TestVector_test_neq2_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct@@7  (=> (= |inline$$WriteRef$1$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@6) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@6) |inline$$Vector_push_back$1$v'@1@@3|)) (and (=> (= (ControlFlow 0 72857) 72982) inline$$WritebackToValue$1$anon3_Then_correct@@6) (=> (= (ControlFlow 0 72857) 72956) inline$$WritebackToValue$1$anon3_Else_correct@@6)))))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon27_Else_correct  (=> (and (not false) (= (ControlFlow 0 72863) 72857)) inline$$WriteRef$1$anon0_correct@@7)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon27_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@8) (= |inline$$Vector_push_back$1$v'@1@@3| ($Vector (let ((len@@24 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@8))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@8)) len@@24 inline$$TestVector_test_neq2_$def_verify$0$$t6@1) (+ len@@24 1)))))) (and (=> (= (ControlFlow 0 72792) 73030) inline$$TestVector_test_neq2_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 72792) 72863) inline$$TestVector_test_neq2_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@3  (=> (and (= inline$$Vector_push_back$1$ta@0@@3 $IntegerType) (= (ControlFlow 0 72780) 72792)) inline$$Vector_push_back$1$anon0_correct@@3)))
(let ((inline$$ReadRef$1$anon0_correct@@8  (=> (and (= inline$$ReadRef$1$v@1@@8 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@6)) (= (ControlFlow 0 72729) 72780)) inline$$Vector_push_back$1$Entry_correct@@3)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon25_Else$3_correct  (=> (and (= inline$$TestVector_test_neq2_$def_verify$0$$t6@1 ($Integer 0)) (= (ControlFlow 0 72735) 72729)) inline$$ReadRef$1$anon0_correct@@8)))
(let ((inline$$BorrowLoc$1$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$1$dst@1@@6 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1@@3)) (= (ControlFlow 0 72687) 72735)) inline$$TestVector_test_neq2_$def_verify$0$anon25_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@15  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@15|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@13| inline$$Vector_empty$0$v@1@@11) (= (ControlFlow 0 72605) 72687)) inline$$BorrowLoc$1$anon0_correct@@6))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@15  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@15|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@15| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@15|) 0 inline$$Vector_empty$0$v@1@@11 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@15|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@13| |inline$$WritebackToValue$0$vdst'@1@@15|) (= (ControlFlow 0 72631) 72687))) inline$$BorrowLoc$1$anon0_correct@@6)))
(let ((inline$$WriteRef$0$anon0_correct@@15  (=> (= |inline$$WriteRef$0$to'@1@@15| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@15) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@15) |inline$$Vector_push_back$0$v'@1@@11|)) (and (=> (= (ControlFlow 0 72506) 72631) inline$$WritebackToValue$0$anon3_Then_correct@@15) (=> (= (ControlFlow 0 72506) 72605) inline$$WritebackToValue$0$anon3_Else_correct@@15)))))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon25_Else_correct  (=> (and (not false) (= (ControlFlow 0 72512) 72506)) inline$$WriteRef$0$anon0_correct@@15)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon25_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@11  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@15) (= |inline$$Vector_push_back$0$v'@1@@11| ($Vector (let ((len@@25 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@15))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@15)) len@@25 inline$$TestVector_test_neq2_$def_verify$0$$t3@1) (+ len@@25 1)))))) (and (=> (= (ControlFlow 0 72441) 73058) inline$$TestVector_test_neq2_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 72441) 72512) inline$$TestVector_test_neq2_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@9  (=> (and (= inline$$Vector_push_back$0$ta@0@@9 $IntegerType) (= (ControlFlow 0 72429) 72441)) inline$$Vector_push_back$0$anon0_correct@@11)))
(let ((inline$$ReadRef$0$anon0_correct@@15  (=> (and (= inline$$ReadRef$0$v@1@@15 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@15)) (= (ControlFlow 0 72378) 72429)) inline$$Vector_push_back$0$Entry_correct@@9)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon23_Else$1_correct  (=> (and (= inline$$TestVector_test_neq2_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 72384) 72378)) inline$$ReadRef$0$anon0_correct@@15)))
(let ((inline$$BorrowLoc$0$anon0_correct@@15  (=> (and (= inline$$BorrowLoc$0$dst@1@@15 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@11)) (= (ControlFlow 0 72336) 72384)) inline$$TestVector_test_neq2_$def_verify$0$anon23_Else$1_correct)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon23_Else_correct  (=> (and (not false) (= (ControlFlow 0 72342) 72336)) inline$$BorrowLoc$0$anon0_correct@@15)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon23_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@3  (=> (= inline$$Vector_empty$1$v@1@@3 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 72274) 73078) inline$$TestVector_test_neq2_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 72274) 72342) inline$$TestVector_test_neq2_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@2  (=> (and (= inline$$Vector_empty$1$ta@0@@2 $IntegerType) (= (ControlFlow 0 72270) 72274)) inline$$Vector_empty$1$anon0_correct@@3)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon21_Else_correct  (=> (and (not false) (= (ControlFlow 0 72280) 72270)) inline$$Vector_empty$1$Entry_correct@@2)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon21_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@11  (=> (= inline$$Vector_empty$0$v@1@@11 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 72233) 73098) inline$$TestVector_test_neq2_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 72233) 72280) inline$$TestVector_test_neq2_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@8  (=> (and (= inline$$Vector_empty$0$ta@0@@8 $IntegerType) (= (ControlFlow 0 72229) 72233)) inline$$Vector_empty$0$anon0_correct@@11)))
(let ((inline$$TestVector_test_neq2_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 72239) 72229)) inline$$Vector_empty$0$Entry_correct@@8)))
(let ((anon0_correct@@19  (=> (= (ControlFlow 0 118488) 72239) inline$$TestVector_test_neq2_$def_verify$0$anon0_correct)))
anon0_correct@@19)))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@17 () Bool)
(declare-fun inline$$TestVector_test_push_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_push_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@14| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@6| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@8| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@7| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@7 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@4| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@9 () T@$Value)
(declare-fun inline$$TestVector_test_push_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@4 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@16| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@12 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@16| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@16 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@12| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@16 () T@$Value)
(declare-fun inline$$TestVector_test_push_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@10 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@3 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@9 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 119216) (let ((anon0$2_correct@@18  (and (=> (= (ControlFlow 0 74632) (- 0 119958)) (=> (not $abort_flag@0@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_push_$def_verify$0$$ret0@2 inline$$TestVector_test_push_$def_verify$0$$ret1@2))))) (=> (=> (not $abort_flag@0@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_push_$def_verify$0$$ret0@2 inline$$TestVector_test_push_$def_verify$0$$ret1@2)))) (and (=> (= (ControlFlow 0 74632) (- 0 119971)) (=> (not $abort_flag@0@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_push_$def_verify$0$$ret0@2))) ($Integer 1)))))) (=> (=> (not $abort_flag@0@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_push_$def_verify$0$$ret0@2))) ($Integer 1))))) (=> (= (ControlFlow 0 74632) (- 0 119989)) (=> (not $abort_flag@0@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_test_push_$def_verify$0$$ret1@2))) ($Integer 1))))))))))))
(let ((inline$$TestVector_test_push_$def_verify$0$anon20_correct  (=> (and (and (= $abort_flag@0@@17 false) (= inline$$TestVector_test_push_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@14|)) (and (= inline$$TestVector_test_push_$def_verify$0$$ret1@2 |inline$$WritebackToValue$1$vdst'@2@@6|) (= (ControlFlow 0 74518) 74632))) anon0$2_correct@@18)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 74516) 74518)) inline$$TestVector_test_push_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 74526) 74518) inline$$TestVector_test_push_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 74506) 74526) inline$$TestVector_test_push_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 74506) 74516) inline$$TestVector_test_push_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestVector_test_push_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 74534) 74526) inline$$TestVector_test_push_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 74534) 74516) inline$$TestVector_test_push_$def_verify$0$anon30_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@7  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@8|) ($Local 1))) (= |inline$$WritebackToValue$1$vdst'@2@@6| inline$$Vector_empty$1$v@1@@4)) (and (=> (= (ControlFlow 0 74464) 74534) inline$$TestVector_test_push_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 74464) 74506) inline$$TestVector_test_push_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@7  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@8|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@7| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@8|) 0 inline$$Vector_empty$1$v@1@@4 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@8|))) (= |inline$$WritebackToValue$1$vdst'@2@@6| |inline$$WritebackToValue$1$vdst'@1@@7|)) (and (=> (= (ControlFlow 0 74490) 74534) inline$$TestVector_test_push_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 74490) 74506) inline$$TestVector_test_push_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct@@8  (=> (= |inline$$WriteRef$1$to'@1@@8| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@7) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@7) |inline$$Vector_push_back$1$v'@1@@4|)) (and (=> (= (ControlFlow 0 74365) 74490) inline$$WritebackToValue$1$anon3_Then_correct@@7) (=> (= (ControlFlow 0 74365) 74464) inline$$WritebackToValue$1$anon3_Else_correct@@7)))))
(let ((inline$$TestVector_test_push_$def_verify$0$anon27_Else_correct  (=> (and (not false) (= (ControlFlow 0 74371) 74365)) inline$$WriteRef$1$anon0_correct@@8)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon27_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@4  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@9) (= |inline$$Vector_push_back$1$v'@1@@4| ($Vector (let ((len@@26 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@9))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@9)) len@@26 inline$$TestVector_test_push_$def_verify$0$$t6@1) (+ len@@26 1)))))) (and (=> (= (ControlFlow 0 74300) 74538) inline$$TestVector_test_push_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 74300) 74371) inline$$TestVector_test_push_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@4  (=> (and (= inline$$Vector_push_back$1$ta@0@@4 $IntegerType) (= (ControlFlow 0 74288) 74300)) inline$$Vector_push_back$1$anon0_correct@@4)))
(let ((inline$$ReadRef$1$anon0_correct@@9  (=> (and (= inline$$ReadRef$1$v@1@@9 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@7)) (= (ControlFlow 0 74237) 74288)) inline$$Vector_push_back$1$Entry_correct@@4)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon25_Else$3_correct  (=> (and (= inline$$TestVector_test_push_$def_verify$0$$t6@1 ($Integer 1)) (= (ControlFlow 0 74243) 74237)) inline$$ReadRef$1$anon0_correct@@9)))
(let ((inline$$BorrowLoc$1$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$1$dst@1@@7 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1@@4)) (= (ControlFlow 0 74195) 74243)) inline$$TestVector_test_push_$def_verify$0$anon25_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@16  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@16|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@14| inline$$Vector_empty$0$v@1@@12) (= (ControlFlow 0 74113) 74195)) inline$$BorrowLoc$1$anon0_correct@@7))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@16  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@16|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@16| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@16|) 0 inline$$Vector_empty$0$v@1@@12 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@16|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@14| |inline$$WritebackToValue$0$vdst'@1@@16|) (= (ControlFlow 0 74139) 74195))) inline$$BorrowLoc$1$anon0_correct@@7)))
(let ((inline$$WriteRef$0$anon0_correct@@16  (=> (= |inline$$WriteRef$0$to'@1@@16| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@16) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@16) |inline$$Vector_push_back$0$v'@1@@12|)) (and (=> (= (ControlFlow 0 74014) 74139) inline$$WritebackToValue$0$anon3_Then_correct@@16) (=> (= (ControlFlow 0 74014) 74113) inline$$WritebackToValue$0$anon3_Else_correct@@16)))))
(let ((inline$$TestVector_test_push_$def_verify$0$anon25_Else_correct  (=> (and (not false) (= (ControlFlow 0 74020) 74014)) inline$$WriteRef$0$anon0_correct@@16)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon25_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@12  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@16) (= |inline$$Vector_push_back$0$v'@1@@12| ($Vector (let ((len@@27 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@16))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@16)) len@@27 inline$$TestVector_test_push_$def_verify$0$$t3@1) (+ len@@27 1)))))) (and (=> (= (ControlFlow 0 73949) 74566) inline$$TestVector_test_push_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 73949) 74020) inline$$TestVector_test_push_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@10  (=> (and (= inline$$Vector_push_back$0$ta@0@@10 $IntegerType) (= (ControlFlow 0 73937) 73949)) inline$$Vector_push_back$0$anon0_correct@@12)))
(let ((inline$$ReadRef$0$anon0_correct@@16  (=> (and (= inline$$ReadRef$0$v@1@@16 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@16)) (= (ControlFlow 0 73886) 73937)) inline$$Vector_push_back$0$Entry_correct@@10)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon23_Else$1_correct  (=> (and (= inline$$TestVector_test_push_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 73892) 73886)) inline$$ReadRef$0$anon0_correct@@16)))
(let ((inline$$BorrowLoc$0$anon0_correct@@16  (=> (and (= inline$$BorrowLoc$0$dst@1@@16 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@12)) (= (ControlFlow 0 73844) 73892)) inline$$TestVector_test_push_$def_verify$0$anon23_Else$1_correct)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon23_Else_correct  (=> (and (not false) (= (ControlFlow 0 73850) 73844)) inline$$BorrowLoc$0$anon0_correct@@16)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon23_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@4  (=> (= inline$$Vector_empty$1$v@1@@4 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 73782) 74586) inline$$TestVector_test_push_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 73782) 73850) inline$$TestVector_test_push_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@3  (=> (and (= inline$$Vector_empty$1$ta@0@@3 $IntegerType) (= (ControlFlow 0 73778) 73782)) inline$$Vector_empty$1$anon0_correct@@4)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon21_Else_correct  (=> (and (not false) (= (ControlFlow 0 73788) 73778)) inline$$Vector_empty$1$Entry_correct@@3)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon21_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@12  (=> (= inline$$Vector_empty$0$v@1@@12 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 73741) 74606) inline$$TestVector_test_push_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 73741) 73788) inline$$TestVector_test_push_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@9  (=> (and (= inline$$Vector_empty$0$ta@0@@9 $IntegerType) (= (ControlFlow 0 73737) 73741)) inline$$Vector_empty$0$anon0_correct@@12)))
(let ((inline$$TestVector_test_push_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 73747) 73737)) inline$$Vector_empty$0$Entry_correct@@9)))
(let ((anon0_correct@@20  (=> (= (ControlFlow 0 119216) 73747) inline$$TestVector_test_push_$def_verify$0$anon0_correct)))
anon0_correct@@20)))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun inline$$TestVector_test_push_pop_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_push_pop_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestVector_test_push_pop_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestVector_test_push_pop_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@18 () Bool)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@7| () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1@@5 () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@9| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@15| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@8| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@8 () T@$Mutation)
(declare-fun |inline$$Vector_pop_back$0$v'@2@@0| () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@0@@0| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$len@1@@0 () Int)
(declare-fun inline$$Vector_pop_back$0$e@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@10 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@1@@0| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@17| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@13 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@17| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@17 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@13| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@17 () T@$Value)
(declare-fun inline$$TestVector_test_push_pop_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@11 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@4 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@10 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 120016) (let ((anon0$2_correct@@19  (=> (= (ControlFlow 0 76258) (- 0 120798)) (=> (not $abort_flag@1@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_push_pop_$def_verify$0$$ret0@2 inline$$TestVector_test_push_pop_$def_verify$0$$ret1@2)))))))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$Abort_correct  (=> (and (= inline$$TestVector_test_push_pop_$def_verify$0$$ret0@1 $Error) (= inline$$TestVector_test_push_pop_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@1@@7 true) (= inline$$TestVector_test_push_pop_$def_verify$0$$ret0@2 inline$$TestVector_test_push_pop_$def_verify$0$$ret0@1)) (and (= inline$$TestVector_test_push_pop_$def_verify$0$$ret1@2 inline$$TestVector_test_push_pop_$def_verify$0$$ret1@1) (= (ControlFlow 0 76180) 76258))) anon0$2_correct@@19))))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 76170) 76180)) inline$$TestVector_test_push_pop_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 76188) 76180) inline$$TestVector_test_push_pop_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon27_Then_correct  (=> $abort_flag@0@@18 (and (=> (= (ControlFlow 0 76164) 76188) inline$$TestVector_test_push_pop_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 76164) 76170) inline$$TestVector_test_push_pop_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon20_correct  (=> (and (and (= $abort_flag@1@@7 $abort_flag@0@@18) (= inline$$TestVector_test_push_pop_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@7|)) (and (= inline$$TestVector_test_push_pop_$def_verify$0$$ret1@2 inline$$Vector_empty$1$v@1@@5) (= (ControlFlow 0 76144) 76258))) anon0$2_correct@@19)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 76142) 76144)) inline$$TestVector_test_push_pop_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 76152) 76144) inline$$TestVector_test_push_pop_$def_verify$0$anon20_correct)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 76132) 76152) inline$$TestVector_test_push_pop_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 76132) 76142) inline$$TestVector_test_push_pop_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 76160) 76152) inline$$TestVector_test_push_pop_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 76160) 76142) inline$$TestVector_test_push_pop_$def_verify$0$anon30_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@8  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@9|) ($Local 0))) (= |inline$$WritebackToValue$1$vdst'@2@@7| |inline$$WritebackToValue$0$vdst'@2@@15|)) (and (=> (= (ControlFlow 0 76090) 76160) inline$$TestVector_test_push_pop_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 76090) 76132) inline$$TestVector_test_push_pop_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@8  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@9|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@8| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@9|) 0 |inline$$WritebackToValue$0$vdst'@2@@15| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@9|))) (= |inline$$WritebackToValue$1$vdst'@2@@7| |inline$$WritebackToValue$1$vdst'@1@@8|)) (and (=> (= (ControlFlow 0 76116) 76160) inline$$TestVector_test_push_pop_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 76116) 76132) inline$$TestVector_test_push_pop_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct@@9  (=> (= |inline$$WriteRef$1$to'@1@@9| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@8) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@8) |inline$$Vector_pop_back$0$v'@2@@0|)) (and (=> (= (ControlFlow 0 75991) 76116) inline$$WritebackToValue$1$anon3_Then_correct@@8) (=> (= (ControlFlow 0 75991) 76090) inline$$WritebackToValue$1$anon3_Else_correct@@8)))))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@0@@18) (= (ControlFlow 0 75997) 75991)) inline$$WriteRef$1$anon0_correct@@9)))
(let ((inline$$Vector_pop_back$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@18 true) (= |inline$$Vector_pop_back$0$v'@2@@0| |inline$$Vector_pop_back$0$v'@0@@0|)) (and (=> (= (ControlFlow 0 75924) 76164) inline$$TestVector_test_push_pop_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 75924) 75997) inline$$TestVector_test_push_pop_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Vector_pop_back$0$anon3_Then_correct@@0  (=> (and (= inline$$Vector_pop_back$0$len@1@@0 0) (= (ControlFlow 0 75922) 75924)) inline$$Vector_pop_back$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_pop_back$0$anon3_Else_correct@@0  (=> (not (= inline$$Vector_pop_back$0$len@1@@0 0)) (=> (and (and (= inline$$Vector_pop_back$0$e@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@10)) (- inline$$Vector_pop_back$0$len@1@@0 1))) (= |inline$$Vector_pop_back$0$v'@1@@0| ($Vector (let ((l@@34 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@10)) 1)))
($ValueArray (|lambda#0| 0 l@@34 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@10)) $Error) l@@34))))) (and (= $abort_flag@0@@18 false) (= |inline$$Vector_pop_back$0$v'@2@@0| |inline$$Vector_pop_back$0$v'@1@@0|))) (and (=> (= (ControlFlow 0 75874) 76164) inline$$TestVector_test_push_pop_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 75874) 75997) inline$$TestVector_test_push_pop_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@10) (= inline$$Vector_pop_back$0$len@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@10)))) (and (=> (= (ControlFlow 0 75852) 75922) inline$$Vector_pop_back$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 75852) 75874) inline$$Vector_pop_back$0$anon3_Else_correct@@0)))))
(let ((inline$$Vector_pop_back$0$Entry_correct  (=> (and (= inline$$Vector_pop_back$0$ta@0 $IntegerType) (= (ControlFlow 0 75842) 75852)) inline$$Vector_pop_back$0$anon0_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct@@10  (=> (and (= inline$$ReadRef$1$v@1@@10 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@8)) (= (ControlFlow 0 75741) 75842)) inline$$Vector_pop_back$0$Entry_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct@@8  (=> (and (= inline$$BorrowLoc$1$dst@1@@8 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@15|)) (= (ControlFlow 0 75703) 75741)) inline$$ReadRef$1$anon0_correct@@10)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@17  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@17|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@15| inline$$Vector_empty$0$v@1@@13) (= (ControlFlow 0 75621) 75703)) inline$$BorrowLoc$1$anon0_correct@@8))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@17  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@17|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@17| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@17|) 0 inline$$Vector_empty$0$v@1@@13 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@17|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@15| |inline$$WritebackToValue$0$vdst'@1@@17|) (= (ControlFlow 0 75647) 75703))) inline$$BorrowLoc$1$anon0_correct@@8)))
(let ((inline$$WriteRef$0$anon0_correct@@17  (=> (= |inline$$WriteRef$0$to'@1@@17| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@17) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@17) |inline$$Vector_push_back$0$v'@1@@13|)) (and (=> (= (ControlFlow 0 75522) 75647) inline$$WritebackToValue$0$anon3_Then_correct@@17) (=> (= (ControlFlow 0 75522) 75621) inline$$WritebackToValue$0$anon3_Else_correct@@17)))))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon25_Else_correct  (=> (and (not false) (= (ControlFlow 0 75528) 75522)) inline$$WriteRef$0$anon0_correct@@17)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon25_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@13  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@17) (= |inline$$Vector_push_back$0$v'@1@@13| ($Vector (let ((len@@28 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@17))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@17)) len@@28 inline$$TestVector_test_push_pop_$def_verify$0$$t3@1) (+ len@@28 1)))))) (and (=> (= (ControlFlow 0 75457) 76192) inline$$TestVector_test_push_pop_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 75457) 75528) inline$$TestVector_test_push_pop_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@11  (=> (and (= inline$$Vector_push_back$0$ta@0@@11 $IntegerType) (= (ControlFlow 0 75445) 75457)) inline$$Vector_push_back$0$anon0_correct@@13)))
(let ((inline$$ReadRef$0$anon0_correct@@17  (=> (and (= inline$$ReadRef$0$v@1@@17 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@17)) (= (ControlFlow 0 75394) 75445)) inline$$Vector_push_back$0$Entry_correct@@11)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon23_Else$1_correct  (=> (and (= inline$$TestVector_test_push_pop_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 75400) 75394)) inline$$ReadRef$0$anon0_correct@@17)))
(let ((inline$$BorrowLoc$0$anon0_correct@@17  (=> (and (= inline$$BorrowLoc$0$dst@1@@17 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@13)) (= (ControlFlow 0 75352) 75400)) inline$$TestVector_test_push_pop_$def_verify$0$anon23_Else$1_correct)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon23_Else_correct  (=> (and (not false) (= (ControlFlow 0 75358) 75352)) inline$$BorrowLoc$0$anon0_correct@@17)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon23_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@5  (=> (= inline$$Vector_empty$1$v@1@@5 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 75290) 76212) inline$$TestVector_test_push_pop_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 75290) 75358) inline$$TestVector_test_push_pop_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@4  (=> (and (= inline$$Vector_empty$1$ta@0@@4 $IntegerType) (= (ControlFlow 0 75286) 75290)) inline$$Vector_empty$1$anon0_correct@@5)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon21_Else_correct  (=> (and (not false) (= (ControlFlow 0 75296) 75286)) inline$$Vector_empty$1$Entry_correct@@4)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon21_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@13  (=> (= inline$$Vector_empty$0$v@1@@13 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 75249) 76232) inline$$TestVector_test_push_pop_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 75249) 75296) inline$$TestVector_test_push_pop_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@10  (=> (and (= inline$$Vector_empty$0$ta@0@@10 $IntegerType) (= (ControlFlow 0 75245) 75249)) inline$$Vector_empty$0$anon0_correct@@13)))
(let ((inline$$TestVector_test_push_pop_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 75255) 75245)) inline$$Vector_empty$0$Entry_correct@@10)))
(let ((anon0_correct@@21  (=> (= (ControlFlow 0 120016) 75255) inline$$TestVector_test_push_pop_$def_verify$0$anon0_correct)))
anon0_correct@@21))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@19 () Bool)
(declare-fun inline$$TestVector_test_reverse1_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_reverse1_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@16| () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1@@6 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@18| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@14 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@18| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@18 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1@@2| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@18 () T@$Value)
(declare-fun inline$$Vector_reverse$0$ta@0@@2 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@5 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@11 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 120819) (let ((anon0$2_correct@@20  (=> (= (ControlFlow 0 77299) (- 0 121272)) (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_reverse1_$def_verify$0$$ret0@2 inline$$TestVector_test_reverse1_$def_verify$0$$ret1@2)))))))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon16_correct  (=> (and (and (= $abort_flag@0@@19 false) (= inline$$TestVector_test_reverse1_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@16|)) (and (= inline$$TestVector_test_reverse1_$def_verify$0$$ret1@2 inline$$Vector_empty$1$v@1@@6) (= (ControlFlow 0 77205) 77299))) anon0$2_correct@@20)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 77203) 77205)) inline$$TestVector_test_reverse1_$def_verify$0$anon16_correct)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 77213) 77205) inline$$TestVector_test_reverse1_$def_verify$0$anon16_correct)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 77193) 77213) inline$$TestVector_test_reverse1_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 77193) 77203) inline$$TestVector_test_reverse1_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 77221) 77213) inline$$TestVector_test_reverse1_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 77221) 77203) inline$$TestVector_test_reverse1_$def_verify$0$anon24_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@18  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@18|) ($Local 0))) (= |inline$$WritebackToValue$0$vdst'@2@@16| inline$$Vector_empty$0$v@1@@14)) (and (=> (= (ControlFlow 0 77151) 77221) inline$$TestVector_test_reverse1_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 77151) 77193) inline$$TestVector_test_reverse1_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@18  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@18|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@18| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@18|) 0 inline$$Vector_empty$0$v@1@@14 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@18|))) (= |inline$$WritebackToValue$0$vdst'@2@@16| |inline$$WritebackToValue$0$vdst'@1@@18|)) (and (=> (= (ControlFlow 0 77177) 77221) inline$$TestVector_test_reverse1_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 77177) 77193) inline$$TestVector_test_reverse1_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@18  (=> (= |inline$$WriteRef$0$to'@1@@18| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@18) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@18) |inline$$Vector_reverse$0$v'@1@@2|)) (and (=> (= (ControlFlow 0 77052) 77177) inline$$WritebackToValue$0$anon3_Then_correct@@18) (=> (= (ControlFlow 0 77052) 77151) inline$$WritebackToValue$0$anon3_Else_correct@@18)))))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon21_Else_correct  (=> (and (not false) (= (ControlFlow 0 77058) 77052)) inline$$WriteRef$0$anon0_correct@@18)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon21_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@18) (= |inline$$Vector_reverse$0$v'@1@@2| ($Vector (let ((l@@35 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@18))))
($ValueArray (|lambda#3| 0 l@@35 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@18)) l@@35 1 $Error) l@@35))))) (and (=> (= (ControlFlow 0 76987) 77225) inline$$TestVector_test_reverse1_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 76987) 77058) inline$$TestVector_test_reverse1_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_reverse$0$Entry_correct@@2  (=> (and (= inline$$Vector_reverse$0$ta@0@@2 $IntegerType) (= (ControlFlow 0 76977) 76987)) inline$$Vector_reverse$0$anon0_correct@@2)))
(let ((inline$$ReadRef$0$anon0_correct@@18  (=> (and (= inline$$ReadRef$0$v@1@@18 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@18)) (= (ControlFlow 0 76934) 76977)) inline$$Vector_reverse$0$Entry_correct@@2)))
(let ((inline$$BorrowLoc$0$anon0_correct@@18  (=> (and (= inline$$BorrowLoc$0$dst@1@@18 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@14)) (= (ControlFlow 0 76896) 76934)) inline$$ReadRef$0$anon0_correct@@18)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= (ControlFlow 0 76902) 76896)) inline$$BorrowLoc$0$anon0_correct@@18)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon19_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@6  (=> (= inline$$Vector_empty$1$v@1@@6 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 76834) 77253) inline$$TestVector_test_reverse1_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 76834) 76902) inline$$TestVector_test_reverse1_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@5  (=> (and (= inline$$Vector_empty$1$ta@0@@5 $IntegerType) (= (ControlFlow 0 76830) 76834)) inline$$Vector_empty$1$anon0_correct@@6)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon17_Else_correct  (=> (and (not false) (= (ControlFlow 0 76840) 76830)) inline$$Vector_empty$1$Entry_correct@@5)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon17_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@14  (=> (= inline$$Vector_empty$0$v@1@@14 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 76793) 77273) inline$$TestVector_test_reverse1_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 76793) 76840) inline$$TestVector_test_reverse1_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@11  (=> (and (= inline$$Vector_empty$0$ta@0@@11 $IntegerType) (= (ControlFlow 0 76789) 76793)) inline$$Vector_empty$0$anon0_correct@@14)))
(let ((inline$$TestVector_test_reverse1_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 76799) 76789)) inline$$Vector_empty$0$Entry_correct@@11)))
(let ((anon0_correct@@22  (=> (= (ControlFlow 0 120819) 76799) inline$$TestVector_test_reverse1_$def_verify$0$anon0_correct)))
anon0_correct@@22))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@20 () Bool)
(declare-fun inline$$TestVector_test_reverse2_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_reverse2_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$4$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WriteRef$4$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@8| () T@$Value)
(declare-fun |inline$$WritebackToValue$4$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$4$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1@@3| () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@0 () T@$Value)
(declare-fun inline$$Vector_reverse$0$ta@0@@3 () T@$TypeValue)
(declare-fun |inline$$WriteRef$3$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@4| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$3$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$3$v'@1@@1| () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@1 () T@$Value)
(declare-fun inline$$TestVector_test_reverse2_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_push_back$3$ta@0@@1 () T@$TypeValue)
(declare-fun |inline$$WriteRef$2$to'@1@@5| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1@@7 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@5| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@5 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@3| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@6 () T@$Value)
(declare-fun inline$$TestVector_test_reverse2_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@3 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@10| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@17| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@9| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@9 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@5| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@11 () T@$Value)
(declare-fun inline$$TestVector_test_reverse2_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@5 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@19| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@15 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@19| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@19 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@14| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@19 () T@$Value)
(declare-fun inline$$TestVector_test_reverse2_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@12 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@6 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@12 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 121293) (let ((anon0$2_correct@@21  (=> (= (ControlFlow 0 80039) (- 0 122662)) (=> (not $abort_flag@0@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_reverse2_$def_verify$0$$ret0@2 inline$$TestVector_test_reverse2_$def_verify$0$$ret1@2)))))))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon32_correct  (=> (and (and (= $abort_flag@0@@20 false) (= inline$$TestVector_test_reverse2_$def_verify$0$$ret0@2 |inline$$WritebackToValue$4$vdst'@2@@0|)) (and (= inline$$TestVector_test_reverse2_$def_verify$0$$ret1@2 |inline$$WritebackToValue$3$vdst'@2@@1|) (= (ControlFlow 0 79865) 80039))) anon0$2_correct@@21)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 79863) 79865)) inline$$TestVector_test_reverse2_$def_verify$0$anon32_correct)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 79873) 79865) inline$$TestVector_test_reverse2_$def_verify$0$anon32_correct)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79853) 79873) inline$$TestVector_test_reverse2_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 79853) 79863) inline$$TestVector_test_reverse2_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 79881) 79873) inline$$TestVector_test_reverse2_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 79881) 79863) inline$$TestVector_test_reverse2_$def_verify$0$anon48_Else_correct))))
(let ((inline$$WritebackToValue$4$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@0|) ($Local 0))) (= |inline$$WritebackToValue$4$vdst'@2@@0| |inline$$WritebackToValue$1$vdst'@2@@8|)) (and (=> (= (ControlFlow 0 79811) 79881) inline$$TestVector_test_reverse2_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 79811) 79853) inline$$TestVector_test_reverse2_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$WritebackToValue$4$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@0|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$4$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$4$to'@1@@0|) 0 |inline$$WritebackToValue$1$vdst'@2@@8| (|v#$Mutation| |inline$$WriteRef$4$to'@1@@0|))) (= |inline$$WritebackToValue$4$vdst'@2@@0| |inline$$WritebackToValue$4$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 79837) 79881) inline$$TestVector_test_reverse2_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 79837) 79853) inline$$TestVector_test_reverse2_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$WriteRef$4$anon0_correct@@0  (=> (= |inline$$WriteRef$4$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$4$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$4$dst@1@@0) |inline$$Vector_reverse$0$v'@1@@3|)) (and (=> (= (ControlFlow 0 79712) 79837) inline$$WritebackToValue$4$anon3_Then_correct@@0) (=> (= (ControlFlow 0 79712) 79811) inline$$WritebackToValue$4$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon45_Else_correct  (=> (and (not false) (= (ControlFlow 0 79718) 79712)) inline$$WriteRef$4$anon0_correct@@0)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon45_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$ReadRef$4$v@1@@0) (= |inline$$Vector_reverse$0$v'@1@@3| ($Vector (let ((l@@36 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@0))))
($ValueArray (|lambda#3| 0 l@@36 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@0)) l@@36 1 $Error) l@@36))))) (and (=> (= (ControlFlow 0 79647) 79885) inline$$TestVector_test_reverse2_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 79647) 79718) inline$$TestVector_test_reverse2_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Vector_reverse$0$Entry_correct@@3  (=> (and (= inline$$Vector_reverse$0$ta@0@@3 $IntegerType) (= (ControlFlow 0 79637) 79647)) inline$$Vector_reverse$0$anon0_correct@@3)))
(let ((inline$$ReadRef$4$anon0_correct@@0  (=> (and (= inline$$ReadRef$4$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$4$dst@1@@0)) (= (ControlFlow 0 79594) 79637)) inline$$Vector_reverse$0$Entry_correct@@3)))
(let ((inline$$BorrowLoc$4$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$4$dst@1@@0 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$1$vdst'@2@@8|)) (= (ControlFlow 0 79556) 79594)) inline$$ReadRef$4$anon0_correct@@0)))
(let ((inline$$WritebackToValue$3$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@1|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$3$vdst'@2@@1| |inline$$WritebackToValue$2$vdst'@2@@4|) (= (ControlFlow 0 79474) 79556)) inline$$BorrowLoc$4$anon0_correct@@0))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@1|) ($Local 1)) (= |inline$$WritebackToValue$3$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1@@1|) 0 |inline$$WritebackToValue$2$vdst'@2@@4| (|v#$Mutation| |inline$$WriteRef$3$to'@1@@1|)))) (and (= |inline$$WritebackToValue$3$vdst'@2@@1| |inline$$WritebackToValue$3$vdst'@1@@1|) (= (ControlFlow 0 79500) 79556))) inline$$BorrowLoc$4$anon0_correct@@0)))
(let ((inline$$WriteRef$3$anon0_correct@@1  (=> (= |inline$$WriteRef$3$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$3$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$3$dst@1@@1) |inline$$Vector_push_back$3$v'@1@@1|)) (and (=> (= (ControlFlow 0 79375) 79500) inline$$WritebackToValue$3$anon3_Then_correct@@1) (=> (= (ControlFlow 0 79375) 79474) inline$$WritebackToValue$3$anon3_Else_correct@@1)))))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon43_Else_correct  (=> (and (not false) (= (ControlFlow 0 79381) 79375)) inline$$WriteRef$3$anon0_correct@@1)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon43_Then_correct true))
(let ((inline$$Vector_push_back$3$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$3$v@1@@1) (= |inline$$Vector_push_back$3$v'@1@@1| ($Vector (let ((len@@29 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@1)) len@@29 inline$$TestVector_test_reverse2_$def_verify$0$$t10@1) (+ len@@29 1)))))) (and (=> (= (ControlFlow 0 79310) 79913) inline$$TestVector_test_reverse2_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 79310) 79381) inline$$TestVector_test_reverse2_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Vector_push_back$3$Entry_correct@@1  (=> (and (= inline$$Vector_push_back$3$ta@0@@1 $IntegerType) (= (ControlFlow 0 79298) 79310)) inline$$Vector_push_back$3$anon0_correct@@1)))
(let ((inline$$ReadRef$3$anon0_correct@@1  (=> (and (= inline$$ReadRef$3$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$3$dst@1@@1)) (= (ControlFlow 0 79247) 79298)) inline$$Vector_push_back$3$Entry_correct@@1)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon41_Else$3_correct  (=> (and (= inline$$TestVector_test_reverse2_$def_verify$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 79253) 79247)) inline$$ReadRef$3$anon0_correct@@1)))
(let ((inline$$BorrowLoc$3$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$3$dst@1@@1 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$2$vdst'@2@@4|)) (= (ControlFlow 0 79205) 79253)) inline$$TestVector_test_reverse2_$def_verify$0$anon41_Else$3_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@5  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@5|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@4| inline$$Vector_empty$1$v@1@@7) (= (ControlFlow 0 79123) 79205)) inline$$BorrowLoc$3$anon0_correct@@1))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@5  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@5|) ($Local 1)) (= |inline$$WritebackToValue$2$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@5|) 0 inline$$Vector_empty$1$v@1@@7 (|v#$Mutation| |inline$$WriteRef$2$to'@1@@5|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@4| |inline$$WritebackToValue$2$vdst'@1@@5|) (= (ControlFlow 0 79149) 79205))) inline$$BorrowLoc$3$anon0_correct@@1)))
(let ((inline$$WriteRef$2$anon0_correct@@5  (=> (= |inline$$WriteRef$2$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@5) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@5) |inline$$Vector_push_back$2$v'@1@@3|)) (and (=> (= (ControlFlow 0 79024) 79149) inline$$WritebackToValue$2$anon3_Then_correct@@5) (=> (= (ControlFlow 0 79024) 79123) inline$$WritebackToValue$2$anon3_Else_correct@@5)))))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon41_Else_correct  (=> (and (not false) (= (ControlFlow 0 79030) 79024)) inline$$WriteRef$2$anon0_correct@@5)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon41_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@6) (= |inline$$Vector_push_back$2$v'@1@@3| ($Vector (let ((len@@30 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@6))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@6)) len@@30 inline$$TestVector_test_reverse2_$def_verify$0$$t8@1) (+ len@@30 1)))))) (and (=> (= (ControlFlow 0 78959) 79933) inline$$TestVector_test_reverse2_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 78959) 79030) inline$$TestVector_test_reverse2_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@3  (=> (and (= inline$$Vector_push_back$2$ta@0@@3 $IntegerType) (= (ControlFlow 0 78947) 78959)) inline$$Vector_push_back$2$anon0_correct@@3)))
(let ((inline$$ReadRef$2$anon0_correct@@6  (=> (and (= inline$$ReadRef$2$v@1@@6 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@5)) (= (ControlFlow 0 78896) 78947)) inline$$Vector_push_back$2$Entry_correct@@3)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon39_Else$3_correct  (=> (and (= inline$$TestVector_test_reverse2_$def_verify$0$$t8@1 ($Integer 2)) (= (ControlFlow 0 78902) 78896)) inline$$ReadRef$2$anon0_correct@@6)))
(let ((inline$$BorrowLoc$2$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$2$dst@1@@5 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1@@7)) (= (ControlFlow 0 78854) 78902)) inline$$TestVector_test_reverse2_$def_verify$0$anon39_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@9  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@10|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@8| |inline$$WritebackToValue$0$vdst'@2@@17|) (= (ControlFlow 0 78772) 78854)) inline$$BorrowLoc$2$anon0_correct@@5))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@9  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@10|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@9| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@10|) 0 |inline$$WritebackToValue$0$vdst'@2@@17| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@10|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@8| |inline$$WritebackToValue$1$vdst'@1@@9|) (= (ControlFlow 0 78798) 78854))) inline$$BorrowLoc$2$anon0_correct@@5)))
(let ((inline$$WriteRef$1$anon0_correct@@10  (=> (= |inline$$WriteRef$1$to'@1@@10| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@9) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@9) |inline$$Vector_push_back$1$v'@1@@5|)) (and (=> (= (ControlFlow 0 78673) 78798) inline$$WritebackToValue$1$anon3_Then_correct@@9) (=> (= (ControlFlow 0 78673) 78772) inline$$WritebackToValue$1$anon3_Else_correct@@9)))))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon39_Else_correct  (=> (and (not false) (= (ControlFlow 0 78679) 78673)) inline$$WriteRef$1$anon0_correct@@10)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon39_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@5  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@11) (= |inline$$Vector_push_back$1$v'@1@@5| ($Vector (let ((len@@31 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@11))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@11)) len@@31 inline$$TestVector_test_reverse2_$def_verify$0$$t6@1) (+ len@@31 1)))))) (and (=> (= (ControlFlow 0 78608) 79953) inline$$TestVector_test_reverse2_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 78608) 78679) inline$$TestVector_test_reverse2_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@5  (=> (and (= inline$$Vector_push_back$1$ta@0@@5 $IntegerType) (= (ControlFlow 0 78596) 78608)) inline$$Vector_push_back$1$anon0_correct@@5)))
(let ((inline$$ReadRef$1$anon0_correct@@11  (=> (and (= inline$$ReadRef$1$v@1@@11 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@9)) (= (ControlFlow 0 78545) 78596)) inline$$Vector_push_back$1$Entry_correct@@5)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon37_Else$3_correct  (=> (and (= inline$$TestVector_test_reverse2_$def_verify$0$$t6@1 ($Integer 2)) (= (ControlFlow 0 78551) 78545)) inline$$ReadRef$1$anon0_correct@@11)))
(let ((inline$$BorrowLoc$1$anon0_correct@@9  (=> (and (= inline$$BorrowLoc$1$dst@1@@9 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@17|)) (= (ControlFlow 0 78503) 78551)) inline$$TestVector_test_reverse2_$def_verify$0$anon37_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@19  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@19|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@17| inline$$Vector_empty$0$v@1@@15) (= (ControlFlow 0 78421) 78503)) inline$$BorrowLoc$1$anon0_correct@@9))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@19  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@19|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@19| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@19|) 0 inline$$Vector_empty$0$v@1@@15 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@19|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@17| |inline$$WritebackToValue$0$vdst'@1@@19|) (= (ControlFlow 0 78447) 78503))) inline$$BorrowLoc$1$anon0_correct@@9)))
(let ((inline$$WriteRef$0$anon0_correct@@19  (=> (= |inline$$WriteRef$0$to'@1@@19| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@19) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@19) |inline$$Vector_push_back$0$v'@1@@14|)) (and (=> (= (ControlFlow 0 78322) 78447) inline$$WritebackToValue$0$anon3_Then_correct@@19) (=> (= (ControlFlow 0 78322) 78421) inline$$WritebackToValue$0$anon3_Else_correct@@19)))))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon37_Else_correct  (=> (and (not false) (= (ControlFlow 0 78328) 78322)) inline$$WriteRef$0$anon0_correct@@19)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon37_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@14  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@19) (= |inline$$Vector_push_back$0$v'@1@@14| ($Vector (let ((len@@32 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@19))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@19)) len@@32 inline$$TestVector_test_reverse2_$def_verify$0$$t3@1) (+ len@@32 1)))))) (and (=> (= (ControlFlow 0 78257) 79973) inline$$TestVector_test_reverse2_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 78257) 78328) inline$$TestVector_test_reverse2_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@12  (=> (and (= inline$$Vector_push_back$0$ta@0@@12 $IntegerType) (= (ControlFlow 0 78245) 78257)) inline$$Vector_push_back$0$anon0_correct@@14)))
(let ((inline$$ReadRef$0$anon0_correct@@19  (=> (and (= inline$$ReadRef$0$v@1@@19 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@19)) (= (ControlFlow 0 78194) 78245)) inline$$Vector_push_back$0$Entry_correct@@12)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon35_Else$1_correct  (=> (and (= inline$$TestVector_test_reverse2_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 78200) 78194)) inline$$ReadRef$0$anon0_correct@@19)))
(let ((inline$$BorrowLoc$0$anon0_correct@@19  (=> (and (= inline$$BorrowLoc$0$dst@1@@19 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@15)) (= (ControlFlow 0 78152) 78200)) inline$$TestVector_test_reverse2_$def_verify$0$anon35_Else$1_correct)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon35_Else_correct  (=> (and (not false) (= (ControlFlow 0 78158) 78152)) inline$$BorrowLoc$0$anon0_correct@@19)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon35_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@7  (=> (= inline$$Vector_empty$1$v@1@@7 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 78090) 79993) inline$$TestVector_test_reverse2_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 78090) 78158) inline$$TestVector_test_reverse2_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@6  (=> (and (= inline$$Vector_empty$1$ta@0@@6 $IntegerType) (= (ControlFlow 0 78086) 78090)) inline$$Vector_empty$1$anon0_correct@@7)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon33_Else_correct  (=> (and (not false) (= (ControlFlow 0 78096) 78086)) inline$$Vector_empty$1$Entry_correct@@6)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon33_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@15  (=> (= inline$$Vector_empty$0$v@1@@15 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 78049) 80013) inline$$TestVector_test_reverse2_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 78049) 78096) inline$$TestVector_test_reverse2_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@12  (=> (and (= inline$$Vector_empty$0$ta@0@@12 $IntegerType) (= (ControlFlow 0 78045) 78049)) inline$$Vector_empty$0$anon0_correct@@15)))
(let ((inline$$TestVector_test_reverse2_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 78055) 78045)) inline$$Vector_empty$0$Entry_correct@@12)))
(let ((anon0_correct@@23  (=> (= (ControlFlow 0 121293) 78055) inline$$TestVector_test_reverse2_$def_verify$0$anon0_correct)))
anon0_correct@@23))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@21 () Bool)
(declare-fun inline$$TestVector_test_reverse3_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_reverse3_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$4$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@2@@2| () T@$Value)
(declare-fun |inline$$WriteRef$4$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@9| () T@$Value)
(declare-fun |inline$$WritebackToValue$4$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$4$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1@@4| () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_reverse$0$ta@0@@4 () T@$TypeValue)
(declare-fun |inline$$WriteRef$3$to'@1@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@5| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$3$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$3$v'@1@@2| () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@2 () T@$Value)
(declare-fun inline$$TestVector_test_reverse3_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_push_back$3$ta@0@@2 () T@$TypeValue)
(declare-fun |inline$$WriteRef$2$to'@1@@6| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1@@8 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@6| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@6 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@4| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@7 () T@$Value)
(declare-fun inline$$TestVector_test_reverse3_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@4 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@11| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@18| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@10| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@10 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@6| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@12 () T@$Value)
(declare-fun inline$$TestVector_test_reverse3_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@6 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@20| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@16 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@20| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@20 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@15| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@20 () T@$Value)
(declare-fun inline$$TestVector_test_reverse3_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@13 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@7 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@13 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 122687) (let ((anon0$2_correct@@22  (=> (= (ControlFlow 0 83067) (- 0 124058)) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_reverse3_$def_verify$0$$ret0@2 inline$$TestVector_test_reverse3_$def_verify$0$$ret1@2))))))))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon32_correct  (=> (and (and (= $abort_flag@0@@21 false) (= inline$$TestVector_test_reverse3_$def_verify$0$$ret0@2 |inline$$WritebackToValue$4$vdst'@2@@1|)) (and (= inline$$TestVector_test_reverse3_$def_verify$0$$ret1@2 |inline$$WritebackToValue$3$vdst'@2@@2|) (= (ControlFlow 0 82893) 83067))) anon0$2_correct@@22)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 82891) 82893)) inline$$TestVector_test_reverse3_$def_verify$0$anon32_correct)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 82901) 82893) inline$$TestVector_test_reverse3_$def_verify$0$anon32_correct)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 82881) 82901) inline$$TestVector_test_reverse3_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 82881) 82891) inline$$TestVector_test_reverse3_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 82909) 82901) inline$$TestVector_test_reverse3_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 82909) 82891) inline$$TestVector_test_reverse3_$def_verify$0$anon48_Else_correct))))
(let ((inline$$WritebackToValue$4$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@1|) ($Local 0))) (= |inline$$WritebackToValue$4$vdst'@2@@1| |inline$$WritebackToValue$1$vdst'@2@@9|)) (and (=> (= (ControlFlow 0 82839) 82909) inline$$TestVector_test_reverse3_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 82839) 82881) inline$$TestVector_test_reverse3_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$WritebackToValue$4$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@1|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$4$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$4$to'@1@@1|) 0 |inline$$WritebackToValue$1$vdst'@2@@9| (|v#$Mutation| |inline$$WriteRef$4$to'@1@@1|))) (= |inline$$WritebackToValue$4$vdst'@2@@1| |inline$$WritebackToValue$4$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 82865) 82909) inline$$TestVector_test_reverse3_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 82865) 82881) inline$$TestVector_test_reverse3_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$WriteRef$4$anon0_correct@@1  (=> (= |inline$$WriteRef$4$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$4$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$4$dst@1@@1) |inline$$Vector_reverse$0$v'@1@@4|)) (and (=> (= (ControlFlow 0 82740) 82865) inline$$WritebackToValue$4$anon3_Then_correct@@1) (=> (= (ControlFlow 0 82740) 82839) inline$$WritebackToValue$4$anon3_Else_correct@@1)))))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon45_Else_correct  (=> (and (not false) (= (ControlFlow 0 82746) 82740)) inline$$WriteRef$4$anon0_correct@@1)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon45_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct@@4  (=> (and ((_ is $Vector) inline$$ReadRef$4$v@1@@1) (= |inline$$Vector_reverse$0$v'@1@@4| ($Vector (let ((l@@37 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@1))))
($ValueArray (|lambda#3| 0 l@@37 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@1)) l@@37 1 $Error) l@@37))))) (and (=> (= (ControlFlow 0 82675) 82913) inline$$TestVector_test_reverse3_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 82675) 82746) inline$$TestVector_test_reverse3_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Vector_reverse$0$Entry_correct@@4  (=> (and (= inline$$Vector_reverse$0$ta@0@@4 $IntegerType) (= (ControlFlow 0 82665) 82675)) inline$$Vector_reverse$0$anon0_correct@@4)))
(let ((inline$$ReadRef$4$anon0_correct@@1  (=> (and (= inline$$ReadRef$4$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$4$dst@1@@1)) (= (ControlFlow 0 82622) 82665)) inline$$Vector_reverse$0$Entry_correct@@4)))
(let ((inline$$BorrowLoc$4$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$4$dst@1@@1 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$1$vdst'@2@@9|)) (= (ControlFlow 0 82584) 82622)) inline$$ReadRef$4$anon0_correct@@1)))
(let ((inline$$WritebackToValue$3$anon3_Else_correct@@2  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@2|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$3$vdst'@2@@2| |inline$$WritebackToValue$2$vdst'@2@@5|) (= (ControlFlow 0 82502) 82584)) inline$$BorrowLoc$4$anon0_correct@@1))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct@@2  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@2|) ($Local 1)) (= |inline$$WritebackToValue$3$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1@@2|) 0 |inline$$WritebackToValue$2$vdst'@2@@5| (|v#$Mutation| |inline$$WriteRef$3$to'@1@@2|)))) (and (= |inline$$WritebackToValue$3$vdst'@2@@2| |inline$$WritebackToValue$3$vdst'@1@@2|) (= (ControlFlow 0 82528) 82584))) inline$$BorrowLoc$4$anon0_correct@@1)))
(let ((inline$$WriteRef$3$anon0_correct@@2  (=> (= |inline$$WriteRef$3$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$3$dst@1@@2) (|p#$Mutation| inline$$BorrowLoc$3$dst@1@@2) |inline$$Vector_push_back$3$v'@1@@2|)) (and (=> (= (ControlFlow 0 82403) 82528) inline$$WritebackToValue$3$anon3_Then_correct@@2) (=> (= (ControlFlow 0 82403) 82502) inline$$WritebackToValue$3$anon3_Else_correct@@2)))))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon43_Else_correct  (=> (and (not false) (= (ControlFlow 0 82409) 82403)) inline$$WriteRef$3$anon0_correct@@2)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon43_Then_correct true))
(let ((inline$$Vector_push_back$3$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$3$v@1@@2) (= |inline$$Vector_push_back$3$v'@1@@2| ($Vector (let ((len@@33 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@2))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@2)) len@@33 inline$$TestVector_test_reverse3_$def_verify$0$$t10@1) (+ len@@33 1)))))) (and (=> (= (ControlFlow 0 82338) 82941) inline$$TestVector_test_reverse3_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 82338) 82409) inline$$TestVector_test_reverse3_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Vector_push_back$3$Entry_correct@@2  (=> (and (= inline$$Vector_push_back$3$ta@0@@2 $IntegerType) (= (ControlFlow 0 82326) 82338)) inline$$Vector_push_back$3$anon0_correct@@2)))
(let ((inline$$ReadRef$3$anon0_correct@@2  (=> (and (= inline$$ReadRef$3$v@1@@2 (|v#$Mutation| inline$$BorrowLoc$3$dst@1@@2)) (= (ControlFlow 0 82275) 82326)) inline$$Vector_push_back$3$Entry_correct@@2)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon41_Else$3_correct  (=> (and (= inline$$TestVector_test_reverse3_$def_verify$0$$t10@1 ($Integer 2)) (= (ControlFlow 0 82281) 82275)) inline$$ReadRef$3$anon0_correct@@2)))
(let ((inline$$BorrowLoc$3$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$3$dst@1@@2 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$2$vdst'@2@@5|)) (= (ControlFlow 0 82233) 82281)) inline$$TestVector_test_reverse3_$def_verify$0$anon41_Else$3_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@6  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@6|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@5| inline$$Vector_empty$1$v@1@@8) (= (ControlFlow 0 82151) 82233)) inline$$BorrowLoc$3$anon0_correct@@2))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@6  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@6|) ($Local 1)) (= |inline$$WritebackToValue$2$vdst'@1@@6| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@6|) 0 inline$$Vector_empty$1$v@1@@8 (|v#$Mutation| |inline$$WriteRef$2$to'@1@@6|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@5| |inline$$WritebackToValue$2$vdst'@1@@6|) (= (ControlFlow 0 82177) 82233))) inline$$BorrowLoc$3$anon0_correct@@2)))
(let ((inline$$WriteRef$2$anon0_correct@@6  (=> (= |inline$$WriteRef$2$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@6) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@6) |inline$$Vector_push_back$2$v'@1@@4|)) (and (=> (= (ControlFlow 0 82052) 82177) inline$$WritebackToValue$2$anon3_Then_correct@@6) (=> (= (ControlFlow 0 82052) 82151) inline$$WritebackToValue$2$anon3_Else_correct@@6)))))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon41_Else_correct  (=> (and (not false) (= (ControlFlow 0 82058) 82052)) inline$$WriteRef$2$anon0_correct@@6)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon41_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@4  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@7) (= |inline$$Vector_push_back$2$v'@1@@4| ($Vector (let ((len@@34 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@7))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@7)) len@@34 inline$$TestVector_test_reverse3_$def_verify$0$$t8@1) (+ len@@34 1)))))) (and (=> (= (ControlFlow 0 81987) 82961) inline$$TestVector_test_reverse3_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 81987) 82058) inline$$TestVector_test_reverse3_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@4  (=> (and (= inline$$Vector_push_back$2$ta@0@@4 $IntegerType) (= (ControlFlow 0 81975) 81987)) inline$$Vector_push_back$2$anon0_correct@@4)))
(let ((inline$$ReadRef$2$anon0_correct@@7  (=> (and (= inline$$ReadRef$2$v@1@@7 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@6)) (= (ControlFlow 0 81924) 81975)) inline$$Vector_push_back$2$Entry_correct@@4)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon39_Else$3_correct  (=> (and (= inline$$TestVector_test_reverse3_$def_verify$0$$t8@1 ($Integer 1)) (= (ControlFlow 0 81930) 81924)) inline$$ReadRef$2$anon0_correct@@7)))
(let ((inline$$BorrowLoc$2$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$2$dst@1@@6 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1@@8)) (= (ControlFlow 0 81882) 81930)) inline$$TestVector_test_reverse3_$def_verify$0$anon39_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@10  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@11|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@9| |inline$$WritebackToValue$0$vdst'@2@@18|) (= (ControlFlow 0 81800) 81882)) inline$$BorrowLoc$2$anon0_correct@@6))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@10  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@11|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@10| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@11|) 0 |inline$$WritebackToValue$0$vdst'@2@@18| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@11|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@9| |inline$$WritebackToValue$1$vdst'@1@@10|) (= (ControlFlow 0 81826) 81882))) inline$$BorrowLoc$2$anon0_correct@@6)))
(let ((inline$$WriteRef$1$anon0_correct@@11  (=> (= |inline$$WriteRef$1$to'@1@@11| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@10) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@10) |inline$$Vector_push_back$1$v'@1@@6|)) (and (=> (= (ControlFlow 0 81701) 81826) inline$$WritebackToValue$1$anon3_Then_correct@@10) (=> (= (ControlFlow 0 81701) 81800) inline$$WritebackToValue$1$anon3_Else_correct@@10)))))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon39_Else_correct  (=> (and (not false) (= (ControlFlow 0 81707) 81701)) inline$$WriteRef$1$anon0_correct@@11)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon39_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@6  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@12) (= |inline$$Vector_push_back$1$v'@1@@6| ($Vector (let ((len@@35 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@12))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@12)) len@@35 inline$$TestVector_test_reverse3_$def_verify$0$$t6@1) (+ len@@35 1)))))) (and (=> (= (ControlFlow 0 81636) 82981) inline$$TestVector_test_reverse3_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 81636) 81707) inline$$TestVector_test_reverse3_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@6  (=> (and (= inline$$Vector_push_back$1$ta@0@@6 $IntegerType) (= (ControlFlow 0 81624) 81636)) inline$$Vector_push_back$1$anon0_correct@@6)))
(let ((inline$$ReadRef$1$anon0_correct@@12  (=> (and (= inline$$ReadRef$1$v@1@@12 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@10)) (= (ControlFlow 0 81573) 81624)) inline$$Vector_push_back$1$Entry_correct@@6)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon37_Else$3_correct  (=> (and (= inline$$TestVector_test_reverse3_$def_verify$0$$t6@1 ($Integer 2)) (= (ControlFlow 0 81579) 81573)) inline$$ReadRef$1$anon0_correct@@12)))
(let ((inline$$BorrowLoc$1$anon0_correct@@10  (=> (and (= inline$$BorrowLoc$1$dst@1@@10 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@18|)) (= (ControlFlow 0 81531) 81579)) inline$$TestVector_test_reverse3_$def_verify$0$anon37_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@20  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@20|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@18| inline$$Vector_empty$0$v@1@@16) (= (ControlFlow 0 81449) 81531)) inline$$BorrowLoc$1$anon0_correct@@10))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@20  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@20|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@20| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@20|) 0 inline$$Vector_empty$0$v@1@@16 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@20|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@18| |inline$$WritebackToValue$0$vdst'@1@@20|) (= (ControlFlow 0 81475) 81531))) inline$$BorrowLoc$1$anon0_correct@@10)))
(let ((inline$$WriteRef$0$anon0_correct@@20  (=> (= |inline$$WriteRef$0$to'@1@@20| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@20) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@20) |inline$$Vector_push_back$0$v'@1@@15|)) (and (=> (= (ControlFlow 0 81350) 81475) inline$$WritebackToValue$0$anon3_Then_correct@@20) (=> (= (ControlFlow 0 81350) 81449) inline$$WritebackToValue$0$anon3_Else_correct@@20)))))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon37_Else_correct  (=> (and (not false) (= (ControlFlow 0 81356) 81350)) inline$$WriteRef$0$anon0_correct@@20)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon37_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@15  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@20) (= |inline$$Vector_push_back$0$v'@1@@15| ($Vector (let ((len@@36 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@20))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@20)) len@@36 inline$$TestVector_test_reverse3_$def_verify$0$$t3@1) (+ len@@36 1)))))) (and (=> (= (ControlFlow 0 81285) 83001) inline$$TestVector_test_reverse3_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 81285) 81356) inline$$TestVector_test_reverse3_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@13  (=> (and (= inline$$Vector_push_back$0$ta@0@@13 $IntegerType) (= (ControlFlow 0 81273) 81285)) inline$$Vector_push_back$0$anon0_correct@@15)))
(let ((inline$$ReadRef$0$anon0_correct@@20  (=> (and (= inline$$ReadRef$0$v@1@@20 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@20)) (= (ControlFlow 0 81222) 81273)) inline$$Vector_push_back$0$Entry_correct@@13)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon35_Else$1_correct  (=> (and (= inline$$TestVector_test_reverse3_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 81228) 81222)) inline$$ReadRef$0$anon0_correct@@20)))
(let ((inline$$BorrowLoc$0$anon0_correct@@20  (=> (and (= inline$$BorrowLoc$0$dst@1@@20 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@16)) (= (ControlFlow 0 81180) 81228)) inline$$TestVector_test_reverse3_$def_verify$0$anon35_Else$1_correct)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon35_Else_correct  (=> (and (not false) (= (ControlFlow 0 81186) 81180)) inline$$BorrowLoc$0$anon0_correct@@20)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon35_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@8  (=> (= inline$$Vector_empty$1$v@1@@8 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 81118) 83021) inline$$TestVector_test_reverse3_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 81118) 81186) inline$$TestVector_test_reverse3_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@7  (=> (and (= inline$$Vector_empty$1$ta@0@@7 $IntegerType) (= (ControlFlow 0 81114) 81118)) inline$$Vector_empty$1$anon0_correct@@8)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon33_Else_correct  (=> (and (not false) (= (ControlFlow 0 81124) 81114)) inline$$Vector_empty$1$Entry_correct@@7)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon33_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@16  (=> (= inline$$Vector_empty$0$v@1@@16 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 81077) 83041) inline$$TestVector_test_reverse3_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 81077) 81124) inline$$TestVector_test_reverse3_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@13  (=> (and (= inline$$Vector_empty$0$ta@0@@13 $IntegerType) (= (ControlFlow 0 81073) 81077)) inline$$Vector_empty$0$anon0_correct@@16)))
(let ((inline$$TestVector_test_reverse3_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 81083) 81073)) inline$$Vector_empty$0$Entry_correct@@13)))
(let ((anon0_correct@@24  (=> (= (ControlFlow 0 122687) 81083) inline$$TestVector_test_reverse3_$def_verify$0$anon0_correct)))
anon0_correct@@24))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@22 () Bool)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@10| () T@$Value)
(declare-fun |inline$$WritebackToValue$7$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$7$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$6$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToValue$7$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$7$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$7$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$7$v@1 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$Vector_push_back$7$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$6$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$5$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToValue$6$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$6$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$6$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$6$v@1@@0 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Vector_push_back$6$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$5$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$4$vdst'@2@@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$5$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$5$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$5$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$5$v@1@@0 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$Vector_push_back$5$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$4$to'@1@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$3$vdst'@2@@3| () T@$Value)
(declare-fun |inline$$WritebackToValue$4$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$4$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$4$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@2 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$Vector_push_back$4$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$3$to'@1@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@6| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@1@@3| () T@$Value)
(declare-fun inline$$BorrowLoc$3$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$3$v'@1@@3| () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@3 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_push_back$3$ta@0@@3 () T@$TypeValue)
(declare-fun |inline$$WriteRef$2$to'@1@@7| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1@@9 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@7| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@7 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@5| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@8 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@5 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@12| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@19| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@11| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@11 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@7| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@13 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@7 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@21| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@17 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@21| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@21 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@16| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@21 () T@$Value)
(declare-fun inline$$TestVector_test_slice_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@14 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@8 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@14 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 124085) (let ((anon0$2_correct@@23  (and (=> (= (ControlFlow 0 87454) (- 0 126346)) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_slice_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3))))))))))))) (=> (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_slice_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3)))))))))))) (and (=> (= (ControlFlow 0 87454) (- 0 126371)) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_slice_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2)))))))))))))) (=> (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified inline$$TestVector_test_slice_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))))))))))) (and (=> (= (ControlFlow 0 87454) (- 0 126398)) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_slice_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))))))))))) (=> (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_slice_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))))))))))) (and (=> (= (ControlFlow 0 87454) (- 0 126423)) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2)))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))))))))))) (=> (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer 2)))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))))))))))) (and (=> (= (ControlFlow 0 87454) (- 0 126460)) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2)))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 2) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 2) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 2) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3))))))))))))) (=> (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 2)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 2)))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 2) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 2) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 2) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 2) ($Integer 3)))))))))))) (=> (= (ControlFlow 0 87454) (- 0 126497)) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 1) ($Integer 3)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 1) ($Integer 3)))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) (|v#$ValueArray| (|v#$Vector| inline$$TestVector_test_slice_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 4) ($Integer 6)))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 4) ($Integer 6)))))))))))))))))))))))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon44_correct  (=> (and (and (= $abort_flag@0@@22 false) (= inline$$TestVector_test_slice_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@10|)) (and (= inline$$TestVector_test_slice_$def_verify$0$$ret1@2 |inline$$WritebackToValue$7$vdst'@2|) (= (ControlFlow 0 87220) 87454))) anon0$2_correct@@23)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 87218) 87220)) inline$$TestVector_test_slice_$def_verify$0$anon44_correct)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 87228) 87220) inline$$TestVector_test_slice_$def_verify$0$anon44_correct)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon65_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 87208) 87228) inline$$TestVector_test_slice_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 87208) 87218) inline$$TestVector_test_slice_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon65_Then_correct  (and (=> (= (ControlFlow 0 87236) 87228) inline$$TestVector_test_slice_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 87236) 87218) inline$$TestVector_test_slice_$def_verify$0$anon66_Else_correct))))
(let ((inline$$WritebackToValue$7$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$7$to'@1|) ($Local 1))) (= |inline$$WritebackToValue$7$vdst'@2| |inline$$WritebackToValue$6$vdst'@2@@0|)) (and (=> (= (ControlFlow 0 87166) 87236) inline$$TestVector_test_slice_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 87166) 87208) inline$$TestVector_test_slice_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$WritebackToValue$7$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$7$to'@1|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$7$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$7$to'@1|) 0 |inline$$WritebackToValue$6$vdst'@2@@0| (|v#$Mutation| |inline$$WriteRef$7$to'@1|))) (= |inline$$WritebackToValue$7$vdst'@2| |inline$$WritebackToValue$7$vdst'@1|)) (and (=> (= (ControlFlow 0 87192) 87236) inline$$TestVector_test_slice_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 87192) 87208) inline$$TestVector_test_slice_$def_verify$0$anon65_Else_correct))))))
(let ((inline$$WriteRef$7$anon0_correct  (=> (= |inline$$WriteRef$7$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$7$dst@1) (|p#$Mutation| inline$$BorrowLoc$7$dst@1) |inline$$Vector_push_back$7$v'@1|)) (and (=> (= (ControlFlow 0 87067) 87192) inline$$WritebackToValue$7$anon3_Then_correct) (=> (= (ControlFlow 0 87067) 87166) inline$$WritebackToValue$7$anon3_Else_correct)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon63_Else_correct  (=> (and (not false) (= (ControlFlow 0 87073) 87067)) inline$$WriteRef$7$anon0_correct)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon63_Then_correct true))
(let ((inline$$Vector_push_back$7$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$7$v@1) (= |inline$$Vector_push_back$7$v'@1| ($Vector (let ((len@@37 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1)) len@@37 inline$$TestVector_test_slice_$def_verify$0$$t18@1) (+ len@@37 1)))))) (and (=> (= (ControlFlow 0 87002) 87240) inline$$TestVector_test_slice_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 87002) 87073) inline$$TestVector_test_slice_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$Vector_push_back$7$Entry_correct  (=> (and (= inline$$Vector_push_back$7$ta@0 $IntegerType) (= (ControlFlow 0 86990) 87002)) inline$$Vector_push_back$7$anon0_correct)))
(let ((inline$$ReadRef$7$anon0_correct  (=> (and (= inline$$ReadRef$7$v@1 (|v#$Mutation| inline$$BorrowLoc$7$dst@1)) (= (ControlFlow 0 86939) 86990)) inline$$Vector_push_back$7$Entry_correct)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon61_Else$3_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t18@1 ($Integer 2)) (= (ControlFlow 0 86945) 86939)) inline$$ReadRef$7$anon0_correct)))
(let ((inline$$BorrowLoc$7$anon0_correct  (=> (and (= inline$$BorrowLoc$7$dst@1 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$6$vdst'@2@@0|)) (= (ControlFlow 0 86897) 86945)) inline$$TestVector_test_slice_$def_verify$0$anon61_Else$3_correct)))
(let ((inline$$WritebackToValue$6$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$6$to'@1@@0|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$6$vdst'@2@@0| |inline$$WritebackToValue$5$vdst'@2@@0|) (= (ControlFlow 0 86815) 86897)) inline$$BorrowLoc$7$anon0_correct))))
(let ((inline$$WritebackToValue$6$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$6$to'@1@@0|) ($Local 1)) (= |inline$$WritebackToValue$6$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$6$to'@1@@0|) 0 |inline$$WritebackToValue$5$vdst'@2@@0| (|v#$Mutation| |inline$$WriteRef$6$to'@1@@0|)))) (and (= |inline$$WritebackToValue$6$vdst'@2@@0| |inline$$WritebackToValue$6$vdst'@1@@0|) (= (ControlFlow 0 86841) 86897))) inline$$BorrowLoc$7$anon0_correct)))
(let ((inline$$WriteRef$6$anon0_correct@@0  (=> (= |inline$$WriteRef$6$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$6$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$6$dst@1@@0) |inline$$Vector_push_back$6$v'@1|)) (and (=> (= (ControlFlow 0 86716) 86841) inline$$WritebackToValue$6$anon3_Then_correct@@0) (=> (= (ControlFlow 0 86716) 86815) inline$$WritebackToValue$6$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon61_Else_correct  (=> (and (not false) (= (ControlFlow 0 86722) 86716)) inline$$WriteRef$6$anon0_correct@@0)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon61_Then_correct true))
(let ((inline$$Vector_push_back$6$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$6$v@1@@0) (= |inline$$Vector_push_back$6$v'@1| ($Vector (let ((len@@38 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1@@0))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1@@0)) len@@38 inline$$TestVector_test_slice_$def_verify$0$$t16@1) (+ len@@38 1)))))) (and (=> (= (ControlFlow 0 86651) 87268) inline$$TestVector_test_slice_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 86651) 86722) inline$$TestVector_test_slice_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Vector_push_back$6$Entry_correct  (=> (and (= inline$$Vector_push_back$6$ta@0 $IntegerType) (= (ControlFlow 0 86639) 86651)) inline$$Vector_push_back$6$anon0_correct)))
(let ((inline$$ReadRef$6$anon0_correct@@0  (=> (and (= inline$$ReadRef$6$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$6$dst@1@@0)) (= (ControlFlow 0 86588) 86639)) inline$$Vector_push_back$6$Entry_correct)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon59_Else$3_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t16@1 ($Integer 1)) (= (ControlFlow 0 86594) 86588)) inline$$ReadRef$6$anon0_correct@@0)))
(let ((inline$$BorrowLoc$6$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$6$dst@1@@0 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$5$vdst'@2@@0|)) (= (ControlFlow 0 86546) 86594)) inline$$TestVector_test_slice_$def_verify$0$anon59_Else$3_correct)))
(let ((inline$$WritebackToValue$5$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$5$to'@1@@0|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$5$vdst'@2@@0| |inline$$WritebackToValue$4$vdst'@2@@2|) (= (ControlFlow 0 86464) 86546)) inline$$BorrowLoc$6$anon0_correct@@0))))
(let ((inline$$WritebackToValue$5$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$5$to'@1@@0|) ($Local 1)) (= |inline$$WritebackToValue$5$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$5$to'@1@@0|) 0 |inline$$WritebackToValue$4$vdst'@2@@2| (|v#$Mutation| |inline$$WriteRef$5$to'@1@@0|)))) (and (= |inline$$WritebackToValue$5$vdst'@2@@0| |inline$$WritebackToValue$5$vdst'@1@@0|) (= (ControlFlow 0 86490) 86546))) inline$$BorrowLoc$6$anon0_correct@@0)))
(let ((inline$$WriteRef$5$anon0_correct@@0  (=> (= |inline$$WriteRef$5$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$5$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$5$dst@1@@0) |inline$$Vector_push_back$5$v'@1@@0|)) (and (=> (= (ControlFlow 0 86365) 86490) inline$$WritebackToValue$5$anon3_Then_correct@@0) (=> (= (ControlFlow 0 86365) 86464) inline$$WritebackToValue$5$anon3_Else_correct@@0)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon59_Else_correct  (=> (and (not false) (= (ControlFlow 0 86371) 86365)) inline$$WriteRef$5$anon0_correct@@0)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon59_Then_correct true))
(let ((inline$$Vector_push_back$5$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$5$v@1@@0) (= |inline$$Vector_push_back$5$v'@1@@0| ($Vector (let ((len@@39 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@0))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@0)) len@@39 inline$$TestVector_test_slice_$def_verify$0$$t14@1) (+ len@@39 1)))))) (and (=> (= (ControlFlow 0 86300) 87288) inline$$TestVector_test_slice_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 86300) 86371) inline$$TestVector_test_slice_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Vector_push_back$5$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$5$ta@0@@0 $IntegerType) (= (ControlFlow 0 86288) 86300)) inline$$Vector_push_back$5$anon0_correct@@0)))
(let ((inline$$ReadRef$5$anon0_correct@@0  (=> (and (= inline$$ReadRef$5$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$5$dst@1@@0)) (= (ControlFlow 0 86237) 86288)) inline$$Vector_push_back$5$Entry_correct@@0)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon57_Else$3_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t14@1 ($Integer 3)) (= (ControlFlow 0 86243) 86237)) inline$$ReadRef$5$anon0_correct@@0)))
(let ((inline$$BorrowLoc$5$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$5$dst@1@@0 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$4$vdst'@2@@2|)) (= (ControlFlow 0 86195) 86243)) inline$$TestVector_test_slice_$def_verify$0$anon57_Else$3_correct)))
(let ((inline$$WritebackToValue$4$anon3_Else_correct@@2  (=> (not (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@2|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$4$vdst'@2@@2| |inline$$WritebackToValue$3$vdst'@2@@3|) (= (ControlFlow 0 86113) 86195)) inline$$BorrowLoc$5$anon0_correct@@0))))
(let ((inline$$WritebackToValue$4$anon3_Then_correct@@2  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@2|) ($Local 1)) (= |inline$$WritebackToValue$4$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$4$to'@1@@2|) 0 |inline$$WritebackToValue$3$vdst'@2@@3| (|v#$Mutation| |inline$$WriteRef$4$to'@1@@2|)))) (and (= |inline$$WritebackToValue$4$vdst'@2@@2| |inline$$WritebackToValue$4$vdst'@1@@2|) (= (ControlFlow 0 86139) 86195))) inline$$BorrowLoc$5$anon0_correct@@0)))
(let ((inline$$WriteRef$4$anon0_correct@@2  (=> (= |inline$$WriteRef$4$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$4$dst@1@@2) (|p#$Mutation| inline$$BorrowLoc$4$dst@1@@2) |inline$$Vector_push_back$4$v'@1@@0|)) (and (=> (= (ControlFlow 0 86014) 86139) inline$$WritebackToValue$4$anon3_Then_correct@@2) (=> (= (ControlFlow 0 86014) 86113) inline$$WritebackToValue$4$anon3_Else_correct@@2)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon57_Else_correct  (=> (and (not false) (= (ControlFlow 0 86020) 86014)) inline$$WriteRef$4$anon0_correct@@2)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon57_Then_correct true))
(let ((inline$$Vector_push_back$4$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$4$v@1@@2) (= |inline$$Vector_push_back$4$v'@1@@0| ($Vector (let ((len@@40 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@2))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@2)) len@@40 inline$$TestVector_test_slice_$def_verify$0$$t12@1) (+ len@@40 1)))))) (and (=> (= (ControlFlow 0 85949) 87308) inline$$TestVector_test_slice_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 85949) 86020) inline$$TestVector_test_slice_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Vector_push_back$4$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$4$ta@0@@0 $IntegerType) (= (ControlFlow 0 85937) 85949)) inline$$Vector_push_back$4$anon0_correct@@0)))
(let ((inline$$ReadRef$4$anon0_correct@@2  (=> (and (= inline$$ReadRef$4$v@1@@2 (|v#$Mutation| inline$$BorrowLoc$4$dst@1@@2)) (= (ControlFlow 0 85886) 85937)) inline$$Vector_push_back$4$Entry_correct@@0)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon55_Else$3_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t12@1 ($Integer 2)) (= (ControlFlow 0 85892) 85886)) inline$$ReadRef$4$anon0_correct@@2)))
(let ((inline$$BorrowLoc$4$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$4$dst@1@@2 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$3$vdst'@2@@3|)) (= (ControlFlow 0 85844) 85892)) inline$$TestVector_test_slice_$def_verify$0$anon55_Else$3_correct)))
(let ((inline$$WritebackToValue$3$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@3|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$3$vdst'@2@@3| |inline$$WritebackToValue$2$vdst'@2@@6|) (= (ControlFlow 0 85762) 85844)) inline$$BorrowLoc$4$anon0_correct@@2))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@3|) ($Local 1)) (= |inline$$WritebackToValue$3$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1@@3|) 0 |inline$$WritebackToValue$2$vdst'@2@@6| (|v#$Mutation| |inline$$WriteRef$3$to'@1@@3|)))) (and (= |inline$$WritebackToValue$3$vdst'@2@@3| |inline$$WritebackToValue$3$vdst'@1@@3|) (= (ControlFlow 0 85788) 85844))) inline$$BorrowLoc$4$anon0_correct@@2)))
(let ((inline$$WriteRef$3$anon0_correct@@3  (=> (= |inline$$WriteRef$3$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$3$dst@1@@3) (|p#$Mutation| inline$$BorrowLoc$3$dst@1@@3) |inline$$Vector_push_back$3$v'@1@@3|)) (and (=> (= (ControlFlow 0 85663) 85788) inline$$WritebackToValue$3$anon3_Then_correct@@3) (=> (= (ControlFlow 0 85663) 85762) inline$$WritebackToValue$3$anon3_Else_correct@@3)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon55_Else_correct  (=> (and (not false) (= (ControlFlow 0 85669) 85663)) inline$$WriteRef$3$anon0_correct@@3)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon55_Then_correct true))
(let ((inline$$Vector_push_back$3$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$ReadRef$3$v@1@@3) (= |inline$$Vector_push_back$3$v'@1@@3| ($Vector (let ((len@@41 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@3))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@3)) len@@41 inline$$TestVector_test_slice_$def_verify$0$$t10@1) (+ len@@41 1)))))) (and (=> (= (ControlFlow 0 85598) 87328) inline$$TestVector_test_slice_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 85598) 85669) inline$$TestVector_test_slice_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Vector_push_back$3$Entry_correct@@3  (=> (and (= inline$$Vector_push_back$3$ta@0@@3 $IntegerType) (= (ControlFlow 0 85586) 85598)) inline$$Vector_push_back$3$anon0_correct@@3)))
(let ((inline$$ReadRef$3$anon0_correct@@3  (=> (and (= inline$$ReadRef$3$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$3$dst@1@@3)) (= (ControlFlow 0 85535) 85586)) inline$$Vector_push_back$3$Entry_correct@@3)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon53_Else$3_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 85541) 85535)) inline$$ReadRef$3$anon0_correct@@3)))
(let ((inline$$BorrowLoc$3$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$3$dst@1@@3 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$2$vdst'@2@@6|)) (= (ControlFlow 0 85493) 85541)) inline$$TestVector_test_slice_$def_verify$0$anon53_Else$3_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@7  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@7|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@6| inline$$Vector_empty$1$v@1@@9) (= (ControlFlow 0 85411) 85493)) inline$$BorrowLoc$3$anon0_correct@@3))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@7  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@7|) ($Local 1)) (= |inline$$WritebackToValue$2$vdst'@1@@7| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@7|) 0 inline$$Vector_empty$1$v@1@@9 (|v#$Mutation| |inline$$WriteRef$2$to'@1@@7|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@6| |inline$$WritebackToValue$2$vdst'@1@@7|) (= (ControlFlow 0 85437) 85493))) inline$$BorrowLoc$3$anon0_correct@@3)))
(let ((inline$$WriteRef$2$anon0_correct@@7  (=> (= |inline$$WriteRef$2$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@7) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@7) |inline$$Vector_push_back$2$v'@1@@5|)) (and (=> (= (ControlFlow 0 85312) 85437) inline$$WritebackToValue$2$anon3_Then_correct@@7) (=> (= (ControlFlow 0 85312) 85411) inline$$WritebackToValue$2$anon3_Else_correct@@7)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon53_Else_correct  (=> (and (not false) (= (ControlFlow 0 85318) 85312)) inline$$WriteRef$2$anon0_correct@@7)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon53_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@5  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@8) (= |inline$$Vector_push_back$2$v'@1@@5| ($Vector (let ((len@@42 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@8))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@8)) len@@42 inline$$TestVector_test_slice_$def_verify$0$$t8@1) (+ len@@42 1)))))) (and (=> (= (ControlFlow 0 85247) 87348) inline$$TestVector_test_slice_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 85247) 85318) inline$$TestVector_test_slice_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@5  (=> (and (= inline$$Vector_push_back$2$ta@0@@5 $IntegerType) (= (ControlFlow 0 85235) 85247)) inline$$Vector_push_back$2$anon0_correct@@5)))
(let ((inline$$ReadRef$2$anon0_correct@@8  (=> (and (= inline$$ReadRef$2$v@1@@8 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@7)) (= (ControlFlow 0 85184) 85235)) inline$$Vector_push_back$2$Entry_correct@@5)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon51_Else$3_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t8@1 ($Integer 0)) (= (ControlFlow 0 85190) 85184)) inline$$ReadRef$2$anon0_correct@@8)))
(let ((inline$$BorrowLoc$2$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$2$dst@1@@7 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1@@9)) (= (ControlFlow 0 85142) 85190)) inline$$TestVector_test_slice_$def_verify$0$anon51_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@11  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@12|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@10| |inline$$WritebackToValue$0$vdst'@2@@19|) (= (ControlFlow 0 85060) 85142)) inline$$BorrowLoc$2$anon0_correct@@7))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@11  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@12|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@11| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@12|) 0 |inline$$WritebackToValue$0$vdst'@2@@19| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@12|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@10| |inline$$WritebackToValue$1$vdst'@1@@11|) (= (ControlFlow 0 85086) 85142))) inline$$BorrowLoc$2$anon0_correct@@7)))
(let ((inline$$WriteRef$1$anon0_correct@@12  (=> (= |inline$$WriteRef$1$to'@1@@12| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@11) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@11) |inline$$Vector_push_back$1$v'@1@@7|)) (and (=> (= (ControlFlow 0 84961) 85086) inline$$WritebackToValue$1$anon3_Then_correct@@11) (=> (= (ControlFlow 0 84961) 85060) inline$$WritebackToValue$1$anon3_Else_correct@@11)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon51_Else_correct  (=> (and (not false) (= (ControlFlow 0 84967) 84961)) inline$$WriteRef$1$anon0_correct@@12)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon51_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@7  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@13) (= |inline$$Vector_push_back$1$v'@1@@7| ($Vector (let ((len@@43 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@13))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@13)) len@@43 inline$$TestVector_test_slice_$def_verify$0$$t6@1) (+ len@@43 1)))))) (and (=> (= (ControlFlow 0 84896) 87368) inline$$TestVector_test_slice_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 84896) 84967) inline$$TestVector_test_slice_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@7  (=> (and (= inline$$Vector_push_back$1$ta@0@@7 $IntegerType) (= (ControlFlow 0 84884) 84896)) inline$$Vector_push_back$1$anon0_correct@@7)))
(let ((inline$$ReadRef$1$anon0_correct@@13  (=> (and (= inline$$ReadRef$1$v@1@@13 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@11)) (= (ControlFlow 0 84833) 84884)) inline$$Vector_push_back$1$Entry_correct@@7)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon49_Else$3_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t6@1 ($Integer 2)) (= (ControlFlow 0 84839) 84833)) inline$$ReadRef$1$anon0_correct@@13)))
(let ((inline$$BorrowLoc$1$anon0_correct@@11  (=> (and (= inline$$BorrowLoc$1$dst@1@@11 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@19|)) (= (ControlFlow 0 84791) 84839)) inline$$TestVector_test_slice_$def_verify$0$anon49_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@21  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@21|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@19| inline$$Vector_empty$0$v@1@@17) (= (ControlFlow 0 84709) 84791)) inline$$BorrowLoc$1$anon0_correct@@11))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@21  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@21|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@21| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@21|) 0 inline$$Vector_empty$0$v@1@@17 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@21|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@19| |inline$$WritebackToValue$0$vdst'@1@@21|) (= (ControlFlow 0 84735) 84791))) inline$$BorrowLoc$1$anon0_correct@@11)))
(let ((inline$$WriteRef$0$anon0_correct@@21  (=> (= |inline$$WriteRef$0$to'@1@@21| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@21) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@21) |inline$$Vector_push_back$0$v'@1@@16|)) (and (=> (= (ControlFlow 0 84610) 84735) inline$$WritebackToValue$0$anon3_Then_correct@@21) (=> (= (ControlFlow 0 84610) 84709) inline$$WritebackToValue$0$anon3_Else_correct@@21)))))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon49_Else_correct  (=> (and (not false) (= (ControlFlow 0 84616) 84610)) inline$$WriteRef$0$anon0_correct@@21)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon49_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@16  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@21) (= |inline$$Vector_push_back$0$v'@1@@16| ($Vector (let ((len@@44 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@21))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@21)) len@@44 inline$$TestVector_test_slice_$def_verify$0$$t3@1) (+ len@@44 1)))))) (and (=> (= (ControlFlow 0 84545) 87388) inline$$TestVector_test_slice_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 84545) 84616) inline$$TestVector_test_slice_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@14  (=> (and (= inline$$Vector_push_back$0$ta@0@@14 $IntegerType) (= (ControlFlow 0 84533) 84545)) inline$$Vector_push_back$0$anon0_correct@@16)))
(let ((inline$$ReadRef$0$anon0_correct@@21  (=> (and (= inline$$ReadRef$0$v@1@@21 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@21)) (= (ControlFlow 0 84482) 84533)) inline$$Vector_push_back$0$Entry_correct@@14)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon47_Else$1_correct  (=> (and (= inline$$TestVector_test_slice_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 84488) 84482)) inline$$ReadRef$0$anon0_correct@@21)))
(let ((inline$$BorrowLoc$0$anon0_correct@@21  (=> (and (= inline$$BorrowLoc$0$dst@1@@21 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@17)) (= (ControlFlow 0 84440) 84488)) inline$$TestVector_test_slice_$def_verify$0$anon47_Else$1_correct)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon47_Else_correct  (=> (and (not false) (= (ControlFlow 0 84446) 84440)) inline$$BorrowLoc$0$anon0_correct@@21)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon47_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@9  (=> (= inline$$Vector_empty$1$v@1@@9 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 84378) 87408) inline$$TestVector_test_slice_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 84378) 84446) inline$$TestVector_test_slice_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@8  (=> (and (= inline$$Vector_empty$1$ta@0@@8 $IntegerType) (= (ControlFlow 0 84374) 84378)) inline$$Vector_empty$1$anon0_correct@@9)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon45_Else_correct  (=> (and (not false) (= (ControlFlow 0 84384) 84374)) inline$$Vector_empty$1$Entry_correct@@8)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon45_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@17  (=> (= inline$$Vector_empty$0$v@1@@17 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 84337) 87428) inline$$TestVector_test_slice_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 84337) 84384) inline$$TestVector_test_slice_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@14  (=> (and (= inline$$Vector_empty$0$ta@0@@14 $IntegerType) (= (ControlFlow 0 84333) 84337)) inline$$Vector_empty$0$anon0_correct@@17)))
(let ((inline$$TestVector_test_slice_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 84343) 84333)) inline$$Vector_empty$0$Entry_correct@@14)))
(let ((anon0_correct@@25  (=> (= (ControlFlow 0 124085) 84343) inline$$TestVector_test_slice_$def_verify$0$anon0_correct)))
anon0_correct@@25)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@23 () Bool)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun |inline$$WritebackToValue$5$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@2@@4| () T@$Value)
(declare-fun |inline$$WriteRef$5$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$4$vdst'@2@@3| () T@$Value)
(declare-fun |inline$$WritebackToValue$5$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$5$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$Vector_swap$1$v'@2| () T@$Value)
(declare-fun |inline$$Vector_swap$1$v'@0| () T@$Value)
(declare-fun inline$$Vector_swap$1$i_ind@1 () Int)
(declare-fun inline$$ReadRef$5$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_swap$1$j_ind@1 () Int)
(declare-fun |inline$$Vector_swap$1$v'@1| () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Vector_swap$1$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$4$to'@1@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@11| () T@$Value)
(declare-fun |inline$$WritebackToValue$4$vdst'@1@@3| () T@$Value)
(declare-fun inline$$BorrowLoc$4$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@2@@1| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@0@@1| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@1@@1 () Int)
(declare-fun inline$$ReadRef$4$v@1@@3 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@1@@1 () Int)
(declare-fun |inline$$Vector_swap$0$v'@1@@1| () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Vector_swap$0$ta@0@@1 () T@$TypeValue)
(declare-fun |inline$$WriteRef$3$to'@1@@4| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@7| () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@1@@4| () T@$Value)
(declare-fun inline$$BorrowLoc$3$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$3$v'@1@@4| () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@4 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_push_back$3$ta@0@@4 () T@$TypeValue)
(declare-fun |inline$$WriteRef$2$to'@1@@8| () T@$Mutation)
(declare-fun inline$$Vector_empty$1$v@1@@10 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@8| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@8 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@6| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@9 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@6 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@13| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@20| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@12| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@12 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@8| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@14 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@8 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@22| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@18 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@22| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@22 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@17| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@22 () T@$Value)
(declare-fun inline$$TestVector_test_swap_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@15 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0@@9 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@15 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 126549) (let ((anon0$2_correct@@24  (=> (= (ControlFlow 0 91683) (- 0 128479)) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestVector_test_swap_$def_verify$0$$ret0@2 inline$$TestVector_test_swap_$def_verify$0$$ret1@2)))))))
(let ((inline$$TestVector_test_swap_$def_verify$0$Abort_correct  (=> (and (= inline$$TestVector_test_swap_$def_verify$0$$ret0@1 $Error) (= inline$$TestVector_test_swap_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= inline$$TestVector_test_swap_$def_verify$0$$ret0@2 inline$$TestVector_test_swap_$def_verify$0$$ret0@1) (= inline$$TestVector_test_swap_$def_verify$0$$ret1@2 inline$$TestVector_test_swap_$def_verify$0$$ret1@1)) (and (= $abort_flag@2@@4 true) (= (ControlFlow 0 91525) 91683))) anon0$2_correct@@24))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 91543) 91525)) inline$$TestVector_test_swap_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 91553) 91525) inline$$TestVector_test_swap_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon49_Then_correct  (=> $abort_flag@0@@23 (and (=> (= (ControlFlow 0 91537) 91553) inline$$TestVector_test_swap_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 91537) 91543) inline$$TestVector_test_swap_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 91515) 91525)) inline$$TestVector_test_swap_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 91533) 91525) inline$$TestVector_test_swap_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon51_Then_correct  (=> $abort_flag@1@@8 (and (=> (= (ControlFlow 0 91509) 91533) inline$$TestVector_test_swap_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 91509) 91515) inline$$TestVector_test_swap_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon36_correct  (=> (and (and (= inline$$TestVector_test_swap_$def_verify$0$$ret0@2 |inline$$WritebackToValue$5$vdst'@2@@1|) (= inline$$TestVector_test_swap_$def_verify$0$$ret1@2 |inline$$WritebackToValue$3$vdst'@2@@4|)) (and (= $abort_flag@2@@4 $abort_flag@1@@8) (= (ControlFlow 0 91489) 91683))) anon0$2_correct@@24)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 91487) 91489)) inline$$TestVector_test_swap_$def_verify$0$anon36_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 91497) 91489) inline$$TestVector_test_swap_$def_verify$0$anon36_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon53_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 91477) 91497) inline$$TestVector_test_swap_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 91477) 91487) inline$$TestVector_test_swap_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon53_Then_correct  (and (=> (= (ControlFlow 0 91505) 91497) inline$$TestVector_test_swap_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 91505) 91487) inline$$TestVector_test_swap_$def_verify$0$anon54_Else_correct))))
(let ((inline$$WritebackToValue$5$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$5$to'@1@@1|) ($Local 0))) (= |inline$$WritebackToValue$5$vdst'@2@@1| |inline$$WritebackToValue$4$vdst'@2@@3|)) (and (=> (= (ControlFlow 0 91435) 91505) inline$$TestVector_test_swap_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 91435) 91477) inline$$TestVector_test_swap_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$WritebackToValue$5$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WriteRef$5$to'@1@@1|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$5$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$5$to'@1@@1|) 0 |inline$$WritebackToValue$4$vdst'@2@@3| (|v#$Mutation| |inline$$WriteRef$5$to'@1@@1|))) (= |inline$$WritebackToValue$5$vdst'@2@@1| |inline$$WritebackToValue$5$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 91461) 91505) inline$$TestVector_test_swap_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 91461) 91477) inline$$TestVector_test_swap_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$WriteRef$5$anon0_correct@@1  (=> (= |inline$$WriteRef$5$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$5$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$5$dst@1@@1) |inline$$Vector_swap$1$v'@2|)) (and (=> (= (ControlFlow 0 91336) 91461) inline$$WritebackToValue$5$anon3_Then_correct@@1) (=> (= (ControlFlow 0 91336) 91435) inline$$WritebackToValue$5$anon3_Else_correct@@1)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon51_Else_correct  (=> (and (not $abort_flag@1@@8) (= (ControlFlow 0 91342) 91336)) inline$$WriteRef$5$anon0_correct@@1)))
(let ((inline$$Vector_swap$1$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@8 true) (= |inline$$Vector_swap$1$v'@2| |inline$$Vector_swap$1$v'@0|)) (and (=> (= (ControlFlow 0 91271) 91509) inline$$TestVector_test_swap_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 91271) 91342) inline$$TestVector_test_swap_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Vector_swap$1$anon3_Then_correct  (=> (and (or (or (or (>= inline$$Vector_swap$1$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1))) (>= inline$$Vector_swap$1$j_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1)))) (< inline$$Vector_swap$1$i_ind@1 0)) (< inline$$Vector_swap$1$j_ind@1 0)) (= (ControlFlow 0 91269) 91271)) inline$$Vector_swap$1$anon3_Then$1_correct)))
(let ((inline$$Vector_swap$1$anon3_Else_correct  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$1$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1))) (>= inline$$Vector_swap$1$j_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1)))) (< inline$$Vector_swap$1$i_ind@1 0)) (< inline$$Vector_swap$1$j_ind@1 0))) (= |inline$$Vector_swap$1$v'@1| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1)) inline$$Vector_swap$1$i_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1)) inline$$Vector_swap$1$j_ind@1)) inline$$Vector_swap$1$j_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1)) inline$$Vector_swap$1$i_ind@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1@@1)))))) (and (= $abort_flag@1@@8 $abort_flag@0@@23) (= |inline$$Vector_swap$1$v'@2| |inline$$Vector_swap$1$v'@1|))) (and (=> (= (ControlFlow 0 91193) 91509) inline$$TestVector_test_swap_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 91193) 91342) inline$$TestVector_test_swap_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Vector_swap$1$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$5$v@1@@1) (=> (and (= inline$$Vector_swap$1$i_ind@1 (|i#$Integer| inline$$TestVector_test_swap_$def_verify$0$$t15@1)) (= inline$$Vector_swap$1$j_ind@1 (|i#$Integer| inline$$TestVector_test_swap_$def_verify$0$$t16@1))) (and (=> (= (ControlFlow 0 91147) 91269) inline$$Vector_swap$1$anon3_Then_correct) (=> (= (ControlFlow 0 91147) 91193) inline$$Vector_swap$1$anon3_Else_correct))))))
(let ((inline$$Vector_swap$1$Entry_correct  (=> (= inline$$Vector_swap$1$ta@0 $IntegerType) (and (=> (= (ControlFlow 0 91133) (- 0 128092)) true) (=> (= (ControlFlow 0 91133) 91147) inline$$Vector_swap$1$anon0_correct)))))
(let ((inline$$ReadRef$5$anon0_correct@@1  (=> (and (= inline$$ReadRef$5$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$5$dst@1@@1)) (= (ControlFlow 0 90971) 91133)) inline$$Vector_swap$1$Entry_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon49_Else$3_correct  (=> (= inline$$TestVector_test_swap_$def_verify$0$$t15@1 ($Integer 0)) (=> (and (= inline$$TestVector_test_swap_$def_verify$0$$t16@1 ($Integer 1)) (= (ControlFlow 0 90977) 90971)) inline$$ReadRef$5$anon0_correct@@1))))
(let ((inline$$BorrowLoc$5$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$5$dst@1@@1 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$4$vdst'@2@@3|)) (= (ControlFlow 0 90925) 90977)) inline$$TestVector_test_swap_$def_verify$0$anon49_Else$3_correct)))
(let ((inline$$WritebackToValue$4$anon3_Else_correct@@3  (=> (not (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@3|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$4$vdst'@2@@3| |inline$$WritebackToValue$1$vdst'@2@@11|) (= (ControlFlow 0 90843) 90925)) inline$$BorrowLoc$5$anon0_correct@@1))))
(let ((inline$$WritebackToValue$4$anon3_Then_correct@@3  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$4$to'@1@@3|) ($Local 0)) (= |inline$$WritebackToValue$4$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$4$to'@1@@3|) 0 |inline$$WritebackToValue$1$vdst'@2@@11| (|v#$Mutation| |inline$$WriteRef$4$to'@1@@3|)))) (and (= |inline$$WritebackToValue$4$vdst'@2@@3| |inline$$WritebackToValue$4$vdst'@1@@3|) (= (ControlFlow 0 90869) 90925))) inline$$BorrowLoc$5$anon0_correct@@1)))
(let ((inline$$WriteRef$4$anon0_correct@@3  (=> (= |inline$$WriteRef$4$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$4$dst@1@@3) (|p#$Mutation| inline$$BorrowLoc$4$dst@1@@3) |inline$$Vector_swap$0$v'@2@@1|)) (and (=> (= (ControlFlow 0 90744) 90869) inline$$WritebackToValue$4$anon3_Then_correct@@3) (=> (= (ControlFlow 0 90744) 90843) inline$$WritebackToValue$4$anon3_Else_correct@@3)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon49_Else_correct  (=> (and (not $abort_flag@0@@23) (= (ControlFlow 0 90750) 90744)) inline$$WriteRef$4$anon0_correct@@3)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@23 true) (= |inline$$Vector_swap$0$v'@2@@1| |inline$$Vector_swap$0$v'@0@@1|)) (and (=> (= (ControlFlow 0 90679) 91537) inline$$TestVector_test_swap_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 90679) 90750) inline$$TestVector_test_swap_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct@@1  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3))) (>= inline$$Vector_swap$0$j_ind@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3)))) (< inline$$Vector_swap$0$i_ind@1@@1 0)) (< inline$$Vector_swap$0$j_ind@1@@1 0)) (= (ControlFlow 0 90677) 90679)) inline$$Vector_swap$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_swap$0$anon3_Else_correct@@1  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3))) (>= inline$$Vector_swap$0$j_ind@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3)))) (< inline$$Vector_swap$0$i_ind@1@@1 0)) (< inline$$Vector_swap$0$j_ind@1@@1 0))) (= |inline$$Vector_swap$0$v'@1@@1| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3)) inline$$Vector_swap$0$i_ind@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3)) inline$$Vector_swap$0$j_ind@1@@1)) inline$$Vector_swap$0$j_ind@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3)) inline$$Vector_swap$0$i_ind@1@@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1@@3)))))) (and (= $abort_flag@0@@23 false) (= |inline$$Vector_swap$0$v'@2@@1| |inline$$Vector_swap$0$v'@1@@1|))) (and (=> (= (ControlFlow 0 90601) 91537) inline$$TestVector_test_swap_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 90601) 90750) inline$$TestVector_test_swap_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct@@1  (=> ((_ is $Vector) inline$$ReadRef$4$v@1@@3) (=> (and (= inline$$Vector_swap$0$i_ind@1@@1 (|i#$Integer| inline$$TestVector_test_swap_$def_verify$0$$t12@1)) (= inline$$Vector_swap$0$j_ind@1@@1 (|i#$Integer| inline$$TestVector_test_swap_$def_verify$0$$t13@1))) (and (=> (= (ControlFlow 0 90555) 90677) inline$$Vector_swap$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 90555) 90601) inline$$Vector_swap$0$anon3_Else_correct@@1))))))
(let ((inline$$Vector_swap$0$Entry_correct@@1  (=> (= inline$$Vector_swap$0$ta@0@@1 $IntegerType) (and (=> (= (ControlFlow 0 90541) (- 0 127799)) true) (=> (= (ControlFlow 0 90541) 90555) inline$$Vector_swap$0$anon0_correct@@1)))))
(let ((inline$$ReadRef$4$anon0_correct@@3  (=> (and (= inline$$ReadRef$4$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$4$dst@1@@3)) (= (ControlFlow 0 90379) 90541)) inline$$Vector_swap$0$Entry_correct@@1)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon47_Else$3_correct  (=> (= inline$$TestVector_test_swap_$def_verify$0$$t12@1 ($Integer 0)) (=> (and (= inline$$TestVector_test_swap_$def_verify$0$$t13@1 ($Integer 0)) (= (ControlFlow 0 90385) 90379)) inline$$ReadRef$4$anon0_correct@@3))))
(let ((inline$$BorrowLoc$4$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$4$dst@1@@3 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$1$vdst'@2@@11|)) (= (ControlFlow 0 90333) 90385)) inline$$TestVector_test_swap_$def_verify$0$anon47_Else$3_correct)))
(let ((inline$$WritebackToValue$3$anon3_Else_correct@@4  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@4|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$3$vdst'@2@@4| |inline$$WritebackToValue$2$vdst'@2@@7|) (= (ControlFlow 0 90251) 90333)) inline$$BorrowLoc$4$anon0_correct@@3))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct@@4  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1@@4|) ($Local 1)) (= |inline$$WritebackToValue$3$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1@@4|) 0 |inline$$WritebackToValue$2$vdst'@2@@7| (|v#$Mutation| |inline$$WriteRef$3$to'@1@@4|)))) (and (= |inline$$WritebackToValue$3$vdst'@2@@4| |inline$$WritebackToValue$3$vdst'@1@@4|) (= (ControlFlow 0 90277) 90333))) inline$$BorrowLoc$4$anon0_correct@@3)))
(let ((inline$$WriteRef$3$anon0_correct@@4  (=> (= |inline$$WriteRef$3$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$3$dst@1@@4) (|p#$Mutation| inline$$BorrowLoc$3$dst@1@@4) |inline$$Vector_push_back$3$v'@1@@4|)) (and (=> (= (ControlFlow 0 90152) 90277) inline$$WritebackToValue$3$anon3_Then_correct@@4) (=> (= (ControlFlow 0 90152) 90251) inline$$WritebackToValue$3$anon3_Else_correct@@4)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon47_Else_correct  (=> (and (not false) (= (ControlFlow 0 90158) 90152)) inline$$WriteRef$3$anon0_correct@@4)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon47_Then_correct true))
(let ((inline$$Vector_push_back$3$anon0_correct@@4  (=> (and ((_ is $Vector) inline$$ReadRef$3$v@1@@4) (= |inline$$Vector_push_back$3$v'@1@@4| ($Vector (let ((len@@45 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@4))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@4)) len@@45 inline$$TestVector_test_swap_$def_verify$0$$t10@1) (+ len@@45 1)))))) (and (=> (= (ControlFlow 0 90087) 91557) inline$$TestVector_test_swap_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 90087) 90158) inline$$TestVector_test_swap_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$Vector_push_back$3$Entry_correct@@4  (=> (and (= inline$$Vector_push_back$3$ta@0@@4 $IntegerType) (= (ControlFlow 0 90075) 90087)) inline$$Vector_push_back$3$anon0_correct@@4)))
(let ((inline$$ReadRef$3$anon0_correct@@4  (=> (and (= inline$$ReadRef$3$v@1@@4 (|v#$Mutation| inline$$BorrowLoc$3$dst@1@@4)) (= (ControlFlow 0 90024) 90075)) inline$$Vector_push_back$3$Entry_correct@@4)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon45_Else$3_correct  (=> (and (= inline$$TestVector_test_swap_$def_verify$0$$t10@1 ($Integer 1)) (= (ControlFlow 0 90030) 90024)) inline$$ReadRef$3$anon0_correct@@4)))
(let ((inline$$BorrowLoc$3$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$3$dst@1@@4 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$2$vdst'@2@@7|)) (= (ControlFlow 0 89982) 90030)) inline$$TestVector_test_swap_$def_verify$0$anon45_Else$3_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@8  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@8|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@7| inline$$Vector_empty$1$v@1@@10) (= (ControlFlow 0 89900) 89982)) inline$$BorrowLoc$3$anon0_correct@@4))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@8  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@8|) ($Local 1)) (= |inline$$WritebackToValue$2$vdst'@1@@8| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@8|) 0 inline$$Vector_empty$1$v@1@@10 (|v#$Mutation| |inline$$WriteRef$2$to'@1@@8|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@7| |inline$$WritebackToValue$2$vdst'@1@@8|) (= (ControlFlow 0 89926) 89982))) inline$$BorrowLoc$3$anon0_correct@@4)))
(let ((inline$$WriteRef$2$anon0_correct@@8  (=> (= |inline$$WriteRef$2$to'@1@@8| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@8) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@8) |inline$$Vector_push_back$2$v'@1@@6|)) (and (=> (= (ControlFlow 0 89801) 89926) inline$$WritebackToValue$2$anon3_Then_correct@@8) (=> (= (ControlFlow 0 89801) 89900) inline$$WritebackToValue$2$anon3_Else_correct@@8)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon45_Else_correct  (=> (and (not false) (= (ControlFlow 0 89807) 89801)) inline$$WriteRef$2$anon0_correct@@8)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon45_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@6  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@9) (= |inline$$Vector_push_back$2$v'@1@@6| ($Vector (let ((len@@46 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@9))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@9)) len@@46 inline$$TestVector_test_swap_$def_verify$0$$t8@1) (+ len@@46 1)))))) (and (=> (= (ControlFlow 0 89736) 91577) inline$$TestVector_test_swap_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 89736) 89807) inline$$TestVector_test_swap_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@6  (=> (and (= inline$$Vector_push_back$2$ta@0@@6 $IntegerType) (= (ControlFlow 0 89724) 89736)) inline$$Vector_push_back$2$anon0_correct@@6)))
(let ((inline$$ReadRef$2$anon0_correct@@9  (=> (and (= inline$$ReadRef$2$v@1@@9 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@8)) (= (ControlFlow 0 89673) 89724)) inline$$Vector_push_back$2$Entry_correct@@6)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon43_Else$3_correct  (=> (and (= inline$$TestVector_test_swap_$def_verify$0$$t8@1 ($Integer 2)) (= (ControlFlow 0 89679) 89673)) inline$$ReadRef$2$anon0_correct@@9)))
(let ((inline$$BorrowLoc$2$anon0_correct@@8  (=> (and (= inline$$BorrowLoc$2$dst@1@@8 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$1$v@1@@10)) (= (ControlFlow 0 89631) 89679)) inline$$TestVector_test_swap_$def_verify$0$anon43_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@12  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@13|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@11| |inline$$WritebackToValue$0$vdst'@2@@20|) (= (ControlFlow 0 89549) 89631)) inline$$BorrowLoc$2$anon0_correct@@8))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@12  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@13|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@12| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@13|) 0 |inline$$WritebackToValue$0$vdst'@2@@20| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@13|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@11| |inline$$WritebackToValue$1$vdst'@1@@12|) (= (ControlFlow 0 89575) 89631))) inline$$BorrowLoc$2$anon0_correct@@8)))
(let ((inline$$WriteRef$1$anon0_correct@@13  (=> (= |inline$$WriteRef$1$to'@1@@13| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@12) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@12) |inline$$Vector_push_back$1$v'@1@@8|)) (and (=> (= (ControlFlow 0 89450) 89575) inline$$WritebackToValue$1$anon3_Then_correct@@12) (=> (= (ControlFlow 0 89450) 89549) inline$$WritebackToValue$1$anon3_Else_correct@@12)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon43_Else_correct  (=> (and (not false) (= (ControlFlow 0 89456) 89450)) inline$$WriteRef$1$anon0_correct@@13)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon43_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@8  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@14) (= |inline$$Vector_push_back$1$v'@1@@8| ($Vector (let ((len@@47 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@14))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@14)) len@@47 inline$$TestVector_test_swap_$def_verify$0$$t6@1) (+ len@@47 1)))))) (and (=> (= (ControlFlow 0 89385) 91597) inline$$TestVector_test_swap_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 89385) 89456) inline$$TestVector_test_swap_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@8  (=> (and (= inline$$Vector_push_back$1$ta@0@@8 $IntegerType) (= (ControlFlow 0 89373) 89385)) inline$$Vector_push_back$1$anon0_correct@@8)))
(let ((inline$$ReadRef$1$anon0_correct@@14  (=> (and (= inline$$ReadRef$1$v@1@@14 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@12)) (= (ControlFlow 0 89322) 89373)) inline$$Vector_push_back$1$Entry_correct@@8)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon41_Else$3_correct  (=> (and (= inline$$TestVector_test_swap_$def_verify$0$$t6@1 ($Integer 2)) (= (ControlFlow 0 89328) 89322)) inline$$ReadRef$1$anon0_correct@@14)))
(let ((inline$$BorrowLoc$1$anon0_correct@@12  (=> (and (= inline$$BorrowLoc$1$dst@1@@12 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@20|)) (= (ControlFlow 0 89280) 89328)) inline$$TestVector_test_swap_$def_verify$0$anon41_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@22  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@22|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@20| inline$$Vector_empty$0$v@1@@18) (= (ControlFlow 0 89198) 89280)) inline$$BorrowLoc$1$anon0_correct@@12))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@22  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@22|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@22| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@22|) 0 inline$$Vector_empty$0$v@1@@18 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@22|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@20| |inline$$WritebackToValue$0$vdst'@1@@22|) (= (ControlFlow 0 89224) 89280))) inline$$BorrowLoc$1$anon0_correct@@12)))
(let ((inline$$WriteRef$0$anon0_correct@@22  (=> (= |inline$$WriteRef$0$to'@1@@22| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@22) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@22) |inline$$Vector_push_back$0$v'@1@@17|)) (and (=> (= (ControlFlow 0 89099) 89224) inline$$WritebackToValue$0$anon3_Then_correct@@22) (=> (= (ControlFlow 0 89099) 89198) inline$$WritebackToValue$0$anon3_Else_correct@@22)))))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon41_Else_correct  (=> (and (not false) (= (ControlFlow 0 89105) 89099)) inline$$WriteRef$0$anon0_correct@@22)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon41_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@17  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@22) (= |inline$$Vector_push_back$0$v'@1@@17| ($Vector (let ((len@@48 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@22))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@22)) len@@48 inline$$TestVector_test_swap_$def_verify$0$$t3@1) (+ len@@48 1)))))) (and (=> (= (ControlFlow 0 89034) 91617) inline$$TestVector_test_swap_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 89034) 89105) inline$$TestVector_test_swap_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@15  (=> (and (= inline$$Vector_push_back$0$ta@0@@15 $IntegerType) (= (ControlFlow 0 89022) 89034)) inline$$Vector_push_back$0$anon0_correct@@17)))
(let ((inline$$ReadRef$0$anon0_correct@@22  (=> (and (= inline$$ReadRef$0$v@1@@22 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@22)) (= (ControlFlow 0 88971) 89022)) inline$$Vector_push_back$0$Entry_correct@@15)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon39_Else$1_correct  (=> (and (= inline$$TestVector_test_swap_$def_verify$0$$t3@1 ($Integer 1)) (= (ControlFlow 0 88977) 88971)) inline$$ReadRef$0$anon0_correct@@22)))
(let ((inline$$BorrowLoc$0$anon0_correct@@22  (=> (and (= inline$$BorrowLoc$0$dst@1@@22 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@18)) (= (ControlFlow 0 88929) 88977)) inline$$TestVector_test_swap_$def_verify$0$anon39_Else$1_correct)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon39_Else_correct  (=> (and (not false) (= (ControlFlow 0 88935) 88929)) inline$$BorrowLoc$0$anon0_correct@@22)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon39_Then_correct true))
(let ((inline$$Vector_empty$1$anon0_correct@@10  (=> (= inline$$Vector_empty$1$v@1@@10 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 88867) 91637) inline$$TestVector_test_swap_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 88867) 88935) inline$$TestVector_test_swap_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct@@9  (=> (and (= inline$$Vector_empty$1$ta@0@@9 $IntegerType) (= (ControlFlow 0 88863) 88867)) inline$$Vector_empty$1$anon0_correct@@10)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon37_Else_correct  (=> (and (not false) (= (ControlFlow 0 88873) 88863)) inline$$Vector_empty$1$Entry_correct@@9)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon37_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@18  (=> (= inline$$Vector_empty$0$v@1@@18 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 88826) 91657) inline$$TestVector_test_swap_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 88826) 88873) inline$$TestVector_test_swap_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@15  (=> (and (= inline$$Vector_empty$0$ta@0@@15 $IntegerType) (= (ControlFlow 0 88822) 88826)) inline$$Vector_empty$0$anon0_correct@@18)))
(let ((inline$$TestVector_test_swap_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 88832) 88822)) inline$$Vector_empty$0$Entry_correct@@15)))
(let ((anon0_correct@@26  (=> (= (ControlFlow 0 126549) 88832) inline$$TestVector_test_swap_$def_verify$0$anon0_correct)))
anon0_correct@@26))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun $abort_flag@0@@24 () Bool)
(declare-fun |inline$$WriteRef$1$to'@1@@14| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@13| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@21| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@13 () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@2@@2| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@0@@2| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@1@@2 () Int)
(declare-fun inline$$ReadRef$1$v@1@@15 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@1@@2 () Int)
(declare-fun |inline$$Vector_swap$0$v'@1@@2| () T@$Value)
(declare-fun inline$$TestVector_test_swap_abort1_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestVector_test_swap_abort1_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_swap$0$ta@0@@2 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@23| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@19 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@23| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@23 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@18| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@23 () T@$Value)
(declare-fun inline$$TestVector_test_swap_abort1_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@16 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@16 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 128501) (let ((anon0$2_correct@@25  (and (=> (= (ControlFlow 0 93526) (- 0 129225)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@9)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@9) (=> (= (ControlFlow 0 93526) (- 0 129234)) (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@1@@9 true) (= (ControlFlow 0 93472) 93526)) anon0$2_correct@@25)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 93466) 93472)) inline$$TestVector_test_swap_abort1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 93480) 93472) inline$$TestVector_test_swap_abort1_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Then_correct  (=> $abort_flag@0@@24 (and (=> (= (ControlFlow 0 93460) 93480) inline$$TestVector_test_swap_abort1_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 93460) 93466) inline$$TestVector_test_swap_abort1_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Else$2_correct  (=> (and (= $abort_flag@1@@9 $abort_flag@0@@24) (= (ControlFlow 0 93456) 93526)) anon0$2_correct@@25)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@13  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@14|) ($Local 0))) (= (ControlFlow 0 93422) 93456)) inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Else$2_correct)))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@13  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@14|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@13| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@14|) 0 |inline$$WritebackToValue$0$vdst'@2@@21| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@14|))) (= (ControlFlow 0 93448) 93456)) inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Else$2_correct))))
(let ((inline$$WriteRef$1$anon0_correct@@14  (=> (= |inline$$WriteRef$1$to'@1@@14| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@13) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@13) |inline$$Vector_swap$0$v'@2@@2|)) (and (=> (= (ControlFlow 0 93323) 93448) inline$$WritebackToValue$1$anon3_Then_correct@@13) (=> (= (ControlFlow 0 93323) 93422) inline$$WritebackToValue$1$anon3_Else_correct@@13)))))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Else_correct  (=> (and (not $abort_flag@0@@24) (= (ControlFlow 0 93329) 93323)) inline$$WriteRef$1$anon0_correct@@14)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@24 true) (= |inline$$Vector_swap$0$v'@2@@2| |inline$$Vector_swap$0$v'@0@@2|)) (and (=> (= (ControlFlow 0 93258) 93460) inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 93258) 93329) inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct@@2  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15))) (>= inline$$Vector_swap$0$j_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15)))) (< inline$$Vector_swap$0$i_ind@1@@2 0)) (< inline$$Vector_swap$0$j_ind@1@@2 0)) (= (ControlFlow 0 93256) 93258)) inline$$Vector_swap$0$anon3_Then$1_correct@@2)))
(let ((inline$$Vector_swap$0$anon3_Else_correct@@2  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15))) (>= inline$$Vector_swap$0$j_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15)))) (< inline$$Vector_swap$0$i_ind@1@@2 0)) (< inline$$Vector_swap$0$j_ind@1@@2 0))) (= |inline$$Vector_swap$0$v'@1@@2| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15)) inline$$Vector_swap$0$i_ind@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15)) inline$$Vector_swap$0$j_ind@1@@2)) inline$$Vector_swap$0$j_ind@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15)) inline$$Vector_swap$0$i_ind@1@@2)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@15)))))) (and (= $abort_flag@0@@24 false) (= |inline$$Vector_swap$0$v'@2@@2| |inline$$Vector_swap$0$v'@1@@2|))) (and (=> (= (ControlFlow 0 93180) 93460) inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 93180) 93329) inline$$TestVector_test_swap_abort1_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct@@2  (=> ((_ is $Vector) inline$$ReadRef$1$v@1@@15) (=> (and (= inline$$Vector_swap$0$i_ind@1@@2 (|i#$Integer| inline$$TestVector_test_swap_abort1_$def_verify$0$$t5@1)) (= inline$$Vector_swap$0$j_ind@1@@2 (|i#$Integer| inline$$TestVector_test_swap_abort1_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 93134) 93256) inline$$Vector_swap$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 93134) 93180) inline$$Vector_swap$0$anon3_Else_correct@@2))))))
(let ((inline$$Vector_swap$0$Entry_correct@@2  (=> (= inline$$Vector_swap$0$ta@0@@2 $IntegerType) (and (=> (= (ControlFlow 0 93120) (- 0 128968)) true) (=> (= (ControlFlow 0 93120) 93134) inline$$Vector_swap$0$anon0_correct@@2)))))
(let ((inline$$ReadRef$1$anon0_correct@@15  (=> (and (= inline$$ReadRef$1$v@1@@15 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@13)) (= (ControlFlow 0 92958) 93120)) inline$$Vector_swap$0$Entry_correct@@2)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon15_Else$3_correct  (=> (= inline$$TestVector_test_swap_abort1_$def_verify$0$$t5@1 ($Integer 1)) (=> (and (= inline$$TestVector_test_swap_abort1_$def_verify$0$$t6@1 ($Integer 0)) (= (ControlFlow 0 92964) 92958)) inline$$ReadRef$1$anon0_correct@@15))))
(let ((inline$$BorrowLoc$1$anon0_correct@@13  (=> (and (= inline$$BorrowLoc$1$dst@1@@13 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@21|)) (= (ControlFlow 0 92912) 92964)) inline$$TestVector_test_swap_abort1_$def_verify$0$anon15_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@23  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@23|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@21| inline$$Vector_empty$0$v@1@@19) (= (ControlFlow 0 92830) 92912)) inline$$BorrowLoc$1$anon0_correct@@13))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@23  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@23|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@23| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@23|) 0 inline$$Vector_empty$0$v@1@@19 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@23|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@21| |inline$$WritebackToValue$0$vdst'@1@@23|) (= (ControlFlow 0 92856) 92912))) inline$$BorrowLoc$1$anon0_correct@@13)))
(let ((inline$$WriteRef$0$anon0_correct@@23  (=> (= |inline$$WriteRef$0$to'@1@@23| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@23) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@23) |inline$$Vector_push_back$0$v'@1@@18|)) (and (=> (= (ControlFlow 0 92731) 92856) inline$$WritebackToValue$0$anon3_Then_correct@@23) (=> (= (ControlFlow 0 92731) 92830) inline$$WritebackToValue$0$anon3_Else_correct@@23)))))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon15_Else_correct  (=> (and (not false) (= (ControlFlow 0 92737) 92731)) inline$$WriteRef$0$anon0_correct@@23)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon15_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@18  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@23) (= |inline$$Vector_push_back$0$v'@1@@18| ($Vector (let ((len@@49 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@23))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@23)) len@@49 inline$$TestVector_test_swap_abort1_$def_verify$0$$t2@1) (+ len@@49 1)))))) (and (=> (= (ControlFlow 0 92666) 93484) inline$$TestVector_test_swap_abort1_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 92666) 92737) inline$$TestVector_test_swap_abort1_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@16  (=> (and (= inline$$Vector_push_back$0$ta@0@@16 $IntegerType) (= (ControlFlow 0 92654) 92666)) inline$$Vector_push_back$0$anon0_correct@@18)))
(let ((inline$$ReadRef$0$anon0_correct@@23  (=> (and (= inline$$ReadRef$0$v@1@@23 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@23)) (= (ControlFlow 0 92603) 92654)) inline$$Vector_push_back$0$Entry_correct@@16)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon13_Else$1_correct  (=> (and (= inline$$TestVector_test_swap_abort1_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 92609) 92603)) inline$$ReadRef$0$anon0_correct@@23)))
(let ((inline$$BorrowLoc$0$anon0_correct@@23  (=> (and (= inline$$BorrowLoc$0$dst@1@@23 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@19)) (= (ControlFlow 0 92561) 92609)) inline$$TestVector_test_swap_abort1_$def_verify$0$anon13_Else$1_correct)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon13_Else_correct  (=> (and (not false) (= (ControlFlow 0 92567) 92561)) inline$$BorrowLoc$0$anon0_correct@@23)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon13_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@19  (=> (= inline$$Vector_empty$0$v@1@@19 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 92499) 93504) inline$$TestVector_test_swap_abort1_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 92499) 92567) inline$$TestVector_test_swap_abort1_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@16  (=> (and (= inline$$Vector_empty$0$ta@0@@16 $IntegerType) (= (ControlFlow 0 92495) 92499)) inline$$Vector_empty$0$anon0_correct@@19)))
(let ((inline$$TestVector_test_swap_abort1_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 92505) 92495)) inline$$Vector_empty$0$Entry_correct@@16)))
(let ((anon0_correct@@27  (=> (= (ControlFlow 0 128501) 92505) inline$$TestVector_test_swap_abort1_$def_verify$0$anon0_correct)))
anon0_correct@@27)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@10 () Bool)
(declare-fun $abort_flag@0@@25 () Bool)
(declare-fun |inline$$WriteRef$1$to'@1@@15| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@14| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@22| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@14 () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@2@@3| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@0@@3| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@1@@3 () Int)
(declare-fun inline$$ReadRef$1$v@1@@16 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@1@@3 () Int)
(declare-fun |inline$$Vector_swap$0$v'@1@@3| () T@$Value)
(declare-fun inline$$TestVector_test_swap_abort2_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestVector_test_swap_abort2_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Vector_swap$0$ta@0@@3 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@24| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@20 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@24| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@24 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@19| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@24 () T@$Value)
(declare-fun inline$$TestVector_test_swap_abort2_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@17 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@17 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 129248) (let ((anon0$2_correct@@26  (and (=> (= (ControlFlow 0 95037) (- 0 129972)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@10)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@10) (=> (= (ControlFlow 0 95037) (- 0 129981)) (=> $abort_flag@1@@10 (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@1@@10 true) (= (ControlFlow 0 94983) 95037)) anon0$2_correct@@26)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 94977) 94983)) inline$$TestVector_test_swap_abort2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 94991) 94983) inline$$TestVector_test_swap_abort2_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Then_correct  (=> $abort_flag@0@@25 (and (=> (= (ControlFlow 0 94971) 94991) inline$$TestVector_test_swap_abort2_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 94971) 94977) inline$$TestVector_test_swap_abort2_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Else$2_correct  (=> (and (= $abort_flag@1@@10 $abort_flag@0@@25) (= (ControlFlow 0 94967) 95037)) anon0$2_correct@@26)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@14  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@15|) ($Local 0))) (= (ControlFlow 0 94933) 94967)) inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Else$2_correct)))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@14  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@15|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@14| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@15|) 0 |inline$$WritebackToValue$0$vdst'@2@@22| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@15|))) (= (ControlFlow 0 94959) 94967)) inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Else$2_correct))))
(let ((inline$$WriteRef$1$anon0_correct@@15  (=> (= |inline$$WriteRef$1$to'@1@@15| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@14) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@14) |inline$$Vector_swap$0$v'@2@@3|)) (and (=> (= (ControlFlow 0 94834) 94959) inline$$WritebackToValue$1$anon3_Then_correct@@14) (=> (= (ControlFlow 0 94834) 94933) inline$$WritebackToValue$1$anon3_Else_correct@@14)))))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Else_correct  (=> (and (not $abort_flag@0@@25) (= (ControlFlow 0 94840) 94834)) inline$$WriteRef$1$anon0_correct@@15)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@0@@25 true) (= |inline$$Vector_swap$0$v'@2@@3| |inline$$Vector_swap$0$v'@0@@3|)) (and (=> (= (ControlFlow 0 94769) 94971) inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 94769) 94840) inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct@@3  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@3 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16))) (>= inline$$Vector_swap$0$j_ind@1@@3 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16)))) (< inline$$Vector_swap$0$i_ind@1@@3 0)) (< inline$$Vector_swap$0$j_ind@1@@3 0)) (= (ControlFlow 0 94767) 94769)) inline$$Vector_swap$0$anon3_Then$1_correct@@3)))
(let ((inline$$Vector_swap$0$anon3_Else_correct@@3  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@3 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16))) (>= inline$$Vector_swap$0$j_ind@1@@3 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16)))) (< inline$$Vector_swap$0$i_ind@1@@3 0)) (< inline$$Vector_swap$0$j_ind@1@@3 0))) (= |inline$$Vector_swap$0$v'@1@@3| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16)) inline$$Vector_swap$0$i_ind@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16)) inline$$Vector_swap$0$j_ind@1@@3)) inline$$Vector_swap$0$j_ind@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16)) inline$$Vector_swap$0$i_ind@1@@3)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@16)))))) (and (= $abort_flag@0@@25 false) (= |inline$$Vector_swap$0$v'@2@@3| |inline$$Vector_swap$0$v'@1@@3|))) (and (=> (= (ControlFlow 0 94691) 94971) inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 94691) 94840) inline$$TestVector_test_swap_abort2_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct@@3  (=> ((_ is $Vector) inline$$ReadRef$1$v@1@@16) (=> (and (= inline$$Vector_swap$0$i_ind@1@@3 (|i#$Integer| inline$$TestVector_test_swap_abort2_$def_verify$0$$t5@1)) (= inline$$Vector_swap$0$j_ind@1@@3 (|i#$Integer| inline$$TestVector_test_swap_abort2_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 94645) 94767) inline$$Vector_swap$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 94645) 94691) inline$$Vector_swap$0$anon3_Else_correct@@3))))))
(let ((inline$$Vector_swap$0$Entry_correct@@3  (=> (= inline$$Vector_swap$0$ta@0@@3 $IntegerType) (and (=> (= (ControlFlow 0 94631) (- 0 129715)) true) (=> (= (ControlFlow 0 94631) 94645) inline$$Vector_swap$0$anon0_correct@@3)))))
(let ((inline$$ReadRef$1$anon0_correct@@16  (=> (and (= inline$$ReadRef$1$v@1@@16 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@14)) (= (ControlFlow 0 94469) 94631)) inline$$Vector_swap$0$Entry_correct@@3)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon15_Else$3_correct  (=> (= inline$$TestVector_test_swap_abort2_$def_verify$0$$t5@1 ($Integer 0)) (=> (and (= inline$$TestVector_test_swap_abort2_$def_verify$0$$t6@1 ($Integer 1)) (= (ControlFlow 0 94475) 94469)) inline$$ReadRef$1$anon0_correct@@16))))
(let ((inline$$BorrowLoc$1$anon0_correct@@14  (=> (and (= inline$$BorrowLoc$1$dst@1@@14 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@22|)) (= (ControlFlow 0 94423) 94475)) inline$$TestVector_test_swap_abort2_$def_verify$0$anon15_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@24  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@24|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@22| inline$$Vector_empty$0$v@1@@20) (= (ControlFlow 0 94341) 94423)) inline$$BorrowLoc$1$anon0_correct@@14))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@24  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@24|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@24| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@24|) 0 inline$$Vector_empty$0$v@1@@20 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@24|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@22| |inline$$WritebackToValue$0$vdst'@1@@24|) (= (ControlFlow 0 94367) 94423))) inline$$BorrowLoc$1$anon0_correct@@14)))
(let ((inline$$WriteRef$0$anon0_correct@@24  (=> (= |inline$$WriteRef$0$to'@1@@24| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@24) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@24) |inline$$Vector_push_back$0$v'@1@@19|)) (and (=> (= (ControlFlow 0 94242) 94367) inline$$WritebackToValue$0$anon3_Then_correct@@24) (=> (= (ControlFlow 0 94242) 94341) inline$$WritebackToValue$0$anon3_Else_correct@@24)))))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon15_Else_correct  (=> (and (not false) (= (ControlFlow 0 94248) 94242)) inline$$WriteRef$0$anon0_correct@@24)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon15_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@19  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@24) (= |inline$$Vector_push_back$0$v'@1@@19| ($Vector (let ((len@@50 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@24))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@24)) len@@50 inline$$TestVector_test_swap_abort2_$def_verify$0$$t2@1) (+ len@@50 1)))))) (and (=> (= (ControlFlow 0 94177) 94995) inline$$TestVector_test_swap_abort2_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 94177) 94248) inline$$TestVector_test_swap_abort2_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@17  (=> (and (= inline$$Vector_push_back$0$ta@0@@17 $IntegerType) (= (ControlFlow 0 94165) 94177)) inline$$Vector_push_back$0$anon0_correct@@19)))
(let ((inline$$ReadRef$0$anon0_correct@@24  (=> (and (= inline$$ReadRef$0$v@1@@24 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@24)) (= (ControlFlow 0 94114) 94165)) inline$$Vector_push_back$0$Entry_correct@@17)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon13_Else$1_correct  (=> (and (= inline$$TestVector_test_swap_abort2_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 94120) 94114)) inline$$ReadRef$0$anon0_correct@@24)))
(let ((inline$$BorrowLoc$0$anon0_correct@@24  (=> (and (= inline$$BorrowLoc$0$dst@1@@24 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@20)) (= (ControlFlow 0 94072) 94120)) inline$$TestVector_test_swap_abort2_$def_verify$0$anon13_Else$1_correct)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon13_Else_correct  (=> (and (not false) (= (ControlFlow 0 94078) 94072)) inline$$BorrowLoc$0$anon0_correct@@24)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon13_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@20  (=> (= inline$$Vector_empty$0$v@1@@20 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 94010) 95015) inline$$TestVector_test_swap_abort2_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 94010) 94078) inline$$TestVector_test_swap_abort2_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@17  (=> (and (= inline$$Vector_empty$0$ta@0@@17 $IntegerType) (= (ControlFlow 0 94006) 94010)) inline$$Vector_empty$0$anon0_correct@@20)))
(let ((inline$$TestVector_test_swap_abort2_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 94016) 94006)) inline$$Vector_empty$0$Entry_correct@@17)))
(let ((anon0_correct@@28  (=> (= (ControlFlow 0 129248) 94016) inline$$TestVector_test_swap_abort2_$def_verify$0$anon0_correct)))
anon0_correct@@28)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun _v () T@$Value)
(declare-fun _w () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@25 () T@$Mutation)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 129998) (let ((anon0$2_correct@@27  (and (=> (= (ControlFlow 0 95614) (- 0 130420)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 95614) (- 0 130429)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 95614) (- 0 130438)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v _v))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v _v)))) (and (=> (= (ControlFlow 0 95614) (- 0 130453)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v _v))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v _v)))) (and (=> (= (ControlFlow 0 95614) (- 0 130468)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))))))) (and (=> (= (ControlFlow 0 95614) (- 0 130495)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))))))) (and (=> (= (ControlFlow 0 95614) (- 0 130522)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _w _w))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _w _w)))) (and (=> (= (ControlFlow 0 95614) (- 0 130535)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _w _w))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _w _w)))) (and (=> (= (ControlFlow 0 95614) (- 0 130550)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _w ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w))))))) (|v#$ValueArray| (|v#$Vector| _w)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _w ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w))))))) (|v#$ValueArray| (|v#$Vector| _w)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))))))))))) (=> (= (ControlFlow 0 95614) (- 0 130574)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _w ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w))))))) (|v#$ValueArray| (|v#$Vector| _w)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _w)))))))))))))))))))))))))))))))))))
(let ((inline$$TestVector_test_vector_equal_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 95580) 95614)) anon0$2_correct@@27)))
(let ((inline$$TestVector_test_vector_equal_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 95590) 95614) anon0$2_correct@@27)))
(let ((inline$$BorrowLoc$0$anon0_correct@@25  (=> (= inline$$BorrowLoc$0$dst@1@@25 ($Mutation ($Local 2) $EmptyPath _w)) (and (=> (= (ControlFlow 0 95564) 95590) inline$$TestVector_test_vector_equal_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 95564) 95580) inline$$TestVector_test_vector_equal_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestVector_test_vector_equal_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 95480) 95564)) inline$$BorrowLoc$0$anon0_correct@@25)))
(let ((inline$$TestVector_test_vector_equal_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 95598) 95564) inline$$BorrowLoc$0$anon0_correct@@25)))
(let ((inline$$TestVector_test_vector_equal_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 95472) 95598) inline$$TestVector_test_vector_equal_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 95472) 95480) inline$$TestVector_test_vector_equal_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestVector_test_vector_equal_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 95606) 95598) inline$$TestVector_test_vector_equal_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 95606) 95480) inline$$TestVector_test_vector_equal_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestVector_test_vector_equal_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 95466) 95606) inline$$TestVector_test_vector_equal_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 95466) 95472) inline$$TestVector_test_vector_equal_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@29  (=> (and (and ((_ is $Vector) _v) (let ((va@@27 (|v#$Vector| _v)))
(let ((l@@38 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@32))
)))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| _v)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0@@8)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0@@8))
))) (=> (and (and (and ((_ is $Vector) _w) (let ((va@@28 (|v#$Vector| _w)))
(let ((l@@39 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@33))
)))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| _w)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _w)) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _w)) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _w)) $$0@@9)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _w)) $$0@@9))
))) (= (ControlFlow 0 95324) 95466)) inline$$TestVector_test_vector_equal_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 129998) 95324) anon0_correct@@29)))
PreconditionGeneratedEntry_correct@@8))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@26 () Bool)
(declare-fun inline$$Vector_is_empty$0$b@1@@2 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@25| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@25| () T@$Value)
(declare-fun inline$$TestVector_T_unpack$0$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@26 () T@$Mutation)
(declare-fun |inline$$Vector_pop_back$0$v'@2@@1| () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@0@@1| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$len@1@@1 () Int)
(declare-fun inline$$Vector_pop_back$0$e@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@25 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@1@@1| () T@$Value)
(declare-fun x@@34 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 130608) (let ((inline$$TestVector_unwrap_or_$def_verify$0$Abort_correct true))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 96894) 96902)) inline$$TestVector_unwrap_or_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 96910) 96902) inline$$TestVector_unwrap_or_$def_verify$0$Abort_correct)))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon30_Then_correct  (=> $abort_flag@0@@26 (and (=> (= (ControlFlow 0 96888) 96910) inline$$TestVector_unwrap_or_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 96888) 96894) inline$$TestVector_unwrap_or_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon33_Else_correct true))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon33_Then_correct true))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 96956) 96876) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 96956) 96866) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 96966) 96876) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 96966) 96866) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Else_correct))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon28_Then_correct  (=> (|b#$Boolean| inline$$Vector_is_empty$0$b@1@@2) (and (=> (= (ControlFlow 0 96948) 96966) inline$$TestVector_unwrap_or_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 96948) 96956) inline$$TestVector_unwrap_or_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 96854) 96876) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 96854) 96866) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 96884) 96876) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 96884) 96866) inline$$TestVector_unwrap_or_$def_verify$0$anon33_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@25  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@25|) ($Local 3))) (and (=> (= (ControlFlow 0 96780) 96884) inline$$TestVector_unwrap_or_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 96780) 96854) inline$$TestVector_unwrap_or_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@25  (=> (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@25|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1@@25| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@25|) 0 inline$$TestVector_T_unpack$0$v@1@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@25|)))) (and (=> (= (ControlFlow 0 96806) 96884) inline$$TestVector_unwrap_or_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 96806) 96854) inline$$TestVector_unwrap_or_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@25  (=> (= |inline$$WriteRef$0$to'@1@@25| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@26) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@26) |inline$$Vector_pop_back$0$v'@2@@1|)) (and (=> (= (ControlFlow 0 96681) 96806) inline$$WritebackToValue$0$anon3_Then_correct@@25) (=> (= (ControlFlow 0 96681) 96780) inline$$WritebackToValue$0$anon3_Else_correct@@25)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon30_Else_correct  (=> (and (not $abort_flag@0@@26) (= (ControlFlow 0 96687) 96681)) inline$$WriteRef$0$anon0_correct@@25)))
(let ((inline$$Vector_pop_back$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@26 true) (= |inline$$Vector_pop_back$0$v'@2@@1| |inline$$Vector_pop_back$0$v'@0@@1|)) (and (=> (= (ControlFlow 0 96614) 96888) inline$$TestVector_unwrap_or_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 96614) 96687) inline$$TestVector_unwrap_or_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Vector_pop_back$0$anon3_Then_correct@@1  (=> (and (= inline$$Vector_pop_back$0$len@1@@1 0) (= (ControlFlow 0 96612) 96614)) inline$$Vector_pop_back$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_pop_back$0$anon3_Else_correct@@1  (=> (not (= inline$$Vector_pop_back$0$len@1@@1 0)) (=> (and (and (= inline$$Vector_pop_back$0$e@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@25)) (- inline$$Vector_pop_back$0$len@1@@1 1))) (= |inline$$Vector_pop_back$0$v'@1@@1| ($Vector (let ((l@@40 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@25)) 1)))
($ValueArray (|lambda#0| 0 l@@40 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@25)) $Error) l@@40))))) (and (= $abort_flag@0@@26 false) (= |inline$$Vector_pop_back$0$v'@2@@1| |inline$$Vector_pop_back$0$v'@1@@1|))) (and (=> (= (ControlFlow 0 96564) 96888) inline$$TestVector_unwrap_or_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 96564) 96687) inline$$TestVector_unwrap_or_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@25) (= inline$$Vector_pop_back$0$len@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@25)))) (and (=> (= (ControlFlow 0 96542) 96612) inline$$Vector_pop_back$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 96542) 96564) inline$$Vector_pop_back$0$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$0$anon0_correct@@25  (=> (and (= inline$$ReadRef$0$v@1@@25 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@26)) (= (ControlFlow 0 96431) 96542)) inline$$Vector_pop_back$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@26  (=> (and (= inline$$BorrowLoc$0$dst@1@@26 ($Mutation ($Local 3) $EmptyPath inline$$TestVector_T_unpack$0$v@1@@0)) (= (ControlFlow 0 96393) 96431)) inline$$ReadRef$0$anon0_correct@@25)))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon28_Else_correct  (=> (and (not (|b#$Boolean| inline$$Vector_is_empty$0$b@1@@2)) (= (ControlFlow 0 96399) 96393)) inline$$BorrowLoc$0$anon0_correct@@26)))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon26_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 96337) 96948) inline$$TestVector_unwrap_or_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 96337) 96399) inline$$TestVector_unwrap_or_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon26_Then_correct true))
(let ((inline$$Vector_is_empty$0$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$TestVector_T_unpack$0$v@1@@0) (= inline$$Vector_is_empty$0$b@1@@2 ($Boolean (= (|l#$ValueArray| (|v#$Vector| inline$$TestVector_T_unpack$0$v@1@@0)) 0)))) (and (=> (= (ControlFlow 0 96323) 96970) inline$$TestVector_unwrap_or_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 96323) 96337) inline$$TestVector_unwrap_or_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 96264) 96323)) inline$$Vector_is_empty$0$anon0_correct@@2)))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 96994) 96323) inline$$Vector_is_empty$0$anon0_correct@@2)))
(let ((inline$$TestVector_T_unpack$0$anon0_correct@@0  (=> (and (and ((_ is $Vector) x@@34) (= inline$$TestVector_T_unpack$0$v@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@34)) $TestVector_T_v))) (and ((_ is $Vector) inline$$TestVector_T_unpack$0$v@1@@0) (let ((va@@29 (|v#$Vector| inline$$TestVector_T_unpack$0$v@1@@0)))
(let ((l@@41 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@35))
))))))) (and (=> (= (ControlFlow 0 96250) 96994) inline$$TestVector_unwrap_or_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 96250) 96264) inline$$TestVector_unwrap_or_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 96123) 96250)) inline$$TestVector_T_unpack$0$anon0_correct@@0)))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 97002) 96250) inline$$TestVector_T_unpack$0$anon0_correct@@0)))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 96115) 97002) inline$$TestVector_unwrap_or_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 96115) 96123) inline$$TestVector_unwrap_or_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 97010) 97002) inline$$TestVector_unwrap_or_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 97010) 96123) inline$$TestVector_unwrap_or_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestVector_unwrap_or_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 96109) 97010) inline$$TestVector_unwrap_or_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 96109) 96115) inline$$TestVector_unwrap_or_$def_verify$0$anon23_Else_correct)))))
(let ((anon0_correct@@30  (=> (and (and (and (and (and ((_ is $Vector) x@@34) (let ((va@@30 (|v#$Vector| x@@34)))
(let ((l@@42 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| x@@34)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@34)) $TestVector_T_v)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| x@@34)) $TestVector_T_v))))
(let ((l@@43 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@37))
))))))) true) (= (ControlFlow 0 95712) 96109)) inline$$TestVector_unwrap_or_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 130608) 95712) anon0_correct@@30)))
PreconditionGeneratedEntry_correct@@9))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@27 () Bool)
(declare-fun inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@8| () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1@@9| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@12| () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@9| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1@@9 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$2$v'@1@@7| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@10 () T@$Value)
(declare-fun inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Vector_push_back$2$ta@0@@7 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1@@16| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@23| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@15| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@15 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1@@9| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@17 () T@$Value)
(declare-fun inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0@@9 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@26| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@21 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@26| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@27 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@20| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@26 () T@$Value)
(declare-fun inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@18 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0@@18 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 131237) (let ((anon0$2_correct@@28  (and (=> (= (ControlFlow 0 98807) (- 0 132215)) (=> (not $abort_flag@0@@27) (|b#$Boolean| ($Boolean (let (($range_1@@0 inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2))
(forall (($i_0@@1 Int) )  (=> (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((n (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@1)))
(|b#$Boolean| ($Boolean (> (|i#$Integer| n) (|i#$Integer| ($Integer 0))))))))))))) (=> (=> (not $abort_flag@0@@27) (|b#$Boolean| ($Boolean (let (($range_1@@0 inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2))
(forall (($i_0@@2 Int) )  (=> (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((n (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@2)))
(|b#$Boolean| ($Boolean (> (|i#$Integer| n) (|i#$Integer| ($Integer 0)))))))))))) (=> (= (ControlFlow 0 98807) (- 0 132262)) (=> (not $abort_flag@0@@27) (|b#$Boolean| ($Boolean (let (($range_3@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2))))))
(forall (($i_2@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@0)) $i_2@@1) (< $i_2@@1 (|i#$Integer| (|ub#$Range| $range_3@@0)))) (let ((i@@16 ($Integer $i_2@@1)))
(|b#$Boolean| ($Boolean (let (($range_5@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2))))))
(forall (($i_4@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_5@@0)) $i_4@@1) (< $i_4@@1 (|i#$Integer| (|ub#$Range| $range_5@@0)))) (let ((j@@1 ($Integer $i_4@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2)) (|i#$Integer| i@@16)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2)) (|i#$Integer| j@@1))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@16 j@@1))))))))))))))))))))))))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon18_correct  (=> (= $abort_flag@0@@27 false) (=> (and (= inline$$TestVector_vector_of_proper_positives_$def_verify$0$$ret0@2 |inline$$WritebackToValue$2$vdst'@2@@8|) (= (ControlFlow 0 98705) 98807)) anon0$2_correct@@28))))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 98703) 98705)) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon18_correct)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 98713) 98705) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon18_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@9  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@9|) ($Local 0))) (= |inline$$WritebackToValue$2$vdst'@2@@8| |inline$$WritebackToValue$1$vdst'@2@@12|)) (and (=> (= (ControlFlow 0 98661) 98713) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 98661) 98703) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@9  (=> (= (|l#$Mutation| |inline$$WriteRef$2$to'@1@@9|) ($Local 0)) (=> (and (= |inline$$WritebackToValue$2$vdst'@1@@9| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@9|) 0 |inline$$WritebackToValue$1$vdst'@2@@12| (|v#$Mutation| |inline$$WriteRef$2$to'@1@@9|))) (= |inline$$WritebackToValue$2$vdst'@2@@8| |inline$$WritebackToValue$2$vdst'@1@@9|)) (and (=> (= (ControlFlow 0 98687) 98713) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 98687) 98703) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$WriteRef$2$anon0_correct@@9  (=> (= |inline$$WriteRef$2$to'@1@@9| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1@@9) (|p#$Mutation| inline$$BorrowLoc$2$dst@1@@9) |inline$$Vector_push_back$2$v'@1@@7|)) (and (=> (= (ControlFlow 0 98562) 98687) inline$$WritebackToValue$2$anon3_Then_correct@@9) (=> (= (ControlFlow 0 98562) 98661) inline$$WritebackToValue$2$anon3_Else_correct@@9)))))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon25_Else_correct  (=> (and (not false) (= (ControlFlow 0 98568) 98562)) inline$$WriteRef$2$anon0_correct@@9)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon25_Then_correct true))
(let ((inline$$Vector_push_back$2$anon0_correct@@7  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@10) (= |inline$$Vector_push_back$2$v'@1@@7| ($Vector (let ((len@@51 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@10))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@10)) len@@51 inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t7@1) (+ len@@51 1)))))) (and (=> (= (ControlFlow 0 98497) 98717) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 98497) 98568) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Vector_push_back$2$Entry_correct@@7  (=> (and (= inline$$Vector_push_back$2$ta@0@@7 $IntegerType) (= (ControlFlow 0 98485) 98497)) inline$$Vector_push_back$2$anon0_correct@@7)))
(let ((inline$$ReadRef$2$anon0_correct@@10  (=> (and (= inline$$ReadRef$2$v@1@@10 (|v#$Mutation| inline$$BorrowLoc$2$dst@1@@9)) (= (ControlFlow 0 98434) 98485)) inline$$Vector_push_back$2$Entry_correct@@7)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon23_Else$3_correct  (=> (and (= inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t7@1 ($Integer 3)) (= (ControlFlow 0 98440) 98434)) inline$$ReadRef$2$anon0_correct@@10)))
(let ((inline$$BorrowLoc$2$anon0_correct@@9  (=> (and (= inline$$BorrowLoc$2$dst@1@@9 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$1$vdst'@2@@12|)) (= (ControlFlow 0 98392) 98440)) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon23_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@15  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@16|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@12| |inline$$WritebackToValue$0$vdst'@2@@23|) (= (ControlFlow 0 98310) 98392)) inline$$BorrowLoc$2$anon0_correct@@9))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@15  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@16|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@15| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@16|) 0 |inline$$WritebackToValue$0$vdst'@2@@23| (|v#$Mutation| |inline$$WriteRef$1$to'@1@@16|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@12| |inline$$WritebackToValue$1$vdst'@1@@15|) (= (ControlFlow 0 98336) 98392))) inline$$BorrowLoc$2$anon0_correct@@9)))
(let ((inline$$WriteRef$1$anon0_correct@@16  (=> (= |inline$$WriteRef$1$to'@1@@16| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@15) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@15) |inline$$Vector_push_back$1$v'@1@@9|)) (and (=> (= (ControlFlow 0 98211) 98336) inline$$WritebackToValue$1$anon3_Then_correct@@15) (=> (= (ControlFlow 0 98211) 98310) inline$$WritebackToValue$1$anon3_Else_correct@@15)))))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon23_Else_correct  (=> (and (not false) (= (ControlFlow 0 98217) 98211)) inline$$WriteRef$1$anon0_correct@@16)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon23_Then_correct true))
(let ((inline$$Vector_push_back$1$anon0_correct@@9  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1@@17) (= |inline$$Vector_push_back$1$v'@1@@9| ($Vector (let ((len@@52 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@17))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@17)) len@@52 inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t5@1) (+ len@@52 1)))))) (and (=> (= (ControlFlow 0 98146) 98743) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 98146) 98217) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct@@9  (=> (and (= inline$$Vector_push_back$1$ta@0@@9 $IntegerType) (= (ControlFlow 0 98134) 98146)) inline$$Vector_push_back$1$anon0_correct@@9)))
(let ((inline$$ReadRef$1$anon0_correct@@17  (=> (and (= inline$$ReadRef$1$v@1@@17 (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@15)) (= (ControlFlow 0 98083) 98134)) inline$$Vector_push_back$1$Entry_correct@@9)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon21_Else$3_correct  (=> (and (= inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t5@1 ($Integer 2)) (= (ControlFlow 0 98089) 98083)) inline$$ReadRef$1$anon0_correct@@17)))
(let ((inline$$BorrowLoc$1$anon0_correct@@15  (=> (and (= inline$$BorrowLoc$1$dst@1@@15 ($Mutation ($Local 0) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@23|)) (= (ControlFlow 0 98041) 98089)) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon21_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@26  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@26|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@23| inline$$Vector_empty$0$v@1@@21) (= (ControlFlow 0 97959) 98041)) inline$$BorrowLoc$1$anon0_correct@@15))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@26  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@26|) ($Local 0)) (= |inline$$WritebackToValue$0$vdst'@1@@26| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@26|) 0 inline$$Vector_empty$0$v@1@@21 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@26|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@23| |inline$$WritebackToValue$0$vdst'@1@@26|) (= (ControlFlow 0 97985) 98041))) inline$$BorrowLoc$1$anon0_correct@@15)))
(let ((inline$$WriteRef$0$anon0_correct@@26  (=> (= |inline$$WriteRef$0$to'@1@@26| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@27) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@27) |inline$$Vector_push_back$0$v'@1@@20|)) (and (=> (= (ControlFlow 0 97860) 97985) inline$$WritebackToValue$0$anon3_Then_correct@@26) (=> (= (ControlFlow 0 97860) 97959) inline$$WritebackToValue$0$anon3_Else_correct@@26)))))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon21_Else_correct  (=> (and (not false) (= (ControlFlow 0 97866) 97860)) inline$$WriteRef$0$anon0_correct@@26)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon21_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@20  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@26) (= |inline$$Vector_push_back$0$v'@1@@20| ($Vector (let ((len@@53 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@26))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@26)) len@@53 inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t2@1) (+ len@@53 1)))))) (and (=> (= (ControlFlow 0 97795) 98763) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 97795) 97866) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@18  (=> (and (= inline$$Vector_push_back$0$ta@0@@18 $IntegerType) (= (ControlFlow 0 97783) 97795)) inline$$Vector_push_back$0$anon0_correct@@20)))
(let ((inline$$ReadRef$0$anon0_correct@@26  (=> (and (= inline$$ReadRef$0$v@1@@26 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@27)) (= (ControlFlow 0 97732) 97783)) inline$$Vector_push_back$0$Entry_correct@@18)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon19_Else$1_correct  (=> (and (= inline$$TestVector_vector_of_proper_positives_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 97738) 97732)) inline$$ReadRef$0$anon0_correct@@26)))
(let ((inline$$BorrowLoc$0$anon0_correct@@27  (=> (and (= inline$$BorrowLoc$0$dst@1@@27 ($Mutation ($Local 0) $EmptyPath inline$$Vector_empty$0$v@1@@21)) (= (ControlFlow 0 97690) 97738)) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon19_Else$1_correct)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= (ControlFlow 0 97696) 97690)) inline$$BorrowLoc$0$anon0_correct@@27)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon19_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@21  (=> (= inline$$Vector_empty$0$v@1@@21 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 97628) 98783) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 97628) 97696) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct@@18  (=> (and (= inline$$Vector_empty$0$ta@0@@18 $IntegerType) (= (ControlFlow 0 97624) 97628)) inline$$Vector_empty$0$anon0_correct@@21)))
(let ((inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 97634) 97624)) inline$$Vector_empty$0$Entry_correct@@18)))
(let ((anon0_correct@@31  (=> (= (ControlFlow 0 131237) 97634) inline$$TestVector_vector_of_proper_positives_$def_verify$0$anon0_correct)))
anon0_correct@@31)))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
