(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun |inline$$WritebackToReference$0$dst'@3| () T@$Mutation)
(declare-sort |T@[$TypeValue]$Value| 0)
(declare-fun |Select_[$TypeValue]$Value| (|T@[$TypeValue]$Value| T@$TypeValue) T@$Value)
(declare-fun $VerifyVector_old_v () |T@[$TypeValue]$Value|)
(declare-fun $tv0 () T@$TypeValue)
(declare-fun |inline$$WritebackToValue$2$vdst'@3| () T@$Value)
(declare-fun $VerifyVector_old_other () |T@[$TypeValue]$Value|)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t12@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@2| () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $ret0@0 () T@$Value)
(declare-fun v@@14 () T@$Value)
(declare-fun other () T@$Value)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$ReadRef$2$v@2 () T@$Value)
(declare-fun inline$$Vector_pop_back$0$e@3 () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@2| () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t13@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@2 () T@$Mutation)
(declare-fun |inline$$Vector_pop_back$0$v'@3| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$e@1 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@1| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$len@2 () Int)
(declare-fun inline$$Vector_pop_back$0$e@2 () T@$Value)
(declare-fun inline$$ReadRef$1$v@2 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@2| () T@$Value)
(declare-fun inline$$Not$0$dst@2 () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$Vector_is_empty$0$b@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t6@1 () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t7@1 () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_append_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 64026) (let ((inline$$VerifyVector_verify_append_$def_verify$0$anon38_Else$2_correct  (and (=> (= (ControlFlow 0 33145) (- 0 66166)) (|b#$Boolean| ($Boolean (>= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))))))) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))) (and (=> (= (ControlFlow 0 33145) (- 0 66188)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0)))))))) (and (=> (= (ControlFlow 0 33145) (- 0 66208)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|)))))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|)))))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0)))))))))) (and (=> (= (ControlFlow 0 33145) (- 0 66252)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_0) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@0) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k))))))))))) (and (=> (= (ControlFlow 0 33145) (- 0 66310)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3)) inline$$VerifyVector_verify_append_$def_verify$0$$i_2) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@0 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|)) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@0))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3)) inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@0) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@0 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$2$vdst'@3|)) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@0)))))))))))))) (=> (= (ControlFlow 0 33145) (- 0 66389)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_5 ($Range ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5)) inline$$VerifyVector_verify_append_$def_verify$0$$i_4) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_4 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@1 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3|))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@1)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@1) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))))))))))))))))))))))))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) (|l#$Mutation| |inline$$WriteRef$2$to'@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@2 inline$$WritebackToReference$0$srcPath@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@3| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) (= (ControlFlow 0 33081) 33145)) inline$$VerifyVector_verify_append_$def_verify$0$anon38_Else$2_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) (|l#$Mutation| |inline$$WriteRef$2$to'@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@2 inline$$WritebackToReference$0$srcPath@2)) (= |inline$$WritebackToReference$0$dst'@2| ($Mutation (|l#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) inline$$WritebackToReference$0$dstPath@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@2) (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) (|v#$Mutation| |inline$$WriteRef$2$to'@2|))))) (and (= |inline$$WritebackToReference$0$dst'@3| |inline$$WritebackToReference$0$dst'@2|) (= (ControlFlow 0 33137) 33145))) inline$$VerifyVector_verify_append_$def_verify$0$anon38_Else$2_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@2 (|p#$Mutation| |inline$$WriteRef$2$to'@2|)) (= inline$$WritebackToReference$0$dstPath@2 (|p#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1))) (and (=> (= (ControlFlow 0 33045) 33137) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 33045) 33081) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (and (= |inline$$WriteRef$2$to'@2| ($Mutation (|l#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) (|p#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) |inline$$Vector_push_back$0$v'@2|)) (= (ControlFlow 0 32902) 33045)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon38_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 32908) 32902)) inline$$WriteRef$2$anon0_correct)))
(let ((GeneratedUnifiedExit_correct  (and (=> (= (ControlFlow 0 64016) (- 0 66561)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| other))))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| other)))))))))) (and (=> (= (ControlFlow 0 64016) (- 0 66591)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))))))) (|v#$ValueArray| (|v#$Vector| $ret0@0)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))))))) v@@14))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))))))) (|v#$ValueArray| (|v#$Vector| $ret0@0)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| v@@14)))))))))) v@@14)))) (=> (= (ControlFlow 0 64016) (- 0 66617)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0))))))) (|v#$ValueArray| (|v#$Vector| $ret0@0)) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| v@@14))) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0)))))))))) other)))))))))))
(let ((anon0$2_correct  (=> (= $ret0@0 inline$$VerifyVector_verify_append_$def_verify$0$$ret0@2) (=> (and (= $abort_flag@4 $abort_flag@3) (= (ControlFlow 0 33249) 64016)) GeneratedUnifiedExit_correct))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct  (=> (and (and (= inline$$VerifyVector_verify_append_$def_verify$0$$ret0@1 $Error) (= $abort_flag@3 true)) (and (= inline$$VerifyVector_verify_append_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_append_$def_verify$0$$ret0@1) (= (ControlFlow 0 32227) 33249))) anon0$2_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 33195) 32227)) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 33205) 32227) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon33_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 33189) 33205) inline$$VerifyVector_verify_append_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 33189) 33195) inline$$VerifyVector_verify_append_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 33175) 32227)) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 33185) 32227) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon36_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 33169) 33185) inline$$VerifyVector_verify_append_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 33169) 33175) inline$$VerifyVector_verify_append_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 33155) 32227)) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 33165) 32227) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon38_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 33149) 33165) inline$$VerifyVector_verify_append_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 33149) 33155) inline$$VerifyVector_verify_append_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@2) (= |inline$$Vector_push_back$0$v'@2| ($Vector (let ((len@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2)) len@@0 inline$$Vector_pop_back$0$e@3) (+ len@@0 1)))))) (and (=> (= (ControlFlow 0 32837) 33149) inline$$VerifyVector_verify_append_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 32837) 32908) inline$$VerifyVector_verify_append_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@2 (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1)) (= (ControlFlow 0 32774) 32837)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@2|) ($Local 13))) (=> (and (= |inline$$WritebackToValue$2$vdst'@3| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1) (= (ControlFlow 0 32710) 32774)) inline$$ReadRef$2$anon0_correct))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@2|) ($Local 13)) (= |inline$$WritebackToValue$2$vdst'@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@2|) 0 inline$$VerifyVector_verify_append_$def_verify$0$$t13@1 (|v#$Mutation| |inline$$WriteRef$1$to'@2|)))) (and (= |inline$$WritebackToValue$2$vdst'@3| |inline$$WritebackToValue$2$vdst'@2|) (= (ControlFlow 0 32736) 32774))) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@2) (|p#$Mutation| inline$$BorrowLoc$2$dst@2) |inline$$Vector_pop_back$0$v'@3|)) (and (=> (= (ControlFlow 0 32611) 32736) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 32611) 32710) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 32617) 32611)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Vector_pop_back$0$anon3_Then$1_correct  (=> (= $abort_flag@2 true) (=> (and (= inline$$Vector_pop_back$0$e@3 inline$$Vector_pop_back$0$e@1) (= |inline$$Vector_pop_back$0$v'@3| |inline$$Vector_pop_back$0$v'@1|)) (and (=> (= (ControlFlow 0 32544) 33169) inline$$VerifyVector_verify_append_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 32544) 32617) inline$$VerifyVector_verify_append_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon3_Then_correct  (=> (and (= inline$$Vector_pop_back$0$len@2 0) (= (ControlFlow 0 32542) 32544)) inline$$Vector_pop_back$0$anon3_Then$1_correct)))
(let ((inline$$Vector_pop_back$0$anon3_Else_correct  (=> (and (not (= inline$$Vector_pop_back$0$len@2 0)) (= inline$$Vector_pop_back$0$e@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2)) (- inline$$Vector_pop_back$0$len@2 1)))) (=> (and (and (= |inline$$Vector_pop_back$0$v'@2| ($Vector (let ((l@@8 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2)) 1)))
($ValueArray (|lambda#0| 0 l@@8 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2)) $Error) l@@8)))) (= $abort_flag@2 $abort_flag@0)) (and (= inline$$Vector_pop_back$0$e@3 inline$$Vector_pop_back$0$e@2) (= |inline$$Vector_pop_back$0$v'@3| |inline$$Vector_pop_back$0$v'@2|))) (and (=> (= (ControlFlow 0 32494) 33169) inline$$VerifyVector_verify_append_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 32494) 32617) inline$$VerifyVector_verify_append_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@2) (= inline$$Vector_pop_back$0$len@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2)))) (and (=> (= (ControlFlow 0 32472) 32542) inline$$Vector_pop_back$0$anon3_Then_correct) (=> (= (ControlFlow 0 32472) 32494) inline$$Vector_pop_back$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@2 (|v#$Mutation| inline$$BorrowLoc$2$dst@2)) (= (ControlFlow 0 32361) 32472)) inline$$Vector_pop_back$0$anon0_correct)))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@2 ($Mutation ($Local 13) $EmptyPath inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)) (= (ControlFlow 0 32323) 32361)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon35_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@2) (= (ControlFlow 0 32273) 32323)) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 32219) 32227)) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 32235) 32227) inline$$VerifyVector_verify_append_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon40_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 32213) 32235) inline$$VerifyVector_verify_append_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 32213) 32219) inline$$VerifyVector_verify_append_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon28_correct  (=> (= $abort_flag@3 $abort_flag@1) (=> (and (= inline$$VerifyVector_verify_append_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2|) (= (ControlFlow 0 32201) 33249)) anon0$2_correct))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 32199) 32201)) inline$$VerifyVector_verify_append_$def_verify$0$anon28_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 32209) 32201) inline$$VerifyVector_verify_append_$def_verify$0$anon28_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon40_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 32193) 32209) inline$$VerifyVector_verify_append_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 32193) 32199) inline$$VerifyVector_verify_append_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Vector_destroy_empty$0$anon2_Then$1_correct  (=> (= $abort_flag@1 true) (and (=> (= (ControlFlow 0 32179) 32213) inline$$VerifyVector_verify_append_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 32179) 32193) inline$$VerifyVector_verify_append_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$Vector_destroy_empty$0$anon2_Then_correct  (=> (and (not (= (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)) 0)) (= (ControlFlow 0 32177) 32179)) inline$$Vector_destroy_empty$0$anon2_Then$1_correct)))
(let ((inline$$Vector_destroy_empty$0$anon2_Else_correct  (=> (and (= (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)) 0) (= $abort_flag@1 $abort_flag@0)) (and (=> (= (ControlFlow 0 32127) 32213) inline$$VerifyVector_verify_append_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 32127) 32193) inline$$VerifyVector_verify_append_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) ($Local 11))) (= |inline$$WritebackToValue$1$vdst'@2| v@@14)) (and (=> (= (ControlFlow 0 31988) 32177) inline$$Vector_destroy_empty$0$anon2_Then_correct) (=> (= (ControlFlow 0 31988) 32127) inline$$Vector_destroy_empty$0$anon2_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (= (|l#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) ($Local 11)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) 0 v@@14 (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1))) (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|)) (and (=> (= (ControlFlow 0 32014) 32177) inline$$Vector_destroy_empty$0$anon2_Then_correct) (=> (= (ControlFlow 0 32014) 32127) inline$$Vector_destroy_empty$0$anon2_Else_correct))))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon35_Else_correct  (=> (not (|b#$Boolean| inline$$Not$0$dst@2)) (and (=> (= (ControlFlow 0 31895) 32014) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 31895) 31988) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@2 ($Boolean  (not (|b#$Boolean| inline$$Vector_is_empty$0$b@2)))) (and (=> (= (ControlFlow 0 31847) 32273) inline$$VerifyVector_verify_append_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 31847) 31895) inline$$VerifyVector_verify_append_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 31837) (- 0 65572)) true) (=> (= (ControlFlow 0 31837) 31847) inline$$Not$0$anon0_correct))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 31853) 31837)) inline$$Not$0$Entry_correct)))
(let ((inline$$Vector_is_empty$0$anon0_correct  (=> (and ((_ is $Vector) inline$$VerifyVector_verify_append_$def_verify$0$$t13@1) (= inline$$Vector_is_empty$0$b@2 ($Boolean (= (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)) 0)))) (and (=> (= (ControlFlow 0 31791) 33189) inline$$VerifyVector_verify_append_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 31791) 31853) inline$$VerifyVector_verify_append_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$L3_correct  (=> (not $abort_flag@0) (=> (and (= (|l#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) ($Local 11)) (= (|p#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1) $EmptyPath)) (=> (and (and ((_ is $Vector) inline$$VerifyVector_verify_append_$def_verify$0$$t3@1) (let ((va@@8 (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t3@1)))
(let ((l@@9 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (and ((_ is $Boolean) inline$$VerifyVector_verify_append_$def_verify$0$$t4@1) ((_ is $Boolean) inline$$VerifyVector_verify_append_$def_verify$0$$t5@1))) (=> (and (and (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t6@1)) (let ((va@@9 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t6@1))))
(let ((l@@10 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t7@1)) (let ((va@@10 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t7@1))))
(let ((l@@11 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
))))))) (and (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1)) (let ((va@@11 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1))))
(let ((l@@12 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (and ((_ is $Vector) inline$$VerifyVector_verify_append_$def_verify$0$$t13@1) (let ((va@@12 (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)))
(let ((l@@13 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))))) (=> (and (and (and (and ((_ is $Vector) inline$$VerifyVector_verify_append_$def_verify$0$$t14@1) (let ((va@@13 (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t14@1)))
(let ((l@@14 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))))))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)))))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0)))))))))))) (and (and (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@0)) inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@1) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@0)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@2 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@2)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@2))))))))))) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@0)) inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@1) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@0)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@3 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_append_$def_verify$0$$t13@1)) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@3)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@3))))))))))))))) (and (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@0 ($Range ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@0)) inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@0) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@0)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@4 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_append_$def_verify$0$$t12@1))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@4)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@4) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))))))))))))) (= (ControlFlow 0 31732) 31791)))) inline$$Vector_is_empty$0$anon0_correct)))))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon31_Else$2_correct  (and (=> (= (ControlFlow 0 31319) (- 0 64720)) (|b#$Boolean| ($Boolean (>= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))))))) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))) (and (=> (= (ControlFlow 0 31319) (- 0 64742)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0)))))))) (and (=> (= (ControlFlow 0 31319) (- 0 64762)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)))))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)))))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0)))))))))) (and (=> (= (ControlFlow 0 31319) (- 0 64806)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@2) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@5 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@5)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@5)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@3) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@5 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@5)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@5))))))))))) (and (=> (= (ControlFlow 0 31319) (- 0 64864)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@2) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@6 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@6)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@6))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@3) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_3@@1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@6 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_2@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| |inline$$WritebackToValue$0$vdst'@2|)) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@6)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@6)))))))))))))) (and (=> (= (ControlFlow 0 31319) (- 0 64943)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@1 ($Range ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@1) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@7 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@7)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@7) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@1 ($Range ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1)))))))
(forall ((inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@1)) inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@2) (< inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_append_$def_verify$0$$range_5@@1)))) (let ((inline$$VerifyVector_verify_append_$def_verify$0$k@@7 ($Integer inline$$VerifyVector_verify_append_$def_verify$0$$i_4@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@7)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0))) (|i#$Integer| ($Integer (- (|i#$Integer| inline$$VerifyVector_verify_append_$def_verify$0$k@@7) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0)))))))))))))))))) (=> (= (ControlFlow 0 31319) 31732) inline$$VerifyVector_verify_append_$def_verify$0$L3_correct)))))))))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 13))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| other) (= (ControlFlow 0 31285) 31319)) inline$$VerifyVector_verify_append_$def_verify$0$anon31_Else$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 13)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 other (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 31311) 31319))) inline$$VerifyVector_verify_append_$def_verify$0$anon31_Else$2_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) |inline$$Vector_reverse$0$v'@1|)) (and (=> (= (ControlFlow 0 31186) 31311) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 31186) 31285) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon31_Else_correct  (=> (and (not false) (= (ControlFlow 0 31192) 31186)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon31_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_reverse$0$v'@1| ($Vector (let ((l@@15 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|lambda#3| 0 l@@15 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) l@@15 1 $Error) l@@15))))) (and (=> (= (ControlFlow 0 31121) 33209) inline$$VerifyVector_verify_append_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 31121) 31192) inline$$VerifyVector_verify_append_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 31068) 31121)) inline$$Vector_reverse$0$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 13) $EmptyPath other)) (= (ControlFlow 0 31030) 31068)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon4$3_correct  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1)))) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0) other))) (= (ControlFlow 0 31036) 31030)) inline$$BorrowLoc$1$anon0_correct))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 11) $EmptyPath v@@14)) (= (ControlFlow 0 30944) 31036)) inline$$VerifyVector_verify_append_$def_verify$0$anon4$3_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 30826) 30944)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 33233) 30944) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 30818) 33233) inline$$VerifyVector_verify_append_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 30818) 30826) inline$$VerifyVector_verify_append_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 33241) 33233) inline$$VerifyVector_verify_append_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 33241) 30826) inline$$VerifyVector_verify_append_$def_verify$0$anon30_Else_correct))))
(let ((inline$$VerifyVector_verify_append_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 30812) 33241) inline$$VerifyVector_verify_append_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 30812) 30818) inline$$VerifyVector_verify_append_$def_verify$0$anon29_Else_correct)))))
(let ((anon0_correct  (=> (and ((_ is $Vector) v@@14) (let ((va@@14 (|v#$Vector| v@@14)))
(let ((l@@16 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (=> (and (and ((_ is $Vector) other) (let ((va@@15 (|v#$Vector| other)))
(let ((l@@17 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (ControlFlow 0 29900) 30812)) inline$$VerifyVector_verify_append_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (forall (($tv0@@0 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@0)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@0))))
(let ((l@@18 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (=> (and (forall (($tv0@@1 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@1)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@1))))
(let ((l@@19 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (= (ControlFlow 0 64026) 29900)) anon0_correct))))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$AddU64$0$dst@3 () T@$Value)
(declare-fun v@@15 () T@$Value)
(declare-fun e () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $ret0@0@@0 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t14@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$i@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t19@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@3 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@2 () Int)
(declare-fun inline$$Vector_borrow$0$dst@2 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$Lt$0$dst@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_contains_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 66728) (let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon26_correct  (=> (= (ControlFlow 0 35552) (- 0 67862)) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_contains_$def_verify$0$$range_1 ($Range ($Integer 0) inline$$AddU64$0$dst@3)))
(exists ((inline$$VerifyVector_verify_contains_$def_verify$0$$i_0 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1)) inline$$VerifyVector_verify_contains_$def_verify$0$$i_0) (< inline$$VerifyVector_verify_contains_$def_verify$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_contains_$def_verify$0$j ($Integer inline$$VerifyVector_verify_contains_$def_verify$0$$i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$j)) e)))))))))))))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 35550) 35552)) inline$$VerifyVector_verify_contains_$def_verify$0$anon26_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 35560) 35552) inline$$VerifyVector_verify_contains_$def_verify$0$anon26_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon39_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 35544) 35560) inline$$VerifyVector_verify_contains_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 35544) 35550) inline$$VerifyVector_verify_contains_$def_verify$0$anon41_Else_correct)))))
(let ((GeneratedUnifiedExit_correct@@0  (and (=> (= (ControlFlow 0 66718) (- 0 68044)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 66718) (- 0 68053)) (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 66718) (- 0 68062)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified $ret0@0@@0 ($Boolean (let (($range_1 v@@15))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@18 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@18 e)))))))))))))))))))
(let ((anon0$2_correct@@0  (=> (= $ret0@0@@0 inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@2) (=> (and (= $abort_flag@4@@0 $abort_flag@3@@0) (= (ControlFlow 0 35754) 66718)) GeneratedUnifiedExit_correct@@0))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon20_correct  (=> (= $abort_flag@3@@0 $abort_flag@1@@0) (=> (and (= inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_contains_$def_verify$0$$t17@1) (= (ControlFlow 0 35674) 35754)) anon0$2_correct@@0))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 35672) 35674)) inline$$VerifyVector_verify_contains_$def_verify$0$anon20_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 35682) 35674) inline$$VerifyVector_verify_contains_$def_verify$0$anon20_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Then$2_correct  (=> (= inline$$VerifyVector_verify_contains_$def_verify$0$$t17@1 ($Boolean true)) (and (=> (= (ControlFlow 0 35666) 35682) inline$$VerifyVector_verify_contains_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 35666) 35672) inline$$VerifyVector_verify_contains_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Then_correct  (=> (and (|b#$Boolean| inline$$VerifyVector_verify_contains_$def_verify$0$$t14@2) (= (ControlFlow 0 35624) 35666)) inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Then$2_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$Abort_correct  (=> (and (and (= inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@1 $Error) (= $abort_flag@3@@0 true)) (and (= inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@1) (= (ControlFlow 0 35578) 35754))) anon0$2_correct@@0)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 35692) 35578)) inline$$VerifyVector_verify_contains_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 35702) 35578) inline$$VerifyVector_verify_contains_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 35686) 35702) inline$$VerifyVector_verify_contains_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 35686) 35692) inline$$VerifyVector_verify_contains_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 35570) 35578)) inline$$VerifyVector_verify_contains_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 35586) 35578) inline$$VerifyVector_verify_contains_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon39_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 35564) 35586) inline$$VerifyVector_verify_contains_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 35564) 35570) inline$$VerifyVector_verify_contains_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= inline$$AddU64$0$dst@3 inline$$AddU64$0$dst@1) (= $abort_flag@2@@0 true)) (and (=> (= (ControlFlow 0 35530) 35564) inline$$VerifyVector_verify_contains_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 35530) 35544) inline$$VerifyVector_verify_contains_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t19@2)) $MAX_U64) (= (ControlFlow 0 35528) 35530)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t19@2))) (= inline$$AddU64$0$dst@2 ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t19@2))))) (and (= inline$$AddU64$0$dst@3 inline$$AddU64$0$dst@2) (= $abort_flag@2@@0 $abort_flag@1@@0))) (and (=> (= (ControlFlow 0 35472) 35564) inline$$VerifyVector_verify_contains_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 35472) 35544) inline$$VerifyVector_verify_contains_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 35442) (- 0 67766)) true) (and (=> (= (ControlFlow 0 35442) 35528) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 35442) 35472) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Else$1_correct  (=> (and (= inline$$VerifyVector_verify_contains_$def_verify$0$$t19@2 ($Integer 1)) (= (ControlFlow 0 35536) 35442)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$VerifyVector_verify_contains_$def_verify$0$$t14@2)) (= (ControlFlow 0 35345) 35536)) inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Else$1_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Else$1_correct  (=> (= inline$$VerifyVector_verify_contains_$def_verify$0$$t14@2 ($Boolean ($IsEqual_stratified inline$$Vector_borrow$0$dst@3 e))) (and (=> (= (ControlFlow 0 35305) 35624) inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 35305) 35345) inline$$VerifyVector_verify_contains_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 35295) 35305)) inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Else$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@0 true) (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@1)) (and (=> (= (ControlFlow 0 35249) 35686) inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 35249) 35295) inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| v@@15)))) (= (ControlFlow 0 35247) 35249)) inline$$Vector_borrow$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| v@@15))))) (= inline$$Vector_borrow$0$dst@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) inline$$Vector_borrow$0$i_ind@2))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@2))) (and (=> (= (ControlFlow 0 35189) 35686) inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 35189) 35295) inline$$VerifyVector_verify_contains_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct  (=> ((_ is $Vector) v@@15) (=> (and ((_ is $Integer) inline$$VerifyVector_verify_contains_$def_verify$0$i@1) (= inline$$Vector_borrow$0$i_ind@2 (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$i@1))) (and (=> (= (ControlFlow 0 35163) 35247) inline$$Vector_borrow$0$anon3_Then_correct) (=> (= (ControlFlow 0 35163) 35189) inline$$Vector_borrow$0$anon3_Else_correct))))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon34_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@2) (= (ControlFlow 0 35005) 35163)) inline$$Vector_borrow$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon28_correct  (=> (= $abort_flag@3@@0 $abort_flag@0@@0) (=> (and (= inline$$VerifyVector_verify_contains_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_contains_$def_verify$0$$t21@1) (= (ControlFlow 0 34959) 35754)) anon0$2_correct@@0))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 34957) 34959)) inline$$VerifyVector_verify_contains_$def_verify$0$anon28_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 34967) 34959) inline$$VerifyVector_verify_contains_$def_verify$0$anon28_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon34_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@2)) (and (=> (= (ControlFlow 0 34951) (- 0 67529)) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@0 v@@15))
(exists ((inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@0 Int) )  (and (and (>= inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@0 0) (< inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@0 (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@0)))) (let ((inline$$VerifyVector_verify_contains_$def_verify$0$x (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@0)) inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_contains_$def_verify$0$x e))))))))))))) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@0 v@@15))
(exists ((inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@1 Int) )  (and (and (>= inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@1 0) (< inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@1 (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@0)))) (let ((inline$$VerifyVector_verify_contains_$def_verify$0$x (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@0)) inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_contains_$def_verify$0$x e)))))))))))) (=> (= inline$$VerifyVector_verify_contains_$def_verify$0$$t21@1 ($Boolean false)) (and (=> (= (ControlFlow 0 34951) 34967) inline$$VerifyVector_verify_contains_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 34951) 34957) inline$$VerifyVector_verify_contains_$def_verify$0$anon42_Else_correct))))))))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@2 ($Boolean (< (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$i@1) (|i#$Integer| inline$$Vector_length$0$l@1)))) (and (=> (= (ControlFlow 0 34886) 35005) inline$$VerifyVector_verify_contains_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 34886) 34951) inline$$VerifyVector_verify_contains_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 34872) (- 0 67498)) true) (=> (= (ControlFlow 0 34872) 34886) inline$$Lt$0$anon0_correct))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$L6_correct  (=> (not $abort_flag@0@@0) (=> (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_contains_$def_verify$0$i@1) (>= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$i@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$i@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_contains_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t7@1) $MAX_U64))) (=> (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_contains_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t8@1) $MAX_U64)) ((_ is $Boolean) inline$$VerifyVector_verify_contains_$def_verify$0$$t9@1)) (and ((_ is $Vector) inline$$VerifyVector_verify_contains_$def_verify$0$$t10@1) (let ((va@@18 (|v#$Vector| inline$$VerifyVector_verify_contains_$def_verify$0$$t10@1)))
(let ((l@@20 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@19))
))))))) (=> (and (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_contains_$def_verify$0$$t11@1) (>= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t11@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t11@1) $MAX_U64)) ((_ is $Boolean) inline$$VerifyVector_verify_contains_$def_verify$0$$t14@1)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_contains_$def_verify$0$$t18@1) (>= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t18@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t18@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_contains_$def_verify$0$$t19@1) (>= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t19@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$$t19@1) $MAX_U64)) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@1 ($Range ($Integer 0) inline$$VerifyVector_verify_contains_$def_verify$0$i@1)))
(exists ((inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@2 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@2) (< inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_contains_$def_verify$0$j@@0 ($Integer inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$j@@0)) e)))))))))))) (= (ControlFlow 0 34794) 34872)))) inline$$Lt$0$Entry_correct))))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon32_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 34669) (- 0 67215)) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@2 ($Range ($Integer 0) inline$$VerifyVector_verify_contains_$def_verify$0$$t4@1)))
(exists ((inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@3 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@2)) inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@3) (< inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@2)))) (let ((inline$$VerifyVector_verify_contains_$def_verify$0$j@@1 ($Integer inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$j@@1)) e))))))))))))) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@2 ($Range ($Integer 0) inline$$VerifyVector_verify_contains_$def_verify$0$$t4@1)))
(exists ((inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@4 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@2)) inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@4) (< inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@4 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_contains_$def_verify$0$$range_1@@2)))) (let ((inline$$VerifyVector_verify_contains_$def_verify$0$j@@1 ($Integer inline$$VerifyVector_verify_contains_$def_verify$0$$i_0@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) (|i#$Integer| inline$$VerifyVector_verify_contains_$def_verify$0$j@@1)) e)))))))))))) (=> (= (ControlFlow 0 34669) 34794) inline$$VerifyVector_verify_contains_$def_verify$0$L6_correct))))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon32_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) v@@15) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| v@@15))))) (and (=> (= (ControlFlow 0 34655) 35706) inline$$VerifyVector_verify_contains_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 34655) 34669) inline$$VerifyVector_verify_contains_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 34570) 34655)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 35730) 34655) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon4$2_correct  (=> (= inline$$VerifyVector_verify_contains_$def_verify$0$$t4@1 ($Integer 0)) (and (=> (= (ControlFlow 0 34562) 35730) inline$$VerifyVector_verify_contains_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 34562) 34570) inline$$VerifyVector_verify_contains_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 34456) 34562)) inline$$VerifyVector_verify_contains_$def_verify$0$anon4$2_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 35738) 34562) inline$$VerifyVector_verify_contains_$def_verify$0$anon4$2_correct)))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 34448) 35738) inline$$VerifyVector_verify_contains_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 34448) 34456) inline$$VerifyVector_verify_contains_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 35746) 35738) inline$$VerifyVector_verify_contains_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 35746) 34456) inline$$VerifyVector_verify_contains_$def_verify$0$anon30_Else_correct))))
(let ((inline$$VerifyVector_verify_contains_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 34442) 35746) inline$$VerifyVector_verify_contains_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 34442) 34448) inline$$VerifyVector_verify_contains_$def_verify$0$anon29_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and ((_ is $Vector) v@@15) (let ((va@@19 (|v#$Vector| v@@15)))
(let ((l@@21 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@20))
)))))) (= (ControlFlow 0 33766) 34442)) inline$$VerifyVector_verify_contains_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (forall (($tv0@@2 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@2)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@2))))
(let ((l@@22 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@21))
))))))) (=> (and (forall (($tv0@@3 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@3)) (let ((va@@21 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@3))))
(let ((l@@23 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@22))
))))))) (= (ControlFlow 0 66728) 33766)) anon0_correct@@0))))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$AddU64$0$dst@3@@0 () T@$Value)
(declare-fun v@@16 () T@$Value)
(declare-fun e@@0 () T@$Value)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun $ret0@0@@1 () T@$Value)
(declare-fun $ret1@0 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$i@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t14@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@3@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@2@@0 () Int)
(declare-fun inline$$Vector_borrow$0$dst@2@@0 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$Lt$0$dst@2@@0 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t25@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@0 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_index_of_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 68188) (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon28_correct  (=> (= (ControlFlow 0 37961) (- 0 69489)) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1 ($Range ($Integer 0) inline$$AddU64$0$dst@3@@0)))
(exists ((inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1)) inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0) (< inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$j ($Integer inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$j)) e@@0)))))))))))))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 37959) 37961)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon28_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 37969) 37961) inline$$VerifyVector_verify_index_of_$def_verify$0$anon28_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon44_Else_correct  (=> (not $abort_flag@2@@1) (and (=> (= (ControlFlow 0 37953) 37969) inline$$VerifyVector_verify_index_of_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 37953) 37959) inline$$VerifyVector_verify_index_of_$def_verify$0$anon46_Else_correct)))))
(let ((GeneratedUnifiedExit_correct@@1  (and (=> (= (ControlFlow 0 68177) (- 0 69725)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@1)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@1) (and (=> (= (ControlFlow 0 68177) (- 0 69734)) (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 68177) (- 0 69743)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $ret0@0@@1 ($Boolean (let (($range_1@@0 v@@16))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@23 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@23 e@@0))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified $ret0@0@@1 ($Boolean (let (($range_1@@0 v@@16))
(exists (($i_0@@1 Int) )  (and (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@23 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@23 e@@0)))))))))))) (and (=> (= (ControlFlow 0 68177) (- 0 69790)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| $ret0@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| $ret1@0)) e@@0)))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| $ret0@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| $ret1@0)) e@@0))))))) (and (=> (= (ControlFlow 0 68177) (- 0 69817)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| $ret0@0@@1) (|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) $ret1@0)))
(forall (($i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2) (< $i_2 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((i@@10 ($Integer $i_2)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| i@@10)) e@@0))))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| $ret0@0@@1) (|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) $ret1@0)))
(forall (($i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2@@0) (< $i_2@@0 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((i@@10 ($Integer $i_2@@0)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| i@@10)) e@@0)))))))))))))) (=> (= (ControlFlow 0 68177) (- 0 69877)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| $ret0@0@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified $ret1@0 ($Integer 0)))))))))))))))))))))
(let ((anon0$2_correct@@1  (=> (and (and (= $ret0@0@@1 inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@2) (= $ret1@0 inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@2)) (and (= $abort_flag@4@@1 $abort_flag@3@@1) (= (ControlFlow 0 38219) 68177))) GeneratedUnifiedExit_correct@@1)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon22_correct  (=> (and (and (= $abort_flag@3@@1 $abort_flag@1@@1) (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_index_of_$def_verify$0$$t17@1)) (and (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) (= (ControlFlow 0 38129) 38219))) anon0$2_correct@@1)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 38127) 38129)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon22_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 38137) 38129) inline$$VerifyVector_verify_index_of_$def_verify$0$anon22_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon42_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 38117) 38137) inline$$VerifyVector_verify_index_of_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 38117) 38127) inline$$VerifyVector_verify_index_of_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon42_Then_correct  (and (=> (= (ControlFlow 0 38145) 38137) inline$$VerifyVector_verify_index_of_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 38145) 38127) inline$$VerifyVector_verify_index_of_$def_verify$0$anon43_Else_correct))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Then$2_correct  (=> (= inline$$VerifyVector_verify_index_of_$def_verify$0$$t17@1 ($Boolean true)) (and (=> (= (ControlFlow 0 38107) 38145) inline$$VerifyVector_verify_index_of_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 38107) 38117) inline$$VerifyVector_verify_index_of_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Then_correct  (=> (and (|b#$Boolean| inline$$VerifyVector_verify_index_of_$def_verify$0$$t14@2) (= (ControlFlow 0 38035) 38107)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Then$2_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$Abort_correct  (=> (and (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@3@@1 true) (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@1)) (and (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@1) (= (ControlFlow 0 37989) 38219))) anon0$2_correct@@1))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 38155) 37989)) inline$$VerifyVector_verify_index_of_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 38165) 37989) inline$$VerifyVector_verify_index_of_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 38149) 38165) inline$$VerifyVector_verify_index_of_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 38149) 38155) inline$$VerifyVector_verify_index_of_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 37979) 37989)) inline$$VerifyVector_verify_index_of_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 37997) 37989) inline$$VerifyVector_verify_index_of_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon44_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 37973) 37997) inline$$VerifyVector_verify_index_of_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 37973) 37979) inline$$VerifyVector_verify_index_of_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= inline$$AddU64$0$dst@3@@0 inline$$AddU64$0$dst@1@@0) (= $abort_flag@2@@1 true)) (and (=> (= (ControlFlow 0 37939) 37973) inline$$VerifyVector_verify_index_of_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 37939) 37953) inline$$VerifyVector_verify_index_of_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@2)) $MAX_U64) (= (ControlFlow 0 37937) 37939)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@2))) (= inline$$AddU64$0$dst@2@@0 ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@2))))) (and (= inline$$AddU64$0$dst@3@@0 inline$$AddU64$0$dst@2@@0) (= $abort_flag@2@@1 $abort_flag@1@@1))) (and (=> (= (ControlFlow 0 37881) 37973) inline$$VerifyVector_verify_index_of_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 37881) 37953) inline$$VerifyVector_verify_index_of_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 37851) (- 0 69393)) true) (and (=> (= (ControlFlow 0 37851) 37937) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 37851) 37881) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Else$1_correct  (=> (and (= inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@2 ($Integer 1)) (= (ControlFlow 0 37945) 37851)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$VerifyVector_verify_index_of_$def_verify$0$$t14@2)) (= (ControlFlow 0 37754) 37945)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Else$1_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Else$1_correct  (=> (= inline$$VerifyVector_verify_index_of_$def_verify$0$$t14@2 ($Boolean ($IsEqual_stratified inline$$Vector_borrow$0$dst@3@@0 e@@0))) (and (=> (= (ControlFlow 0 37714) 38035) inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 37714) 37754) inline$$VerifyVector_verify_index_of_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 37704) 37714)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Else$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@1 true) (= inline$$Vector_borrow$0$dst@3@@0 inline$$Vector_borrow$0$dst@1@@0)) (and (=> (= (ControlFlow 0 37658) 38149) inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 37658) 37704) inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@0  (=> (and (or (< inline$$Vector_borrow$0$i_ind@2@@0 0) (>= inline$$Vector_borrow$0$i_ind@2@@0 (|l#$ValueArray| (|v#$Vector| v@@16)))) (= (ControlFlow 0 37656) 37658)) inline$$Vector_borrow$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@0  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@2@@0 0) (>= inline$$Vector_borrow$0$i_ind@2@@0 (|l#$ValueArray| (|v#$Vector| v@@16))))) (= inline$$Vector_borrow$0$dst@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) inline$$Vector_borrow$0$i_ind@2@@0))) (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= inline$$Vector_borrow$0$dst@3@@0 inline$$Vector_borrow$0$dst@2@@0))) (and (=> (= (ControlFlow 0 37598) 38149) inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 37598) 37704) inline$$VerifyVector_verify_index_of_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct@@0  (=> ((_ is $Vector) v@@16) (=> (and ((_ is $Integer) inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) (= inline$$Vector_borrow$0$i_ind@2@@0 (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$i@1))) (and (=> (= (ControlFlow 0 37572) 37656) inline$$Vector_borrow$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 37572) 37598) inline$$Vector_borrow$0$anon3_Else_correct@@0))))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@2@@0) (= (ControlFlow 0 37414) 37572)) inline$$Vector_borrow$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon32_correct  (=> (and (and (= $abort_flag@3@@1 $abort_flag@0@@1) (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_index_of_$def_verify$0$$t24@1)) (and (= inline$$VerifyVector_verify_index_of_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_index_of_$def_verify$0$$t25@1) (= (ControlFlow 0 37360) 38219))) anon0$2_correct@@1)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 37358) 37360)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon32_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 37368) 37360) inline$$VerifyVector_verify_index_of_$def_verify$0$anon32_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 37348) 37368) inline$$VerifyVector_verify_index_of_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 37348) 37358) inline$$VerifyVector_verify_index_of_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 37376) 37368) inline$$VerifyVector_verify_index_of_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 37376) 37358) inline$$VerifyVector_verify_index_of_$def_verify$0$anon48_Else_correct))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon38_Else$2_correct  (=> (and (= inline$$VerifyVector_verify_index_of_$def_verify$0$$t24@1 ($Boolean false)) (= inline$$VerifyVector_verify_index_of_$def_verify$0$$t25@1 ($Integer 0))) (and (=> (= (ControlFlow 0 37342) 37376) inline$$VerifyVector_verify_index_of_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 37342) 37348) inline$$VerifyVector_verify_index_of_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@2@@0)) (= (ControlFlow 0 37296) 37342)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon38_Else$2_correct)))
(let ((inline$$Lt$0$anon0_correct@@0  (=> (= inline$$Lt$0$dst@2@@0 ($Boolean (< (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) (|i#$Integer| inline$$Vector_length$0$l@1@@0)))) (and (=> (= (ControlFlow 0 37248) 37414) inline$$VerifyVector_verify_index_of_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 37248) 37296) inline$$VerifyVector_verify_index_of_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 37234) (- 0 69125)) true) (=> (= (ControlFlow 0 37234) 37248) inline$$Lt$0$anon0_correct@@0))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$L6_correct  (=> (not $abort_flag@0@@1) (=> (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) (>= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$i@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_index_of_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t7@1) $MAX_U64))) (=> (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_index_of_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t8@1) $MAX_U64)) ((_ is $Boolean) inline$$VerifyVector_verify_index_of_$def_verify$0$$t9@1)) (and ((_ is $Vector) inline$$VerifyVector_verify_index_of_$def_verify$0$$t10@1) (let ((va@@22 (|v#$Vector| inline$$VerifyVector_verify_index_of_$def_verify$0$$t10@1)))
(let ((l@@24 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@24))
))))))) (=> (and (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_index_of_$def_verify$0$$t11@1) (>= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t11@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t11@1) $MAX_U64)) ((_ is $Boolean) inline$$VerifyVector_verify_index_of_$def_verify$0$$t14@1)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_index_of_$def_verify$0$$t19@1) (>= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t19@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t19@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@1) (>= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$$t20@1) $MAX_U64)) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@0 ($Range ($Integer 0) inline$$VerifyVector_verify_index_of_$def_verify$0$i@1)))
(exists ((inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@0 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@0)) inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@0) (< inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@0)))) (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$j@@0 ($Integer inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$j@@0)) e@@0)))))))))))) (= (ControlFlow 0 37156) 37234)))) inline$$Lt$0$Entry_correct@@0))))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon36_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 37031) (- 0 68842)) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@1 ($Range ($Integer 0) inline$$VerifyVector_verify_index_of_$def_verify$0$$t4@1)))
(exists ((inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@1 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@1) (< inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$j@@1 ($Integer inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$j@@1)) e@@0))))))))))))) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@1 ($Range ($Integer 0) inline$$VerifyVector_verify_index_of_$def_verify$0$$t4@1)))
(exists ((inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@2 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@2) (< inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_index_of_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_index_of_$def_verify$0$j@@1 ($Integer inline$$VerifyVector_verify_index_of_$def_verify$0$$i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) (|i#$Integer| inline$$VerifyVector_verify_index_of_$def_verify$0$j@@1)) e@@0)))))))))))) (=> (= (ControlFlow 0 37031) 37156) inline$$VerifyVector_verify_index_of_$def_verify$0$L6_correct))))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon36_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@0  (=> (and ((_ is $Vector) v@@16) (= inline$$Vector_length$0$l@1@@0 ($Integer (|l#$ValueArray| (|v#$Vector| v@@16))))) (and (=> (= (ControlFlow 0 37017) 38169) inline$$VerifyVector_verify_index_of_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 37017) 37031) inline$$VerifyVector_verify_index_of_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 36932) 37017)) inline$$Vector_length$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 38193) 37017) inline$$Vector_length$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon4$2_correct  (=> (= inline$$VerifyVector_verify_index_of_$def_verify$0$$t4@1 ($Integer 0)) (and (=> (= (ControlFlow 0 36924) 38193) inline$$VerifyVector_verify_index_of_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 36924) 36932) inline$$VerifyVector_verify_index_of_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 36818) 36924)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon4$2_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 38201) 36924) inline$$VerifyVector_verify_index_of_$def_verify$0$anon4$2_correct)))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 36810) 38201) inline$$VerifyVector_verify_index_of_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 36810) 36818) inline$$VerifyVector_verify_index_of_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 38209) 38201) inline$$VerifyVector_verify_index_of_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 38209) 36818) inline$$VerifyVector_verify_index_of_$def_verify$0$anon34_Else_correct))))
(let ((inline$$VerifyVector_verify_index_of_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 36804) 38209) inline$$VerifyVector_verify_index_of_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 36804) 36810) inline$$VerifyVector_verify_index_of_$def_verify$0$anon33_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and ((_ is $Vector) v@@16) (let ((va@@23 (|v#$Vector| v@@16)))
(let ((l@@25 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@25))
)))))) (= (ControlFlow 0 36083) 36804)) inline$$VerifyVector_verify_index_of_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (forall (($tv0@@4 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@4)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@4))))
(let ((l@@26 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@26))
))))))) (=> (and (forall (($tv0@@5 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@5)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@5))))
(let ((l@@27 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@27))
))))))) (= (ControlFlow 0 68188) 36083)) anon0_correct@@1))))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$VerifyVector_verify_is_empty_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@17 () T@$Value)
(declare-fun inline$$VerifyVector_verify_is_empty_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_is_empty_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 69918) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 38958) (- 0 70182)) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_is_empty_$def_verify$0$$ret0@2 ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@17))) ($Integer 0))))))))))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon8_correct  (=> (= $abort_flag@0@@2 false) (=> (and (= inline$$VerifyVector_verify_is_empty_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_is_empty_$def_verify$0$$t4@1) (= (ControlFlow 0 38910) 38958)) anon0$2_correct@@2))))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 38908) 38910)) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon8_correct)))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 38918) 38910) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon8_correct)))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon10_Else_correct  (=> (not false) (=> (and (= inline$$VerifyVector_verify_is_empty_$def_verify$0$$t3@1 ($Integer 0)) (= inline$$VerifyVector_verify_is_empty_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1@@1 inline$$VerifyVector_verify_is_empty_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 38902) 38918) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38902) 38908) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon10_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@1  (=> (and ((_ is $Vector) v@@17) (= inline$$Vector_length$0$l@1@@1 ($Integer (|l#$ValueArray| (|v#$Vector| v@@17))))) (and (=> (= (ControlFlow 0 38874) 38922) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 38874) 38902) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 38789) 38874)) inline$$Vector_length$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 38950) 38874) inline$$Vector_length$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_is_empty_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 38783) 38950) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 38783) 38789) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and ((_ is $Vector) v@@17) (let ((va@@26 (|v#$Vector| v@@17)))
(let ((l@@28 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@28))
)))))) (= (ControlFlow 0 38593) 38783)) inline$$VerifyVector_verify_is_empty_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (forall (($tv0@@6 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@6)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@6))))
(let ((l@@29 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@29))
))))))) (=> (and (forall (($tv0@@7 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@7)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@7))))
(let ((l@@30 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@30))
))))))) (= (ControlFlow 0 69918) 38593)) anon0_correct@@2))))
PreconditionGeneratedEntry_correct@@2)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun lhs () T@$Value)
(declare-fun other@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_append$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 70216) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 39793) (- 0 70712)) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| other@@0))))))))))) (=> (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| other@@0)))))))))) (and (=> (= (ControlFlow 0 39793) (- 0 70742)) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs))))))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))))))) lhs))))) (=> (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs))))))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| lhs)))))))))) lhs)))) (=> (= (ControlFlow 0 39793) (- 0 70768)) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| lhs))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| lhs))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2))))))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| lhs))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| lhs))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| lhs))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| lhs))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| lhs))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2)))))))))) other@@0)))))))))))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon10_correct  (=> (= $abort_flag@0@@3 false) (=> (and (= inline$$VerifyVector_verify_model_append_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@0|) (= (ControlFlow 0 39737) 39793)) anon0$2_correct@@3))))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 39735) 39737)) inline$$VerifyVector_verify_model_append_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 39745) 39737) inline$$VerifyVector_verify_model_append_$def_verify$0$anon10_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2@@0| lhs)) (and (=> (= (ControlFlow 0 39693) 39745) inline$$VerifyVector_verify_model_append_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 39693) 39735) inline$$VerifyVector_verify_model_append_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 lhs (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 39719) 39745) inline$$VerifyVector_verify_model_append_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 39719) 39735) inline$$VerifyVector_verify_model_append_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0) |inline$$Vector_append$0$v'@1|)) (and (=> (= (ControlFlow 0 39594) 39719) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 39594) 39693) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon13_Else_correct  (=> (and (not false) (= (ControlFlow 0 39600) 39594)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon13_Then_correct true))
(let ((inline$$Vector_append$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (=> (and ((_ is $Vector) other@@0) (= |inline$$Vector_append$0$v'@1| ($Vector (let ((m2 (|v#$ValueArray| (|v#$Vector| other@@0))))
(let ((l2 (|l#$ValueArray| (|v#$Vector| other@@0))))
(let ((m1 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0))))
(let ((l1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0))))
($ValueArray (|lambda#2| 0 (+ l1 l2) l1 m1 m2 l1 $Error) (+ l1 l2))))))))) (and (=> (= (ControlFlow 0 39529) 39749) inline$$VerifyVector_verify_model_append_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 39529) 39600) inline$$VerifyVector_verify_model_append_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 39458) 39529)) inline$$Vector_append$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 2) $EmptyPath lhs)) (= (ControlFlow 0 39420) 39458)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 39302) 39420)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 39777) 39420) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 39294) 39777) inline$$VerifyVector_verify_model_append_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 39294) 39302) inline$$VerifyVector_verify_model_append_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 39785) 39777) inline$$VerifyVector_verify_model_append_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 39785) 39302) inline$$VerifyVector_verify_model_append_$def_verify$0$anon12_Else_correct))))
(let ((inline$$VerifyVector_verify_model_append_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 39288) 39785) inline$$VerifyVector_verify_model_append_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 39288) 39294) inline$$VerifyVector_verify_model_append_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@3  (=> (and ((_ is $Vector) lhs) (let ((va@@29 (|v#$Vector| lhs)))
(let ((l@@31 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@31))
)))))) (=> (and (and ((_ is $Vector) other@@0) (let ((va@@30 (|v#$Vector| other@@0)))
(let ((l@@32 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@32))
)))))) (= (ControlFlow 0 39062) 39288)) inline$$VerifyVector_verify_model_append_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (forall (($tv0@@8 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@8)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@8))))
(let ((l@@33 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@33))
))))))) (=> (and (forall (($tv0@@9 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@9)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@9))))
(let ((l@@34 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@34))
))))))) (= (ControlFlow 0 70216) 39062)) anon0_correct@@3))))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun i@@11 () T@$Value)
(declare-fun v@@18 () T@$Value)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$VerifyVector_verify_model_borrow_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_borrow_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@2@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1 () Int)
(declare-fun inline$$Vector_borrow$0$dst@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 70803) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 40554) (- 0 71205)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@11) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@18))))))) $abort_flag@1@@2)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@11) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@18))))))) $abort_flag@1@@2) (and (=> (= (ControlFlow 0 40554) (- 0 71224)) (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@11) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@18))))))))) (=> (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@11) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@18)))))))) (=> (= (ControlFlow 0 40554) (- 0 71243)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_borrow_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@18)) (|i#$Integer| i@@11)))))))))))))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon7_correct  (=> (and (and (= inline$$VerifyVector_verify_model_borrow_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_model_borrow_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_model_borrow_$def_verify$0$$ret0@1)) (and (= $abort_flag@1@@2 true) (= (ControlFlow 0 40522) 40554))) anon0$2_correct@@4)))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 40516) 40522)) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 40530) 40522) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 40510) 40530) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 40510) 40516) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon10_correct  (=> (= inline$$VerifyVector_verify_model_borrow_$def_verify$0$$ret0@2 inline$$Vector_borrow$0$dst@2@@1) (=> (and (= $abort_flag@1@@2 $abort_flag@0@@4) (= (ControlFlow 0 40498) 40554)) anon0$2_correct@@4))))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 40496) 40498)) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 40506) 40498) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@4) (and (=> (= (ControlFlow 0 40490) 40506) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 40490) 40496) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@4 true) (= inline$$Vector_borrow$0$dst@2@@1 inline$$Vector_borrow$0$dst@0)) (and (=> (= (ControlFlow 0 40474) 40510) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 40474) 40490) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@1  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| v@@18)))) (= (ControlFlow 0 40472) 40474)) inline$$Vector_borrow$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@1  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| v@@18))))) (= inline$$Vector_borrow$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@18)) inline$$Vector_borrow$0$i_ind@1))) (and (= $abort_flag@0@@4 false) (= inline$$Vector_borrow$0$dst@2@@1 inline$$Vector_borrow$0$dst@1@@1))) (and (=> (= (ControlFlow 0 40414) 40510) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 40414) 40490) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct@@1  (=> ((_ is $Vector) v@@18) (=> (and ((_ is $Integer) i@@11) (= inline$$Vector_borrow$0$i_ind@1 (|i#$Integer| i@@11))) (and (=> (= (ControlFlow 0 40388) 40472) inline$$Vector_borrow$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 40388) 40414) inline$$Vector_borrow$0$anon3_Else_correct@@1))))))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 40196) 40388)) inline$$Vector_borrow$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 40538) 40388) inline$$Vector_borrow$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40188) 40538) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 40188) 40196) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 40546) 40538) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 40546) 40196) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon12_Else_correct))))
(let ((inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 40182) 40546) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 40182) 40188) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@4  (=> (and ((_ is $Vector) v@@18) (let ((va@@33 (|v#$Vector| v@@18)))
(let ((l@@35 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@35))
)))))) (=> (and (and (and ((_ is $Integer) i@@11) (>= (|i#$Integer| i@@11) 0)) (<= (|i#$Integer| i@@11) $MAX_U64)) (= (ControlFlow 0 39966) 40182)) inline$$VerifyVector_verify_model_borrow_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (forall (($tv0@@10 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@10)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@10))))
(let ((l@@36 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@36))
))))))) (=> (and (forall (($tv0@@11 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@11)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@11))))
(let ((l@@37 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@37))
))))))) (= (ControlFlow 0 70803) 39966)) anon0_correct@@4))))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun i@@12 () T@$Value)
(declare-fun v@@19 () T@$Value)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret0@1 () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $DefaultMutation () T@$Mutation)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun |inline$$Splice1$0$dst'@1| () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$Vector_borrow_mut$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$Vector_borrow_mut$0$v'| () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@0 () T@$Mutation)
(declare-fun inline$$Vector_borrow_mut$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@1 () T@$Mutation)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 71271) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 41668) (- 0 71904)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@12) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@19))))))) $abort_flag@1@@3)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@12) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@19))))))) $abort_flag@1@@3) (and (=> (= (ControlFlow 0 41668) (- 0 71923)) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@12) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@19))))))))) (=> (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@12) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@19)))))))) (=> (= (ControlFlow 0 41668) (- 0 71942)) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|v#$Mutation| inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret0@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret1@2)) (|i#$Integer| i@@12)))))))))))))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon7_correct  (=> (= inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret1@1 $Error) (=> (and (and (= inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret0@1 $DefaultMutation) (= inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret1@1)) (and (= $abort_flag@1@@3 true) (= (ControlFlow 0 41634) 41668))) anon0$2_correct@@5))))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 41626) 41634)) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 41642) 41634) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 41620) 41642) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 41620) 41626) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon12_correct  (=> (and (and (= inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret0@1 |inline$$Splice1$0$dst'@1|) (= inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$ret1@2 v@@19)) (and (= $abort_flag@1@@3 $abort_flag@0@@5) (= (ControlFlow 0 41598) 41668))) anon0$2_correct@@5)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 41596) 41598)) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 41606) 41598) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 41586) 41606) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 41586) 41596) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon17_Then_correct  (=> (= inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$Splice1$0$dst'@1|)) (and (=> (= (ControlFlow 0 41616) 41606) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 41616) 41596) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Splice1$0$anon0_correct  (=> (= |inline$$Splice1$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) ($ConcatPath_stratified (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|p#$Mutation| inline$$Vector_borrow_mut$0$dst@2)) (|v#$Mutation| inline$$Vector_borrow_mut$0$dst@2))) (and (=> (= (ControlFlow 0 41570) 41616) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 41570) 41586) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1) |inline$$Vector_borrow_mut$0$v'|)) (= (ControlFlow 0 41489) 41570)) inline$$Splice1$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@5) (= (ControlFlow 0 41495) 41489)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$Vector_borrow_mut$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@5 true) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@0)) (and (=> (= (ControlFlow 0 41422) 41620) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 41422) 41495) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)))) (= (ControlFlow 0 41420) 41422)) inline$$Vector_borrow_mut$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow_mut$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1))))) (= inline$$Vector_borrow_mut$0$dst@1 ($Mutation ($Local 0) ($Path (|Store_[$int]$int| (|p#$Path| $EmptyPath) 0 inline$$Vector_borrow_mut$0$i_ind@1) 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) inline$$Vector_borrow_mut$0$i_ind@1)))) (and (= $abort_flag@0@@5 false) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@1))) (and (=> (= (ControlFlow 0 41362) 41620) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 41362) 41495) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$anon0_correct  (=> (and (= inline$$Vector_borrow_mut$0$i_ind@1 (|i#$Integer| i@@12)) ((_ is $Vector) inline$$ReadRef$0$v@1@@1)) (and (=> (= (ControlFlow 0 41314) 41420) inline$$Vector_borrow_mut$0$anon3_Then_correct) (=> (= (ControlFlow 0 41314) 41362) inline$$Vector_borrow_mut$0$anon3_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$Entry_correct  (and (=> (= (ControlFlow 0 41304) (- 0 71633)) true) (=> (= (ControlFlow 0 41304) 41314) inline$$Vector_borrow_mut$0$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 41161) 41304)) inline$$Vector_borrow_mut$0$Entry_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 2) $EmptyPath v@@19)) (= (ControlFlow 0 41089) 41161)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 40971) 41089)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 41650) 41089) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40963) 41650) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 40963) 40971) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 41658) 41650) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 41658) 40971) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon14_Else_correct))))
(let ((inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 40957) 41658) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 40957) 40963) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@5  (=> (and ((_ is $Vector) v@@19) (let ((va@@36 (|v#$Vector| v@@19)))
(let ((l@@38 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@38))
)))))) (=> (and (and (and ((_ is $Integer) i@@12) (>= (|i#$Integer| i@@12) 0)) (<= (|i#$Integer| i@@12) $MAX_U64)) (= (ControlFlow 0 40676) 40957)) inline$$VerifyVector_verify_model_borrow_mut_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (forall (($tv0@@12 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@12)) (let ((va@@37 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@12))))
(let ((l@@39 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@39))
))))))) (=> (and (forall (($tv0@@13 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@13)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@13))))
(let ((l@@40 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@40))
))))))) (= (ControlFlow 0 71271) 40676)) anon0_correct@@5))))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun inline$$VerifyVector_verify_model_contains_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@20 () T@$Value)
(declare-fun e@@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 71970) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 42299) (- 0 72289)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@6)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@6) (and (=> (= (ControlFlow 0 42299) (- 0 72298)) (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 42299) (- 0 72307)) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_contains_$def_verify$0$$ret0@2 ($Boolean (let (($range_1@@1 v@@20))
(exists (($i_0@@2 Int) )  (and (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@41 e@@1)))))))))))))))))))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon10_correct  (=> (= $abort_flag@0@@6 false) (=> (and (= inline$$VerifyVector_verify_model_contains_$def_verify$0$$ret0@2 inline$$Vector_contains$0$res@1) (= (ControlFlow 0 42243) 42299)) anon0$2_correct@@6))))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 42241) 42243)) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 42251) 42243) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon13_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 42235) 42251) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 42235) 42241) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon13_Then_correct true))
(let ((inline$$Vector_contains$0$anon0_correct  (=> (and ((_ is $Vector) v@@20) (= inline$$Vector_contains$0$res@1 ($Boolean (exists ((i@@13 Int) )  (and (and (<= 0 i@@13) (< i@@13 (|l#$ValueArray| (|v#$Vector| v@@20)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@20)) i@@13) e@@1)))))) (and (=> (= (ControlFlow 0 42219) 42255) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 42219) 42235) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 42090) 42219)) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 42283) 42219) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42082) 42283) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 42082) 42090) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 42291) 42283) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 42291) 42090) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon12_Else_correct))))
(let ((inline$$VerifyVector_verify_model_contains_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 42076) 42291) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 42076) 42082) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@6  (=> (and (and ((_ is $Vector) v@@20) (let ((va@@39 (|v#$Vector| v@@20)))
(let ((l@@41 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@42))
)))))) (= (ControlFlow 0 41867) 42076)) inline$$VerifyVector_verify_model_contains_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (forall (($tv0@@14 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@14)) (let ((va@@40 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@14))))
(let ((l@@42 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@43))
))))))) (=> (and (forall (($tv0@@15 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@15)) (let ((va@@41 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@15))))
(let ((l@@43 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@44))
))))))) (= (ControlFlow 0 71970) 41867)) anon0_correct@@6))))
PreconditionGeneratedEntry_correct@@6)))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun v@@21 () T@$Value)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_flag@0@@7 () Bool)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 72362) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 42762) (- 0 72600)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@21)))) (|i#$Integer| ($Integer 0))))) $abort_flag@1@@4)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@21)))) (|i#$Integer| ($Integer 0))))) $abort_flag@1@@4) (=> (= (ControlFlow 0 42762) (- 0 72621)) (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@21)))) (|i#$Integer| ($Integer 0)))))))))))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon5_correct  (=> (and (= $abort_flag@1@@4 true) (= (ControlFlow 0 42740) 42762)) anon0$2_correct@@7)))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 42736) 42740)) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon5_correct)))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 42748) 42740) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon5_correct)))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon8_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 42730) 42748) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 42730) 42736) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@0@@7) (=> (and (= $abort_flag@1@@4 $abort_flag@0@@7) (= (ControlFlow 0 42726) 42762)) anon0$2_correct@@7))))
(let ((inline$$Vector_destroy_empty$0$anon2_Then$1_correct@@0  (=> (= $abort_flag@0@@7 true) (and (=> (= (ControlFlow 0 42714) 42730) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 42714) 42726) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Vector_destroy_empty$0$anon2_Then_correct@@0  (=> (and (not (= (|l#$ValueArray| (|v#$Vector| v@@21)) 0)) (= (ControlFlow 0 42712) 42714)) inline$$Vector_destroy_empty$0$anon2_Then$1_correct@@0)))
(let ((inline$$Vector_destroy_empty$0$anon2_Else_correct@@0  (=> (and (= (|l#$ValueArray| (|v#$Vector| v@@21)) 0) (= $abort_flag@0@@7 false)) (and (=> (= (ControlFlow 0 42662) 42730) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 42662) 42726) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42555) 42712) inline$$Vector_destroy_empty$0$anon2_Then_correct@@0) (=> (= (ControlFlow 0 42555) 42662) inline$$Vector_destroy_empty$0$anon2_Else_correct@@0)))))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 42756) 42712) inline$$Vector_destroy_empty$0$anon2_Then_correct@@0) (=> (= (ControlFlow 0 42756) 42662) inline$$Vector_destroy_empty$0$anon2_Else_correct@@0))))
(let ((inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 42549) 42756) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 42549) 42555) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and ((_ is $Vector) v@@21) (let ((va@@42 (|v#$Vector| v@@21)))
(let ((l@@44 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@45))
)))))) (= (ControlFlow 0 42413) 42549)) inline$$VerifyVector_verify_model_destroy_empty_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (forall (($tv0@@16 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@16)) (let ((va@@43 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@16))))
(let ((l@@45 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@46))
))))))) (=> (and (forall (($tv0@@17 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@17)) (let ((va@@44 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@17))))
(let ((l@@46 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@47))
))))))) (= (ControlFlow 0 72362) 42413)) anon0_correct@@7))))
PreconditionGeneratedEntry_correct@@7)))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun inline$$VerifyVector_verify_model_empty_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 72649) (let ((anon0$2_correct@@8  (=> (= (ControlFlow 0 43054) (- 0 72826)) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_empty_$def_verify$0$$ret0@2))) ($Integer 0))))))))
(let ((inline$$VerifyVector_verify_model_empty_$def_verify$0$anon6_correct  (=> (= $abort_flag@0@@8 false) (=> (and (= inline$$VerifyVector_verify_model_empty_$def_verify$0$$ret0@2 inline$$Vector_empty$0$v@1) (= (ControlFlow 0 43014) 43054)) anon0$2_correct@@8))))
(let ((inline$$VerifyVector_verify_model_empty_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 43012) 43014)) inline$$VerifyVector_verify_model_empty_$def_verify$0$anon6_correct)))
(let ((inline$$VerifyVector_verify_model_empty_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 43022) 43014) inline$$VerifyVector_verify_model_empty_$def_verify$0$anon6_correct)))
(let ((inline$$VerifyVector_verify_model_empty_$def_verify$0$anon7_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 43006) 43022) inline$$VerifyVector_verify_model_empty_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 43006) 43012) inline$$VerifyVector_verify_model_empty_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_empty_$def_verify$0$anon7_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 42990) 43026) inline$$VerifyVector_verify_model_empty_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 42990) 43006) inline$$VerifyVector_verify_model_empty_$def_verify$0$anon7_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_empty_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 42996) 42990)) inline$$Vector_empty$0$anon0_correct)))
(let ((anon0_correct@@8  (=> (forall (($tv0@@18 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@18)) (let ((va@@45 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@18))))
(let ((l@@47 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@48))
))))))) (=> (and (forall (($tv0@@19 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@19)) (let ((va@@46 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@19))))
(let ((l@@48 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@49))
))))))) (= (ControlFlow 0 72649) 42996)) inline$$VerifyVector_verify_model_empty_$def_verify$0$anon0_correct))))
anon0_correct@@8))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@22 () T@$Value)
(declare-fun e@@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun call3formal@res1@0 () T@$Value)
(declare-fun call4formal@res2@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 72855) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 43550) (- 0 73559)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9) (and (=> (= (ControlFlow 0 43550) (- 0 73568)) (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 43550) (- 0 73577)) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2 ($Boolean (let (($range_1@@2 v@@22))
(exists (($i_0@@3 Int) )  (and (and (>= $i_0@@3 0) (< $i_0@@3 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((x@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@50 e@@2))))))))))))) (=> (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2 ($Boolean (let (($range_1@@2 v@@22))
(exists (($i_0@@4 Int) )  (and (and (>= $i_0@@4 0) (< $i_0@@4 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((x@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@50 e@@2)))))))))))) (and (=> (= (ControlFlow 0 43550) (- 0 73624)) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) (|i#$Integer| inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret1@2)) e@@2)))))))) (=> (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) (|i#$Integer| inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret1@2)) e@@2))))))) (and (=> (= (ControlFlow 0 43550) (- 0 73651)) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean (let (($range_3@@0 ($Range ($Integer 0) inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret1@2)))
(forall (($i_2@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@0)) $i_2@@1) (< $i_2@@1 (|i#$Integer| (|ub#$Range| $range_3@@0)))) (let ((i@@14 ($Integer $i_2@@1)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) (|i#$Integer| i@@14)) e@@2))))))))))))))) (=> (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean (let (($range_3@@0 ($Range ($Integer 0) inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret1@2)))
(forall (($i_2@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@0)) $i_2@@2) (< $i_2@@2 (|i#$Integer| (|ub#$Range| $range_3@@0)))) (let ((i@@14 ($Integer $i_2@@2)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) (|i#$Integer| i@@14)) e@@2)))))))))))))) (=> (= (ControlFlow 0 43550) (- 0 73711)) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret1@2 ($Integer 0)))))))))))))))))))))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon12_correct  (=> (and (and (= $abort_flag@0@@9 false) (= inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret0@2 call3formal@res1@0)) (and (= inline$$VerifyVector_verify_model_index_of_$def_verify$0$$ret1@2 call4formal@res2@0) (= (ControlFlow 0 43482) 43550))) anon0$2_correct@@9)))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 43480) 43482)) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 43490) 43482) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43470) 43490) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 43470) 43480) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 43498) 43490) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 43498) 43480) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon18_Else_correct))))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon15_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 43464) 43498) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 43464) 43470) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon15_Then_correct true))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon4$2_correct  (and (=> (= (ControlFlow 0 43456) (- 0 73360)) ((_ is $Vector) v@@22)) (=> ((_ is $Vector) v@@22) (=> (and (and (and ((_ is $Boolean) call3formal@res1@0) ((_ is $Integer) call4formal@res2@0)) (and (<= 0 (|i#$Integer| call4formal@res2@0)) (< (|i#$Integer| call4formal@res2@0) (|l#$ValueArray| (|v#$Vector| v@@22))))) (and (and (= call3formal@res1@0 ($Boolean (exists ((i@@15 Int) )  (and (and (<= 0 i@@15) (< i@@15 (|l#$ValueArray| (|v#$Vector| v@@22)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) i@@15) e@@2))))) (=> (|b#$Boolean| call3formal@res1@0) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) (|i#$Integer| call4formal@res2@0)) e@@2))) (and (=> (|b#$Boolean| call3formal@res1@0) (forall ((i@@16 Int) )  (=> (and (<= 0 i@@16) (< i@@16 (|i#$Integer| call4formal@res2@0))) (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) i@@16) e@@2))))) (=> (not (|b#$Boolean| call3formal@res1@0)) (= (|i#$Integer| call4formal@res2@0) 0))))) (and (=> (= (ControlFlow 0 43456) 43502) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 43456) 43464) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon15_Else_correct)))))))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 43386) 43456)) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon4$2_correct)))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 43532) 43456) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon4$2_correct)))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 43378) 43532) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 43378) 43386) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 43540) 43532) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 43540) 43386) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon14_Else_correct))))
(let ((inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 43372) 43540) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 43372) 43378) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@9  (=> (and (and ((_ is $Vector) v@@22) (let ((va@@47 (|v#$Vector| v@@22)))
(let ((l@@49 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@51))
)))))) (= (ControlFlow 0 43122) 43372)) inline$$VerifyVector_verify_model_index_of_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (forall (($tv0@@20 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@20)) (let ((va@@48 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@20))))
(let ((l@@50 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@52))
))))))) (=> (and (forall (($tv0@@21 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@21)) (let ((va@@49 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@21))))
(let ((l@@51 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@53))
))))))) (= (ControlFlow 0 72855) 43122)) anon0_correct@@9))))
PreconditionGeneratedEntry_correct@@8)))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun inline$$VerifyVector_verify_model_is_empty_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@23 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$b@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 73751) (let ((anon0$2_correct@@10  (=> (= (ControlFlow 0 44001) (- 0 73987)) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_is_empty_$def_verify$0$$ret0@2 ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@23))) ($Integer 0))))))))))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon8_correct  (=> (= $abort_flag@0@@10 false) (=> (and (= inline$$VerifyVector_verify_model_is_empty_$def_verify$0$$ret0@2 inline$$Vector_is_empty$0$b@1) (= (ControlFlow 0 43953) 44001)) anon0$2_correct@@10))))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 43951) 43953)) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon8_correct)))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 43961) 43953) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon8_correct)))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon10_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 43945) 43961) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 43945) 43951) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon10_Then_correct true))
(let ((inline$$Vector_is_empty$0$anon0_correct@@0  (=> (and ((_ is $Vector) v@@23) (= inline$$Vector_is_empty$0$b@1 ($Boolean (= (|l#$ValueArray| (|v#$Vector| v@@23)) 0)))) (and (=> (= (ControlFlow 0 43929) 43965) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 43929) 43945) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 43836) 43929)) inline$$Vector_is_empty$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 43993) 43929) inline$$Vector_is_empty$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 43830) 43993) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 43830) 43836) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@10  (=> (and (and ((_ is $Vector) v@@23) (let ((va@@50 (|v#$Vector| v@@23)))
(let ((l@@52 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@54))
)))))) (= (ControlFlow 0 43660) 43830)) inline$$VerifyVector_verify_model_is_empty_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (forall (($tv0@@22 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@22)) (let ((va@@51 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@22))))
(let ((l@@53 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@55))
))))))) (=> (and (forall (($tv0@@23 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@23)) (let ((va@@52 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@23))))
(let ((l@@54 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@56))
))))))) (= (ControlFlow 0 73751) 43660)) anon0_correct@@10))))
PreconditionGeneratedEntry_correct@@9)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@11 () Bool)
(declare-fun inline$$VerifyVector_verify_model_length_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@24 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 74020) (let ((anon0$2_correct@@11  (=> (= (ControlFlow 0 44426) (- 0 74244)) (=> (not $abort_flag@0@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_length_$def_verify$0$$ret0@2 ($Integer (|l#$ValueArray| (|v#$Vector| v@@24))))))))))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon8_correct  (=> (= $abort_flag@0@@11 false) (=> (and (= inline$$VerifyVector_verify_model_length_$def_verify$0$$ret0@2 inline$$Vector_length$0$l@1@@2) (= (ControlFlow 0 44378) 44426)) anon0$2_correct@@11))))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 44376) 44378)) inline$$VerifyVector_verify_model_length_$def_verify$0$anon8_correct)))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 44386) 44378) inline$$VerifyVector_verify_model_length_$def_verify$0$anon8_correct)))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon10_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 44370) 44386) inline$$VerifyVector_verify_model_length_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 44370) 44376) inline$$VerifyVector_verify_model_length_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon10_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@2  (=> (and ((_ is $Vector) v@@24) (= inline$$Vector_length$0$l@1@@2 ($Integer (|l#$ValueArray| (|v#$Vector| v@@24))))) (and (=> (= (ControlFlow 0 44354) 44390) inline$$VerifyVector_verify_model_length_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 44354) 44370) inline$$VerifyVector_verify_model_length_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 44269) 44354)) inline$$Vector_length$0$anon0_correct@@2)))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 44418) 44354) inline$$Vector_length$0$anon0_correct@@2)))
(let ((inline$$VerifyVector_verify_model_length_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 44263) 44418) inline$$VerifyVector_verify_model_length_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 44263) 44269) inline$$VerifyVector_verify_model_length_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@11  (=> (and (and ((_ is $Vector) v@@24) (let ((va@@53 (|v#$Vector| v@@24)))
(let ((l@@55 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@57))
)))))) (= (ControlFlow 0 44093) 44263)) inline$$VerifyVector_verify_model_length_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (forall (($tv0@@24 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@24)) (let ((va@@54 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@24))))
(let ((l@@56 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@58))
))))))) (=> (and (forall (($tv0@@25 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@25)) (let ((va@@55 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@25))))
(let ((l@@57 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@59))
))))))) (= (ControlFlow 0 74020) 44093)) anon0_correct@@11))))
PreconditionGeneratedEntry_correct@@10)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun v@@25 () T@$Value)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@12 () Bool)
(declare-fun inline$$Vector_pop_back$0$e@2@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$Vector_pop_back$0$v'@2@@0| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$e@0 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@0| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$len@1 () Int)
(declare-fun inline$$Vector_pop_back$0$e@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@1@@0| () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 74270) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 45344) (- 0 74925)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@25))) ($Integer 0)))) $abort_flag@1@@5)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@25))) ($Integer 0)))) $abort_flag@1@@5) (and (=> (= (ControlFlow 0 45344) (- 0 74942)) (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@25))) ($Integer 0)))))) (=> (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| v@@25))) ($Integer 0))))) (and (=> (= (ControlFlow 0 45344) (- 0 74959)) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 45344) (- 0 74989)) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@25)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1))))))))))) (=> (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@25)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1)))))))))) (=> (= (ControlFlow 0 45344) (- 0 75021)) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1)))))))) (|v#$ValueArray| (|v#$Vector| v@@25)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@25)))) (|i#$Integer| ($Integer 1))))))))))))))))))))))))))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon5_correct  (=> (and (= inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@1) (= inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@1)) (and (= $abort_flag@1@@5 true) (= (ControlFlow 0 45318) 45344))) anon0$2_correct@@12))))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 45310) 45318)) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon5_correct)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 45326) 45318) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon5_correct)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon12_Then_correct  (=> $abort_flag@0@@12 (and (=> (= (ControlFlow 0 45304) 45326) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 45304) 45310) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon10_correct  (=> (and (and (= inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret0@2 inline$$Vector_pop_back$0$e@2@@0) (= inline$$VerifyVector_verify_model_pop_back_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@1|)) (and (= $abort_flag@1@@5 $abort_flag@0@@12) (= (ControlFlow 0 45284) 45344))) anon0$2_correct@@12)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 45282) 45284)) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 45292) 45284) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon14_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 45272) 45292) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 45272) 45282) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon14_Then_correct  (and (=> (= (ControlFlow 0 45300) 45292) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 45300) 45282) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon15_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@1| v@@25)) (and (=> (= (ControlFlow 0 45230) 45300) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 45230) 45272) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|) 0 v@@25 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))) (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 45256) 45300) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 45256) 45272) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2) |inline$$Vector_pop_back$0$v'@2@@0|)) (and (=> (= (ControlFlow 0 45131) 45256) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 45131) 45230) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon12_Else_correct  (=> (and (not $abort_flag@0@@12) (= (ControlFlow 0 45137) 45131)) inline$$WriteRef$0$anon0_correct@@2)))
(let ((inline$$Vector_pop_back$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@12 true) (=> (and (= inline$$Vector_pop_back$0$e@2@@0 inline$$Vector_pop_back$0$e@0) (= |inline$$Vector_pop_back$0$v'@2@@0| |inline$$Vector_pop_back$0$v'@0|)) (and (=> (= (ControlFlow 0 45064) 45304) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 45064) 45137) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon3_Then_correct@@0  (=> (and (= inline$$Vector_pop_back$0$len@1 0) (= (ControlFlow 0 45062) 45064)) inline$$Vector_pop_back$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_pop_back$0$anon3_Else_correct@@0  (=> (and (not (= inline$$Vector_pop_back$0$len@1 0)) (= inline$$Vector_pop_back$0$e@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) (- inline$$Vector_pop_back$0$len@1 1)))) (=> (and (and (= |inline$$Vector_pop_back$0$v'@1@@0| ($Vector (let ((l@@58 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) 1)))
($ValueArray (|lambda#0| 0 l@@58 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $Error) l@@58)))) (= $abort_flag@0@@12 false)) (and (= inline$$Vector_pop_back$0$e@2@@0 inline$$Vector_pop_back$0$e@1@@0) (= |inline$$Vector_pop_back$0$v'@2@@0| |inline$$Vector_pop_back$0$v'@1@@0|))) (and (=> (= (ControlFlow 0 45014) 45304) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 45014) 45137) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@2) (= inline$$Vector_pop_back$0$len@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)))) (and (=> (= (ControlFlow 0 44992) 45062) inline$$Vector_pop_back$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 44992) 45014) inline$$Vector_pop_back$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (= (ControlFlow 0 44881) 44992)) inline$$Vector_pop_back$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$0$dst@1@@2 ($Mutation ($Local 1) $EmptyPath v@@25)) (= (ControlFlow 0 44843) 44881)) inline$$ReadRef$0$anon0_correct@@2)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 44759) 44843)) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 45334) 44843) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 44753) 45334) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 44753) 44759) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@12  (=> (and (and ((_ is $Vector) v@@25) (let ((va@@56 (|v#$Vector| v@@25)))
(let ((l@@59 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@60))
)))))) (= (ControlFlow 0 44518) 44753)) inline$$VerifyVector_verify_model_pop_back_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (forall (($tv0@@26 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@26)) (let ((va@@57 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@26))))
(let ((l@@60 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@61))
))))))) (=> (and (forall (($tv0@@27 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@27)) (let ((va@@58 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@27))))
(let ((l@@61 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@62))
))))))) (= (ControlFlow 0 74270) 44518)) anon0_correct@@12))))
PreconditionGeneratedEntry_correct@@11))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@13 () Bool)
(declare-fun inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@26 () T@$Value)
(declare-fun e@@3 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@2| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 75068) (let ((anon0$2_correct@@13  (and (=> (= (ControlFlow 0 46232) (- 0 75574)) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@26)))) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@26)))) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 46232) (- 0 75604)) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1)))))) e@@3))))) (=> (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1)))))) e@@3)))) (=> (= (ControlFlow 0 46232) (- 0 75635)) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified v@@26 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1)))))))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1))))))))))))))))))))))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon10_correct  (=> (= $abort_flag@0@@13 false) (=> (and (= inline$$VerifyVector_verify_model_push_back_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@2|) (= (ControlFlow 0 46176) 46232)) anon0$2_correct@@13))))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 46174) 46176)) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 46184) 46176) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon10_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@2  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2@@2| v@@26)) (and (=> (= (ControlFlow 0 46132) 46184) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 46132) 46174) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@2  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|) 0 v@@26 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) (= |inline$$WritebackToValue$0$vdst'@2@@2| |inline$$WritebackToValue$0$vdst'@1@@2|)) (and (=> (= (ControlFlow 0 46158) 46184) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 46158) 46174) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3) |inline$$Vector_push_back$0$v'@1|)) (and (=> (= (ControlFlow 0 46033) 46158) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 46033) 46132) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon13_Else_correct  (=> (and (not false) (= (ControlFlow 0 46039) 46033)) inline$$WriteRef$0$anon0_correct@@3)))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon13_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@3) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) len@@1 e@@3) (+ len@@1 1)))))) (and (=> (= (ControlFlow 0 45968) 46188) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 45968) 46039) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (= (ControlFlow 0 45905) 45968)) inline$$Vector_push_back$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$0$dst@1@@3 ($Mutation ($Local 2) $EmptyPath v@@26)) (= (ControlFlow 0 45867) 45905)) inline$$ReadRef$0$anon0_correct@@3)))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 45749) 45867)) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 46216) 45867) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 45741) 46216) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 45741) 45749) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 46224) 46216) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 46224) 45749) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon12_Else_correct))))
(let ((inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 45735) 46224) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 45735) 45741) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@13  (=> (and (and ((_ is $Vector) v@@26) (let ((va@@59 (|v#$Vector| v@@26)))
(let ((l@@62 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@63))
)))))) (= (ControlFlow 0 45509) 45735)) inline$$VerifyVector_verify_model_push_back_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (forall (($tv0@@28 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@28)) (let ((va@@60 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@28))))
(let ((l@@63 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@64))
))))))) (=> (and (forall (($tv0@@29 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@29)) (let ((va@@61 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@29))))
(let ((l@@64 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@65))
))))))) (= (ControlFlow 0 75068) 45509)) anon0_correct@@13))))
PreconditionGeneratedEntry_correct@@12))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun i@@17 () T@$Value)
(declare-fun v@@27 () T@$Value)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@14 () Bool)
(declare-fun inline$$Vector_remove$0$e@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@3| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@4| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@3| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@4 () T@$Mutation)
(declare-fun |inline$$Vector_remove$0$v'@2| () T@$Value)
(declare-fun inline$$Vector_remove$0$e@0 () T@$Value)
(declare-fun |inline$$Vector_remove$0$v'@0| () T@$Value)
(declare-fun inline$$Vector_remove$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$0$v@1@@4 () T@$Value)
(declare-fun inline$$Vector_remove$0$e@1 () T@$Value)
(declare-fun |inline$$Vector_remove$0$v'@1| () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 75683) (let ((anon0$2_correct@@14  (and (=> (= (ControlFlow 0 47364) (- 0 76426)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@17) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))) $abort_flag@1@@6)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@17) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))) $abort_flag@1@@6) (and (=> (= (ControlFlow 0 47364) (- 0 76445)) (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@17) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))))) (=> (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@17) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))))) (and (=> (= (ControlFlow 0 47364) (- 0 76464)) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 47364) (- 0 76494)) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) (|v#$ValueArray| (|v#$Vector| v@@27)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))))))))))) (=> (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) (|v#$ValueArray| (|v#$Vector| v@@27)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) i@@17))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) i@@17))))))))))) (and (=> (= (ControlFlow 0 47364) (- 0 76528)) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2))))))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))) (|v#$ValueArray| (|v#$Vector| v@@27)) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))))))))))) (=> (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2))))))) (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))) (|i#$Integer| (|lb#$Range| ($Range i@@17 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2)))))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))) (|v#$ValueArray| (|v#$Vector| v@@27)) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| i@@17) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@27)))))))))))))) (=> (= (ControlFlow 0 47364) (- 0 76573)) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@27)) (|i#$Integer| i@@17)) inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret0@2)))))))))))))))))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon7_correct  (=> (and (= inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret0@1) (= inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@1)) (and (= $abort_flag@1@@6 true) (= (ControlFlow 0 47330) 47364))) anon0$2_correct@@14))))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 47322) 47330)) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 47338) 47330) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@14 (and (=> (= (ControlFlow 0 47316) 47338) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 47316) 47322) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon12_correct  (=> (and (and (= inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret0@2 inline$$Vector_remove$0$e@2) (= inline$$VerifyVector_verify_model_remove_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@3|)) (and (= $abort_flag@1@@6 $abort_flag@0@@14) (= (ControlFlow 0 47296) 47364))) anon0$2_correct@@14)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 47294) 47296)) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 47304) 47296) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 47284) 47304) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 47284) 47294) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 47312) 47304) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 47312) 47294) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon18_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@3  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2@@3| v@@27)) (and (=> (= (ControlFlow 0 47242) 47312) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 47242) 47284) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@3  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@4|) 0 v@@27 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@4|))) (= |inline$$WritebackToValue$0$vdst'@2@@3| |inline$$WritebackToValue$0$vdst'@1@@3|)) (and (=> (= (ControlFlow 0 47268) 47312) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 47268) 47284) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@4  (=> (= |inline$$WriteRef$0$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4) |inline$$Vector_remove$0$v'@2|)) (and (=> (= (ControlFlow 0 47143) 47268) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 47143) 47242) inline$$WritebackToValue$0$anon3_Else_correct@@3)))))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@14) (= (ControlFlow 0 47149) 47143)) inline$$WriteRef$0$anon0_correct@@4)))
(let ((inline$$Vector_remove$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@14 true) (=> (and (= inline$$Vector_remove$0$e@2 inline$$Vector_remove$0$e@0) (= |inline$$Vector_remove$0$v'@2| |inline$$Vector_remove$0$v'@0|)) (and (=> (= (ControlFlow 0 47076) 47316) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 47076) 47149) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$Vector_remove$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_remove$0$i_ind@1 0) (>= inline$$Vector_remove$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)))) (= (ControlFlow 0 47074) 47076)) inline$$Vector_remove$0$anon3_Then$1_correct)))
(let ((inline$$Vector_remove$0$anon3_Else_correct  (=> (and (not (or (< inline$$Vector_remove$0$i_ind@1 0) (>= inline$$Vector_remove$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4))))) (= inline$$Vector_remove$0$e@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) inline$$Vector_remove$0$i_ind@1))) (=> (and (and (= |inline$$Vector_remove$0$v'@1| ($Vector (let ((l@@65 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) 1)))
($ValueArray (|lambda#1| 0 l@@65 inline$$Vector_remove$0$i_ind@1 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) 1 $Error) l@@65)))) (= $abort_flag@0@@14 false)) (and (= inline$$Vector_remove$0$e@2 inline$$Vector_remove$0$e@1) (= |inline$$Vector_remove$0$v'@2| |inline$$Vector_remove$0$v'@1|))) (and (=> (= (ControlFlow 0 47016) 47316) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 47016) 47149) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$Vector_remove$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@4) (= inline$$Vector_remove$0$i_ind@1 (|i#$Integer| i@@17))) (and (=> (= (ControlFlow 0 46984) 47074) inline$$Vector_remove$0$anon3_Then_correct) (=> (= (ControlFlow 0 46984) 47016) inline$$Vector_remove$0$anon3_Else_correct)))))
(let ((inline$$Vector_remove$0$Entry_correct  (and (=> (= (ControlFlow 0 46974) (- 0 76138)) true) (=> (= (ControlFlow 0 46974) 46984) inline$$Vector_remove$0$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@4  (=> (and (= inline$$ReadRef$0$v@1@@4 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (= (ControlFlow 0 46847) 46974)) inline$$Vector_remove$0$Entry_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$0$dst@1@@4 ($Mutation ($Local 2) $EmptyPath v@@27)) (= (ControlFlow 0 46809) 46847)) inline$$ReadRef$0$anon0_correct@@4)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 46691) 46809)) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 47346) 46809) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 46683) 47346) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 46683) 46691) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 47354) 47346) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 47354) 46691) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon14_Else_correct))))
(let ((inline$$VerifyVector_verify_model_remove_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 46677) 47354) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 46677) 46683) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@14  (=> (and ((_ is $Vector) v@@27) (let ((va@@62 (|v#$Vector| v@@27)))
(let ((l@@66 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@66))
)))))) (=> (and (and (and ((_ is $Integer) i@@17) (>= (|i#$Integer| i@@17) 0)) (<= (|i#$Integer| i@@17) $MAX_U64)) (= (ControlFlow 0 46403) 46677)) inline$$VerifyVector_verify_model_remove_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@13  (=> (forall (($tv0@@30 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@30)) (let ((va@@63 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@30))))
(let ((l@@67 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@67))
))))))) (=> (and (forall (($tv0@@31 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@31)) (let ((va@@64 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@31))))
(let ((l@@68 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@68))
))))))) (= (ControlFlow 0 75683) 46403)) anon0_correct@@14))))
PreconditionGeneratedEntry_correct@@13)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@15 () Bool)
(declare-fun inline$$VerifyVector_verify_model_reverse_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v@@28 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@4| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@5| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@4| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@5 () T@$Mutation)
(declare-fun |inline$$Vector_reverse$0$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 76599) (let ((anon0$2_correct@@15  (and (=> (= (ControlFlow 0 48177) (- 0 77064)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@15)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@15) (and (=> (= (ControlFlow 0 48177) (- 0 77073)) (=> $abort_flag@0@@15 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@15 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 48177) (- 0 77082)) (=> (not $abort_flag@0@@15) (|b#$Boolean| ($Boolean (let (($range_1@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_reverse_$def_verify$0$$ret0@2))))))
(forall (($i_0@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@3)) $i_0@@5) (< $i_0@@5 (|i#$Integer| (|ub#$Range| $range_1@@3)))) (let ((i@@18 ($Integer $i_0@@5)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@28)) (|i#$Integer| i@@18)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_reverse_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_reverse_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| i@@18))))))))))))))))))))))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon8_correct  (=> (= $abort_flag@0@@15 false) (=> (and (= inline$$VerifyVector_verify_model_reverse_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@4|) (= (ControlFlow 0 48129) 48177)) anon0$2_correct@@15))))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 48127) 48129)) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon8_correct)))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 48137) 48129) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon8_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@4  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@4| v@@28)) (and (=> (= (ControlFlow 0 48085) 48137) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 48085) 48127) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@4  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|) 0 v@@28 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|))) (= |inline$$WritebackToValue$0$vdst'@2@@4| |inline$$WritebackToValue$0$vdst'@1@@4|)) (and (=> (= (ControlFlow 0 48111) 48137) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 48111) 48127) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@5  (=> (= |inline$$WriteRef$0$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5) |inline$$Vector_reverse$0$v'@1@@0|)) (and (=> (= (ControlFlow 0 47986) 48111) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 47986) 48085) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon10_Else_correct  (=> (and (not false) (= (ControlFlow 0 47992) 47986)) inline$$WriteRef$0$anon0_correct@@5)))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon10_Then_correct true))
(let ((inline$$Vector_reverse$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@5) (= |inline$$Vector_reverse$0$v'@1@@0| ($Vector (let ((l@@69 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5))))
($ValueArray (|lambda#3| 0 l@@69 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@5)) l@@69 1 $Error) l@@69))))) (and (=> (= (ControlFlow 0 47921) 48141) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 47921) 47992) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@5  (=> (and (= inline$$ReadRef$0$v@1@@5 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (= (ControlFlow 0 47868) 47921)) inline$$Vector_reverse$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$0$dst@1@@5 ($Mutation ($Local 1) $EmptyPath v@@28)) (= (ControlFlow 0 47830) 47868)) inline$$ReadRef$0$anon0_correct@@5)))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 47746) 47830)) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 48169) 47830) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 47740) 48169) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 47740) 47746) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@15  (=> (and (and ((_ is $Vector) v@@28) (let ((va@@65 (|v#$Vector| v@@28)))
(let ((l@@70 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@69))
)))))) (= (ControlFlow 0 47553) 47740)) inline$$VerifyVector_verify_model_reverse_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@14  (=> (forall (($tv0@@32 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@32)) (let ((va@@66 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@32))))
(let ((l@@71 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@70))
))))))) (=> (and (forall (($tv0@@33 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@33)) (let ((va@@67 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@33))))
(let ((l@@72 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@71))
))))))) (= (ControlFlow 0 76599) 47553)) anon0_correct@@15))))
PreconditionGeneratedEntry_correct@@14))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun i@@19 () T@$Value)
(declare-fun v@@29 () T@$Value)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun j@@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_swap_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_swap_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@16 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@5| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@6| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@5| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@6 () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@2| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@0| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$0$v@1@@6 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@1 () Int)
(declare-fun |inline$$Vector_swap$0$v'@1| () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 77170) (let ((anon0$2_correct@@16  (and (=> (= (ControlFlow 0 49386) (- 0 77866)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@19) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29))))))) $abort_flag@1@@7)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@19) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29))))))) $abort_flag@1@@7) (and (=> (= (ControlFlow 0 49386) (- 0 77885)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@1) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29))))))) $abort_flag@1@@7)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@1) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29))))))) $abort_flag@1@@7) (and (=> (= (ControlFlow 0 49386) (- 0 77904)) (=> $abort_flag@1@@7 (or (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@19) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29))))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@1) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29)))))))))) (=> (=> $abort_flag@1@@7 (or (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@19) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29))))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@1) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@29))))))))) (=> (= (ControlFlow 0 49386) (- 0 77941)) (=> (not $abort_flag@1@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_swap_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@29)) (|i#$Integer| i@@19) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@29)) (|i#$Integer| j@@1))) (|l#$ValueArray| (|v#$Vector| v@@29)))))) (|i#$Integer| j@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@29)) (|i#$Integer| i@@19))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@29)) (|i#$Integer| i@@19) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@29)) (|i#$Integer| j@@1))) (|l#$ValueArray| (|v#$Vector| v@@29)))))))))))))))))))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon9_correct  (=> (and (and (= inline$$VerifyVector_verify_model_swap_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_model_swap_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_model_swap_$def_verify$0$$ret0@1)) (and (= $abort_flag@1@@7 true) (= (ControlFlow 0 49346) 49386))) anon0$2_correct@@16)))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 49340) 49346)) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon9_correct)))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 49354) 49346) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon9_correct)))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@16 (and (=> (= (ControlFlow 0 49334) 49354) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 49334) 49340) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon12_correct  (=> (= inline$$VerifyVector_verify_model_swap_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@5|) (=> (and (= $abort_flag@1@@7 $abort_flag@0@@16) (= (ControlFlow 0 49322) 49386)) anon0$2_correct@@16))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 49320) 49322)) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 49330) 49322) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon12_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@5  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@5| v@@29)) (and (=> (= (ControlFlow 0 49278) 49330) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 49278) 49320) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@5  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@6|) 0 v@@29 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@6|))) (= |inline$$WritebackToValue$0$vdst'@2@@5| |inline$$WritebackToValue$0$vdst'@1@@5|)) (and (=> (= (ControlFlow 0 49304) 49330) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 49304) 49320) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@6  (=> (= |inline$$WriteRef$0$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6) |inline$$Vector_swap$0$v'@2|)) (and (=> (= (ControlFlow 0 49179) 49304) inline$$WritebackToValue$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 49179) 49278) inline$$WritebackToValue$0$anon3_Else_correct@@5)))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@0@@16) (= (ControlFlow 0 49185) 49179)) inline$$WriteRef$0$anon0_correct@@6)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@16 true) (= |inline$$Vector_swap$0$v'@2| |inline$$Vector_swap$0$v'@0|)) (and (=> (= (ControlFlow 0 49114) 49334) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 49114) 49185) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6))) (>= inline$$Vector_swap$0$j_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)))) (< inline$$Vector_swap$0$i_ind@1 0)) (< inline$$Vector_swap$0$j_ind@1 0)) (= (ControlFlow 0 49112) 49114)) inline$$Vector_swap$0$anon3_Then$1_correct)))
(let ((inline$$Vector_swap$0$anon3_Else_correct  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6))) (>= inline$$Vector_swap$0$j_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)))) (< inline$$Vector_swap$0$i_ind@1 0)) (< inline$$Vector_swap$0$j_ind@1 0))) (= |inline$$Vector_swap$0$v'@1| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) inline$$Vector_swap$0$i_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) inline$$Vector_swap$0$j_ind@1)) inline$$Vector_swap$0$j_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) inline$$Vector_swap$0$i_ind@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)))))) (and (= $abort_flag@0@@16 false) (= |inline$$Vector_swap$0$v'@2| |inline$$Vector_swap$0$v'@1|))) (and (=> (= (ControlFlow 0 49036) 49334) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 49036) 49185) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$0$v@1@@6) (=> (and (= inline$$Vector_swap$0$i_ind@1 (|i#$Integer| i@@19)) (= inline$$Vector_swap$0$j_ind@1 (|i#$Integer| j@@1))) (and (=> (= (ControlFlow 0 48990) 49112) inline$$Vector_swap$0$anon3_Then_correct) (=> (= (ControlFlow 0 48990) 49036) inline$$Vector_swap$0$anon3_Else_correct))))))
(let ((inline$$Vector_swap$0$Entry_correct  (and (=> (= (ControlFlow 0 48976) (- 0 77591)) true) (=> (= (ControlFlow 0 48976) 48990) inline$$Vector_swap$0$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@6  (=> (and (= inline$$ReadRef$0$v@1@@6 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (= (ControlFlow 0 48814) 48976)) inline$$Vector_swap$0$Entry_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$0$dst@1@@6 ($Mutation ($Local 3) $EmptyPath v@@29)) (= (ControlFlow 0 48776) 48814)) inline$$ReadRef$0$anon0_correct@@6)))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 48624) 48776)) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 49362) 48776) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon14_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 48616) 49362) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 48616) 48624) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon14_Then_correct  (and (=> (= (ControlFlow 0 49370) 49362) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 49370) 48624) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon15_Else_correct))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 48608) 49370) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 48608) 48616) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 49378) 49370) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 49378) 48616) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon14_Else_correct))))
(let ((inline$$VerifyVector_verify_model_swap_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 48602) 49378) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 48602) 48608) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@16  (=> (and ((_ is $Vector) v@@29) (let ((va@@68 (|v#$Vector| v@@29)))
(let ((l@@73 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@72))
)))))) (=> (and (and ((_ is $Integer) i@@19) (>= (|i#$Integer| i@@19) 0)) (<= (|i#$Integer| i@@19) $MAX_U64)) (=> (and (and (and ((_ is $Integer) j@@1) (>= (|i#$Integer| j@@1) 0)) (<= (|i#$Integer| j@@1) $MAX_U64)) (= (ControlFlow 0 48330) 48602)) inline$$VerifyVector_verify_model_swap_$def_verify$0$anon0_correct)))))
(let ((PreconditionGeneratedEntry_correct@@15  (=> (forall (($tv0@@34 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@34)) (let ((va@@69 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@34))))
(let ((l@@74 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@73))
))))))) (=> (and (forall (($tv0@@35 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@35)) (let ((va@@70 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@35))))
(let ((l@@75 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@74))
))))))) (= (ControlFlow 0 77170) 48330)) anon0_correct@@16))))
PreconditionGeneratedEntry_correct@@15)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun i@@20 () T@$Value)
(declare-fun v@@30 () T@$Value)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@17 () Bool)
(declare-fun inline$$Vector_swap_remove$0$e@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@6| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@7| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@6| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@7 () T@$Mutation)
(declare-fun |inline$$Vector_swap_remove$0$v'@2| () T@$Value)
(declare-fun inline$$Vector_swap_remove$0$e@0 () T@$Value)
(declare-fun |inline$$Vector_swap_remove$0$v'@0| () T@$Value)
(declare-fun inline$$Vector_swap_remove$0$i_ind@1 () Int)
(declare-fun inline$$Vector_swap_remove$0$len@1 () Int)
(declare-fun inline$$Vector_swap_remove$0$e@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@7 () T@$Value)
(declare-fun |inline$$Vector_swap_remove$0$v'@1| () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 77985) (let ((anon0$2_correct@@17  (and (=> (= (ControlFlow 0 50565) (- 0 78727)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@20) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30))))))) $abort_flag@1@@8)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@20) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30))))))) $abort_flag@1@@8) (and (=> (= (ControlFlow 0 50565) (- 0 78746)) (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@20) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30))))))))) (=> (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@20) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))))))) (and (=> (= (ControlFlow 0 50565) (- 0 78765)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 50565) (- 0 78795)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1)))))))) (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@30)) (|i#$Integer| i@@20) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@30)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|l#$ValueArray| (|v#$Vector| v@@30)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1)))))))) (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@30)) (|i#$Integer| i@@20) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@30)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|l#$ValueArray| (|v#$Vector| v@@30)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@30)))) (|i#$Integer| ($Integer 1))))))))))))))) (=> (= (ControlFlow 0 50565) (- 0 78857)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@30)) (|i#$Integer| i@@20)) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret0@2)))))))))))))))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon7_correct  (=> (and (= inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret0@1) (= inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@1)) (and (= $abort_flag@1@@8 true) (= (ControlFlow 0 50531) 50565))) anon0$2_correct@@17))))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 50523) 50531)) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 50539) 50531) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon7_correct)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@17 (and (=> (= (ControlFlow 0 50517) 50539) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 50517) 50523) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon12_correct  (=> (and (and (= inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret0@2 inline$$Vector_swap_remove$0$e@2) (= inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@6|)) (and (= $abort_flag@1@@8 $abort_flag@0@@17) (= (ControlFlow 0 50497) 50565))) anon0$2_correct@@17)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 50495) 50497)) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 50505) 50497) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 50485) 50505) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 50485) 50495) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 50513) 50505) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 50513) 50495) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon18_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@6  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2@@6| v@@30)) (and (=> (= (ControlFlow 0 50443) 50513) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 50443) 50485) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@6  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@6| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@7|) 0 v@@30 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|))) (= |inline$$WritebackToValue$0$vdst'@2@@6| |inline$$WritebackToValue$0$vdst'@1@@6|)) (and (=> (= (ControlFlow 0 50469) 50513) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 50469) 50485) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@7  (=> (= |inline$$WriteRef$0$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7) |inline$$Vector_swap_remove$0$v'@2|)) (and (=> (= (ControlFlow 0 50344) 50469) inline$$WritebackToValue$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 50344) 50443) inline$$WritebackToValue$0$anon3_Else_correct@@6)))))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@17) (= (ControlFlow 0 50350) 50344)) inline$$WriteRef$0$anon0_correct@@7)))
(let ((inline$$Vector_swap_remove$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@17 true) (=> (and (= inline$$Vector_swap_remove$0$e@2 inline$$Vector_swap_remove$0$e@0) (= |inline$$Vector_swap_remove$0$v'@2| |inline$$Vector_swap_remove$0$v'@0|)) (and (=> (= (ControlFlow 0 50277) 50517) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 50277) 50350) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$Vector_swap_remove$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_swap_remove$0$i_ind@1 0) (>= inline$$Vector_swap_remove$0$i_ind@1 inline$$Vector_swap_remove$0$len@1)) (= (ControlFlow 0 50275) 50277)) inline$$Vector_swap_remove$0$anon3_Then$1_correct)))
(let ((inline$$Vector_swap_remove$0$anon3_Else_correct  (=> (and (not (or (< inline$$Vector_swap_remove$0$i_ind@1 0) (>= inline$$Vector_swap_remove$0$i_ind@1 inline$$Vector_swap_remove$0$len@1))) (= inline$$Vector_swap_remove$0$e@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) inline$$Vector_swap_remove$0$i_ind@1))) (=> (and (and (= |inline$$Vector_swap_remove$0$v'@1| ($Vector (let ((l@@76 (- (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) inline$$Vector_swap_remove$0$i_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) (- inline$$Vector_swap_remove$0$len@1 1))) (- inline$$Vector_swap_remove$0$len@1 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) inline$$Vector_swap_remove$0$i_ind@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)))))) 1)))
($ValueArray (|lambda#0| 0 l@@76 (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) inline$$Vector_swap_remove$0$i_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) (- inline$$Vector_swap_remove$0$len@1 1))) (- inline$$Vector_swap_remove$0$len@1 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)) inline$$Vector_swap_remove$0$i_ind@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)))))) $Error) l@@76)))) (= $abort_flag@0@@17 false)) (and (= inline$$Vector_swap_remove$0$e@2 inline$$Vector_swap_remove$0$e@1) (= |inline$$Vector_swap_remove$0$v'@2| |inline$$Vector_swap_remove$0$v'@1|))) (and (=> (= (ControlFlow 0 50219) 50517) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 50219) 50350) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$Vector_swap_remove$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$0$v@1@@7) (=> (and (= inline$$Vector_swap_remove$0$i_ind@1 (|i#$Integer| i@@20)) (= inline$$Vector_swap_remove$0$len@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@7)))) (and (=> (= (ControlFlow 0 50181) 50275) inline$$Vector_swap_remove$0$anon3_Then_correct) (=> (= (ControlFlow 0 50181) 50219) inline$$Vector_swap_remove$0$anon3_Else_correct))))))
(let ((inline$$Vector_swap_remove$0$Entry_correct  (and (=> (= (ControlFlow 0 50167) (- 0 78424)) true) (=> (= (ControlFlow 0 50167) 50181) inline$$Vector_swap_remove$0$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@7  (=> (and (= inline$$ReadRef$0$v@1@@7 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7)) (= (ControlFlow 0 50029) 50167)) inline$$Vector_swap_remove$0$Entry_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$0$dst@1@@7 ($Mutation ($Local 2) $EmptyPath v@@30)) (= (ControlFlow 0 49991) 50029)) inline$$ReadRef$0$anon0_correct@@7)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 49873) 49991)) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 50547) 49991) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 49865) 50547) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 49865) 49873) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 50555) 50547) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 50555) 49873) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon14_Else_correct))))
(let ((inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 49859) 50555) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 49859) 49865) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@17  (=> (and ((_ is $Vector) v@@30) (let ((va@@71 (|v#$Vector| v@@30)))
(let ((l@@77 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@75))
)))))) (=> (and (and (and ((_ is $Integer) i@@20) (>= (|i#$Integer| i@@20) 0)) (<= (|i#$Integer| i@@20) $MAX_U64)) (= (ControlFlow 0 49585) 49859)) inline$$VerifyVector_verify_model_swap_remove_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@16  (=> (forall (($tv0@@36 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@36)) (let ((va@@72 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@36))))
(let ((l@@78 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@76))
))))))) (=> (and (forall (($tv0@@37 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@37)) (let ((va@@73 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@37))))
(let ((l@@79 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@77))
))))))) (= (ControlFlow 0 77985) 49585)) anon0_correct@@17))))
PreconditionGeneratedEntry_correct@@16)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun j@@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@3@@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@3@@0| () T@$Mutation)
(declare-fun $tv0@@38 () T@$TypeValue)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@2@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@2@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@2@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@3| () T@$Value)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun v@@31 () T@$Value)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $ret1@0@@0 () T@$Value)
(declare-fun $ret0@0@@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@5 () Bool)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t14@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun $abort_flag@0@@18 () Bool)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun |inline$$Vector_swap$0$v'@1@@0| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@2 () Int)
(declare-fun inline$$ReadRef$2$v@2@@0 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@2 () Int)
(declare-fun |inline$$Vector_swap$0$v'@2@@0| () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$i@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t24@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$Lt$0$dst@2@@1 () T@$Value)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun inline$$Vector_pop_back$0$e@2@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@8| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@7| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@2@@1| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$e@0@@0 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@0@@0| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$len@1@@0 () Int)
(declare-fun inline$$Vector_pop_back$0$e@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@1@@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@7| () T@$Value)
(declare-fun |inline$$VerifyVector_verify_remove_$def_verify$0$tmp#$3@1| () T@$Value)
(declare-fun |inline$$VerifyVector_verify_remove_$def_verify$0$tmp#$4@1| () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t21@1 () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t23@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t26@1 () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t27@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t28@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t34@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@8 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@3 () T@$Value)
(declare-fun inline$$VerifyVector_verify_remove_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@8 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 79006) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Else$2_correct  (and (=> (= (ControlFlow 0 54915) (- 0 81663)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| j@@2) (|i#$Integer| inline$$AddU64$0$dst@3@@1)))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@3@@1) (|i#$Integer| inline$$Sub$0$dst@2)))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| j@@2) (|i#$Integer| inline$$AddU64$0$dst@3@@1)))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@3@@1) (|i#$Integer| inline$$Sub$0$dst@2))))))) (and (=> (= (ControlFlow 0 54915) (- 0 81693)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|)))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))))))) (and (=> (= (ControlFlow 0 54915) (- 0 81717)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))))))))) (and (=> (= (ControlFlow 0 54915) (- 0 81749)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_1 ($Range j@@2 inline$$AddU64$0$dst@3@@1)))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_0) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k) (|i#$Integer| ($Integer 1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_1 ($Range j@@2 inline$$AddU64$0$dst@3@@1)))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@0) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k) (|i#$Integer| ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 54915) (- 0 81810)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_3 ($Range ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@3@@1) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|)))))))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_2) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@0 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@0)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_3 ($Range ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@3@@1) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|)))))))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@0) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@0 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@0))))))))))) (=> (= (ControlFlow 0 54915) (- 0 81875)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@0|))) (|i#$Integer| inline$$AddU64$0$dst@3@@1)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| j@@2))))))))))))))))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) (|l#$Mutation| |inline$$WriteRef$1$to'@2@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@2@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@2@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@2@@0 inline$$WritebackToReference$0$srcPath@2@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@3@@0| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) (= (ControlFlow 0 54851) 54915)) inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Else$2_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) (|l#$Mutation| |inline$$WriteRef$1$to'@2@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@2@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@2@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@2@@0 inline$$WritebackToReference$0$srcPath@2@@0)) (= |inline$$WritebackToReference$0$dst'@2@@0| ($Mutation (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) inline$$WritebackToReference$0$dstPath@2@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@2@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@2@@0) (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) (|v#$Mutation| |inline$$WriteRef$1$to'@2@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@3@@0| |inline$$WritebackToReference$0$dst'@2@@0|) (= (ControlFlow 0 54907) 54915))) inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Else$2_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@2@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@2@@0|)) (= inline$$WritebackToReference$0$dstPath@2@@0 (|p#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1))) (and (=> (= (ControlFlow 0 54815) 54907) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 54815) 54851) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (and (= |inline$$WriteRef$1$to'@2@@0| ($Mutation (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) (|p#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) |inline$$Vector_swap$0$v'@3|)) (= (ControlFlow 0 54672) 54815)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Else_correct  (=> (and (not $abort_flag@4@@2) (= (ControlFlow 0 54678) 54672)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((GeneratedUnifiedExit_correct@@2  (and (=> (= (ControlFlow 0 78995) (- 0 82062)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@2) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@2) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 78995) (- 0 82081)) (=> $abort_flag@6 (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@2) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))))) (=> (=> $abort_flag@6 (|b#$Boolean| ($Boolean (>= (|i#$Integer| j@@2) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))))) (and (=> (= (ControlFlow 0 78995) (- 0 82100)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 78995) (- 0 82130)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| $ret1@0@@0)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| v@@31)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))))))))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| $ret1@0@@0)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| v@@31)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))))))) (and (=> (= (ControlFlow 0 78995) (- 0 82164)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0))))))) (|v#$ValueArray| (|v#$Vector| $ret1@0@@0)) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))) (|v#$ValueArray| (|v#$Vector| v@@31)) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))))))))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0))))))) (|v#$ValueArray| (|v#$Vector| $ret1@0@@0)) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))) (|i#$Integer| (|lb#$Range| ($Range j@@2 ($Integer (|l#$ValueArray| (|v#$Vector| $ret1@0@@0)))))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))) (|v#$ValueArray| (|v#$Vector| v@@31)) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| v@@31)))))))))))))) (=> (= (ControlFlow 0 78995) (- 0 82209)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@31)) (|i#$Integer| j@@2)) $ret0@0@@2)))))))))))))))))
(let ((anon0$2_correct@@18  (=> (and (and (= $ret1@0@@0 inline$$VerifyVector_verify_remove_$def_verify$0$$ret1@2) (= $ret0@0@@2 inline$$VerifyVector_verify_remove_$def_verify$0$$ret0@2)) (and (= $abort_flag@6 $abort_flag@5) (= (ControlFlow 0 55127) 78995))) GeneratedUnifiedExit_correct@@2)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct  (=> (and (= inline$$VerifyVector_verify_remove_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_remove_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@5 true) (= inline$$VerifyVector_verify_remove_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_remove_$def_verify$0$$ret0@1)) (and (= inline$$VerifyVector_verify_remove_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_remove_$def_verify$0$$ret1@1) (= (ControlFlow 0 53770) 55127))) anon0$2_correct@@18))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 55063) 53770)) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 55073) 53770) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Then$1_correct  (=> (and (= inline$$VerifyVector_verify_remove_$def_verify$0$$t14@1 ($Integer 10)) (= $abort_code@2 (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t14@1))) (and (=> (= (ControlFlow 0 55057) 55073) inline$$VerifyVector_verify_remove_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 55057) 55063) inline$$VerifyVector_verify_remove_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1) (= (ControlFlow 0 55047) 55057)) inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Then$1_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 54999) 53770)) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 55009) 53770) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon52_Then_correct  (=> $abort_flag@0@@18 (and (=> (= (ControlFlow 0 54993) 55009) inline$$VerifyVector_verify_remove_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 54993) 54999) inline$$VerifyVector_verify_remove_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 54953) 53770)) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 54963) 53770) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon58_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 54947) 54963) inline$$VerifyVector_verify_remove_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 54947) 54953) inline$$VerifyVector_verify_remove_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 54925) 53770)) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 54935) 53770) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 54919) 54935) inline$$VerifyVector_verify_remove_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 54919) 54925) inline$$VerifyVector_verify_remove_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct@@0  (=> (and (= |inline$$Vector_swap$0$v'@3| |inline$$Vector_swap$0$v'@1@@0|) (= $abort_flag@4@@2 true)) (and (=> (= (ControlFlow 0 54607) 54919) inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 54607) 54678) inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct@@0  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0))) (>= inline$$Vector_swap$0$j_ind@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0)))) (< inline$$Vector_swap$0$i_ind@2 0)) (< inline$$Vector_swap$0$j_ind@2 0)) (= (ControlFlow 0 54605) 54607)) inline$$Vector_swap$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_swap$0$anon3_Else_correct@@0  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0))) (>= inline$$Vector_swap$0$j_ind@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0)))) (< inline$$Vector_swap$0$i_ind@2 0)) (< inline$$Vector_swap$0$j_ind@2 0))) (= |inline$$Vector_swap$0$v'@2@@0| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0)) inline$$Vector_swap$0$i_ind@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0)) inline$$Vector_swap$0$j_ind@2)) inline$$Vector_swap$0$j_ind@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0)) inline$$Vector_swap$0$i_ind@2)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2@@0)))))) (and (= |inline$$Vector_swap$0$v'@3| |inline$$Vector_swap$0$v'@2@@0|) (= $abort_flag@4@@2 $abort_flag@3@@2))) (and (=> (= (ControlFlow 0 54529) 54919) inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 54529) 54678) inline$$VerifyVector_verify_remove_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct@@0  (=> ((_ is $Vector) inline$$ReadRef$2$v@2@@0) (=> (and (= inline$$Vector_swap$0$i_ind@2 (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1)) (= inline$$Vector_swap$0$j_ind@2 (|i#$Integer| inline$$AddU64$0$dst@3@@1))) (and (=> (= (ControlFlow 0 54483) 54605) inline$$Vector_swap$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 54483) 54529) inline$$Vector_swap$0$anon3_Else_correct@@0))))))
(let ((inline$$Vector_swap$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 54469) (- 0 81380)) true) (=> (= (ControlFlow 0 54469) 54483) inline$$Vector_swap$0$anon0_correct@@0))))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@2@@0 (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1)) (= (ControlFlow 0 54307) 54469)) inline$$Vector_swap$0$Entry_correct@@0)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 54173) 54307)) inline$$ReadRef$2$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 54943) 54307) inline$$ReadRef$2$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon58_Else_correct  (=> (not $abort_flag@3@@2) (and (=> (= (ControlFlow 0 54167) 54943) inline$$VerifyVector_verify_remove_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 54167) 54173) inline$$VerifyVector_verify_remove_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@3@@2 true) (= inline$$AddU64$0$dst@3@@1 inline$$AddU64$0$dst@1@@1)) (and (=> (= (ControlFlow 0 54153) 54947) inline$$VerifyVector_verify_remove_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 54153) 54167) inline$$VerifyVector_verify_remove_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t24@2)) $MAX_U64) (= (ControlFlow 0 54151) 54153)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t24@2))) (= inline$$AddU64$0$dst@2@@1 ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t24@2))))) (and (= $abort_flag@3@@2 $abort_flag@1@@9) (= inline$$AddU64$0$dst@3@@1 inline$$AddU64$0$dst@2@@1))) (and (=> (= (ControlFlow 0 54095) 54947) inline$$VerifyVector_verify_remove_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 54095) 54167) inline$$VerifyVector_verify_remove_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 54065) (- 0 81235)) true) (and (=> (= (ControlFlow 0 54065) 54151) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 54065) 54095) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon26$1_correct  (=> (and (= inline$$VerifyVector_verify_remove_$def_verify$0$$t24@2 ($Integer 1)) (= (ControlFlow 0 54159) 54065)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 53934) 54159)) inline$$VerifyVector_verify_remove_$def_verify$0$anon26$1_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 54971) 54159) inline$$VerifyVector_verify_remove_$def_verify$0$anon26$1_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon56_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 53858) 54971) inline$$VerifyVector_verify_remove_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 53858) 53934) inline$$VerifyVector_verify_remove_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon56_Then_correct  (=> (= inline$$VerifyVector_verify_remove_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1)) (and (=> (= (ControlFlow 0 54981) 54971) inline$$VerifyVector_verify_remove_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 54981) 53934) inline$$VerifyVector_verify_remove_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon55_Then_correct  (=> (|b#$Boolean| inline$$Lt$0$dst@2@@1) (and (=> (= (ControlFlow 0 53816) 54981) inline$$VerifyVector_verify_remove_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 53816) 53858) inline$$VerifyVector_verify_remove_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 53760) 53770)) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 53778) 53770) inline$$VerifyVector_verify_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon63_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 53754) 53778) inline$$VerifyVector_verify_remove_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 53754) 53760) inline$$VerifyVector_verify_remove_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon44_correct  (=> (and (and (= $abort_flag@5 $abort_flag@2@@2) (= inline$$VerifyVector_verify_remove_$def_verify$0$$ret0@2 inline$$Vector_pop_back$0$e@2@@1)) (and (= inline$$VerifyVector_verify_remove_$def_verify$0$$ret1@2 |inline$$WritebackToValue$1$vdst'@2@@0|) (= (ControlFlow 0 53734) 55127))) anon0$2_correct@@18)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 53732) 53734)) inline$$VerifyVector_verify_remove_$def_verify$0$anon44_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 53742) 53734) inline$$VerifyVector_verify_remove_$def_verify$0$anon44_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon65_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 53722) 53742) inline$$VerifyVector_verify_remove_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 53722) 53732) inline$$VerifyVector_verify_remove_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon65_Then_correct  (and (=> (= (ControlFlow 0 53750) 53742) inline$$VerifyVector_verify_remove_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 53750) 53732) inline$$VerifyVector_verify_remove_$def_verify$0$anon66_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) ($Local 31))) (= |inline$$WritebackToValue$1$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@2@@7|)) (and (=> (= (ControlFlow 0 53680) 53750) inline$$VerifyVector_verify_remove_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 53680) 53722) inline$$VerifyVector_verify_remove_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|) ($Local 31)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@8|) 0 |inline$$WritebackToValue$0$vdst'@2@@7| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@8|))) (= |inline$$WritebackToValue$1$vdst'@2@@0| |inline$$WritebackToValue$1$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 53706) 53750) inline$$VerifyVector_verify_remove_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 53706) 53722) inline$$VerifyVector_verify_remove_$def_verify$0$anon65_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@8  (=> (= |inline$$WriteRef$0$to'@1@@8| ($Mutation (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) (|p#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) |inline$$Vector_pop_back$0$v'@2@@1|)) (and (=> (= (ControlFlow 0 53581) 53706) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 53581) 53680) inline$$WritebackToValue$1$anon3_Else_correct@@0)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon63_Else_correct  (=> (and (not $abort_flag@2@@2) (= (ControlFlow 0 53587) 53581)) inline$$WriteRef$0$anon0_correct@@8)))
(let ((inline$$Vector_pop_back$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@2@@2 true) (=> (and (= inline$$Vector_pop_back$0$e@2@@1 inline$$Vector_pop_back$0$e@0@@0) (= |inline$$Vector_pop_back$0$v'@2@@1| |inline$$Vector_pop_back$0$v'@0@@0|)) (and (=> (= (ControlFlow 0 53514) 53754) inline$$VerifyVector_verify_remove_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 53514) 53587) inline$$VerifyVector_verify_remove_$def_verify$0$anon63_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon3_Then_correct@@1  (=> (and (= inline$$Vector_pop_back$0$len@1@@0 0) (= (ControlFlow 0 53512) 53514)) inline$$Vector_pop_back$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_pop_back$0$anon3_Else_correct@@1  (=> (and (not (= inline$$Vector_pop_back$0$len@1@@0 0)) (= inline$$Vector_pop_back$0$e@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) (- inline$$Vector_pop_back$0$len@1@@0 1)))) (=> (and (and (= |inline$$Vector_pop_back$0$v'@1@@1| ($Vector (let ((l@@80 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) 1)))
($ValueArray (|lambda#0| 0 l@@80 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Error) l@@80)))) (= $abort_flag@2@@2 $abort_flag@1@@9)) (and (= inline$$Vector_pop_back$0$e@2@@1 inline$$Vector_pop_back$0$e@1@@1) (= |inline$$Vector_pop_back$0$v'@2@@1| |inline$$Vector_pop_back$0$v'@1@@1|))) (and (=> (= (ControlFlow 0 53464) 53754) inline$$VerifyVector_verify_remove_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 53464) 53587) inline$$VerifyVector_verify_remove_$def_verify$0$anon63_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1) (= inline$$Vector_pop_back$0$len@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)))) (and (=> (= (ControlFlow 0 53442) 53512) inline$$Vector_pop_back$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 53442) 53464) inline$$Vector_pop_back$0$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1)) (= (ControlFlow 0 53331) 53442)) inline$$Vector_pop_back$0$anon0_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@7  (=> (not (= (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) ($Local 31))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@7| v@@31) (= (ControlFlow 0 53267) 53331)) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@7  (=> (and (and (= (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) ($Local 31)) (= |inline$$WritebackToValue$0$vdst'@1@@7| ($UpdateValue_stratified (|p#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) 0 v@@31 (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@7| |inline$$WritebackToValue$0$vdst'@1@@7|) (= (ControlFlow 0 53293) 53331))) inline$$ReadRef$1$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon55_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@2@@1)) (and (=> (= (ControlFlow 0 53174) 53293) inline$$WritebackToValue$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 53174) 53267) inline$$WritebackToValue$0$anon3_Else_correct@@7)))))
(let ((inline$$Lt$0$anon0_correct@@1  (=> (= inline$$Lt$0$dst@2@@1 ($Boolean (< (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) (|i#$Integer| inline$$Sub$0$dst@2)))) (and (=> (= (ControlFlow 0 53126) 53816) inline$$VerifyVector_verify_remove_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 53126) 53174) inline$$VerifyVector_verify_remove_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 53112) (- 0 80810)) true) (=> (= (ControlFlow 0 53112) 53126) inline$$Lt$0$anon0_correct@@1))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$L6_correct  (=> (not $abort_flag@1@@9) (=> (and (= (|l#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) ($Local 31)) (= (|p#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1) $EmptyPath)) (=> (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$i@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) $MAX_U64)) (=> (and (and (and (and ((_ is $Integer) |inline$$VerifyVector_verify_remove_$def_verify$0$tmp#$3@1|) (>= (|i#$Integer| |inline$$VerifyVector_verify_remove_$def_verify$0$tmp#$3@1|) 0)) (<= (|i#$Integer| |inline$$VerifyVector_verify_remove_$def_verify$0$tmp#$3@1|) $MAX_U64)) (and ((_ is $Vector) (|v#$Mutation| |inline$$VerifyVector_verify_remove_$def_verify$0$tmp#$4@1|)) (let ((va@@74 (|v#$Vector| (|v#$Mutation| |inline$$VerifyVector_verify_remove_$def_verify$0$tmp#$4@1|))))
(let ((l@@81 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@78))
))))))) (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$$t18@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t18@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t18@1) $MAX_U64))) (=> (and (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$$t19@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t19@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t19@1) $MAX_U64)) ((_ is $Boolean) inline$$VerifyVector_verify_remove_$def_verify$0$$t20@1)) (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t21@1)) (let ((va@@75 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t21@1))))
(let ((l@@82 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@79))
))))))) (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$$t22@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t22@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t22@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$$t23@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t23@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t23@1) $MAX_U64)))) (=> (and (and (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$$t24@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t24@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t24@1) $MAX_U64)) (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t26@1)) (let ((va@@76 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t26@1))))
(let ((l@@83 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@80))
))))))) (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$$t27@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t27@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t27@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_remove_$def_verify$0$$t28@1) (>= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t28@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t28@1) $MAX_U64)) (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1)) (let ((va@@77 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1))))
(let ((l@@84 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@81))
)))))))) (and (and (and (and ((_ is $Vector) inline$$VerifyVector_verify_remove_$def_verify$0$$t34@1) (let ((va@@78 (|v#$Vector| inline$$VerifyVector_verify_remove_$def_verify$0$$t34@1)))
(let ((l@@85 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@82))
)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| j@@2) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1)))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) (|i#$Integer| inline$$Sub$0$dst@2)))))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))))))))))) (and (and (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@0 ($Range j@@2 inline$$VerifyVector_verify_remove_$def_verify$0$i@1)))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@0)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@1) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@0)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@1 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@1)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@1) (|i#$Integer| ($Integer 1))))))))))))))) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@0 ($Range ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1)))))))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@0)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@1) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@0)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@2 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@2)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@2)))))))))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_remove_$def_verify$0$$t32@1))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$i@1)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| j@@2))))) (= (ControlFlow 0 53034) 53112))))) inline$$Lt$0$Entry_correct@@1))))))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon20_correct  (and (=> (= (ControlFlow 0 52654) (- 0 80043)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| j@@2) (|i#$Integer| j@@2)))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| j@@2) (|i#$Integer| inline$$Sub$0$dst@2)))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| j@@2) (|i#$Integer| j@@2)))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| j@@2) (|i#$Integer| inline$$Sub$0$dst@2))))))) (and (=> (= (ControlFlow 0 52654) (- 0 80073)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))))))) (and (=> (= (ControlFlow 0 52654) (- 0 80097)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) j@@2))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) j@@2)))))))))) (and (=> (= (ControlFlow 0 52654) (- 0 80129)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@1 ($Range j@@2 j@@2)))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@2) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@3 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@3)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@3) (|i#$Integer| ($Integer 1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@1 ($Range j@@2 j@@2)))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@3) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@3 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@3)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@3) (|i#$Integer| ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 52654) (- 0 80190)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@1 ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)))))))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@1)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@2) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@1)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@4 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@4)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@4)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@1 ($Range ($Integer (+ (|i#$Integer| j@@2) (|i#$Integer| ($Integer 1)))) ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)))))))
(forall ((inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@1)) inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@3) (< inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_remove_$def_verify$0$$range_3@@1)))) (let ((inline$$VerifyVector_verify_remove_$def_verify$0$k@@4 ($Integer inline$$VerifyVector_verify_remove_$def_verify$0$$i_2@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@4)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$k@@4))))))))))) (and (=> (= (ControlFlow 0 52654) (- 0 80255)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| j@@2)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| j@@2)))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (|i#$Integer| j@@2)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38))) (|i#$Integer| j@@2))))) (=> (= (ControlFlow 0 52654) 53034) inline$$VerifyVector_verify_remove_$def_verify$0$L6_correct)))))))))))))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 52652) 52654)) inline$$VerifyVector_verify_remove_$def_verify$0$anon20_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 54989) 52654) inline$$VerifyVector_verify_remove_$def_verify$0$anon20_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@0@@18) (and (=> (= (ControlFlow 0 52646) 54989) inline$$VerifyVector_verify_remove_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 52646) 52652) inline$$VerifyVector_verify_remove_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@18 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 52632) 54993) inline$$VerifyVector_verify_remove_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 52632) 52646) inline$$VerifyVector_verify_remove_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$Vector_length$0$l@1@@3) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t16@1)) (= (ControlFlow 0 52630) 52632)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t16@1) (|i#$Integer| inline$$Vector_length$0$l@1@@3)) (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@3) (|i#$Integer| inline$$VerifyVector_verify_remove_$def_verify$0$$t16@1))))) (and (= $abort_flag@0@@18 false) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 52578) 54993) inline$$VerifyVector_verify_remove_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 52578) 52646) inline$$VerifyVector_verify_remove_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 52552) (- 0 79957)) true) (and (=> (= (ControlFlow 0 52552) 52630) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 52552) 52578) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Else$1_correct  (=> (and (= inline$$VerifyVector_verify_remove_$def_verify$0$$t16@1 ($Integer 1)) (= (ControlFlow 0 52638) 52552)) inline$$Sub$0$Entry_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Else_correct  (=> (not (|b#$Boolean| inline$$Ge$0$dst@1)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@38) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)))) (= (ControlFlow 0 52463) 52638)) inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Else$1_correct))))
(let ((inline$$Ge$0$anon0_correct  (=> (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| j@@2) (|i#$Integer| inline$$Vector_length$0$l@1@@3)))) (and (=> (= (ControlFlow 0 52399) 55047) inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 52399) 52463) inline$$VerifyVector_verify_remove_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 52385) (- 0 79889)) true) (=> (= (ControlFlow 0 52385) 52399) inline$$Ge$0$anon0_correct))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 52273) 52385)) inline$$Ge$0$Entry_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 55081) 52385) inline$$Ge$0$Entry_correct)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon47_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 52231) 55081) inline$$VerifyVector_verify_remove_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 52231) 52273) inline$$VerifyVector_verify_remove_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon47_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@3  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@8) (= inline$$Vector_length$0$l@1@@3 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8))))) (and (=> (= (ControlFlow 0 52185) 55085) inline$$VerifyVector_verify_remove_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 52185) 52231) inline$$VerifyVector_verify_remove_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@8  (=> (and (= inline$$ReadRef$0$v@1@@8 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8)) (= (ControlFlow 0 52128) 52185)) inline$$Vector_length$0$anon0_correct@@3)))
(let ((inline$$BorrowLoc$0$anon0_correct@@8  (=> (and (= inline$$BorrowLoc$0$dst@1@@8 ($Mutation ($Local 31) $EmptyPath v@@31)) (= (ControlFlow 0 52056) 52128)) inline$$ReadRef$0$anon0_correct@@8)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 51938) 52056)) inline$$BorrowLoc$0$anon0_correct@@8)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 55109) 52056) inline$$BorrowLoc$0$anon0_correct@@8)))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 51930) 55109) inline$$VerifyVector_verify_remove_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 51930) 51938) inline$$VerifyVector_verify_remove_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 55117) 55109) inline$$VerifyVector_verify_remove_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 55117) 51938) inline$$VerifyVector_verify_remove_$def_verify$0$anon46_Else_correct))))
(let ((inline$$VerifyVector_verify_remove_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 51924) 55117) inline$$VerifyVector_verify_remove_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 51924) 51930) inline$$VerifyVector_verify_remove_$def_verify$0$anon45_Else_correct)))))
(let ((anon0_correct@@18  (=> (and ((_ is $Vector) v@@31) (let ((va@@79 (|v#$Vector| v@@31)))
(let ((l@@86 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@83))
)))))) (=> (and (and (and ((_ is $Integer) j@@2) (>= (|i#$Integer| j@@2) 0)) (<= (|i#$Integer| j@@2) $MAX_U64)) (= (ControlFlow 0 50757) 51924)) inline$$VerifyVector_verify_remove_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@17  (=> (forall (($tv0@@39 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@39)) (let ((va@@80 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@39))))
(let ((l@@87 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@84))
))))))) (=> (and (forall (($tv0@@40 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@40)) (let ((va@@81 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@40))))
(let ((l@@88 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@85))
))))))) (= (ControlFlow 0 79006) 50757)) anon0_correct@@18))))
PreconditionGeneratedEntry_correct@@17)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$AddU64$0$dst@3@@2 () T@$Value)
(declare-fun inline$$Sub$1$dst@3 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@3@@1| () T@$Mutation)
(declare-fun $tv0@@41 () T@$TypeValue)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $ret0@0@@3 () T@$Value)
(declare-fun v@@32 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@19 () Bool)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun inline$$Sub$1$dst@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@2 () T@$Value)
(declare-fun inline$$Sub$1$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@2@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@2@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@3@@0| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@1@@1| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@2@@0 () Int)
(declare-fun inline$$ReadRef$1$v@2@@0 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@2@@0 () Int)
(declare-fun |inline$$Vector_swap$0$v'@2@@1| () T@$Value)
(declare-fun $abort_flag@1@@10 () Bool)
(declare-fun inline$$Lt$0$dst@2@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@8| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@8| () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t18@1 () T@$Mutation)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t30@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@9 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@0@@0 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(declare-fun inline$$VerifyVector_verify_reverse_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@9 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 82354) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon36_correct  (and (=> (= (ControlFlow 0 59306) (- 0 84649)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@3@@2) (|i#$Integer| inline$$Sub$1$dst@3))) ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1)))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@3@@2) (|i#$Integer| inline$$Sub$1$dst@3))) ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))))) (and (=> (= (ControlFlow 0 59306) (- 0 84678)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1 ($Range ($Integer 0) inline$$AddU64$0$dst@3@@2)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@1|))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1 ($Range ($Integer 0) inline$$AddU64$0$dst@3@@2)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@0) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@1|))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i)))))))))))))) (and (=> (= (ControlFlow 0 59306) (- 0 84751)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3 ($Range ($Integer 0) inline$$AddU64$0$dst@3@@2)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@0 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@1|))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@0))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@0)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3 ($Range ($Integer 0) inline$$AddU64$0$dst@3@@2)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@0) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@0 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@1|))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@0))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@0))))))))))) (and (=> (= (ControlFlow 0 59306) (- 0 84824)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5 ($Range inline$$AddU64$0$dst@3@@2 ($Integer (+ (|i#$Integer| inline$$Sub$1$dst@3) (|i#$Integer| ($Integer 1)))))))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$j ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@1|))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5 ($Range inline$$AddU64$0$dst@3@@2 ($Integer (+ (|i#$Integer| inline$$Sub$1$dst@3) (|i#$Integer| ($Integer 1)))))))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@0) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@0 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$j ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@1|))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j))))))))))) (=> (= (ControlFlow 0 59306) (- 0 84885)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@3@@1|)))) inline$$Vector_length$0$l@1@@4))))))))))))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 59304) 59306)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon36_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon56_Then_correct  (=> (= (ControlFlow 0 59314) 59306) inline$$VerifyVector_verify_reverse_$def_verify$0$anon36_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@4@@3) (and (=> (= (ControlFlow 0 59298) 59314) inline$$VerifyVector_verify_reverse_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 59298) 59304) inline$$VerifyVector_verify_reverse_$def_verify$0$anon56_Else_correct)))))
(let ((GeneratedUnifiedExit_correct@@3  (and (=> (= (ControlFlow 0 82345) (- 0 85036)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 82345) (- 0 85045)) (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 82345) (- 0 85054)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (let (($range_1@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0@@3))))))
(forall (($i_0@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@4)) $i_0@@6) (< $i_0@@6 (|i#$Integer| (|ub#$Range| $range_1@@4)))) (let ((i@@21 ($Integer $i_0@@6)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $ret0@0@@3)) (|i#$Integer| i@@21)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@32)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| $ret0@0@@3)))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| i@@21))))))))))))))))))))))
(let ((anon0$2_correct@@19  (=> (= $ret0@0@@3 inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@2) (=> (and (= $abort_flag@6@@0 $abort_flag@5@@0) (= (ControlFlow 0 59518) 82345)) GeneratedUnifiedExit_correct@@3))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon10_correct  (=> (= $abort_flag@5@@0 false) (=> (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@2 v@@32) (= (ControlFlow 0 59474) 59518)) anon0$2_correct@@19))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 59472) 59474)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 59482) 59474) inline$$VerifyVector_verify_reverse_$def_verify$0$anon10_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon42_Then_correct  (=> (|b#$Boolean| inline$$VerifyVector_verify_reverse_$def_verify$0$$t9@1) (and (=> (= (ControlFlow 0 59462) 59482) inline$$VerifyVector_verify_reverse_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 59462) 59472) inline$$VerifyVector_verify_reverse_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct  (=> (and (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@1 $Error) (= $abort_flag@5@@0 true)) (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@1) (= (ControlFlow 0 59332) 59518))) anon0$2_correct@@19)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 59406) 59332)) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 59416) 59332) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon45_Then_correct  (=> $abort_flag@0@@19 (and (=> (= (ControlFlow 0 59400) 59416) inline$$VerifyVector_verify_reverse_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 59400) 59406) inline$$VerifyVector_verify_reverse_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 59378) 59332)) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 59388) 59332) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 59372) 59388) inline$$VerifyVector_verify_reverse_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 59372) 59378) inline$$VerifyVector_verify_reverse_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 59358) 59332)) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 59368) 59332) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon51_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 59352) 59368) inline$$VerifyVector_verify_reverse_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 59352) 59358) inline$$VerifyVector_verify_reverse_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 59324) 59332)) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 59340) 59332) inline$$VerifyVector_verify_reverse_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon54_Then_correct  (=> $abort_flag@4@@3 (and (=> (= (ControlFlow 0 59318) 59340) inline$$VerifyVector_verify_reverse_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 59318) 59324) inline$$VerifyVector_verify_reverse_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then$1_correct  (=> (and (= inline$$Sub$1$dst@3 inline$$Sub$1$dst@1) (= $abort_flag@4@@3 true)) (and (=> (= (ControlFlow 0 59284) 59318) inline$$VerifyVector_verify_reverse_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 59284) 59298) inline$$VerifyVector_verify_reverse_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@2)) (= (ControlFlow 0 59282) 59284)) inline$$Sub$1$anon3_Then$1_correct)))
(let ((inline$$Sub$1$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@2) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1)) (= inline$$Sub$1$dst@2 ($Integer (- (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@2))))) (and (= inline$$Sub$1$dst@3 inline$$Sub$1$dst@2) (= $abort_flag@4@@3 $abort_flag@3@@3))) (and (=> (= (ControlFlow 0 59230) 59318) inline$$VerifyVector_verify_reverse_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 59230) 59298) inline$$VerifyVector_verify_reverse_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Sub$1$Entry_correct  (and (=> (= (ControlFlow 0 59204) (- 0 84561)) true) (and (=> (= (ControlFlow 0 59204) 59282) inline$$Sub$1$anon3_Then_correct) (=> (= (ControlFlow 0 59204) 59230) inline$$Sub$1$anon3_Else_correct)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon30$1_correct  (=> (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@2 ($Integer 1)) (= (ControlFlow 0 59290) 59204)) inline$$Sub$1$Entry_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 59081) 59290)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon30$1_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 59348) 59290) inline$$VerifyVector_verify_reverse_$def_verify$0$anon30$1_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon51_Else_correct  (=> (not $abort_flag@3@@3) (and (=> (= (ControlFlow 0 59075) 59348) inline$$VerifyVector_verify_reverse_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 59075) 59081) inline$$VerifyVector_verify_reverse_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= inline$$AddU64$0$dst@3@@2 inline$$AddU64$0$dst@1@@2) (= $abort_flag@3@@3 true)) (and (=> (= (ControlFlow 0 59061) 59352) inline$$VerifyVector_verify_reverse_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 59061) 59075) inline$$VerifyVector_verify_reverse_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@2)) $MAX_U64) (= (ControlFlow 0 59059) 59061)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@2))) (= inline$$AddU64$0$dst@2@@2 ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@2))))) (and (= inline$$AddU64$0$dst@3@@2 inline$$AddU64$0$dst@2@@2) (= $abort_flag@3@@3 $abort_flag@2@@3))) (and (=> (= (ControlFlow 0 59003) 59352) inline$$VerifyVector_verify_reverse_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 59003) 59075) inline$$VerifyVector_verify_reverse_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 58973) (- 0 84442)) true) (and (=> (= (ControlFlow 0 58973) 59059) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 58973) 59003) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Else$3_correct  (=> (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@2 ($Integer 1)) (= (ControlFlow 0 59067) 58973)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) (|l#$Mutation| |inline$$WriteRef$0$to'@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@2@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@2@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@2@@1 inline$$WritebackToReference$0$srcPath@2@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@3@@1| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) (= (ControlFlow 0 58780) 59067)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Else$3_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) (|l#$Mutation| |inline$$WriteRef$0$to'@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@2@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@2@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@2@@1 inline$$WritebackToReference$0$srcPath@2@@1)) (= |inline$$WritebackToReference$0$dst'@2@@1| ($Mutation (|l#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) inline$$WritebackToReference$0$dstPath@2@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@2@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@2@@1) (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) (|v#$Mutation| |inline$$WriteRef$0$to'@2|))))) (and (= |inline$$WritebackToReference$0$dst'@3@@1| |inline$$WritebackToReference$0$dst'@2@@1|) (= (ControlFlow 0 58836) 59067))) inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Else$3_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@2@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@2|)) (= inline$$WritebackToReference$0$dstPath@2@@1 (|p#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1))) (and (=> (= (ControlFlow 0 58744) 58836) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 58744) 58780) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@9  (=> (and (= |inline$$WriteRef$0$to'@2| ($Mutation (|l#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) (|p#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) |inline$$Vector_swap$0$v'@3@@0|)) (= (ControlFlow 0 58601) 58744)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 58607) 58601)) inline$$WriteRef$0$anon0_correct@@9)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@2@@3 true) (= |inline$$Vector_swap$0$v'@3@@0| |inline$$Vector_swap$0$v'@1@@1|)) (and (=> (= (ControlFlow 0 58536) 59372) inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 58536) 58607) inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct@@1  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@2@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0))) (>= inline$$Vector_swap$0$j_ind@2@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0)))) (< inline$$Vector_swap$0$i_ind@2@@0 0)) (< inline$$Vector_swap$0$j_ind@2@@0 0)) (= (ControlFlow 0 58534) 58536)) inline$$Vector_swap$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_swap$0$anon3_Else_correct@@1  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@2@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0))) (>= inline$$Vector_swap$0$j_ind@2@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0)))) (< inline$$Vector_swap$0$i_ind@2@@0 0)) (< inline$$Vector_swap$0$j_ind@2@@0 0))) (= |inline$$Vector_swap$0$v'@2@@1| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0)) inline$$Vector_swap$0$i_ind@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0)) inline$$Vector_swap$0$j_ind@2@@0)) inline$$Vector_swap$0$j_ind@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0)) inline$$Vector_swap$0$i_ind@2@@0)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@2@@0)))))) (and (= $abort_flag@2@@3 $abort_flag@1@@10) (= |inline$$Vector_swap$0$v'@3@@0| |inline$$Vector_swap$0$v'@2@@1|))) (and (=> (= (ControlFlow 0 58458) 59372) inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 58458) 58607) inline$$VerifyVector_verify_reverse_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct@@1  (=> ((_ is $Vector) inline$$ReadRef$1$v@2@@0) (=> (and (= inline$$Vector_swap$0$i_ind@2@@0 (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1)) (= inline$$Vector_swap$0$j_ind@2@@0 (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1))) (and (=> (= (ControlFlow 0 58412) 58534) inline$$Vector_swap$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 58412) 58458) inline$$Vector_swap$0$anon3_Else_correct@@1))))))
(let ((inline$$Vector_swap$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 58398) (- 0 84138)) true) (=> (= (ControlFlow 0 58398) 58412) inline$$Vector_swap$0$anon0_correct@@1))))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@2@@0 (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1)) (= (ControlFlow 0 58236) 58398)) inline$$Vector_swap$0$Entry_correct@@1)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon48_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@2@@2) (= (ControlFlow 0 58136) 58236)) inline$$ReadRef$1$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon38_correct  (=> (= $abort_flag@5@@0 $abort_flag@1@@10) (=> (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@8|) (= (ControlFlow 0 58090) 59518)) anon0$2_correct@@19))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 58088) 58090)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon38_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 58098) 58090) inline$$VerifyVector_verify_reverse_$def_verify$0$anon38_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@8  (=> (and (not (= (|l#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) ($Local 28))) (= |inline$$WritebackToValue$0$vdst'@2@@8| v@@32)) (and (=> (= (ControlFlow 0 58046) 58098) inline$$VerifyVector_verify_reverse_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 58046) 58088) inline$$VerifyVector_verify_reverse_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@8  (=> (= (|l#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) ($Local 28)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@8| ($UpdateValue_stratified (|p#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) 0 v@@32 (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1))) (= |inline$$WritebackToValue$0$vdst'@2@@8| |inline$$WritebackToValue$0$vdst'@1@@8|)) (and (=> (= (ControlFlow 0 58072) 58098) inline$$VerifyVector_verify_reverse_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 58072) 58088) inline$$VerifyVector_verify_reverse_$def_verify$0$anon57_Else_correct))))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon48_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@2@@2)) (and (=> (= (ControlFlow 0 57953) 58072) inline$$WritebackToValue$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 57953) 58046) inline$$WritebackToValue$0$anon3_Else_correct@@8)))))
(let ((inline$$Lt$0$anon0_correct@@2  (=> (= inline$$Lt$0$dst@2@@2 ($Boolean (< (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1)))) (and (=> (= (ControlFlow 0 57905) 58136) inline$$VerifyVector_verify_reverse_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 57905) 57953) inline$$VerifyVector_verify_reverse_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 57891) (- 0 83978)) true) (=> (= (ControlFlow 0 57891) 57905) inline$$Lt$0$anon0_correct@@2))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$L6_correct  (=> (not $abort_flag@1@@10) (=> (and (= (|l#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) ($Local 28)) (= (|p#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1) $EmptyPath)) (=> (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1) $MAX_U64)) (=> (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t15@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t15@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t15@1) $MAX_U64))) (=> (and (and (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t16@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t16@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t16@1) $MAX_U64)) ((_ is $Boolean) inline$$VerifyVector_verify_reverse_$def_verify$0$$t17@1)) (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t18@1)) (let ((va@@82 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t18@1))))
(let ((l@@89 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@86))
))))))) (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t19@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t19@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t19@1) $MAX_U64))) (and (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t20@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t20@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t20@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t21@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t21@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t21@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t22@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t24@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t24@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t24@1) $MAX_U64)))) (and (and (and (and ((_ is $Integer) inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@1) (>= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@1) 0)) (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t25@1) $MAX_U64)) (and ((_ is $Vector) (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1)) (let ((va@@83 (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1))))
(let ((l@@90 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@87))
))))))) (and (and (and ((_ is $Vector) inline$$VerifyVector_verify_reverse_$def_verify$0$$t30@1) (let ((va@@84 (|v#$Vector| inline$$VerifyVector_verify_reverse_$def_verify$0$$t30@1)))
(let ((l@@91 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@88))
)))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1))) ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))))) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@0 ($Range ($Integer 0) inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@0)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@1) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@0)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@1 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@1)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@1)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@0 ($Range ($Integer 0) inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@0)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@1) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@0)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@2 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@2))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@2))))))))))) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@0 ($Range inline$$VerifyVector_verify_reverse_$def_verify$0$front_index@1 ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$back_index@1) (|i#$Integer| ($Integer 1)))))))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@0)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@1) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@1 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@0)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$j@@0 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j@@0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j@@0)))))))))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$VerifyVector_verify_reverse_$def_verify$0$$t29@1)))) inline$$Vector_length$0$l@1@@4))) (= (ControlFlow 0 57813) 57891))))))) inline$$Lt$0$Entry_correct@@2)))))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon18_correct  (and (=> (= (ControlFlow 0 57430) (- 0 83186)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1) (|i#$Integer| inline$$Sub$0$dst@2@@0))) ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1)))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1) (|i#$Integer| inline$$Sub$0$dst@2@@0))) ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))))) (and (=> (= (ControlFlow 0 57430) (- 0 83215)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@1 ($Range ($Integer 0) inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@2) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@3 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@3)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@3))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@1 ($Range ($Integer 0) inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@3) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_1@@1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@3 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@3)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@3)))))))))))))) (and (=> (= (ControlFlow 0 57430) (- 0 83288)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@1 ($Range ($Integer 0) inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@2) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@4 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@4))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@4)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@1 ($Range ($Integer 0) inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1)))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@3) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_3@@1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$i@@4 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_2@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| ($Integer 1))))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@4))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$i@@4))))))))))) (and (=> (= (ControlFlow 0 57430) (- 0 83361)) (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@1 ($Range inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1 ($Integer (+ (|i#$Integer| inline$$Sub$0$dst@2@@0) (|i#$Integer| ($Integer 1)))))))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@2) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@2 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$j@@1 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j@@1)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j@@1)))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@1 ($Range inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1 ($Integer (+ (|i#$Integer| inline$$Sub$0$dst@2@@0) (|i#$Integer| ($Integer 1)))))))
(forall ((inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@1)) inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@3) (< inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@3 (|i#$Integer| (|ub#$Range| inline$$VerifyVector_verify_reverse_$def_verify$0$$range_5@@1)))) (let ((inline$$VerifyVector_verify_reverse_$def_verify$0$j@@1 ($Integer inline$$VerifyVector_verify_reverse_$def_verify$0$$i_4@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j@@1)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41))) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$j@@1))))))))))) (and (=> (= (ControlFlow 0 57430) (- 0 83422)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9)))) inline$$Vector_length$0$l@1@@4)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9)))) inline$$Vector_length$0$l@1@@4))) (=> (= (ControlFlow 0 57430) 57813) inline$$VerifyVector_verify_reverse_$def_verify$0$L6_correct)))))))))))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 57428) 57430)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon18_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 59396) 57430) inline$$VerifyVector_verify_reverse_$def_verify$0$anon18_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon45_Else_correct  (=> (not $abort_flag@0@@19) (and (=> (= (ControlFlow 0 57422) 59396) inline$$VerifyVector_verify_reverse_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 57422) 57428) inline$$VerifyVector_verify_reverse_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@19 true) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@0@@0)) (and (=> (= (ControlFlow 0 57408) 59400) inline$$VerifyVector_verify_reverse_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 57408) 57422) inline$$VerifyVector_verify_reverse_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t13@1)) (= (ControlFlow 0 57406) 57408)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (and (and (<= (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t13@1) (|i#$Integer| inline$$Vector_length$0$l@1@@4)) (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@4) (|i#$Integer| inline$$VerifyVector_verify_reverse_$def_verify$0$$t13@1))))) (and (= $abort_flag@0@@19 false) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@1@@0))) (and (=> (= (ControlFlow 0 57354) 59400) inline$$VerifyVector_verify_reverse_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 57354) 57422) inline$$VerifyVector_verify_reverse_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 57328) (- 0 83100)) true) (and (=> (= (ControlFlow 0 57328) 57406) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 57328) 57354) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon12$1_correct  (=> (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$t13@1 ($Integer 1)) (= (ControlFlow 0 57414) 57328)) inline$$Sub$0$Entry_correct@@0)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 57205) 57414)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon12$1_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 59424) 57414) inline$$VerifyVector_verify_reverse_$def_verify$0$anon12$1_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon42_Else_correct  (=> (not (|b#$Boolean| inline$$VerifyVector_verify_reverse_$def_verify$0$$t9@1)) (=> (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@41) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9)))) (= inline$$VerifyVector_verify_reverse_$def_verify$0$$t11@1 ($Integer 0))) (and (=> (= (ControlFlow 0 57197) 59424) inline$$VerifyVector_verify_reverse_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 57197) 57205) inline$$VerifyVector_verify_reverse_$def_verify$0$anon44_Else_correct))))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon40_Else$1_correct  (=> (and (= inline$$VerifyVector_verify_reverse_$def_verify$0$$t8@1 ($Integer 0)) (= inline$$VerifyVector_verify_reverse_$def_verify$0$$t9@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1@@4 inline$$VerifyVector_verify_reverse_$def_verify$0$$t8@1)))) (and (=> (= (ControlFlow 0 57137) 59462) inline$$VerifyVector_verify_reverse_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 57137) 57197) inline$$VerifyVector_verify_reverse_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon40_Else_correct  (=> (and (not false) (= (ControlFlow 0 57123) 57137)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon40_Else$1_correct)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon40_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@4  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@9) (= inline$$Vector_length$0$l@1@@4 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9))))) (and (=> (= (ControlFlow 0 57077) 59486) inline$$VerifyVector_verify_reverse_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 57077) 57123) inline$$VerifyVector_verify_reverse_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@9  (=> (and (= inline$$ReadRef$0$v@1@@9 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9)) (= (ControlFlow 0 57020) 57077)) inline$$Vector_length$0$anon0_correct@@4)))
(let ((inline$$BorrowLoc$0$anon0_correct@@9  (=> (and (= inline$$BorrowLoc$0$dst@1@@9 ($Mutation ($Local 28) $EmptyPath v@@32)) (= (ControlFlow 0 56948) 57020)) inline$$ReadRef$0$anon0_correct@@9)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 56864) 56948)) inline$$BorrowLoc$0$anon0_correct@@9)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 59510) 56948) inline$$BorrowLoc$0$anon0_correct@@9)))
(let ((inline$$VerifyVector_verify_reverse_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 56858) 59510) inline$$VerifyVector_verify_reverse_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 56858) 56864) inline$$VerifyVector_verify_reverse_$def_verify$0$anon39_Else_correct)))))
(let ((anon0_correct@@19  (=> (and (and ((_ is $Vector) v@@32) (let ((va@@85 (|v#$Vector| v@@32)))
(let ((l@@92 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@89))
)))))) (= (ControlFlow 0 55800) 56858)) inline$$VerifyVector_verify_reverse_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@18  (=> (forall (($tv0@@42 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@42)) (let ((va@@86 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@42))))
(let ((l@@93 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@90))
))))))) (=> (and (forall (($tv0@@43 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@43)) (let ((va@@87 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@43))))
(let ((l@@94 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@91))
))))))) (= (ControlFlow 0 82354) 55800)) anon0_correct@@19))))
PreconditionGeneratedEntry_correct@@18)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@20 () Bool)
(declare-fun inline$$VerifyVector_verify_singleton_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun e@@4 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@9| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@9| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@9| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@10 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 85141) (let ((anon0$2_correct@@20  (and (=> (= (ControlFlow 0 60799) (- 0 85610)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@20)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@20) (and (=> (= (ControlFlow 0 60799) (- 0 85619)) (=> $abort_flag@0@@20 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@20 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 60799) (- 0 85628)) (=> (not $abort_flag@0@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_singleton_$def_verify$0$$ret0@2))) ($Integer 1)))))) (=> (=> (not $abort_flag@0@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_singleton_$def_verify$0$$ret0@2))) ($Integer 1))))) (=> (= (ControlFlow 0 60799) (- 0 85646)) (=> (not $abort_flag@0@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_singleton_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 0))) e@@4)))))))))))))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon12_correct  (=> (= $abort_flag@0@@20 false) (=> (and (= inline$$VerifyVector_verify_singleton_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@9|) (= (ControlFlow 0 60729) 60799)) anon0$2_correct@@20))))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 60727) 60729)) inline$$VerifyVector_verify_singleton_$def_verify$0$anon12_correct)))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 60737) 60729) inline$$VerifyVector_verify_singleton_$def_verify$0$anon12_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@9  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@9| inline$$Vector_empty$0$v@1@@0)) (and (=> (= (ControlFlow 0 60685) 60737) inline$$VerifyVector_verify_singleton_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 60685) 60727) inline$$VerifyVector_verify_singleton_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@9  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@9| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@9|) 0 inline$$Vector_empty$0$v@1@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@9|))) (= |inline$$WritebackToValue$0$vdst'@2@@9| |inline$$WritebackToValue$0$vdst'@1@@9|)) (and (=> (= (ControlFlow 0 60711) 60737) inline$$VerifyVector_verify_singleton_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 60711) 60727) inline$$VerifyVector_verify_singleton_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@10  (=> (= |inline$$WriteRef$0$to'@1@@9| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10) |inline$$Vector_push_back$0$v'@1@@0|)) (and (=> (= (ControlFlow 0 60586) 60711) inline$$WritebackToValue$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 60586) 60685) inline$$WritebackToValue$0$anon3_Else_correct@@9)))))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon16_Else_correct  (=> (and (not false) (= (ControlFlow 0 60592) 60586)) inline$$WriteRef$0$anon0_correct@@10)))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon16_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@10) (= |inline$$Vector_push_back$0$v'@1@@0| ($Vector (let ((len@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) len@@2 e@@4) (+ len@@2 1)))))) (and (=> (= (ControlFlow 0 60521) 60741) inline$$VerifyVector_verify_singleton_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 60521) 60592) inline$$VerifyVector_verify_singleton_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@10  (=> (and (= inline$$ReadRef$0$v@1@@10 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10)) (= (ControlFlow 0 60458) 60521)) inline$$Vector_push_back$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@10  (=> (and (= inline$$BorrowLoc$0$dst@1@@10 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$0$v@1@@0)) (= (ControlFlow 0 60420) 60458)) inline$$ReadRef$0$anon0_correct@@10)))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon14_Else_correct  (=> (and (not false) (= (ControlFlow 0 60426) 60420)) inline$$BorrowLoc$0$anon0_correct@@10)))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon14_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct@@0  (=> (= inline$$Vector_empty$0$v@1@@0 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 60358) 60767) inline$$VerifyVector_verify_singleton_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 60358) 60426) inline$$VerifyVector_verify_singleton_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 60295) 60358)) inline$$Vector_empty$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 60791) 60358) inline$$Vector_empty$0$anon0_correct@@0)))
(let ((inline$$VerifyVector_verify_singleton_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 60289) 60791) inline$$VerifyVector_verify_singleton_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 60289) 60295) inline$$VerifyVector_verify_singleton_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@20  (=> (forall (($tv0@@44 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@44)) (let ((va@@88 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@44))))
(let ((l@@95 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@92))
))))))) (=> (and (forall (($tv0@@45 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@45)) (let ((va@@89 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@45))))
(let ((l@@96 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@93))
))))))) (= (ControlFlow 0 85141) 60289)) inline$$VerifyVector_verify_singleton_$def_verify$0$anon0_correct))))
anon0_correct@@20))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun i@@22 () T@$Value)
(declare-fun v@@33 () T@$Value)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@21 () Bool)
(declare-fun $abort_flag@1@@11 () Bool)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun inline$$Vector_pop_back$0$e@2@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@10| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@10| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@10| () T@$Mutation)
(declare-fun |inline$$Vector_pop_back$0$v'@2@@2| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$e@0@@1 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@0@@1| () T@$Value)
(declare-fun inline$$Vector_pop_back$0$len@1@@1 () Int)
(declare-fun inline$$Vector_pop_back$0$e@1@@2 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun |inline$$Vector_pop_back$0$v'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@11 () T@$Mutation)
(declare-fun |inline$$Vector_swap$0$v'@2@@2| () T@$Value)
(declare-fun |inline$$Vector_swap$0$v'@0@@0| () T@$Value)
(declare-fun inline$$Vector_swap$0$i_ind@1@@0 () Int)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$Vector_swap$0$j_ind@1@@0 () Int)
(declare-fun |inline$$Vector_swap$0$v'@1@@2| () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@5 () T@$Value)
(declare-fun inline$$VerifyVector_verify_swap_remove_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@11 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 85678) (let ((anon0$2_correct@@21  (and (=> (= (ControlFlow 0 62831) (- 0 86849)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@22) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@22) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 62831) (- 0 86868)) (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@22) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33))))))))) (=> (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@22) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))))))) (and (=> (= (ControlFlow 0 62831) (- 0 86887)) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@2))) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 62831) (- 0 86917)) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1)))))))) (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@33)) (|i#$Integer| i@@22) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@33)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|l#$ValueArray| (|v#$Vector| v@@33)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@2 ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1)))))))) (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@33)) (|i#$Integer| i@@22) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@33)) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|l#$ValueArray| (|v#$Vector| v@@33)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| v@@33)))) (|i#$Integer| ($Integer 1))))))))))))))) (=> (= (ControlFlow 0 62831) (- 0 86979)) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@33)) (|i#$Integer| i@@22)) inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret0@2)))))))))))))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$Abort_correct  (=> (and (= inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret0@1 $Error) (= inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@3@@4 true) (= inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret0@2 inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret0@1)) (and (= inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@2 inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@1) (= (ControlFlow 0 62729) 62831))) anon0$2_correct@@21))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 62775) 62729)) inline$$VerifyVector_verify_swap_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 62785) 62729) inline$$VerifyVector_verify_swap_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon31_Then_correct  (=> $abort_flag@0@@21 (and (=> (= (ControlFlow 0 62769) 62785) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 62769) 62775) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 62747) 62729)) inline$$VerifyVector_verify_swap_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 62757) 62729) inline$$VerifyVector_verify_swap_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon34_Then_correct  (=> $abort_flag@1@@11 (and (=> (= (ControlFlow 0 62741) 62757) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 62741) 62747) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 62719) 62729)) inline$$VerifyVector_verify_swap_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 62737) 62729) inline$$VerifyVector_verify_swap_remove_$def_verify$0$Abort_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon36_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 62713) 62737) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 62713) 62719) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon26_correct  (=> (and (and (= $abort_flag@3@@4 $abort_flag@2@@4) (= inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret0@2 inline$$Vector_pop_back$0$e@2@@2)) (and (= inline$$VerifyVector_verify_swap_remove_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@10|) (= (ControlFlow 0 62693) 62831))) anon0$2_correct@@21)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 62691) 62693)) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon26_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 62701) 62693) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon26_correct)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon38_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 62681) 62701) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 62681) 62691) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon38_Then_correct  (and (=> (= (ControlFlow 0 62709) 62701) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 62709) 62691) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon39_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@10  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@10| v@@33)) (and (=> (= (ControlFlow 0 62639) 62709) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 62639) 62681) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@10  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@10| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 v@@33 (|v#$Mutation| |inline$$WriteRef$1$to'@1|))) (= |inline$$WritebackToValue$0$vdst'@2@@10| |inline$$WritebackToValue$0$vdst'@1@@10|)) (and (=> (= (ControlFlow 0 62665) 62709) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 62665) 62681) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@10|) (|p#$Mutation| |inline$$WriteRef$0$to'@1@@10|) |inline$$Vector_pop_back$0$v'@2@@2|)) (and (=> (= (ControlFlow 0 62540) 62665) inline$$WritebackToValue$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 62540) 62639) inline$$WritebackToValue$0$anon3_Else_correct@@10)))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@2@@4) (= (ControlFlow 0 62546) 62540)) inline$$WriteRef$1$anon0_correct@@1)))
(let ((inline$$Vector_pop_back$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@2@@4 true) (=> (and (= inline$$Vector_pop_back$0$e@2@@2 inline$$Vector_pop_back$0$e@0@@1) (= |inline$$Vector_pop_back$0$v'@2@@2| |inline$$Vector_pop_back$0$v'@0@@1|)) (and (=> (= (ControlFlow 0 62473) 62713) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 62473) 62546) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon3_Then_correct@@2  (=> (and (= inline$$Vector_pop_back$0$len@1@@1 0) (= (ControlFlow 0 62471) 62473)) inline$$Vector_pop_back$0$anon3_Then$1_correct@@2)))
(let ((inline$$Vector_pop_back$0$anon3_Else_correct@@2  (=> (and (not (= inline$$Vector_pop_back$0$len@1@@1 0)) (= inline$$Vector_pop_back$0$e@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) (- inline$$Vector_pop_back$0$len@1@@1 1)))) (=> (and (and (= |inline$$Vector_pop_back$0$v'@1@@2| ($Vector (let ((l@@97 (- (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) 1)))
($ValueArray (|lambda#0| 0 l@@97 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Error) l@@97)))) (= $abort_flag@2@@4 $abort_flag@1@@11)) (and (= inline$$Vector_pop_back$0$e@2@@2 inline$$Vector_pop_back$0$e@1@@2) (= |inline$$Vector_pop_back$0$v'@2@@2| |inline$$Vector_pop_back$0$v'@1@@2|))) (and (=> (= (ControlFlow 0 62423) 62713) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 62423) 62546) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$Vector_pop_back$0$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1) (= inline$$Vector_pop_back$0$len@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)))) (and (=> (= (ControlFlow 0 62401) 62471) inline$$Vector_pop_back$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 62401) 62423) inline$$Vector_pop_back$0$anon3_Else_correct@@2)))))
(let ((inline$$ReadRef$2$anon0_correct@@1  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@10|)) (= (ControlFlow 0 62290) 62401)) inline$$Vector_pop_back$0$anon0_correct@@2)))
(let ((inline$$WriteRef$0$anon0_correct@@11  (=> (and (= |inline$$WriteRef$0$to'@1@@10| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@11) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@11) |inline$$Vector_swap$0$v'@2@@2|)) (= (ControlFlow 0 62252) 62290)) inline$$ReadRef$2$anon0_correct@@1)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@1@@11) (= (ControlFlow 0 62258) 62252)) inline$$WriteRef$0$anon0_correct@@11)))
(let ((inline$$Vector_swap$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@1@@11 true) (= |inline$$Vector_swap$0$v'@2@@2| |inline$$Vector_swap$0$v'@0@@0|)) (and (=> (= (ControlFlow 0 62187) 62741) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 62187) 62258) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Vector_swap$0$anon3_Then_correct@@2  (=> (and (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0))) (>= inline$$Vector_swap$0$j_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)))) (< inline$$Vector_swap$0$i_ind@1@@0 0)) (< inline$$Vector_swap$0$j_ind@1@@0 0)) (= (ControlFlow 0 62185) 62187)) inline$$Vector_swap$0$anon3_Then$1_correct@@2)))
(let ((inline$$Vector_swap$0$anon3_Else_correct@@2  (=> (and (and (not (or (or (or (>= inline$$Vector_swap$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0))) (>= inline$$Vector_swap$0$j_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)))) (< inline$$Vector_swap$0$i_ind@1@@0 0)) (< inline$$Vector_swap$0$j_ind@1@@0 0))) (= |inline$$Vector_swap$0$v'@1@@2| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) inline$$Vector_swap$0$i_ind@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) inline$$Vector_swap$0$j_ind@1@@0)) inline$$Vector_swap$0$j_ind@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) inline$$Vector_swap$0$i_ind@1@@0)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)))))) (and (= $abort_flag@1@@11 $abort_flag@0@@21) (= |inline$$Vector_swap$0$v'@2@@2| |inline$$Vector_swap$0$v'@1@@2|))) (and (=> (= (ControlFlow 0 62109) 62741) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 62109) 62258) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Vector_swap$0$anon0_correct@@2  (=> ((_ is $Vector) inline$$ReadRef$1$v@1@@0) (=> (and (= inline$$Vector_swap$0$i_ind@1@@0 (|i#$Integer| i@@22)) (= inline$$Vector_swap$0$j_ind@1@@0 (|i#$Integer| inline$$Sub$0$dst@2@@1))) (and (=> (= (ControlFlow 0 62063) 62185) inline$$Vector_swap$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 62063) 62109) inline$$Vector_swap$0$anon3_Else_correct@@2))))))
(let ((inline$$Vector_swap$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 62049) (- 0 86356)) true) (=> (= (ControlFlow 0 62049) 62063) inline$$Vector_swap$0$anon0_correct@@2))))
(let ((inline$$ReadRef$1$anon0_correct@@2  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@11)) (= (ControlFlow 0 61887) 62049)) inline$$Vector_swap$0$Entry_correct@@2)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 61855) 61887)) inline$$ReadRef$1$anon0_correct@@2)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 62765) 61887) inline$$ReadRef$1$anon0_correct@@2)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon31_Else_correct  (=> (not $abort_flag@0@@21) (and (=> (= (ControlFlow 0 61849) 62765) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 61849) 61855) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@21 true) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@0@@1)) (and (=> (= (ControlFlow 0 61835) 62769) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 61835) 61849) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$Vector_length$0$l@1@@5) (|i#$Integer| inline$$VerifyVector_verify_swap_remove_$def_verify$0$$t8@1)) (= (ControlFlow 0 61833) 61835)) inline$$Sub$0$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$0$anon3_Else_correct@@1  (=> (and (and (<= (|i#$Integer| inline$$VerifyVector_verify_swap_remove_$def_verify$0$$t8@1) (|i#$Integer| inline$$Vector_length$0$l@1@@5)) (= inline$$Sub$0$dst@1@@1 ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1@@5) (|i#$Integer| inline$$VerifyVector_verify_swap_remove_$def_verify$0$$t8@1))))) (and (= $abort_flag@0@@21 false) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@1@@1))) (and (=> (= (ControlFlow 0 61781) 62769) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 61781) 61849) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 61755) (- 0 86246)) true) (and (=> (= (ControlFlow 0 61755) 61833) inline$$Sub$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 61755) 61781) inline$$Sub$0$anon3_Else_correct@@1)))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon29_Else_correct  (=> (not false) (=> (and (= inline$$VerifyVector_verify_swap_remove_$def_verify$0$$t8@1 ($Integer 1)) (= (ControlFlow 0 61841) 61755)) inline$$Sub$0$Entry_correct@@1))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon29_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@5  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@11) (= inline$$Vector_length$0$l@1@@5 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@11))))) (and (=> (= (ControlFlow 0 61654) 62789) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 61654) 61841) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@11  (=> (and (= inline$$ReadRef$0$v@1@@11 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@11)) (= (ControlFlow 0 61597) 61654)) inline$$Vector_length$0$anon0_correct@@5)))
(let ((inline$$BorrowLoc$0$anon0_correct@@11  (=> (and (= inline$$BorrowLoc$0$dst@1@@11 ($Mutation ($Local 3) $EmptyPath v@@33)) (= (ControlFlow 0 61559) 61597)) inline$$ReadRef$0$anon0_correct@@11)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 61441) 61559)) inline$$BorrowLoc$0$anon0_correct@@11)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 62813) 61559) inline$$BorrowLoc$0$anon0_correct@@11)))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 61433) 62813) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 61433) 61441) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 62821) 62813) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 62821) 61441) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon28_Else_correct))))
(let ((inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 61427) 62821) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 61427) 61433) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon27_Else_correct)))))
(let ((anon0_correct@@21  (=> (and ((_ is $Vector) v@@33) (let ((va@@90 (|v#$Vector| v@@33)))
(let ((l@@98 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@94))
)))))) (=> (and (and (and ((_ is $Integer) i@@22) (>= (|i#$Integer| i@@22) 0)) (<= (|i#$Integer| i@@22) $MAX_U64)) (= (ControlFlow 0 60961) 61427)) inline$$VerifyVector_verify_swap_remove_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@19  (=> (forall (($tv0@@46 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@46)) (let ((va@@91 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_v $tv0@@46))))
(let ((l@@99 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@95))
))))))) (=> (and (forall (($tv0@@47 T@$TypeValue) )  (and ((_ is $Vector) (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@47)) (let ((va@@92 (|v#$Vector| (|Select_[$TypeValue]$Value| $VerifyVector_old_other $tv0@@47))))
(let ((l@@100 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@96))
))))))) (= (ControlFlow 0 85678) 60961)) anon0_correct@@21))))
PreconditionGeneratedEntry_correct@@19)))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
